﻿
app.factory('BaseService', ['$http', '$q', '$httpParamSerializerJQLike', 'SYSTEM_PATH', '$rootScope', '$uibModal', '$filter', function ($http, $q, $httpParamSerializerJQLike, SYSTEM_PATH, $rootScope, $uibModal, $filter) {
    var methods = {

        GetHeaderGridView: function (cs) {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + SYSTEM_PATH + '/GetHeaderGridView/' + cs)
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        methods.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetReportList: function (cs) {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + SYSTEM_PATH + '/GetReportList/' + cs)
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        methods.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetDataTable: function (servicePath, action) {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + servicePath + '/' + action + '/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        methods.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetDataTableByParam: function (servicePath, action, param) {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + servicePath + '/' + action + '/' + param)
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        methods.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        //------- New scan -------
        CallAction: function (servicePath, action, data) {
            //methods.Message.alert(data);
            return $q(function (resolve, reject) {
                var config = {
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8;'
                    }
                }
                $http.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";
                $http.post(window.location.origin + servicePath + '/' + action, data, config)
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        methods.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        //------- New scan -------
        PostAction: function (servicePath, action, data, finish) {
            //alert(data);
            return $q(function (resolve, reject) {
                var config = {
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8;'
                    }
                }
                $http.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";
                $http.post(window.location.origin + servicePath + '/' + action, data, config)
                    .then(function (res) {
                        (typeof finish == "function") ? finish(res) : null;
                    }, function (error) {
                        console.log(error);
                    });
            });
        },
        PostActionJSON: function (servicePath, action, data, finish) {
            //alert(data);
            return $q(function (resolve, reject) {
                var config = {
                    headers: {
                        'Content-Type': 'application/json;charset=utf-8;'
                    }
                }
                $http.defaults.headers.post["Content-Type"] = "application/json";
                $http.post(window.location.origin + servicePath + '/' + action, data, config)
                    .then(function (res) {
                        (typeof finish == "function") ? finish(res) : null;
                    }, function (error) {
                        console.log(error);
                    });
            });
        },

        Message: {
            info: function (customText) {
                var tempModalDefaults = {
                    backdrop: 'static',
                    keyboard: true,
                    modalFade: true,
                    templateUrl: 'info-modal'
                };
                var tempModalOptions = {
                    bodyText: customText
                };

                if (!tempModalDefaults.controller) {
                    tempModalDefaults.controller = ['$scope', '$uibModalInstance', function ($scope, $uibModalInstance) {
                        $scope.modalOptions = tempModalOptions;
                        $scope.modalOptions.ok = function (result) {
                            $uibModalInstance.close(result);
                        };
                        $scope.modalOptions.close = function (result) {
                            $uibModalInstance.dismiss('cancel');
                        };
                    }];
                }

                return $uibModal.open(tempModalDefaults).result;
            },
            warning: function (customText) {
                var tempModalDefaults = {
                    backdrop: 'static',
                    keyboard: true,
                    modalFade: true,
                    templateUrl: 'warning-modal'
                };
                var tempModalOptions = {
                    bodyText: customText
                };

                if (!tempModalDefaults.controller) {
                    tempModalDefaults.controller = ['$scope', '$uibModalInstance', function ($scope, $uibModalInstance) {
                        $scope.modalOptions = tempModalOptions;
                        $scope.modalOptions.ok = function (result) {
                            $uibModalInstance.close(result);
                        };
                        $scope.modalOptions.close = function (result) {
                            $uibModalInstance.dismiss('cancel');
                        };
                    }];
                }

                return $uibModal.open(tempModalDefaults).result;
            },
            alert: function (customText) {
                var tempModalDefaults = {
                    backdrop: 'static',
                    keyboard: true,
                    modalFade: true,
                    templateUrl: 'alert-modal'
                };
                var tempModalOptions = {
                    bodyText: customText
                };

                if (!tempModalDefaults.controller) {
                    tempModalDefaults.controller = ['$scope', '$uibModalInstance', function ($scope, $uibModalInstance) {
                        $scope.modalOptions = tempModalOptions;
                        $scope.modalOptions.ok = function (result) {
                            $uibModalInstance.close(result);
                        };
                        $scope.modalOptions.close = function (result) {
                            $uibModalInstance.dismiss('cancel');
                        };
                    }];
                }

                return $uibModal.open(tempModalDefaults).result;
            },

            confirm: function (customText) {
                var tempModalDefaults = {
                    backdrop: 'static',
                    keyboard: true,
                    modalFade: true,
                    templateUrl: 'confirm-modal'
                };
                var tempModalOptions = {
                    bodyText: customText
                };

                if (!tempModalDefaults.controller) {
                    tempModalDefaults.controller = ['$scope', '$uibModalInstance', function ($scope, $uibModalInstance) {
                        $scope.modalOptions = tempModalOptions;
                        $scope.modalOptions.ok = function (result) {
                            $uibModalInstance.close(result);
                        };
                        $scope.modalOptions.close = function (result) {
                            $uibModalInstance.dismiss('cancel');
                        };
                    }];
                }

                return $uibModal.open(tempModalDefaults).result;
            }
        },

        ConvertParam: function (obj, exception, prefix) {

            var str = [], p;
            for (p in obj) {
                if (obj.hasOwnProperty(p)) {
                    var k = prefix ? prefix + "[" + p + "]" : p, v = obj[p];
                    if (v !== null && typeof v === "object" && !(v instanceof Date)) {
                        str.push(
                            this.ConvertParam(v, exception, k)
                        );
                    } else if (v !== null) {
                        var itemKey = encodeURIComponent(k);
                        var itemVal = (exception && (prefix == exception || k == exception)) ? encodeURIComponent(v) : encodeURIComponent(v).replace(/(\')/g, "''");
                        str.push(
                            itemKey + "=" + itemVal
                        );
                    } else {
                        str.push(
                            encodeURIComponent(k) + "="
                        );
                    }
                }
            }
            return str.join("&");

        },

        ObjectAssign: function (target, source) {
            var objects = [(target || {}), source];
            result = objects.reduce(function (r, o) {
                Object.keys(o).forEach(function (k) {
                    r[k] = o[k];
                });
                return r;
            }, {});
            return result;
        },
        GetFYObject: function (obj) {
            //Set FY year selector
            obj.FY = [];
            const currentYear = new Date().getFullYear();
            for (let _year = currentYear + 1; _year >= 2018; _year--) {
                fy = _year.toString().substr(-2);
                obj.FY.push({
                    "fiscalYear": fy,
                    "fullYear": _year,
                    "CURRENT_YEAR": _year == currentYear
                });
            }
            //Add obj for FY month
            obj.FYMonths = [];
            const _FYMonths = [3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2];
            _FYMonths.forEach(function (item, key) {
                let _fyMonth = new Date(1990, item, 1).toLocaleString("en-us", { month: "long" });
                let _fyMonthShort = new Date(1990, item, 1).toLocaleString("en-us", { month: "short" });
                let _fyMonthTH = new Date(1990, item, 1).toLocaleString("th-th", { month: "long" });
                obj.FYMonths.push({
                    "MONTH_INDEX": key,
                    "MONTH": ("0" + (item + 1).toString()).substr(-2),
                    "MONTH_NAME": _fyMonth,
                    "MONTH_NAME_SHORT": _fyMonthShort,
                    "MONTH_NAME_TH": _fyMonthTH,
                    "AddYear": (item < 3) ? 1 : 0,
                    "Month": (item + 1),
                    "Quarter": (item >= 3) ? Math.ceil((item + 1) / 3) - 1 : Math.ceil((item + 13) / 3) - 1, // Q1:3-5, Q2:6-8, Q3:9-11, Q4:0-2
                    "CURRENT_MONTH": item == new Date().getMonth()
                })
            })
            return obj;
        },
        GetDataMonthName: function (dataMonth) {
            if (dataMonth) {
                let fyObj = {};
                this.GetFYObject(fyObj)
                const periodMonth = dataMonth.substr(-2);
                const periodYear = dataMonth.substr(0, 4);
                let dataMonthName = $filter('filter')(fyObj.FYMonths, { MONTH: periodMonth }, true)[0].MONTH_NAME
                    + '-' + String(periodYear)
                return dataMonthName;
            } else {
                return null;
            }
        },
        GetDataMontShorthName: function (dataMonth) {
            if (dataMonth) {
                let fyObj = {};
                this.GetFYObject(fyObj)
                const periodMonth = dataMonth.substr(-2);
                const periodYear = dataMonth.substr(0, 2);
                let dataMonthName = $filter('filter')(fyObj.FYMonths, { MONTH: periodMonth }, true)[0].MONTH_NAME_SHORT
                    + '-' + String(periodYear)
                return dataMonthName;
            } else {
                return null;
            }
        }

    };

    return methods;
}]);

app.factory('FnService', function () {
    return {

        //----------------- Fn ----------------
        CheckPersonalID: function (id) {

            if (id.length != 13)
                return false;

            for (i = 0, sum = 0; i < 12; i++)
                sum += parseFloat(id.charAt(i)) * (13 - i);

            if ((11 - sum % 11) % 10 != parseFloat(id.charAt(12)))
                return false;
            return true;
        },

        CheckPassword: function (pw) {

            if (!(pw.length >= 6 && pw.length <= 12))
                return "กรุณาตั้งรหัสผ่าน 6-12 ตัวอักษร";

            iLetter = 0;
            iNumber = 0;

            for (i = 0; i < pw.length; i++) {

                if (this.IsLetter(pw.charAt(i)))
                    iLetter = iLetter + 1
                if (this.IsNumber(pw.charAt(i)))
                    iNumber = iNumber + 1
            }

            if (iLetter == 0 || iNumber == 0)
                return "กรุณาตั้งรหัสผ่าน ประกอบด้วยตัวอักษรผสมกับตัวเลขและอักขระพิเศษ (สัญลักษณ์)";

            if (iLetter + iNumber == pw.length)
                return "กรุณาตั้งรหัสผ่าน ประกอบด้วยตัวอักษรผสมกับตัวเลขและอักขระพิเศษ (สัญลักษณ์)";

            return "";

        },

        IsLetter: function (str) {
            return str.length === 1 && str.match(/[a-z]/i);
        },

        IsNumber: function (str) {
            return str.length === 1 && str.match(/[0-9]/i);
        },

    };
});

app.factory('BizDataService', ['$http', '$q', '$httpParamSerializerJQLike', 'SYSTEM_PATH', 'BaseService', function ($http, $q, $httpParamSerializerJQLike, SYSTEM_PATH, BaseService) {
    return {

        //----------------- Biz data ----------------
        GetQuarterMonth: function (pYear, pQuarter) {
            var MList = [];

            if (pQuarter == 1) {

                MList.M1 = 'Apr ' + pYear;
                MList.M2 = 'May ' + pYear;
                MList.M3 = 'Jun ' + pYear;

                MList.MNo1 = '04';
                MList.MNo2 = '05';
                MList.MNo3 = '06';

            } else if (pQuarter == 2) {

                MList.M1 = 'Jul ' + pYear;
                MList.M2 = 'Aug ' + pYear;
                MList.M3 = 'Sep ' + pYear;

                MList.MNo1 = '07';
                MList.MNo2 = '08';
                MList.MNo3 = '09';

            } else if (pQuarter == 3) {

                MList.M1 = 'Oct ' + pYear;
                MList.M2 = 'Nov ' + pYear;
                MList.M3 = 'Dec ' + pYear;

                MList.MNo1 = '10';
                MList.MNo2 = '11';
                MList.MNo3 = '12';

            } else if (pQuarter == 4) {

                MList.M1 = 'Jan ' + (pYear + 1);
                MList.M2 = 'Feb ' + (pYear + 1);
                MList.M3 = 'Mar ' + (pYear + 1);

                MList.MNo1 = '01';
                MList.MNo2 = '02';
                MList.MNo3 = '03';

            }

            return MList;
        },

        //----------------- Biz data ----------------
        GetMonthName: function (iMonth) {
            var Mname = '';

            switch (iMonth) {
                case 1:
                    Mname = 'January';
                    break;
                case 2:
                    Mname = 'February';
                    break;
                case 3:
                    Mname = 'March';
                    break;
                case 4:
                    Mname = 'April';
                    break;
                case 5:
                    Mname = 'May';
                    break;
                case 6:
                    Mname = 'June';
                    break;
                case 7:
                    Mname = 'July';
                    break;
                case 8:
                    Mname = 'August';
                    break;
                case 9:
                    Mname = 'September';
                    break;
                case 10:
                    Mname = 'October';
                    break;
                case 11:
                    Mname = 'November';
                    break;
                case 12:
                    Mname = 'December';
                    break;
                default:
                    break;
            }


            return Mname;
        },

        //----------------- Biz data ----------------
        GetMonthNameTH: function (iMonth) {
            var Mname = '';

            switch (iMonth) {
                case 1:
                    Mname = 'มกราคม';
                    break;
                case 2:
                    Mname = 'กุมภาพันธ์';
                    break;
                case 3:
                    Mname = 'มีนาคม';
                    break;
                case 4:
                    Mname = 'เมษายน';
                    break;
                case 5:
                    Mname = 'พฤษภาคม';
                    break;
                case 6:
                    Mname = 'มิถุนายน';
                    break;
                case 7:
                    Mname = 'กรกฎาคม';
                    break;
                case 8:
                    Mname = 'สิงหาคม';
                    break;
                case 9:
                    Mname = 'กันยายน';
                    break;
                case 10:
                    Mname = 'ตุลาคม';
                    break;
                case 11:
                    Mname = 'พฤศจิกายน';
                    break;
                case 12:
                    Mname = 'ธันวาคม';
                    break;
                default:
                    break;
            }

            return Mname;
        },
        //------------------ Biz data ---------------------------

        GetRetailSalesMonth: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetRetailSalesMonth/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetRetailSalesYear: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetRetailSalesYear/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetFiscalYear: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetFiscalYear/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetOutletList: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetOutlet/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetDealerList: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetDealer/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetSystemMenu: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/SystemDs/GetSystemMenu/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetBaseModel: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetBaseModel/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },

        GetEstimatedPayment: function () {
            return $q(function (resolve, reject) {
                $http.get(window.location.origin + '/Home/GetEstimatedPayment/')
                    .then(function (res) {
                        resolve(res.data);
                    }, function (error) {
                        BaseService.Message.alert('Connection error :' + error.statusText);
                        reject(error);
                    });
            });
        },
        Get2MonthList: function () {
            var FY2Months = [];

            FY2Months.push({
                "MONTH_INDEX": 1,
                "MONTH": "04",
                "MONTH_NAME": "Apr-May",
                "Month": 4,
                "CURRENT_MONTH": (3 == new Date().getMonth()) || (4 == new Date().getMonth())
            })
            FY2Months.push({
                "MONTH_INDEX": 2,
                "MONTH": "06",
                "MONTH_NAME": "Jun-Jul",
                "Month": 6,
                "CURRENT_MONTH": (5 == new Date().getMonth()) || (6 == new Date().getMonth())
            })
            FY2Months.push({
                "MONTH_INDEX": 3,
                "MONTH": "08",
                "MONTH_NAME": "Aug-Sep",
                "Month": 8,
                "CURRENT_MONTH": (7 == new Date().getMonth()) || (8 == new Date().getMonth())
            })
            FY2Months.push({
                "MONTH_INDEX": 4,
                "MONTH": "10",
                "MONTH_NAME": "Oct-Nov",
                "Month": 10,
                "CURRENT_MONTH": (9 == new Date().getMonth()) || (10 == new Date().getMonth())
            })
            FY2Months.push({
                "MONTH_INDEX": 5,
                "MONTH": "12",
                "MONTH_NAME": "Dec-Jan",
                "Month": 12,
                "CURRENT_MONTH": (11 == new Date().getMonth()) || (0 == new Date().getMonth())
            })
            FY2Months.push({
                "MONTH_INDEX": 6,
                "MONTH": "02",
                "MONTH_NAME": "Feb-Mar",
                "Month": 2,
                "CURRENT_MONTH": (1 == new Date().getMonth()) || (2 == new Date().getMonth())
            })

            return FY2Months;
        }
    };
}]);
