﻿app.controller("AccMainController", ['$scope', 'BaseService', 'CONFIG_PATH', 'ACCOUNT_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, ACCOUNT_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth());
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth = $scope.periodMonth - 1;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth = $scope.periodMonth + 1;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    function GetHeader() {

        BaseService.GetHeaderGridView('InceitveConfigApproval')
            .then(function (result) {
                $scope.ListHeader2 = result;
                // console.log($scope.ListHeader2);
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.ListAccrue = result.Table2;
                $scope.ListPayment = result.Table3;
                $scope.ListReconcile = result.Table4;

            }, function (error) {
                console.log('Unable to load GetIncDash data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])

app.controller("EstimatePaymentController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'BizDataService', 'Upload', '$timeout', function ($scope, BaseService, ACCOUNT_PATH, BizDataService, Upload, $timeout) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('EstimatePayment')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH, "GetEstimatePayment", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.formData = {};

        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.PAY_MONTH == null || $scope.formData.PAY_MONTH == '') {
            BaseService.Message.info('Month payment cannot empty.');
            return;
        }

        if ($scope.formData.PAY_DATE == null || $scope.formData.PAY_DATE == '') {
            BaseService.Message.info('Payment date cannot empty.');
            return;
        }

        if ($scope.formData.DUE_DATE == null || $scope.formData.DUE_DATE == '') {
            BaseService.Message.info('Submit due date cannot empty.');
            return;
        }

        if ($scope.formData.GM_APPROVE_DUE_DATE == null || $scope.formData.GM_APPROVE_DUE_DATE == '') {
            BaseService.Message.info('GM Accrue due date cannot empty.');
            return;
        }
        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(ACCOUNT_PATH, "SaveEstimatePayment", data)
            .then(function (result) {
                BaseService.Message.info('Successfully saved').then(function() {
                  GetData();
                  document.getElementById('DetailModal').style.display = 'none';
                })
            }, function (error) {
                console.log('Unable to SaveEstimatePayment: ' + error.message)
            })
    }


    $scope.ShowItem_Click = function (ID) {

        document.getElementById('DetailModal').style.display = 'block';

        var sendData = [{ "ID": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH, "GetEstimatePayment", data)
            .then(function (result) {
                $scope.formData = result[0]
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })

    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openPayDate = function () {
        $scope.popupPayDate.opened = true;
    }

    $scope.popupPayDate = {
        opened: false
    }

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
    $scope.openGMApproveDate = function () {
        $scope.popupGMApproveDate.opened = true;
    }
    $scope.popupGMApproveDate = {
        opened: false
    }
}])

app.controller("Rpt1DealerPaymentController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, ACCOUNT_PATH, REPORT_PATH, BizDataService, $filter) {
    
    Opening();

    function Opening() {
        $scope.Section = 0;
        $scope.REPORT_ID = 146;
        $scope.FnName = "GetDealerPaymentByMonthly";
        $scope.reportName = 'Dealer payment for Campaign';
       
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "REPORT_ID": $scope.REPORT_ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH, $scope.FnName, data)
            .then(function (result) {
              
                $scope.ListDetail = result.Table;
                
            }, function (error) {
                console.log('Unable to load GetPayment: ' + error.message)
            })
    }

    $scope.Payto_Change = function (Payto) {
        $scope.Section = Payto;
        $scope.FnName = "GetDealerPaymentByMonthly";

        switch (Payto) {
            case 0:
                $scope.REPORT_ID = 146;
                $scope.reportName = 'Dealer payment for Campaign';
                break;

            case 1:
                $scope.REPORT_ID = 147;
                $scope.reportName = 'Dealer payment for Fleet';
                break;

            case 2:
                $scope.REPORT_ID = 148;
                $scope.reportName = 'Dealer payment for Incentive';
                break;

            case 3:
                $scope.REPORT_ID = 149;
                $scope.reportName = 'Dealer payment for CQ';
                break;

            case 4:
                break;

            default:
                break;
        }

        $scope.reportSum = 'VME_Rpt_ACC_Dealer_Payment_ByMonthly&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName
        $scope.reportDetail = 'VME_Rpt_ACC_Dealer_Payment_ByMonthly_Detail&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName

        GetData();
       
    };


    $scope.$watch('Month', function(value) {
        if(value) {
            $scope.DATA_MONTH = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
            $scope.reportSum = 'VME_Rpt_ACC_Dealer_Payment_ByMonthly&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName
            $scope.reportDetail = 'VME_Rpt_ACC_Dealer_Payment_ByMonthly_Detail&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName
            GetData();
        }
    })
    
    $scope.openMonth = function() {
        $scope.popupMonth.opened = true;
    };
    $scope.popupMonth = {
        opened: false,
    };

    $scope.Report_Click = function (RptNo) {

        if (RptNo == 'Summary') {
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportSum , '_blank');
        } else if (RptNo == 'Detail'){
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportDetail , '_blank');
        }
       
    }

}])

app.controller("OverallAccrueAsofController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, ACCOUNT_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {
        Opening();
        function Opening() {
            let date = new Date();
            $scope.periodMonth = (date.getMonth() + 1);
            $scope.periodYear = date.getFullYear();
            $scope.ViewSection = 1;
            $scope.SumDetail = 1;
            $scope.fnCall = 'GetOverallAccrueAsof';
            document.getElementById('Summary2').style.display = 'none';
            GetHeader();
            $scope.$watch('ViewDetail_Change', function(value) {
                if(value) {
                    $scope.ViewDetail_Change($scope.ViewSection)
                }
            },true)
        }
        function GetHeader() {
            var sendData = [{
                'TableName1': 'OverallAccrueAsofTotal'
                , 'TableName2': 'CampaignAccrueAsof'
                , 'TableName3': 'FleetAccrueAsof '
                , 'TableName4': ''
                , 'TableName5': ''
            }];
            var data = BaseService.ConvertParam(sendData[0]);
            BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
                .then(function (result) {
                    $scope.ListHeader1 = result.Table;
                    $scope.ListHeader2 = result.Table1;
                    $scope.ListHeader3 = result.Table2;
                    $scope.ListHeader4 = result.Table3;
                    $scope.ListHeader5 = result.Table4;
                    $scope.ListHeader = $scope.ListHeader1;
                }, function (error) {
                    console.log('Unable to load header data: ' + error.message)
                });
        }

        function GetData() {
            BaseService.CallAction(ACCOUNT_PATH, $scope.fnCall)
                .then(function (result) {
                    $scope.ViewDetailSum = result.Table;
                }, function (error) {
                    console.log('Unable to load ' + $scope.fnCall + ' data: ' + error.message)
                })
        }
        function GetModelSummary() {
            BaseService.CallAction(ACCOUNT_PATH, $scope.fnCall)
                .then(function (result) {
                    $scope.ViewDetailSum1 = result.Table;
                }, function (error) {
                    console.log('Unable to load ' + $scope.fnCall + ' data: ' + error.message)
                })
        }
        function GetModelMonthly() {
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
            var data = BaseService.ConvertParam(sendData[0]);
            BaseService.CallAction(ACCOUNT_PATH, $scope.fnCall,data)
                .then(function (result) {
                    $scope.ViewDetailSum1 = result.Table;
                }, function (error) {
                    console.log('Unable to load '+  $scope.fnCall + ' data: ' + error.message)
                })
        }
        $scope.ViewDetail_Change = function (iNumber) {
            $scope.ViewSection = iNumber;
            document.getElementById('Summary1').style.display = 'block';
            document.getElementById('Summary2').style.display = 'none';
            if ($scope.ViewSection == 1) {
                $scope.fnCall = 'GetOverallAccrueAsof';
            } else if ($scope.ViewSection == 2) {
                $scope.fnCall = 'GetCampaignAccrueAsof';

            } else if ($scope.ViewSection == 21) {
                $scope.fnCall = 'GetDealerAccrueAsof';
            } else if ($scope.ViewSection == 22) {
                $scope.fnCall = 'GetLeasingAccrueAsof';
            } else if ($scope.ViewSection == 23) {
                $scope.fnCall = 'GetInsuranceAccrueAsof';
            } else if ($scope.ViewSection == 24) {
                $scope.fnCall = 'GetAfterSalesAccrueAsof';

            } else if ($scope.ViewSection == 3) {
                $scope.fnCall = 'GetFleetAccrueAsof';
            } else if ($scope.ViewSection == 4) {
                $scope.fnCall = 'GetIncentiveAccrueAsof';
            } else if ($scope.ViewSection == 5) {
                $scope.fnCall = 'GetDemoCarAccrueAsof';
            } else if ($scope.ViewSection == 6) {
                $scope.fnCall = 'GetCQAccrueAsof';
            }
            GetData();
        }
        $scope.ViewModelTotal_Click = function () {
            $scope.viewMonth = false;
            document.getElementById('Summary1').style.display = 'none';
            document.getElementById('Summary2').style.display = 'block';
            if ($scope.ViewSection == 1){
                $scope.fnCall = 'GetOverallAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 2){
                $scope.fnCall = 'GetCampaignAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader2;
            }      

            else if ($scope.ViewSection == 21) {
                $scope.fnCall = 'GetDealerAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 22) {
                $scope.fnCall = 'GetLeasingAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 23) {
                $scope.fnCall = 'GetInsuranceAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }   
            else if ($scope.ViewSection == 24) {
                $scope.fnCall = 'GetAfterSalesAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }   

            else if ($scope.ViewSection == 3){
                $scope.fnCall = 'GetFleetAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader3;
            }
            else if ($scope.ViewSection == 4){
                $scope.fnCall = 'GetIncentiveAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 5){
                $scope.fnCall = 'GetDemoCarAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 6){
                $scope.fnCall = 'GetCQAccrueAsofSummary';
                $scope.ListHeader = $scope.ListHeader1;
            }
            GetModelSummary();
        }
        $scope.ViewModelMonthly_Click = function (DATA_MONTH) {
            $scope.viewMonth = true;
            $scope.DATA_MONTH = DATA_MONTH;
            $scope.periodYear = parseInt($scope.DATA_MONTH.substr(0, 4));
            $scope.periodMonth = parseInt(($scope.DATA_MONTH).substr(-2));
            $scope.periodMonth = new Date(1990,$scope.periodMonth - 1,1).toLocaleString("en-us", {month: "long"});
            document.getElementById('Summary1').style.display = 'none';
            document.getElementById('Summary2').style.display = 'block';
            if ($scope.ViewSection == 1){
                $scope.fnCall = 'GetOverallAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 2){
                $scope.fnCall = 'GetCampaignAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader2;
            }

            else if ($scope.ViewSection == 21) {
                $scope.fnCall = 'GetDealerAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 22) {
                $scope.fnCall = 'GetLeasingAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 23) {
                $scope.fnCall = 'GetInsuranceAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 24) {
                $scope.fnCall = 'GetAfterSalesAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
           
            else if ($scope.ViewSection == 3){
                $scope.fnCall = 'GetFleetAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader3;
            }
            else if ($scope.ViewSection == 4){
                $scope.fnCall = 'GetIncentiveAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 5){
                $scope.fnCall = 'GetDemoCarAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            else if ($scope.ViewSection == 6){
                $scope.fnCall = 'GetCQAccrueAsofMonthly';
                $scope.ListHeader = $scope.ListHeader1;
            }
            GetModelMonthly();
        }
        $scope.CloseItem_Click = function () {
            document.getElementById('Summary1').style.display = 'block';
            document.getElementById('Summary2').style.display = 'none';
        }
        $scope.Report_Click = function () {
            switch($scope.ViewSection){
                case 1 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_Overall_Accrue_Asof_Monthly';
                        reportName ='Overall balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_Overall_Accrue_Asof_Summary';
                        reportName='Overall balance summary';
                        $scope.DATA_MONTH=null;
                    }                   
                break;
                case 2 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_CMP_Accrue_Asof_Monthly';
                        reportName='Campaign (overall) balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_CMP_Accrue_Asof_Summary';
                        reportName='Campaign (overall) balance summary';
                        $scope.DATA_MONTH=null;
                    }                   
                    break;

                case 21:
                    if ($scope.viewMonth == true) {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Monthly_Dealer';
                        reportName = 'Dealer balance monthly';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Summary_Dealer';
                        reportName = 'Dealer balance summary';
                        $scope.DATA_MONTH = null;
                    }
                    break;

                case 22:
                    if ($scope.viewMonth == true) {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Monthly_Leasing';
                        reportName = 'Leasing balance monthly';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Summary_Leasing';
                        reportName = 'Leasing balance summary';
                        $scope.DATA_MONTH = null;
                    }
                    break;

                case 23:
                    if ($scope.viewMonth == true) {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Monthly_Lockton';
                        reportName = 'Lockton balance monthly';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Summary_Lockton';
                        reportName = 'Lockton balance summary';
                        $scope.DATA_MONTH = null;
                    }
                    break;

                case 24:
                    if ($scope.viewMonth == true) {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Monthly_AfterSales';
                        reportName = 'After sales balance monthly';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Accrue_Asof_Summary_AfterSales';
                        reportName = 'After sales balance summary';
                        $scope.DATA_MONTH = null;
                    }
                    break;

                case 3 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_FLT_Accrue_Asof_Monthly';
                        reportName='Fleet balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_FLT_Accrue_Asof_Summary';
                        reportName='Fleet balance summary';
                        $scope.DATA_MONTH=null;
                    }
                break;
                case 4 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_INC_Accrue_Asof_Monthly';
                        reportName='Incentive balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_INC_Accrue_Asof_Summary';
                        reportName='Incentive balance summary';
                        $scope.DATA_MONTH=null;
                    }
                break;
                case 5 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_DMC_Accrue_Asof_Monthly';
                        reportName='Demo car balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_DMC_Accrue_Asof_Summary';
                        reportName='Demo car balance summary';
                        $scope.DATA_MONTH=null;
                    }
                break;
                case 6 :
                    if($scope.viewMonth==true){
                        reportCode='VME_Rpt_CQ_Accrue_Asof_Monthly';
                        reportName='CQ balance monthly';
                    }
                    else{
                        reportCode='VME_Rpt_CQ_Accrue_Asof_Summary';
                        reportName='CQ balance summary';
                        $scope.DATA_MONTH=null;
                    }
                break;
            }
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
        }
    }])

app.controller("OverallPaymentController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, ACCOUNT_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;
        $scope.SumDetail = 1;
        $scope.fnCall = 'GetOverallPayment';
        GetHeader();

        $scope.sortType = 'MODEL_ORDER';
        $scope.sortReverse = false;
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {

        var sendData = [{
            'TableName1': 'AllAccrueByModel'
            , 'TableName2': 'RptCampaignPaymentSummary'
            , 'TableName3': 'FleetPaymentWithCBbyModel'
            , 'TableName4': 'RptIncentiveAllSummary'
            , 'TableName5': 'ModelDemoCarAccrueSummary'
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
                $scope.ListHeader3 = result.Table2;
                $scope.ListHeader4 = result.Table3;
                $scope.ListHeader5 = result.Table4;
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('ModelSummary1')
            .then(function (result) {
                $scope.ListHeader6 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH, $scope.fnCall, data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
            }, function (error) {
                console.log('Unable to load GetOverallAccrue data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {

        $scope.ViewSection = iNumber;
        if ($scope.ViewSection == 1) {
            $scope.fnCall = 'GetOverallPayment';
            $scope.ListHeader = $scope.ListHeader1;

        } else if ($scope.ViewSection == 2) {
            $scope.fnCall = 'GetOverallCampaignPayment';
            $scope.ListHeader = $scope.ListHeader2;

        } else if ($scope.ViewSection == 3) {
            $scope.fnCall = 'GetFleetPaymentMonthlyByModel';
            $scope.ListHeader = $scope.ListHeader3;

        } else if ($scope.ViewSection == 4) {
            $scope.fnCall = 'GetOverallIncentivePayment';
            $scope.ListHeader = $scope.ListHeader4;

        } else if ($scope.ViewSection == 5) {
            $scope.fnCall = 'GetDemoCarPaymentByMonth';
            $scope.ListHeader = $scope.ListHeader5;

        } else if ($scope.ViewSection == 6) {
            $scope.fnCall = 'GetCQPaymentMonthlyByModel';
            $scope.ListHeader = $scope.ListHeader6;
        }
        GetData();
    }

    $scope.Report_Click = function () {

        switch($scope.ViewSection){
            case 1:
            reportCode = 'VME_Rpt_All_Type_Payment_Summary';
            reportName = 'Overall payment summary';
            break;
            case 2:
            reportCode = 'VME_Rpt_CMP_All_Type_Payment_Summary';
            reportName = 'Campaign all payment summary';
            break;
            case 3:
            reportCode='VME_Rpt_FLT_Payment_Monthly_Model';
            reportName='Fleet payment summary';
            break;
            case 4:
            reportCode = 'VME_Rpt_INC_All_Type_Payment_Summary';
            reportName = 'Incentive all payment summary';
            break;
            case 5:
            reportCode = 'VME_Rpt_DMC_Payment_Summary';
            reportName = 'Demo car payment summary';
            break;
            case 6:
            reportCode = 'VME_Rpt_CQ_Payment_Summary';
            reportName = 'CQ incentive payment summary';
            break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }


    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("AllOperationsController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, ACCOUNT_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;
        $scope.SumDetail = 1;
        $scope.FnName ='GetAllOperations';
        GetHeader();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {

        BaseService.GetHeaderGridView('AllOperations')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME_SHORT
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(ACCOUNT_PATH,$scope.FnName, data)
            .then(function (result) {
                $scope.ViewDetail = result.Table;
            }, function (error) {
                console.log('Unable to load GetAllOperations data: ' + error.message)
            })
    }

    $scope.Report_Click = function () {
        $scope.reportCode='VME_Rpt_All_Operations_Monthly';
        $scope.reportName='Monthly operations on '+$scope.DATA_MONTHNAME;
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
    }

}])

app.controller("AsOfAllController", ['$scope', 'BaseService', 'ACCOUNT_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, ACCOUNT_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.filter = {};
        $scope.Section = 1;
        GetHeader();
        $scope.$watch('ASOF_DATE','periodYear', 'periodMonth', function (value) {
            if (value) {
                console.log(value)
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('AllOperations')
            .then(function (result) {
                $scope.ListHeader1 = result;
                $scope.ListHeader = $scope.ListHeader1
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('FleetOperations')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.ASOF_DATE) != 'undefined'){
            var d = $scope.ASOF_DATE;
            $scope.AsOf_Date = d.getFullYear().toString() + '-' + ('00'+(d.getMonth()+1).toString()).substr(-2) + '-' + d.getDate().toString()
            $scope.AsOf_DateMonth = ('00'+(d.getDate()).toString()).substr(-2)+'-'+d.toLocaleString("en-us", {month: "long"}).substr(0,4)+'-'+d.getFullYear().toString()
        }
        if (typeof ($scope.AsOf_Date) == 'undefined') {
            return;
        }

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME_SHORT
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }             
        GetData();
    }

    function GetData() {
       
        if ($scope.VME_TYPE == 'Fleet') {
            $scope.ListHeader = $scope.ListHeader2;
        } else {
            $scope.ListHeader = $scope.ListHeader1;
        }
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH,"ASOF_DATE":$scope.ASOF_DATE,"VME_TYPE":$scope.VME_TYPE}];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(ACCOUNT_PATH, 'GetAsOfAllType', data)
            .then(function (result) {
                $scope.ViewDetail = result.Table;
               $scope.ViewDetail1 = result.Table1;
            }, function (error) {
                console.log('Unable to load GetAsOfAllType data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function(iNumber){
        $scope.Section = iNumber;
    }

    $scope.Report_Click = function () {
        if($scope.Section==1){
            $scope.reportCode='VME_Rpt_AsOf_All_Month';
            $scope.reportName= $scope.VME_TYPE+' : RS Month for '+$scope.AsOf_DateMonth;
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.AsOf_Date + '&p2=' + $scope.VME_TYPE + '&p3=' + $scope.reportName,'_blank');
        }
        else if($scope.Section==2){
            $scope.reportCode='VME_Rpt_AsOf_ByMonth';
            $scope.reportName= $scope.VME_TYPE+' : RS Month for '+$scope.DATA_MONTHNAME+' retail sale on '+$scope.AsOf_DateMonth;
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.AsOf_Date + '&p3=' + $scope.VME_TYPE +'&p4=' + $scope.reportName,'_blank');
        }      
    }
    $scope.openAsOfDate = function () {
        $scope.popupAsOfDate.opened = true;
    }
    $scope.popupAsOfDate = {
        opened: false
    }

}])

app.controller("InterfaceCheckController", ["$scope", "BaseService", "ACCOUNT_PATH", "REPORT_PATH", "$filter", function ($scope, BaseService, ACCOUNT_PATH, REPORT_PATH, $filter) {
   
    $scope.init = function () {
        $scope.ListInterfaceStatus = [];
        $scope.ListInterfaceDetail = [];
        $scope.showDetail = false;
        $scope.filters = { IS_FAILED: 'Y' };
        $scope.detail_filters = {};
        $scope.GetInterfaceStatus();
    }

    $scope.GetInterfaceStatus = function () {
        BaseService.GetDataTable(ACCOUNT_PATH, "GetInterfaceStatus")
            .then(function (result) {
                $scope.ListInterfaceStatus = result;
            })
    }

    $scope.typeFilter = function () {
        return $filter('unique')(
            $filter('filter')($scope.ListInterfaceStatus, $scope.filters)
            , "VME_TYPE");
    }

    $scope.ViewDetail_Click = function (item) {
        $scope.showDetail = true;
        $scope.detail_filters = {};
        $scope.ListInterfaceDetail = [];
        let data = BaseService.ConvertParam({
            VME_TYPE: item.VME_TYPE,
            VME_ID: item.VME_ID,
            IF_FLAG: item.IF_FLAG,
            IF_SENT: item.IF_SENT
        });

        BaseService.CallAction(ACCOUNT_PATH, "GetInterfaceDetail", data)
            .then(function (result) {
                $scope.ListInterfaceDetail = result;
            })
    }

    $scope.closeDetail = function () {
        $scope.showDetail = false;
        $scope.detail_filters = {};
        $scope.ListInterfaceDetail = [];
    }

    $scope.getFailRecordCount = function () {
        return $filter('filter')($scope.ListInterfaceDetail, { RESULT_OVERALL: 'N' }, true).length;
    }

    $scope.init();
}])