﻿app.controller("CQMainController", ['$scope', 'BaseService', 'CONFIG_PATH', 'CQ_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, CQ_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth());
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth = $scope.periodMonth - 1;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth = $scope.periodMonth + 1;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    function GetHeader() {

        BaseService.GetHeaderGridView('InceitveConfigApproval')
            .then(function (result) {
                $scope.ListHeader2 = result;
                console.log($scope.ListHeader2);
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.OpenReport = function () {
        reportCode = "VME_Rpt_VDM_SSI_Unit_Confirm";
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.periodYear , '_blank');
    }
    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.ListAccrue = result.Table2;
                $scope.ListPayment = result.Table3;
                $scope.ListReconcile = result.Table4;

                $scope.ListVolumeCQ = result.Table5;

            }, function (error) {
                console.log('Unable to load GetIncDash data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])

app.controller("CQConfigController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', function ($scope, BaseService, CQ_PATH, BizDataService) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.year = date.getFullYear();
        $scope.filter = {};
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CQConfigList')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load Chassis amount data: ' + error.message)
            })
    }

    $scope.GetData = function () {
        var data = BaseService.ConvertParam({
            "year": $scope.year
        })
        BaseService.CallAction(CQ_PATH, 'GetCQConfigList', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load CQ config data: ' + error.message)
            })
    }
    $scope.GetData();

    $scope.Edit_Submit = function () {

        if ($scope.formData.SSI_TARGET1_AMT == null || $scope.formData.SSI_TARGET1_AMT == '') {
            BaseService.Message.warning("SSI Target cannot empty.");
            return;
        }
        if ($scope.formData.SSI_TARGET2_AMT == null || $scope.formData.SSI_TARGET2_AMT == '') {
            BaseService.Message.warning("SSI Country cannot empty.");
            return;
        }
        if ($scope.formData.CSI_TARGET1_AMT == null || $scope.formData.CSI_TARGET1_AMT == '') {
            BaseService.Message.warning("CSI Target cannot empty.");
            return;
        }
        if ($scope.formData.CSI_TARGET2_AMT == null || $scope.formData.CSI_TARGET2_AMT == '') {
            BaseService.Message.warning("CSI Country cannot empty.");
            return;
        }

        if ($scope.formData.CSI_TARGET2_AMT < $scope.formData.CSI_TARGET1_AMT) {
            BaseService.Message.warning("CSI Target1 cannot be more than CSI Target2.");
            return;
        }

        if ($scope.formData.SSI_TARGET2_AMT < $scope.formData.SSI_TARGET1_AMT) {
            BaseService.Message.warning("SSI Target1 cannot be more than SSI Target2.");
            return;
        }


        if ($scope.formData.SSI_STD_PASS1 == null || $scope.formData.SSI_STD_PASS1 == '') {
            BaseService.Message.warning("SSI VDM bonus lv.1 cannot empty.");
            return;
        }
        if ($scope.formData.SSI_ADD_PASS1 == null || $scope.formData.SSI_ADD_PASS1 == '') {
            BaseService.Message.warning("SSI Extra bonus lv.1 cannot empty.");
            return;
        }
        if ($scope.formData.SSI_STD_PASS2 == null || $scope.formData.SSI_STD_PASS2 == '') {
            BaseService.Message.warning("SSI VDM bonus lv.2 cannot empty.");
            return;
        }
        if ($scope.formData.SSI_ADD_PASS2 == null || $scope.formData.SSI_ADD_PASS2 == '') {
            BaseService.Message.warning("SSI Extra bonus lv.2 cannot empty.");
            return;
        }
        if ($scope.formData.SSI_TARGET_MIN == null || $scope.formData.SSI_TARGET_MIN == '') {
            BaseService.Message.warning("SSI MIN cannot empty.");
            return;
        }
        if ($scope.formData.SSI_TARGET_SOP8 == null || $scope.formData.SSI_TARGET_SOP8 == '') {
            BaseService.Message.warning("SSI SOP8 cannot empty.");
            return;
        }
        if ($scope.formData.SSI_TARGET_SOP10 == null || $scope.formData.SSI_TARGET_SOP10 == '') {
            BaseService.Message.warning("SSI SOP10 cannot empty.");
            return;
        }

        if ($scope.formData.CSI_STD_PASS1 == null || $scope.formData.CSI_STD_PASS1 == '') {
            BaseService.Message.warning("CSI VDM bonus lv.1 cannot empty.");
            return;
        }
        if ($scope.formData.CSI_ADD_PASS1 == null || $scope.formData.CSI_ADD_PASS1 == '') {
            BaseService.Message.warning("CSI Extra bonus lv.1 cannot empty.");
            return;
        }
        if ($scope.formData.CSI_STD_PASS2 == null || $scope.formData.CSI_STD_PASS2 == '') {
            BaseService.Message.warning("CSI VDM bonus lv.2 cannot empty.");
            return;
        }
        if ($scope.formData.CSI_ADD_PASS2 == null || $scope.formData.CSI_ADD_PASS2 == '') {
            BaseService.Message.warning("CSI Extra bonus lv.2 cannot empty.");
            return;
        }
        if ($scope.formData.CSI_TARGET_MIN == null || $scope.formData.CSI_TARGET_MIN == '') {
            BaseService.Message.warning("CSI MIN cannot empty.");
            return;
        }
        if ($scope.formData.CSI_TARGET_SOP13 == null || $scope.formData.CSI_TARGET_SOP13 == '') {
            BaseService.Message.warning("CSI SOP13 cannot empty.");
            return;
        }
        if ($scope.formData.CSI_TARGET_SOP14 == null || $scope.formData.CSI_TARGET_SOP14 == '') {
            BaseService.Message.warning("CSI SOP14 cannot empty.");
            return;
        }

        var data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(CQ_PATH, 'SaveCQConfig', data)
            .then(function (result) {
                BaseService.Message.info("Successfully saved.");
                $scope.CloseItem_Click();
                $scope.GetData();
            }, function (error) {
                console.log('Unable to save CQ config data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (id) {
        document.getElementById("DetailModal").style.display = "block";
        var data = BaseService.ConvertParam({
            "year": $scope.year,
            "id": id
        })
        BaseService.CallAction(CQ_PATH, 'GetCQConfig', data)
            .then(function (result) {
                $scope.formData = result[0];
            }, function (error) {
                console.log('Unable to load CQ config data: ' + error.message)
            })
    }

    $scope.AddConfig_Click = function () {

        BaseService.Message.confirm("Would you like to add all quarter?").then(function () {
            $scope.formData = {
                "ID": 0,
                "YEAR": $scope.year
            };

            var data = BaseService.ConvertParam($scope.formData);
            BaseService.CallAction(CQ_PATH, 'SaveCQConfig', data)
                .then(function (result) {
                    $scope.GetData();
                    BaseService.Message.info("Successfully quarter added.");
                }, function (error) {
                    console.log('Unable to save CQ config data: ' + error.message)
                })
        })
    }

    $scope.CloseItem_Click = function () {
        document.getElementById("DetailModal").style.display = "none";
    }

    $scope.Approve_Submit = function (obj, type, QUARTER) {

        BaseService.Message.confirm("Would you like to \"" + type.toLowerCase() + "\" this model?").then(function () {
            const data = BaseService.ConvertParam({
                "ID": obj.ID,
                "TYPE": type,
                "quarter": QUARTER
            });

            BaseService.CallAction(CQ_PATH, "CQApproveSubmit", data)
                .then(function (result) {
                    $scope.GetData();
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }

}])

app.controller("UploadBookingController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, BaseService, CQ_PATH, BizDataService, Upload, $timeout, REPORT_PATH) {

    //------ Set booking type
    $scope.confirmBtn = null;
    $scope.fileUpload = null;

    Opening();

    function Opening() {
        let date = new Date()
        $scope.year = date.getFullYear();
        $scope.formData = {};
        GetHeader();
        $scope.$watch('year', function (value) {
            $scope.GetData;
        });

        $scope.IS_ROLE = true;
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("CQFileUpload")
            .then(function (result) {
                $scope.HeaderFields = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.GetData = function () {
        if ($scope.quarter == null || $scope.year == null) {
            return;
        }

        let data = BaseService.ConvertParam({
            quarter: $scope.quarter.Quarter,
            quarterYear: $scope.year,
            type: 'Acc',
            month: $scope.quarter.Month
        });

        BaseService.CallAction(CQ_PATH, 'CQFileUploadList', data)
            .then(function (result) {
                $scope.FindResult1 = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.uploadData = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.ListDetail = null;

                file.upload = Upload.upload({
                    url: window.location.origin + CQ_PATH + '/UploadBooking',
                    data: {
                        File: file,
                        quarter: $scope.quarter.Quarter,
                        quarterYear: $scope.year,
                        sourceForm: $scope.SOURCE_FROM,
                        month: $scope.quarter.Month
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved.");
                        $scope.ListDetail = res.data;
                        $scope.confirmBtn = null;
                        $scope.fileUpload = null;

                        $scope.GetData();
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file");
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });
            })
        }
    };

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }

    $scope.Source_Change = function () {

        $scope.IS_ROLE = false;
        if ($scope.SOURCE_FROM == 'Customer data') {
            $scope.IS_ROLE = true;
        } else if ($scope.SOURCE_FROM == 'Manpower & Training') {
            $scope.IS_ROLE = true;
        } else if ($scope.SOURCE_FROM == 'SSI Performance') {
            $scope.IS_ROLE = true;
        } else if ($scope.SOURCE_FROM == 'CSI Performance') {
            $scope.IS_ROLE = true;
        } else {
            //Waring
            return;
        }
    }

    $scope.Download_Click = function () {
        var gReport = '';

        if ($scope.SOURCE_FROM == 'Customer data') {
            gReport = 'CQ01BOOKING_CUST';
        } else if ($scope.SOURCE_FROM == 'Manpower & Training') {
            gReport = 'CQ01BOOKING_MAN';
        } else if ($scope.SOURCE_FROM == 'SSI Performance') {
            gReport = 'CQ01BOOKING_SSI';
        } else if ($scope.SOURCE_FROM == 'CSI Performance') {
            gReport = 'CQ01BOOKING_CSI';
        } else {
            //Waring
            return;
        }

        var gDataMonth;
        if ($scope.quarter.Month < 10) {
            gDataMonth = $scope.year + '0' + $scope.quarter.Month;
        } else {
            gDataMonth = $scope.year + '' + $scope.quarter.Month;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&ExportName=' + gReport + '_' + gDataMonth + '&rc=' + gReport + '&p1=' + gDataMonth + '&p2=Acc', '_blank');
    }

}])

app.controller("UploadPaymentController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, BaseService, CQ_PATH, BizDataService, Upload, $timeout, REPORT_PATH) {

    $scope.confirmBtn = null;
    $scope.fileUpload = null;

    //------ Set payment type
    Opening();

    function Opening() {
        let date = new Date()
        $scope.year = date.getFullYear();
        $scope.formData = {};
        GetHeader();

    }

    function GetHeader() {
        BaseService.GetHeaderGridView("CQFileUpload")
            .then(function (result) {
                $scope.HeaderFields = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.GetData = function () {
        if ($scope.quarter == null || $scope.year == null) {
            return;
        }
        let data = BaseService.ConvertParam({
            quarter: $scope.quarter,
            quarterYear: $scope.year,
            type: 'Pay'
        });

        BaseService.CallAction(CQ_PATH, 'CQFileUploadList', data)
            .then(function (result) {
                $scope.FindResult1 = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.uploadData = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.ListDetail = null;

                file.upload = Upload.upload({
                    url: window.location.origin + CQ_PATH + '/UploadPayment',
                    data: {
                        File: file,
                        quarter: $scope.quarter,
                        quarterYear: $scope.year,
                        sourceForm: $scope.SOURCE_FROM
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved.");
                        $scope.ListDetail = res.data;
                        $scope.confirmBtn = null;
                        $scope.fileUpload = null;

                        $scope.GetData();
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file");
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });
            });
        }
    };

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }

    $scope.Download_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        var gReport = '';

        if ($scope.SOURCE_FROM == 'Customer data') {
            gReport = 'CQ01BOOKING_CUST';
        } else if ($scope.SOURCE_FROM == 'Manpower & Training') {
            gReport = 'CQ01BOOKING_MAN';
        } else if ($scope.SOURCE_FROM == 'SSI Performance') {
            gReport = 'CQ01BOOKING_SSI';
        } else if ($scope.SOURCE_FROM == 'CSI Performance') {
            gReport = 'CQ01BOOKING_CSI';
        } else {
            //Waring
            return;
        }

        var gDataMonth;
        if ($scope.quarter == 1) {
            gDataMonth = $scope.year + '06';
        } else if ($scope.quarter == 2) {
            gDataMonth = $scope.year + '09';
        } else if ($scope.quarter == 3) {
            gDataMonth = $scope.year + '12';
        } else if ($scope.quarter == 4) {
            gDataMonth = parseInt($scope.year + 1) + '03';
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&&export=excelopenxml&ExportName=' + gReport + '_Quarter' + $scope.quarter + '&rc=' + gReport + '&p1=' + gDataMonth + '&p2=Pay', '_blank');
    }

}])

app.controller("CQSummaryController", ['$scope', 'BaseService', 'CQ_PATH', 'REPORT_PATH', 'BizDataService', 'Upload', '$timeout', function ($scope, BaseService, CQ_PATH, REPORT_PATH, BizDataService, Upload, $timeout) {

    Opening();

    function Opening() {
        $scope.confirmBtn = null;
        $scope.fileUpload = null;

        let date = new Date()
        $scope.year = date.getFullYear();
        if (date.getMonth() <= 2) {
            $scope.quarter = "4";
        } else if (date.getMonth() <= 5) {
            $scope.quarter = "1";
        } if (date.getMonth() <= 8) {
            $scope.quarter = "2";
        } else {
            $scope.quarter = "3";
        }

        $scope.month = '00';
        $scope.formData = {};
        GetHeader();
        $scope.Section = 0;
        GetData()
    }


    function GetHeader() {
        BaseService.GetHeaderGridView("CQDetailShort")
            .then(function (result) {
                $scope.HeaderFields = result;
            }, function (error) {
                console.log('Unable to load header CQDetailShort : ' + error.message)
            })
    }


    function GetData() {

        $scope.QuarterMonth = BizDataService.GetQuarterMonth($scope.year, $scope.quarter);

        let data = BaseService.ConvertParam({
            quarter: $scope.quarter,
            quarterYear: $scope.year
        });

        BaseService.CallAction(CQ_PATH, "GetCQSummary", data)
            .then(function (result) {
                $scope.M1Sum = result.Table;
                $scope.M1Detail = result.Table1;
                $scope.M2Sum = result.Table2;
                $scope.M2Detail = result.Table3;
                $scope.M3Sum = result.Table4;
                $scope.M3Detail = result.Table5;
                $scope.QuarterSum = result.Table6;
                $scope.QuarterDetail = result.Table7;
                $scope.Configure = result.Table8;
            }, function (error) {
                console.log('Unable to load GetCQSummary data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if ($scope.year == null || $scope.quarter == null) {
            return;
        }
        GetData();
    }

    $scope.Download_Click = function () {
        let reportName, reportParam1, reportParam2
        console.log($scope.year);
        switch ($scope.Section) {
            case 0:
                reportName = 'VME_Rpt_CQ_paramHdFYQ';
                reportParam1 = $scope.year;
                reportParam2 = $scope.quarter;
                break;

            case 1:
                reportName = 'VME_Rpt_CQ_paramHdFYM';
                if ($scope.quarter == 4) {
                    reportParam1 = ($scope.year + 1).toString() + ($scope.month).toString();
                } else {
                    reportParam1 = ($scope.year).toString() + ($scope.month).toString();
                }
               
                reportParam2 = $scope.quarter;
                break;

            case 2:
                reportName = 'VME_Rpt_CQ_paramHdFYM';

                if ($scope.quarter == 4) {
                    reportParam1 = ($scope.year + 1).toString() + ($scope.month).toString();
                } else {
                    reportParam1 = ($scope.year).toString() + ($scope.month).toString();
                }
                reportParam2 = $scope.quarter;
                break;

            case 3:
                reportName = 'VME_Rpt_CQ_paramHdFYM';
                if ($scope.quarter == 4) {
                    reportParam1 = ($scope.year + 1).toString() + ($scope.month).toString();
                } else {
                    reportParam1 = ($scope.year).toString() + ($scope.month).toString();
                }
                reportParam2 = $scope.quarter;
                break;

            default:
                break;
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportName + '&p1=' + reportParam1 + '&p2=' + reportParam2, '_blank');
    }

}])

app.controller("Rpt1CQSummaryController", ['$scope', 'BaseService', 'CQ_PATH', 'INCENTIVE_PATH', 'BizDataService', function ($scope, BaseService, CQ_PATH, INCENTIVE_PATH, BizDataService) {

    Opening();

    function Opening() {
        $scope.filter = {};
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.filter.checkAll = false;

        GetHeader();
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            BaseService.Message.warning('Please select month');
            return;
        }
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignChassisAmountRep')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load Chassis amount data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{
            "DATA_MONTH": $scope.DATA_MONTH
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, "GetCQRptSummary", data)
            .then(function (result) {
                $scope.OverlAll = result.Table;
                $scope.Detail1List = result.Table1;
                $scope.Detail2List = result.Table2;

                //console.log(result);
                //console.log(result.Table1);
            }, function (error) {
                console.log('Unable to load GetCQRptSummary data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };


}])

app.controller("CQAccrueController", ['$scope', 'BaseService', 'CQ_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CQ_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.loaded = true;
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        GetHeader();
        InitailDataModel();
        $scope.$watch('loaded', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('ModelSummary1')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptIncentiveAccrueDetail')
            .then(function (result) {
                $scope.ModelHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView("CQDetailShort")
            .then(function (result) {
                $scope.HeaderFields = result;
            }, function (error) {
                console.log('Unable to load header CQDetailShort : ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {

            return;
        }
        $scope.QUARTER = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].Quarter;
        GetData();
    }

    function GetData() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, "GetCQAccrueSummary", data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.M1Detail = result.Table1;
                $scope.SubmitStatus = result.Table2[0];
                $scope.AccPayList = result.Table3[0];

            }, function (error) {
                console.log('Unable to load GetCQAccrueSummary: ' + error.message)
            })
        BaseService.CallAction(CQ_PATH, "GetCQAccrueHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetCQAccrueHistory: ' + error.message)
            })

        if ($scope.ViewChassis == 1) {

            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
            var data = BaseService.ConvertParam(sendData[0]);
            BaseService.CallAction(CQ_PATH, 'GetCQAccrueByChassis', data)
                .then(function (result) {
                    $scope.DetailData1 = result;
                }, function (error) {
                    console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
                })
        }

    }
    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
    }

    $scope.Accrue_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Accrue':
                confirmType = 'submit accrue';
                submitType = 'submitted';
                break;

            case 'AccrueApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'AccrueReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            case 'MSControlApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'MSControlReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + " for this month?").then(function () {
            var sendData = [{
                "DATA_MONTH": $scope.DATA_MONTH,
                "STATUS": status,
                "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH)
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CQ_PATH, "SubmitAccrue", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result)
                    }
                }, function (error) {
                    console.log('Unable to load GetAccruePayment: ' + error.message)
                })
        })

    }


    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'CQModelSummary1';
        $scope.DVM_ACCRUE_TableName2 = '';
        $scope.DVM_ACCRUE_TableName3 = '';
        $scope.DVM_ACCRUE_TableName4 = '';
        $scope.DVM_ACCRUE_TableName5 = '';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetCQAccrueSummary';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));
        $scope.QUARTER = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].Quarter;

        $scope.SubSection = 0;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.M1Detail = result.Table1;
                $scope.SubmitStatus = result.Table2[0];
                $scope.AccPayList = result.Table3[0];

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, 'GetCQAccrueByChassis', data)
            .then(function (result) {
                $scope.DetailData1 = result;
            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {

        if (ReportNo == 'report0') {
            if ($scope.SubmitStatus.APPROVE_ACCRUE == null || $scope.SubmitStatus.APPROVE_ACCRUE == 'MS_Return' || $scope.SubmitStatus.APPROVE_ACCRUE == 'GM_Return') {
                $scope.reportName = 'CQ incentive - Summary';
            }
            else {
                $scope.reportName = 'CQ incentive accrue - Summary';
            }
            $scope.reportCode = 'VME_Rpt_CQ_Accrue_Summary';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        }
        else if (ReportNo == 'report1') {
            if ($scope.SubmitStatus.APPROVE_ACCRUE == null || $scope.SubmitStatus.APPROVE_ACCRUE == 'MS_Return' || $scope.SubmitStatus.APPROVE_ACCRUE == 'GM_Return') {
                $scope.reportName = 'CQ incentive - Detail';
            } else {
                $scope.reportName = 'CQ incentive accrue - Detail';
            }
            $scope.reportCode = 'VME_Rpt_CQ_Accrue_Detail';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        }
        else if (ReportNo == 'report2') {
            $scope.reportCode = 'VME_Rpt_CQ_paramHdFYM'
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.QUARTER, '_blank');
        }
    }
}])

app.controller("CQPaymentController", ['$scope', 'BaseService', 'CQ_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CQ_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        $scope.SubSection = 2;
        $scope.ViewSection = 2;
        $scope.SelectedDealer = [];
        $scope.SelectAllDealer = [];
        $scope.SUBMIT_DATE_FILTER = {};
        $scope.FILTER = {};

        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CQPaymentList')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('CQPayment1ListByModel')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('CQPayment1ListByChassis')
            .then(function (result) {
                $scope.ListHeader4 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('CQPayment1ListByDealer')
            .then(function (result) {
                $scope.ListHeader5 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('CQPayment1ListByOutlet')
            .then(function (result) {
                $scope.ListHeader6 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.SelectedDealer = [];
        let data_months = '';
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{
                "OPERATION_OF": $scope.OperationOf
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CQ_PATH, "GetPayment", data)
                .then(function (result) {
                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListSelectedTmp = result.Table2;
                    if ($scope.OperationOf == 'Manager') {
                        $scope.ListSubmitDate = result.Table3;
                    }
                    $scope.ListSelected = $scope.FilterOperationItem($scope.ListSelectedTmp, $scope.SUBMIT_DATE_FILTER);

                    let uniqueDataMonth = $filter('unique')($scope.ListSelected, "DATA_MONTH");
                    uniqueDataMonth.forEach(function (datamonth) {
                        data_months = data_months + ',' + datamonth.DATA_MONTH;
                    })

                    $scope.data_months = data_months.substr(1, data_months.length - 1);
                }, function (error) {
                    console.log('Unable to load CQ Payment: ' + error.message)
                })
        }, true)
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    $scope.SetSubmitDate = function (obj) {
        $scope.SUBMIT_DATE_FILTER = obj;
        $scope.SelectedDealer = [];
        $scope.SelectAllDealer = [];
        let data_months = '';

        $scope.ListSelected = $scope.FilterOperationItem($scope.ListSelectedTmp, $scope.SUBMIT_DATE_FILTER);
        $scope.SumSelected = $scope.FilterOperationItem($scope.SumSelectedTmp, $scope.SUBMIT_DATE_FILTER);

        let uniqueDataMonth = $filter('unique')($scope.ListSelected, "DATA_MONTH");
        uniqueDataMonth.forEach(function (datamonth) {
            data_months = data_months + ',' + datamonth.DATA_MONTH;
        })

        $scope.data_months = data_months.substr(1, data_months.length - 1);

    }

    $scope.FilterOperationItem = function (TargetObject, ObjectToCompare) {
        return (
            ($scope.OperationOf == 'Manager') ?
                $filter('filter')(TargetObject, {
                    ID: ((ObjectToCompare != null && ObjectToCompare.hasOwnProperty('ID') ? ObjectToCompare.ID : null))
                }, true) :
                TargetObject
        )
    }

    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedDealer.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var dealercode = [];
        $scope.SelectedDealer.forEach(function (item) {
            dealercode.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "DEALER_CODE": dealercode,
        }, "DEALER_CODE");

        BaseService.CallAction(CQ_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.SelectAllPayment_Submit = function (type) {
        var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, "SelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }

    $scope.UnSelectAll_Submit = function () {
        var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, "UnSelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }

    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "DEALER_CODE": chassis,
        });

        BaseService.CallAction(CQ_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    // BaseService.Message.info("Successfully saved.");tid
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.PAYMENT_ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(CQ_PATH, "SubmitPayment", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        $scope.SubmitStatus.APPROVE_PAYMENT = 'ACC_Approved';
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedDealer = function (chassis) {
        if ($scope.SelectedDealer.indexOf(chassis) < 0) {
            $scope.SelectedDealer.push(chassis);
        } else {
            $scope.SelectedDealer.splice($scope.SelectedDealer.indexOf(chassis), 1);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.SelectedDealer = $scope.SelectAllDealer;
        } else {
            $scope.SelectedDealer = [];
        }
    }


    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewSection = 2;
        $scope.PAYMENT_ID = row.ID;
        $scope.SubmitStatus = row;

        var sendData = [{
            "PAYMENT_ID": row.ID
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, 'GetPaymentSubmit', data)
            .then(function (result) {
                $scope.ViewDataChassis = result.Table;
                $scope.ViewDataModel = result.Table1;
                $scope.ViewDataDealer = result.Table2;
                $scope.ViewDataOutlet = result.Table3;
            }, function (error) {
                console.log('Unable to load GetPaymentSubmit: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewSection = iNumber;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }
    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.Report_Click = function (ReportNo) {
        var p1 = null;
        var p2 = null;
        switch (ReportNo) {
            case 'SelectedDetail':
                $scope.reportCode = 'VME_Rpt_CQ_Payment_Select_Detail';
                $scope.reportName = 'CQ incentive selected to payment';
                p1 = $scope.reportName;
                break;
            case 'Report0':
                $scope.reportCode = 'VME_Rpt_CQ_Payment_ByChassis';
                $scope.reportName = 'CQ incentive payment by chassis';
                p1 = $scope.PAYMENT_ID;
                p2 = $scope.reportName;
                break;
            case 'Report1':
                $scope.reportCode = 'VME_Rpt_CQ_Payment_ByModel';
                $scope.reportName = 'CQ incentive payment by base model';
                p1 = $scope.PAYMENT_ID;
                p2 = $scope.reportName;
                break;
            case 'Report2':
                $scope.reportCode = 'VME_Rpt_CQ_Payment_ByDealer';
                $scope.reportName = 'CQ incentive payment by dealer';
                p1 = $scope.PAYMENT_ID;
                p2 = $scope.reportName;
                break;
            case 'Report3':
                $scope.reportCode = 'VME_Rpt_CQ_Payment_ByOutlet';
                $scope.reportName = 'CQ incentive payment by outlet';
                p1 = $scope.PAYMENT_ID;
                p2 = $scope.reportName;
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + p1 + '&p2=' + p2, '_blank');
    }
}])

app.controller("CQReconcileController", ['$scope', 'BaseService', 'CQ_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CQ_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.loaded = true;
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        $scope.Section = 0;
        GetHeader();
        InitailDataModel();
        $scope.$watch('loaded', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ReconStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('ModelReconSummary1')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptCQReconDetail')
            .then(function (result) {
                $scope.ModelHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        GetData();
    }

    function GetData() {
        BaseService.CallAction(CQ_PATH, "GetCQReconHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetCQReconHistory: ' + error.message)
            })
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, "GetCQReconcile", data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];

            }, function (error) {
                console.log('Unable to load CQ Reconcile: ' + error.message)
            })
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    $scope.Reconcile_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Reconcile':
                confirmType = 'submit reconcile';
                submitType = 'submitted';
                break;

            case 'ReconcileApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'ReconcileReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "STATUS": status }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CQ_PATH, "SubmitReconcile", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load Submit reconcile: ' + error.message)
                })
        })

    }

    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelReconSummary1';
        $scope.DVM_ACCRUE_TableName2 = '';
        $scope.DVM_ACCRUE_TableName3 = '';
        $scope.DVM_ACCRUE_TableName4 = '';
        $scope.DVM_ACCRUE_TableName5 = '';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetCQReconcile';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        $scope.SubSection = 0;
        //  $scope.SubmitStatus = row;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;

        var sendData = [{
            "SP_NAME": 'sp_Rpt_CQ_Recon_ByChassis',
            "DATA_MONTH": $scope.DATA_MONTH,
            "REPORT_ID": '6'
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, 'GetAsDetail', data)
            .then(function (result) {
                $scope.DetailData1 = result;
            }, function (error) {
                console.log('Unable to load sp_Rpt_CQ_Recon_ByChassis data: ' + error.message)
            })

    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        switch (ReportNo) {
            case 'report0':
                $scope.reportCode = 'VME_Rpt_CQ_Recon_Summary';
                $scope.reportName = 'CQ incentive reconcile - Summary';
                $scope.REPORT_ID = 92;
                break;
            case 'report1':
                $scope.reportCode = 'VME_Rpt_CQ_Recon_Detail';
                $scope.reportName = 'CQ incentive reconcile - Detail';
                $scope.REPORT_ID = null;
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName, '_blank');
    }
    //------------------- Data model section --------------------------
}])

app.controller("Rpt1CQDetailController", ['$scope', 'BaseService', 'CONFIG_PATH', 'CQ_PATH', 'DEALER_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, CQ_PATH, DEALER_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.select = {};
        $scope.ListHeader = [];
        $scope.ListDetail = [];

        //--- Default value

        $scope.Section = 1;
        $scope.select.Period = 'Accrue';
        $scope.FnGetSummary = 'GetCQAllAccrue';
        $scope.reportName = 'Accrue';
        $scope.FnGetDetail = 'sp_Rpt_CQ_D2';
        $scope.REPORT_ID = 86;
        GetHeader();
        ChangeMonth();
    }

    function ChangeMonth () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
    }

    $scope.Select_Change = function (gChange) {
        $scope.ListDetail = [];

        if (gChange == 'Summary') {
            $scope.Section = 1;
        } else if (gChange == 'Detail') {
            $scope.Section = 2;
        }

        if (gChange == 'Year' || gChange == 'Month') {
            ChangeMonth();
        } else {
            ChangeHeader();
        }
        
        if ($scope.Section == 1) { //Summary
            if ($scope.select.Period == 'Accrue') {
                $scope.FnGetSummary = 'GetCQAllAccrue';
            } else if ($scope.select.Period == 'Payment') {
                $scope.FnGetSummary = 'GetPaymentByMonth';
            } else if ($scope.select.Period == 'Reconcile') {
                $scope.FnGetSummary = 'GetCQReconcile';
            }
            
            GetDataSummary();
        } else if ($scope.Section == 2) { //Detail
            if ($scope.select.Period == 'Accrue') {
                $scope.FnGetDetail = 'sp_Rpt_CQ_D2';
                $scope.REPORT_ID = 86;
            } else if ($scope.select.Period == 'Payment') {
                $scope.FnGetDetail = 'sp_Rpt_INC_D3';
                $scope.REPORT_ID = 87;
            } else if ($scope.select.Period == 'Reconcile') {
                $scope.FnGetDetail = 'sp_Rpt_CQ_Recon_ByChassis';
                $scope.reportCode = 'VME_Rpt_INC_Recon_D1';
                $scope.REPORT_ID = 88;
            }
            
            GetDataDetail();
        }
    }

    function GetHeader() {
        var sendData = [{
            'TableName1': 'ModelSummary1'
            , 'TableName2': 'ModelReconSummary1'
            , 'TableName3': 'RptCQAccrueDetail'
            , 'TableName4': 'RptCQPaymentDetail'
            , 'TableName5': 'RptCQReconDetail'
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelSummary1 = result.Table;
                $scope.ModelReconSummary1 = result.Table1;
                $scope.RptCQAccrueDetail = result.Table2;
                $scope.RptCQPaymentDetail = result.Table3;
                $scope.RptCQReconDetail = result.Table4;
                $scope.ListHeader = $scope.ModelSummary1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function ChangeHeader() {
        if ($scope.Section == 1) {
            if ($scope.select.Period == 'Accrue' || $scope.select.Period == 'Payment') {
                $scope.ListHeader = $scope.ModelSummary1;
            } else if ($scope.select.Period == 'Reconcile') {
                $scope.ListHeader = $scope.ModelReconSummary1;
            }
        } else {
            if ($scope.select.Period == 'Accrue') {
                $scope.ListHeader = $scope.RptCQAccrueDetail;
            } else if ($scope.select.Period == 'Payment') {
                $scope.ListHeader = $scope.RptCQPaymentDetail;
            } else if ($scope.select.Period == 'Reconcile') {
                $scope.ListHeader = $scope.RptCQReconDetail;
            }
        }
    }

    function GetDataSummary() {
        var sendData = [{
            "DATA_MONTH": $scope.DATA_MONTH
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CQ_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.ListDetail = result.Table;

            }, function (error) {
                console.log('Unable to load GetResultList data: ' + error.message)
            })
    }

    function GetDataDetail() {
        $scope.ListDetail = []
        var sendData = [{
            "SP_NAME": $scope.FnGetDetail,
            "DATA_MONTH": $scope.DATA_MONTH,
            "REPORT_ID": $scope.REPORT_ID
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CQ_PATH, 'GetAsDetail', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetAsDetail data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }

            return filterResult;
        }
    }


    $scope.Report_Click = function () {

        if ($scope.Section == 1) {
            $scope.reportName = $scope.select.Period + ' summary ';

            $scope.REPORT_ID = 90;
            if ($scope.select.Period == 'Accrue') {
                $scope.reportCode = 'VME_Rpt_CQ_S1';
            } else if ($scope.select.Period == 'Payment') {
                $scope.REPORT_ID = $scope.REPORT_ID + 1;
                $scope.reportCode = 'VME_Rpt_CQ_S1';
            } else if ($scope.select.Period == 'Reconcile') {
                $scope.REPORT_ID = $scope.REPORT_ID + 2;
                $scope.reportCode = 'VME_Rpt_CQ_S1_Recon';
            }
        } else {
            $scope.reportName = $scope.select.Period + ' detail ';

            $scope.REPORT_ID = 86;
            if ($scope.select.Period == 'Accrue') {
                $scope.reportCode = 'VME_Rpt_INC_D2';
            } else if ($scope.select.Period == 'Payment') {
                $scope.REPORT_ID = $scope.REPORT_ID + 1;
                $scope.reportCode = 'VME_Rpt_VDM_Payment_Detail';

            } else if ($scope.select.Period == 'Reconcile') {
                $scope.REPORT_ID = $scope.REPORT_ID + 2;
                $scope.reportCode = 'VME_Rpt_INC_Recon_D1';
            }
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName, '_blank');
    }

}])

app.controller("VdmConfigSOPController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', function ($scope, BaseService, CQ_PATH, BizDataService) {
    Opening();

    function Opening() {

        $scope.filter = {};
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
        GetData();
    }


    function GetHeader() {
        BaseService.GetHeaderGridView('VdmConfigSOPNameList')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load CQConfigList data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(CQ_PATH, 'GetVdmConfigureNameList')
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to GetVdmConfigureNameList: ' + error.message)
            })
    }

    $scope.AddConfig_Click = function () {
        document.getElementById("DetailModal").style.display = "block";
        $scope.formData = {
            ID: 0
        }
        $scope.MonthFrom = null;
        $scope.MonthTo = null;
    }

    $scope.ShowItem_Click = function (row) {
        document.getElementById("DetailModal").style.display = "block";
        $scope.formData = row;
        $scope.MonthFrom = (isNaN(Date.parse(row._DATA_MONTH_FROM))) ? null : new Date(row._DATA_MONTH_FROM);
        $scope.MonthTo = (isNaN(Date.parse(row._DATA_MONTH_TO))) ? null : new Date(row._DATA_MONTH_TO);

    }

    $scope.Save_CLick = function () {
        $scope.formData.DATA_MONTH_FROM = $scope.MonthFrom.getFullYear().toString() + (('00'+ ($scope.MonthFrom.getMonth() + 1)).substr(-2)).toString();
        $scope.formData.DATA_MONTH_TO = $scope.MonthTo.getFullYear().toString() + (('00'+ ($scope.MonthTo.getMonth() + 1)).substr(-2)).toString();
        var data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(CQ_PATH, 'SaveVdmConfigureName', data)
            .then(function (result) {
                BaseService.Message.info("Successfully saved.");
                $scope.CloseItem_Click();
                GetData();
            }, function (error) {
                console.log('Unable to SaveVdmConfigureName: ' + error.message)
            })
    }


    $scope.CloseItem_Click = function () {
        document.getElementById("DetailModal").style.display = "none";
    }
    
    $scope.openMonthFrom = function () {
        $scope.popupMonthFrom.opened = true;
    };
    $scope.popupMonthFrom = {
        opened: false,
    };
    $scope.openMonthTo = function () {
        $scope.popupMonthTo.opened = true;
    };
    $scope.popupMonthTo = {
        opened: false
    };

}])

app.controller("VdmConfigController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', function ($scope, BaseService, CQ_PATH, BizDataService) {
    Opening();

    function Opening() {

        $scope.filter = {};
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
        GetData();
    }


    function GetHeader() {
        BaseService.GetHeaderGridView('VdmConfigList')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load CQConfigList data: ' + error.message)
            })
    }

    function GetData() {
        var data = BaseService.ConvertParam({
            "year": ""
        })
        BaseService.CallAction(CQ_PATH, 'GetVdmConfigList', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to GetCQConfigList: ' + error.message)
            })
    }

    $scope.AddConfig_Click = function () {

        BaseService.Message.confirm("Would you like to add configure?").then(function () {
            $scope.formData = {
                "ID": 0
            };

            var data = BaseService.ConvertParam($scope.formData);
            BaseService.CallAction(CQ_PATH, 'AddNewVdmConfig', data)
                .then(function (result) {
                    GetData();
                    BaseService.Message.info("Successfully added.");
                }, function (error) {
                    console.log('Unable to AddNewVdmConfig: ' + error.message)
                })
        })
    }

    $scope.ShowItem_Click = function (row) {
        document.getElementById("DetailModal").style.display = "block";
        $scope.formData = row;

    }

    $scope.Save_CLick = function () {

        //if ($scope.formData.CSI_TARGET_SOP13 == null || $scope.formData.CSI_TARGET_SOP13 == '') {
        //    BaseService.Message.warning("CSI SOP13 cannot empty.");
        //    return;
        //}
        //if ($scope.formData.CSI_TARGET_SOP14 == null || $scope.formData.CSI_TARGET_SOP14 == '') {
        //    BaseService.Message.warning("CSI SOP14 cannot empty.");
        //    return;
        //}

        var data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(CQ_PATH, 'SaveVdmConfig', data)
            .then(function (result) {
                BaseService.Message.info("Successfully saved.");
                $scope.CloseItem_Click();
                $scope.GetData();
            }, function (error) {
                console.log('Unable to SaveVdmConfig: ' + error.message)
            })
    }


    $scope.CloseItem_Click = function () {
        document.getElementById("DetailModal").style.display = "none";
    }

    $scope.Approve_Submit = function (obj, type, QUARTER) {

        BaseService.Message.confirm("Would you like to \"" + type.toLowerCase() + "\" this model?").then(function () {
            const data = BaseService.ConvertParam({
                "ID": obj.ID,
                "TYPE": type,
                "quarter": QUARTER
            });

            BaseService.CallAction(CQ_PATH, "CQApproveSubmit", data)
                .then(function (result) {
                    $scope.GetData();
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }

}])

app.controller("VdmUploadController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', 'Upload', '$timeout', 'REPORT_PATH', '$filter', function ($scope, BaseService, CQ_PATH, BizDataService, Upload, $timeout, REPORT_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.VDMType = [
            { label: 'SSI', value: 'SSI', sourceFrom: ['CSM', 'SSI'] },
            { label: 'CSI', value: 'CSI', sourceFrom: ['CSM', 'CSI'] },
            { label: 'Manpower (SSI)', value: 'ManpowerSSI', sourceFrom: ['CSM', 'Manpower', 'ManpowerSSI'] },
            { label: 'Manpower (CSI)', value: 'ManpowerCSI', sourceFrom: ['CSM', 'Manpower', 'ManpowerCSI'] },
            { label: 'Assess (SSI)', value: 'AssessSSI', sourceFrom: ['CSM', 'Assess', 'AssessSSI'] },
            { label: 'Assess (CSI)', value: 'AssessCSI', sourceFrom: ['CSM', 'Assess', 'AssessCSI'] },
            { label: 'VOC (SSI)', value: 'VOCSSI', sourceFrom: ['CSM', 'VOC', 'VOCSSI'] },
            { label: 'VOC (CSI)', value: 'VOCCSI', sourceFrom: ['CSM', 'VOC', 'VOCCSI'] }
        ]
        //------ Set booking type
        $scope.confirmBtn = null;
        $scope.fileUpload = null;
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.AccPay = "Accrue";
        $scope.SOPName = {};
        $scope.UploadStatus = {};

        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.filter = {};
        $scope.formData = {};

        // $scope.SOURCE_FROM = 'SSI';
        $scope.IS_ROLE = true;
        $scope.tempUploadResult = null;
        $scope.IsShowHeader = false;

        $scope.$watch('init', function(value) {
            if(value) {
                GetHeader();

                $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
                    $scope.ViewData_Click();
                });
            }
        }, true)
    }

    $scope.GetVDMType = function (usertype) {
    }
    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetHeader() {
        var url;
        if(['SSI', 'ManpowerSSI', 'AssessSSI', 'VOCSSI'].indexOf($scope.SOURCE_FROM) >= 0) {
            url = 'VDMUploadSSI'
        } else if(['CSI', 'ManpowerCSI', 'AssessCSI', 'VOCCSI'].indexOf($scope.SOURCE_FROM) >= 0) {
            url = 'VDMUploadCSI'
        }

        BaseService.GetHeaderGridView(url)
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load vdm header data: ' + error.message)
            })
    }

    function GetData() {

        let data = BaseService.ConvertParam({
            DATA_MONTH: $scope.DATA_MONTH,
            type: $scope.SOURCE_FROM,
            AccPay: $scope.AccPay
        });

        BaseService.CallAction(CQ_PATH, 'VdmFileUploadList', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
                $scope.SOPName = result.Table1[0];
                $scope.UploadStatus = result.Table2[0];
            }, function (error) {
                console.log('Unable to load vdm data: ' + error.message)
            })
    }

    function GetHeaderFileHeader() {
        BaseService.GetHeaderGridView('VDMUploadHeader')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load file header\'s header: ' + error.message)
            })
    }

    function GetFileHeader() {
        BaseService.GetDataTable(CQ_PATH, "VdmFileHeaderList")
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load file header list: ' + error.message)
            })
    }
    
    $scope.initFileUpload = function () {
        $scope.tempUploadResult = null;
        $scope.fileUpload = null;
        GetHeader();
        GetData();
    }

    $scope.ShowFileHeaderList = function (showHeader) {
        $scope.ListHeader = [];
        $scope.ListDetail = [];

        if (showHeader) {
            GetHeaderFileHeader();
            GetFileHeader();
        } else {
            $scope.initFileUpload();
        }

        $scope.IsShowHeader = showHeader;
    }

    $scope.uploadData = function () {
        var url;
        switch ($scope.SOURCE_FROM) {
            case 'CSI': url = "/UploadCSI";
                break;
            case 'SSI': url = "/UploadSSI";
                break;
            case 'ManpowerCSI': url = "/UploadManpowerCSI";
                break;
            case 'ManpowerSSI': url = "/UploadManpowerSSI";
                break;
            case 'AssessCSI': url = "/UploadAssessCSI";
                break;
            case 'AssessSSI': url = "/UploadAssessSSI";
                break;
            case 'VOCCSI': url = "/UploadVOCCSI";
                break;
            case 'VOCSSI': url = "/UploadVOCSSI";
                break;
        }

        if ($scope.fileUpload && url) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.ListDetail = null;

                file.upload = Upload.upload({
                    url: window.location.origin + CQ_PATH + url,
                    data: {
                        File: file,
                        year: $scope.periodYear,
                        month: $scope.periodMonth
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        $scope.ListDetail = res.data.data;
                        $scope.tempUploadResult = {
                            fileName: res.data.fileName,
                            filePath: res.data.filePath,
                            fileLocation: res.data.fileLocation
                        };
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file");
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });
            })
        }
    };

    $scope.saveUploadData = function () {
        var url;
        switch ($scope.SOURCE_FROM) {
            case 'CSI': url = "/ConfirmUploadCSI";
                break;
            case 'SSI': url = "/ConfirmUploadSSI";
                break;
            case 'ManpowerCSI': url = "/ConfirmUploadManpowerCSI";
                break;
            case 'ManpowerSSI': url = "/ConfirmUploadManpowerSSI";
                break;
            case 'AssessCSI': url = "/ConfirmUploadAssessCSI";
                break;
            case 'AssessSSI': url = "/ConfirmUploadAssessSSI";
                break;
            case 'VOCCSI': url = "/ConfirmUploadVOCCSI";
                break;
            case 'VOCSSI': url = "/ConfirmUploadVOCSSI";
                break;
        }

        var data = BaseService.ConvertParam({
            pFileName: $scope.tempUploadResult.fileName,
            pUploadPath: $scope.tempUploadResult.filePath,
            pFileLocation: $scope.tempUploadResult.fileLocation,
            pType: $scope.AccPay,
            pYear: $scope.periodYear,
            pMonth: $scope.periodMonth
        })

        BaseService.CallAction(CQ_PATH, url, data)
            .then(function (result) {
                if (result == "Done") {
                    $scope.initFileUpload();
                }
            })
    }

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }

    $scope.Download_Click = function () {

        var gReport = '';

        if(['SSI', 'ManpowerSSI', 'AssessSSI', 'VOCSSI'].indexOf($scope.SOURCE_FROM) >= 0) {
            gReport = 'VME_Rpt_VDM_SSI_Upload'
        } else if(['CSI', 'ManpowerCSI', 'AssessCSI', 'VOCCSI'].indexOf($scope.SOURCE_FROM) >= 0) {
            gReport = 'VME_Rpt_VDM_CSI_Upload'
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&ExportName=VDM_' + $scope.SOURCE_FROM + '_' + $scope.AccPay + '_' + $scope.DATA_MONTH + '&rc='+ gReport + '&p1=' + $scope.DATA_MONTH, '_blank');
        //window.open('/upload/VDM/' + gReport + '.xlsx', '_blank');

        //var gDataMonth;
        //if ($scope.quarter.Month < 10) {
        //    gDataMonth = $scope.year + '0' + $scope.quarter.Month;
        //} else {
        //    gDataMonth = $scope.year + '' + $scope.quarter.Month;
        //}
        //window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&ExportName=' + gReport + '_' + gDataMonth + '&rc=' + gReport + '&p1=' + gDataMonth + '&p2=Acc', '_blank');
    }

    $scope.findRemarks = function (obj) {
        if(!obj) {
            return false;
        }
        
        let result = obj.data.filter(function (x) {return x.REMARKS != ""})

        return (result && result.length <= 0);
    }
    $scope.CheckUser = function(item) {
        if (item == 'CSM') {
            return 'SSI';
        } else if (item != '' && (item.indexOf("CSI") >= 0 || item.indexOf("SSI") >= 0)) {
            return item;
        } else if(item != '' && ['SSI','CSI'].indexOf(item) < 0) {
            return item + 'SSI';
        } else {
            return '';
        }
    }
    $scope.vdmTypeFilter = function (item) {
        return function(type) {
            return (type.sourceFrom.indexOf(item) >= 0);
        }
    }

}])

app.controller("VdmSummaryController", ["$scope", "CQ_PATH", "BaseService", "BizDataService", "REPORT_PATH", function ($scope, CQ_PATH, BaseService, BizDataService, REPORT_PATH) {

    $scope.Openning = function () {
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.cfgDetail = {};
        $scope.monthOfData = {};

        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.Section = 'Accrue'

        $scope.GetHeader();

        $scope.$watchGroup(['periodMonth', 'periodYear'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true);
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        $scope.GetData($scope.Section);
    }

    $scope.GetHeader = function () {
        BaseService.GetHeaderGridView("VDMSummary")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load vdm header data: ' + error.message)
            })
    }

    $scope.GetData = function (accPay) {
        $scope.monthOfData = {};
        $scope.ListDetail = [];
        $scope.cfgDetail = [];
        $scope.StatusDetail = {};

        let url = "";
        switch (accPay) {
            case "Accrue": url = "GetAccrueSummary";
                break;
            case "Payment": url = "GetPaymentSummary";
                break;
        }

        BaseService.GetDataTableByParam(CQ_PATH, url, $scope.DATA_MONTH)
            .then(function (result) {
                $scope.cfgDetail = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.StatusDetail = result.Table2.length > 0 ? result.Table2[0] : {};

                if($scope.ListDetail.length > 0) {
                    $scope.monthOfData = {
                        SSI_MONTH: $scope.ListDetail[0].SSI_MONTH,
                        CSI_MONTH: $scope.ListDetail[0].CSI_MONTH
                    }
                }
            }, function (error) {
                console.log('Unable to load summary data: ' + error.message);
            })
    }

    $scope.Download_Click = function () {
        var gReport = 'VME_Rpt_VDM_Summary';
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + gReport + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.Section ,'_blank');
    }
    $scope.changeSection = function (accPay) {
        $scope.Section = accPay;

        $scope.GetData($scope.Section);
    }

    $scope.Confirm_Click = function (section) {
        let confirmMsg = "Would you like to confirm that the data is correct?";

        if (section == 'Payment' && $scope.monthOfData.SSI_MONTH != $scope.monthOfData.CSI_MONTH) {
            confirmMsg = "Would you like to confirm to payment of CSI \"" + $scope.monthOfData.CSI_MONTH + "\" into SSI \"" + $scope.monthOfData.SSI_MONTH + "\"?";
        }

        BaseService.Message.confirm(confirmMsg)
            .then(function() {
                let data = BaseService.ConvertParam({
                    DATA_MONTH: $scope.DATA_MONTH,
                    TYPE: section
                })
                BaseService.CallAction(CQ_PATH, "ConfirmSummaryData", data)
                    .then(function(res) {
                        if(res == 'Done') {
                            BaseService.Message.info("Generate successful.");
                            $scope.changeSection($scope.Section);
                        }
                    }, function(error) {
                        console.log("Unable to confirm data: " + error.message);
                    })
                
            })
    }

    $scope.showConfirmButton = function() {
        return $scope.ListDetail.length > 0
        && (($scope.Section == 'Accrue' && $scope.StatusDetail.IS_ACCRUED == 0)
            || ($scope.Section == 'Payment' && $scope.StatusDetail.IS_ACCRUED == 1 && $scope.StatusDetail.IS_PAID == 0))
    }
    
    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Openning();
}])

app.controller("VdmAccrueController", ["$scope", "CQ_PATH", "BaseService", "BizDataService", "REPORT_PATH", function ($scope, CQ_PATH, BaseService, BizDataService, REPORT_PATH) {

    $scope.Openning = function () {
        $scope.StatusHeader = [];
        $scope.ModelHeader1 = [];
        $scope.HeaderFields = [];
        $scope.StatusList = [];
        $scope.ModelData1 = [];
        $scope.M1Detail = [];
        $scope.ListDetailStatus = null;
        
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.SubSection = 0;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        $scope.VDM_FLAG = 1;

        $scope.GetHeader();
        $scope.GetStatusList();
        $scope.ViewData_Click();
    }
    
    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        $scope.GetData($scope.DATA_MONTH);
    }

    $scope.GetHeader = function () {
        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.StatusHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
            
        BaseService.GetHeaderGridView('VDMModelSummary1')
            .then(function (result) {
                $scope.ModelHeader1 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView("VDMDealerSummary1")
            .then(function (result) {
                $scope.HeaderFields = result;
            }, function (error) {
                console.log('Unable to load header VDMDealerSummary1 : ' + error.message)
            })
    }

    $scope.GetStatusList = function () {
        BaseService.GetDataTable(CQ_PATH, "GetVDMAccrueHistory")
            .then(function (result) {
                $scope.StatusList = result;
            }, function (error) {
                console.log('Unable to load VDM Accrue history: ' + error.message)
            })
    }

    $scope.GetData = function (dataMonth) {
        BaseService.GetDataTableByParam(CQ_PATH, "GetVDMAccrue", dataMonth)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.M1Detail = result.Table1;
                $scope.ListDetailStatus = result.Table2.length > 0 ? result.Table2[0] : null;
            })
    }

    $scope.ViewHistory_Click = function (dataMonth) {
        $scope.DATA_MONTH = dataMonth;
        $scope.periodYear = parseInt(dataMonth.substr(0,4));
        $scope.periodMonth = parseInt(dataMonth.substr(-2));
        $scope.SubSection_Change(1);
    }

    $scope.SubSection_Change = function (subsection) {
        if (subsection == 1) {
            $scope.GetData($scope.DATA_MONTH);
            // $scope.GetData();
        }

        $scope.SubSection = subsection;
    }

    $scope.ViewDetail_Change = function (viewmodel) {
        $scope.ViewModel = viewmodel;
    }
    
    $scope.Accrue_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Accrue':
                confirmType = 'submit accrue';
                submitType = 'submitted';
                break;

            case 'AccrueApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'AccrueReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            case 'MSControlApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'MSControlReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + " for this month?").then(function () {
            var sendData = {
                "DATA_MONTH": $scope.DATA_MONTH,
                "STATUS": status,
                "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH)
            };
            var data = BaseService.ConvertParam(sendData);

            BaseService.CallAction(CQ_PATH, "SubmitVDMAccrue", data)
                .then(function (result) {
                    $scope.GetData($scope.DATA_MONTH);
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result)
                    }
                }, function (error) {
                    console.log('Unable to load Submit VDM Accrue: ' + error.message)
                })
        })

    }
    $scope.Report_Click = function (ReportNo) {
        var p1 = null;
        var p2 = null;
        switch (ReportNo) {
            case 'Report0':
                $scope.reportCode = 'VME_Rpt_VDM_Accrue_ByModel'            
                p1 = $scope.StatusList[0].ID;
                p2 = $scope.DATA_MONTH;
                break;
            case 'Report1':
                $scope.reportCode = 'VME_Rpt_VDM_Accrue_ByOutlet';
                p1 = $scope.StatusList[0].ID;
                p2 = $scope.DATA_MONTH;
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + p1 + '&p2=' + p2, '_blank');
    }

    $scope.Openning();
}])

app.controller("VdmPaymentController", ["$scope", "CQ_PATH", "BaseService", "BizDataService", "REPORT_PATH", "SYSTEM_PATH", function ($scope, CQ_PATH, BaseService, BizDataService, REPORT_PATH, SYSTEM_PATH) {

    $scope.Openning = function () {
        $scope.ListHeader = [];
        $scope.ListHeader2 = [];
        $scope.ListHeader3 = [];
        $scope.ListHeader4 = [];
        $scope.ListHeader5 = [];
        $scope.ListHeader6 = [];
        $scope.ListDetail = [];
        $scope.ListStatus = [];
        $scope.FILTER = {};
        
        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.PAYMENT_ID = null;
        $scope.PAYMENT_TYPE = 'SSI';

        $scope.SubSection = 0;
        $scope.ViewSection = 1;
        $scope.ViewDetail = false;

        $scope.SubmitStatus = {};

        $scope.GetHeader();
        $scope.GetStatusList();
    }

    $scope.GetHeader = function () {
        
        BaseService.GetHeaderGridView('VDMPaymentList')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.error('Unable to load header data: ' + error.message)
            })

        headerData = BaseService.ConvertParam({
            'TableName1': 'CQPayment1ListByModel',
            'TableName2': 'PaymentStatus',
            'TableName3': 'CQPayment1ListByChassis',
            'TableName4': 'CQPayment1ListByDealer',
            'TableName5': 'CQPayment1ListByOutlet'
        });
        
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', headerData)
            .then(function (result) {
                $scope.ListHeader2 = result.Table;
                $scope.ListHeader3 = result.Table1;
                $scope.ListHeader4 = result.Table2;
                $scope.ListHeader5 = result.Table3;
                $scope.ListHeader6 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (id) {
        $scope.PAYMENT_ID = id;
        $scope.ViewSection = 1;

        $scope.changePaymentType('')
    }

    $scope.GetSubmitList = function (id) {
        $scope.SubmitStatus = {};
        let data = BaseService.ConvertParam({
            id: id,
            paymentType: $scope.PAYMENT_TYPE
        })
        BaseService.CallAction(CQ_PATH, "VDMSubmitList", data)
            .then(function(res) {
                $scope.ViewDataChassis = res.Table;
                $scope.ViewDataModel = res.Table1;
                $scope.ViewDataDealer = res.Table2;
                $scope.ViewDataOutlet = res.Table3;

                $scope.SubmitStatus = (res.Table4.length > 0) ? res.Table4[0] : {};

                $scope.PAYMENT_ID = id;
                $scope.ViewDetail = true;
            }, function(error) {
                console.error("Unable to get payment detail: " + error.message);
            })
    }

    $scope.GetStatusList = function () {
        BaseService.GetDataTable(CQ_PATH, "VDMStatusList")
            .then(function(res) {
                $scope.ListStatus = res;
            }, function(error) {
                console.error("Unable to get not selected list:" + error.message);
            })
    }


    $scope.GetNotSelectedList = function () {
        BaseService.GetDataTable(CQ_PATH, "VDMNotSelectedList")
            .then(function(res) {
                $scope.ListDetail_SSI = res.Table;
                $scope.ListDetail_CSI = res.Table1;

                $scope.changePaymentType($scope.PAYMENT_TYPE);
            }, function(error) {
                console.error("Unable to get not selected list:" + error.message);
            })
    }

    $scope.GetSelectedList = function () {
        let data = BaseService.ConvertParam({
            paymentType: $scope.PAYMENT_TYPE
        })

        BaseService.CallAction(CQ_PATH, "VDMSelectedList", data)
            .then(function(res) {
                $scope.ViewDataChassis = res.Table;
                $scope.ViewDataModel = res.Table1;
                $scope.ViewDataDealer = res.Table2;
                $scope.ViewDataOutlet = res.Table3;
            }, function(error) {
                console.error("Unable to get not selected list:" + error.message);
            })
    }

    $scope.SelectAllPayment_Submit = function () {
        let data = BaseService.ConvertParam({
            paymentType: $scope.PAYMENT_TYPE
        })
        BaseService.Message.confirm("Are you sure to select all chassis for payment?")
            .then(function () {
                BaseService.CallAction(CQ_PATH, "VDMSelectAllPayment", data)
                    .then(function(res) {
                        if(res == "Done") {
                            $scope.GetNotSelectedList();
                            BaseService.Message.info("Successfully selected all chassis to payment.");
                        }
                    }, function (error) {
                        console.error("Unable to select all payment:" + error.message);
                    })
            })
    }

    $scope.UnSelectAll_Submit = function () {
        let data = BaseService.ConvertParam({
            paymentType: $scope.PAYMENT_TYPE
        })
        BaseService.Message.confirm("Are you sure to deselect all chassis from payment?")
            .then(function () {
                BaseService.CallAction(CQ_PATH, "VDMUnSelectAllPayment", data)
                    .then(function(res) {
                        if(res == "Done") {
                            $scope.GetSelectedList();
                            BaseService.Message.info("Successfully deselected all chassis from payment.");
                        }
                    }, function (error) {
                        console.error("Unable to select all payment:" + error.message);
                    })
            })
    }

    $scope.SubSection_Change = function (subsection) {
        $scope.PAYMENT_ID = null;
        $scope.ViewDetail = false;
        switch(subsection) {
            case 0: break;
            case 1: $scope.GetNotSelectedList();
                    $scope.PAYMENT_TYPE = 'SSI';
                break;
            case 2: $scope.PAYMENT_TYPE = 'SSI';
                    $scope.ViewSection = 1;
                    $scope.GetSelectedList();
                break;
        }

        $scope.SubSection = subsection;
    }

    $scope.ViewDetail_Change = function (viewsection) {
        $scope.ViewSection = viewsection;
    }
    
    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = {
                "STATUS": status,
                "ID": ($scope.PAYMENT_ID || null)
            };
            var data = BaseService.ConvertParam(sendData);

            BaseService.CallAction(CQ_PATH, "SubmitVDMPayment", data)
                .then(function (result) {
                    $scope.GetSelectedList();
                    $scope.GetStatusList();

                    if($scope.PAYMENT_ID) {
                        $scope.GetSubmitList($scope.PAYMENT_ID)
                    }

                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load Submit VDM Payment: ' + error.message)
                })
        })

    }
    
    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }
    
    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        $scope.SelectedChassis.forEach(function (item) {
            chassis.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE
        }, "CHASSIS_NO");

        BaseService.CallAction(CQ_PATH, "SelectVDMtoPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    $scope.GetNotSelectedList();
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.changePaymentType = function (paymentType) {
        $scope.PAYMENT_TYPE = paymentType;
        if($scope.SubSection == 0) {
            $scope.GetSubmitList($scope.PAYMENT_ID)
        } else if($scope.SubSection == 1) {
            if(paymentType == 'SSI') {
                $scope.ListDetail = $scope.ListDetail_SSI;
            } else if(paymentType == 'CSI') {
                $scope.ListDetail = $scope.ListDetail_CSI;
            }
        } else if($scope.SubSection == 2) { //For selected to payment tab
            $scope.GetSelectedList()
        }
    }

    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];
        
        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }

        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }
            (filterResult) ? n++ : null;
            return filterResult;
        }
    }

    $scope.Report_Click = function (ReportNo) {
        var p1 = null;
        var p2 = null;
        var p3 = null;
        switch (ReportNo) {
            case 'SelectedDetail':
                $scope.reportCode = 'VME_Rpt_VDM_Payment_Select_Detail';
                $scope.reportName = 'CQ incentive selected to payment';
                p1 = $scope.reportName;
                break;
            case 'Report0':
                $scope.reportCode = 'VME_Rpt_VDM_Payment_ByChassis';
                $scope.reportName = 'CQ incentive payment by chassis';
                p1 = $scope.PAYMENT_ID || '0';
                p2 = $scope.reportName;
                p3 = $scope.PAYMENT_TYPE
                break;
            case 'Report1':
                $scope.reportCode = 'VME_Rpt_VDM_Payment_ByModel';
                $scope.reportName = 'CQ incentive payment by base model';
                p1 = $scope.PAYMENT_ID || '0';
                p2 = $scope.reportName;
                p3 = $scope.PAYMENT_TYPE
                break;
            case 'Report2':
                $scope.reportCode = 'VME_Rpt_VDM_Payment_ByDealer';
                $scope.reportName = 'CQ incentive payment by dealer';
                p1 = $scope.PAYMENT_ID || '0';
                p2 = $scope.reportName;
                p3 = $scope.PAYMENT_TYPE
                break;
            case 'Report3':
                $scope.reportCode = 'VME_Rpt_VDM_Payment_ByOutlet';
                $scope.reportName = 'CQ incentive payment by outlet';
                p1 = $scope.PAYMENT_ID || '0';
                p2 = $scope.reportName;
                p3 = $scope.PAYMENT_TYPE
                break;
            default:
                break;
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + p1 + '&p2=' + p2 + '&p3=' + p3, '_blank');
    }

    $scope.Openning();
}])

app.controller("VdmUnitUploadController", ['$scope', 'BaseService', 'CQ_PATH', 'BizDataService', 'Upload', '$timeout', 'REPORT_PATH', '$filter', function ($scope, BaseService, CQ_PATH, BizDataService, Upload, $timeout, REPORT_PATH, $filter) {

    Opening();

    function Opening() {
        //------ Set booking type
        // $scope.confirmBtn = null;
        $scope.fileUpload = null;
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.UploadStatus = {};

        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.SOURCE_FROM = "SSI";
        $scope.AccPay = 'Accrue';
        $scope.filter = {};
        $scope.formData = {};
        
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            $scope.ViewData_Click();
        });
        GetHeader();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetHeader() {
        var url;
        switch ($scope.SOURCE_FROM) {
            case 'CSI': url = "VDMServiceUnits";
                break;
            case 'SSI': url = "VDMChassisContactable";
                break;
        }

        BaseService.GetHeaderGridView(url)
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load vdm header data: ' + error.message)
            })
    }

    function GetData() {
        var url;
        switch ($scope.SOURCE_FROM) {
            case 'CSI': url = "GetServiceUnits";
                break;
            case 'SSI': url = "GetChassisContactable";
                break;
        }

        var data = BaseService.ConvertParam({
            pDataMonth: $scope.DATA_MONTH,
            pAccPay: $scope.AccPay
        })

        BaseService.CallAction(CQ_PATH, url, data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
                $scope.UploadStatus = result.Table1[0];
            }, function (error) {
                console.log('Unable to load vdm data: ' + error.message)
            })
    }
    $scope.Report_Click = function () {
        var p1 = null;
        var p2 = null;
        switch ($scope.SOURCE_FROM) {
            case 'SSI':
                $scope.reportCode = 'VME_Rpt_VDM_ContactChassis_Data';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.AccPay;
                break;
            case 'CSI':
                $scope.reportCode = 'VME_Rpt_VDM_ServiceHistory_Data';
                p1 = $scope.DATA_MONTH;
                break;         
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + p1 + '&p2=' + p2 , '_blank');
    }

    $scope.initFileUpload = function (){
        $scope.fileUpload = null;
        GetHeader();
        GetData();
    }

    $scope.uploadData = function () {
        var url;
        switch ($scope.SOURCE_FROM) {
            case 'CSI': url = "/ServiceUnitsSave";
                break;
            case 'SSI': url = "/ChassisContactableSave";
                break;
        }

        if ($scope.fileUpload && url) {
            BaseService.Message.confirm("Would you like upload this file for summary?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + CQ_PATH + url,
                    data: {
                        File: file,
                        pAccPay: $scope.AccPay,
                        pYear: $scope.periodYear,
                        pMonth: $scope.periodMonth
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        if(res.data == "Done") {
                            $scope.initFileUpload();
                            BaseService.Message.info("Successfully uploaded unit.")
                        }
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file");
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });
            })
        }
    };

}])
