app.controller("DealerController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.DealerCond = "DealerList";
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView($scope.DealerCond)
            .then(function (result) {
                $scope.ListHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetDealerList", data)
            .then(function (result) {
                //console.log(result)
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }


    $scope.Edit_Submit = function () {

        let scopeData = $scope.formData.Dealer;
        scopeData.DealerCond = $scope.DealerCond;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "EditDealerConf", data)
            .then(function (result) {
                GetData();
                document.getElementById('DetailModal').style.display = 'none';
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetDealerList", data)
            .then(function (result) {
                $scope.formData.Dealer = result[0]
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("ModelController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        GetHeader();
        GetData();
        
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("ModelList1")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }


    function GetData() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }


    $scope.Edit_Submit = function (itemID) {

        if ($scope.formData.Model.END_EFFECTIVE_DATE < $scope.formData.Model.START_EFFECTIVE_DATE) {
            BaseService.Message.warning("End Effective date is less than Start Effective date");
            return;
        }

        let data = BaseService.ConvertParam($scope.formData.Model)

        BaseService.CallAction(CONFIG_PATH, "EditModelConf", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info("Successfully saved.");
            }, function (error) {
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(CONFIG_PATH, "GetModelList", ID, { id: ID })
            .then(function (result) {
                $scope.formData.Model = result[0]
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("CostCenterController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("CostCenterList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(CONFIG_PATH, "getCostCenterList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.CostCenterEdit_Submit = function () {

        let data = BaseService.ConvertParam($scope.formData.CostCenter)

        BaseService.CallAction(CONFIG_PATH, "EditCostCenterConf", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
            }, function (error) {
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }


    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block'

        BaseService.GetDataTableByParam(CONFIG_PATH, "getCostCenterList", ID, { id: ID })
            .then(function (result) {
                $scope.formData.CostCenter = result[0]
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }


    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }


    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("MsrpController", ['$scope', 'BaseService', 'CONFIG_PATH', 'REPORT_PATH', '$filter', 'Upload', function ($scope, BaseService, CONFIG_PATH, REPORT_PATH, $filter, Upload) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = {};
        
        $scope.MSRPCond = "MSRPList2";
        GetModelList();
        $scope.filter.BASE_MODEL = 'B17';
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.fileUpload = null;
        $scope.confirmBtn = null;        
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('MSRPList2')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null, "BASE_MODEL": $scope.filter.BASE_MODEL }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetMsrpList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelBaseList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    $scope.Edit_Submit = function (itemType) {

        if ($scope.formData.MSRP.END_EFFECTIVE_DATE < $scope.formData.MSRP.START_EFFECTIVE_DATE) {
            BaseService.Message.warning("End Effective date is less than Start Effective date");
            return;
        }

        let scopeData = $scope.formData.MSRP
        scopeData._itemType = itemType

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "EditMsrpConf", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to edit MRSP: ' + error.message)
            })
    }

    $scope.Create_Duplicate = function (itemType) {

        BaseService.Message.confirm("Are you sure to duplicate record?").then(function() {
          let scopeData = {};
          console.log(itemType)
          scopeData._itemType = itemType;
          scopeData._DupFrom = $scope.formData.MSRP._ID;

          let data = BaseService.ConvertParam(scopeData)
          console.log(data)
          BaseService.CallAction(CONFIG_PATH, "AddMSRPDup", data)
          .then(function (result) {
            console.log(result);
            $scope.ShowItem_Click(result[0].ID);
            GetData();
          }, function (error) {
            console.log('Unable to Add Duplicate: ' + error.message)
          })
        })
    }

    $scope.ShowItem_Click = function (ID) {

        document.getElementById('DetailModal').style.display = 'block';

        var sendData = [{ "ID": ID, "BASE_MODEL": $scope.filter.BASE_MODEL }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetMsrpList", data)
            .then(function (result) {
                $scope.formData.MSRP = result[0]
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })

    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }


    $scope.Download_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&ExportName=MSRP_Configue&rc=MSRP01', '_blank');
    }
    //NEW
    $scope.uploadMSRPData = function () {
        var file = this.fileUpload;
        $scope.fileName = file.name;
        $scope.ListDetail = null;
        file.upload = Upload.upload({             
            url: window.location.origin + CONFIG_PATH + '/UploadMSRPData',
            data: { File: file },
        });
        file.upload.then(function (res) {
            $timeout(function () {
                console.log(res.data);
                $scope.ListDetail = res.data;
                $scope.confirmBtn = true;
            })
        }, function (res) {
            if (res.status > 0) {
                console.log("ERROR: ");//ถึงตรงนี้
                $scope.errorMsg = res.status + ': ' + res.data;
                BaseService.Message.alert("Cannot upload file")
            }
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    };
    $scope.confirmUpload = function (fileName) {
        var sendData = [{ "fileName": fileName }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CONFIG_PATH, "ConfirmMSRPUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to confirm uploaded data: ' + error.message)
            })
    }
    $scope.cancelUpload = function (fileName) {
        var sendData = [{ "fileName": fileName}];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(LEASING_PATH, "CancelMSRPUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to cancel uploaded data: ' + error.message)
            })
    }
    //NEW
}])

app.controller("AccountCostCenterController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        
        $scope.tab = 1;
        $scope.len = 2;
        GetData();
    }

    function GetData() {
        BaseService.GetDataTableByParam(CONFIG_PATH, "GetAccountCostCenterList", "CostCenter", { id: "CostCenter" })
            .then(function (result) {
                $scope.CostCenter = result
            }, function (error) {
                console.log('Unable to load account center data: ' + error.message)
            })

        BaseService.GetDataTableByParam(CONFIG_PATH, "GetAccountCostCenterList", "AccountCode", { id: "AccountCode" })
            .then(function (result) {
                $scope.AccountCode = result
            }, function (error) {
                console.log('Unable to load account center data: ' + error.message)
            })
    }

    $scope.openStartDate = function ($event, row) {

        for (i = 0; i < $scope.CostCenter.length; i++) {
            $scope.CostCenter[i].StartDateOpened = false;
            $scope.CostCenter[i].EndDateopened = false;
        }

        for (i = 0; i < $scope.AccountCode.length; i++) {
            $scope.CostCenter[i].StartDateOpened = false;
            $scope.CostCenter[i].EndDateopened = false;
        }

        $event.preventDefault();
        $event.stopPropagation();
        row.StartDateOpened = true;
    }

    $scope.closeStartDate = function ($event, row) {
        row.StartDateOpened = true;
    }

    $scope.popupStartDate = {
        StartDateOpened: false
    }

    $scope.openEndDate = function ($event, row) {

        for (i = 0; i < $scope.CostCenter.length; i++) {
            $scope.CostCenter[i].StartDateOpened = false;
            $scope.CostCenter[i].EndDateopened = false;
        }

        for (i = 0; i < $scope.AccountCode.length; i++) {
            $scope.CostCenter[i].StartDateOpened = false;
            $scope.CostCenter[i].EndDateopened = false;
        }

        $event.preventDefault();
        $event.stopPropagation();
        row.EndDateopened = true;
    }

    $scope.popupEndDate = {
        EndDateopened: false
    }

    $scope.Submit_CostCenter = function () {

        var scopeData = {};
        var Type = ""
        if ($scope.tab == 1) {
            scopeData = $scope.CostCenter;
            Type = "CostCenter";
        }
        else {
            scopeData = $scope.AccountCode;
            Type = "AccountCode";
        }

        let finishedLoop = 0;

        for (i = 0; i < scopeData.length; i++) {
            if (scopeData[i].STARTDATE == '' || scopeData[i].STARTDATE == null) {
                BaseService.Message.warning('Please fill all information');
                return;
            }

            if (scopeData[i].ENDDATE == '' || scopeData[i].ENDDATE == null) {
                BaseService.Message.warning('Please fill all information');
                return;
            }
        }

        for (i = 0; i < scopeData.length; i++) {
            scopeData[i].TYPE = Type;
            let data = BaseService.ConvertParam(scopeData[i]);

            BaseService.CallAction(CONFIG_PATH, "SubmitAccountCostCenter", data)
                .then(function (result) {
                    finishedLoop++;

                    if (finishedLoop == scopeData.length - 1) {
                        BaseService.Message.info('Successfully saved');
                        GetData();
                    }
                }, function (error) {
                    BaseService.Message.alert('Cannot save your change, please contact administrator.');
                    console.log('Unable to edit Account Costcenter data: ' + error.message + finishedLoop)
                })
        }
    }
}])

app.controller("PaymentTypeController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = {};
        
 
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('PaymentType')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {

        BaseService.GetDataTable(CONFIG_PATH, "GetPaymentTypeList")
            .then(function (result) {
                $scope.ListDetail = result;
                //console.log(result);
            }, function (error) {
                console.log('Unable to load GetPaymentType : ' + error.message)
            })
    }

    $scope.Save_Submit = function (itemType) {

        if ($scope.formData.END_EFFECTIVE_DATE < $scope.formData.START_EFFECTIVE_DATE) {
            BaseService.Message.warning("End Effective date is less than Start Effective date");
            return;
        }


        let scopeData = $scope.formData
        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "SavePaymentType", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to SavePaymentType : ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (obj) {

        $scope.formData = {};

        document.getElementById('DetailModal').style.display = 'block';

        if(obj.ID==0) {
            $scope.formData = obj;
            $scope.formData.START_EFFECTIVE_DATE = new Date();
            $scope.formData.END_EFFECTIVE_DATE = new Date();
        } else {
            var sendData = [{ "ID": obj.ID }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CONFIG_PATH, "GetPaymentType", data)
                .then(function (result) {
                    $scope.formData = result[0]
                }, function (error) {
                    console.log('Unable to load GetPaymentType data: ' + error.message)
                })
        }

    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("SubModelController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = {};
        
        $scope.MSRPCond = "MSRPList2";
        GetModelList();
        $scope.filter.BASE_MODEL = 'B17';
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('SubModel')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null, "BASE_MODEL": $scope.filter.BASE_MODEL }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetMsrpList", data)
            .then(function (result) {
                $scope.ListDetail = result;
                //console.log(result);
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelBaseList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    $scope.Edit_Submit = function (itemType) {

        if ($scope.formData.MSRP.END_EFFECTIVE_DATE < $scope.formData.MSRP.START_EFFECTIVE_DATE) {
            BaseService.Message.warning("End Effective date is less than Start Effective date");
            return;
        }

        let scopeData = $scope.formData.MSRP
        scopeData._itemType = itemType

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "EditMsrpConf", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to edit MRSP: ' + error.message)
            })
    }

    $scope.Create_Duplicate = function (itemType) {

        BaseService.Message.confirm("Are you sure to duplicate record?").then(function () {
            let scopeData = {};
            console.log(itemType)
            scopeData._itemType = itemType;
            scopeData._DupFrom = $scope.formData.MSRP._ID;

            let data = BaseService.ConvertParam(scopeData)
            console.log(data)
            BaseService.CallAction(CONFIG_PATH, "AddMSRPDup", data)
                .then(function (result) {
                    console.log(result);
                    $scope.ShowItem_Click(result[0].ID);
                    GetData();
                }, function (error) {
                    console.log('Unable to Add Duplicate: ' + error.message)
                })
        })
    }

    $scope.ShowItem_Click = function (ID) {

        document.getElementById('DetailModal').style.display = 'block';

        var sendData = [{ "ID": ID, "BASE_MODEL": $scope.filter.BASE_MODEL }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetMsrpList", data)
            .then(function (result) {
                $scope.formData.MSRP = result[0]
            }, function (error) {
                console.log('Unable to load MSRP data: ' + error.message)
            })

    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("NewPaymentTypeController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};

        $scope.Section = 1;
        $scope.itemPrefix = 'PC';
        $scope.itemShow = "Profit Center";
        $scope.ListDetail = null;
        GetData();
    }

    function GetData() {
        BaseService.GetDataTable(CONFIG_PATH, "NewGetPaymentTypeList")
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetPaymentType : ' + error.message)
            })
    }

    $scope.Save_Submit = function (type) {
        let paramData = $scope.formData
        let data = BaseService.ConvertParam(paramData)

        BaseService.CallAction(CONFIG_PATH, "NewSavePaymentType", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to SavePaymentType : ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (obj, type) {
        $scope.formData = {};
                document.getElementById('DetailModal').style.display = 'block';

        
        if (obj.CLAIM_TYPE_CODE == '') {
            $scope.formData = obj;
            $scope.formData.START_EFFECTIVE_DATE = new Date();
            $scope.formData.END_EFFECTIVE_DATE = new Date();
        } else {
            var sendData = [{ "CLAIM_TYPE_CODE": obj.CLAIM_TYPE_CODE, "TYPE": type }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CONFIG_PATH, "NewGetPaymentType", data)
                .then(function (result) {
                    $scope.formData = result[0]
                    if ($scope.formData) {
                        $scope.formData.TYPE = type;
                    }
                }, function (error) {
                    console.log('Unable to load GetPaymentType data: ' + error.message)
                })
        }
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        $scope.formData = {};
    }

    $scope.Section_Change = function (iChange) {
        $scope.Section = iChange;
        if (iChange == 1) {
            $scope.itemPrefix = 'PC';
            $scope.itemShow = "Profit Center";
        }
        else if (iChange == 2) {
            $scope.itemPrefix = 'CC';
            $scope.itemShow = "Cost Center";
        }
        else if (iChange == 3) {
            $scope.itemPrefix = 'AC';
            $scope.itemShow = "Account Code";
        }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("APVendorController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.DealerCond = "DealerListNewAP";
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView($scope.DealerCond)
            .then(function (result) {
                $scope.ListHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetNewDealerList", data)
            .then(function (result) {
                //console.log(result)
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }


    $scope.Edit_Submit = function () {

        let scopeData = $scope.formData.Dealer;
        scopeData.DealerCond = $scope.DealerCond;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "EditNewDealerConf", data)
            .then(function (result) {
                GetData();
                document.getElementById('DetailModal').style.display = 'none';
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetNewDealerList", data)
            .then(function (result) {
                $scope.formData.Dealer = result[0]
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller('InternalOrderController', ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {
    Opening();

    function Opening() {
        $scope.InternalOrderList = [];
        $scope.formData = {};
        $scope.$watch('GetInternalOrderList', function (v) {
            if (v) {
                $scope.GetInternalOrderList();
            }
        }, true)
    }

    $scope.GetInternalOrderList = function () {
        BaseService.GetDataTable(CONFIG_PATH, "GetInternalOrderList")
            .then(function (result) {
                $scope.InternalOrderList = result;
            }, function (error) {
                console.log('Unable to load internal order list: ' + error.message);
            })
    }

    $scope.ShowItem_Click = function (obj) {
        $scope.formData = {}
        document.getElementById("EditMaster").style.display = "block";
        var data = BaseService.ConvertParam(obj);
        BaseService.CallAction(CONFIG_PATH, "GetInternalOrderByID", data)
            .then(function (result) {
                $scope.formData = result[0];
            }, function (error) {
                console.log('Unable to load internal order item: ' + error.message);
            })
    }

    $scope.Save_Submit = function () {
        var data = BaseService.ConvertParam($scope.formData);
        BaseService.CallAction(CONFIG_PATH, "SaveInternalOrder", data)
            .then(function (result) {
                console.log(result);
                if (result === "Done") {
                    $scope.CloseItem_Click();
                    $scope.GetInternalOrderList();
                }
            }, function (error) {
                console.log('Unable to save internal order: ' + error.message);
            })
    }

    $scope.CloseItem_Click = function () {
        document.getElementById("EditMaster").style.display = "none";
    }
}])
app.controller("InterfaceLayoutController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {
    $scope.init = function () {
        $scope.layoutList = [];
        $scope.PaymentTypeList = [];
        $scope.filters = {};
        $scope.formData = {};
        $scope.interfaceFields = ["COMPANY_CODE", "DOCUMENT_DATE", "DOCUMENT_HEADER_TEXT", "DOCUMENT_TYPE", "POSTING_DATE", "PERIOD", "TRANSLATION_DATE", "DOCUMENT_CURRENCY", "EXCHANGE_RATE", "CALCULATE_TAX", "REFERENCE", "REF_KEY_1_HD_INVOICE_TYPE", "BUSINESS_PLACE", "POSTING_KEY", "SPECIAL_G_L_INDICATOR", "G_L_ACCOUNTS", "VENDOR_CODE", "CUSTOMER_CODE", "RECONCILLIATION_ACCOUNTS", "AMOUNT_IN_DOCUMENT_CURRENCY", "AMOUNT_IN_LOCAL_CURRENCY", "TAX_CODE", "TAX_AMOUNT", "TAX_BASE_AMOUNT_IN_DOCUMENT_CURRENCY", "COST_CENTER", "INTERNAL_ORDER", "PROFIT_CENTER", "LINE_ITEM_TEXT", "WITHOLDING_TAX_TYPE", "WITHOLDING_TAX_CODE", "WITHOLDING_TAX_BASE", "WITHOLDING_TAX_AMOUNT", "ASSIGNMENT_NUMBER", "BRANCH_NUMBER_OF_AP_AR", "PAYMENT_TERM", "BASELINE_DATE", "PAYMENT_BLOCK", "PAYMENT_METHOD", "PARTNER_BANK", "HOUSE_BANK", "EXPENSE_CATEGORY_FUNCTIONAL_AREA", "MATERIAL_NUMBER", "PLANT", "BUSINESS_PARTNER_REFERENCE_KEY1", "BUSINESS_PARTNER_REFERENCE_KEY2", "BUSINESS_PARTNER_REFERENCE_KEY3", "TITLE_ONE_TIME", "NAME_1_ONE_TIME", "NAME_2_ONE_TIME", "NAME_3_ONE_TIME", "NAME_4_ONE_TIME", "POSTAL_CODE_ONE_TIME", "CITY_ONE_TIME", "COUNTRY_KEY_ONE_TIME", "HOUSE_NUMBER_AND_STREET_ONE_TIME", "TYPE_OF_BUSINESS_ONE_TIME", "REGION_ONE_TIME", "LANGUAGE_ONE_TIME", "BANK_COUNTRY_KEY_ONE_TIME", "BANK_ACCOUNT_NUMBER_ONE_TIME", "BANK_KEYS_ONE_TIME", "BANK_CONTROL_KEY_ONE_TIME", "REFERENCE_FOR_BANK_DETAILS_ONE_TIME", "INSTRUCTION_KEY_ONE_TIME", "INDICATOR_FOR_DME_ONE_TIME", "TAX_NUMBER_1_ONE_TIME", "TAX_NUMBER_2_ONE_TIME", "TAX_NUMBER_3_ONE_TIME", "TAX_NUMBER_4_ONE_TIME", "EQUALIZATION_TAX_ONE_TIME", "LIABLE_FOR_VAT_ONE_TIME", "DUE_DATE_SPECIAL_GL", "VALUE_DATE_BANK_ACCOUNT", "TRANSACTION_TYPE", "TRADING_PARTNER", "MARKET_CODE", "LEDGER_GROUP", "CONTROLLING_AREA", "SALES_ORG", "DISTR_CHANNEL", "DIVISION", "MODEL_3_4", "BRAND_CODE", "ECO_AND_NON_ECO", "DESTINATION_CODE", "COUNTRY_SHIP_TO", "REGION_CO_PA", "PRODUCT_TYPE", "ORIGINAL_COMPANY"]

        $scope.showDetail = false;

        $scope.getVMETypeLayout();

        //$scope.editLayout();
    }

    $scope.getVMETypeLayout = function () {
        BaseService.GetDataTable(CONFIG_PATH, "GetVMEPaymentTypeLayout")
            .then(function (result) {
                $scope.PaymentTypeList = result
            })
    }

    $scope.editLayout = function (obj) {
        $scope.formData = obj;
        $scope.layoutList = [$scope.getDefaultFields()];

        let data = BaseService.ConvertParam({
            vmePaymentID: obj.VME_PAYMENT_TYPE_ID,
            accountType: obj.ACCOUNT_TYPE
        });

        BaseService.CallAction(CONFIG_PATH, "GetVMEPaymentTypeLayoutDetail", data)
            .then(function (result) {
                if (result.length > 0) {
                    $scope.layoutList = result
                }
            })

        $scope.showDetail = true;
    }

    $scope.closeDetail = function () {
        $scope.showDetail = false;
        $scope.formData = null;
        $scope.layoutList = [];
    }

    $scope.addLayout = function () {
        $scope.layoutList.push($scope.getDefaultFields());
    }

    $scope.removeLayout = function (index) {
        BaseService.Message.confirm("Are you sure to remove this record?")
            .then(function () {
                $scope.layoutList.splice(index, 1);
            }, function () { })
    }

    $scope.formSubmit = function () {
        BaseService.Message.confirm("Are you sure to save this change?")
            .then(function () {
                let data = BaseService.ConvertParam({
                    vmePaymentTypeId: $scope.formData.VME_PAYMENT_TYPE_ID,
                    accountType: $scope.formData.ACCOUNT_TYPE,
                    layoutList: JSON.stringify($scope.layoutList)
                });

                BaseService.CallAction(CONFIG_PATH, "SaveVMEPaymentTypeLayout", data)
                    .then(function (result) {
                        console.log(result);
                    }, function (err) {
                        console.error("Unable to save vme payment type layout: " + err.message);
                    })
            }, function () { })
    }

    $scope.getDefaultFields = function () {
        let obj = {ID: 0, REMARKS: ''};
        this.interfaceFields.forEach(function (f) {
            obj[f] = ''
        })

        return obj;
    }

    $scope.init();
}])

app.controller("ImportPaymentController", ['$scope', 'BaseService', 'CONFIG_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'Upload', '$timeout', '$filter', function ($scope, BaseService, CONFIG_PATH, SYSTEM_PATH, REPORT_PATH, Upload, $timeout, $filter) {
  
  $scope.init = function () {
        $scope.filters = {};
        $scope.PaymentTypeList = [];
        $scope.DOAList = [];
        $scope.formData = {};
        $scope.tblHeader = {};
        $scope.tblDetail = {};
        $scope.DOADetail = [];
        $scope.fileUpload = null;
        $scope.showDetail = false;
        $scope.DOAId = 0;
        $scope.accPayList = [
            { type: 'Accrue', subtype: '', label: 'Accrue' },
            { type: 'Payment', subtype: '', label: 'Payment' },
            { type: 'Accrue', subtype: 'Chargeback', label: 'Chargeback' },
        ]

        $scope.tabName = "Chassis";

        $scope.getHeaderList();

        $scope.$watch('VME_TYPE', function (v) {
            if (v) {
                $scope.getDOAList();
                $scope.getVMETypeMaster();
            }
        }, true)
    }

    $scope.getHeaderList = function () {
        let data = BaseService.ConvertParam({
            TableName1: "DOADetailByChassis",
            TableName2: "DOADetailByBaseModel",
            TableName3: "DOADetailByDealer",
            TableName4: "DOADetailByOutlet",
            TableName5: "",
        })

        BaseService.CallAction(SYSTEM_PATH, "GetHeaderGridViewList", data)
            .then(function (res) {
                $scope.tblHeader.Chassis = res.Table;
                $scope.tblHeader.BaseModel = res.Table1;
                $scope.tblHeader.Dealer = res.Table2;
                $scope.tblHeader.Outlet = res.Table3;
            }, function (error) {
                console.error("Unable to get Header gridview: " + error.message);
            })
    }

    $scope.getDOAList = function () {
        if ($scope.VME_TYPE == 'All') {
            BaseService.GetDataTable(CONFIG_PATH, "GetDOAImportList")
                .then(function (result) {
                    $scope.DOAList = result;
                }, function (error) {
                    console.error("Unable to get DOA list: " + error.message);
                })
        } else {
            BaseService.GetDataTableByParam(CONFIG_PATH, "GetDOAImportList", $scope.VME_TYPE)
                .then(function (result) {
                    $scope.DOAList = result;
                }, function (error) {
                    console.error("Unable to get DOA list: " + error.message);
                })
        }
    }

    $scope.addDOA = function () {
        $scope.formData = { CONFIRMABLE: 'Y', STATUS: 'Active' };
        $scope.tblDetail = {};
        $scope.fileUpload = null;
        $scope.showDetail = true;
        $scope.ACC_PAY = undefined;
    }

    $scope.editDOA = function (id) {
        $scope.DOAId = id;
        $scope.showDetail = true;
        $scope.formData = {};
        $scope.tblDetail = {};
        BaseService.GetDataTableByParam(CONFIG_PATH, "GetDOAImportByID", id)
            .then(function (result) {
                $scope.formData = result.Table[0];
                $scope.tblDetail.Chassis = result.Table1;
                $scope.tblDetail.BaseModel = result.Table2;
                $scope.tblDetail.Dealer = result.Table3;
                $scope.tblDetail.Outlet = result.Table4;

                $scope.switchTabDetail('Chassis');
                $scope.findAccPay();
            }, function (error) {
                console.error("Unable to get DOA by ID: " + error.message);
            })
    }

    $scope.submitDOA = function (id, status) {
        var confirmType, submitType;
        switch (status) {
            case 'Submit':
                confirmType = 'confirm DOA';
                submitType = 'confirmed';
                break;

            case 'DOAApprove':
                confirmType = 'approve DOA';
                submitType = 'approved';
                break;

            case 'DOAReturn':
                confirmType = 'return DOA';
                submitType = 'returned';
                break;

            case 'FinalDOAApprove':
                confirmType = 'approve DOA';
                submitType = 'approved';
                break;

            case 'FinalDOAReturn':
                confirmType = 'return DOA';
                submitType = 'returned';
                break;

            default:
                break;
        }
        BaseService.Message.confirm("Would you like to " + confirmType + "?")
            .then(function() {

                let data = BaseService.ConvertParam({
                    ID: id,
                    STATUS: status
                })

                BaseService.CallAction(CONFIG_PATH, "SubmitDOA", data)
                    .then(function (result) {
                        if (result == "Done") {
                            BaseService.Message.info("Successfully " + submitType + ".");
                            $scope.editDOA(id);
                            $scope.getDOAList();
                            //$scope.closeDetail();
                        } else {
                            BaseService.Message.alert(result);
                        }
                    }, function (error) {
                        console.error('Unable to confirm DOA: ' + error.message);
                    });

            }, function () { })
    }

    $scope.formSubmit = function () {
        BaseService.Message.confirm("Would you like to confirm upload DOA number " + $scope.formData.DOA_NO + "?")
            .then(function () {
                $scope.DOASave();
            }, function () { })
    }
    $scope.DOASave = function () {
                let data = BaseService.ConvertParam($scope.formData);

                BaseService.CallAction(CONFIG_PATH, "SaveDOAImport", data)
                    .then(function (result) {
                if (result.result != "Error") {
                        if (!$scope.formData.ID) {
                            $scope.formData.ID = result[0].ID
                        }
                BaseService.Message.info("DOA is successfully imported.");
                        $scope.editDOA($scope.formData.ID);
                $scope.getDOAList();
                } else {
                    BaseService.Message.alert(result.Message);
                }
                    }, function (error) {
                        console.error('Unable to save DOA: ' + error.message);
                    })
    }

    $scope.getVMETypeMaster = function () {
        BaseService.GetDataTable(CONFIG_PATH, "GetVMEPaymentTypeMaster")
            .then(function (result) {
                $scope.PaymentTypeList = ($scope.VME_TYPE == 'All') ? result : $filter('filter')(result, {VME_TYPE: $scope.VME_TYPE }, true);
            })
    }

    $scope.importFileTrigger = function () {

        let file = this.fileUpload;

        file.upload = Upload.upload({
            url: window.location.origin + CONFIG_PATH + '/UploadDOAMaster',
            data: { File: file },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                if (res.data.result == 500) {
                    BaseService.Message.alert("Please choose file.");
                } else if (res.data.result == 200) {
                    $scope.formData.UPLOAD_LOCATION = res.data.fileLocation.replace('~','');
                    if ($scope.formData.CONFIRMABLE == 'Y'
                        && doaform.doano.checkValidity()
                        && doaform.subject.checkValidity()
                        && doaform.vmetypeid.checkValidity()
                        && doaform.accpay.checkValidity()
                        && doaform.approvedby.checkValidity()) {
                        $scope.DOASave()
                    } else {
                        BaseService.Message.alert("Attach file completed. Please fill all required fields then click save button.");
                    }
                    $scope.fileUpload = null;
                }
            })
        }, function (res) {
            if (res.status > 0) {
                $scope.errorMsg = res.status + ': ' + res.data;
                BaseService.Message.alert("Cannot upload file")
            }
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        })

    }

    $scope.switchTabDetail = function (tabName) {
        $scope.tabName = tabName;
        $scope.DOADetail = $scope.tblDetail[tabName];
    }

    $scope.closeDetail = function () {
        $scope.formData = {};
        $scope.tblDetail = {};
        $scope.fileUpload = null;
        $scope.showDetail = false;
        $scope.DOAId = 0;
        $scope.tabName = 'Chassis';
    }

    $scope.exportReport = function () {
        let p1 = $scope.DOAId;

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=VME_Rpt_DOA_Detail&p1=' + p1, '_blank');
    }

    $scope.Download_Click = function () {
        window.open('/Doc/Template/CIMS_Additional_DOA_template.xlsx', '_blank');
    }
    $scope.selectACCPAY = function (ACC_PAY) {
        $scope.formData.VME_PAYMENT_ID = undefined;
        $scope.formData.ACCRUE_PAYMENT = ACC_PAY.type;
    }
    $scope.findAccPay = function () {
        var paymentDetail = $scope.$watch('PaymentTypeList', function (v) {
            if (v.length > 0) {
                var matchedPT = $filter('filter')($scope.PaymentTypeList, { ID: $scope.formData.VME_PAYMENT_ID }, true);
                if (matchedPT.length > 0) {
                    $scope.ACC_PAY = $filter('filter')($scope.accPayList, {
                        type: $scope.formData.ACCRUE_PAYMENT,
                        subtype: matchedPT[0].SUB_PAYMENT_TYPE
                    }, true)[0];
                    paymentDetail();
                }
            }
        }, true)
    }
    $scope.init();
}])