﻿app.controller("DealerMainController", ['$scope', 'BaseService', 'DEALER_PATH', 'CAMPAIGN_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEALER_PATH, CAMPAIGN_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        // GetHeader();
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView($scope.DealerCond)
            .then(function (result) {
                $scope.ListHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })

        BaseService.GetHeaderGridView("DmcOutletConfig")
            .then(function (result) {
                $scope.ListHeader2 = result;
            }, function (error) {
                console.log('Unable to load DmcOutletConfig header data: ' + error.message)
            })
    }
    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        GetData();
    }




    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListLeasingVolume = result.Table1;
                $scope.ListInsuranceVolume = result.Table2;
                $scope.ListDetail = result.Table3;
                $scope.ListCmpStatus = result.Table4;
                $scope.ListAllFleetStatus = result.Table5;
                $scope.ListAllDemoCarStatus = result.Table6;
                $scope.ListDemoCarStatus = result.Table7;
            }, function (error) {
                console.log('Unable to load campaign dashboard data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])

app.controller("DealerLoginController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'DEALER_PATH', '$filter', function ($scope, BaseService, SYSTEM_PATH, DEALER_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.IsRight = true;
        GetData();
    }

    function GetData() {

        var sendData = [{ "PA": 'A' }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(SYSTEM_PATH, 'GetAuthen', data)
            .then(function (result) {
                if (result == null || result == '') {
                    $scope.IsRight = false;
                } else {
                    $scope.IsRight = true;
                }


            }, function (error) {
                console.log('Unable to load GetAuthen: ' + error.message)
            })

    }


    $scope.btnTypeClass = function (type) {
        return {
            'btn': true,
            'btn-block': true,
            'btn-default': $scope.dealertype != type,
            'btn-submit': $scope.dealertype == type
        };
    }

    $scope.PwdRequire = true;

    $scope.SubUserList = [
        {
            SUB_USER_TYPE: 'Opt',
            NAME: 'Operation'
        },
        {
            SUB_USER_TYPE: 'Mgr',
            NAME: 'Manager'
        },
        {
            SUB_USER_TYPE: 'Act',
            NAME: 'Account'
        },
        {
            SUB_USER_TYPE: 'Evt',
            NAME: 'Dealer Event'
        },
        {
            SUB_USER_TYPE: 'Tar',
            NAME: 'Dealer target'
        }
    ]

    $scope.$watch('usrname', function (value) {
        if (value) {
            BaseService.CallAction(DEALER_PATH, "CheckSubTypeLogin", BaseService.ConvertParam({ "usrname": value }))
                .then(function (result) {
                    $scope.SubUserList.forEach(function (item) {
                        let resultItem = $filter('filter')(result, { SUB_USER_TYPE: item.SUB_USER_TYPE }, true);
                        if (resultItem.length > 0) {
                            item.IS_INIT_PWD = resultItem[0].IS_INIT_PWD;
                        }
                    });
                }, function (error) {
                    console.log('Unable to Check sub user type data: ' + error.message)
                })
        }
    })

    $scope.SelectSubUser = function (obj) {
        $scope.dealertype = obj.SUB_USER_TYPE;
        $scope.PwdRequire = (obj.IS_INIT_PWD == 'N');
    }
}])

app.controller("DealerChangePWDController", ['$scope', 'DEALER_PATH', 'BaseService', function ($scope, DEALER_PATH, BaseService) {
    $scope.btnTypeClass = function (type) {
        return {
            'btn': true,
            'btn-block': true,
            'btn-default': $scope.dealertype != type,
            'btn-submit': $scope.dealertype == type
        };
    }

    $scope.init = function () {
        $scope.formData = {};

        $scope.$watch('passwordExpire', function (value) {
            if (value) {
                BaseService.Message.alert("รหัสผ่านของท่านหมดอายุ กรุณาเปลี่ยนรหัสผ่านก่อนเข้าใช้งาน");
            }
        })

        $scope.$watch('initialPwd', function (value) {
            if (value) {
                BaseService.Message.alert("กรุณาตั้งรหัสผ่านของท่าน เพื่อเข้าใช้งานระบบ");
            }
        })
    }

    $scope.SaveChangePWD = function (username) {

        let data = BaseService.ConvertParam({
            SUB_USER_TYPE: $scope.dealertype,
            PASSWORD_OLD: $scope.old_password || (($scope.initialPwd) ? String.fromCharCode(112, 97, 115, 115, 119, 111, 114, 100) : ''),
            PASSWORD: $scope.password || '',
            PASSWORD2: $scope.password2 || '',
        })

        BaseService.CallAction(DEALER_PATH, "CheckPersonalChange", data).then(function (result) {
            if (result != "Done") {
                BaseService.Message.alert(result);
                return;
            } else {
                BaseService.CallAction(DEALER_PATH, "UpdateNewPWD", data).then(function (result) {
                    if (result == "Done") {
                        BaseService.Message.info("รหัสผ่านถูกเปลี่ยนเสร็จสิ้น").then(function () {
                            document.getElementById("formChangePWD").submit();
                        })
                    }
                }, function (error) {
                    console.log('Unable to save data: ' + error.message)
                })
            }
        }, function (error) {
            console.log('Unable to save data: ' + error.message)
        })
    }

    $scope.CancelEdit = function () {
        window.history.back();
    }

    $scope.init();
}])

app.controller("DealerSelectController", ['$scope', 'DEALER_PATH', 'CAMPAIGN_PATH', 'FLEET_PATH', 'DEMOCAR_PATH', 'BaseService', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, DEALER_PATH, CAMPAIGN_PATH, FLEET_PATH, DEMOCAR_PATH, BaseService, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        $scope.FILTER = {};
        $scope.selector = [];
        $scope.Unselect = [];
        GetHeader();
        $scope.matchedInsurance = false;

        $scope.DocFlags = [
            { DOC_FLAG: "A", DOC_STATUS: "ตรวจสอบเรียบร้อยแล้ว", DOC_STATUS_EN: "Complete" },
            { DOC_FLAG: "I", DOC_STATUS: "เอกสารไม่เรียบร้อย", DOC_STATUS_EN: "Incomplete" },
            { DOC_FLAG: "W", DOC_STATUS: "ยังไม่ได้อัพโหลดเอกสาร", DOC_STATUS_EN: "Waiting for upload" },
            { DOC_FLAG: "U", DOC_STATUS: "เอกสารรอการตรวจสอบ", DOC_STATUS_EN: "Uploaded" },
            { DOC_FLAG: "CB", DOC_STATUS: "เรียกเก็บเงินค่าปรับ", DOC_STATUS_EN: "Charge back" }
        ]

        $scope.$watch('ViewData_Click', function (val) {
            if (val) {
                $scope.ViewData_Click();
            }
        }, true)
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
            GetData();
        }
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DLRCampaignSelect')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, "GetRSList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetRSList data: ' + error.message)
            })
        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialActive", data)
            .then(function (result) {
                $scope.ListSpecial = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        $scope.formData = {}
        $scope.CampaignList = {}
        $scope.Detail = {}
        $scope.ItemType = 'Campaign'
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, "GetCampaignMatchList", data)
            .then(function (result) {
                $scope.CampaignList = $filter('filter')(result, $scope.excludeDummy());

                BaseService.CallAction(DEALER_PATH, "GetCampaignRetailSales", data)
                    .then(function (result) {
                        $scope.formData = result[0];
                        $scope.CSC1_CHECK = ($scope.formData.CSC1_ID != null && $scope.formData.CSC1_ID != '');
                        $scope.CSC2_CHECK = ($scope.formData.CSC2_ID != null && $scope.formData.CSC2_ID != '');
                        $scope.CSC3_CHECK = ($scope.formData.CSC3_ID != null && $scope.formData.CSC3_ID != '');

                        $scope.selectedCampaign = $filter('filter')($scope.CampaignList, {
                            CAMPAIGN_ID: $scope.formData.DLR_CAMPAIGN_ID
                        }, true)[0];
                    }, function (error) {
                        console.log('Unable to load GetCampaignRetailSales data: ' + error.message)
                    })
            }, function (error) {
                console.log('Unable to load GetCampaignMatchList data: ' + error.message)
            })
    }

    $scope.ShowCampaign_Change = function (selectedCampaign) {
        if (selectedCampaign != null) {
            $scope.formData.DLR_CAMPAIGN_ID = selectedCampaign.CAMPAIGN_ID;
        }
    }
    $scope.GetListCheck1 = function (value, isChecked) {
        $scope.CSC1_CHECK = isChecked;
        if ($scope.CSC1_CHECK) {
            $scope.formData.CSC1_ID = value;
        } else {
            $scope.formData.CSC1_ID = 0;
        }
    }
    $scope.GetListCheck2 = function (value, isChecked) {
        $scope.CSC2_CHECK = isChecked;
        if ($scope.CSC2_CHECK) {
            $scope.formData.CSC2_ID = value;
        } else {
            $scope.formData.CSC2_ID = 0;
        }
    }
    $scope.GetListCheck3 = function (value, isChecked) {
        $scope.CSC3_CHECK = isChecked;
        if ($scope.CSC3_CHECK) {
            $scope.formData.CSC3_ID = value;
        } else {
            $scope.formData.CSC3_ID = 0;
        }
    }


    $scope.Select = function () {
        return function (input) {
            return ((input.CAMPAIGN_ID != null) ? input.CAMPAIGN_ID.toString() : '') == (($scope.formData.DLR_CAMPAIGN_ID != null) ? $scope.formData.DLR_CAMPAIGN_ID.toString() : '');
        }
    }

    $scope.Save_Submit = function (CHASSIS_NO) {

        var sendData = [{
            "DLR_CAMPAIGN_ID": $scope.formData.DLR_CAMPAIGN_ID,
            "CHASSIS_NO": CHASSIS_NO,
            "CSC1_ID": $scope.formData.CSC1_ID || 0,
            "CSC2_ID": $scope.formData.CSC2_ID || 0,
            "CSC3_ID": $scope.formData.CSC3_ID || 0,
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, "SaveSelectCampaign", data)
            .then(function (result) {
                BaseService.Message.info('บันทึกข้อมูลเรียบร้อย').then(function () {
                    GetData();
                    document.getElementById('DetailModal').style.display = 'none';
                })
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.').then(function () {
                    console.log('Unable to edit dealer data: ' + error.message)
                    document.getElementById('DetailModal').style.display = 'none';
                })
            })
    }

    //-------------- Fleet -----------------


    $scope.ShowFleet_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        $scope.ItemType = 'Fleet'
        $scope.ID = ID;
        GetDetail(ID);
    }


    function GetDetail(ID) {

        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        $scope.fileUpload = null;
        $scope.UploadedFileName = null;
        BaseService.CallAction(DEALER_PATH, "GetFleetResult", data)
            .then(function (result) {
                $scope.formData = result[0];

                $scope.selectChassis = ID;
                $scope.GetBullatinList();

                if ($scope.formData.DOCUMENT_FILE_PATH) {
                    let fileUploadPath = $scope.formData.DOCUMENT_FILE_PATH;
                    let lastPathSign = fileUploadPath.lastIndexOf("/");
                    let fileNameLength = fileUploadPath.length - lastPathSign;

                    $scope.UploadedFileName = fileUploadPath.substr(lastPathSign + 1, fileNameLength);
                }

            }, function (error) {
                console.log('Unable to load GetFleetResult data: ' + error.message)
            })

    }
    $scope.ShowEdit_Group = function () {
        var DocList = [];
        $scope.fileUpload = null;
        $scope.formGroup = {};
        $scope.Unselect = [];
        let HAS_APPROVED = false;
        $scope.selector.forEach(function (Chassis) {
            matchedItem = $filter('filter')($scope.ListDetail, { CHASSIS_NO: Chassis }, true)[0];
            if (DocList.indexOf(matchedItem.DOC_ID) < 0) {
                DocList.push(matchedItem.DOC_ID);
            }
            console.log(matchedItem);
            if (matchedItem.DOC_FLAG == 'A') {
                HAS_APPROVED = true;
            }

        })
        if (DocList.length > 1) {
            BaseService.Message.confirm("พบรหัสอนุมัติมากกว่า 1 ชนิด ระบบจะลบเอกสารที่เกี่ยวข้องออก ท่านต้องการทำต่อหรือไม่")
                .then(function () {
                    $scope.formGroup = {
                        FileID: 0,
                        DOC_REF: null,
                        DOCUMENT_FILE_PATH: null,
                        HAS_APPROVED: HAS_APPROVED,
                    }
                    document.getElementById('GroupModal').style.display = 'block';
                }, function () {
                    null;
                })
        } else {
            GetFleetGroup(DocList[0], $scope.FILTER.FLEET_NAME);
            document.getElementById('GroupModal').style.display = 'block';
        }
    }
    $scope.ShowFleetGroup_Click = function (item) {
        BaseService.Message.confirm("เนื่องจากรถคันนี้ได้ถูกอับโหลดเอกสารเป็นกลุ่ม ท่านต้องการเข้าหน้าจออับโหลดเอกสารเป็นกลุ่มหรือไม่")
            .then(function () {
                GetFleetGroup(item.DOC_ID, item.FLEET_NAME)
                document.getElementById('GroupModal').style.display = 'block';
            }, function () {
                $scope.ShowFleet_Click(item.CHASSIS_NO);
            })
    }
    function GetFleetGroup(DOC_ID, FLEET_NAME) {
        $scope.UploadedFileName = null;
        if (DOC_ID && DOC_ID != 0) {
            $scope.formGroup = {};
            $scope.selector = [];
            $scope.Unselect = [];
            let HAS_APPROVED = false;
            let ChassisGroup = $filter('filter')($scope.ListDetail, { DOC_ID: DOC_ID, SALE_TYPE: 'Fleet', FLEET_NAME: FLEET_NAME }, true);
            ChassisGroup.forEach(function (item) {
                if (item.DOC_FLAG == 'A') {
                    HAS_APPROVED = true;
                }
                $scope.selector.push(item.CHASSIS_NO);
            })
            $scope.formGroup = {
                FileID: ChassisGroup[0].DOC_ID,
                DOC_REF: ChassisGroup[0].DOC_REF,
                DOCUMENT_FILE_PATH: ChassisGroup[0].DOCUMENT_FILE_PATH,
                HAS_APPROVED: HAS_APPROVED,
                DOC_FLAG: ChassisGroup[0].DOC_FLAG,
                REMARKS: ChassisGroup[0].REMARKS,
            }
        } else {
            $scope.formGroup = {
                FileID: 0,
                DOC_REF: null,
                DOCUMENT_FILE_PATH: null,
                DOC_FLAG: 'W',
                REMARKS: null,
            }
        }
    }
    $scope.SaveFleet_Submit = function () {

        if ($scope.formData.DOC_REF == null || $scope.formData.DOC_REF.trim() == '') {
            BaseService.Message.warning("กรุณาใส่ รหัสอนุมัติเอกสาร")
            return;
        }

        var file = this.fileUpload;

        file.upload = Upload.upload({
            url: window.location.origin + FLEET_PATH + '/UploadPaymentDoc',
            data: {
                File: file,
                Chassis: $scope.selectChassis,
                DealerID: $scope.OutletID,
                DocRef: $scope.formData.DOC_REF,
            },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                BaseService.Message.info('อัพโหลดเอกสาร เรียบร้อยแล้ว').then(function () {
                    $scope.fileUpload = null;
                    GetData();
                    GetDetail($scope.ID);
                })
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });

    }
    $scope.UploadFleetGroup_Submit = function () {
        if ($scope.formGroup.DOC_REF == null || $scope.formGroup.DOC_REF.trim() == '') {
            BaseService.Message.warning("กรุณาใส่ รหัสอนุมัติเอกสาร")
            return;
        }
        var file = this.fileUpload;
        file.upload = Upload.upload({
            url: window.location.origin + FLEET_PATH + '/UploadPaymentDocGroup',
            data: {
                File: file,
                DealerID: $scope.OutletID,
                DocRef: $scope.formGroup.DOC_REF,
                FileID: $scope.formGroup.FileID
            },
        });
        file.upload.then(function (res) {
            $timeout(function () {
                $scope.fileUpload = null;
                GetData();
                $scope.formGroup.FileID = res.data.FileID;
                BaseService.Message.info('อัพโหลดเอกสาร เรียบร้อยแล้ว กรุณากดปุ่มบันทึก เพื่อบันทึกลงในระบบ')
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    }
    $scope.SaveGroup_Submit = function () {
        if ($scope.FileID == 0) {
        }
        let scopeData = {
            Chassis: $scope.selector,
            DealerID: $scope.OutletID,
            DocRef: $scope.formGroup.DOC_REF,
            FileID: $scope.formGroup.FileID
        }
        let data = BaseService.ConvertParam(scopeData)
        BaseService.CallAction(FLEET_PATH, "SaveGroupWOUpload", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                $scope.selector = [];
                $scope.Unselect = [];
                BaseService.Message.info('บันทึกข้อมูลเรียบร้อย');
            }, function (error) {
                console.log('Unable to edit fleet data: ' + error.message)
            })
    }

    $scope.GetBullatinList = function () {
        $scope.fleetBullatin = null;

        data = BaseService.ConvertParam({ "FLEET_NAME": $scope.formData.FLEET_NAME });

        BaseService.CallAction(FLEET_PATH, "GetFleetBullatinDealer", data)
            .then(function (result) {
                $scope.bullatinList = result;
                $scope.fleetBullatin = $filter('filter')($scope.bullatinList, { FLEET_BULLATIN: $scope.formData.FLEET_BULLATIN }, true)[0];
            }, function (error) {
                console.log('Unable to load Bullatin data: ' + error.message)
            })
    }

    $scope.GetBullatinConfigure = function (date_from, date_to, fn) {

        var data = BaseService.ConvertParam({
            "DATE_FROM": date_from,
            "DATE_TO": date_to,
            "FLEET_NAME": $scope.formData.FLEET_NAME,
            "MODEL_CODE": $scope.formData.MODEL_CODE
        });

        BaseService.CallAction(FLEET_PATH, "GetFleetResultGroup", data)
            .then(function (result) {
                (typeof (fn) != 'undefined') ? fn(result[0]) : null;
            }, function (error) {
                console.log('Unable to load GetFleetResultGroup data: ' + error.message)
            })
    }

    $scope.Save_Bullatin_Submit = function () {
        let scopeData = $scope.formData;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(FLEET_PATH, "SaveFleetResult", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('บันทึกข้อมูลเรียบร้อย');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit fleet data: ' + error.message)
            })
    }

    $scope.BullatinChange = function (obj) {
        $scope.GetBullatinConfigure(obj.START_DATE, obj.END_DATE, function (result) {
            if (result) {
                $scope.formData.MONTHLY_PROGRAM_ID = result.MONTHLY_PROGRAM_ID
                $scope.formData.FLEET_CAMPAIGN_AMOUNT = result.CFG_CAMPAIGN_AMOUNT
                $scope.formData.ONTOP_FLAG = 'M'
                $scope.formData.ONTOP_M = result.CFG_ONTOP_M
                $scope.formData.ONTOP_L = result.CFG_ONTOP_L
                $scope.formData.ADD_ONTOP = result.CFG_ADD_ONTOP

                $scope.formData.FLEET_AMOUNT = result.CFG_CAMPAIGN_AMOUNT + result.CFG_ONTOP_M + result.CFG_ADD_ONTOP
            } else {
                $scope.formData.MONTHLY_PROGRAM_ID = 0
                $scope.formData.FLEET_CAMPAIGN_AMOUNT = 0
                $scope.formData.ONTOP_FLAG = 'M'
                $scope.formData.ONTOP_M = 0
                $scope.formData.ONTOP_L = 0
                $scope.formData.ADD_ONTOP = 0
                $scope.formData.FLEET_AMOUNT = 0
            }
        });
    }

    //--------------Democar-----------------
    $scope.ShowDemoCar_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        $scope.ItemType = 'DemoCar'
        $scope.ID = ID;
        GetDetailDemoCar(ID);
    }

    function GetDetailDemoCar(ID) {
        $scope.fileUpload = null;
        $scope.selectChassis = ID

        var year = $scope.periodYear.toString();
        var month = $scope.periodMonth.toString();
        var DATA_MONTH = year + ('0' + month.toString()).substr(-2);
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        document.getElementById('DetailModal').style.display = 'block';
        $scope.selectPayment = '';
        $scope.formDataRightSide = {};
        BaseService.CallAction(DEALER_PATH, "GetDemoCarChassisInfo", data)
            .then(function (result) {
                $scope.formData = result.Table[0];
                $scope.DocNotComplete = ($scope.formData.DOC_FLAG != 'A');
                $scope.selectPayment = ($scope.formData.ACCEPTABLEPAYMENT == 'Accept') ? 'Accept' : 'Reject';


                if ($scope.formData.DOCUMENT_FILE_PATH) {
                    let fileUploadPath = $scope.formData.DOCUMENT_FILE_PATH;
                    let lastPathSign = fileUploadPath.lastIndexOf("/");
                    let fileNameLength = fileUploadPath.length - lastPathSign;

                    $scope.UploadedFileName = fileUploadPath.substr(lastPathSign + 1, fileNameLength);
                }

            }, function (error) {
                BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetDemoCarUpload data: ' + error.message)
            })
    }

    $scope.Save_SubmitUpload = function () {
        var file = this.fileUpload;
        file.upload = Upload.upload({
            url: window.location.origin + DEMOCAR_PATH + '/UploadPaymentDoc',
            data: {
                File: file,
                Chassis: $scope.selectChassis,
                DealerID: $scope.formData.DEALER_CODE,
                DOC_REF: $scope.formData.DOC_REF,
                DOC_DATE: $scope.formData.DOC_DATE
            },
        });
        file.upload.then(function (res) {
            $timeout(function () {
                BaseService.Message.info('อัปโหลดเอกสารเรียบร้อย').then(function () {
                    $scope.fileUpload = null;
                    $scope.ShowDemoCar_Click($scope.formData.CHASSIS_NO);
                })
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    }
    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }


    $scope.openDocDate = function () {
        $scope.popupDocDate.opened = true;
    }
    $scope.popupDocDate = {
        opened: false
    }
    $scope.Save_InActionEdit = function () {

        console.log(data)
        if (!$scope.formData.DOC_DATE) {
            BaseService.Message.alert('Document date and Document ref cannot empty');
            return;
        }
        var data = BaseService.ConvertParam($scope.formData);
        BaseService.CallAction(DEMOCAR_PATH, "SaveDMCSummaryDetail", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('บันทึกข้อมูลเรียบร้อย');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    //-----------------------------------

    $scope.ToggleSelector = function (thisItem) {

        if (($scope.FILTER.FLEET_NAME && $scope.FILTER.FLEET_NAME != '')
            || $scope.selector.length > 0) {
            const thisItemID = thisItem.CHASSIS_NO;

            let thisElement = document.getElementById(thisItemID);


            if (!thisElement.classList.contains("selected")) {
                $scope.selector.push(thisItemID);
                thisElement.classList.add("selected");
            } else {
                $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
                thisElement.classList.remove("selected");
            }
        }
    }
    $scope.ToggleUnSelect = function (thisItem) {
        const thisItemID = thisItem.CHASSIS_NO;
        let thisElement = document.getElementById(thisItemID);
        if ($scope.Unselect.indexOf(thisItemID) == -1) {
            $scope.Unselect.push(thisItemID);
        } else {
            $scope.Unselect.splice($scope.Unselect.indexOf(thisItemID), 1);
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.moveToUnselect = function (thisItem) {
        $scope.ToggleUnSelect(thisItem)
        $scope.ToggleSelector(thisItem)
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        document.getElementById('GroupModal').style.display = 'none';
        $scope.selector = [];
        $scope.Unselect = [];
    }
    $scope.selectDeselectAll = function (isSelect) {
        if ($scope.AllItem) {
            $scope.AllItem.forEach(function (item) {
                let thisElement = document.getElementById(item.CHASSIS_NO);
                if (isSelect && thisElement && !thisElement.classList.contains("selected")) {
                    $scope.selector.push(item.CHASSIS_NO);
                    thisElement.classList.add("selected");
                } else if (!isSelect && thisElement && thisElement.classList.contains("selected")) {
                    $scope.selector.splice($scope.selector.indexOf(item.CHASSIS_NO), 1);
                    thisElement.classList.remove("selected");
                }
            })
        }
    }
    $scope.filterItem = function () {
        let n = 1;
        $scope.AllItem = [];
        $scope.HAS_EXPIRED = false;
        return function (input) {
            let filterResult = true;
            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if (filterResult) {
                    if ($scope.FILTER[item] == null) {
                        filterResult = true;
                    } else if (item == 'SALE_TYPE' || item == 'DOC_FLAG' || item == 'FLEET_NAME') {
                        if ($scope.FILTER[item] != '') {
                            if ((input[item] || '').toLowerCase() == $scope.FILTER[item].toLowerCase()) {
                                filterResult = true;
                            } else {
                                filterResult = false;
                            }
                        }
                    } else if ((input[item] || '').toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                        filterResult = false;
                    }
                }
            });
            if (filterResult && n >= $scope.PageRecFrom && n <= $scope.PageRecTo) {
                $scope.AllItem.push(input);
            }
            if (filterResult) {
                if (input.IS_EXPIRED == true) {
                    $scope.HAS_EXPIRED = true;
                }
                n++;
            }
            //console.log(filterResult);
            return filterResult;
        }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, { CHASSIS_NO: $scope.FILTER.CHASSIS_NO, MODEL_CODE: $scope.FILTER.MODEL_CODE });

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.excludeDummy = function () {
        return function (input) {
            return input.CAMPAIGN_CODE != 'DUMMYADJUST' && input.CAMPAIGN_CODE != 'DUMMYNOTPAY';
        }
    }

    $scope.openMonth = function () {
        $scope.popupMonth.opened = true;
    };
    $scope.popupMonth = {
        opened: false,
    };

    $scope.setOptionClass = function (obj) {
        let require = $scope.formData.HAS_INSURANCE == 'Y' && obj.FREE_INSURANCE;
        (require) ? $scope.matchedInsurance = true : null;
        return { 'require': require };
    }
    $scope.setCampaignSelectable = function (obj) {
        var selectable = true;
        if ($scope.formData.WAIT_FLAG || $scope.formData.WAIT_FLAG == null) {
            if ($scope.formData.HAS_INSURANCE == 'Y') {
                selectable = obj.FREE_INSURANCE;
            }
            if ($scope.formData.HAS_LEASING == 'Y') {
                if ($scope.formData.LEASING_TYPE == 'EX') {
                    selectable = obj.JOIN_LEASING && obj.CAMPAIGN_NAME == 'NLTH Exclusive campaign'
                } else if ($scope.formData.LEASING_TYPE == 'GEN') {
                    selectable = obj.JOIN_LEASING && obj.CAMPAIGN_NAME == 'NLTH General rate'
                } else if ($scope.formData.LEASING_TYPE == 'ALL') {
                    selectable = obj.JOIN_LEASING;
                } else {
                    selectable = false;
                }
            }
            if (!selectable) {
                selectable = ($scope.formData.DLR_CAMPAIGN_ID == obj.CAMPAIGN_ID);
            }
        } else {
            selectable = ($scope.formData.CAMPAIGN_ID == obj.CAMPAIGN_ID);
        }
        return selectable;
    }
    $scope.Report_Click = function () {
        $scope.reportCode = 'VME_Rpt_DLR_Campaign_Selection';
        $scope.reportName = 'Dealer campaign selection';
        gText = 'rt=1&export=excelopenxml&ExportName=DealerSelectionCampaign' + $scope.DATA_MONTH;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=VME_Rpt_DLR_Campaign_Selection&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.OutletID + '&p3=' + $scope.reportName, '_blank');
    }

    //----Error catch
    $scope.CheckFileUpload = function (file, error) {
        setTimeout(function () {
            let invalidFile = $scope[error]
            if (invalidFile && invalidFile.$error == 'maxSize') {
                BaseService.Message.alert("ไฟล์ต้องมีขนาดไม่เกิน " + invalidFile.$errorParam);
            }
        }, 100)
    }

}])

app.controller("DealerTrackingController", ['$scope', 'DEALER_PATH', 'BaseService', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, DEALER_PATH, BaseService, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.Section = 0;
        $scope.FnName = "GetDealerPayment";
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true)
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
            GetData();
        }
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DealerGetAmount')
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, $scope.FnName, data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load FnName: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, { CHASSIS_NO: $scope.FILTER.CHASSIS_NO, MODEL_CODE: $scope.FILTER.MODEL_CODE });
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.openMonth = function () {
        $scope.popupMonth.opened = true;
    };
    $scope.popupMonth = {
        opened: false,
    };

    $scope.Report_Click = function (RptNo) {
        if (RptNo == 'Summary') {
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportSum, '_blank');
        } else if (RptNo == 'Detail') {
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportDetail, '_blank');
        }
    }

    $scope.ShowItem_Click = function (Chassis) {
        document.getElementById('DetailModal').style.display = 'block';
        $scope.GetDetailData(Chassis);
    }

    $scope.GetDetailData = function (Chassis) {
        var data = BaseService.ConvertParam({
            'CHASSIS_NO': Chassis,
            'DATA_MONTH': $scope.DATA_MONTH
        })
        BaseService.CallAction(DEALER_PATH, 'GetDealerDetail', data)
            .then(function (result) {
                $scope.formData = (result.Table[0] || {});
                $scope.formData_CMP = result.Table1 || [];
                $scope.formData_FLT = result.Table2 || [];
                $scope.formData_FCB = result.Table3 || [];
                $scope.formData_DMC = result.Table4 || [];
                $scope.formData_INC = result.Table5 || [];
                $scope.formData_VDM = result.Table6 || [];
            }, function (error) {
                console.log('Unable to load GetDealerDetail:' + error.message);
            })
    }
    $scope.Report_Click = function () {
        $scope.reportCode = 'VME_Rpt_DLR_All_Payment';
        $scope.reportName = 'รายงานผลประโยชน์ที่ได้รับรายคัน';
        gText = 'rt=1&export=excelopenxml&ExportName=' + $scope.reportCode + '_' + $scope.DATA_MONTH;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.OutletID + '&p3=' + $scope.reportName, '_blank');
    }

}])

app.controller("DealerBeneficController", ['$scope', 'DEALER_PATH', 'SYSTEM_PATH', 'INCENTIVE_PATH', 'BaseService', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, DEALER_PATH, SYSTEM_PATH, INCENTIVE_PATH, BaseService, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.year = date.getFullYear();
        $scope.CQ_MIGRATE_YEAR = 2019;
        $scope.DATA_MONTH_CQ = $scope.year.toString().concat('04');
        if (date.getMonth() <= 2) {
            $scope.quarter = "4";
        } else if (date.getMonth() <= 5) {
            $scope.quarter = "1";
        } if (date.getMonth() <= 8) {
            $scope.quarter = "2";
        } else {
            $scope.quarter = "3";
        }
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.Section = 1;
        $scope.FnName = "GetDealerBeneficCMP";
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true)

        GetOutletList();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
            GetData($scope.DATA_MONTH);
        }
    }

    $scope.OutletSelected_Change = function (obj) {
        $scope.OutletSelected = obj;

        $scope.OutletID = $scope.OutletSelected;
        GetData($scope.DATA_MONTH);
    }

    $scope.VME_Change = function (Payto) {
        $scope.Section = Payto;
        let dataMonth = $scope.DATA_MONTH;

        switch (Payto) {
            case 1:
                $scope.FnName = "GetDealerBeneficCMP";
                $scope.ListHeader = $scope.ListHeader1;
                break;

            case 2:
                $scope.FnName = "GetDealerBeneficFLT";
                $scope.ListHeader = $scope.ListHeader2;
                break;

            case 3:
                $scope.FnName = "GetDealerBeneficINC";
                $scope.ListHeader = $scope.ListHeader1;
                break;

            case 4:
                $scope.FnName = "GetDealerBeneficDMC";
                $scope.ListHeader = $scope.ListHeader4;
                break;

            case 5:
                $scope.FnName = "GetDealerBeneficCQ";
                $scope.ListHeader = $scope.ListHeader4;
                dataMonth = $scope.DATA_MONTH_CQ
                if ($scope.year >= $scope.CQ_MIGRATE_YEAR) {
                    $scope.FnName = "GetDealerBeneficCQ2";
                }
                break;

            default:
                break;
        }
        GetData(dataMonth);

    };

    function GetHeader() {

        var sendData = [{
            'TableName1': 'DealerCampaignList'
            , 'TableName2': 'DealerFleetList'
            , 'TableName3': 'RsModelPay'
            , 'TableName4': 'IncentiveModelList'
            , 'TableName5': 'RptDealerDemoCar'
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
                $scope.ListDetailHeader = result.Table2;
                $scope.HeaderPercent = result.Table3;
                $scope.ListHeader4 = result.Table4;

                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });


        var sendData = [{
            'TableName1': 'ScModelPay'
            , 'TableName2': 'CQDetailShort'
            , 'TableName3': 'VDMSummaryDLR'
            , 'TableName4': 'x'
            , 'TableName5': 'x'
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ScListDetailHeader = result.Table;
                $scope.HeaderFields = result.Table1;
                $scope.VDMFields = result.Table2;

            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.setCQDataMonth = function (val) {
        $scope.DATA_MONTH_CQ = val;
    }
    $scope.setCQQuater = function (val) {
        $scope.quarter = val;
    }

    $scope.GetDataCQ = function () {
        if ($scope.quarter == null || $scope.year == null) {
            return;
        }
        $scope.FnName = ($scope.year >= $scope.CQ_MIGRATE_YEAR) ? "GetDealerBeneficCQ2" : "GetDealerBeneficCQ";
        GetData($scope.DATA_MONTH_CQ);
    }

    function GetData(dataMonth) {

        var sendData = [{ "DATA_MONTH": dataMonth, "Q_YEAR": $scope.year, "Q_QUARTER": $scope.quarter, "OUTLET_ID": $scope.OutletID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, $scope.FnName, data)
            .then(function (result) {
                if ($scope.Section <= 2) {
                    $scope.ListInfo1 = result.Table;
                    $scope.ListInfo2 = result.Table1;
                } else if ($scope.Section == 3) {
                    $scope.RsformData = result.Table[0];
                    $scope.RsformDetail = result.Table1;
                    $scope.Rs2MformData = result.Table2[0];
                    $scope.Rs2MformDetail = result.Table3;

                    $scope.formPercent = result.Table4;
                    $scope.SpformDetail = result.Table5;
                    $scope.ScformDetail = result.Table6;

                    var data = BaseService.ConvertParam({ "year": $scope.periodYear, "month": String('00' + $scope.periodMonth.toString()).slice(-2) });
                    BaseService.CallAction(INCENTIVE_PATH, "GetSpPercentMonthly", data)
                        .then(function (result1) {
                            $scope.ListMaskHeader = result1[0];

                            var i = 0;
                            $scope.hasConfig = false;
                            for (var property in $scope.ListMaskHeader) {
                                if ($scope.ListMaskHeader.hasOwnProperty(property)) {
                                    if ($scope.ListMaskHeader[property] > 0) {
                                        $scope.HeaderPercent[i + 2]["VISIBILITY"] = 1;
                                        $scope.hasConfig = true;
                                    } else {
                                        $scope.HeaderPercent[i + 2]["VISIBILITY"] = 0;
                                    }
                                }
                                i++;
                            }
                            calculateTotal();
                        }, function (error) {
                            console.log('Unable to load data: ' + error.message)
                        });
                } else if ($scope.Section == 4) {
                    $scope.ListInfo1 = result.Table;

                } else if ($scope.Section == 5) {
                    $scope.QuarterSum = result.Table;
                    $scope.QuarterDetail = result.Table1;
                    $scope.Configure = result.Table2;
                }

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetDetail() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, $scope.FnName + '_Detail', data)
            .then(function (result) {
                $scope.ListDetail = result;

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetOutletList() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, 'GetOutletList', data)
            .then(function (result) {
                $scope.OutletList = result;

            }, function (error) {
                console.log('Unable to GetOutletList: ' + error.message)
            })
    }

    //----------------------- Incentive RS ---------------------

    $scope.RsShowChassisDetail = function (row) {

        $scope.formChassisDetail = null;
        $scope.ModelName = row.INC_MODEL_NAME;

        document.getElementById('ChassisModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH,
            "DEALER_ID": $scope.RsformData.DEALER_ID,
            "INC_MODEL_ID": row.INC_MODEL_ID,
            "GET_AMOUNT": row.GET_AMOUNT
        });

        BaseService.CallAction(DEALER_PATH, "GetRsModelChassis", data)
            .then(function (result) {
                $scope.formChassisDetail = result;
            }, function (error) {
                console.log('Unable to load GetRsModelChassis data: ' + error.message)
            })
    }


    $scope.SpShowChassisDetail = function (row) {

        $scope.formChassisDetail = null;
        $scope.ModelName = row.INC_MODEL_NAME;

        document.getElementById('ChassisModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH,
            "DEALER_ID": $scope.RsformData.DEALER_ID,
            "INC_MODEL_ID": row.SP_ID,
            "GET_AMOUNT": row.GET_AMOUNT
        });

        BaseService.CallAction(DEALER_PATH, "GetSPModelChassis", data)
            .then(function (result) {
                $scope.formChassisDetail = result;
            }, function (error) {
                console.log('Unable to load GetRsModelChassis data: ' + error.message)
            })
    }

    $scope.ScShowChassisDetail = function (row) {

        $scope.formChassisDetail = null;
        $scope.ModelName = row.INC_NAME;

        document.getElementById('ChassisModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH,
            "DEALER_ID": $scope.RsformData.DEALER_ID,
            "INC_NAME": row.INC_NAME
        });

        BaseService.CallAction(DEALER_PATH, "GetScChassisByDealerIncName", data)
            .then(function (result) {
                $scope.formChassisDetail = result;
            }, function (error) {
                console.log('Unable to load GetScModelChassis data: ' + error.message)
            })
    }


    $scope.Close_ChassisModal = function (ID) {
        document.getElementById('ChassisModal').style.display = 'none';
    }

    function calculateTotal() {

        $scope.RsTotal = [];
        $scope.Rs2MTotal = [];
        $scope.SpTotal = [];
        $scope.ScTotal = [];
        for (var i in $scope.ListDetailHeader) {
            if ($scope.ListDetailHeader[i]['FIELD_NAME'] != 'INC_MODEL_NAME'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'ACTUAL_PERCENT'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'PERCENT_GET'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'GET_AMOUNT') {
                var key = $scope.ListDetailHeader[i]['FIELD_NAME'];
                $scope.RsTotal[key] = 0;

                for (var j in $scope.RsformDetail) {
                    $scope.RsTotal[key] += parseInt($scope.RsformDetail[j][key]);
                }
            }
        }

        for (var i in $scope.ListDetailHeader) {
            if ($scope.ListDetailHeader[i]['FIELD_NAME'] != 'INC_MODEL_NAME'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'ACTUAL_PERCENT'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'PERCENT_GET'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'GET_AMOUNT') {
                var key = $scope.ListDetailHeader[i]['FIELD_NAME'];
                $scope.Rs2MTotal[key] = 0;

                for (var j in $scope.Rs2MformDetail) {
                    $scope.Rs2MTotal[key] += parseInt($scope.Rs2MformDetail[j][key]);
                }
            }
        }

        for (var i in $scope.ListDetailHeader) {
            if ($scope.ListDetailHeader[i]['FIELD_NAME'] != 'INC_MODEL_NAME'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'ACTUAL_PERCENT'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'PERCENT_GET'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'GET_AMOUNT') {
                var key = $scope.ListDetailHeader[i]['FIELD_NAME'];
                $scope.SpTotal[key] = 0;

                for (var j in $scope.SpformDetail) {
                    $scope.SpTotal[key] += parseInt($scope.SpformDetail[j][key]);
                }
            }
        }

        for (var i in $scope.scListDetailHeader) {
            if ($scope.scListDetailHeader[i]['FIELD_NAME'] != 'INC_MODEL_NAME'
                && $scope.scListDetailHeader[i]['FIELD_NAME'] != 'PERCENT_GET'
            ) {
                var key = $scope.scListDetailHeader[i]['FIELD_NAME'];
                $scope.ScTotal[key] = 0;

                for (var j in $scope.ScformDetail) {
                    $scope.ScTotal[key] += parseInt($scope.ScformDetail[j][key]);
                }
            }
        }
    }

    //----------------------- End Incentive RS ---------------------


    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, { CHASSIS_NO: $scope.FILTER.CHASSIS_NO, MODEL_CODE: $scope.FILTER.MODEL_CODE });

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.openMonth = function () {
        $scope.popupMonth.opened = true;
    };
    $scope.popupMonth = {
        opened: false,
    };

    $scope.Report_Click = function (IncReport) {

        var reportName = '';
        var p = null, p1 = null, p2 = null, p3 = null, p4 = null;
        switch ($scope.Section) {
            case 1:
                p = 'VME_Rpt_DLR_Benefic_Campaign_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์แคมเปญส่งเสริมการขาย';
                break;
            case 2:
                p = 'VME_Rpt_DLR_Benefic_Fleet_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์การขายฟลีท (Fleet)';
                break;
            case 3:
                if (IncReport == 'report1') {
                    p = 'VME_Rpt_DLR_Benefic_INC_RS_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขายรายเดือน';
                }
                else if (IncReport == 'report3') {
                    p = 'VME_Rpt_DLR_Benefic_INC_2M_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขาย 2 เดือน';
                }
                else if (IncReport == 'report2') {
                    p = 'VME_Rpt_DLR_Benefic_INC_SP_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขายเฉพาะรุ่น';
                }
                else {
                    p = 'VME_Rpt_DLR_Benefic_INC_SC_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานโปรแกรมส่งเสริมการขายพิเศษ';
                }
                break;
            case 4:
                p = 'VME_Rpt_DLR_Benefic_DemoCar_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์รถยนต์ทดลองขับ';
                break;
            case 5:
                if ($scope.year >= $scope.CQ_MIGRATE_YEAR) {
                    p = 'VME_Rpt_DLR_Benefic_VDM_Detail_ByChassis';
                    p1 = $scope.DATA_MONTH_CQ;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานผลการประเมินคุณภาพ';
                }
                else {
                p = 'VME_Rpt_DLR_Benefic_CQ_Detail';
                p1 = $scope.year;
                p2 = $scope.quarter;
                p3 = $scope.OutletID;
                p4 = 'รายงานผลการประเมินคุณภาพ';
                }
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + p + '&p1=' + p1 + '&p2=' + p2 + '&p3=' + p3 + '&p4=' + p4, '_blank');
    }

    $scope.ExReport_Click = function (IncReport) {

        var p = null, p1 = null, p2 = null, p3 = null, p4 = null;
        switch ($scope.Section) {
            case 1:
                p = 'VME_Rpt_DLR_Benefic_Campaign_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์แคมเปญส่งเสริมการขาย';
                break;
            case 2:
                p = 'VME_Rpt_DLR_Benefic_Fleet_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์การขายฟลีท (Fleet)';
                break;
            case 3:
                if (IncReport == 'report1') {
                    p = 'VME_Rpt_DLR_Benefic_INC_RS_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขายรายเดือน';
                }
                else if (IncReport == 'report3') {
                    p = 'VME_Rpt_DLR_Benefic_INC_2M_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขาย 2 เดือน';
                }
                else if (IncReport == 'report2') {
                    p = 'VME_Rpt_DLR_Benefic_INC_SP_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานบรรลุเป้าการขายเฉพาะรุ่น';
                }
                else {
                    p = 'VME_Rpt_DLR_Benefic_INC_SC_Volume_Model';
                    p1 = $scope.DATA_MONTH;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานโปรแกรมส่งเสริมการขายพิเศษ';
                }
                break;
            case 4:
                p = 'VME_Rpt_DLR_Benefic_DemoCar_Detail';
                p1 = $scope.DATA_MONTH;
                p2 = $scope.OutletID;
                p3 = 'รายงานผลประโยชน์รถยนต์ทดลองขับ';
                break;
            case 5:
                if ($scope.year >= $scope.CQ_MIGRATE_YEAR) {
                    p = 'VME_Rpt_DLR_Benefic_VDM_Detail';
                    p1 = $scope.DATA_MONTH_CQ;
                    p2 = $scope.OutletID;
                    p3 = 'รายงานผลการประเมินคุณภาพ';
                }
                else {
                    p = 'VME_Rpt_DLR_Benefic_CQ_Detail';
                    p1 = $scope.year;
                    p2 = $scope.quarter;
                    p3 = $scope.OutletID;
                    p4 = 'รายงานผลการประเมินคุณภาพ';
                }
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&&export=excelopenxml&ExportName=' + p + '_' + p1 + '&rc=' + p + '&p1=' + p1 + '&p2=' + p2 + '&p3=' + p3 + '&p4=' + p4, '_blank');

    }

    $scope.VDMCountPass = function (type, obj) {
        let result = obj.filter(function (item) {
            if (type == 'SSI') {
                return item.SSI_AMOUNT > 0
            } else if (type == 'CSI') {
                return item.CSI_AMOUNT > 0
            }
        })

        return result.length;
    }

}])

app.controller("DealerPaymentRoundController", ['$scope', 'DEALER_PATH', 'SYSTEM_PATH', 'ACCOUNT_PATH', 'INCENTIVE_PATH', 'BaseService', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, DEALER_PATH, SYSTEM_PATH, ACCOUNT_PATH, INCENTIVE_PATH, BaseService, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.PAYMENT_DATE = '';
        $scope.FILTER = {};
        $scope.Section = 1;
        $scope.FnName = "GetDealerPaymentCMP";
        $scope.CQ_MIGRATE_DATAMONTH = '201904';
        GetHeader();

        GetData();
    }

    function GetHeader() {

        BaseService.GetHeaderGridView('DealerPaymentDate')
            .then(function (result) {
                $scope.ListHeaderPayment = result
            }, function (error) {
                console.log('Unable to load header data [EstimatePayment]: ' + error.message)
            })

        var sendData = [{
            'TableName1': 'DealerCampaignList'
            , 'TableName2': 'DealerFleetList'
            , 'TableName3': 'RsModelPay'
            , 'TableName4': 'IncentiveModelList'
            , 'TableName5': 'RptDealerDemoCar'
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
                $scope.ListDetailHeader = result.Table2;
                $scope.HeaderPercent = result.Table3;
                $scope.ListHeader4 = result.Table4;

                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });


        BaseService.GetHeaderGridView('ScModelPay')
            .then(function (result) {
                $scope.ScListDetailHeader = result
            }, function (error) {
                console.log('Unable to load header data [ScModelPay]:  ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null }];
        var data = BaseService.ConvertParam(sendData[0]);
        BizDataService.GetEstimatedPayment().then(function (result) {
            $scope.ListDetailPayment = result;
        }, function (error) {
            console.log('Unable to load MSRP data: ' + error.message)
        })
    }

    function GetDataList() {

        if ($scope.PAYMENT_DATE == '') {
            return;
        }
        $scope.ListInfo = {};
        $scope.ListDetail = {};
        var sendData = [{ "PAYMENT_DATE": $scope.PAYMENT_DATE }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, 'GetDealerPaymentDate', data)
            .then(function (result) {
                $scope.ListInfo1 = result.Table;
                $scope.ListInfo2 = result.Table1;
                $scope.ListInfo3 = result.Table2;
                $scope.ListInfo4 = result.Table3;
                $scope.ListInfo5 = result.Table4;

                var sumUnit = 0;
                for (var idx in $scope.ListInfo3) {
                    sumUnit = sumUnit + $scope.ListInfo3[idx]['AMOUNT'];
                }
                $scope.incTotal = sumUnit;

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetDetail() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, $scope.FnName + '_Detail', data)
            .then(function (result) {
                $scope.ListDetail = result;

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (row) {
        $scope.selectedID = row.ID;
        $scope.PAYMENT_DATE = row.PAY_DATE;
        GetDataList();
    }

    $scope.Close_ChassisModal = function (ID) {
        document.getElementById('ChassisModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, { CHASSIS_NO: $scope.FILTER.CHASSIS_NO, MODEL_CODE: $scope.FILTER.MODEL_CODE });

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.openMonth = function () {
        $scope.popupMonth.opened = true;
    };
    $scope.popupMonth = {
        opened: false,
    };
    $scope.RecReport_Click = function (RptNo) {
        var reportCode;
        var reportName;
        switch (RptNo) {
            case 1:
                reportCode = 'VME_Rpt_DLR_Receipt_Campaign_Summary';
                reportName = 'รายงานสรุปยอดเงินแคมเปญส่งเสริมการขาย (Campaign)';
                break;
            case 2:
                reportCode = 'VME_Rpt_DLR_Receipt_Fleet_Summary';
                reportName = 'รายงานสรุปยอดเงินการขายฟลีท (Fleet)';
                break;
            case 3:
                reportCode = 'VME_Rpt_DLR_Receipt_Incentive_Summary';
                reportName = 'รายงานสรุปยอดเงินบรรลุเป้าหมายการขาย (Incentive)';
                break;
            case 4:
                reportCode = 'VME_Rpt_DLR_Receipt_DemoCar_Summary';
                reportName = 'รายงานสรุปยอดเงินรถยนต์ทดลองขับ (Demo car)';
                break;
            case 5:
                reportCode = 'VME_Rpt_DLR_Receipt_CQ_Summary';
                reportName = 'รายงานสรุปยอดเงินผลการประเมินคุณภาพ (Customer Quality)';
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.PAYMENT_DATE + '&p2=' + $scope.OutletID + '&p3=' + reportName, '_blank');
    }
    $scope.Report_Click = function (RptNo) {
        var reportCode;
        var reportName;

        switch (RptNo) {

            case 1:
                reportCode = 'VME_Rpt_DLR_Payment_Campaign_Detail';
                reportName = 'รายงานสรุปการชำระเงินแคมเปญส่งเสริมการขาย (Campaign)';
                break;
            case 2:
                reportCode = 'VME_Rpt_DLR_Payment_Fleet_Detail';
                reportName = 'รายงานสรุปการชำระเงินการขายฟลีท (Fleet)';
                break;

            case 3:
                reportCode = 'VME_Rpt_DLR_Payment_INC_Detail';
                reportName = 'รายงานสรุปการชำระเงินบรรลุเป้าหมายการขาย (Incentive)';
                break;
            case 4:
                reportCode = 'VME_Rpt_DLR_Payment_DemoCar_Detail';
                reportName = 'รายงานสรุปการชำระเงินรถยนต์ทดลองขับ (Demo car)';
                break;
            case 5:
                if ($scope.ListInfo5[0].DATA_MONTH < $scope.CQ_MIGRATE_DATAMONTH) {
                reportCode = 'VME_Rpt_DLR_Payment_CQ_Detail';
                } else {
                    reportCode = 'VME_Rpt_DLR_Payment_VDM_Detail';
                }
                reportName = 'รายงานสรุปการชำระเงินผลการประเมินคุณภาพ (Customer Quality)';
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.PAYMENT_DATE + '&p2=' + $scope.OutletID + '&p3=' + reportName, '_blank');

    }

    $scope.ExReport_Click = function (RptNo) {
        var reportCode;
        var reportName;
        switch (RptNo) {
            case 1:
                reportCode = 'VME_Rpt_DLR_Payment_Campaign_Detail';
                reportName = 'รายงานสรุปการชำระเงินแคมเปญส่งเสริมการขาย (Campaign)';
                break;
            case 2:
                reportCode = 'VME_Rpt_DLR_Payment_Fleet_Detail';
                reportName = 'รายงานสรุปการชำระเงินการขายฟลีท (Fleet)';
                break;
            case 3:
                reportCode = 'VME_Rpt_DLR_Payment_INC_Detail';
                reportName = 'รายงานสรุปการชำระเงินบรรลุเป้าหมายการขาย (Incentive)';
                break;
            case 4:
                reportCode = 'VME_Rpt_DLR_Payment_DemoCar_Detail';
                reportName = 'รายงานสรุปการชำระเงินรถยนต์ทดลองขับ (Demo car)';
                break;
            case 5:
                reportCode = 'VME_Rpt_DLR_Payment_CQ_Detail';
                reportName = 'รายงานสรุปการชำระเงินผลการประเมินคุณภาพ (Customer Quality)';
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&ExportName=' + reportCode + '_' + $scope.PAYMENT_DATE + '&rc=' + reportCode + '&p1=' + $scope.PAYMENT_DATE + '&p2=' + $scope.OutletID + '&p3=' + reportName, '_blank');
    }
    $scope.ShowPaymentCondition = function (PaymentSection, obj) {
        if (PaymentSection == 1) {
            return obj != '' && obj != null;
        } else if (PaymentSection == 2) {
            return obj != '' && obj != null;
        } else if (PaymentSection == 3) {
            return obj != '' && obj != null && obj[0].UNIT != 0 && obj.lengh != 1;
        } else if (PaymentSection == 4) {
            return obj != '' && obj != null;
        } else if (PaymentSection == 5) {
            return obj != '' && obj != null && obj[0].UNIT && obj[0].UNIT > 0;
        }
    }

}])

app.controller("DealerSalesAreaController", ['$scope', 'DEALER_PATH', 'SYSTEM_PATH', 'INCENTIVE_PATH', 'BaseService', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, DEALER_PATH, SYSTEM_PATH, INCENTIVE_PATH, BaseService, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {

    Opening();
    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true)
    }
    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
    }
    $scope.Report_Click = function (ReportNo) {
        switch (ReportNo) {
            case 'report0':
                $scope.reportCode = 'VME_Dealer_Tracking';
                $scope.reportName = 'รายงานสรุปการเลือกแคมเปญ'
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
    }
}])

app.controller("SurveyController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("SurveyList1")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(CONFIG_PATH, "GetSurveyList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        var sendData = [{ "ID": 0 }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "AddSurvey", data)
            .then(function (result) {
                GetData();
                BaseService.Message.info("Successfully add new.");
            }, function (error) {
                console.log('Unable to AddSurvey: ' + error.message)
            })
    }

    $scope.Edit_Submit = function (itemID) {
        let data = BaseService.ConvertParam($scope.formData)
        BaseService.CallAction(CONFIG_PATH, "UpdateSurvey", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info("Successfully saved.");
            }, function (error) {
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';

        var sendData = { "ID": ID };
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CONFIG_PATH, 'GetSurveyInfo', data)
            .then(function (result) {
                $scope.formData = result[0];
                console.log(result[0]);
            }, function (error) {
                console.log('Unable to GetSurveyInfo: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])
