﻿app.controller("SaleAreaMainController", ['$scope', 'BaseService', 'DEALER_PATH', 'CONFIG_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEALER_PATH, CONFIG_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.DealerCond = "DealerList";
        GetHeader();
        GetData();

        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        // GetHeader();
        GetData2();
    }

    $scope.GetData = function () {
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView($scope.DealerCond)
            .then(function (result) {
                $scope.ListHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
	    
	      BaseService.GetHeaderGridView("DmcOutletConfig")
            .then(function (result) {
                $scope.ListHeader2 = result;
            }, function (error) {
                console.log('Unable to load DmcOutletConfig header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "Zone": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, "GetDealerListByZone", data)
            .then(function (result) {
                $scope.ListDealer = result;
                $scope.SelectedDealer = (sessionStorage.DealerZone) ? JSON.parse(sessionStorage.DealerZone) : '';
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (item) {

        var sendData = [{ "ID": item.HEAD_DEALER_ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, "ChangeActiveDealer", data)
            .then(function (result) {
                sessionStorage.DealerZone = JSON.stringify($scope.SelectedDealer);
                GetData2();
            }, function (error) {
                console.log('Unable to ChangeActiveDealer : ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    //------------------- Dealer section -------------------

    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        GetData2();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthNameTH($scope.periodMonth);
        GetData2();
    }

    function GetData2() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEALER_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListLeasingVolume = result.Table1;
                $scope.ListInsuranceVolume = result.Table2;
                $scope.ListDetail = result.Table3;
                $scope.ListCmpStatus = result.Table4;
                $scope.ListAllFleetStatus = result.Table5;
                $scope.ListAllDemoCarStatus = result.Table6;
                $scope.ListDemoCarStatus = result.Table7;
            }, function (error) {
                console.log('Unable to load campaign dashboard data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])



app.controller("DemoCarMainController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        // GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.ListAccrue = result.Table2;
                $scope.ListPayment = result.Table3;
                $scope.ListReconcile = result.Table4;
                $scope.ListPayment2 = result.Table5;
            }, function (error) {
                console.log('Unable to load fleet dashboard data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("DemocarDealerController", ['$scope', 'BaseService', 'BizDataService', 'DEMOCAR_PATH', 'REPORT_PATH', 'Upload', '$timeout', function ($scope, BaseService, BizDataService, DEMOCAR_PATH, REPORT_PATH, Upload, $timeout) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.year = date.getFullYear();
        GetHeader();
        $scope.formData = {};

        $scope.$watch('year', function (value) {
            GetData();
        });
     
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.year) == 'undefined') {
            return;
        }
        GetData();
    }


    function GetHeader() {
        BaseService.GetHeaderGridView("DmcOutletConfig")
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load DmcOutletConfig header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "FY": $scope.year.fullYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        var fnCall = '';
        fnCall = "GetOutletList"; 
        fnCall = "GetOutletResult"; 
        BaseService.CallAction(DEMOCAR_PATH, "GetOutletList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetDealerList data: ' + error.message)
            })
    }


    $scope.Edit_Submit = function () {

        let data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(DEMOCAR_PATH, "SaveOutletConfig", data)
            .then(function (result) {
                GetData();
                document.getElementById('DetailModal').style.display = 'none';
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (row) {
        $scope.formData = row;    
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    

    $scope.Download_Click = function () {
        window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=OutletConfig&rc=Rpt_DMC_Outlet_Config&p1=' + $scope.year.fullYear, '_blank');

    }

    $scope.Download_Click2 = function () {    
        window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=OutletResultg&rc=Rpt_DMC_Outlet_Result&p1=' + $scope.year.fullYear, '_blank');

    }

    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + DEMOCAR_PATH + '/UploadDemoCarConfig',
                    data: { File: file, fy: $scope.year.fullYear },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved").then(function () {
                            $scope.fileUpload = null;
                            $scope.ViewData_Click();
                        })
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }
}])

app.controller("DemocarModelConfigController", ['$scope', 'BaseService', 'DEMOCAR_PATH', '$filter', 'Upload', '$timeout', function ($scope, BaseService, DEMOCAR_PATH, $filter, Upload, $timeout) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = { "MODEL_NAME": '' };
        $scope.panel = [];
        $scope.popupStartDate = [];
        $scope.popupEndDate = [];
        $scope.format = 'd!-MMM-yy'; // 101 = mm/dd/yyyy
        $scope.ViewMode = 1;
        $scope.periodID = null;
        $scope.ListHeader = null;
        $scope.GroupHeader = null;
        $scope.ListDetailGroupList = null;
        GetHeader();
        GetHeader2();
        GetModelHeaderList();
        GetModelList();
        GetData();
    }

    //$scope.ModelBaseView_Click = function () {
    //    getModelList($scope.ProgramID, $scope.filter.BASE_MODEL);
    //}

    $scope.GetData = function () {
        
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("DemoCarModelList")
            .then(function (result) {
                $scope.GroupHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load DemoCarModelList header data: ' + error.message)
            })
    }

    function GetHeader2() {
        BaseService.GetHeaderGridView("DemoCarModelListInside")
            .then(function (result2) {
                $scope.GroupInsideHeader = result2
            }, function (error) {
                console.log('Unable to load DemoCarModelList header data: ' + error.message)
            })
    }
    function GetData() {

        var sendData = [{ "CURRENT_PERIOD_ID": ($scope.periodID) ? $scope.periodID : 0 }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoModelGroupList", data)
            .then(function (result) {
                $scope.ListDetailGroupList = result;
                if (typeof (result[0]) != 'undefined') {
                    $scope.periodID = result[0].PERIOD_ID;
                    $scope.periodDisable = (result[0].REVIEW_STATUS == 'Approved' || result[0].REVIEW_STATUS == 'Send') ? true : false;
                }
            }, function (error) {
                console.log('Unable to load DemoModelGroupList data: ' + error.message)
            })
    }
    $scope.ShowGroup_Click = function (MODELGROUP_ID) {
        document.getElementById('GroupModal').style.display = 'block';
        $scope.filter = {};
        $scope.filter2 = {};
        $scope.filter3 = {};
        $scope.selector = [];
        $scope.remover = [];
        GetSelectedList('ShowDataInGroup',MODELGROUP_ID);
        GetNotSelectedList('ShowDataInGroup',MODELGROUP_ID);
        $scope.Mode = 1;
        BaseService.GetDataTableByParam(DEMOCAR_PATH, "GetDemoCarModelByID", MODELGROUP_ID, { id: MODELGROUP_ID })
            .then(function (result) {
                $scope.Group = result[0]
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }
    $scope.Download_Click = function () {

        //window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&rc=FLT01&p1=' + $scope.FleetModelList[0].PERIOD_ID + '&p2=' + $scope.FleetModelList[0].PROGRAM_ID, '_blank');
    }
    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;
                $scope.fileName = file.name;
                file.upload = Upload.upload({
                    url: window.location.origin + DEMOCAR_PATH + '/UpdateDemoCarConfig',
                    data: { File: file },
                });
                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved");
                        //$scope.ViewModelDetail_Click($scope.ProgramID);
                        $scope.fileUpload = null;
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });
            })
        }
    }

    $scope.AddMode_Click = function () {
        $scope.Mode = 2;       
        $scope.filter3.MODEL_CODE = '';
        $scope.filter3.MODEL_NAME = '';
    }

    $scope.ShowMode_Click = function () {
        $scope.Mode = 1;
    }


    $scope.TogglePanel = function (ID) {
        const panelHeadElement = document.getElementById('panelheading_' + ID);
        const panelBodyElement = document.getElementById('panelbody_' + ID);

        $scope.panel[ID] = !$scope.panel[ID];

    }

    $scope.SaveDemoModel_Submit = function (dataRow, rowID) {

    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    // ----------------- Group --------------------
    $scope.DeleteGroup_Click = function () {        
        BaseService.Message.confirm("Would you like to remove this group?").then(function () {
            var data = BaseService.ConvertParam($scope.Group)
            BaseService.CallAction(DEMOCAR_PATH, "DeleteDemocarGroup", data)
                .then(function (result) {
                    GetData();
                    document.getElementById('GroupModal').style.display = 'none';
                })
        })
    }
    $scope.AddNewGroup_Click = function () {
        document.getElementById('GroupModal').style.display = 'block';
        $scope.filter = {};
        $scope.Group = {};
        $scope.Group.MODELGROUP_ID = 0;
        $scope.selector = [];
        $scope.remover = [];
        var MODELGROUP_ID = 0;
        GetSelectedList("new", MODELGROUP_ID);
        GetNotSelectedList("new", MODELGROUP_ID);
        $scope.Mode = 1;
        $scope.periodDisable = false;
    }

    $scope.SaveGroup_Click = function () {

        if ($scope.Group.MODELGROUP_NAME == null || $scope.Group.MODELGROUP_NAME == "")
        {
            BaseService.Message.info('Model group Cannot Empty');
            return;
        }
        if ($scope.Group.MODELGROUP_NO == null || $scope.Group.MODELGROUP_NO == "") {
            BaseService.Message.info('No Cannot Empty');
            return;
        }
        if ($scope.Group.MIN_HOLDING == null || $scope.Group.MIN_HOLDING == "") {
            BaseService.Message.info('Min holding Cannot Empty');
            return;
        }
        if ($scope.Group.MAX_HOLDING == null || $scope.Group.MAX_HOLDING == "") {
            BaseService.Message.info('Max holding Cannot Empty');
            return;
        }
        $scope.Group.ModelID = [];

        $scope.SelectedList.forEach(function (itemList) {
            const itemListID = '\'\''
                + ((itemList.SALES_END_ITEM != null) ? itemList.SALES_END_ITEM : '')
                + ((itemList.OPTION_CODE != null) ? itemList.OPTION_CODE : '')
                + '\'\'';
            $scope.Group.ModelID.push(itemListID);
        })

        $scope.Group.PERIODID = ($scope.periodID) ? $scope.periodID : 0; 
        var data = BaseService.ConvertParam($scope.Group, "ModelID");

        BaseService.CallAction(DEMOCAR_PATH, "SaveDemoCarModelGroup", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                $scope.filter = { "MODEL_NAME": '' };
                BaseService.Message.info('Successfully saved');
            })
    }

    $scope.ToggleToSelector = function (thisItem) {

        const thisItemID = ((thisItem.SALES_END_ITEM != null) ? thisItem.SALES_END_ITEM : '')
            + ((thisItem.OPTION_CODE != null) ? thisItem.OPTION_CODE : '');

        let thisElement = document.getElementById(thisItemID);


        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.ToggleToRemover = function (thisItem) {

        const thisItemID = ((thisItem.SALES_END_ITEM != null) ? thisItem.SALES_END_ITEM : '')
            + ((thisItem.OPTION_CODE != null) ? thisItem.OPTION_CODE : '');

        let thisElement = document.getElementById(thisItemID);

        if (!thisElement.classList.contains("selected")) {
            $scope.remover.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.remover.splice($scope.remover.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.AddModel_Click = function () {
        $scope.selector.forEach(function (item) {
            let thisItem = $filter('filter')($scope.NotSelectedList, $scope.ModelIDFilter(item))[0];
            let thisIndex = $scope.NotSelectedList.indexOf(thisItem);

            $scope.SelectedList.push(thisItem);
            $scope.NotSelectedList.splice(thisIndex, 1);
        })
        $scope.selector = [];

        $scope.Mode = 1;
    }

    $scope.RemoveModel_Click = function () {
        $scope.remover.forEach(function (item) {
            let thisItem = $filter('filter')($scope.SelectedList, $scope.ModelIDFilter(item))[0];
            let thisIndex = $scope.SelectedList.indexOf(thisItem);

            $scope.NotSelectedList.push(thisItem);
            $scope.SelectedList.splice(thisIndex, 1);
        })
        $scope.remover = [];
    }

    $scope.AddAllLeft_Click = function () {
        const AllItem = $filter('filter')($scope.NotSelectedList, $scope.filter3);

        AllItem.forEach(function (thisItem) {
            let thisIndex = $scope.NotSelectedList.indexOf(thisItem);

            $scope.SelectedList.push(thisItem);
            $scope.NotSelectedList.splice(thisIndex, 1);
        })
        $scope.Mode = 1;
    }

    $scope.AddAllRight_Click = function () {
        const AllItem = $scope.SelectedList;

        for (var i = AllItem.length - 1; i >= 0; i--) {
            $scope.NotSelectedList.push($scope.SelectedList.pop());
        }
    }

    $scope.ModelIDFilter = function (item) {
        return function (input) {
            return (((input.SALES_END_ITEM != null) ? input.SALES_END_ITEM : '') + ((input.OPTION_CODE != null) ? input.OPTION_CODE : '')) === item
        }
    }

    $scope.NotSelectedRowClass = function (row) {

        const thisItemID = ((row.SALES_END_ITEM != null) ? row.SALES_END_ITEM : '')
            + ((row.OPTION_CODE != null) ? row.OPTION_CODE : '');

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = ((row.SALES_END_ITEM != null) ? row.SALES_END_ITEM : '')
            + ((row.OPTION_CODE != null) ? row.OPTION_CODE : '');

        if ($scope.remover.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    //------------------- Group popup ------------------------------
    function GetModelHeaderList() {
        BaseService.GetHeaderGridView("DemoCarModelConfig")
            .then(function (result) {
                $scope.ModelHeaderList = result
            }, function (error) {
                console.log('Unable to load ModelListHeader data: ' + error.message)
            })
    }

    function GetSelectedList(type, ModelGroup_ID) {
        var sendData = [{
            "CURRENT_PERIOD_ID": ($scope.periodID) ? $scope.periodID : 0
            , "TYPE": type
            , "MODELGROUP_ID": ModelGroup_ID
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        $scope.SelectedList = [];
        BaseService.CallAction(DEMOCAR_PATH, "GetDemoModelSelectedList", data)
            .then(function (result) {
                $scope.SelectedList = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetNotSelectedList(type,ModelGroup_ID) {
        var sendData = [{
            "CURRENT_PERIOD_ID": ($scope.periodID) ? $scope.periodID : 0
            , "TYPE": type
            , "MODELGROUP_ID": ModelGroup_ID
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoModelNotSelectedList", data)
            .then(function (result) {
                $scope.NotSelectedList = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetModelList() {
        BaseService.GetDataTable(DEMOCAR_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }
}])

app.controller("DemoCarResultController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.selector = [];
        $scope.selectedModel = [];
        $scope.format = 'd!-MMM-yy';
        $scope.DATE_FROM = new Date()
        $scope.DATE_TO = new Date()
        $scope.KEY_PLAN = 'Y';
        $scope.democarBulletin = {};
        $scope.formDataRightSide = {};
        // GetRetailSalesMonth();
        GetHeader();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DemoCarResultList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.selector = [];
        $scope.selectedModel = [];
        var sendData = [{
            "DATE_FROM": $scope.DATE_FROM,
            "DATE_TO": $scope.DATE_TO,
            "KEY_PLAN": $scope.KEY_PLAN
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarSummaryResult", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetDemoCarSummaryResult data: ' + error)
            })
    }

    $scope.ViewData_Click = function () {
        $scope.FILTER = {};
        GetData();
    }

    $scope.Selected_Change = function () {
        if ($scope.selectPayment == 'Accept') {
        } else if ($scope.selectPayment == 'Reject') {
            $scope.democarBulletin = {};
            $scope.formData.BULLETIN_ID = 0;
            $scope.formData.PAYMENT1 = 0;
            $scope.formData.PAYMENT2 = 0;
            $scope.formData.MIN_HOLDING = 0;
            $scope.formData.MAX_HOLDING = 0;
        } else {
            $scope.democarBulletin = {};
            $scope.formData.BULLETIN_ID = 0;
            $scope.formData.PAYMENT1 = 0;
            $scope.formData.PAYMENT2 = 0;
            $scope.formData.MIN_HOLDING = 0;
            $scope.formData.MAX_HOLDING = 0;
        }
    }
    $scope.DataMonth_Change = function () {
        $scope.ViewData_Click();
    }

    $scope.ShowItem_Click = function (obj) {
        document.getElementById('DetailModal').style.display = 'block';
        $scope.selectPayment = 'Reject';
        $scope.democarBulletin = {};
        $scope.formDataRightSide = {};
        $scope.UNIT = null;
        $scope.DEALERQUOTA = null;

        var sendData = [{
            "DATE_FROM": $scope.DATE_FROM,
            "DATE_TO": $scope.DATE_TO,
            "CHASSIS_NO": obj.CHASSIS_NO,
            "DEALER_ID": obj.DEALER_ID,
            "BASE_MODEL": obj.BASE_MODEL
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        data1 = BaseService.ConvertParam({ "MODEL_CODE": obj.MODEL_CODE, "CHASSIS_NO": obj.CHASSIS_NO });

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarBulletin", data1)
            .then(function (result) {
                $scope.bulletinList = result;

                BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarResult", data)
                    .then(function (result) {
                        $scope.formData = result.Table[0];
                        $scope.BulletinShow = ($scope.formData.PAYMENT_FLAG == 'N' || $scope.formData.PAYMENT_FLAG == 'A');

                        $scope.selectPayment = ($scope.formData.ACCEPTABLEPAYMENT == 'Accept') ? 'Accept' : 'Reject';
                        $scope.UNIT = result.Table1[0].ROW_COUNT;

                        if ($scope.formData.BULLETIN) {
                            $scope.democarBulletin = $filter('filter')($scope.bulletinList, { PERIOD_NAME: $scope.formData.BULLETIN }, true)[0]
                        }

                    }, function (error) {
                        console.log('Unable to load GetDemoCarResult data: ' + error.message)
                    })
            }, function (error) {
                console.log('Unable to load GetDemoCarBulletin data: ' + error.message)
            })


    }

    $scope.Save_InActionEdit = function () {

        //--------------------------------------               DATA             ----------------------------------------------------------        
        if ($scope.selectPayment == 'Accept' && ($scope.democarBulletin == null || !$scope.democarBulletin.ID)) {
            BaseService.Message.alert('Please select Bulletin');
            return;
        }

        $scope.formData.ACCEPTABLEPAYMENT = $scope.selectPayment

        var data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(DEMOCAR_PATH, "SaveDMCSummaryDetail", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.ToggleSelector = function (thisItem) {

        const thisItemID = thisItem.CHASSIS_NO;

        let thisElement = document.getElementById(thisItemID);


        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
            $scope.selectedModel.push(thisItem.MODEL_CODE);
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            $scope.selectedModel.splice($scope.selectedModel.indexOf(thisItem.MODEL_CODE), 1);
            thisElement.classList.remove("selected");
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.selectDeselectAll = function (isSelect) {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());

        filteredItems.forEach(function (item) {
            let thisElement = document.getElementById(item.CHASSIS_NO);
            if (isSelect && !thisElement.classList.contains("selected")) {
                $scope.selector.push(item.CHASSIS_NO);
                thisElement.classList.add("selected");
                $scope.selectedModel.push(item.MODEL_CODE);
            } else if (!isSelect && thisElement.classList.contains("selected")) {
                $scope.selector.splice($scope.selector.indexOf(item.CHASSIS_NO), 1);
                $scope.selectedModel.splice($scope.selectedModel.indexOf(item.MODEL_CODE), 1);
                thisElement.classList.remove("selected");
            }
        })
    }

    $scope.filterItem = function () {

        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            return filterResult;
        }
    }

    $scope.isOneModelSelected = function (obj) {
        let returnArray = $filter('uniqueArray')(obj);
        return (returnArray.length === 1)
    }

    $scope.GetBullatinList = function (MODELCODE) {
        $scope.democarBulletin = {};

        data = BaseService.ConvertParam({ "MODEL_CODE": MODELCODE });

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarBulletin", data)
            .then(function (result) {
                $scope.bulletinList = result;
            }, function (error) {
                console.log('Unable to load GetDemoCarBulletin data: ' + error.message)
            })
    }

    $scope.BullatinChange = function (obj, CHASSIS) {
        var sendData = [{
            "PERIODID": $scope.democarBulletin.ID,
            "CHASSIS_NO": CHASSIS
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarResultBullatinChange", data)
            .then(function (result) {  
                $scope.formDataRightSide = result.Table[0];
                $scope.formData.BULLETIN_ID = $scope.democarBulletin.ID;
                $scope.formData.PAYMENT1 = $scope.formDataRightSide.PAYMENT1;
                $scope.formData.PAYMENT2 = $scope.formDataRightSide.PAYMENT2;
                $scope.formData.MIN_HOLDING = $scope.formDataRightSide.MIN_HOLDING;
                $scope.formData.MAX_HOLDING = $scope.formDataRightSide.MAX_HOLDING;
            }, function (error) {
                BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load get Demo car result data: ' + error.message)
            })
    }

    $scope.SaveBullatin = function () {

        var data = BaseService.ConvertParam({
            "CHASSIS_NO": "''" + $scope.selector.join("'',''") + "''",
            "MONTHLY_PROGRAM_ID": $scope.democarBulletin.MONTHLY_PROGRAM_ID,
            "ONTOP_FLAG": $scope.formData.ONTOP_FLAG
        }, "CHASSIS_NO");

        BaseService.CallAction(DEMOCAR_PATH, "SaveBullatin", data)
            .then(function (result) {
                //document.getElementById('GroupModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit bullatin data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        // document.getElementById('GroupModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("PeriodDemoCarController", ['$scope', 'BaseService', 'DEMOCAR_PATH', function ($scope, BaseService, DEMOCAR_PATH) {

    Opening();


    function Opening() {
        $scope.formData = {};
        $scope.periodDisable = false;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("PeriodCampaignList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(DEMOCAR_PATH, "GetPeriodDMCList")
            .then(function (result) {
                $scope.ListDetail = result

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.formData = {};
        $scope.formData.ID = 0;
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.Add_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning('Announce cannot empty.'); /*Tidtee edit 12/09/2017*/
            return;
        }

        if ($scope.formData.START_DATE == null || $scope.formData.START_DATE == '' ||
            $scope.formData.END_DATE == null || $scope.formData.END_DATE == '') {
            BaseService.Message.warning('The Start date and End date cannot empty.');
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date"); /*Tidtee edit 12/09/2017*/
            return;
        }

        var data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(DEMOCAR_PATH, "AddPeriodDemoCar", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved.');
            })


    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning('Announce cannot empty.'); /*Tidtee edit 12/09/2017*/
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date");
            return;
        }

        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(DEMOCAR_PATH, "EditDMCPeriod", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved.');
            }, function (error) {
             
            })

    }

    $scope.ShowItem_Click = function (ID) {
        $scope.formData.ID = ID;
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(DEMOCAR_PATH, "GetPeriodDMCList", ID, { id: ID })
            .then(function (result) {
                $scope.formData = result[0]
                $scope.periodDisable = (result[0].REVIEW_STATUS == 'Approved' || result[0].REVIEW_STATUS == 'Send') ? true : false;
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.Approve_Submit = function (obj, type) {

        BaseService.Message.confirm("Would you like to \"" + type + "\" " + obj.PERIOD_NAME + "?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj.ID, "TYPE": type, "PERIOD_NAME": obj.PERIOD_NAME });

            BaseService.CallAction(DEMOCAR_PATH, "ApproveSubmit", data)
                .then(function (result) {
                    GetData();
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }
    //NEW
    $scope.SendPeriod = function (obj, type) {

       
        BaseService.Message.confirm("Would you like to \"" + type + "\" " + obj.PERIOD_NAME + " for approve?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj.ID, "TYPE": type, "PERIOD_NAME": obj.PERIOD_NAME });

            BaseService.CallAction(DEMOCAR_PATH, "Send_Period", data)
                .then(function (result) {
                    GetData();
                }, function (error) {
                    console.log('Unable to submit send period: ' + error.message);
                })
        })
    }
    //NEW
}])

app.controller("DemoCarAccrueController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        GetHeader();
        InitailDataModel();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('ModelDemoCarAccrueSummary')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {

            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDMCAccrueSummary", data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;

                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];
            }, function (error) {
                console.log('Unable to load GetDMCAccrueSummary: ' + error.message)
            })
        BaseService.CallAction(DEMOCAR_PATH, "GetDemoAccrueHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetDemoAccrueHistory: ' + error.message)
            })

        if ($scope.ViewChassis == 1) {

            $scope.ModelHeader = $scope.ModelHeader4;
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
            var data = BaseService.ConvertParam(sendData[0]);
            BaseService.CallAction(DEMOCAR_PATH, 'GetDemoCarAccrueAll', data)
                .then(function (result) {
                    $scope.DetailData1 = result;

                }, function (error) {
                    console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
                })
        }
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
    }

    $scope.Accrue_Submit = function (status) {
        var confirmType;
        var submittype;

        switch (status) {
            case 'Accrue':
                confirmType = 'submit accrue';
                submittype = 'submitted';
                break;

            case 'AccrueApprove':
                confirmType = '"Approve" accrue';
                submittype = 'approved';
                break;

            case 'AccrueReturn':
                confirmType = '"Return" accrue';
                submittype = 'returned';
                break;

            case 'MSControlApprove':
                confirmType = '"Approve" accrue';
                submittype = 'approved';
                break;

            case 'MSControlReturn':
                confirmType = '"Return" accrue';
                submittype = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + " for this month?").then(function () {
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "STATUS": status, "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH)  }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(DEMOCAR_PATH, "SubmitAccrue", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submittype + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load GetAccruePayment: ' + error.message)
                })
        })

    }


    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelDemoCarAccrueSummary';
        $scope.DVM_ACCRUE_TableName2 = '';
        $scope.DVM_ACCRUE_TableName3 = '';
        $scope.DVM_ACCRUE_TableName4 = 'RptDemoCarAccrueDetail';
        $scope.DVM_ACCRUE_TableName5 = '';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetDMCAccrueSummary';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        $scope.SubSection = 0;
        //  $scope.SubmitStatus = row;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;


        $scope.ModelHeader = $scope.ModelHeader4;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, 'GetDemoCarAccrueAll', data)
            .then(function (result) {
                $scope.DetailData1 = result;

            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode = '';
        var reportID = '';
        var reportName = '';

     

        if (ReportNo == 'report0') {
            if ($scope.SubmitStatus.APPROVE_ACCRUE == null) {
                reportCode = 'VME_Rpt_DMC_Accrue_Summary';//[sp_Rpt_DMC_Accrue_Detail]
                reportID = 47;
                reportName = 'Demo car - Summary';
            } else {
                reportCode = 'VME_Rpt_DMC_Accrue_Summary';//[sp_Rpt_DMC_Accrue_Detail]
                reportID = 48;
                reportName = 'Accrue for demo car - Detail';
            }
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + reportName, '_blank');

        }
        else if (ReportNo == 'report1') {
            if ($scope.SubmitStatus.APPROVE_ACCRUE == null) {
                reportCode = 'VME_Rpt_DMC_D1';//[sp_Rpt_DMC_Accrue_Detail]
                reportName = 'Demo car - Detail';
            } else {
                reportCode = 'VME_Rpt_DMC_D1';//[sp_Rpt_DMC_Accrue_Detail]
                reportName = 'Accrue for demo car - Detail';
            }
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
        }
    }


}])

app.controller("DemoCarUploadController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'DEALER_PATH', 'BizDataService', '$filter', 'Upload', '$timeout', function ($scope, BaseService, DEMOCAR_PATH, DEALER_PATH, BizDataService, $filter, Upload, $timeout) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        GetDealerListSelect();
        // GetRetailSalesMonth();
        GetHeader();
        // GetData();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) == 'undefined' || typeof ($scope.periodMonth) == 'undefined') {
            return;
        }

        GetData();
    }

    function GetDealerListSelect() {

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarDealerList")
            .then(function (result) {
                //console.log(result);
                $scope.DealerList = result
            }, function (error) {
                console.log('Unable to load GetDemoCarDealerList data: ' + error)
            })

    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DemoCarDealer')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var year = $scope.periodYear.toString();
        var month = $scope.periodMonth.toString();
        var DATA_MONTH = year + ('0' + month.toString()).substr(-2);//201704
        var sendData = [{ "DATA_MONTH": DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarSelectResult", data)
            .then(function (result) {
                //console.log(result);
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetDemoCarSummaryResult data: ' + error)
            })
    }

    $scope.ShowItem_Click = function (obj) {
        $scope.fileUpload = null;

        $scope.selectChassis = obj.CHASSIS_NO
     
        var sendData = [{ "CHASSIS_NO": obj.CHASSIS_NO }];
        var data = BaseService.ConvertParam(sendData[0]);

        document.getElementById('DetailModal').style.display = 'block';
        $scope.selectPayment = '';
        $scope.formDataRightSide = {};
        
        //BaseService.CallAction(DEMOCAR_PATH, "GetDMCUpload", data)
        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarChassisInfo", data)
            .then(function (result) {
                $scope.formData = result.Table[0];               
             
                $scope.DocNotComplete = ($scope.formData.DOC_FLAG != 'A');
                $scope.selectPayment = ($scope.formData.ACCEPTABLEPAYMENT == 'Accept') ? 'Accept' : 'Reject';

                if ($scope.formData.DOCUMENT_FILE_PATH) {
                    let fileUploadPath = $scope.formData.DOCUMENT_FILE_PATH;
                    let lastPathSign = fileUploadPath.lastIndexOf("/");
                    let fileNameLength = fileUploadPath.length - lastPathSign;

                    $scope.UploadedFileName = fileUploadPath.substr(lastPathSign + 1, fileNameLength);
                }

            }, function (error) {
               // BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetDemoCarUpload data: ' + error.message)
            })

    }

    $scope.Save_Submit = function () {

        var file = this.fileUpload;

        file.upload = Upload.upload({
            url: window.location.origin + DEMOCAR_PATH + '/UploadPaymentDoc',
            data: { 
                File: file, 
                Chassis: $scope.selectChassis, 
                DealerID: $scope.formData.DEALER_CODE,
                DOC_REF: $scope.formData.DOC_REF,
                DOC_DATE: $scope.formData.DOC_DATE
            },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                BaseService.Message.info('Successfully uploaded document').then(function () {
                    $scope.fileUpload = null;
                    $scope.ShowItem_Click($scope.formData);
                    $scope.GetData();
                })
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });

    }

    $scope.Save_InActionEdit = function () {

        var data = BaseService.ConvertParam($scope.formData);

        if ($scope.formData.DOC_DATE == null || $scope.formData.DOC_REF == null) {
            BaseService.Message.alert('Document date and Document ref cannot empty');
            return;
        }
        BaseService.CallAction(DEMOCAR_PATH, "SaveDMCSummaryDetail", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, { CHASSIS_NO: $scope.FILTER.CHASSIS_NO });

        return (filteredItems) ? filteredItems.length : 0;
    }
    

    $scope.openDocDate = function () {
        $scope.popupDocDate.opened = true;
    }

    $scope.popupDocDate = {
        opened: false
    }
}])

app.controller("DemoCarCheckUploadController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.selector = [];
        $scope.selectedModel = [];
        $scope.format = 'd!-MMM-yy';
        $scope.Section = 1;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DemoCarCheckUploadedList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });

    }

    function GetData() {
        $scope.ListDetail = [];

        var DOC_STATUS = '';
     
        if ($scope.Section == 1) {
            DOC_STATUS = 'U';
        } else if ($scope.Section == 2) {
            DOC_STATUS = 'A';
        } else if ($scope.Section == 3) {
            DOC_STATUS = 'I';
        } else if ($scope.Section == 4) {
            DOC_STATUS = 'W';
        } else if ($scope.Section == 5) {
            DOC_STATUS = 'E';
        }

        var sendData = [{ "DOC_STATUS": DOC_STATUS }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarUploadStatus",data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetDemoCarUploadStatus data: ' + error.message)
            });
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.FLEET_NAME) == 'undefined') {
            return;
        }
        $scope.FILTER = {};
        GetData();
    }

    $scope.ShowItem_Click = function (ID) {

        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarChassisInfo", data)
            .then(function (result) {
                $scope.formData = result.Table[0];

                if ($scope.formData.DOCUMENT_FILE_PATH) {
                    let fileUploadPath = $scope.formData.DOCUMENT_FILE_PATH;
                    let lastPathSign = fileUploadPath.lastIndexOf("/");
                    let fileNameLength = fileUploadPath.length - lastPathSign;

                    $scope.UploadedFileName = fileUploadPath.substr(lastPathSign + 1, fileNameLength);
                }
            }, function (error) {
                //BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetDemoCarCheckDocResult data: ' + error.message)
            })
    }

    $scope.Save_Submit = function () {
        
        if($scope.formData.DOC_FLAG=='I' && ($scope.formData.REMARKS=='' || $scope.formData.REMARKS==null)) {
            BaseService.Message.alert("Please fill remark field");
            return;
        }

        let scopeData = $scope.formData;
        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(DEMOCAR_PATH, "Save2ndPayment", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.filterItem = function () {

        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            return filterResult;
        }
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        //document.getElementById('GroupModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.$watch('Section', function (newValue, oldValue) {
        GetHeader();
        GetData();
    }, true);


    $scope.Report_Click = function () {
        switch ($scope.Section) {
            case 1:
                $scope.reportCode = 'VME_Rpt_DMC_Check_ByUploaded';
                $scope.reportName = 'Demo car upload checking - Uploaded';
                $scope.DOC_STATUS = 'U';
                break;
            case 2:
                $scope.reportCode = 'VME_Rpt_DMC_Check_ByUploaded';
                $scope.reportName = 'Demo car upload checking - Completed';
                $scope.DOC_STATUS = 'A';
                break;
            case 3:
                $scope.reportCode = 'VME_Rpt_DMC_Check_ByUploaded';
                $scope.reportName = 'Demo car upload checking - Incompleted';
                $scope.DOC_STATUS = 'I';
                break;
            case 4:
                $scope.reportCode = 'VME_Rpt_DMC_Check_ByUploaded';
                $scope.reportName = 'Demo car upload checking - Waiting';
                $scope.DOC_STATUS = 'W';
                break;
            case 5:
                $scope.reportCode = 'VME_Rpt_DMC_Check_ByUploaded';
                $scope.reportName = 'Demo car upload checking - Expired';
                $scope.DOC_STATUS = 'E';
                break;
            default:
                break;
     
           
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DOC_STATUS + '&p2=' + $scope.reportName, '_blank');
        //window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.DOC_STATUS + '&p3=' + $scope.reportName, '_blank');
    }
}])

app.controller("DemoCarPaymentController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'BizDataService', '$filter','REPORT_PATH', 'SYSTEM_PATH', function ($scope, BaseService, DEMOCAR_PATH, BizDataService, $filter,REPORT_PATH, SYSTEM_PATH) {
    Opening();

    function Opening() {
        $scope.SubSection = 2;
        $scope.ViewSection = 1;
        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SUBMIT_DATE_FILTER = {};
        $scope.PaymentType = '1st';
        $scope.FILTER = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
        InitailDataModel();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DemoCarPayment')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });
        
        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

    }

    function GetData() {
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];

        $scope.$watch('OperationOf', function (value) {
            var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(DEMOCAR_PATH, "GetPayment", data)
                .then(function (result) {

                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListSelected = result.Table2;
                    $scope.SumSelected = result.Table3;

                    if ($scope.OperationOf == 'Manager') {
                        $scope.ListSubmitDate = result.Table4;
                    }
                    if($scope.PAYMENT_ID) { $scope.SubmitStatus = $filter('filter')($scope.ListStatus, {ID: $scope.PAYMENT_ID}, true)[0] }
                    $scope.GetUniqueMonth($scope.ListSelected,'DATA_MONTH');
                    
                }, function (error) {
                    console.log('Unable to load GetPayment: ' + error.message)
                })
        }, true)
    }

    function GetCancelledChassis() {
        $scope.ListDetail = [];
        var sendData = {
            "OPERATION_OF": $scope.OperationOf,
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(DEMOCAR_PATH, 'GetNotPaymentListCancelled', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
            }, function (error) {
                console.log('Unable to load cancelled chassis: ' + error.message);
            })
    }
    function A_GetData() {
        $scope.ViewDetail = false;
        $scope.FILTER = {};
        $scope.A_ViewModel = 'Chassis';
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, 'GetSelectedPayment',data)
            .then(function (result) {
                $scope.A_DVM_ModelData1 = result.Table;
                $scope.A_DVM_ModelData2 = result.Table1;
                $scope.A_DVM_ModelData3 = result.Table2;
                $scope.A_DVM_ModelData4 = result.Table3;
                $scope.A_ViewModel_Change($scope.A_ViewModel);
            }, function (error) {
                console.log('Unable to load GetSelectedPayment: ' + error.message)
            })
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
        if (iChange == 0) {
            GetData();
        } else if (iChange == 1) {
            A_InitailDataModel();         
            A_GetData();          
        } else if (iChange == 3) {
            GetCancelledChassis();
        }

    }

    $scope.FilterOperationItem = function (TargetObject, ObjectToCompare) {
        return (
            ($scope.OperationOf == 'Manager') ?
                $filter('filter')(TargetObject, { ID: ((ObjectToCompare != null && ObjectToCompare.hasOwnProperty('ID') ? ObjectToCompare.ID : null)) }, true) :
                TargetObject
        )
    }

    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        $scope.SelectedChassis.forEach(function (item) {
            chassis.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS");

        BaseService.CallAction(DEMOCAR_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    //BaseService.Message.info("Successfully saved.");
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.SelectAllPayment_Submit = function (type) {
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, "SelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }
    $scope.UnSelectAll_Submit = function () {
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, "UnSelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    A_GetData();
                    GetData();
                }
            }, function (error) {
                console.log("Unable to Unselect all payment:" + error.message);
            })
    }
    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS_NO");

        BaseService.CallAction(DEMOCAR_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    A_GetData();
                    GetData();
                    
                }
            }, function (error) {
                console.log("Unable to remove selected payment:" + error.message);
            })
    }
    $scope.CancelPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }
        BaseService.Message.confirm("Would you like to cancel the payment for selected chassis?").then(function () {
            var chassis = [];
            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
            var data = BaseService.ConvertParam({
                "CHASSIS": chassis,
                "PAYMENT_TYPE": $scope.PaymentType
            }, "CHASSIS");
            BaseService.CallAction(DEMOCAR_PATH, "CancelSelectPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                    }
                }, function (error) {
                    console.log("Unable to cancel payment:" + error.message);
                })
        })
    }
    $scope.UndoCancel_Submit = function (chassis) {
        var data = BaseService.ConvertParam({
            "PAYMENT_TYPE": $scope.PaymentType,
            "CHASSIS": chassis
        })
        BaseService.Message.confirm("Would you like to reverse the cancelled chassis to payment?")
            .then(function () {
                BaseService.CallAction(DEMOCAR_PATH, "UndoCancelledChassis", data)
                    .then(function (result) {
                        if (result == "Done") {
                            BaseService.Message.info("Successfully saved.");
                            GetCancelledChassis();
                        }
                    }, function (error) {
                        console.log("Unable to reverse chassis: " + chassis + ": " + error.message);
                })
        })
    }

    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }


        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.PAYMENT_ID || null),
                "DATA_MONTHS":$scope.data_months
            });

            BaseService.CallAction(DEMOCAR_PATH, "SubmitPayment", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log("Unable to SubmitPayment payment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }

    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;
    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];
        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }
        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }
            (filterResult) ? n++ : null;

            return filterResult;
        }
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.FILTER = {};
        $scope.ViewModel = 'Chassis';
        $scope.PAYMENT_ID = row.ID;
        $scope.SubmitStatus = row;


        var sendData = [{ "PAYMENT_ID": row.ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, 'GetPaymentSubmitByModel', data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;
                $scope.ViewModel_Change($scope.ViewModel);
            }, function (error) {
                console.log('Unable to load GetNonPayment: ' + error.message)
            })
    }


    function InitailDataModel() {
        //---- Data model

        $scope.DVM = {};
        $scope.DVM_TableName1 = 'DemocarPayment1ListByChassis';
        $scope.DVM_TableName2 = 'DemocarPayment1ListByModel';
        $scope.DVM_TableName3 = 'DemocarPayment1ListByDealer';
        $scope.DVM_TableName4 = 'DemocarPayment1ListByOutlet';
        $scope.DVM_TableName5 = 'x';
        GetDataModelHeader();
    }
    function GetDataModelHeader() {
            var sendData = [{ 
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
            }];
            var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
                .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
                }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }
    function A_InitailDataModel() {
        //---- Data model
        $scope.A_DVM = {};
        $scope.A_DVM_TableName1 = 'DemoCarPayment';
        $scope.A_DVM_TableName2 = 'DemocarPayment1ListByModel';
        $scope.A_DVM_TableName3 = 'DemocarPayment1ListByDealer';
        $scope.A_DVM_TableName4 = 'DemocarPayment1ListByOutlet';
        $scope.A_DVM_TableName5 = 'x';
        A_GetDataModelHeader();
    }
    function A_GetDataModelHeader() {
            var sendData = [{ 
            'TableName1': $scope.A_DVM_TableName1
            , 'TableName2': $scope.A_DVM_TableName2
            , 'TableName3': $scope.A_DVM_TableName3
            , 'TableName4': $scope.A_DVM_TableName4
            , 'TableName5': $scope.A_DVM_TableName5
            }];
            var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
                .then(function (result) {
                $scope.A_DVM_ModelHeader1 = result.Table;
                $scope.A_DVM_ModelHeader2 = result.Table1;
                $scope.A_DVM_ModelHeader3 = result.Table2;
                $scope.A_DVM_ModelHeader4 = result.Table3;
                }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }
    $scope.ViewModel_Change = function (ViewModel) {
        $scope.ViewModel = ViewModel;
        switch (ViewModel) {
            case "Chassis":
                $scope.DVM_Data = $scope.DVM_ModelData1;
                $scope.DVM_Header = $scope.DVM_ModelHeader1;
                $scope.GetUniqueMonth($scope.DVM_ModelData1,'DATA_MONTHNAME');
                break;
            case "Model":
                $scope.DVM_Data2 = $scope.DVM_ModelData2;
                $scope.DVM_Header = $scope.DVM_ModelHeader2;
                break;
            case "Dealer":
                $scope.DVM_Data = $scope.DVM_ModelData3;
                $scope.DVM_Header = $scope.DVM_ModelHeader3;
                break;
            case "Outlet":
                $scope.DVM_Data = $scope.DVM_ModelData4;
                $scope.DVM_Header = $scope.DVM_ModelHeader4;
                break;
            default:
                break;
        }
    }

    $scope.A_ViewModel_Change = function (A_ViewModel) {
        $scope.A_ViewModel = A_ViewModel;
        switch ( $scope.A_ViewModel) {
            case "Chassis":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData1;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader1;
                $scope.GetUniqueMonth($scope.A_DVM_ModelData1,'DATA_MONTHNAME');
                break;
            case "Model":
                $scope.A_DVM_Data2 = $scope.A_DVM_ModelData2;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader2;
                break;
            case "Dealer":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData3;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader3;
                break;
            case "Outlet":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData4;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader4;
                break;
            default:
                break;
        }
    }
    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }
    function GetSummary(listData) {
        $scope.sum = {};
        $scope.sumUnit = 0;
        $scope.sumAmount = 0;
        for (var idx in listData) {
            $scope.sumUnit = $scope.sumUnit + listData[idx]['UNIT'];
            $scope.sumAmount = $scope.sumAmount + listData[idx]['AMOUNT'];
        }
    }
    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }
    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }
    $scope.Report_Click = function () {
        if($scope.SubSection==1){
            switch($scope.A_ViewModel){
                case "Chassis":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByChassis';
                    $scope.reportName='Demo car selected 1st payment by chassis';
                break;
                case "Model":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByModel';
                    $scope.reportName='Demo car selected 1st payment by model';
                break;
                case "Dealer":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByDealer';
                    $scope.reportName='Demo car selected 1st payment by dealer';
                break;
                case "Outlet":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByOutlet';
                    $scope.reportName='Demo car selected 1st payment by outlet';
            break;
                default:
                break;
            }
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + 'DemoCar' + '&p2=' + $scope.PaymentType +'&p3='+ $scope.reportName, '_blank'); 
        }
        else if($scope.SubSection==2){
        switch($scope.ViewModel){
            case "Chassis":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByChassis';
                $scope.reportName='Demo car 1st payment by chassis';
            break;
            case "Model":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByModel';
                $scope.reportName='Demo car 1st payment by model';
            break;
            case "Dealer":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByDealer';
                $scope.reportName='Demo car 1st payment by dealer';
            break;
            case "Outlet":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByOutlet';
                $scope.reportName='Demo car 1st payment by outlet';
            break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.PAYMENT_ID + '&p2=' + $scope.PaymentType +'&p3='+ $scope.reportName, '_blank');
        }
    }
    $scope.GetUniqueMonth = function (obj, fieldname) {
        $scope.data_months = '';
        let data_months = '';
        let uniqueDataMonth = $filter('unique')(obj, fieldname);
        uniqueDataMonth.forEach(function (datamonth) {
            data_months = data_months + ',' + datamonth[fieldname];
        })
        $scope.data_months = data_months.substr(1,data_months.length-1);
    }
}])

app.controller("DemoCarPayment2ndController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'BizDataService', '$filter','REPORT_PATH', 'SYSTEM_PATH', function ($scope, BaseService, DEMOCAR_PATH, BizDataService, $filter,REPORT_PATH, SYSTEM_PATH) {
    Opening();

    function Opening() {
        $scope.SubSection = 2;
        $scope.ViewSection = 1;
        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SUBMIT_DATE_FILTER = {};
        $scope.PaymentType = '2nd';
        $scope.FILTER = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
        InitailDataModel();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('DemoCarPayment')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });   

        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    
    }

    function GetData() {
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];
        let data_months = '';
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(DEMOCAR_PATH, "GetPayment2nd", data)
                .then(function (result) {

                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListSelected = result.Table2;
                    $scope.SumSelected = result.Table3;

                    if ($scope.OperationOf == 'Manager') {
                        $scope.ListSubmitDate = result.Table4;
                    }

                    if($scope.PAYMENT_ID) { $scope.SubmitStatus = $filter('filter')($scope.ListStatus, {ID: $scope.PAYMENT_ID}, true)[0] }
                    $scope.GetUniqueMonth($scope.ListSelected,'DATA_MONTH');
                }, function (error) {
                    console.log('Unable to load GetPayment: ' + error.message)
                })
        }, true)
    }

    function GetCancelledChassis() {
        $scope.ListDetail = [];
        var sendData = {
            "OPERATION_OF": $scope.OperationOf,
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(DEMOCAR_PATH, 'GetNotPaymentListCancelled', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
            }, function (error) {
                console.log('Unable to load cancelled chassis: ' + error.message);
            })
    }
    function A_GetData() {
        $scope.ViewDetail = false;
        $scope.FILTER = {};
        $scope.A_ViewModel = 'Chassis';
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, 'GetSelectedPayment',data)
            .then(function (result) {
                $scope.A_DVM_ModelData1 = result.Table;
                $scope.A_DVM_ModelData2 = result.Table1;
                $scope.A_DVM_ModelData3 = result.Table2;
                $scope.A_DVM_ModelData4 = result.Table3;
                $scope.A_ViewModel_Change($scope.A_ViewModel);
            }, function (error) {
                console.log('Unable to load GetSelectedPayment: ' + error.message)
            })
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
        if (iChange == 0) {
            GetData();
        } else if (iChange == 1) {
            A_InitailDataModel();         
            A_GetData();          
        } else if (iChange == 3) {
            GetCancelledChassis();
        }

    }

    $scope.FilterOperationItem = function (TargetObject, ObjectToCompare) {
        return (
            ($scope.OperationOf == 'Manager') ?
                $filter('filter')(TargetObject, { ID: ((ObjectToCompare != null && ObjectToCompare.hasOwnProperty('ID') ? ObjectToCompare.ID : null)) }, true) :
                TargetObject
        )
    }

    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        $scope.SelectedChassis.forEach(function (item) {
            chassis.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS");

        BaseService.CallAction(DEMOCAR_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    //BaseService.Message.info("Successfully saved.");
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.SelectAllPayment_Submit = function (type) {
        //var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, "SelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }
    $scope.UnSelectAll_Submit = function () {
        //var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam({"PAYMENT_TYPE": $scope.PaymentType});
        BaseService.CallAction(DEMOCAR_PATH, "UnSelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    A_GetData();
                    GetData();

                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }
    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS_NO");

        BaseService.CallAction(DEMOCAR_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    A_GetData();
                    GetData();
                    //BaseService.Message.info("Successfully saved.");
                }
            }, function (error) {
                console.log("Unable to RemoveSelectPayment:" + error.message);
            })
    }
    $scope.CancelPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }
        BaseService.Message.confirm("Would you like to cancel the payment for selected chassis?").then(function () {
            var chassis = [];
            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
            var data = BaseService.ConvertParam({
                "CHASSIS": chassis,
                "PAYMENT_TYPE": $scope.PaymentType
            }, "CHASSIS");
            BaseService.CallAction(DEMOCAR_PATH, "CancelSelectPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                    }
                }, function (error) {
                    console.log("Unable to CancelSelectPayment:" + error.message);
                })
        })
    }

    $scope.CancelPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }
        BaseService.Message.confirm("Would you like to cancel the payment for selected chassis?").then(function () {
            var chassis = [];
            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
            var data = BaseService.ConvertParam({
                "CHASSIS": chassis,
                "PAYMENT_TYPE": $scope.PaymentType
            }, "CHASSIS");
            BaseService.CallAction(DEMOCAR_PATH, "CancelSelectPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                    }
                }, function (error) {
                    console.log("Unable to cancel payment:" + error.message);
                })
        })
    }
    $scope.UndoCancel_Submit = function (chassis) {
        var data = BaseService.ConvertParam({
            "PAYMENT_TYPE": $scope.PaymentType,
            "CHASSIS": chassis
        })
        BaseService.Message.confirm("Would you like to reverse the cancelled chassis to payment?")
            .then(function () {
                BaseService.CallAction(DEMOCAR_PATH, "UndoCancelledChassis", data)
                    .then(function (result) {
                        if (result == "Done") {
                            BaseService.Message.info("Successfully saved.");
                            GetCancelledChassis();
                        }
                    }, function (error) {
                        console.log("Unable to reverse chassis: " + chassis + ": " + error.message);
                    })
            })
    }
    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.PAYMENT_ID || null),
                "DATA_MONTHS":$scope.data_months
            });

            BaseService.CallAction(DEMOCAR_PATH, "SubmitPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                        A_GetData();
                 
                        BaseService.Message.info("Successfully "+submitType+".");
                    }
                }, function (error) {
                    console.log("Unable to SubmitPayment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }
    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;
    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];
        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }
        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }

            (filterResult) ? n++ : null;
            
            return filterResult;
        }
    }
    $scope.ViewDetail_Click = function (row) {
        $scope.FILTER = {};
        $scope.ViewDetail = true;
        $scope.ViewModel = 'Chassis';
        $scope.PAYMENT_ID = row.ID;
        $scope.SubmitStatus = row;

        var sendData = [{ "PAYMENT_ID": row.ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, 'GetPayment2ndSubmitByModel', data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;
                $scope.ViewModel_Change($scope.ViewModel);
            }, function (error) {
                console.log('Unable to load GetNonPayment: ' + error.message)
            })
    }
    function InitailDataModel() {
        //---- Data model

        $scope.DVM = {};
        $scope.DVM_TableName1 = 'DemocarPayment2ListByChassis';
        $scope.DVM_TableName2 = 'DemocarPayment2ListByModel';
        $scope.DVM_TableName3 = 'DemocarPayment2ListByDealer';
        $scope.DVM_TableName4 = 'DemocarPayment2ListByOutlet';
        $scope.DVM_TableName5 = 'x';
        GetDataModelHeader();
    }
    function GetDataModelHeader() {
            var sendData = [{ 
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
            }];
            var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
                .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
                }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }
    function A_InitailDataModel() {
        //---- Data model
        $scope.A_DVM = {};
        $scope.A_DVM_TableName1 = 'DemoCarPayment';
        $scope.A_DVM_TableName2 = 'DemocarPayment2ListByModel';
        $scope.A_DVM_TableName3 = 'DemocarPayment2ListByDealer';
        $scope.A_DVM_TableName4 = 'DemocarPayment2ListByOutlet';
        $scope.A_DVM_TableName5 = 'x';
        A_GetDataModelHeader();
    }
    function A_GetDataModelHeader() {
            var sendData = [{ 
            'TableName1': $scope.A_DVM_TableName1
            , 'TableName2': $scope.A_DVM_TableName2
            , 'TableName3': $scope.A_DVM_TableName3
            , 'TableName4': $scope.A_DVM_TableName4
            , 'TableName5': $scope.A_DVM_TableName5
            }];
            var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
                .then(function (result) {
                $scope.A_DVM_ModelHeader1 = result.Table;
                $scope.A_DVM_ModelHeader2 = result.Table1;
                $scope.A_DVM_ModelHeader3 = result.Table2;
                $scope.A_DVM_ModelHeader4 = result.Table3;
                }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }
    $scope.ViewModel_Change = function (ViewModel) {
        $scope.ViewModel = ViewModel;
        switch (ViewModel) {
            case "Chassis":
                $scope.DVM_Data = $scope.DVM_ModelData1;
                $scope.DVM_Header = $scope.DVM_ModelHeader1;
                $scope.GetUniqueMonth($scope.DVM_ModelData1,'DATA_MONTHNAME');
                break;
            case "Model":
                $scope.DVM_Data2 = $scope.DVM_ModelData2;
                $scope.DVM_Header = $scope.DVM_ModelHeader2;
                break;
            case "Dealer":
                $scope.DVM_Data = $scope.DVM_ModelData3;
                $scope.DVM_Header = $scope.DVM_ModelHeader3;
                break;
            case "Outlet":
                $scope.DVM_Data = $scope.DVM_ModelData4;
                $scope.DVM_Header = $scope.DVM_ModelHeader4;
                break;
            default:
                break;
        }
    }
    $scope.A_ViewModel_Change = function (A_ViewModel) {
        $scope.A_ViewModel = A_ViewModel;
        switch ( $scope.A_ViewModel) {
            case "Chassis":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData1;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader1;
                $scope.GetUniqueMonth($scope.A_DVM_ModelData1,'DATA_MONTHNAME');
                break;
            case "Model":
                $scope.A_DVM_Data2 = $scope.A_DVM_ModelData2;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader2;
                break;
            case "Dealer":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData3;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader3;
                break;
            case "Outlet":
                $scope.A_DVM_Data = $scope.A_DVM_ModelData4;
                $scope.A_DVM_Header = $scope.A_DVM_ModelHeader4;
                break;
            default:
                break;
        }
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }
    function GetSummary(listData) {
        $scope.sum = {};
        $scope.sumUnit = 0;
        $scope.sumAmount = 0;
        for (var idx in listData) {
            $scope.sumUnit = $scope.sumUnit + listData[idx]['UNIT'];
            $scope.sumAmount = $scope.sumAmount + listData[idx]['AMOUNT'];
        }
    }
    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }
    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }
    $scope.Report_Click = function () {
        if ($scope.SubSection == 1) {
            switch ($scope.A_ViewModel) {
                case "Chassis":
                $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByChassis';
                $scope.reportName='Demo car selected 2nd payment by chassis';
                break;
                case "Model":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByModel';
                    $scope.reportName='Demo car selected 2nd payment by model';
                break;
                case "Dealer":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByDealer';
                    $scope.reportName='Demo car selected 2nd payment by dealer';
                break;
                case "Outlet":
                    $scope.reportCode='VME_Rpt_DMC_Payment_Selected_ByOutlet';
                    $scope.reportName='Demo car selected 2nd payment by outlet';
                break;
                default:
                break;
            }
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + 'DemoCar' + '&p2=' + $scope.PaymentType + '&p3=' + $scope.reportName, '_blank');
        }
        else if ($scope.SubSection == 2) {
        switch($scope.ViewModel){
            case "Chassis":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByChassis';
                $scope.reportName='Demo car 2nd payment by chassis';
            break;
            case "Model":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByModel';
                $scope.reportName='Demo car 2nd payment by model';
            break;
            case "Dealer":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByDealer';
                $scope.reportName='Demo car 2nd payment by dealer';
            break;
            case "Outlet":
                $scope.reportCode='VME_Rpt_DMC_Payment_ByOutlet';
                $scope.reportName='Demo car 2nd payment by outlet';
            break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.PAYMENT_ID + '&p2=' + $scope.PaymentType +'&p3='+ $scope.reportName, '_blank');
        }
    }
    $scope.GetUniqueMonth = function (obj, fieldname) {
        $scope.data_months = '';
        let data_months = '';
        let uniqueDataMonth = $filter('unique')(obj, fieldname);
        uniqueDataMonth.forEach(function (datamonth) {
            data_months = data_months + ',' + datamonth[fieldname];
        })
        $scope.data_months = data_months.substr(1,data_months.length-1);
    }
}])

app.controller("DemoCarReconController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        $scope.Section = 0;

        GetHeader();
        InitailDataModel();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ReconStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('ModelReconSummary1')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        BaseService.CallAction(DEMOCAR_PATH, "GetDemoCarReconHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetFleetReconHistory: ' + error.message)
            })
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetReconcile", data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];

            }, function (error) {
                console.log('Unable to load GetAccruePayment: ' + error.message)
            })
    }



    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    $scope.Reconcile_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Reconcile':
                confirmType = 'submit reconcile';
                submitType = 'submitted';
                break;

            case 'ReconcileApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'ReconcileReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "STATUS": status }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(DEMOCAR_PATH, "SubmitRecon", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load Submit reconcile: ' + error.message)
                })
        })

    }

    $scope.Report_Click = function (pReportType) {

        var reportCode = '';
        var reportID = '';
        var reportName = '';

        reportCode = 'VME_Rpt_DMC_D5_Recon';//[sp_Rpt_S1_DMC_Recon]
        reportID = 158;

        reportName = 'Demo car Reconcile - Detail';

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + reportName, '_blank');
    }

    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelReconSummary1';
        $scope.DVM_ACCRUE_TableName2 = '';
        $scope.DVM_ACCRUE_TableName3 = '';
        $scope.DVM_ACCRUE_TableName4 = 'RptDemoCarReconDetail';
        $scope.DVM_ACCRUE_TableName5 = '';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetReconcile';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        $scope.SubSection = 0;
        //  $scope.SubmitStatus = row;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;

        $scope.ModelHeader = $scope.ModelHeader4;
       
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, 'GetDemoCarReconAll', data)
            .then(function (result) {
                $scope.DetailData1 = result;

            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode = '';
        var reportID = '';
        var reportName = '';
        if(ReportNo=='report0'){
            $scope.reportCode = 'VME_Rpt_DMC_S1_Recon';
            $scope.reportName = 'Demo car reconcile - Summary';
            $scope.reportID = 164;
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' + $scope.reportName, '_blank');
        }
        else if(ReportNo=='report1'){
            $scope.reportCode = 'VME_Rpt_DMC_D5_Recon';
            $scope.reportName = 'Demo car reconcile - Detail';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        }



    }
    //------------------- Data model section --------------------------
}])

app.controller("Rpt1DMCTrackingController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.filter = {};
        $scope.formData = {};
        $scope.filter.checkAll = false;

        //--- Default value
        $scope.Section = 1;
        $scope.FnGetSummary = 'GetAccruePaymentStatus';
        $scope.reportCode = 'VME_Rpt_CMP_ACC_Summary';

        GetHeader();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        if ($scope.Section == 1) {
            //GetData();
            GetProgramFleetByMonth();
        } else {
            $scope.ListDetail = {};
            GetDataSummary();
        }

        return;
    }
    $scope.ViewData_Click();

    $scope.Program_Change = function () {
        if (typeof ($scope.FLEET_NAME) == 'undefined' || $scope.FLEET_NAME == null) {
            return;
        }
        if ($scope.Section == 1) {

            GetData();
        }

    }

    $scope.Select_Change = function (gChange) {

        if (gChange == "1") {
            $scope.Section = 1;
        } else if (gChange == "2") {
            $scope.Section = 2;
        } else if (gChange == "3") {
            $scope.Section = 3;
        } else if (gChange == "4") {
            $scope.Section = 4;
        } else if (gChange == "5") {
            $scope.Section = 5;
        }

        ChangeHeader();

        $scope.ListDetail = {};
        if ($scope.Section == 1) {
            $scope.FnGetSummary = '';
            $scope.reportCode = 'VME_Rpt_CMP_ACC_Summary';

        } else if ($scope.Section == 2) {
            $scope.FnGetSummary = 'GetAccruePaymentStatus';
            $scope.reportCode = 'VME_Rpt_FLT_STATUS';
            GetDataSummary();

        } else if ($scope.Section == 3) {
            $scope.FnGetSummary = 'GetAccruePaymentRemain';
            $scope.reportCode = 'VME_Rpt_FLT_S6_Remain';
            GetDataSummary();

        } else if ($scope.Section == 4) {
            $scope.FnGetSummary = 'GetDealerPaidStatus';
            $scope.reportCode = 'VME_Rpt_FLT_S7_Dealer_Paid';
            GetDataSummary();

        } else if ($scope.Section == 5) {
            $scope.FnGetSummary = 'GetDealerDocStatus';
            $scope.reportCode = 'VME_Rpt_FLT_S8_Dealer_Doc_Status';
            GetDataSummary();
        }
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "FLEET_NAME": $scope.FLEET_NAME }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, "GetFleetRptSummary", data)
            .then(function (result) {

                $scope.Detail1List = result.Table;
                $scope.Detail2List = result.Table1;
                $scope.OverlAll = result.Table2;

            }, function (error) {
                console.log('Unable to load GetCampaignChassisSumList data: ' + error.message)
            })
    }

    function GetProgramFleetByMonth() {
        $scope.FleetProgramList = null;
        BaseService.GetDataTableByParam(DEMOCAR_PATH, "GetFleetListByMonth", $scope.DATA_MONTH)
            .then(function (result) {
                $scope.FleetProgramList = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptFleetStatus')
            .then(function (result) {
                $scope.ModelSummary1 = result;
                $scope.ListHeader = $scope.ModelSummary1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptFleetStatus')
            .then(function (result) {
                $scope.ModelSummary2 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('FleetModelRemain')
            .then(function (result) {
                $scope.ModelSummary3 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('FleetDealerPaidStatus')
            .then(function (result) {
                $scope.ModelSummary4 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })


        BaseService.GetHeaderGridView('FleetDealerDocStatus')
            .then(function (result) {
                $scope.ModelSummary5 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

    }

    function ChangeHeader() {
        if ($scope.Section == 1) {
            // $scope.ListHeader = $scope.ModelSummary1;
        } else if ($scope.Section == 2) {
            $scope.ListHeader = $scope.ModelSummary2;
        } else if ($scope.Section == 3) {
            $scope.ListHeader = $scope.ModelSummary3;
        } else if ($scope.Section == 4) {
            $scope.ListHeader = $scope.ModelSummary4;
        } else if ($scope.Section == 5) {
            $scope.ListHeader = $scope.ModelSummary5;
        }
    }

    function GetDataSummary() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.ListDetail = result;

                if ($scope.Section == 3) {
                    GetSummary($scope.ListDetail)
                }

            }, function (error) {
                console.log('Unable to load ' + $scope.FnGetSummary + ' data: ' + error.message)
            })
    }

    function GetSummary(listData) {
        var sum1 = 0;
        var sum2 = 0;
        var sum3 = 0;
        var sum4 = 0;
        var sum5 = 0;
        var sum6 = 0;
        var sum7 = 0;
        var sum8 = 0;
        var sum9 = 0;
        var sum10 = 0;
        var sum11 = 0;
        var sum12 = 0;
        var sum13 = 0;
        var sum14 = 0;
        var sum15 = 0;

        for (var idx in listData) {
            sum1 = sum1 + listData[idx]['UNIT'];
            sum2 = sum2 + listData[idx]['FLEET_CAMPAIGN_AMOUNT'];
            sum3 = sum3 + listData[idx]['ONTOP'];
            sum4 = sum4 + listData[idx]['ADD_ONTOP'];
            sum5 = sum5 + listData[idx]['AMOUNT'];

            sum6 = sum6 + listData[idx]['P_UNIT'];
            sum7 = sum7 + listData[idx]['P_FLEET_CAMPAIGN_AMOUNT'];
            sum8 = sum8 + listData[idx]['P_ONTOP'];
            sum9 = sum9 + listData[idx]['P_ADD_ONTOP'];
            sum10 = sum10 + listData[idx]['PAID'];

            sum11 = sum11 + listData[idx]['R_UNIT'];
            sum12 = sum12 + listData[idx]['R_FLEET_CAMPAIGN_AMOUNT'];
            sum13 = sum13 + listData[idx]['R_ONTOP'];
            sum14 = sum14 + listData[idx]['R_ADD_ONTOP'];
            sum15 = sum15 + listData[idx]['REMAIN'];
        }

        $scope.sum1 = sum1;
        $scope.sum2 = sum2;
        $scope.sum3 = sum3;
        $scope.sum4 = sum4;
        $scope.sum5 = sum5;

        $scope.sum6 = sum6;
        $scope.sum7 = sum7;
        $scope.sum8 = sum8;
        $scope.sum9 = sum9;
        $scope.sum10 = sum10;

        $scope.sum11 = sum11;
        $scope.sum12 = sum12;
        $scope.sum13 = sum13;
        $scope.sum14 = sum14;
        $scope.sum15 = sum15;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };


    $scope.Report_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH, '_blank');
    }

}])

app.controller("Rpt1DMCDetailController", ['$scope', 'BaseService', 'DEMOCAR_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, DEMOCAR_PATH, REPORT_PATH, BizDataService, $filter) {
    openning();

    function openning() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.select = {};
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.FILTER = {};

        //--- Default value
        $scope.Section = 1;
        $scope.select.Period = 'Accrue';
        $scope.FnGetSummary = 'GetDemoCarAccrueSummary';
        $scope.reportName = 'Accrue';
        $scope.reportCode = 'VME_Rpt_FLT_S2';
        $scope.REPORT_ID = 154;
        GetHeader();
    }

    function GetHeader() {
        var gHeaderGridName = '';
        if ($scope.Section == 1) {
            if ($scope.select.Period == 'Reconcile') {
                gHeaderGridName = 'ModelReconSummary1';

            } else if ($scope.select.Period == 'Accrue') {
                gHeaderGridName = 'ModelDemoCarAccrueSummary';

            } else if ($scope.select.Period == 'Payment1') {
                gHeaderGridName = 'ModelDemoCarSummary1';
            } else if ($scope.select.Period == 'Payment2') {
                gHeaderGridName = 'ModelDemoCarSummary2';
            } else if ($scope.select.Period == 'Payment') {
                gHeaderGridName = 'ModelDemoCarAccrueSummary';
            }
        } else {
            if ($scope.select.Period == 'Accrue') {
                gHeaderGridName = 'RptDemoCarAccrueDetail';
            } else if ($scope.select.Period == 'Payment1') {
                gHeaderGridName = 'RptDemoCarPaymentDetail';
            } else if ($scope.select.Period == 'Payment2') {
                gHeaderGridName = 'RptDemoCarPaymentDetail';
            } else if ($scope.select.Period == 'Payment') {
                gHeaderGridName = 'RptDemoCarPaymentAll';
            } else if ($scope.select.Period == 'Reconcile') {
                gHeaderGridName = 'RptDemoCarReconDetail';
            }
        }

        BaseService.GetHeaderGridView(gHeaderGridName)
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load table header data: ' + error.message)
            })
    }

    $scope.Select_Change = function (gChange) {
        if ($scope.select.Period == 'Accrue') {
            $scope.FnGetSummary = 'GetDMCAccrueSummary';
            $scope.reportName = 'Accrue';
            $scope.FnGetDetail = 'sp_Rpt_DMC_Accrue_ByChassis';
            $scope.reportCode = 'VME_Rpt_DMC_D1';
            $scope.REPORT_ID = 154;
            if ($scope.Section == 1) $scope.REPORT_ID = $scope.REPORT_ID + 6;
        } else if ($scope.select.Period == 'Payment1') {
            $scope.FnGetSummary = 'GetPayment1ByMonth';
            $scope.reportName = 'Payment1';
            $scope.FnGetDetail = 'sp_Rpt_DMC_D3';
            $scope.reportCode = 'VME_Rpt_DMC_D3';
            $scope.REPORT_ID = 155;
            if ($scope.Section == 1) $scope.REPORT_ID = $scope.REPORT_ID + 6;
        } else if ($scope.select.Period == 'Payment2') {
            $scope.FnGetSummary = 'GetPayment2ByMonth';
            $scope.reportName = 'Payment2';
            $scope.FnGetDetail = 'sp_Rpt_DMC_D3';
            $scope.reportCode = 'VME_Rpt_DMC_D3';
            $scope.REPORT_ID = 156;
            if ($scope.Section == 1) $scope.REPORT_ID = $scope.REPORT_ID + 6;
        } else if ($scope.select.Period == 'Payment') {
            $scope.FnGetSummary = 'GetPaymentByMonth';
            $scope.reportName = 'Payment';
            $scope.FnGetDetail = 'sp_Rpt_DMC_D4';
            $scope.reportCode = 'VME_Rpt_DMC_D4';
            $scope.REPORT_ID = 157;
            if ($scope.Section == 1) $scope.REPORT_ID = $scope.REPORT_ID + 6;
        } else if ($scope.select.Period == 'Reconcile') {
            $scope.FnGetSummary = 'GetReconcile';
            $scope.reportName = 'Reconcile';
            $scope.FnGetDetail = 'sp_Rpt_DMC_Recon_ByChassis';
            $scope.reportCode = 'VME_Rpt_DMC_D5_Recon';
            $scope.REPORT_ID = 158;
          
            if ($scope.Section == 1) $scope.REPORT_ID = $scope.REPORT_ID + 6;
        }

        GetHeader();

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        $scope.ListDetail = [];
        if ($scope.Section == 1) {
            if ($scope.select.Period == 'Reconcile') {
                $scope.reportCode = 'VME_Rpt_DMC_S1_Recon';
            } else {
                $scope.reportCode = 'VME_Rpt_DMC_S2';
            }

            $scope.reportName = $scope.reportName + ' summary';
            GetDataSummary();
        } else {
            $scope.reportName = $scope.reportName + ' detail';
            GetDataDetail()
        }
    }

    function GetDataSummary() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(DEMOCAR_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.ListDetail = (result.Table) ? result.Table : [];
                //$scope.SumList = result.Table1;

                $scope.SubmitStatus = (result.Table1) ? result.Table1[0] : {};
                $scope.AccPayList = (result.Table2) ? result.Table2[0] : {};

                if ($scope.select.Period == 'Accrue' && $scope.SubmitStatus.APPROVE_ACCRUE == null) {
                    $scope.ListDetail = null;
                } else {
                    GetSummary($scope.ListDetail);
                }

            }, function (error) {
                console.log('Unable to load Demo car summary data: ' + error.message)
            })
    }

    function GetSummary(listData) {
        var sumUnit = 0;
        var sumAmount = 0;
        var sumPUnit = 0;
        var sumPAmount1 = 0;
        var sumPAmount2 = 0;
        var sumTotal = 0;
        var sumP1 = 0;
        var sumP2 = 0;
        var sumRAmount = 0;
        var sumBAmount = 0;

        $scope.sumPaid = 0;
        $scope.sumPaidPerUnit = 0;

        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['UNIT'];
            sumAmount = sumAmount + listData[idx]['AMOUNT'];
            sumPUnit = sumPUnit + listData[idx]['P_UNIT'];
            sumPAmount1 = sumPAmount1 + listData[idx]['P_PAYMENT1'];
            sumPAmount2 = sumPAmount2 + listData[idx]['P_PAYMENT2'];

            sumP1 = sumP1 + listData[idx]['PAYMENT1'];
            sumP2 = sumP2 + listData[idx]['PAYMENT2'];

            $scope.sumPaid = $scope.sumPaid + listData[idx]['P_AMOUNT'];
            $scope.sumPaidPerUnit = $scope.sumPaidPerUnit + listData[idx]['P_PER_UNIT'];

            sumRAmount = sumRAmount + listData[idx]['RECONCILE'];
            sumBAmount = sumBAmount + listData[idx]['BALANCE'];
        }

        $scope.sumUnit = sumUnit;
        $scope.sumAmount = sumAmount;
        $scope.sumPUnit = sumPUnit;
        $scope.sumPAmount1 = sumPAmount1;
        $scope.sumPAmount2 = sumPAmount2;
        $scope.sumTotal = sumTotal;
        $scope.sumP1 = sumP1;
        $scope.sumP2 = sumP2;
        $scope.sumRAmount = sumRAmount;
        $scope.sumBAmount = sumBAmount;
    }

    function GetDataDetail() {
        var sendData = [{ "SP_NAME": $scope.FnGetDetail, "DATA_MONTH": $scope.DATA_MONTH, "REPORT_ID": $scope.REPORT_ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(DEMOCAR_PATH, 'GetAsDetail', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load Demo car detail data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.ModelReport_Click = function () {
        if($scope.select.Period=="Accrue"){
            if($scope.Section==1){
                $scope.reportCode='VME_Rpt_DMC_Accrue_Summary';
                $scope.reportName='Demo car accrue - Summary';
                $scope.reportID = 48;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' + $scope.reportName, '_blank');
            }
            else{
                $scope.reportCode = 'VME_Rpt_DMC_D1';//[sp_Rpt_DMC_Accrue_Detail]
                $scope.reportName = 'Accrue for demo car - Detail';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
            }
        }
        else if($scope.select.Period=="Payment1"){
            if($scope.Section==1){
                $scope.reportCode='VME_Rpt_DMC_S2';
                $scope.reportName = 'Demo car 1st payment - Summary';
                $scope.reportID=161;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' +$scope.reportID+ '&p3=' + $scope.reportName, '_blank');
            }
            else{
                $scope.reportCode='VME_Rpt_DMC_D3';
                $scope.reportName = 'Demo car 1st payment - Detail';
                $scope.reportID=155;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' +$scope.reportName, '_blank');
            }

        }
        else if($scope.select.Period=="Payment2"){
            if($scope.Section==1){
                $scope.reportCode='VME_Rpt_DMC_S2';
                $scope.reportName = 'Demo car 2nd payment - Summary';
                $scope.reportID=162;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' +$scope.reportID+ '&p3=' + $scope.reportName, '_blank');
            }
            else{
                $scope.reportCode='VME_Rpt_DMC_D3';
                $scope.reportName = 'Demo car 2nd payment - Detail';
                $scope.reportID=156;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' +$scope.reportName, '_blank');
            }

        }
        else if($scope.select.Period=="Payment"){
            if($scope.Section==1){
                $scope.reportCode='VME_Rpt_DMC_S2';
                $scope.reportName = 'Demo car payment - Summary';
                $scope.reportID=163;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' +$scope.reportName, '_blank');
            }
            else{
                $scope.reportCode='VME_Rpt_DMC_D4';
                $scope.reportName = 'Demo car payment - Detail';
                $scope.reportID=157;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' +$scope.reportName, '_blank');
            }
        }
        else if($scope.select.Period=="Reconcile"){
            if($scope.Section==1){
                $scope.reportCode = 'VME_Rpt_DMC_S1_Recon';
                $scope.reportName = 'Demo car reconcile - Summary';
                $scope.reportID = 164;
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportID + '&p3=' + $scope.reportName, '_blank');
            }
            else{
                $scope.reportCode = 'VME_Rpt_DMC_D5_Recon';
                $scope.reportName = 'Demo car reconcile - Detail';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
            }
        }        
    }

}])
