﻿app.controller("FleetMainController", ['$scope', 'BaseService', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        // GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.ListAccrue = result.Table2;
                $scope.ListPayment = result.Table3;
                $scope.ListReconcile = result.Table4;

            }, function (error) {
                console.log('Unable to load fleet dashboard data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("FleetProgramController", ['$scope', 'BaseService', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CONFIG_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("FleetProgram")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }


    function GetData() {
        BaseService.GetDataTable(CONFIG_PATH, "GetFleetList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.Add_New = function () {

        $scope.formData.Fleet = {
            "STATUS": "Active"
        };

        document.getElementById('DetailModal').style.display = 'block';
    }


    $scope.Edit_Submit = function () {

        if ($scope.formData.Fleet.FLEET_NAME == null || $scope.formData.Fleet.FLEET_NAME == '') {
            BaseService.Message.warning("Customer type / Program name cannot empty.");
            return;
        }

        if ($scope.formData.Fleet.FLEET_DESCRIPTION == null || $scope.formData.Fleet.FLEET_DESCRIPTION == '') {
            BaseService.Message.warning("Description cannot empty.");
            return;
        }

        if ($scope.formData.Fleet.FLEET_LEVEL == null || $scope.formData.Fleet.FLEET_LEVEL == '') {
            BaseService.Message.warning("Fleet level cannot empty.");
            return;
        }

        if ($scope.formData.Fleet.START_EFFECTIVE_DATE == null || $scope.formData.Fleet.START_EFFECTIVE_DATE == '' ||
            $scope.formData.Fleet.END_EFFECTIVE_DATE == null || $scope.formData.Fleet.END_EFFECTIVE_DATE == '') {
            BaseService.Message.warning('The Start Effective date and End Effective date cannot empty.');
            return;
        }

        if (Date.parse($scope.formData.Fleet.END_EFFECTIVE_DATE) < Date.parse($scope.formData.Fleet.START_EFFECTIVE_DATE)) {
            BaseService.Message.warning("End Effective date is less than Start Effective date");
            return;
        }

        let confirmed = false;

        if ($scope.formData.Fleet.STATUS == "Inactive") {
            BaseService.Message.confirm("Inactive status will not appear to the list, if you confirm this change.").then(function () {
                $scope.UpdateFleetProgram();
            })
        } else {
            $scope.UpdateFleetProgram();
        }

    }

    $scope.UpdateFleetProgram = function () {

        let data = BaseService.ConvertParam($scope.formData.Fleet)

        BaseService.CallAction(CONFIG_PATH, "EditFleetProgramConf", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to edit fleet program data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(CONFIG_PATH, "GetFleetList", ID, { id: ID })
            .then(function (result) {
                $scope.formData.Fleet = result[0]
            }, function (error) {
                console.log('Unable to load fleet program data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("PeriodFleetController", ['$scope', 'BaseService', 'FLEET_PATH', function ($scope, BaseService, FLEET_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.format = 'd!-MMM-yy'; // 101 = mm/dd/yyyy
        $scope.periodDisable = false;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("PeriodFleetList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(FLEET_PATH, "GetPeriodFleetList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.formData = {};
        $scope.formData.ID = 0;
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.Add_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning("Fleet period name cannot empty.");
            return;
        }

        if ($scope.formData.START_DATE == null || $scope.formData.START_DATE == '' ||
            $scope.formData.END_DATE == null || $scope.formData.END_DATE == '') {
            BaseService.Message.warning("The Start date and End date cannot empty.");
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date");
            return;
        }

        var data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(FLEET_PATH, "CheckPeriodFleetExist", data)
            .then(function (result) {
                if (result[0]["TOTAL"] == 0) {
                    BaseService.CallAction(FLEET_PATH, "AddPeriodFleet", data)
                        .then(function (result) {
                            GetData();
                            document.getElementById('DetailModal').style.display = 'none';
                        })
                } else {
                    BaseService.Message.alert('The Start date and End date have already exist.');
                }
            }, function (error) {
                console.log('Unable to check data: ' + error.message)
            })

    }
    $scope.Edit_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning("Fleet period name cannot empty.");
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date");
            return;
        }

        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(FLEET_PATH, "EditPeriodFleet", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');

            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit data: ' + error.message)
            })

    }

    $scope.GenFleet_Click = function (ID) {

        BaseService.Message.confirm('Do you want to run Fleet process?').then(function () {
            let data = BaseService.ConvertParam($scope.formData)

            BaseService.CallAction(FLEET_PATH, "GenFleetProgram", data)
                .then(function (result) {
                    BaseService.Message.info('Create fleet program successful');
                }, function (error) {
                    BaseService.Message.alert('Cannot create fleet program');
                    console.log('Unable to GenFleetProgram : ' + error.message)
                })

        })
    }

    $scope.ShowItem_Click = function (ID) {
        $scope.formData.ID = ID;
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(FLEET_PATH, "GetPeriodFleetList", ID, { id: ID })
            .then(function (result) {
                $scope.formData = result[0];

                $scope.periodDisable = (result[0].REVIEW_STATUS == 'Approved') ? true : false;
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }



    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.Approve_Submit = function (obj, type, PERIOD_NAME) {
        BaseService.Message.confirm("Would you like to \"" + type + "\" this period?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj.ID, "TYPE": type, "period_name": PERIOD_NAME });

            BaseService.CallAction(FLEET_PATH, "ApproveSubmit", data)
                .then(function (result) {
                    //console.log(result);
                    GetData();
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }

    //NEW by KS
    $scope.SendFleetPeriod = function (obj, type, PERIOD_NAME) {

        BaseService.Message.confirm("Would you like to \"" + type + "\" this for approve?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj, "TYPE": type, "period_name": PERIOD_NAME });

            BaseService.CallAction(FLEET_PATH, "FLT_Send_Period", data)
                .then(function (result) {
                    GetData();
                }, function (error) {
                    console.log('Unable to submit send period: ' + error.message);
                })
        })
    }
    //NEW by KS

}])

app.controller("FleetConfigureController", ['$scope', 'BaseService', 'FLEET_PATH', 'CONFIG_PATH', 'REPORT_PATH', '$filter', 'Upload', '$timeout', function ($scope, BaseService, FLEET_PATH, CONFIG_PATH, REPORT_PATH, $filter, Upload, $timeout) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.filter = { "BASE_MODEL": null };
        $scope.Fleet = {};
        $scope.panel = [];
        $scope.DOAs = [];
        $scope.popupStartDate = [];
        $scope.popupEndDate = [];
        $scope.popupDOADate = [];
        $scope.format = 'd!-MMM-yy'; // 101 = mm/dd/yyyy
        $scope.periodID = null;
        $scope.periodDisable = false;
        $scope.type = ["Bulletin", "DOA"];
        GetModelBaseList();
        GetFleetList();
        document.getElementById('EditFleetProgram').style.display = 'none';
        document.getElementById('ViewFleetDetail').style.display = 'none';
        document.getElementById('CopyModelModal').style.display = 'none';
        $scope.ViewMode = 1;
        $scope.DOATemplate = {
            ID: 0,
            DOA_NUMBER: '',
            DOA_DETAIL: '',
            DOA_CHASSIS_COUNT: '',
            DOA_DATE: '',
            BULLETIN_ID: '',
        };

        //$scope.filter.MODEL_CODE = 'B17';
    }

    function GetFleetList() {
        BaseService.GetDataTable(FLEET_PATH, "GetFleetList")
            .then(function (result) {
                $scope.ListDetail = result
                if (typeof (result[0]) != 'undefined') {
                    $scope.periodID = result[0].PERIOD_ID;
                    $scope.periodDisable = (result[0].REVIEW_STATUS == 'Approved') ? true : false;
                }
            }, function (error) {
                console.log('Unable to load Fleet data: ' + error.message)
            })
    }

    $scope.GetModelList = function () {

        BaseService.GetDataTable(FLEET_PATH, "GetFleetModel")
            .then(function (result) {
                $scope.ModelList = result
            }, function (error) {
                console.log('Unable to load Model data: ' + error.message)
            })
    }

    function GetModelBaseList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelBaseList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    $scope.Add_New = function () {

        $scope.FleetProgramList = [];
        $scope.Fleet = {};
        $scope.Fleet.ID = 0;

        document.getElementById('FleetProgramModal').style.display = 'block';

        BaseService.GetDataTable(CONFIG_PATH, "GetFleetList", '')
            .then(function (result) {
                $scope.FleetProgramList = result;
            }, function (error) {
                console.log('Unable to edit fleet program data: ' + error.message)
            })
    }

    $scope.ShowGroup_Click = function (ID) {
        $scope.programType = 'Bulletin';
        $scope.DOAs = [];
        $scope.DOAs.push(BaseService.ObjectAssign({}, $scope.DOATemplate));
        $scope.FleetProgramList = [];
        $scope.Fleet = {};
        // $scope.Fleet.ID = ID;
        $scope.ViewMode = 2;

        document.getElementById('ProgramList').style.display = 'none';
        document.getElementById('EditFleetProgram').style.display = 'block';

        BaseService.GetDataTableByParam(FLEET_PATH, "GetFleetList", ID)
            .then(function (result) {
                $scope.Fleet = result[0];

                if ($scope.Fleet) {
                    $scope.periodDisable = ($scope.Fleet._REVIEW_STATUS == 'Approved');
                    if ($scope.Fleet.FLEET_BULLATIN == 'DOA') {
                        $scope.programType = 'DOA';
                        $scope.GetDOAList();
                    } else {
                        $scope.programType = 'Bulletin';
                    }
                }
                (!$scope.periodDisable) ? $scope.GetActiveBulletin(ID) : null;

            }, function (error) {
                console.log('Unable to edit fleet program data: ' + error.message)
            })
    }

    $scope.GetActiveBulletin = function (ID) {
        BaseService.GetDataTableByParam(FLEET_PATH, "GetBulletinActiveList", ID)
            .then(function (result) {
                $scope.BulletinList = result;
            }, function (error) {
                console.log('Unable to edit fleet program data: ' + error.message)
            })
    }

    $scope.CopyModel_Click = function (ID) {

        $scope.Copy = {};
        $scope.Copy.ID = ID;
        $scope.FleetProgramCopy = $filter('filter')($scope.ListDetail, { ID: $scope.Copy.ID }, true)[0]._FLEET_NAME;

        GetFleetListByPeriod();
        document.getElementById('ProgramList').style.display = 'none';
        document.getElementById('CopyModelModal').style.display = 'block';
        $scope.ViewMode = 4;
    }

    function GetPeriodFleetList() {
        BaseService.GetDataTable(FLEET_PATH, "GetPeriodFleetList")
            .then(function (result) {
                $scope.PeriodFleetList = result;
            }, function (error) {
                console.log('Unable to load period data: ' + error.message)
            })
    }

    function GetFleetListByPeriod() {
        BaseService.GetDataTable(FLEET_PATH, "GetFleetCopyList")
            .then(function (result) {
                $scope.FleetProgramListCopy = result;

            }, function (error) {
                console.log('Unable to load Fleet data: ' + error.message)
            })
    }

    $scope.Copy_Submit = function () {
        var PROGRAM_ID = parseInt($scope.Copy.MONTHLY_PROGRAM_ID);

        var FleetProgramTo = $filter('filter')($scope.FleetProgramListCopy, { MONTHLY_PROGRAM_ID: PROGRAM_ID }, true)[0].FLEET_NAME;
        BaseService.Message.confirm('Are you sure to copy information from "' + $scope.FleetProgramCopy + '" to "' + FleetProgramTo + '" ').then(function () {
            let data = BaseService.ConvertParam($scope.Copy)

            BaseService.CallAction(FLEET_PATH, "CopyFleetProgram", data)
                .then(function (result) {
                    BaseService.Message.info('Successfully copied fleet program');
                }, function (error) {
                    console.log('Unable to copy fleet program data: ' + error.message)
                })
        })
    }

    $scope.GetFleetDescription = function () {
        return ($scope.Fleet.FLEET_PROGRAM_ID && $scope.FleetProgramList.length > 0) ? $filter('filter')($scope.FleetProgramList, { ID: $scope.Fleet.FLEET_PROGRAM_ID }, true)[0].FLEET_DESCRIPTION : "";
    }

    $scope.Edit_Submit = function () {

        let data = BaseService.ConvertParam($scope.Fleet)
        $scope.ViewMode = 2;
        BaseService.CallAction(FLEET_PATH, "EditFleetProgram", data)
            .then(function (result) {
                GetFleetList();
                BaseService.Message.info('Save fleet program successfully ');
                $scope.CloseItem_Click();
            }, function (error) {
                console.log('Unable to edit fleet program data: ' + error.message)
            })

        if ($scope.Fleet.FLEET_BULLATIN == 'DOA') {
            $scope.DOAs.forEach(function (item) {
                $scope.SaveDOA(item);
            })
        }
    }

    $scope.SetBulletinName = function (id) {
        $scope.Fleet.BULLETIN_ID = id;
        $scope.Fleet.FLEET_BULLATIN = $filter('filter')($scope.BulletinList, { ID: id }, true)[0].BULLETIN_NAME;
    }

    $scope.SetDOAName = function (obj, id) {
        var selectedDOA = $filter('filter')($scope.BulletinList, { ID: id }, true)[0];
        obj.BULLETIN_ID = id;
        obj.DOA_DETAIL = (selectedDOA) ? selectedDOA.BULLETIN_NAME : null;
        obj.DOA_DATE = (selectedDOA) ? selectedDOA.BULLETIN_DATE : null;
    }

    $scope.DeleteItem_Click = function () {

        let data = BaseService.ConvertParam({
            "ID": $scope.Fleet.ID,
            "STATUS": "Inactive",
            "MODIFY_BY": "1",
            "MODIFY_DATE_TIME": ""
        });
        BaseService.CallAction(FLEET_PATH, "EditFleetProgram", data)
            .then(function (result) {
                document.getElementById('EditFleetProgram').style.display = 'none';
                GetFleetList();
            }, function (error) {
                console.log('Unable to delete fleet program data: ' + error.message)
            })
    }

    $scope.ViewModelDetail_Click = function (ID) {
        $scope.ProgramID = ID
        $scope.ViewMode = 3;
        document.getElementById('ProgramList').style.display = 'none';
        document.getElementById('ViewFleetDetail').style.display = 'block';

        $scope.FleetName = $filter('filter')($scope.ListDetail, { ID: ID }, true)[0]._FLEET_NAME;

        $scope.filter.BASE_MODEL = 'B17';
        getModelList(ID, $scope.filter.BASE_MODEL);

    }

    
    $scope.GetGenRate_Click = function () {               
        BaseService.Message.confirm("Would you like to update the Retail campaign?").then(function () {
            var sendData = {
                "PERIOD_ID": $scope.FleetModelList[0].PERIOD_ID
            }
            var data = BaseService.ConvertParam(sendData);

            BaseService.CallAction(FLEET_PATH, "UpdateCampaignGenRateAmount", data)
                .then(function (result) {
                    getModelList(I$scope.ProgramID, $scope.filter.BASE_MODEL);
                    BaseService.Message.info('Update Retail campaing successfully ');
                }, function (error) {
                    console.log('Unable to edit fleet program data: ' + error.message)
                })

            if ($scope.Fleet.FLEET_BULLATIN == 'DOA') {
                $scope.DOAs.forEach(function (item) {
                    $scope.SaveDOA(item);
                })
            }

        })
    }

    $scope.ModelBaseView_Click = function () {
        getModelList($scope.ProgramID, $scope.filter.BASE_MODEL);
    }

    function getModelList(ID, ModelBase) {
        var sendData = [{ "PROGRAM_ID": ID, "BASE_MODEL": ModelBase }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetModelList", data)
            .then(function (result) {
                $scope.panel = [];
                result.forEach(function () {
                    $scope.panel.push(false);
                })
                $scope.FleetModelList = result;
                $scope.periodDisable = (result[0] && result[0].REVIEW_STATUS == 'Approved');
            }, function (error) {
                console.log('Unable to load Model data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        $scope.ViewMode = 1;
        document.getElementById('ProgramList').style.display = 'block';
        document.getElementById('EditFleetProgram').style.display = 'none';
        document.getElementById('ViewFleetDetail').style.display = 'none';
        document.getElementById('CopyModelModal').style.display = 'none';
    }

    $scope.TogglePanel = function (ID) {
        const panelHeadElement = document.getElementById('panelheading_' + ID);
        const panelBodyElement = document.getElementById('panelbody_' + ID);

        $scope.panel[ID] = !$scope.panel[ID];

    }

    $scope.SaveFleetModel_Submit = function (dataRow, rowID) {

        //---- Varidate 
        if (dataRow.ONTOP_M > dataRow.ONTOP_L) {
            BaseService.Message.warning('Fleet dis.(M) is more than Fleet dis.(L)');
            return;
        }
        if (dataRow.EXCEPT_DO_ONTOP_M > dataRow.EXCEPT_DO_ONTOP_L) {
            BaseService.Message.warning('Fleet dis.(M) is more than Fleet dis.(L)');
            return;
        }

        dataRow.MONTHLY_PROGRAM_ID = $scope.ProgramID;

        const data = BaseService.ConvertParam(dataRow);
       
        BaseService.CallAction(FLEET_PATH, "SaveFleetModel", data)
            .then(function (result) {
                BaseService.Message.info("Successfully saved")
            }, function (error) {
                console.log('Unable to delete fleet program data: ' + error.message)
            })
    }

    $scope.Download_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        window.open(window.location.origin + REPORT_PATH + 'rt=1&export=excelopenxml&rc=FLT01&p1=' + $scope.FleetModelList[0].PERIOD_ID + '&p2=' + $scope.FleetModelList[0].PROGRAM_ID, '_blank');
    }

    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + FLEET_PATH + '/UpdateFleetConfig',
                    data: { File: file, programID: $scope.ProgramID },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved");
                        $scope.ViewModelDetail_Click($scope.ProgramID);
                        $scope.fileUpload = null;
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.openStartDate = function (index) {
        $scope.popupStartDate[index] = true;
    }

    $scope.openStartDate1 = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.openDOADate = function (index) {
        $scope.popupDOADate[index] = true;
    }

    $scope.openEndDate = function (index) {
        $scope.popupEndDate[index] = true;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Approve_Submit = function (type) {
        BaseService.Message.confirm("Would you like to \"" + type + "\" this period?").then(function () {
            const data = BaseService.ConvertParam({ "ID": $scope.periodID, "TYPE": type });

            BaseService.CallAction(FLEET_PATH, "ApproveSubmit", data)
                .then(function (result) {
                    console.log(result);
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }

    $scope.setProgramType = function (type) {
        $scope.programType = type;
        if (type == 'DOA') {
            $scope.Fleet.FLEET_BULLATIN = 'DOA';
            $scope.Fleet.FLEET_BULLATIN_DEALER = false;
            if ($scope.DOAs && $scope.DOAs.length == 0) {
                $scope.DOAs.push(BaseService.ObjectAssign({}, $scope.DOATemplate));
            }
        } else {
            $scope.Fleet.FLEET_BULLATIN = '';
            $scope.Fleet.FLEET_BULLATIN_DEALER = false;
            $scope.DOAs = [];
        }
    }

    $scope.AddDOA = function (obj) {
        if (obj.DOA_NUMBER == '' || obj.DOA_MODEL_CODE == '' || obj.DOA_CHASSIS_COUNT == '' || obj.DOA_PAY_AMOUNT == '') {
            BaseService.Message.alert("Please insert data before add the DOA.");
            return;
        }
        $scope.SaveDOA(obj, function (res) {
            $scope.DOAs.push(BaseService.ObjectAssign({}, $scope.DOATemplate));
        });
    }

    $scope.DOASave_Click = function (obj) {
        if (obj.DOA_NUMBER == '' || obj.DOA_DATE == '' || obj.BULLETIN_ID == '' || obj.DOA_DETAIL == '' || obj.DOA_CHASSIS_COUNT == '') {
            BaseService.Message.alert("Please insert data before add/save the DOA.");
            return;
        }

        $scope.SaveDOA(obj);
    }

    $scope.SaveDOA = function (obj, fn) {
        if (obj.DOA_NUMBER == '' || obj.DOA_DATE == '' || obj.BULLETIN_ID == '' || obj.DOA_DETAIL == '' || obj.DOA_CHASSIS_COUNT == '') {
            return;
        }

        obj.MONTHLY_PROGRAM_ID = $scope.Fleet.ID;
        var data = BaseService.ConvertParam(obj);

        BaseService.CallAction(FLEET_PATH, 'SaveFleetDOA', data)
            .then(function (result) {
                obj.ID = result[0]["ID"];
                (typeof (fn) == 'function') ? fn(result) : null;
            }, function (error) {
                console.log('Unable to save DOA: ' + error.message);
            })
    }

    $scope.RemoveDOA = function (obj) {
        obj.MONTHLY_PROGRAM_ID = $scope.Fleet.ID;
        var data = BaseService.ConvertParam(obj);

        BaseService.CallAction(FLEET_PATH, 'DeleteFleetDOA', data)
            .then(function (result) {
            }, function (error) {
                console.log('Unable to save DOA: ' + error.message);
            })

        $scope.DOAs.splice($scope.DOAs.indexOf(obj), 1);
        if ($scope.DOAs.length == 0) {
            $scope.DOAs.push(BaseService.ObjectAssign({}, $scope.DOATemplate));
        }
    }

    $scope.GetDOAList = function () {
        BaseService.GetDataTableByParam(FLEET_PATH, 'GetDOAListByMonthlyID', $scope.Fleet.ID)
            .then(function (result) {
                if (result.length > 0) {
                    $scope.DOAs = result;
                }
            }, function (error) {
                console.log('Unable to get DOA List by monthly ID: ' + error.message);
            })
    }
}])

app.controller("FleetResultController", ['$scope', 'BaseService', 'FLEET_PATH', 'REPORT_PATH','BizDataService', '$filter', function ($scope, BaseService, FLEET_PATH, REPORT_PATH ,BizDataService, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.selector = [];
        $scope.selectedModel = [];
        $scope.sortType = 'CUST_NAME';
        $scope.format = 'd!-MMM-yy';
        $scope.DATE_FROM = new Date()
        $scope.DATE_TO = new Date()
        GetRetailSalesMonth();
        GetHeader();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetProgramFleetByMonth() {

        var sendData = [{
            "DATE_FROM": $scope.DATE_FROM,
            "DATE_TO": $scope.DATE_TO
        }];

        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetListByDate", data)
            .then(function (result) {
                $scope.FleetProgramList = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('FleetResultList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.selector = [];
        $scope.selectedModel = [];
        var sendData = [{
            "DATE_FROM": $scope.DATE_FROM,
            "DATE_TO": $scope.DATE_TO
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetResultListByFleetName", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetFleetResultListByFleetName data: ' + error.message)
            })
    }

    $scope.SelectFleetMatch = function () {
        const selectedObj = $filter('filter')($scope.fleetMatch, { MONTHLY_PROGRAM_ID: $scope.formData.MONTHLY_PROGRAM_ID }, true)[0];

        $scope.formData.FLEET_CAMPAIGN_AMOUNT = ($scope.formData.FLEET_CAMPAIGN_AMOUNT == null) ? selectedObj.CAMPAIGN_AMOUNT : $scope.formData.FLEET_CAMPAIGN_AMOUNT;
        $scope.formData.ONTOP = ($scope.formData.ONTOP == null) ? selectedObj.ONTOP_M : $scope.formData.ONTOP;
        $scope.formData.ONTOP_M = selectedObj.ONTOP_M;
        $scope.formData.ONTOP_L = selectedObj.ONTOP_L;
        $scope.formData.ADD_ONTOP = ($scope.formData.ADD_ONTOP == null) ? selectedObj.ADD_ONTOP : $scope.formData.ADD_ONTOP;
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.FLEET_NAME) == 'undefined') {
            //BaseService.Message.warning('Please select fleet program');
            return;
        }

    }

    $scope.DataMonth_Change = function () {
        GetProgramFleetByMonth();
        $scope.ViewData_Click();
        $scope.FILTER = {};
        GetData();
    }

    $scope.ShowItem_Click = function (ID) {
        $scope.AbleToSave = true;
        $scope.thisDOA = null;
        $scope.DOAs = [];

        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetResult", data)
            .then(function (result) {
                $scope.formData = result[0];
                $scope.GetBullatinList('Single');
            }, function (error) {
                BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetFleetResult data: ' + error.message)
            })
    }

    $scope.Save_Submit = function () {

        if ($scope.formData.ONTOP_FLAG == null) {
            BaseService.Message.warning("Please select ontop flag");
            return;
        }
        if ($scope.formData.MONTHLY_PROGRAM_ID == null) {
            BaseService.Message.warning("Please select Bulletin");
            return;
        }

        let scopeData = $scope.formData;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(FLEET_PATH, "SaveFleetResult", data)
            .then(function (result) {
                //document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }


    $scope.ToggleSelector = function (thisItem) {

        const thisItemID = thisItem.CHASSIS_NO;

        let thisElement = document.getElementById(thisItemID);


        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
            $scope.selectedModel.push(thisItem.MODEL_CODE);
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            $scope.selectedModel.splice($scope.selectedModel.indexOf(thisItem.MODEL_CODE), 1);
            thisElement.classList.remove("selected");
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.selectDeselectAll = function (isSelect) {
        if ($scope.AllItem) {
            $scope.AllItem.forEach(function (item) {
                let thisElement = document.getElementById(item.CHASSIS_NO);
                if (isSelect && thisElement && !thisElement.classList.contains("selected")) {
                    $scope.selector.push(item.CHASSIS_NO);
                    thisElement.classList.add("selected");
                    $scope.selectedModel.push(item.MODEL_CODE);
                } else if (!isSelect && thisElement && thisElement.classList.contains("selected")) {
                    $scope.selector.splice($scope.selector.indexOf(item.CHASSIS_NO), 1);
                    $scope.selectedModel.splice($scope.selectedModel.indexOf(item.MODEL_CODE), 1);
                    thisElement.classList.remove("selected");
                }
            })
        }
    }

    $scope.filterItem = function () {
        let n = 1;
        $scope.AllItem = [];
        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (item == 'FILTER_FLEET_NAME') {
                    if((input[item] || '').toLowerCase().trim() == $scope.FILTER[item].toLowerCase().trim()) {
                    filterResult = true;
                    } else {
                        filterResult = false;
                    }
                } else if ((input[item] || '').toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.PageRecFrom && n <= $scope.PageRecTo) {
                $scope.AllItem.push(input);
            }

            (filterResult) ? n++ : null;
            //console.log(filterResult);
            return filterResult;
        }
    }

    $scope.isOneModelSelected = function (obj) {
        let returnArray = $filter('uniqueArray')(obj);
        return (returnArray.length === 1)
    }

    $scope.GetBullatinList = function (type) {
        $scope.fleetBullatin = null;

        data = BaseService.ConvertParam({ "FLEET_NAME": $scope.formData.FLEET_NAME || $scope.FILTER.FILTER_FLEET_NAME });

        BaseService.CallAction(FLEET_PATH, "GetFleetBullatin", data)
            .then(function (result) {
                $scope.bullatinList = result;
                if (type == 'Single') {
                    $scope.fleetBullatin = $filter('filter')($scope.bullatinList, { MONTHLY_PROGRAM_ID: ($scope.formData.MONTHLY_PROGRAM_ID || 'x') }, true)[0]
                    if ($scope.fleetBullatin && $scope.fleetBullatin.IS_DOA == 'Y') {
                        $scope.GetDOAList($scope.fleetBullatin.MONTHLY_PROGRAM_ID);
                    }
                }
            }, function (error) {
                console.log('Unable to load GetFleetBullatin data: ' + error.message)
            })
    }

    $scope.ShowEdit_Group = function () {
        $scope.formData = {};
        $scope.formData.ONTOP_FLAG = 'M'
        document.getElementById('GroupModal').style.display = 'block';

        $scope.SaveGroup_Submit = function () {
            document.getElementById('GroupModal').style.display = 'none';
        }

        if ($scope.isOneModelSelected($scope.selectedModel)) {
            $scope.GetConfigureGroup('Group',0, $scope.DATE_FROM, $scope.DATE_TO);
           
        }

        $scope.GetBullatinList('Group');
    }

    $scope.GetConfigureGroup = function (type, MONTHLY_PROGRAM_ID, date_from, date_to, fleet_name, monthly_id, fn) {
        
        var data = BaseService.ConvertParam({
            "MONTHLY_PROGRAM_ID": MONTHLY_PROGRAM_ID,
            "DATE_FROM": date_from,
            "DATE_TO": date_to,
            "FLEET_NAME": fleet_name,
            "MODEL_CODE": (type == 'Group') ? $scope.selectedModel[0] : $scope.formData.MODEL_CODE
        });
        monthly_id = (monthly_id || '');

        BaseService.CallAction(FLEET_PATH, "GetFleetResultGroup", data)
            .then(function (result) {
                let selectedResult = $filter('filter')(result, { MONTHLY_PROGRAM_ID: monthly_id }, true);
                (typeof (fn) != 'undefined') ? fn(selectedResult[0]) : null;
            }, function (error) {
                console.log('Unable to load GetFleetResultGroup data: ' + error.message)
            })
    }

    $scope.BullatinChange = function (obj, type) {
        $scope.DOAs = [];
        $scope.formData.DOA_ID = null;
        if (type == 'Group' && $scope.isOneModelSelected($scope.selectedModel)) {
            if (obj.IS_DOA == 'Y') {
                $scope.GetDOAList(obj.MONTHLY_PROGRAM_ID);
            }

            $scope.SaveGroup_Submit = $scope.SaveBullatinWithAmount;

            $scope.GetConfigureGroup('Group', 0, obj.START_DATE, obj.END_DATE, $scope.FILTER.FILTER_FLEET_NAME, obj.MONTHLY_PROGRAM_ID, function (result) {
                console.log($scope.formData,result);
                $scope.formData = result;
                $scope.formData.FLEET_CAMPAIGN_AMOUNT = $scope.formData.CFG_CAMPAIGN_AMOUNT
                $scope.formData.ONTOP_M = $scope.formData.CFG_ONTOP_M
                $scope.formData.ONTOP_L = $scope.formData.CFG_ONTOP_L
                $scope.formData.ADD_ONTOP = $scope.formData.CFG_ADD_ONTOP
            });
        } else if (type == 'Group') {
            $scope.SaveGroup_Submit = $scope.SaveBullatin;

        } else if (type == 'Single') {
            if (obj.IS_DOA == 'Y') {
                $scope.GetDOAList(obj.MONTHLY_PROGRAM_ID);
            }
            console.log(' Single ');
            $scope.GetConfigureGroup('Single', obj.MONTHLY_PROGRAM_ID, obj.START_DATE, obj.END_DATE, $scope.formData.FLEET_NAME, obj.MONTHLY_PROGRAM_ID, function (result) {
                if (result) {
                    $scope.formData = BaseService.ObjectAssign($scope.formData, {
                        "CFG_CAMPAIGN_AMOUNT": result.CFG_CAMPAIGN_AMOUNT,
                        "CFG_ONTOP_M": result.CFG_ONTOP_M,
                        "CFG_ONTOP_L": result.CFG_ONTOP_L,
                        "CFG_ADD_ONTOP": result.CFG_ADD_ONTOP,
                        "FLEET_CAMPAIGN_AMOUNT": result.CFG_CAMPAIGN_AMOUNT,
                        "ONTOP_M": result.CFG_ONTOP_M,
                        "ONTOP_L": result.CFG_ONTOP_L,
                        "ADD_ONTOP": result.CFG_ADD_ONTOP,
                        "MONTHLY_PROGRAM_ID": result.MONTHLY_PROGRAM_ID,
                    });
                    console.log(' Assign ');
                } else {
                    $scope.formData = BaseService.ObjectAssign($scope.formData, {
                        "CFG_CAMPAIGN_AMOUNT": 0,
                        "CFG_ONTOP_M": 0,
                        "CFG_ONTOP_L": 0,
                        "CFG_ADD_ONTOP": 0,
                        "FLEET_CAMPAIGN_AMOUNT": 0,
                        "ONTOP_M": 0,
                        "ONTOP_L": 0,
                        "ADD_ONTOP": 0,
                        "MONTHLY_PROGRAM_ID": 0,
                    });
                    console.log('Not Assign ');
                }

            });
        }
    }

    $scope.GetDOAList = function (MONTHLY_PROGRAM_ID) {
        BaseService.GetDataTableByParam(FLEET_PATH, 'GetDOAAvailable', MONTHLY_PROGRAM_ID)
            .then(function (result) {
                if (result.length > 0) {
                    $scope.DOAs = result;
                    $scope.SetDOA($scope.formData.CURRENT_DOA_ID, 1);
                }
            }, function (error) {
                console.log('Unable to get DOA List by monthly ID: ' + error.message);
            })
    }

    $scope.SetDOA = function (objID, chassisAmount) {
        $scope.formData.DOA_ID = objID;
        $scope.thisDOA = $filter('filter')($scope.DOAs, { ID: (objID || 'x') }, true)[0];

        if ($scope.thisDOA) {
            $scope.thisDOA.SELECT_UNITS = chassisAmount;
            $scope.thisDOA.CAL_EXCEPT_UNITS = ($scope.formData.CURRENT_DOA_ID == $scope.thisDOA.ID) ? chassisAmount : 0;

            if ($scope.thisDOA && $scope.thisDOA.CHASSIS_COUNT + chassisAmount > $scope.thisDOA.DOA_CHASSIS_COUNT) {
                $scope.AbleToSave = false;
                $scope.thisDOA.labelColor = 'require';
            }
        }
    }

    $scope.SaveBullatin = function () {

        var data = BaseService.ConvertParam({
            "CHASSIS_NO": "''" + $scope.selector.join("'',''") + "''",
            "MONTHLY_PROGRAM_ID": $scope.fleetBullatin.MONTHLY_PROGRAM_ID,
            "ONTOP_FLAG": $scope.formData.ONTOP_FLAG
        }, "CHASSIS_NO");

        BaseService.CallAction(FLEET_PATH, "SaveBullatin", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit bullatin data: ' + error.message)
            })
    }

    $scope.SaveBullatinWithAmount = function () {

        let scopeData = $scope.formData;
        scopeData.CHASSIS_NO = "''" + $scope.selector.join("'',''") + "''";

        let data = BaseService.ConvertParam(scopeData, "CHASSIS_NO")

        BaseService.CallAction(FLEET_PATH, "SaveFleetAmountGroup", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit fleet group data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        document.getElementById('GroupModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
    $scope.Report_Click = function () {
        $scope.reportCode = 'VME_Rpt_FLT_Select_Bulletin';
        $scope.reportName = 'Fleet Select Bulletin';
        Date_From = $scope.DATE_FROM.getFullYear().toString() + ("00" + ($scope.DATE_FROM.getMonth() + 1).toString()).substr(-2) + ("00" + ($scope.DATE_FROM.getDate()).toString()).substr(-2);
        Date_To = $scope.DATE_TO.getFullYear().toString() + ("00" + ($scope.DATE_TO.getMonth() + 1).toString()).substr(-2) + ("00" + ($scope.DATE_TO.getDate()).toString()).substr(-2);
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + Date_From + '&p2=' + Date_To  + '&p3=' + $scope.reportName , '_blank');
    }
}])

app.controller("FleetSummaryController", ['$scope', 'BaseService', 'FLEET_PATH', 'BizDataService', '$window', function ($scope, BaseService, FLEET_PATH, BizDataService, $window) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListReport = null
        GetReport();
    }

    function GetReport() {
        BaseService.GetReportList('Fleet')
            .then(function (result) {
                $scope.ListReport = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.redirectTo = function (url) {
        $window.open(url, '_blank');
    };
}])

app.controller("FleetAccrueController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        GetHeader();
        InitailDataModel();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetAccrueSummary", data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.ModelData2 = result.Table1;
                $scope.ModelData3 = result.Table2;
                $scope.SubmitStatus = result.Table3[0];
                $scope.AccPayList = result.Table4[0];
                $scope.EnableSubmit = result.Table5[0];

                var DataGroup3 = $scope.ModelData3.map(function (obj) { return obj.DATA_MONTHNAME; });
                DataGroup3 = DataGroup3.filter(function (v, i) { return DataGroup3.indexOf(v) == i; });

                $scope.DataGroup3 = DataGroup3;
               

            }, function (error) {
                console.log('Unable to load GetFleetAccrueSummary: ' + error.message)
            })

        BaseService.CallAction(FLEET_PATH, "GetFleetAccrueHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetFleetAccrueHistory: ' + error.message)
            })

        if ($scope.ViewChassis == 1){

            if ($scope.ViewModel == 1) {
                fnGetDataModel = 'GetFleetAccrueAll';
                $scope.ModelHeader = $scope.ModelHeader4;
            } else if ($scope.ViewModel == 2) {
                fnGetDataModel = 'GetFleetAccrueCurrent';
                $scope.ModelHeader = $scope.ModelHeader4;
            } else {
                fnGetDataModel = 'GetFleetAccrueChargeBack';
                $scope.ModelHeader = $scope.ModelHeader5;
            }

            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
            var data = BaseService.ConvertParam(sendData[0]);
            BaseService.CallAction(FLEET_PATH, fnGetDataModel, data)
                .then(function (result) {
                    $scope.DetailData1 = result;

                }, function (error) {
                    console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
                })
        }
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
    }

    $scope.Accrue_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Accrue':
                confirmType = 'submit accrue';
                submitType = 'submitted';
                break;

            case 'AccrueApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'AccrueReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            case 'MSControlApprove':
                confirmType = '"Approve" accrue';
                submitType = 'approved';
                break;

            case 'MSControlReturn':
                confirmType = '"Return" accrue';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + " for this month?").then(function () {
            var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "STATUS": status, "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH) }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "SubmitAccrue", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load GetAccruePayment: ' + error.message)
                })
        })

    }

    $scope.Report_Click = function (pReportType) {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");
        var reportCode = '';
        var reportID = '';
        var reportName = '';
        if ($scope.SubmitStatus.APPROVE_ACCRUE == null || $scope.SubmitStatus.APPROVE_ACCRUE == 'MS_Return' || $scope.SubmitStatus.APPROVE_ACCRUE == 'GM_Return') {
            reportCode = 'VME_Rpt_CPN_D7';
            reportID = 41;
        } else {
            reportCode = 'VME_Rpt_FLT_D2';
            reportID = 42;
        }
        reportName = 'Fleet Accure - Detail';
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + reportName, '_blank');
    }
    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelFleetAccrue1';
        $scope.DVM_ACCRUE_TableName2 = 'ModelFleetSummary4';
        $scope.DVM_ACCRUE_TableName3 = 'FleetModelChargeBackWithMonth';
        $scope.DVM_ACCRUE_TableName4 = 'FleetAccrueDetail';
        $scope.DVM_ACCRUE_TableName5 = 'FleetAccrueChargeBack';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetFleetAccrueSummary';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        $scope.SubSection = 0;
        //  $scope.SubmitStatus = row;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.ModelData2 = result.Table1;
                $scope.ModelData3 = result.Table2;
                $scope.SubmitStatus = result.Table3[0];
                $scope.AccPayList = result.Table4[0];
                $scope.EnableSubmit = result.Table5[0];        
                
            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {
       
        $scope.ViewChassis = 1;

        if ($scope.ViewModel == 1) {
            fnGetDataModel = 'GetFleetAccrueAll';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else if ($scope.ViewModel == 2) {
            fnGetDataModel = 'GetFleetAccrueCurrent';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else {
            fnGetDataModel = 'GetFleetAccrueChargeBack';
            $scope.ModelHeader = $scope.ModelHeader5;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, fnGetDataModel , data)
            .then(function (result) {
                $scope.DetailData1 = result;              

            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

   $scope.ModelReport_Click = function (ReportNo) {
        var reportCode;
        var reportName;

        if (ReportNo == 'report0') {
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_AccrueSummary_ByModel';
                reportName = 'Fleet accrue summary';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
            }
            else if ($scope.ViewModel == 2) {
                reportCode = 'VME_Rpt_FLT_AccrueCurrentMonth_ByModel';
                reportName = 'Fleet accrue current month';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH +'&p2='+reportName, '_blank');
            }
            else{
                reportCode = 'VME_Rpt_FLT_AdjustAccrue_ByModel';
                reportName = 'Fleet adjust accrue';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH +'&p2='+reportName, '_blank');
            }
        }
        else if (ReportNo == 'report1') {
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_AccrueSummary_Detail';
                reportName = 'Fleet accrue summary detail';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
            }
            else if ($scope.ViewModel == 2) {
                reportCode = 'VME_Rpt_FLT_AccrueCurrentMonth_Detail';
                reportName = 'Fleet accrue current month detail';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH +'&p2='+reportName, '_blank');
            }
            else{
                reportCode = 'VME_Rpt_FLT_AdjustAccrue_Detail';
                reportName = 'Fleet adjust accrue detail';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&ExportName=FleetAccrue' + $scope.DATA_MONTH + '&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH +'&p2='+reportName, '_blank');
            }
        }    

       
    }

    //------------------- Data model section --------------------------

}])

app.controller("FleetPaymentController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        $scope.SubSection = 1;
        $scope.SubMenu = 1;

        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SUBMIT_DATE_FILTER = {};
        $scope.PaymentType = '1st';
        $scope.FILTER = {};
        $scope.FILTER1 = {};
        $scope.FILTER2 = {};
        $scope.FILTER3 = {};
        $scope.FILTER4 = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
        InitailDataModel();
        $scope.CBS_ViewAs = 'By Chassis';
        $scope.A_ViewAs = 'By Chassis';
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('FleetPayment1')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('ModelFleetSummary2')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptFleetPaymentDetail')
            .then(function (result) {
                $scope.ListHeader4 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];
        
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "GetPayment", data)
                .then(function (result) {
                    $scope.ListStatus = result.Table;

                    if ($scope.ID != 'undefined') { 
                        $scope.SubmitStatus = $filter('filter')(result.Table, { ID: $scope.ID }, true)[0];
                        //console.log($scope.SubmitStatus)
                    }
                }, function (error) {
                    console.log('Unable to load GetPayment: ' + error.message)
                })
        }, true)
    }
    
    function GetCancelledChassis() {
        $scope.ListDetail = [];
        var sendData = {
            "OPERATION_OF": $scope.OperationOf
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(FLEET_PATH, 'GetNotPaymentListCancelled', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
            }, function (error) {
                console.log('Unable to load cancelled chassis: ' + error.message);
            })
    }
    function GetSelectedPayment() {
        var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, 'GetNotPaymentList', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;     
            }, function (error) {
                console.log('Unable to load  GetNotPaymentList : ' + error.message)
            });
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;

        if (iChange == 1) {
            $scope.ListDetail = null;
            $scope.ListSelectedTmp = null;
            $scope.SumSelectedTmp = null;
            $scope.ListSelected = null;
            $scope.SumSelected = null;
            GetData();

        } else if (iChange == 2) {
            GetSelectedPayment();   
            $scope.SubMenu = 1;
        } else {
            return;
        }
    }

    $scope.SubMenu_Change = function (iChange) {
        if ($scope.SubMenu == iChange) {
            return;
        }
        $scope.SubMenu = iChange;
        if (iChange == 1) {
            GetSelectedPayment();   
            $scope.A_ModelData1 = null;
            $scope.A_ModelData2 = null;
            $scope.CBS_ModelData1 = null;
            $scope.CBS_ModelData2 = null;
        } else if(iChange == 2) {
            InitailDataModel_CBS();
            $scope.ListDetail = null;
            $scope.A_ModelData1 = null;
            $scope.A_ModelData2 = null;
            $scope.A_ModelHeader1 = null;
            $scope.A_ModelHeader2 = null;
            $scope.A_ModelHeader3 = null;
            $scope.A_ModelHeader4 = null;
        } else if (iChange == 3) {
            InitailDataModel_A();
            $scope.ListDetail = null;
            $scope.CBS_ModelData1 = null;
            $scope.CBS_ModelData2 = null;
            $scope.CBS_ModelHeader1 = null;
            $scope.CBS_ModelHeader2 = null;
            $scope.CBS_ModelHeader3 = null;
            $scope.CBS_ModelHeader4 = null;
        } else if (iChange == 4) {
            GetCancelledChassis();
        }
    }

    $scope.SetSubmitDate = function (obj) {
        $scope.SUBMIT_DATE_FILTER = obj;
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];
        let data_months = '';

        $scope.ListSelected = $scope.FilterOperationItem($scope.ListSelectedTmp, $scope.SUBMIT_DATE_FILTER);
        $scope.SumSelected = $scope.FilterOperationItem($scope.SumSelectedTmp, $scope.SUBMIT_DATE_FILTER);
        
        let uniqueDataMonth = $filter('unique')($scope.ListSelected, "DATA_MONTH");
        uniqueDataMonth.forEach(function (datamonth) {
            data_months = data_months + ',' + datamonth.DATA_MONTH;
        })

        $scope.data_months = data_months.substr(1, data_months.length - 1);
    }

    $scope.FilterOperationItem = function (TargetObject, ObjectToCompare) {
        return (
            ($scope.OperationOf == 'Manager') ?
                $filter('filter')(TargetObject, { ID: ((ObjectToCompare != null && ObjectToCompare.hasOwnProperty('ID') ? ObjectToCompare.ID : null)) }, true) :
                TargetObject
        )
    }

    $scope.SelectPayment_Submit = function (type) {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        if(type=='All') {
            $scope.ListDetail.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
        } else {
            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
        }
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS");

        BaseService.CallAction(FLEET_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetSelectedPayment();
                    //GetData_CBS();
                    //GetData_A();
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }
    
    $scope.CancelPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        BaseService.Message.confirm("Would you like to cancel the payment for selected chassis?").then(function () {

            var chassis = [];

            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })

            var data = BaseService.ConvertParam({
                "CHASSIS": chassis,
                "PAYMENT_TYPE": $scope.PaymentType
            }, "CHASSIS");

            BaseService.CallAction(FLEET_PATH, "CancelSelectPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetSelectedPayment();
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })

        })


    }

    $scope.UndoCancel_Submit = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis
        })
        BaseService.Message.confirm("Would you like to reverse the cancelled chassis to payment?")
            .then(function () {
                BaseService.CallAction(FLEET_PATH, "UndoCancelledChassis", data)
                    .then(function (result) {
                        if (result == "Done") {
                            BaseService.Message.info("Successfully saved.");
                            GetCancelledChassis();
                        }
                    }, function (error) {
                        console.log("Unable to reverse chassis: " + chassis + ": " + error.message);
                    })
            })
    }
    $scope.SelectAllPayment_Submit = function (type) {
        var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "SelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetSelectedPayment();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }
    
    $scope.UnSelectAll_Submit = function () {
        var sendData = [{ "P": "OK" }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "UnSelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData_A();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }

    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS_NO");

        BaseService.CallAction(FLEET_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData_A();
                   // GetSelectedPayment();
                    //BaseService.Message.info("Successfully saved.");tid
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(FLEET_PATH, "SubmitPayment", data)
                .then(function (result) {
                    GetData();                     
                    if ($scope.SubMenu == 3) {
                        GetData_A();                           
                    } else {
                        GetData_DVM($scope.ID);
                    }
                       
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }

    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;

    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];

        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }

        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }

            (filterResult) ? n++ : null;

            return filterResult;
        }
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel == 1;
        $scope.ID = row.ID;
        $scope.SubmitStatus = row;
        GetData_DVM($scope.ID);

    }

    //------------------- CB Data model section --------------------------
    function InitailDataModel_CBS() {
        //---- Data model
        $scope.CBS_ViewModel = 1;
        $scope.CBS_TableName1 = 'FleetChargeBackList';
        $scope.CBS_TableName2 = 'FleetModelChargeBack';
        $scope.CBS_TableName3 = 'FleetChargeBackDealerList';
        $scope.CBS_TableName4 = 'FleetChargeBackOutletList';
        $scope.CBS_TableName5 = 'x';
        $scope.MatchMode = 1;
        GetDataModelHeader_CBS();

        var sendData = [{ "ID": "0" }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, 'GetChargeBackSelectedPaymentByChassis', data)
            .then(function (result) {
                $scope.CBS_ModelData1 = result.Table;
                $scope.CBS_ModelData2 = result.Table1;
                $scope.CBS_ModelData = $scope.CBS_ModelData1;
            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ': ' + error.message)
            })
    }
    
    function GetDataModelHeader_CBS() {
        var sendData = [{
            'TableName1': $scope.CBS_TableName1
            , 'TableName2': $scope.CBS_TableName2
            , 'TableName3': $scope.CBS_TableName3
            , 'TableName4': $scope.CBS_TableName4
            , 'TableName5': $scope.CBS_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.CBS_ModelHeader1 = result.Table;
                $scope.CBS_ModelHeader2 = result.Table1;
                $scope.CBS_ModelHeader3 = result.Table2;
                $scope.CBS_ModelHeader4 = result.Table3;
                $scope.CBS_ModelHeader = $scope.CBS_ModelHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click_CBS = function (ViewModel) {   
        $scope.CBS_ViewDetail = true;
        //$scope.CBS_ViewModel = ViewModel;

        if (ViewModel == 1) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByChassis';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader1;
            $scope.CBS_ViewAs = 'By Chassis';
        } else if (ViewModel == 2) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByModel';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader2;
            $scope.CBS_ViewAs = 'By Base model';
        } else if (ViewModel == 3) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByDealer';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader3;
            $scope.CBS_ViewAs = 'By Dealer';
        } else if (ViewModel == 4) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByOutlet';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader4;
            $scope.CBS_ViewAs = 'By Outlet';
        } else {
            return;
        }
        GetData_CBS();      
    }

    function GetData_CBS() {

        var sendData = [{ "ID": "0" }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.CBS_fnGetDataModel, data)
            .then(function (result) {
                $scope.CBS_ModelData1 = result.Table;
                $scope.CBS_ModelData2 = result.Table1;
                $scope.ChangeMatch_Click_CBS($scope.MatchMode);
            }, function (error) {
                console.log('Unable to load ' + $scope.CBS_fnGetDataModel + ': ' + error.message)
            })
    }

    $scope.ChangeMatch_Click_CBS = function (iChange) {
        $scope.MatchMode = iChange;
        if (iChange == 1) {
            $scope.CBS_ModelData = $scope.CBS_ModelData1;

        } else {
            $scope.CBS_ModelData = $scope.CBS_ModelData2;

        }
    }

    //------------------- Select payment : Data model section --------------------------

    function InitailDataModel_A() {
        //---- Data model
        $scope.A_ViewModel = 1;

        $scope.A_TableName1 = 'FleetPaymentSelectedWithCB';
        $scope.A_TableName2 = 'FleetPaymentWithCBbyModel';
        $scope.A_TableName3 = 'PaymentChargeBackDealerList';
        $scope.A_TableName4 = 'PaymentChargeBackOutletList';
        $scope.A_TableName5 = 'x';
        $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBack';
                
        $scope.submitButton = 1;
        GetDataModelHeader_A();
        GetData_A();
    }

    function GetDataModelHeader_A() {
        var sendData = [{
            'TableName1': $scope.A_TableName1
            , 'TableName2': $scope.A_TableName2
            , 'TableName3': $scope.A_TableName3
            , 'TableName4': $scope.A_TableName4
            , 'TableName5': $scope.A_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.A_ModelHeader1 = result.Table;
                $scope.A_ModelHeader2 = result.Table1;
                $scope.A_ModelHeader3 = result.Table2;
                $scope.A_ModelHeader4 = result.Table3;
                $scope.A_ModelHeader = $scope.A_ModelHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.A_ViewDetail_Change = function (iNumber) {
        $scope.A_ViewModel = iNumber;
    }

    function GetData_A() {

        var sendData = [{ "ID": "0" }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, $scope.A_fnGetDataModel , data)
            .then(function (result) {

                $scope.A_DVM_ModelData1 = result.Table;
                $scope.A_DVM_ModelData2 = result.Table1;
                $scope.A_DVM_ModelData3 = result.Table2;
                $scope.A_DVM_ModelData4 = result.Table3;
                
            }, function (error) {
                console.log('Unable to load ' + $scope.A_fnGetDataModel + ': ' + error.message)
            })
    }

    //------------------- History : Data model section --------------------------

    function InitailDataModel() {
        //---- Data model
        $scope.ViewModel = 1;

        $scope.DVM = {};
        $scope.DVM_TableName1 = 'FleetPaymentSelectedWithCB';
        $scope.DVM_TableName2 = 'FleetPaymentWithCBbyModel';
        $scope.DVM_TableName3 = 'PaymentChargeBackDealerList'; //'FleetPaymentDealerList';
        $scope.DVM_TableName4 = 'PaymentChargeBackOutletList'; //'FleetPaymentOutletList';
        $scope.DVM_TableName5 = 'x';
        $scope.DVM_fnGetDataModel = 'GetPaymentSubmitByModel';

        GetDataModelHeader();
    }

    function GetDataModelHeader() {

        var sendData = [{
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }
    
    function GetData_DVM(ID) {
        var sendData = [{ "ID": ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.DVM_fnGetDataModel, data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_fnGetDataModel + ' : ' + error.message)
            })

    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    //-----------------------------------------------------------------------------------------------------------------------------
    $scope.ModelReport_Click = function (ReportNo) {

        
        if ($scope.SubSection == 1) {
            if (ReportNo == 'report1') {
                $scope.reportCode = 'VME_Rpt_FLT_Payment_ByChassis';
                $scope.reportName = 'Fleet payment detail by chassis';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');

            } else if (ReportNo == 'report2') {
                $scope.reportCode = 'VME_Rpt_FLT_Payment_ByModel';
                $scope.reportName = 'Fleet payment detail by base model';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');
            } else if (ReportNo == 'report3') {
                $scope.reportCode = 'VME_Rpt_FLT_Payment_ByDealer';
                $scope.reportName = 'Fleet payment detail by dealer';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');
            } else if (ReportNo == 'report4') {
                $scope.reportCode = 'VME_Rpt_FLT_Payment_ByOutlet';
                $scope.reportName = 'Fleet payment detail by outlet';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');
            }
        }
        else if ($scope.SubSection == 2) {
            if ($scope.SubMenu == 2) {
                if (ReportNo == 'report1') {
                    $scope.reportCode = 'VME_Rpt_FLT_CB_Selected_Payment_ByChassis';
                    $scope.reportName = 'Fleet charge back selected payment by chassis';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.MatchMode + '&p2=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report2') {
                    $scope.reportCode = 'VME_Rpt_FLT_CB_Selected_Payment_ByModel';
                    $scope.reportName = 'Fleet charge back selected payment by model';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.MatchMode + '&p2=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report3') {
                    $scope.reportCode = 'VME_Rpt_FLT_CB_Selected_Payment_ByDealer';
                    $scope.reportName = 'Fleet charge back selected payment by dealer';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.MatchMode + '&p2=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report4') {
                    $scope.reportCode = 'VME_Rpt_FLT_CB_Selected_Payment_ByOutlet';
                    $scope.reportName = 'Fleet charge back selected payment by outlet';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.MatchMode + '&p2=' + $scope.reportName, '_blank');
                }
            }
            else if ($scope.SubMenu == 3) {
                if (ReportNo == 'report1') {
                    $scope.reportCode = 'VME_Rpt_FLT_Payment_With_CB_ByChassis';
                    $scope.reportName = 'Fleet payment with charge back by chassis';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report2') {
                    $scope.reportCode = 'VME_Rpt_FLT_Payment_With_CB_ByModel';
                    $scope.reportName = 'Fleet payment with charge back by model';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report3') {
                    $scope.reportCode = 'VME_Rpt_FLT_Payment_With_CB_ByDealer';
                    $scope.reportName = 'Fleet payment with charge back by dealer';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.reportName, '_blank');
                }
                else if (ReportNo == 'report4') {
                    $scope.reportCode = 'VME_Rpt_FLT_Payment_With_CB_ByOutlet';
                    $scope.reportName = 'Fleet payment with charge back by outlet';
                    window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.reportName, '_blank');
                }
            }
        }
    }
    //------------------- Data model section --------------------------

}])

app.controller("FleetCheckUploadController", ['$scope', 'BaseService', 'FLEET_PATH', 'Upload', 'BizDataService', '$filter', '$timeout', 'REPORT_PATH', function ($scope, BaseService, FLEET_PATH, Upload, BizDataService, $filter, $timeout, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.CB = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.FILTER = {};
        $scope.selector = [];
        $scope.selectedModel = [];
        $scope.format = 'd!-MMM-yy';
        $scope.Section = 1;
        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        if ($scope.Section == 5 || $scope.Section == 3) {
            BaseService.GetHeaderGridView('FleetCheckUploadWaitingList')
                .then(function (result) {
                    $scope.ListHeader = result

                }, function (error) {
                    console.log('Unable to load dealer header data: ' + error.message)
                });
        } else if ($scope.Section == 1 || $scope.Section == 2 || $scope.Section==4) {
            BaseService.GetHeaderGridView('FleetCheckUploadedList')
                .then(function (result) {
                    $scope.ListHeader = result;
                }, function (error) {
                    console.log('Unable to load dealer header data: ' + error.message)
                });
        }
    }

    function GetData() {
        $scope.FILTER = {};
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        $scope.ListDetail = [];
        if ($scope.Section == 5) {
            BaseService.CallAction(FLEET_PATH, "GetFleetWaitingForUpload", data)
                .then(function (result) {
                    $scope.ListDetail = result
                }, function (error) {
                    console.log('Unable to load GetFleetChargeBack data: ' + error.message)
                });
	}else if ($scope.Section == 3) {
            BaseService.CallAction(FLEET_PATH, "GetFleetExpiredForUpload", data)
                .then(function (result) {
                    $scope.ListDetail = result
                }, function (error) {
                    console.log('Unable to load GetFleetChargeBack data: ' + error.message)
                });
        } else if ($scope.Section == 1) {
            BaseService.CallAction(FLEET_PATH, "GetFleetUploaded", data)
                .then(function (result) {
                    $scope.ListDetail = result
                }, function (error) {
                    console.log('Unable to load GetFleetUploaded data: ' + error.message)
                });
        } else if ($scope.Section == 2) {
            BaseService.CallAction(FLEET_PATH, "GetFleetIncompleteForUpload", data)
                .then(function (result) {
                    $scope.ListDetail = result
                }, function (error) {
                    console.log('Unable to load GetFleetIncompleteForUpload data: ' + error.message)
                });
        } else if ($scope.Section == 4) {
            BaseService.CallAction(FLEET_PATH, "GetFleetCompleteForUpload", data)
                .then(function (result) {
                    $scope.ListDetail = result
                }, function (error) {
                    console.log('Unable to load GetFleetCompleteForUpload data: ' + error.message)
                });
        }
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        $scope.FILTER = {};
        GetData();
    }

    $scope.ShowItem_Click = function (ID) {

        document.getElementById('DetailModal').style.display = 'block';
        $scope.ID = ID;
        GetDetail(ID);
    }
    
    $scope.ShowFleetGroup_Click = function (item) {
        BaseService.Message.confirm("Would you like to check group chassis?")
            .then(function () {
                GetFleetGroup(item.DOC_ID, item.FLEET_NAME)
                document.getElementById('GroupModal').style.display = 'block';
            }, function () {
                $scope.ShowItem_Click(item.CHASSIS_NO);
            })
    }
    
    function GetFleetGroup(DOC_ID, FLEET_NAME) {
        $scope.FleetGroupList = [];
        $scope.formGroup = {};
        $scope.selector = [];
        
        GetFleetGroupList(DOC_ID, FLEET_NAME, function (result) {
            $scope.FleetGroupList = result
            $scope.FleetGroupList.forEach(function(item) {
                $scope.selector.push(item.CHASSIS_NO);
            })
            $scope.formGroup = {
                DOC_FLAG: $scope.FleetGroupList[0].DOC_FLAG,
                REMARKS: $scope.FleetGroupList[0].REMARKS,
                DOC_REF: $scope.FleetGroupList[0].DOC_REF,
                DOCUMENT_FILE_PATH: $scope.FleetGroupList[0].DOCUMENT_FILE_PATH,
                FLEET_NAME: $scope.FleetGroupList[0].FLEET_NAME,
            }
        });

    }
    function GetFleetGroupList(DOC_ID, FLEET_NAME, fn) {
        let data = BaseService.ConvertParam({
            DOC_ID: DOC_ID,
            FLEET_NAME: FLEET_NAME,
        })

        BaseService.CallAction(FLEET_PATH, "GetFleetGroupList", data)
            .then(function(result) {
                (typeof fn == 'function') ? fn(result) : null;
            }, function(error, msg) {
                console.log('Unable to get fleet group list');
            })
    }
    
    function GetDetail(ID) {

        $scope.selectChassis = ID;
        
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetResult", data)
            .then(function (result) {
                $scope.formData = result[0];
                $scope.GetChargeBackTypeList();
                if ($scope.formData.DOCUMENT_FILE_PATH) {
                    let fileUploadPath = $scope.formData.DOCUMENT_FILE_PATH;
                    let lastPathSign = fileUploadPath.lastIndexOf("/");
                    let fileNameLength = fileUploadPath.length - lastPathSign;
                    $scope.UploadedFileName = fileUploadPath.substr(lastPathSign + 1, fileNameLength);
                }
            }, function (error) {
                BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetFleetResult 1 data: ' + error.message)
            })

    }

    $scope.GetChargeBackTypeList = function () {

        $scope.formData.CHARGE_BACK = null;
        BaseService.CallAction(FLEET_PATH, "GetChargeBackType")
            .then(function (result) {
                $scope.ChargeBackTypeList = result;
            }, function (error) {
                console.log('Unable to load GetChargeBackType data: ' + error.message)
            })
    }

    $scope.CB_Type_Change = function () {

        if ($scope.formData.DOC_FLAG == 'B') {

            var sendData = [{ "CHASSIS_NO": $scope.formData.CHASSIS_NO }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "GetChargeBackAmount", data)
                .then(function (result) {
                    $scope.formData.CHARGE_BACK = result[0].CHARGE_BACK;
                    $scope.CB = result[0];
                    console.log(result[0]);
                }, function (error) {
                    console.log('Unable to load GetChargeBackAmount: ' + error.message)
                })
        } else {
            $scope.formData.CHARGE_BACK = 0;
        }

        
    }
    
    $scope.SaveGroup_Submit = function () {

        let scopeData = { 
            Chassis: $scope.selector, 
            DOC_FLAG: $scope.formGroup.DOC_FLAG,
            REMARKS: $scope.formGroup.REMARKS
        }

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(FLEET_PATH, "UpdateDocGroupStatus", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                $scope.selector = [];
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to edit fleet data: ' + error.message)
            })
    }

    $scope.Save_Submit = function () {

        if ($scope.formData.DOC_FLAG == 'I' && ($scope.formData.REMARKS == '' || $scope.formData.REMARKS == null)) {
            BaseService.Message.alert("Please fill remark field");
            return;
        }

        if ($scope.formData.DOC_FLAG == 'B' && ($scope.formData.CHARGE_BACK_TYPE == '' || $scope.formData.CHARGE_BACK_TYPE == null)) {
            BaseService.Message.alert("Please fill Charge back type field.")
            return;
        }
        if ($scope.formData.DOC_FLAG == 'B' && ($scope.formData.CHARGE_BACK == '' || $scope.formData.CHARGE_BACK == null)) {
            BaseService.Message.alert("Please fill Charge back field.")
            return;
        }

        let scopeData = $scope.formData;
        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(FLEET_PATH, "UpdateDocStatus", data)
            .then(function (result) {
                BaseService.Message.info('Successfully saved');
                GetData();
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }


    $scope.SaveFleet_Submit = function () {

        var file = this.fileUpload;

        file.upload = Upload.upload({
            url: window.location.origin + FLEET_PATH + '/UploadPaymentDoc',
            data: { File: file, Chassis: $scope.selectChassis, DealerID: $scope.DEALER_ID, DocRef: $scope.formData.DOC_REF },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                BaseService.Message.info('Upload file completed').then(function () {
                    $scope.fileUpload = null;
                    GetData();
                    GetDetail($scope.ID);
                })
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });

    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.filterItem = function () {
        const date = new Date();
        const currentDate = new Date(date.getFullYear(), date.getMonth(), date.getDate())

        return function (input) {

            let filterResult = true;
            let expireDate = new Date(input._EXPIRED_DATE);

            /*if ($scope.Section == 3) {
                filterResult = expireDate < currentDate;
            } else if ($scope.Section == 5) {
                filterResult = expireDate >= currentDate;
            }*/
            if (filterResult) {
                //filter with $scope.FILTER (like case)
                Object.keys($scope.FILTER).forEach(function (item) {
                    if ($scope.FILTER[item] == null) {
                        filterResult = true;
                    } else if ((input[item]).toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                        filterResult = false;
                    }
                });
            }

            return filterResult;
        }
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        document.getElementById('GroupModal').style.display = 'none';
       
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.$watch('Section', function (val) {
        if(val) {
            GetHeader();
            GetData();
        }
    }, true);
    
    //----Error catch
    $scope.CheckFileUpload = function(file, error) {
        setTimeout(function() {
            let invalidFile = $scope[error]
            if (invalidFile && invalidFile.$error == 'maxSize') {
                BaseService.Message.alert("ไฟล์ต้องมีขนาดไม่เกิน " + invalidFile.$errorParam);
            }
        },100)
    }

    $scope.Report_Click = function () {
            switch ($scope.Section) {
                case 1:
                    $scope.reportCode = 'VME_Rpt_FLT_Check_ByUploaded';
                    $scope.reportName = 'Fleet upload checking - Uploaded';
                    $scope.CheckType = 'uploaded';
                    break;
                case 4:
                    $scope.reportCode = 'VME_Rpt_FLT_Check_ByUploaded';
                    $scope.reportName = 'Fleet upload checking - Completed';
                    $scope.CheckType = 'completed';
                    break;
                case 2:
                    $scope.reportCode = 'VME_Rpt_FLT_Check_ByUploaded';
                    $scope.reportName = 'Fleet upload checking - Incompleted';
                    $scope.CheckType = 'incompleted';
                    break;
                case 5:
                    $scope.reportCode = 'VME_Rpt_FLT_Check_ByUploaded';
                    $scope.reportName = 'Fleet upload checking - Waiting';
                    $scope.CheckType = 'waiting';
                    break;
                case 3:
                    $scope.reportCode = 'VME_Rpt_FLT_Check_ByUploaded';
                    $scope.reportName = 'Fleet upload checking - Expired';
                    $scope.CheckType = 'expired';
                    break;
                default:
                    break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.CheckType + '&p3=' + $scope.reportName, '_blank');
        }
}])

app.controller("FleetChargeBackController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        //$scope.SubSection = 0;

        //---- Data model
        InitailDataModel();

        $scope.ChangeBackType = 'Doc';
        $scope.FILTER = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();

        GetData();
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    function GetHeader() {

        var sendData = [{
            'TableName1': 'ChangeBackStatus'
            , 'TableName2': 'FleetChargeBackList'
            , 'TableName3': 'x', 'TableName4': 'x', 'TableName5': 'x'
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;

            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });

    }

    function GetData() {
        let data_months = '';
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "GetFleetChargeBack", data)
                .then(function (result) {

                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListBaseModel = result.Table2;

                }, function (error) {
                    console.log('Unable to load GetFleetChargeBack: ' + error.message)
                })
        }, true)
    }

    $scope.ShowItem_Click = function (ID,forceAllow) {
        if(forceAllow) {
            $scope.AllowSave = forceAllow;
        }

        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetResult", data)
            .then(function (result) {
                $scope.formData = result[0];
                $scope.GetChargeBackTypeList();
            }, function (error) {
                BaseService.Message.alert('Session error or expired. Please try to log-in again.');
                console.log('Unable to load GetFleetResult 1 data: ' + error.message)
            })
    }
    
    $scope.GetChargeBackTypeList = function () {

        BaseService.CallAction(FLEET_PATH, "GetChargeBackType")
            .then(function (result) {
                $scope.ChargeBackTypeList = result;
            }, function (error) {
                console.log('Unable to load GetChargeBackType data: ' + error.message)
            })
    }
    
    $scope.Save_Submit = function () {

        if ($scope.formData.DOC_FLAG == 'I' && ($scope.formData.REMARKS == '' || $scope.formData.REMARKS == null)) {
            BaseService.Message.alert("Please fill remark field");
            return;
        }

        if (($scope.formData.DOC_FLAG == 'B' || $scope.formData.DOC_FLAG == 'CB') 
            && ($scope.formData.CHARGE_BACK_TYPE == '' || $scope.formData.CHARGE_BACK_TYPE == null)) {
            BaseService.Message.alert("Please fill Charge back type field.")
            return;
        }
        if (($scope.formData.DOC_FLAG == 'B' || $scope.formData.DOC_FLAG == 'CB') 
            && ($scope.formData.CHARGE_BACK == '' || $scope.formData.CHARGE_BACK == null)) {
            BaseService.Message.alert("Please fill Charge back field.")
            return;
        }

        let scopeData = $scope.formData;
        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(FLEET_PATH, "UpdateDocStatus", data)
            .then(function (result) {
                //document.getElementById('DetailModal').style.display = 'none';
                GetData();
                $scope.ViewDetail_Click($scope.SubmitStatus)
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function () {
        document.getElementById("DetailModal").style.display = "none";
    }

    $scope.ChargeBack_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'ChargeBack':
                confirmType = 'submit charge back';
                submitType = 'submitted';
                break;

            case 'ChargeBackApprove':
                confirmType = '"Approve" charge back';
                submitType = 'approved';
                break;

            case 'ChargeBackReturn':
                confirmType = '"Return" charge back';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "CHARGE_BACK_TYPE": $scope.ChangeBackType,
                "ID": ($scope.CHARGE_BACK_ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(FLEET_PATH, "SubmitChargeBack", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                        $scope.SubSection_Change(2);
                        BaseService.Message.info("Successfully " + submitType + ".");
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;

    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];

        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }

        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }

            (filterResult) ? n++ : null;

            return filterResult;
        }
    }

    //------------------- Data model section --------------------------
    function InitailDataModel() {
        //---- Data model
        $scope.ViewModel = 1;


        $scope.DVM = {};
        $scope.DVM_TableName1 = 'FleetChargeBackList';
        $scope.DVM_TableName2 = 'FleetModelChargeBack';
        $scope.DVM_TableName3 = 'FleetChargeBackDealerList';
        $scope.DVM_TableName4 = 'FleetChargeBackOutletList';
        $scope.DVM_TableName5 = 'x';
        $scope.DVM_fnGetDataModel = 'GetChargeBackSubmitDetail';

        GetDataModelHeader();
    }


    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });

    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel == 1;
        $scope.CHARGE_BACK_ID = row.ID;
        $scope.SubmitStatus = row;
        $scope.AllowSave = row.APPROVE != 'GM_Approved';

        var sendData = [{ "ID": row.ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.DVM_fnGetDataModel, data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;


            }, function (error) {
                console.log('Unable to load GetChargeBackSubmitDetail: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        if($scope.SubSection==2){
        if (ReportNo == 'report1') {
            $scope.reportCode = 'VME_Rpt_FLT_ChargeBack_ByChassis';
            $scope.reportName = 'Charge back detail by chassis';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + $scope.reportName, '_blank');

        } else if (ReportNo == 'report2') {
            $scope.reportCode = 'VME_Rpt_FLT_ChargeBack_ByModel';
            $scope.reportName = 'Charge back detail by base model';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + $scope.reportName, '_blank');
        } else if (ReportNo == 'report3') {
            $scope.reportCode = 'VME_Rpt_FLT_ChargeBack_ByDealer';
            $scope.reportName = 'Charge back detail by dealer';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + $scope.reportName, '_blank');
        } else if (ReportNo == 'report4') {
            $scope.reportCode = 'VME_Rpt_FLT_ChargeBack_ByOutlet';
            $scope.reportName = 'Charge back detail by outlet';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + $scope.reportName, '_blank');
            }
        }
        else if($scope.SubSection==0){
            $scope.reportCode = 'VME_Rpt_FLT_CB_NotSubmit_ByChassis';
            $scope.reportName = 'Charge back chassis (Not submit)';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.OperationOf + '&p2=' + $scope.reportName, '_blank');
        }
    }

    //------------------- Data model section --------------------------

}])

app.controller("FleetPaymentChargeBackController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        $scope.SubSection = 2;
        GetDataModelHeader();
        //---- Data model
        $scope.ViewModel = 3;

        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SUBMIT_DATE_FILTER = {};
        $scope.PaymentType = '1st';
        $scope.FILTER = {};
        $scope.FILTER1 = {};
        $scope.FILTER2 = {};
        $scope.FILTER3 = {};
        $scope.FILTER4 = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('FleetPayment1')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('ModelFleetSummary2')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptFleetPaymentDetail')
            .then(function (result) {
                $scope.ListHeader4 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];
        let data_months = '';
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{ "OPERATION_OF": $scope.OperationOf }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "GetPayment", data)
                .then(function (result) {
                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListSelectedTmp = result.Table2;
                    $scope.SumSelectedTmp = result.Table3;
                    if ($scope.OperationOf == 'Manager') {
                        $scope.ListSubmitDate = result.Table4;
                    }
                    $scope.ListSelected = $scope.FilterOperationItem($scope.ListSelectedTmp, $scope.SUBMIT_DATE_FILTER);
                    $scope.SumSelected = $scope.FilterOperationItem($scope.SumSelectedTmp, $scope.SUBMIT_DATE_FILTER);

                    let uniqueDataMonth = $filter('unique')($scope.ListSelected, "DATA_MONTH");
                    uniqueDataMonth.forEach(function (datamonth) {
                        data_months = data_months + ',' + datamonth.DATA_MONTH;
                    })

                    $scope.data_months = data_months.substr(1, data_months.length - 1);
                }, function (error) {
                    console.log('Unable to load GetPayment: ' + error.message)
                })
        }, true)
    }
    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewModel == 1;
        $scope.GetDataTab();
    }

    $scope.SetSubmitDate = function (obj) {
        $scope.SUBMIT_DATE_FILTER = obj;
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];
        let data_months = '';

        $scope.ListSelected = $scope.FilterOperationItem($scope.ListSelectedTmp, $scope.SUBMIT_DATE_FILTER);
        $scope.SumSelected = $scope.FilterOperationItem($scope.SumSelectedTmp, $scope.SUBMIT_DATE_FILTER);


        let uniqueDataMonth = $filter('unique')($scope.ListSelected, "DATA_MONTH");
        uniqueDataMonth.forEach(function (datamonth) {
            data_months = data_months + ',' + datamonth.DATA_MONTH;
        })

        $scope.data_months = data_months.substr(1, data_months.length - 1);
    }

    $scope.FilterOperationItem = function (TargetObject, ObjectToCompare) {
        return (
            ($scope.OperationOf == 'Manager') ?
                $filter('filter')(TargetObject, { ID: ((ObjectToCompare != null && ObjectToCompare.hasOwnProperty('ID') ? ObjectToCompare.ID : null)) }, true) :
                TargetObject
        )
    }

    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        $scope.SelectedChassis.forEach(function (item) {
            chassis.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS");

        BaseService.CallAction(FLEET_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    //BaseService.Message.info("Successfully saved.");tid
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS_NO");

        BaseService.CallAction(FLEET_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    //BaseService.Message.info("Successfully saved.");tid
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.Payment_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }


        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(FLEET_PATH, "SubmitPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                        $scope.SubmitStatus.APPROVE_PAYMENT = 'ACC_Approved';
                        BaseService.Message.info("Successfully " + submitType + ".");
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }

    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;

    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];

        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }

        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }

            (filterResult) ? n++ : null;

            return filterResult;
        }
    }


    //------------------- Data model section --------------------------
    function GetDataModelHeader() {
        
        var sendData = [{ 'TableName1': 'PaymentChargeBackDealerList', 'TableName2': 'PaymentChargeBackOutletList', 'TableName3': 'x', 'TableName4': 'x', 'TableName5': 'x' }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader3 = result.Table;
                $scope.ModelHeader4 = result.Table1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.GetDataTab = function () {
        var fnName = 'GetPaymentWithChargeBack';

        var sendData = [{ "ID": $scope.ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, fnName, data)
            .then(function (result) {
                $scope.ModelData3 = result.Table;
                $scope.ModelData4 = result.Table1;

            }, function (error) {
                console.log('Unable to load ' + fnName + ': ' + error.message)
            })
    }

    $scope.ViewDetail_Click = function (row) {

        $scope.ViewDetail = true;
        $scope.ViewModel == 1;

        $scope.ID = row.ID;
        $scope.SubmitStatus = row;
        $scope.GetDataTab();
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {

        if (ReportNo == 'report3') {
            $scope.reportCode = 'VME_Rpt_FLT_PWC_Summary_ByDealer';
            $scope.reportName = 'Payment with charge back summary by dealer';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');

        } else if (ReportNo == 'report4') {
            $scope.reportCode = 'VME_Rpt_FLT_PWC_Summary_ByOutlet';
            $scope.reportName = 'Payment with charge back summary by outlet';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.ID + '&p2=' + $scope.reportName, '_blank');
        }
    }

}])

app.controller("FleetReconController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
        $scope.Section = 0;

        GetHeader();
        InitailDataModel();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ReconStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {

        BaseService.CallAction(FLEET_PATH, "GetFleetReconHistory", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetFleetReconHistory: ' + error.message)
            })


        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetReconcile", data)
            .then(function (result) {

                $scope.ModelData1 = result.Table;
                $scope.ModelData3 = result.Table1;
                $scope.SubmitStatus = result.Table2[0];
                $scope.AccPayList = result.Table3[0];

                var DataGroup3 = $scope.ModelData3.map(function (obj) { return obj.DATA_MONTHNAME; });
                DataGroup3 = DataGroup3.filter(function (v, i) { return DataGroup3.indexOf(v) == i; });

                $scope.DataGroup3 = DataGroup3;
            }, function (error) {
                console.log('Unable to load GetAccruePayment: ' + error.message)
            })          

    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    $scope.Reconcile_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Reconcile':
                confirmType = 'submit reconcile';
                submitType = 'submitted';
                break;

            case 'ReconcileApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'ReconcileReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" reconcile';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" reconcile';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = [{
                "DATA_MONTH": $scope.DATA_MONTH,
                "STATUS": status,
                "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH)
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(FLEET_PATH, "SubmitRecon", data)
                .then(function (result) {
                    GetData();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load Submit reconcile: ' + error.message)
                })
        })

    }


    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelFleetRecon';
        $scope.DVM_ACCRUE_TableName2 = 'ModelFleetSummary2';
        $scope.DVM_ACCRUE_TableName3 = 'FleetModelChargeBackWithMonth';
        $scope.DVM_ACCRUE_TableName4 = 'FleetReconDetail';
        $scope.DVM_ACCRUE_TableName5 = 'FleetAccrueChargeBack';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetReconcile';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.DATA_MONTH = row.DATA_MONTH;

        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        $scope.SubSection = 0;
        //  $scope.SubmitStatus = row;

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.ModelData3 = result.Table1;
                $scope.SubmitStatus = result.Table2[0];
                $scope.AccPayList = result.Table3[0];
                // $scope.ModelData1 = result.Table;
                // $scope.ModelData2 = result.Table1;
                // $scope.ModelData3 = result.Table2;
                // $scope.SubmitStatus = result.Table3[0];
                // $scope.AccPayList = result.Table4[0];
                // $scope.EnableSubmit = result.Table5[0];

            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;

        if ($scope.ViewModel == 1) {
            fnGetDataModel = 'GetFleetReconAll';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else if ($scope.ViewModel == 2) {
            fnGetDataModel = 'GetFleetAccrueCurrent';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else {
            fnGetDataModel = 'GetFleetReconChargeBackByChassis';
            $scope.ModelHeader = $scope.ModelHeader5;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, fnGetDataModel, data)
            .then(function (result) {
                $scope.DetailData1 = result;

            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode;
        var reportName;
        var CB_FLAG;
    
        if (ReportNo == 'report0') {
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_ReconSummary_ByModel';
                reportName = 'Fleet reconcile summary';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
            }
            else if($scope.ViewModel == 3){
                reportCode = 'VME_Rpt_FLT_ReconAdjustAccrue_ByModel';
                reportName = 'Fleet reconcile adjust accrue';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
            }
        }
        else if(ReportNo == 'report1'){
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_ReconSummary_Detail';
                reportName = 'Fleet reconcile summary detail';
                CB_FLAG ='N'
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + CB_FLAG + '&p3=' + reportName, '_blank');
            }
            if ($scope.ViewModel == 3) {
                reportCode = 'VME_Rpt_FLT_ReconAdjustAccrue_Detail';
                reportName = 'Fleet reconcile adjust accrue detail';
                CB_FLAG = 'Y'
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + CB_FLAG + '&p3=' + reportName, '_blank');
            }
        }
    }
    //------------------- Data model section --------------------------
}])

app.controller("Rpt1FleetAccrueController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'CONFIG_PATH', 'FLEET_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, CONFIG_PATH, FLEET_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.select = {};
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.FILTER = {};

        //--- Default value
        $scope.Section = 1;
        $scope.select.Period = 'Accrue';
        $scope.FnGetSummary = 'GetFleetAccrueSummary';
        $scope.reportName = 'Accrue';
        $scope.reportCode = 'VME_Rpt_FLT_S2';
        $scope.REPORT_ID = 48;
        $scope.selector = [];
        InitailDataModel();
    }

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })


    //------------------- Data model Accrue section --------------------------
    function InitailDataModel() {

        $scope.DVM_ACCRUE = {};
        $scope.DVM_ACCRUE_TableName1 = 'ModelFleetAccrue1';
        $scope.DVM_ACCRUE_TableName2 = 'ModelFleetRecon';
        $scope.DVM_ACCRUE_TableName3 = 'FleetModelChargeBackWithMonth';
        $scope.DVM_ACCRUE_TableName4 = 'FleetReconDetail';
        $scope.DVM_ACCRUE_TableName5 = 'FleetReconDetail';
        $scope.DVM_ACCRUE_fnGetDataModel = 'GetFleetAccrueFromTo';

        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.ViewChassis = 0;
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_ACCRUE_TableName1
            , 'TableName2': $scope.DVM_ACCRUE_TableName2
            , 'TableName3': $scope.DVM_ACCRUE_TableName3
            , 'TableName4': $scope.DVM_ACCRUE_TableName4
            , 'TableName5': $scope.DVM_ACCRUE_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ModelHeader1 = result.Table;
                $scope.ModelHeader2 = result.Table1;
                $scope.ModelHeader3 = result.Table2;
                $scope.ModelHeader4 = result.Table3;
                $scope.ModelHeader5 = result.Table4;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.ViewDetail_Click = function () {

        $scope.ViewDetail = true;
    
        var sendData = [{ "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM, "DATA_MONTH_TO": $scope.DATA_MONTH_TO  }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, $scope.DVM_ACCRUE_fnGetDataModel, data)
            .then(function (result) {
                $scope.ModelData1 = result.Table;
                $scope.ModelData2 = result.Table1;
                $scope.ModelData3 = result.Table2;
               
                var DataGroup3 = $scope.ModelData3.map(function (obj) { return obj.DATA_MONTHNAME; });
                DataGroup3 = DataGroup3.filter(function (v, i) { return DataGroup3.indexOf(v) == i; });

                $scope.DataGroup3 = DataGroup3;
            }, function (error) {
                console.log('Unable to load ' + $scope.DVM_ACCRUE_fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewDetail2_Click = function () {

        $scope.ViewChassis = 1;

        if ($scope.ViewModel == 1) {
            fnGetDataModel = 'GetFleetReconFromTo';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else if ($scope.ViewModel == 2) {
            fnGetDataModel = 'GetFleetReconFromTo';
            $scope.ModelHeader = $scope.ModelHeader4;
        } else {
            fnGetDataModel = 'GetFleetReconChargeBackFromTo';
            $scope.ModelHeader = $scope.ModelHeader5;
        }

        var sendData = [{ "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM, "DATA_MONTH_TO": $scope.DATA_MONTH_TO }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, fnGetDataModel, data)
            .then(function (result) {
                $scope.DetailData1 = result.Table;

            }, function (error) {
                console.log('Unable to load ' + fnGetDataModel + ' : ' + error.message)
            })
    }

    $scope.ViewModel_Click = function () {
        $scope.ViewChassis = 0;
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
        $scope.ViewChassis = 0;
    }

    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode;
        var reportName;

        if (ReportNo == 'report0') {
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_Accrue_FromTo_Model';
                reportName = 'Fleet accrue summary';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ reportName, '_blank');
            }
            else if($scope.ViewModel == 2){
                reportCode = 'VME_Rpt_FLT_Recon_FromTo_Model';
                reportName = 'Fleet reconcile summary';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ reportName, '_blank');
            }
            else if($scope.ViewModel == 3){
                reportCode = 'VME_Rpt_FLT_AdjustAccrue_FromTo_Model';
                reportName = 'Fleet adjust accrue';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ reportName, '_blank');
            }
        }
        else if(ReportNo == 'report1'){
            if ($scope.ViewModel == 1) {
                reportCode = 'VME_Rpt_FLT_Recon_FromTo_Detail';
                reportName = 'Fleet accrue summary detail';
                CB_FLAG = 'N'
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ CB_FLAG + '&p4=' + reportName, '_blank');
            }
            else if($scope.ViewModel == 2){
                reportCode = 'VME_Rpt_FLT_Recon_FromTo_Detail';
                reportName = 'Fleet reconcile summary detail';
                CB_FLAG ='N';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ CB_FLAG +'&p4=' + reportName, '_blank');
            }
            else if($scope.ViewModel == 3){
                reportCode = 'VME_Rpt_FLT_Recon_FromTo_Detail';
                reportName = 'Fleet adjust accrue detail';
                CB_FLAG ='Y';
                window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3='+ CB_FLAG +'&p4=' + reportName, '_blank');
            }
        }

    }
    //------------------- Data model section --------------------------

}])

app.controller("Rpt2FleetPaymentController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'CONFIG_PATH', 'FLEET_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, CONFIG_PATH, FLEET_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.SubSection = 2;
 
        InitailDataModel_A();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }  
    
    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData_A();
    }
    
    //------------------- payment : Data model section --------------------------

    function InitailDataModel_A() {
        //---- Data model
        $scope.A_ViewModel = 1;

        $scope.A_TableName1 = 'FleetPaymentMonthlyWithCB';
        $scope.A_TableName2 = 'FleetPaymentWithCBbyModel';
        $scope.A_TableName3 = 'PaymentChargeBackDealerList';
        $scope.A_TableName4 = 'PaymentChargeBackOutletList';
        $scope.A_TableName5 = 'x';
        $scope.A_fnGetDataModel = 'GetPaymentByMonth';

        GetDataModelHeader_A();
        GetData_A();
    }

    function GetDataModelHeader_A() {
        var sendData = [{
            'TableName1': $scope.A_TableName1
            , 'TableName2': $scope.A_TableName2
            , 'TableName3': $scope.A_TableName3
            , 'TableName4': $scope.A_TableName4
            , 'TableName5': $scope.A_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.A_ModelHeader1 = result.Table;
                $scope.A_ModelHeader2 = result.Table1;
                $scope.A_ModelHeader3 = result.Table2;
                $scope.A_ModelHeader4 = result.Table3;
                $scope.A_ModelHeader = $scope.A_ModelHeader1;

            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    $scope.A_ViewDetail_Change = function (iNumber) {
        $scope.A_ViewModel = iNumber;
    }

    function GetData_A() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, $scope.A_fnGetDataModel, data)
            .then(function (result) {

                $scope.A_DVM_ModelData1 = result.Table;
                $scope.A_DVM_ModelData2 = result.Table1;
                $scope.A_DVM_ModelData3 = result.Table2;
                $scope.A_DVM_ModelData4 = result.Table3;

            }, function (error) {
                console.log('Unable to load ' + $scope.A_fnGetDataModel + ': ' + error.message)
            })
    }
    $scope.Back_Click = function () {
        $scope.ViewDetail = false;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterItem());
        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.ModelReport_Click = function (ReportNo) {

        if (ReportNo == 'report1') {
            $scope.reportCode = 'VME_Rpt_FLT_Payment_Monthly_Chassis';
            $scope.reportName = 'Fleet payment monthly by chassis';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');

        } else if (ReportNo == 'report2') {
            $scope.reportCode = 'VME_Rpt_FLT_Payment_Monthly_Model';
            $scope.reportName = 'Fleet payment monthly by base model';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        } else if (ReportNo == 'report3') {
            $scope.reportCode = 'VME_Rpt_FLT_Payment_Monthly_Dealer';
            $scope.reportName = 'Fleet payment monthly by dealer';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        } else if (ReportNo == 'report4') {
            $scope.reportCode = 'VME_Rpt_FLT_Payment_Monthly_Outlet';
            $scope.reportName = 'Fleet payment monthly by outlet';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.reportName, '_blank');
        }
    }

    //------------------- Data model section --------------------------

}])

app.controller("Rpt1FleetTrackingController", ['$scope', 'BaseService', 'FLEET_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, FLEET_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.filter = {};
        $scope.formData = {};
        $scope.filter.checkAll = false;

        //--- Default value
        $scope.Section = 2;
        $scope.FnGetSummary = 'GetAccruePaymentStatus';
        $scope.reportCode = 'VME_Rpt_FLT_STATUS';

        GetHeader();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        if ($scope.Section == 1) {
            GetProgramFleetByMonth();
        } else {
            $scope.ListDetail = {};
            GetDataSummary();
        }

        return;
    }
    $scope.ViewData_Click();

    $scope.Program_Change = function () {
        if (typeof ($scope.FLEET_NAME) == 'undefined' || $scope.FLEET_NAME == null) {
            return;
        }
        if ($scope.Section == 1) {
            GetData();
        }
    }

    $scope.Select_Change = function (gChange) {

        if (gChange == "1") {
            $scope.Section = 1;
        } else if (gChange == "2") {
            $scope.Section = 2;
        } else if (gChange == "3") {
            $scope.Section = 3;
        } else if (gChange == "4") {
            $scope.Section = 4;
        } else if (gChange == "5") {
            $scope.Section = 5;
        }

        ChangeHeader();

        $scope.ListDetail = {};
        if ($scope.Section == 1) {
            $scope.FnGetSummary = '';
            $scope.reportCode = 'VME_Rpt_CMP_ACC_Summary';

        } else if ($scope.Section == 2) {
            $scope.FnGetSummary = 'GetAccruePaymentStatus';
            $scope.reportCode = 'VME_Rpt_FLT_STATUS';
            GetDataSummary();

        } else if ($scope.Section == 3) {
            $scope.FnGetSummary = 'GetAccruePaymentRemain';
            $scope.reportCode = 'VME_Rpt_FLT_S6_Remain';
            GetDataSummary();

        } else if ($scope.Section == 4) {
            $scope.FnGetSummary = 'GetDealerPaidStatus';
            $scope.reportCode = 'VME_Rpt_FLT_S7_Dealer_Paid';
            GetDataSummary();

        } else if ($scope.Section == 5) {
            $scope.FnGetSummary = 'GetDealerDocStatus';
            $scope.reportCode = 'VME_Rpt_FLT_S8_Dealer_Doc_Status';
            GetDataSummary();
        }
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "FLEET_NAME": $scope.FLEET_NAME }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, "GetFleetRptSummary", data)
            .then(function (result) {

                $scope.Detail1List = result.Table;
                $scope.Detail2List = result.Table1;
                $scope.OverlAll = result.Table2;

            }, function (error) {
                console.log('Unable to load GetCampaignChassisSumList data: ' + error.message)
            })
    }

    function GetProgramFleetByMonth() {
        $scope.FleetProgramList = null;
        BaseService.GetDataTableByParam(FLEET_PATH, "GetFleetListByMonth", $scope.DATA_MONTH)
            .then(function (result) {
                $scope.FleetProgramList = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptFleetStatus')
            .then(function (result) {
                $scope.ModelSummary1 = result;
                $scope.ListHeader = $scope.ModelSummary1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptFleetStatus')
            .then(function (result) {
                $scope.ModelSummary2 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('FleetModelRemain')
            .then(function (result) {
                $scope.ModelSummary3 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('FleetDealerPaidStatus')
            .then(function (result) {
                $scope.ModelSummary4 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })


        BaseService.GetHeaderGridView('FleetDealerDocStatus')
            .then(function (result) {
                $scope.ModelSummary5 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

    }

    function ChangeHeader() {
        if ($scope.Section == 1) {
            // $scope.ListHeader = $scope.ModelSummary1;
        } else if ($scope.Section == 2) {
            $scope.ListHeader = $scope.ModelSummary2;
        } else if ($scope.Section == 3) {
            $scope.ListHeader = $scope.ModelSummary3;
        } else if ($scope.Section == 4) {
            $scope.ListHeader = $scope.ModelSummary4;
        } else if ($scope.Section == 5) {
            $scope.ListHeader = $scope.ModelSummary5;
        }
    }

    function GetDataSummary() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(FLEET_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.ListDetail = result;

                if ($scope.Section == 3) {
                    GetSummary($scope.ListDetail)
                }

            }, function (error) {
                console.log('Unable to load ' + $scope.FnGetSummary + ' data: ' + error.message)
            })
    }

    function GetSummary(listData) {
        var sum1 = 0;
        var sum2 = 0;
        var sum3 = 0;
        var sum4 = 0;
        var sum5 = 0;
        var sum6 = 0;
        var sum7 = 0;
        var sum8 = 0;
        var sum9 = 0;
        var sum10 = 0;
        var sum11 = 0;
        var sum12 = 0;
        var sum13 = 0;
        var sum14 = 0;
        var sum15 = 0;

        for (var idx in listData) {
            sum1 = sum1 + listData[idx]['UNIT'];
            sum2 = sum2 + listData[idx]['FLEET_CAMPAIGN_AMOUNT'];
            sum3 = sum3 + listData[idx]['ONTOP'];
            sum4 = sum4 + listData[idx]['ADD_ONTOP'];
            sum5 = sum5 + listData[idx]['AMOUNT'];

            sum6 = sum6 + listData[idx]['P_UNIT'];
            sum7 = sum7 + listData[idx]['P_FLEET_CAMPAIGN_AMOUNT'];
            sum8 = sum8 + listData[idx]['P_ONTOP'];
            sum9 = sum9 + listData[idx]['P_ADD_ONTOP'];
            sum10 = sum10 + listData[idx]['PAID'];

            sum11 = sum11 + listData[idx]['R_UNIT'];
            sum12 = sum12 + listData[idx]['R_FLEET_CAMPAIGN_AMOUNT'];
            sum13 = sum13 + listData[idx]['R_ONTOP'];
            sum14 = sum14 + listData[idx]['R_ADD_ONTOP'];
            sum15 = sum15 + listData[idx]['REMAIN'];
        }

        $scope.sum1 = sum1;
        $scope.sum2 = sum2;
        $scope.sum3 = sum3;
        $scope.sum4 = sum4;
        $scope.sum5 = sum5;

        $scope.sum6 = sum6;
        $scope.sum7 = sum7;
        $scope.sum8 = sum8;
        $scope.sum9 = sum9;
        $scope.sum10 = sum10;

        $scope.sum11 = sum11;
        $scope.sum12 = sum12;
        $scope.sum13 = sum13;
        $scope.sum14 = sum14;
        $scope.sum15 = sum15;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };


    $scope.Report_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH, '_blank');
    }

}])

app.controller("FleetBulletinController", ['$scope', 'BaseService', 'FLEET_PATH', '$filter', function ($scope, BaseService, FLEET_PATH, $filter) {
    openning();

    function openning() {
        $scope.FILTER = {};
        $scope.formData = {};
        $scope.type = ["Bulletin", "DOA"];
        $scope.status = ["Active", "Inactive"];
        GetHeader();
        GetData();
    }



    function GetHeader() {
        BaseService.GetHeaderGridView("FleetBulletin")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(FLEET_PATH, "GetBulletinList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.formData = {
            "ID": 0,
            "BULLETIN_STATUS": "Active"
        }
        document.getElementById("DetailModal").style.display = "block";
    }

    $scope.ShowItem_Click = function (id) {
        BaseService.GetDataTableByParam(FLEET_PATH, "GetBulletinByID", id)
            .then(function (result) {
                $scope.formData = result[0];
                document.getElementById("DetailModal").style.display = "block";
            }, function (error) {
                console.log('Unable to load bulletin of ' + id + ': ' + error.message);
            })
    }

    $scope.Edit_Submit = function () {
        if ($scope.formData.BULLETIN_TYPE == null || $scope.formData.BULLETIN_TYPE == "") {
            BaseService.Message.alert("Type cannot empty");
            return;
        }
        if ($scope.formData.BULLETIN_NAME == null || $scope.formData.BULLETIN_NAME == "") {
            BaseService.Message.alert("Name cannot empty");
            return;
        }
        if ($scope.formData.BULLETIN_DATE == null || $scope.formData.BULLETIN_DATE == "") {
            BaseService.Message.alert("Announce date cannot empty");
            return;
        }
        if ($scope.formData.BULLETIN_DETAIL == null || $scope.formData.BULLETIN_DETAIL == "") {
            BaseService.Message.alert("Detail cannot empty");
            return;
        }
        if ($scope.formData.EFFECTIVE_DATE == null || $scope.formData.EFFECTIVE_DATE == "") {
            BaseService.Message.alert("Effective date cannot empty");
            return;
        }
        if ($scope.formData.EXPIRE_DATE == null || $scope.formData.EXPIRE_DATE == "") {
            BaseService.Message.alert("Expire date cannot empty");
            return;
        }

        let data = BaseService.ConvertParam($scope.formData);

        BaseService.CallAction(FLEET_PATH, "SaveBulletin", data)
            .then(function (result) {
                console.log(result);
                if (result == "Done") {
                    GetData();
                    BaseService.Message.info("Successfully saved");
                    $scope.CloseItem_Click()
                }
            }, function (error) {
                console.log('Unable to save bulletin/DOA: ' + error.message);
            })
    }

    $scope.CloseItem_Click = function () {
        document.getElementById("DetailModal").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.openDate = function () {
        $scope.popupDate.opened = true;
    }

    $scope.popupDate = {
        opened: false
    }

}])

app.controller("FleetConditionController", ['$scope', 'BaseService', 'FLEET_PATH', 'INCENTIVE_PATH', 'REPORT_PATH', '$filter', 'Upload', '$timeout', function ($scope, BaseService, FLEET_PATH, INCENTIVE_PATH, REPORT_PATH, $filter, Upload, $timeout) {
    opening();

    function opening() {
        const date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.dataTypes = ["Dealer", "Outlet", "Chassis"];
        $scope.dataType = "Chassis";
        GetConditionType();
        GetCondition();
        GetHeader();

        $scope.$watch('ViewData_Click', function(value) {
            if(value) {
                $scope.ViewData_Click()
            }
        },true)

    }

    function GetHeader() {

        BaseService.GetHeaderGridView('IncentiveConditionChassis')
            .then(function (result) {
                $scope.ListHeader3 = result;
                $scope.ListHeader = $scope.ListHeader3;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.DataType_Change = function () {
        if ($scope.dataType == 'Dealer') {
            $scope.ListHeader = $scope.ListHeader1;
        } else if ($scope.dataType == 'Outlet') {
            $scope.ListHeader = $scope.ListHeader2;
        } else if ($scope.dataType == 'Chassis') {
            $scope.ListHeader = $scope.ListHeader3;
        }
        GetData();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "DATA_TYPE": $scope.dataType }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(FLEET_PATH, "GetConditionList", data)
            .then(function (result) {
                $scope.ListDetail = result;

            }, function (error) {
                console.log('Unable to load GetConditionList: ' + error.message)
            })
    }
    function GetConditionType() {
        BaseService.GetDataTableByParam('/Home', 'GetConditionType', 'FLT').then(function (result) {

            $scope.conditionType = result[0];
            $scope.conditionTypeChange($scope.conditionType);

        }, function (error) {
            console.log('Unable to load Condition name data: ' + error.message);
        })
    }

    function GetCondition() {
        BaseService.GetDataTableByParam('/Home', 'GetCondition', 'FLT').then(function (result) {
            $scope.ConditionList = result;
            $scope.condition = result[0];
            $scope.conditionChange($scope.condition);
        }, function (error) {
            console.log('Unable to load Condition name data: ' + error.message);
        })
    }
    $scope.conditionTypeChange = function (item) {
        $scope.conditionTypeID = item.ID;
        if($scope.ConditionList) {
            $scope.condition = $filter('filter')($scope.ConditionList, $scope.conditionFilter())[0];
            $scope.conditionChange($scope.condition);
        }
    }
    $scope.conditionChange = function (item) {
        $scope.conditionID = item.ID;
    }
    $scope.conditionFilter = function () {
        return function(input) {
            filterResult = true;
            if(filterResult && (input.GROUPING_BY || '').indexOf($scope.dataType) < 0) {
                filterResult = false;
            }
            if(filterResult && input.CONDITION_TYPE_ID == null && input.VME_TYPE == $scope.conditionType.VME_TYPE) {
                filterResult = true;
            } else if (filterResult && input.CONDITION_TYPE_ID != null && input.CONDITION_TYPE_ID == $scope.conditionTypeID) {
                filterResult = true;
            } else {
                filterResult = false;
            }
            return filterResult;
        }
    }

    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.uploadCondition = "UploadFleetCondition";

                file.upload = Upload.upload({
                    url: window.location.origin + FLEET_PATH + '/' + $scope.uploadCondition,
                    data: {
                        File: file,
                        year: $scope.periodYear,
                        month: $scope.periodMonth,
                        dataType: $scope.dataType,
                        condition: $scope.conditionID,
                        conditionTypeID: $scope.conditionTypeID,
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        if (res.data[0].RESULT == "DONE") {
                            BaseService.Message.info("Successfully saved").then(function () {
                                $scope.fileUpload = null;
                                $scope.ViewData_Click();
                            })
                        }
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.Download_Click = function () {
        gText = 'rt=1&export=excelopenxml&ExportName=FleetChassis' + $scope.DATA_MONTH + '_' + $scope.conditionID;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=CHASSIS&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.conditionTypeID + '&p3=' + $scope.conditionID, '_blank');
    }

}])

function MonthPicker($scope) {
    $scope.openMonthFrom = function () {
        $scope.popupMonthFrom.opened = true;
    };
    $scope.popupMonthFrom = {
        opened: false,
    };
    $scope.openMonthTo = function () {
        $scope.popupMonthTo.opened = true;
    };
    $scope.popupMonthTo = {
        opened: false
    };
}
