app.controller("RetailDataController", ['$scope', 'BaseService', 'INTERFACE_PATH','REPORT_PATH', function ($scope, BaseService, INTERFACE_PATH,REPORT_PATH) {
    $scope.init = function() {
        
        $scope.formData = {
            'DATE_FROM': new Date(),
            'DATE_TO': new Date(),
        };
        $scope.GetHeader();
    }
    MonthPicker($scope);
    
        $scope.$watch('MonthFrom', function (value) {
            if (value) {
                $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
            }
        })
    
        $scope.$watch('MonthTo', function (value) {
            if (value) {
                $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
            }
        })
    
    $scope.GetHeader = function() {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView('RetailHeader').then(function(result) {
            $scope.ListHeader = result
        }, function(error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }
    
    $scope.GetData = function() {
        $scope.ListDetail = null;
        var sendData = [{ "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM, "DATA_MONTH_TO": $scope.DATA_MONTH_TO, "FLEET_FLAG": $scope.formData.FLEET_FLAG }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(INTERFACE_PATH, 'RetailList', data)
            .then(function(result) {
                $scope.ListDetail = result
            }, function(error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    // $scope.openStartDate = function () {
    //     $scope.popupStartDate.opened = true;
    // }

    // $scope.popupStartDate = {
    //     opened: false
    // }

    // $scope.openEndDate = function () {
    //     $scope.popupEndDate.opened = true;
    // }

    // $scope.popupEndDate = {
    //     opened: false
    // }

    $scope.init();
    $scope.Download_Click = function () {
        gText = 'rt=1&export=excelopenxml&ExportName=Retaildata' + $scope.DATA_MONTH_FROM + '-' + $scope.DATA_MONTH_TO;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=RetailData&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3=' + $scope.formData.FLEET_FLAG, '_blank');
    }
}])

app.controller("ModelMasterDataController", ['$scope', 'BaseService', 'INTERFACE_PATH' ,'CONFIG_PATH', function ($scope, BaseService, INTERFACE_PATH ,CONFIG_PATH) {
    $scope.init = function () {

        $scope.formData = {
            'DATE_FROM': new Date(),
            'DATE_TO': new Date(),
        };
        $scope.GetHeader();
        GetModelList();
    }
    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelBaseList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView('ModelMasterList').then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.CallAction(INTERFACE_PATH, 'ModelMaster', BaseService.ConvertParam($scope.formData)).then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.init();
}])

app.controller("DealerMasterDataController", ['$scope', 'BaseService', 'INTERFACE_PATH','CONFIG_PATH', function ($scope, BaseService, INTERFACE_PATH,CONFIG_PATH) {
    $scope.init = function () {

        $scope.formData = {
            'DATE_FROM': new Date(),
            'DATE_TO': new Date(),
        };
        $scope.GetHeader();
        $scope.GetData();
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView('DealerMasterDataList').then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.CallAction(INTERFACE_PATH, 'DealerMaster', BaseService.ConvertParam($scope.formData)).then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.init();
}])

app.controller("ModelMasterInterfaceController", ['$scope', 'BaseService', 'INTERFACE_PATH', 'CONFIG_PATH', function ($scope, BaseService, INTERFACE_PATH, CONFIG_PATH) {
    $scope.init = function () {
        $scope.GetHeader();
        $scope.GetData();
    }
    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView('ModelMasterInterface').then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }
    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.CallAction(INTERFACE_PATH, 'GetModelMasterInterface', BaseService.ConvertParam($scope.formData)).then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }
    $scope.init();
}])
function MonthPicker($scope) {
    $scope.openMonthFrom = function () {
        $scope.popupMonthFrom.opened = true;
    };
    $scope.popupMonthFrom = {
        opened: false,
    };
    $scope.openMonthTo = function () {
        $scope.popupMonthTo.opened = true;
    };
    $scope.popupMonthTo = {
        opened: false
    };
}