﻿app.controller("LeasingUploadController", ['$scope', 'BaseService', 'LEASING_PATH', 'Upload', '$timeout', '$filter', 'BizDataService', function ($scope, BaseService, LEASING_PATH, Upload, $timeout, $filter, BizDataService) {
    //Leasing Data here

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.confirmBtn = null;
        $scope.fileUpload = null;        
    }

    $scope.uploadLeasingData = function () {

        var file = this.fileUpload;

        $scope.fileName = file.name;
        $scope.ListDetail = null;

        file.upload = Upload.upload({
            url: window.location.origin + LEASING_PATH + '/UploadLeasingData',
            data: { File: file, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                if(res.data.result == 500) {
                    BaseService.Message.alert("Please insert file.");
                } else if (res.data.result == 200) {
                    BaseService.Message.alert((res.data.data));
                } else {
                    $scope.ListDetail = res.data;
                    $scope.confirmBtn = true;
                }
            })
        }, function (res) {
            if (res.status > 0)
            {
              $scope.errorMsg = res.status + ': ' + res.data;
              BaseService.Message.alert("Cannot upload file")
            }
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    };


    $scope.confirmUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "ConfirmLeasingUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                    BaseService.Message.info("Successfully saved");
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to confirm uploaded data: ' + error.message)
            })
    }

    $scope.cancelUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "CancelLeasingUpload", data)
            .then(function (result) {

                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to cancel uploaded data: ' + error.message)
            })
    }

    $scope.GetFileList = function () {

        var sendData = [{ periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        BaseService.GetHeaderGridView("FileHistory")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load File header data: ' + error.message)
            })

        BaseService.CallAction(LEASING_PATH, "GetFileList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to list files: ' + error.message)
            })
        $scope.isFileList = true;
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    $scope.GetLeasingData = function () {

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        var sendData = [{ periodMonth: String('00' + $scope.periodMonth).slice(-2), periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.GetHeaderGridView("LeasingData")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load LeasingData header data: ' + error.message)
            })

        BaseService.CallAction(LEASING_PATH, "GetLeasingData", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to get Leasing data: ' + error.message)
            })

        $scope.isFileList = false;
    }
    $scope.GetLeasingData();

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }

    $scope.GetTemplateFile = function () {
        location.href="/Doc/template/NLTH template.xlsx";
    }
}])

app.controller("LeasingUploadEditController", ['$scope', 'BaseService', 'LEASING_PATH', 'Upload', '$timeout', '$filter', 'BizDataService', function ($scope, BaseService, LEASING_PATH, Upload, $timeout, $filter, BizDataService) {
    //Leasing Data here

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.confirmBtn = null;
        $scope.fileUpload = null;
    }

    $scope.uploadLeasingData = function () {

        var file = this.fileUpload;

        $scope.fileName = file.name;
        $scope.ListDetail = null;

        file.upload = Upload.upload({
            url: window.location.origin + LEASING_PATH + '/UploadLeasingData',
            data: { File: file, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                if (res.data.result == 500) {
                    BaseService.Message.alert("Please insert file.");
                } else if (res.data.result == 200) {
                    BaseService.Message.alert((res.data.data));
                } else {
                    $scope.ListDetail = res.data;
                    $scope.confirmBtn = true;
                }
            })
        }, function (res) {
            if (res.status > 0) {
                $scope.errorMsg = res.status + ': ' + res.data;
                BaseService.Message.alert("Cannot upload file")
            }
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    };


    $scope.confirmUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "ConfirmLeasingUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                    BaseService.Message.info("Successfully saved");
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to confirm uploaded data: ' + error.message)
            })
    }

    $scope.cancelUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "CancelLeasingUpload", data)
            .then(function (result) {

                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetLeasingData();
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.")
                console.log('Unable to cancel uploaded data: ' + error.message)
            })
    }

    $scope.GetFileList = function () {

        var sendData = [{ periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        BaseService.GetHeaderGridView("FileHistory")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load File header data: ' + error.message)
            })

        BaseService.CallAction(LEASING_PATH, "GetFileList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to list files: ' + error.message)
            })
        $scope.isFileList = true;
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    $scope.GetLeasingData = function () {

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        var sendData = [{ periodMonth: String('00' + $scope.periodMonth).slice(-2), periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.GetHeaderGridView("LeasingData")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load LeasingData header data: ' + error.message)
            })

        BaseService.CallAction(LEASING_PATH, "GetLeasingData", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to get Leasing data: ' + error.message)
            })

        $scope.isFileList = false;
    }
    $scope.GetLeasingData();

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }

    $scope.GetTemplateFile = function () {
        location.href = "/Doc/template/NLTH template.xlsx";
    }


    $scope.Edit_Submit = function () {

        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(LEASING_PATH, "EditLeasingData", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';       
                BaseService.Message.info('Successfully saved');
                $scope.GetLeasingData();
            }, function (error) {
                console.log('Unable to edit upload NLTH data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "GetLeasingDataList", data)
            .then(function (result) {
                $scope.formData = result[0]
            }, function (error) {
                console.log('Unable to load GetLeasingDataList data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }
    $scope.openApplicationDate = function () {
        $scope.popupApplicationDate.opened = true;
    }
    $scope.popupApplicationDate = {
        opened: false
    }
    $scope.openBookingDate = function () {
        $scope.popupBookingDate.opened = true;
    }
    $scope.popupBookingDate = {
        opened: false
    }
    $scope.openPaymentDate = function () {
        $scope.popupPaymentDate.opened = true;
    }
    $scope.popupPaymentDate = {
        opened: false
    }
    $scope.openInvoiceDate = function () {
        $scope.popupInvoiceDate.opened = true;
    }
    $scope.popupInvoiceDate = {
        opened: false
    }

}])

app.controller("DealerController", ['$scope', 'BaseService', 'CONFIG_PATH', function ($scope, BaseService, CONFIG_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.DealerCond = "DealerList";
        GetHeader();
        GetData();
    }

    $scope.GetData = function () {
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView($scope.DealerCond)
            .then(function (result) {
                $scope.ListHeader = result
                //console.log(result)
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "ID": null, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetDealerList", data)
            .then(function (result) {
                //console.log(result)
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }


    $scope.Edit_Submit = function () {

        let scopeData = $scope.formData.Dealer;
        scopeData.DealerCond = $scope.DealerCond;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CONFIG_PATH, "EditDealerConf", data)
            .then(function (result) {
                GetData();
                document.getElementById('DetailModal').style.display = 'none';
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID, "DealerCond": $scope.DealerCond }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CONFIG_PATH, "GetDealerList", data)
            .then(function (result) {
                $scope.formData.Dealer = result[0]
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("LeasingAmountController", ['$scope', 'BaseService', 'LEASING_PATH', 'BizDataService', function ($scope, BaseService, LEASING_PATH, BizDataService) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetRetailSalesMonth();
        GetHeader();
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00'+$scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('LeasingSumRep')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load Dealer summary data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(LEASING_PATH, "GetLeasingSumList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetLeasingSumList data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        pColName = (pColName=='APPLICATION_DATE_STR') ? 'APPLICATION_DATE' : pColName;
        pColName = (pColName=='BOOKING_DATE_STR') ? 'BOOKING_DATE' : pColName;
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.setInitRec = function (obj) {
        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }
}])

app.controller("LeasingReportController", ['$scope', 'BaseService', 'LEASING_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, LEASING_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ListHeader = {};
        $scope.ListDetail = [];
        $scope.sortType = '';

        GetHeader();
        $scope.$watch('ViewData_Click', function(value) {
            if(value) {
                $scope.ViewData_Click();
            }
        },true)
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        GetData();
    }

    function GetData() {
        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH,
        });

        BaseService.CallAction(LEASING_PATH, "LeasingMatchChassis", data)
            .then(function(result) {
                $scope.ListDetail = result;
            }, function(error) {
                console.log(error);
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('LeasingReport')
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Report_Click = function () {
        $scope.reportCode ='VME_Rpt_Leasing_Matched_Detail';
        $scope.reportName ='NLTH Report';
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2='+ $scope.reportName, '_blank');
    }

}])
