﻿app.controller("MSControlMainController", ['$scope', 'BaseService', 'CONFIG_PATH', 'MS_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, MS_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        // GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListDetail = result.Table1;
                $scope.ListAccrue = result.Table2;
                $scope.ListPayment = result.Table3;
                $scope.ListReconcile = result.Table4;

            }, function (error) {
                console.log('Unable to load GetIncDash data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])


app.controller("Rpt1MsSummary", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    opening();
    function opening() {
        $scope.Section = 1;
        $scope.TBLTypes = ['AmountList', 'PerUnitList'];
        $scope.VMETypes = ['Campaign', 'Incentives', 'CQ', 'Fleet', 'Test Drive', 'TTL'];
        $scope.VMETypesValue = ['CMP', 'INC', 'CQ', 'FLT', 'DEMO', 'TOTAL'];
    }

    $scope.GetAfterBookingList = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControlSummaryAfterBooking', $scope.data)
            .then(function (result) {
                $scope.AmountList = result.Table;
                $scope.PerUnitList = result.Table1;
            }, function (error) {
                console.log('Unable to load summary data: ' + error.message)
            })
    }

    $scope.GetTrackingReport = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControlTrackingReport', $scope.data)
            .then(function (result) {
                $scope.ResultList = result.Table;
            }, function (error) {
                console.log('Unable to load summary data: ' + error.message)
            })
    }

    $scope.GetMSControlSummary = $scope.GetAfterBookingList;

    $scope.Select_Change = function (section) {
        switch (section) {
            case 1:
                $scope.Section = 1;
                $scope.GetMSControlSummary = $scope.GetAfterBookingList;
                (($scope.AmountList && $scope.AmountList.length == 0) || ($scope.PerUnitList && $scope.PerUnitList == 0)) ? $scope.GetMSControlSummary() : null;
                break;

            case 2:
                $scope.Section = 2;
                $scope.GetMSControlSummary = $scope.GetTrackingReport;
                ($scope.ResultList && $scope.ResultList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            default:
                break;
        }
        $scope.Section = section;
    }

    MonthPickerWatcher($scope, BaseService);

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.Report_Click = function () {

        switch ($scope.Section) {
            case 1:
                $scope.report = 'VME_Rpt_MSC_02_Sum_After_Booking&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 2:
                $scope.report = 'VME_Rpt_MSC_03_Sum_Tracking&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.report, '_blank');

    }

}])

app.controller("Rpt2Campaign", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    opening();
    function opening() {
        $scope.Section = 1;
        $scope.TBLTypes = ['AmountList', 'PerUnitList'];
        $scope.VMETypes = ['Dealer', 'Leasing', 'Insurance', 'After sales', 'TTL'];
        $scope.VMETypesValue = ['DEALER_CLAIM', 'LEASING', 'INSURANCE', 'AFTER_SALES', 'TOTAL'];
    }

    GetVMEReport($scope, BaseService, MS_PATH, 'Campaign');

    $scope.GetMSControlSummary = $scope.GetVMETotal;

    $scope.Select_Change = function (section) {
        switch (section) {
            case 1:
                $scope.GetMSControlSummary = $scope.GetVMETotal;
                (($scope.AmountList && $scope.AmountList.length == 0) || ($scope.PerUnitList && $scope.PerUnitList == 0)) ? $scope.GetMSControlSummary() : null;
                break;

            case 2:
                $scope.GetMSControlSummary = $scope.GetVMEAccrue;
                ($scope.AccrueList && $scope.AccrueList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 3:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustPY;
                ($scope.AdjustPYList && $scope.AdjustPYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 4:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustCY;
                ($scope.AdjustCYList && $scope.AdjustCYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            default:
                break;
        }
        $scope.Section = section;
    }

    MonthPickerWatcher($scope, BaseService);

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.Report_Click = function () {

        switch ($scope.Section) {
            case 1:
                $scope.report = 'VME_Rpt_MSC_13_CMP_Total&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 2:
                $scope.report = 'VME_Rpt_MSC_14_CMP_Accrue&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 3:
                $scope.report = 'VME_Rpt_MSC_15_CMP_Adj_PY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 4:
                $scope.report = 'VME_Rpt_MSC_16_CMP_Adj_CY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.report, '_blank');

    }

}])

app.controller("Rpt3Fleet", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    opening();
    function opening() {
        $scope.Section = 1;
        $scope.TBLTypes = ['AmountList', 'PerUnitList'];
        $scope.VMETypes = ['Campaign', 'Normal Fleet Dis.', 'Additional', 'TTL'];
        $scope.VMETypesValue = ['FLEET_CAMPAIGN', 'ONTOP', 'ADD_ONTOP', 'TOTAL'];
    }

    GetVMEReport($scope, BaseService, MS_PATH, 'Fleet');

    $scope.GetMSControlSummary = $scope.GetVMETotal;

    $scope.Select_Change = function (section) {
        switch (section) {
            case 1:
                $scope.GetMSControlSummary = $scope.GetVMETotal;
                (($scope.AmountList && $scope.AmountList.length == 0) || ($scope.PerUnitList && $scope.PerUnitList == 0)) ? $scope.GetMSControlSummary() : null;
                break;

            case 2:
                $scope.GetMSControlSummary = $scope.GetVMEAccrue;
                ($scope.AccrueList && $scope.AccrueList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 3:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustPY;
                ($scope.AdjustPYList && $scope.AdjustPYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 4:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustCY;
                ($scope.AdjustCYList && $scope.AdjustCYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            default:
                break;
        }
        $scope.Section = section;
    }

    MonthPickerWatcher($scope, BaseService);

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.Report_Click = function () {

        switch ($scope.Section) {
            case 1:
                $scope.report = 'VME_Rpt_MSC_05_FLT_Total&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 2:
                $scope.report = 'VME_Rpt_MSC_06_FLT_Accrue&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 3:
                $scope.report = 'VME_Rpt_MSC_07_FLT_Adj_PY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 4:
                $scope.report = 'VME_Rpt_MSC_08_FLT_Adj_CY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.report, '_blank');
    }

}])

app.controller("Rpt4Incentive", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    opening();
    function opening() {
        $scope.Section = 1;
        $scope.TBLTypes = ['AmountList', 'PerUnitList'];
        $scope.VMETypes = ['All model', 'Model Specific', 'Special incentives', 'TTL'];
        $scope.VMETypesValue = ['RS', 'SP', 'SC', 'TOTAL'];
    }

    GetVMEReport($scope, BaseService, MS_PATH, 'Incentive');

    $scope.GetMSControlSummary = $scope.GetVMETotal;

    $scope.Select_Change = function (section) {
        switch (section) {
            case 1:
                $scope.GetMSControlSummary = $scope.GetVMETotal;
                (($scope.AmountList && $scope.AmountList.length == 0) || ($scope.PerUnitList && $scope.PerUnitList == 0)) ? $scope.GetMSControlSummary() : null;
                break;

            case 2:
                $scope.GetMSControlSummary = $scope.GetVMEAccrue;
                ($scope.AccrueList && $scope.AccrueList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 3:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustPY;
                ($scope.AdjustPYList && $scope.AdjustPYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 4:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustCY;
                ($scope.AdjustCYList && $scope.AdjustCYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            default:
                break;
        }
        $scope.Section = section;
    }

    MonthPickerWatcher($scope, BaseService);

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.Report_Click = function () {

        switch ($scope.Section) {
            case 1:
                $scope.report = 'VME_Rpt_MSC_09_INC_Total&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 2:
                $scope.report = 'VME_Rpt_MSC_10_INC_Accrue&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 3:
                $scope.report = 'VME_Rpt_MSC_11_INC_Adj_PY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 4:
                $scope.report = 'VME_Rpt_MSC_12_INC_Adj_CY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.report, '_blank');
    }
}])

app.controller("Rpt5CQ", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    opening();
    function opening() {
        $scope.Section = 1;
        $scope.TBLTypes = ['AmountList', 'PerUnitList'];
        $scope.VMETypes = ['CQ', 'TTL'];
        $scope.VMETypesValue = ['CQ', 'TOTAL'];
    }

    GetVMEReport($scope, BaseService, MS_PATH, 'CQ');

    $scope.GetMSControlSummary = $scope.GetVMETotal;

    $scope.Select_Change = function (section) {
        switch (section) {
            case 1:
                $scope.GetMSControlSummary = $scope.GetVMETotal;
                (($scope.AmountList && $scope.AmountList.length == 0) || ($scope.PerUnitList && $scope.PerUnitList == 0)) ? $scope.GetMSControlSummary() : null;
                break;

            case 2:
                $scope.GetMSControlSummary = $scope.GetVMEAccrue;
                ($scope.AccrueList && $scope.AccrueList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 3:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustPY;
                ($scope.AdjustPYList && $scope.AdjustPYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            case 4:
                $scope.GetMSControlSummary = $scope.GetVMEAdjustCY;
                ($scope.AdjustCYList && $scope.AdjustCYList.length == 0) ? $scope.GetMSControlSummary() : null;
                break;

            default:
                break;
        }
        $scope.Section = section;
    }

    MonthPickerWatcher($scope, BaseService);

    MonthPicker($scope);

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.Report_Click = function () {

        switch ($scope.Section) {
            case 1:
                $scope.report = 'VME_Rpt_MSC_17_CQ_Total&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 2:
                $scope.report = 'VME_Rpt_MSC_18_CQ_Accrue&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 3:
                $scope.report = 'VME_Rpt_MSC_19_CQ_Adj_PY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            case 4:
                $scope.report = 'VME_Rpt_MSC_20_CQ_Adj_CY&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO;
                break;

            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.report, '_blank');
    }
}])

app.controller("Rpt1CampaignAllAccrue", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();
    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;

        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true);
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptCampaignAllSummary')
            .then(function (result) {
                $scope.ListHeader1 = result
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptCampaignAllAccrueDetail')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, 'GetCampaignAllAccrue', data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
                $scope.ListViewDetail = result.Table1;
            }, function (error) {
                console.log('Unable to load GetCampaignAllAccrue data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewSection = iNumber;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Report_Click = function () {

        if ($scope.ViewSection == 1) {
            reportCode = 'VME_Rpt_CMP_All_Type_Accrue_Summary';
            reportName = 'Campaign all accrue summary';
        } else if ($scope.ViewSection == 2) {
            reportCode = 'VME_Rpt_CMP_All_Type_Accrue_Detail';
            reportName = 'Campaign all accrue detail';
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }

}])

app.controller("Rpt2CampaignAllPayment", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();
    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;

        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true);
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptCampaignAllSummary')
            .then(function (result) {
                $scope.ListHeader1 = result
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptCampaignAllPaymentDetail')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, 'GetCampaignAllPayment', data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
                $scope.ListViewDetail = result.Table1;
            }, function (error) {
                console.log('Unable to load GetCampaignAllPayment data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewSection = iNumber;
        // if ($scope.ViewSection == 1) {
        //     $scope.REPORT_ID = 48;
        //     $scope.reportCode = 'VME_Rpt_FLT_S2';
        //     $scope.reportName = 'Payment summary';
        // } else if ($scope.ViewSection == 2) {
        //     $scope.REPORT_ID = 43;
        //     $scope.reportCode = 'VME_Rpt_CPN_D5';
        //     $scope.reportName = $scope.reportName + ' detail (' + $scope.PaymentType + ')';
        // }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Report_Click = function () {

        if ($scope.ViewSection == 1) {
            reportCode = 'VME_Rpt_CMP_All_Type_Payment_Summary';
            reportName = 'Campaign all payment summary';
        } else if ($scope.ViewSection == 2) {
            reportCode = 'VME_Rpt_CMP_All_Type_Payment_Detail';
            reportName = 'Campaign all payment detail';
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }

}])

app.controller("Rpt1IncentiveAccrue", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();
    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;

        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true);
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptIncentiveAllSummary')
            .then(function (result) {
                $scope.ListHeader1 = result
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptIncentiveAllAccrueDetail')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, 'GetIncentiveAllAccrue', data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
                $scope.ListViewDetail = result.Table1;
            }, function (error) {
                console.log('Unable to load GetIncentiveAllPayment data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewSection = iNumber;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Report_Click = function () {

        if ($scope.ViewSection == 1) {
            reportCode = 'VME_Rpt_INC_All_Type_Accrue_Summary';
            reportName = 'Incentive all accrue summary';
        } else if ($scope.ViewSection == 2) {
            reportCode = 'VME_Rpt_INC_All_Type_Accrue_Detail';
            reportName = 'Incentive all accrue detail';
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }

}])

app.controller("Rpt2IncentivePayment", ['$scope', 'BaseService', 'MS_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();
    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;

        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true);
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('RptIncentiveAllSummary')
            .then(function (result) {
                $scope.ListHeader1 = result
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('RptIncentiveAllPaymentDetail')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, 'GetIncentiveAllPayment', data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
                $scope.ListViewDetail = result.Table1;
            }, function (error) {
                console.log('Unable to load GetIncentiveAllPayment data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewSection = iNumber;
        // if ($scope.ViewSection == 1) {
        //     $scope.REPORT_ID = 48;
        //     $scope.reportCode = 'VME_Rpt_FLT_S2';
        //     $scope.reportName = 'Payment summary';
        // } else if ($scope.ViewSection == 2) {
        //     $scope.REPORT_ID = 43;
        //     $scope.reportCode = 'VME_Rpt_CPN_D5';
        //     $scope.reportName = $scope.reportName + ' detail (' + $scope.PaymentType + ')';
        // }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.Report_Click = function () {

        if ($scope.ViewSection == 1) {
            reportCode = 'VME_Rpt_INC_All_Type_Payment_Summary';
            reportName = 'Incentive all payment summary';
        } else if ($scope.ViewSection == 2) {
            reportCode = 'VME_Rpt_INC_All_Type_Payment_Detail';
            reportName = 'Incentive all payment detail';
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }

}])

app.controller("OverallAccrueController", ['$scope', 'BaseService', 'MS_PATH', 'SYSTEM_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, MS_PATH, SYSTEM_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.ViewSection = 1;
        $scope.SumDetail = 1;
        $scope.fnCall = 'GetOverallAccrue';
        GetHeader();
        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {

        var sendData = [{
            'TableName1': 'AllAccrueByModel'
            , 'TableName2': 'RptCampaignAllSummary'
            , 'TableName3': 'ModelFleetSummary2'
            , 'TableName4': 'RptIncentiveAllSummary'
            , 'TableName5': 'ModelDemoCarAccrueSummary'
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
                $scope.ListHeader3 = result.Table2;
                $scope.ListHeader4 = result.Table3;
                $scope.ListHeader5 = result.Table4;
                $scope.ListHeader = $scope.ListHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('ModelSummary1')
            .then(function (result) {
                $scope.ListHeader6 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(MS_PATH, $scope.fnCall, data)
            .then(function (result) {
                $scope.ViewDetailSum = result.Table;
            }, function (error) {
                console.log('Unable to load GetOverallAccrue data: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {

        $scope.ViewSection = iNumber;
        if ($scope.ViewSection == 1) {
            $scope.fnCall = 'GetOverallAccrue';
            $scope.ListHeader = $scope.ListHeader1;

        } else if ($scope.ViewSection == 2) {
            $scope.fnCall = 'GetCampaignAllAccrue';
            $scope.ListHeader = $scope.ListHeader2;

        } else if ($scope.ViewSection == 3) {
            $scope.fnCall = 'GetFleetAllAccrue';
            $scope.ListHeader = $scope.ListHeader3;

        } else if ($scope.ViewSection == 4) {
            $scope.fnCall = 'GetIncentiveAllAccrue';
            $scope.ListHeader = $scope.ListHeader4;

        } else if ($scope.ViewSection == 5) {
            $scope.fnCall = 'GetDemoCarAllAccrue';
            $scope.ListHeader = $scope.ListHeader5;

        } else if ($scope.ViewSection == 6) {
            $scope.fnCall = 'GetCQAllAccrue';
            $scope.ListHeader = $scope.ListHeader6;
        }
        GetData();
    }

    $scope.Report_Click = function () {

        switch ($scope.ViewSection) {
            case 1:
                reportCode = 'VME_Rpt_All_Type_Accrue_Summary';
                reportName = 'Overall Accrue summary';
                break;
            case 2:
                reportCode = 'VME_Rpt_CMP_All_Type_Accrue_Summary';
                reportName = 'Campaign all accrue summary';
                break;
            case 3:
                reportCode = 'VME_Rpt_FLT_AccrueWithCB_ByModel';
                reportName = 'Fleet accrue summary';
                break;
            case 4:
                reportCode = 'VME_Rpt_INC_All_Type_Accrue_Summary';
                reportName = 'Incentive all accrue summary';
                break;
            case 5:
                reportCode = 'VME_Rpt_DMC_All_Accrue_Summary';
                reportName = 'Demo car accrue summary';
                break;
            case 6:
                reportCode = 'VME_Rpt_CQ_All_Accrue_Summary';
                reportName = 'CQ incentive accrue summary';
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportName, '_blank');
    }

}])


function GetVMEReport($scope, BaseService, MS_PATH, VMEType) {
    $scope.GetVMETotal = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControl' + VMEType + 'Total', $scope.data)
            .then(function (result) {
                $scope.AmountList = result.Table;
                $scope.PerUnitList = result.Table1;
            }, function (error) {
                console.log('Unable to load ' + VMEType + ' Total data: ' + error.message);
            });
    };
    $scope.GetVMEAccrue = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControl' + VMEType + 'Accrue', $scope.data)
            .then(function (result) {
                $scope.AccrueList = result.Table;
            }, function (error) {
                console.log('Unable to load ' + VMEType + ' Accrue data: ' + error.message);
            });
    };
    $scope.GetVMEAdjustPY = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControl' + VMEType + 'AdjustPY', $scope.data)
            .then(function (result) {
                $scope.AdjustPYList = result.Table;
            }, function (error) {
                console.log('Unable to load ' + VMEType + ' AdjustPY data: ' + error.message);
            });
    };
    $scope.GetVMEAdjustCY = function () {
        BaseService.CallAction(MS_PATH, 'GetMSControl' + VMEType + 'AdjustCY', $scope.data)
            .then(function (result) {
                $scope.AdjustCYList = result.Table;
            }, function (error) {
                console.log('Unable to load ' + VMEType + ' AdjustCY data: ' + error.message);
            });
    };
}

function MonthPickerWatcher($scope, BaseService) {
    $scope.ViewDetail_Click = function () {
        $scope.AmountList = [];
        $scope.PerUnitList = [];
        $scope.AccrueList = [];
        $scope.AdjustPYList = [];
        $scope.AdjustCYList = [];
        $scope.ResultList = [];

        let dataMonthFrom = ($scope.MonthFrom) ?
            $scope.MonthFrom.getFullYear().toString()
            + ('00' + ($scope.MonthFrom.getMonth() + 1).toString()).substr(-2)
            : null;
        let dataMonthTo = ($scope.MonthTo) ?
            $scope.MonthTo.getFullYear().toString()
            + ('00' + ($scope.MonthTo.getMonth() + 1).toString()).substr(-2)
            : null;
        $scope.data = BaseService.ConvertParam({ "DATA_MONTH_FROM": dataMonthFrom, "DATA_MONTH_TO": dataMonthTo });
        $scope.GetMSControlSummary();
    }
}

function MonthPicker($scope) {
    $scope.openMonthFrom = function () {
        $scope.popupMonthFrom.opened = true;
    };
    $scope.popupMonthFrom = {
        opened: false,
    };
    $scope.openMonthTo = function () {
        $scope.popupMonthTo.opened = true;
    };
    $scope.popupMonthTo = {
        opened: false
    };
}
