app.controller("UserListController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, BizDataService, $filter) {

    $scope.init = function () {
        $scope.formData = {};
        $scope.userRoles = [{}];
        $scope.selectedRole = [];
        $scope.GetHeader();
        $scope.GetData();
        $scope.titles = {
            "EN": ["Mr.", "Mrs.", "Miss"],
            "TH": ["นาย", "นาง", "นางสาว"],
        }
        $scope.filters = {
            NAME: '',
        }

        $scope.formSubData = [];
    }

    $scope._subTypeList = function () {
        return [
            { SUB_USER_TYPE: "Opt" },
            { SUB_USER_TYPE: "Mgr" },
            { SUB_USER_TYPE: "Act" },
            { SUB_USER_TYPE: "Evt" },
            { SUB_USER_TYPE: "Tar" },
        ]
    }

    //$scope.GetOutlet = function () {
    //    BizDataService.GetOutletList().then(function (result) {
    //        $scope.OutletList = result
    //    }, function (error) {
    //        console.log('Unable to load outlet: ' + error.message);
    //    });
    //}

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("UserList").then(function (result) {
            $scope.ListHeader = result;
            console.log('$scope.ListDetail', $scope.ListHeader);
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetUsers").then(function (result) {
            $scope.ListDetail = result;
            console.log('$scope.ListDetail', $scope.ListDetail);
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.GetDepartment = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetDepartment").then(function (result) {
            $scope.DepartmentList = result
        }, function (error) {
            console.log('Unable to load department: ' + error.message)
        })
    }

    $scope.GetPosition = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetPosition").then(function (result) {
            $scope.PositionList = result
        }, function (error) {
            console.log('Unable to load position: ' + error.message)
        })
    }

    $scope.GetRoles = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetRoleHeader").then(function (result) {
            $scope.RoleList = result;
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.ShowUser = function (obj) {
        document.getElementById("UserInfo").style.display = "block";
        $scope.dealerSelected = null;

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
            if ($scope.formData.USER_TYPE == 'Dealer') {
                $scope.dealerSelected = $filter('filter')($scope.OutletList, { DEALER_ID: $scope.formData.REFERENCE_NO }, true)[0];

                BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserSubByID", obj.ID).then(function (result) {
                    if (result.length == 0) {
                        $scope.formSubData = $scope._subTypeList();
                    } else {
                        $scope.formSubData = result;
                    }
                }, function (error) {
                    console.log('Unable to load detail: ' + error.message)
                })
            } else {
                BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserSubByID", obj.ID).then(function (result) {
                    if (result.length == 0) {
                        $scope.userRoles = [{ ROLE_ID: $scope.formData.ROLE_ID }];
                    } else {
                        $scope.userRoles = result;
                    }
                }, function (error) {
                    console.log('Unable to load detail: ' + error.message)
                })
            }

        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddUser = function () {
        $scope.formData.ID = 0;
        $scope.formData.USER_STATUS = '1';
        $scope.formData.USER_TYPE = 'Employee';
        $scope.formData.HEAD_OFFICE = false;
        document.getElementById("UserInfo").style.display = "block";
        $scope.dealerSelected = null;
        $scope.formSubData = $scope._subTypeList();
    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.USER_TYPE == 'Employee') {
            if ($scope.formData.TITLE_TH == null || $scope.formData.FIRST_NAME_TH == null || $scope.formData.FIRST_NAME_TH == '' ||
                $scope.formData.LAST_NAME_TH == null || $scope.formData.LAST_NAME_TH == '') {
                BaseService.Message.warning("Name TH cannot empty.");
                return;
            }

            if ($scope.formData.TITLE_EN == null || $scope.formData.FIRST_NAME_EN == null || $scope.formData.FIRST_NAME_EN == '' ||
                $scope.formData.LAST_NAME_EN == null || $scope.formData.LAST_NAME_EN == '') {
                BaseService.Message.warning("Name EN cannot empty.");
                return;
            }

            //if ($scope.formData.DEPARTMENT_ID == null) {
            //    BaseService.Message.warning("Department cannot empty.");
            //    return;
            //}
            //if ($scope.formData.POSITION_ID == null) {
            //    BaseService.Message.warning("Position cannot empty.");
            //    return;
            //}
            if ($scope.formData.ID == 0 && ($scope.formData.PASSWORD == null || $scope.formData.PASSWORD == '')) {
                BaseService.Message.warning("Password cannot empty.");
                return;
            }
            if ($scope.formData.ID == 0 && ($scope.formData.PASSWORD2 == null || $scope.formData.PASSWORD2 == '')) {
                BaseService.Message.warning("Retype Password cannot empty.");
                return;
            }
            if ($scope.formData.PASSWORD != $scope.formData.PASSWORD2) {
                BaseService.Message.warning("Passwords do not match.");
                return;
            }
        } else if ($scope.formData.USER_TYPE == 'Dealer') {
            if ($scope.formData.FIRST_NAME_TH == null || $scope.formData.FIRST_NAME_TH == ''
                || $scope.formData.FIRST_NAME_EN == null || $scope.formData.FIRST_NAME_EN == '') {
                BaseService.Message.warning("Dealer name cannot empty");
            }
        }

        if ($scope.formData.EMAIL == null || $scope.formData.EMAIL == '') {
            BaseService.Message.warning("Email cannot empty.");
            return;
        }

        if ($scope.formData.REFERENCE_NO == null || $scope.formData.REFERENCE_NO == '') {
            BaseService.Message.warning("Reference no cannot empty.");
            return;
        }

        if ($scope.formData.USERNAME == null || $scope.formData.USERNAME == '') {
            BaseService.Message.warning("Username cannot empty");
            return;
        }

        selectedRole = $filter('filter')($scope.userRoles, function (item) {
            return item.ROLE_ID && item.ROLE_ID != ''
        }, true);
        if (selectedRole.length >= 1) {
            $scope.formData.ROLE_ID = selectedRole[0].ROLE_ID;
        }
        if ($scope.formData.ROLE_ID == null) {
            BaseService.Message.warning("Role cannot empty.");
            return;
        }

        BaseService.CallAction(SYSTEM_PATH, "SaveUser", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result.Result == "Done") {
                $scope.userID = result.ID

                if ($scope.formData.USER_TYPE == 'Dealer') {
                    $scope.formSubData.forEach(function (item, index) {
                        item.USER_ID = $scope.userID;
                        item.USERNAME = $scope.formData.USERNAME;
                        BaseService.CallAction(SYSTEM_PATH, "SaveSubUser", BaseService.ConvertParam(item)).then(function (result) {
                            if (index + 1 == $scope.formSubData.length) {
                                $scope.CloseModal();
                                $scope.GetData();
                                BaseService.Message.info("Successfully saved");
                            }
                        }, function (error) {
                            console.log('Unable to save department: ' + error.message)
                        })
                    })
                } else if ($scope.formData.USER_TYPE == 'Employee' && selectedRole.length > 1) {
                    selectedRole.forEach(function (item, index) {
                        item.USER_ID = $scope.userID;
                        item.USERNAME = $scope.formData.USERNAME;
                        item.SUB_USER_TYPE = 'CIMS';
                        BaseService.CallAction(SYSTEM_PATH, "SaveSubUser", BaseService.ConvertParam(item)).then(function (result) {
                            if (index + 1 == $scope.formSubData.length) {
                                $scope.CloseModal();
                                $scope.GetData();
                                BaseService.Message.info("Successfully saved");
                            }
                        }, function (error) {
                            console.log('Unable to save department: ' + error.message)
                        })
                    })
                } else {
                    $scope.CloseModal();
                    $scope.GetData();
                    BaseService.Message.info("Successfully saved");
                }
            } else {
                BaseService.Message.alert(result.Result);
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        $scope.formSubData = null;
        document.getElementById("UserInfo").style.display = "none";
    }

    $scope.ClearData = function (item) {
        $scope.formData = {};
        $scope.formData.ID = 0;
        $scope.formData.USER_STATUS = '1';
        $scope.formData.HEAD_OFFICE = false;
        $scope.dealerSelected = null;
        $scope.formData.USER_TYPE = item;
    }

    $scope.SetDealerData = function (obj) {
        $scope.formData.FIRST_NAME_TH = obj.DEALER_NAME_TH;
        $scope.formData.FIRST_NAME_EN = obj.DEALER_NAME_EN;
        $scope.formData.REFERENCE_NO = obj.DEALER_ID;
        $scope.formData.USERNAME = obj.DEALER_ID;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    //$scope.UserFilter = function () {
    //    return function (input) {

    //        return input.USER_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.USER_NAME_EN != null) ? input.USER_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false);
    //    }
    //}
    $scope.AddRole = function () {
        $scope.userRoles.push({});
    }

    $scope.init();
}])

app.controller("MenuController", ['$scope', 'BaseService', 'SYSTEM_PATH', function ($scope, BaseService, SYSTEM_PATH) {
    $scope.init = function () {
        $scope.formData = {};
        $scope.isHeader = true;
        $scope.GetHeader();
        $scope.GetData();
        $scope.filters = {
            NAME: '',
            HEADER_NAME: '',
        }
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        const action = ($scope.isHeader) ? "MenuHeaderList" : "MenuDetailList";
        BaseService.GetHeaderGridView(action).then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        const action = ($scope.isHeader) ? "GetMenuHeader" : "GetMenuDetail";
        BaseService.GetDataTable(SYSTEM_PATH, action).then(function (result) {
            $scope.ListDetail = result;
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.ShowMenu = function (obj) {
        $scope.GetMenuHeader();

        let action = null;

        if ($scope.isHeader) {
            document.getElementById("HeaderInfo").style.display = "block";
            action = "GetMenuHeaderByID"
        } else {
            document.getElementById("DetailInfo").style.display = "block";
            action = "GetMenuDetailByID"
        }


        BaseService.GetDataTableByParam(SYSTEM_PATH, action, obj.ID).then(function (result) {
            $scope.formData = result[0];
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.GetMenuHeader = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetMenuHeader").then(function (result) {
            $scope.MenuHeaderList = result;
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.ToggleMenu = function () {
        $scope.isHeader = !$scope.isHeader;
        $scope.GetHeader();
        $scope.GetData();
    }

    $scope.AddMenu = function () {
        $scope.GetMenuHeader();
        $scope.formData.ID = 0;
        if ($scope.isHeader) {
            $scope.formData.TITLE_STATUS = '1';
            document.getElementById("HeaderInfo").style.display = "block";
        } else {
            $scope.formData.MENU_STATUS = '1';
            $scope.formData.ROUTE_TYPE = 'WebView'
            document.getElementById("DetailInfo").style.display = "block";
        }
    }

    $scope.Edit_Submit = function () {
        if (($scope.formData.TITLE_NO == null || $scope.formData.TITLE_NO == '')
            && ($scope.formData.MENU_NO == null || $scope.formData.MENU_NO == '')) {
            BaseService.Message.warning("Title/Menu no cannot empty.");
            return;
        }
        if (($scope.formData.TITLE_NAME_TH == null || $scope.formData.TITLE_NAME_TH == '')
            && ($scope.formData.MENU_NAME_TH == null || $scope.formData.MENU_NAME_TH == '')) {
            BaseService.Message.warning("Title/Menu name TH cannot empty.");
            return;
        }
        if (($scope.formData.TITLE_NAME_EN == null || $scope.formData.TITLE_NAME_EN == '')
            && ($scope.formData.MENU_NAME_EN == null || $scope.formData.MENU_NAME_EN == '')) {
            BaseService.Message.warning("Title/Menu name EN cannot empty.");
            return;
        }

        const action = ($scope.isHeader) ? "SaveMenuHeader" : "SaveMenuDetail";
        BaseService.CallAction(SYSTEM_PATH, action, BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result == "Done") {
                $scope.CloseModal();
                $scope.GetData();
                BaseService.Message.info("Successfully saved");
            } else {
                BaseService.Message.alert(result);
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        document.getElementById("HeaderInfo").style.display = "none";
        document.getElementById("DetailInfo").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.MenuFilter = function () {
        return function (input) {

            return (
                input.TITLE_STATUS == '1'
                &&
                (input.TITLE_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.TITLE_NAME_EN != null) ? input.TITLE_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false))
            )
                || (
                    input.MENU_STATUS == '1'
                    &&
                    (input.MENU_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.MENU_NAME_EN != null) ? input.MENU_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false))
                    &&
                    (input.HEADER_NAME.indexOf($scope.filters.HEADER_NAME) >= 0)
                );
        }
    }

    $scope.init();
}])

app.controller("RolesController", ['$scope', 'BaseService', 'SYSTEM_PATH', '$filter', function ($scope, BaseService, SYSTEM_PATH, $filter) {
    $scope.init = function () {
        $scope.formData = {
            '_VIEW_HEADER_ID': [],
            '_EDIT_HEADER_ID': [],
            'VIEWABLE_ID': [],
            'EDITABLE_ID': [],
        };
        $scope.showHeaderDetail = {};
        $scope.GetHeader();
        $scope.GetData();
    }
    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("RoleList").then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetRoleHeader").then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.GetMenuHeader = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetMenuHeader").then(function (result) {
            $scope.MenuHeaderList = result;
        }, function (error) {
            console.log('Unable to load menu detail: ' + error.message)
        })
    }

    $scope.GetMenuDetail = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetMenuDetail").then(function (result) {
            $scope.MenuDetailList = result;
        }, function (error) {
            console.log('Unable to load menu detail: ' + error.message)
        })
    }

    $scope.ShowRole = function (obj) {
        $scope.showHeaderDetail = {};
        document.getElementById("RoleInfo").style.display = "block";

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetRoleHeaderByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
            $scope.formData._VIEW_HEADER_ID = [];
            $scope.formData._EDIT_HEADER_ID = [];
            $scope.formData.VIEWABLE_ID = [];
            $scope.formData.EDITABLE_ID = [];

            BaseService.GetDataTableByParam(SYSTEM_PATH, "GetRoleDetail", obj.ID).then(function (result) {
                result.forEach(function (item) {
                    if (item.VIEWABLE) {
                        $scope.formData._VIEW_HEADER_ID.push(item.MENU_HEADER_ID);
                        $scope.formData.VIEWABLE_ID.push(item.MENU_DETAIL_ID);
                    }
                    if (item.EDITABLE) {
                        $scope.formData._EDIT_HEADER_ID.push(item.MENU_HEADER_ID);
                        $scope.formData.EDITABLE_ID.push(item.MENU_DETAIL_ID);
                    }
                })
            }, function (error) {
                console.log('Unable to load detail: ' + error.message)
            })

        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddRole = function () {
        $scope.formData.ID = 0;
        $scope.formData.ROLE_STATUS = '1';
        document.getElementById("RoleInfo").style.display = "block";
    }

    $scope.Edit_Submit = function () {
        if ($scope.formData.ROLE_NAME_TH == null || $scope.formData.ROLE_NAME_TH == '') {
            BaseService.Message.warning("Role name TH cannot empty.");
            return;
        }
        if ($scope.formData.ROLE_NAME_EN == null || $scope.formData.ROLE_NAME_EN == '') {
            BaseService.Message.warning("Role name EN cannot empty.");
            return;
        }

        if ($scope.formData.VIEWABLE_ID.length == 0) {
            BaseService.Message.warning("one or more menu cannot empty.");
            return;
        }

        BaseService.CallAction(SYSTEM_PATH, "SaveRole", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result == "Done") {
                $scope.CloseModal();
                $scope.GetData();
                BaseService.Message.info("Successfully saved");
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.ToggletoView = function (obj) {
        const thisItemID = obj.ID;
        const thisHeaderID = obj.HEADER_ID;
        let thisElement = document.getElementById("V_" + thisItemID.toString());
        let editElement = document.getElementById("E_" + thisItemID.toString());

        if (!thisElement.classList.contains("btn-primary")) {
            $scope.formData.VIEWABLE_ID.push(thisItemID);
            $scope.formData._VIEW_HEADER_ID.push(thisHeaderID);
        } else {
            $scope.formData.VIEWABLE_ID.splice($scope.formData.VIEWABLE_ID.indexOf(thisItemID), 1);
            $scope.formData._VIEW_HEADER_ID.splice($scope.formData._VIEW_HEADER_ID.indexOf(thisHeaderID), 1);
            if (editElement.classList.contains("btn-primary")) {
                $scope.ToggletoEdit(obj);
            }
        }
    }

    $scope.ToggletoEdit = function (obj) {
        const thisItemID = obj.ID;
        const thisHeaderID = obj.HEADER_ID;
        let thisElement = document.getElementById("E_" + thisItemID.toString());
        let viewElement = document.getElementById("V_" + thisItemID.toString());

        if (!thisElement.classList.contains("btn-primary")) {
            $scope.formData.EDITABLE_ID.push(thisItemID);
            $scope.formData._EDIT_HEADER_ID.push(thisHeaderID);
            if (!viewElement.classList.contains("btn-primary")) {
                $scope.ToggletoView(obj);
            }
        } else {
            $scope.formData.EDITABLE_ID.splice($scope.formData.EDITABLE_ID.indexOf(thisItemID), 1);
            $scope.formData._EDIT_HEADER_ID.splice($scope.formData._EDIT_HEADER_ID.indexOf(thisHeaderID), 1);
        }
    }

    $scope.ToggleHeader = function (obj, type) {
        const thisItemID = obj.ID;
        const details = $filter('filter')($scope.MenuDetailList, { HEADER_ID: thisItemID }, true);
        const toggleDetailFunction = (type == 'View') ? $scope.ToggletoView : $scope.ToggletoEdit;

        details.forEach(function (detail) {
            toggleDetailFunction(detail);
        })
    }

    $scope.HeaderClass = function (obj, type) {
        const thisItemID = obj.ID;
        const isHeaderSelect = (type == 'View') ? $scope.formData._VIEW_HEADER_ID.indexOf(thisItemID) >= 0 : $scope.formData._EDIT_HEADER_ID.indexOf(thisItemID) >= 0;

        return {
            'btn': true,
            'btn-default': !isHeaderSelect,
            'btn-primary': isHeaderSelect,
        }
    }

    $scope.DetailClass = function (obj, type) {
        const thisItemID = obj.ID;
        const isDetailSelect = (type == 'View') ? $scope.formData.VIEWABLE_ID.indexOf(thisItemID) >= 0 : $scope.formData.EDITABLE_ID.indexOf(thisItemID) >= 0;

        return {
            'btn': true,
            'btn-default': !isDetailSelect,
            'btn-primary': isDetailSelect,
        }
    }

    $scope.CloseModal = function () {
        $scope.formData = {
            '_VIEW_HEADER_ID': [],
            '_EDIT_HEADER_ID': [],
            'VIEWABLE_ID': [],
            'EDITABLE_ID': [],
        };
        document.getElementById("RoleInfo").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    $scope.init();
}])

app.controller("DepartmentController", ['$scope', 'BaseService', 'SYSTEM_PATH', function ($scope, BaseService, SYSTEM_PATH) {

    $scope.init = function () {
        $scope.formData = {};
        $scope.GetHeader();
        $scope.GetData();
        $scope.filters = {
            NAME: '',
        }
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("DepartmentList").then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetDepartment").then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.ShowDepartment = function (obj) {
        document.getElementById("DepartmentInfo").style.display = "block";

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetDepartmentByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddDepartment = function () {
        $scope.formData.ID = 0;
        $scope.formData.DEPT_STATUS = '1';
        document.getElementById("DepartmentInfo").style.display = "block";
    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.DEPT_NAME_TH == null || $scope.formData.DEPT_NAME_TH == '') {
            BaseService.Message.warning("Name TH cannot empty.");
            return;
        }
        if ($scope.formData.DEPT_NAME_EN == null || $scope.formData.DEPT_NAME_EN == '') {
            BaseService.Message.warning("Name EN cannot empty.");
            return;
        }
        BaseService.CallAction(SYSTEM_PATH, "SaveDepartment", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result == "Done") {
                $scope.CloseModal();
                $scope.GetData();
                BaseService.Message.info("Successfully saved");
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        document.getElementById("DepartmentInfo").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.DepartmentFilter = function () {
        return function (input) {
            return input.DEPT_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.DEPT_NAME_EN != null) ? input.DEPT_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false);
        }
    }

    $scope.init();
}])

app.controller("PositionController", ['$scope', 'BaseService', 'SYSTEM_PATH', function ($scope, BaseService, SYSTEM_PATH) {

    $scope.init = function () {
        $scope.formData = {};
        $scope.GetHeader();
        $scope.GetData();
        $scope.filters = {
            NAME: '',
        }
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("PositionList").then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetPosition").then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.ShowPosition = function (obj) {
        document.getElementById("PositionInfo").style.display = "block";

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetPositionByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddPosition = function () {
        $scope.formData.ID = 0;
        $scope.formData.POSITION_STATUS = '1';
        document.getElementById("PositionInfo").style.display = "block";
    }

    $scope.Edit_Submit = function () {
        if ($scope.formData.POSITION_NAME_TH == null || $scope.formData.POSITION_NAME_TH == '') {
            BaseService.Message.warning("Name TH cannot empty.");
            return;
        }
        if ($scope.formData.POSITION_NAME_EN == null || $scope.formData.POSITION_NAME_EN == '') {
            BaseService.Message.warning("Name EN cannot empty.");
            return;
        }
        BaseService.CallAction(SYSTEM_PATH, "SavePosition", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result == "Done") {
                $scope.CloseModal();
                $scope.GetData();
                BaseService.Message.info("Successfully saved");
            }
        }, function (error) {
            console.log('Unable to save position: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        document.getElementById("PositionInfo").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.PositionFilter = function () {
        return function (input) {
            return input.POSITION_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.POSITION_NAME_EN != null) ? input.POSITION_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false);
        }
    }

    $scope.init();
}])

app.controller("PersonalController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'BizDataService', function ($scope, BaseService, SYSTEM_PATH, BizDataService) {

    $scope.init = function () {
        $scope.formData = {};
        $scope.titles = {
            "EN": ["Mr.", "Mrs.", "Miss"],
            "TH": ["นาย", "นาง", "นางสาว"],
        }

        $scope.GetData();
    }

    $scope.GetDepartment = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetDepartment").then(function (result) {
            $scope.DepartmentList = result
        }, function (error) {
            console.log('Unable to load department: ' + error.message)
        })
    }

    $scope.GetPosition = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetPosition").then(function (result) {
            $scope.PositionList = result
        }, function (error) {
            console.log('Unable to load position: ' + error.message)
        })
    }

    $scope.GetData = function () {
        BaseService.CallAction(SYSTEM_PATH, "GetPersonalData", "").then(function (result) {
            $scope.formData = result[0];
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.SaveUser = function () {

        BaseService.CallAction(SYSTEM_PATH, "CheckPersonalChange", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result != "Done") {
                BaseService.Message.alert(result);
                return;
            } else {
                BaseService.CallAction(SYSTEM_PATH, "SaveUser", BaseService.ConvertParam($scope.formData)).then(function (result) {
                    if (result == "Done") {
                        $scope.GetData();
                        BaseService.Message.info("Successfully saved");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to save department: ' + error.message)
                })
            }
        }, function (error) {
            console.log('Unable to save data: ' + error.message)
        })
    }

    $scope.CancelEdit = function () {
        window.location.href = "/System/Main";
    }

    $scope.init();
}])

app.controller("ChangePWDController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'BizDataService', function ($scope, BaseService, SYSTEM_PATH, BizDataService) {

    $scope.init = function () {
        $scope.formData = {};

        $scope.$watch('passwordExpire', function (value) {
            if (value) {
                BaseService.Message.alert("รหัสผ่านของท่านหมดอายุ กรุณาเปลี่ยนรหัสผ่านก่อนเข้าใช้งาน");
            }
        })
    }

    $scope.SaveChangePWD = function (username) {
        $scope.formData.username = username;
        BaseService.CallAction(SYSTEM_PATH, "CheckPersonalChange", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result != "Done") {
                BaseService.Message.alert(result);
                return;
            } else {
                BaseService.CallAction(SYSTEM_PATH, "UpdateNewPWD", BaseService.ConvertParam($scope.formData)).then(function (result) {
                    if (result == "Done") {
                        BaseService.Message.info("Password changed successfully.").then(function () {
                            document.getElementById("formChangePWD").submit();
                        })
                    }
                }, function (error) {
                    console.log('Unable to save data: ' + error.message)
                })
            }
        }, function (error) {
            console.log('Unable to save data: ' + error.message)
        })
    }

    $scope.CancelEdit = function () {
        window.history.back();
    }

    $scope.init();
}])

app.controller("LanguageController", ['$scope', 'BaseService', 'SYSTEM_PATH', '$filter', function ($scope, BaseService, SYSTEM_PATH, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.LangData = {};
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("Language")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.CallAction(SYSTEM_PATH, "GetLanguage")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load dealer data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(SYSTEM_PATH, "GetLanguage", data)
            .then(function (result) {
                $scope.formData.Language = result[0];
            }, function (error) {
                console.log('Unable to load language data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.Edit_Submit = function () {

        let scopeData = $scope.formData.Language;
        let data = BaseService.ConvertParam(scopeData);

        BaseService.CallAction(SYSTEM_PATH, "UpdateLanguage", data)
            .then(function (result) {
                GetData();
                document.getElementById('DetailModal').style.display = 'none';
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            });

        BaseService.CallAction(SYSTEM_PATH, "GetLanguageTH", data)
            .then(function (result) {
                $scope.LangData.Menu = result.Table;
                $scope.LangData.Label = result.Table1;
                $scope.LangData.msgInfo = result.Table2;
                $scope.LangData.msgWarning = result.Table3;
                $scope.LangData.msgAlert = result.Table4;
                $scope.LangData.msgConfirm = result.Table5;

                $scope.formData.SaveTXT = JSON.stringify($scope.LangData);
                $scope.formData.Language = "TH";
                let data = BaseService.ConvertParam($scope.formData);
                BaseService.CallAction(SYSTEM_PATH, "UpdateLanguageJSON", data)
                    .then(function (error) {
                    });

            }, function (error) {
                console.log('Unable to load language data: ' + error.message)
            });

        BaseService.CallAction(SYSTEM_PATH, "GetLanguageEN", data)
            .then(function (result) {
                $scope.LangData.Menu = result.Table;
                $scope.LangData.Label = result.Table1;
                $scope.LangData.msgInfo = result.Table2;
                $scope.LangData.msgWarning = result.Table3;
                $scope.LangData.msgAlert = result.Table4;
                $scope.LangData.msgConfirm = result.Table5;

                $scope.formData.SaveTXT = JSON.stringify($scope.LangData);
                $scope.formData.Language = "EN";
                let data = BaseService.ConvertParam($scope.formData);
                BaseService.CallAction(SYSTEM_PATH, "UpdateLanguageJSON", data)
                    .then(function (error) {
                    });

            }, function (error) {
                console.log('Unable to load language data: ' + error.message)
            });
    }
}])

app.controller("GridviewController", ['$scope', 'BaseService', 'SYSTEM_PATH', function ($scope, BaseService, SYSTEM_PATH) {
    $scope.init = function () {
        $scope.formData = {};
        $scope.isHeader = true;
        $scope.newGridView = false;
        $scope.GetHeader();
        $scope.GetData();
        $scope.sortType = 'RNO';
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        if ($scope.isHeader) {
            BaseService.GetHeaderGridView("GridViewListHeader").then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        } else {
            BaseService.GetHeaderGridView("GridViewListDetail").then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        }
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        if ($scope.isHeader) {
            BaseService.GetDataTable(SYSTEM_PATH, "GetGridViewHeader").then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load detail: ' + error.message)
            });
        } else {
            BaseService.GetDataTableByParam(SYSTEM_PATH, "GetGridViewHeader", $scope.formData.TABLE_NAME).then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load detail: ' + error.message)
            });
        }

    }

    $scope.ShowGridViewDetail = function (obj) {
        $scope.FILTER = null;
        if ($scope.isHeader) {
            $scope.isHeader = false;
            $scope.formData.TABLE_NAME = obj.TABLE_NAME;
            $scope.GetHeader();
            $scope.GetData();
        } else {
            $scope.newGridView = false;
            document.getElementById("DetailInfo").style.display = "block";
            BaseService.GetDataTableByParam(SYSTEM_PATH, "GetGridViewDetail", obj.ID).then(function (result) {
                $scope.formData = result[0];
            }, function (error) {
                console.log('Unable to load detail: ' + error.message)
            })
        }
    }

    $scope.GetMenuHeader = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetMenuHeader").then(function (result) {
            $scope.MenuHeaderList = result;
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddGridView = function () {
        $scope.formData.ID = 0;
        $scope.newGridView = true;
        document.getElementById("DetailInfo").style.display = "block";
    }

    $scope.Edit_Submit = function () {
        if ($scope.formData.TABLE_NAME == null || $scope.formData.TABLE_NAME == '') {
            BaseService.Message.warning('Table name cannot empty.');
            return;
        }
        if ($scope.formData.RNO == null) {
            BaseService.Message.warning('Order no cannot empty.');
            return;
        }
        if ($scope.formData.FIELD_NAME == null || $scope.formData.FIELD_NAME == '') {
            BaseService.Message.warning('Field name cannot empty.');
            return;
        }
        if ($scope.formData.TITLE_TH == null || $scope.formData.TITLE_TH == '') {
            BaseService.Message.warning('Title name TH cannot empty.');
            return;
        }
        if ($scope.formData.TITLE_EN == null || $scope.formData.TITLE_EN == '') {
            BaseService.Message.warning('Title name EN cannot empty.');
            return;
        }
        if ($scope.formData.WIDTH == null || $scope.formData.WIDTH == '') {
            BaseService.Message.warning('Width cannot empty.');
            return;
        }
        if ($scope.formData.ALIGN == null) {
            BaseService.Message.warning('Align cannot empty.');
            return;
        }
        if ($scope.formData.V_ALIGN == null) {
            BaseService.Message.warning('Vertical align cannot empty.');
            return;
        }
        if ($scope.formData.DATA_TYPE == null) {
            BaseService.Message.warning('Data type cannot empty.');
            return;
        }
        BaseService.CallAction(SYSTEM_PATH, "SaveGridView", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result == "Done") {
                BaseService.Message.info("Successfully saved").then(function () {
                    $scope.GetData();
                    $scope.CloseModal();
                })
            } else {
                BaseService.Message.alert(result);
            }
        }, function (error) {
            console.log('Unable to save SaveGridView: ' + error.message)
        });
    }

    $scope.CloseModal = function () {
        var TABLE_NAME = $scope.formData.TABLE_NAME;
        $scope.formData = {};
        document.getElementById("DetailInfo").style.display = "none";
        $scope.formData.TABLE_NAME = TABLE_NAME;
    }

    $scope.CloseExpanded = function () {
        $scope.formData = {};
        $scope.FILTER = null;
        $scope.isHeader = true;
        $scope.GetHeader();
        $scope.GetData();
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.init();
}])

app.controller("ReportConfigureController", ['$scope', 'BaseService', 'SYSTEM_PATH', function ($scope, BaseService, SYSTEM_PATH) {

    $scope.init = function () {
        $scope.formData = {};
        $scope.GetHeader();
        $scope.GetData();
        $scope.filters = {
            NAME: '',
        }
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("ReportConfigure").then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)

        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetReportConfigure").then(function (result) {
            $scope.ListDetail = result
            console.log(result)
        }, function (error) {
            console.log('Unable to load data: ' + error.message)
        })
    }

    $scope.ShowReportConfigure = function (obj) {
        document.getElementById("ReportConfigureInfo").style.display = "block";

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetReportConfigureByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddReportConfigure = function () {
        $scope.formData.ID = 0;
        document.getElementById("ReportConfigureInfo").style.display = "block";
    }

    $scope.Edit_Submit = function () {
        BaseService.CallAction(SYSTEM_PATH, "SaveReportConfigure", $.param($scope.formData)).then(function (result) {
            if (result == "Done") {
                $scope.CloseModal();
                $scope.GetData();
                BaseService.Message.info("Successfully saved");
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        document.getElementById("ReportConfigureInfo").style.display = "none";
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.init();
}])
app.controller("RolesLoginController", ["$scope", "BaseService", "SYSTEM_PATH", function ($scope, BaseService, SYSTEM_PATH) {
    $scope.init = function () {
        $scope.SubUserList = [];
        $scope.GetData();
        $scope.roleid = null;
    }
    $scope.GetData = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetUserRoles")
            .then(function (result) {
                $scope.SubUserList = result;
            })
    }
    $scope.btnTypeClass = function (type) {
        return {
            'btn': true,
            'btn-block': true,
            'btn-default': $scope.subusertype != type,
            'btn-submit': $scope.subusertype == type
        };
    }
    $scope.SelectSubUser = function (obj) {
        $scope.subusertype = obj.SUB_USER_TYPE;
        $scope.roleid = obj.ROLE_ID
        document.formLogin.roleid.value = obj.ROLE_ID;
        document.formLogin.subusertype.value = obj.SUB_USER_TYPE;
        document.formLogin.submit();
    }
    $scope.init();
}])



app.controller("UserChangePasswordController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, BizDataService, $filter) {

    $scope.init = function () {
        $scope.MenuSection = 0
        $scope.formData = {};
        $scope.userRoles = [{}];
        $scope.selectedRole = [];
        $scope.GetHeader();
        $scope.GetData();
        $scope.titles = {
            "EN": ["Mr.", "Mrs.", "Miss"],
            "TH": ["นาย", "นาง", "นางสาว"],
        }
        $scope.filters = {
            NAME: '',
        }

        $scope.formSubData = [];
    }

    $scope._subTypeList = function () {
        return [
            { SUB_USER_TYPE: "Opt" },
            { SUB_USER_TYPE: "Mgr" },
            { SUB_USER_TYPE: "Act" },
            { SUB_USER_TYPE: "Evt" },
            { SUB_USER_TYPE: "Tar" },
        ]
    }

    $scope.GetOutlet = function () {
        BizDataService.GetOutletList().then(function (result) {
            $scope.OutletList = result
        }, function (error) {
            console.log('Unable to load outlet: ' + error.message);
        });
    }

    $scope.GetHeader = function () {
        $scope.ListHeader = null;
        BaseService.GetHeaderGridView("UserList").then(function (result) {
            $scope.ListHeader = result
        }, function (error) {
            console.log('Unable to load header data: ' + error.message)
        })
    }

    $scope.GetData = function () {
        $scope.ListDetail = null;
        BaseService.GetDataTable(SYSTEM_PATH, "GetUsersForDealer").then(function (result) {
            $scope.ListDetail = result
        }, function (error) {
            console.log('Unable to GetUsersForDealer: ' + error.message)
        })
    }

    $scope.GetDepartment = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetDepartment").then(function (result) {
            $scope.DepartmentList = result
        }, function (error) {
            console.log('Unable to load department: ' + error.message)
        })
    }

    $scope.GetPosition = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetPosition").then(function (result) {
            $scope.PositionList = result
        }, function (error) {
            console.log('Unable to load position: ' + error.message)
        })
    }

    $scope.GetRoles = function () {
        BaseService.GetDataTable(SYSTEM_PATH, "GetRoleHeader").then(function (result) {
            $scope.RoleList = result;
        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.ShowUser = function (obj) {

        document.getElementById("UserInfo").style.display = "block";
        $scope.dealerSelected = null;

        BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserByID", obj.ID).then(function (result) {
            $scope.formData = result[0];
            if ($scope.formData.USER_TYPE == 'Dealer') {
                $scope.dealerSelected = $filter('filter')($scope.OutletList, { DEALER_ID: $scope.formData.REFERENCE_NO }, true)[0];

                BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserSubByID", obj.ID).then(function (result) {
                    if (result.length == 0) {
                        $scope.formSubData = $scope._subTypeList();
                    } else {
                        $scope.formSubData = result;
                    }
                }, function (error) {
                    console.log('Unable to load detail: ' + error.message)
                })
            } else {
                BaseService.GetDataTableByParam(SYSTEM_PATH, "GetUserSubByID", obj.ID).then(function (result) {
                    if (result.length == 0) {
                        $scope.userRoles = [{ ROLE_ID: $scope.formData.ROLE_ID }];
                    } else {
                        $scope.userRoles = result;
                    }
                }, function (error) {
                    console.log('Unable to load detail: ' + error.message)
                })
            }

        }, function (error) {
            console.log('Unable to load detail: ' + error.message)
        })
    }

    $scope.AddUser = function () {
        $scope.formData.ID = 0;
        $scope.formData.USER_STATUS = '1';
        $scope.formData.USER_TYPE = 'Employee';
        $scope.formData.HEAD_OFFICE = false;
        document.getElementById("UserInfo").style.display = "block";
        $scope.dealerSelected = null;
        $scope.formSubData = $scope._subTypeList();
    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.USER_TYPE == 'Employee') {
            if ($scope.formData.TITLE_TH == null || $scope.formData.FIRST_NAME_TH == null || $scope.formData.FIRST_NAME_TH == '' ||
                $scope.formData.LAST_NAME_TH == null || $scope.formData.LAST_NAME_TH == '') {
                BaseService.Message.warning("Name TH cannot empty.");
                return;
            }

            if ($scope.formData.TITLE_EN == null || $scope.formData.FIRST_NAME_EN == null || $scope.formData.FIRST_NAME_EN == '' ||
                $scope.formData.LAST_NAME_EN == null || $scope.formData.LAST_NAME_EN == '') {
                BaseService.Message.warning("Name EN cannot empty.");
                return;
            }

            if ($scope.formData.DEPARTMENT_ID == null) {
                BaseService.Message.warning("Department cannot empty.");
                return;
            }
            if ($scope.formData.POSITION_ID == null) {
                BaseService.Message.warning("Position cannot empty.");
                return;
            }
            if ($scope.formData.ID == 0 && ($scope.formData.PASSWORD == null || $scope.formData.PASSWORD == '')) {
                BaseService.Message.warning("Password cannot empty.");
                return;
            }
            if ($scope.formData.ID == 0 && ($scope.formData.PASSWORD2 == null || $scope.formData.PASSWORD2 == '')) {
                BaseService.Message.warning("Retype Password cannot empty.");
                return;
            }
            if ($scope.formData.PASSWORD != $scope.formData.PASSWORD2) {
                BaseService.Message.warning("Passwords do not match.");
                return;
            }
        } else if ($scope.formData.USER_TYPE == 'Dealer') {
            if ($scope.formData.FIRST_NAME_TH == null || $scope.formData.FIRST_NAME_TH == ''
                || $scope.formData.FIRST_NAME_EN == null || $scope.formData.FIRST_NAME_EN == '') {
                BaseService.Message.warning("Dealer name cannot empty");
            }
        }

        if ($scope.formData.EMAIL == null || $scope.formData.EMAIL == '') {
            BaseService.Message.warning("Email cannot empty.");
            return;
        }

        if ($scope.formData.REFERENCE_NO == null || $scope.formData.REFERENCE_NO == '') {
            BaseService.Message.warning("Reference no cannot empty.");
            return;
        }

        if ($scope.formData.USERNAME == null || $scope.formData.USERNAME == '') {
            BaseService.Message.warning("Username cannot empty");
            return;
        }

        selectedRole = $filter('filter')($scope.userRoles, function (item) {
            return item.ROLE_ID && item.ROLE_ID != ''
        }, true);
        if (selectedRole.length >= 1) {
            $scope.formData.ROLE_ID = selectedRole[0].ROLE_ID;
        }
        if ($scope.formData.ROLE_ID == null) {
            BaseService.Message.warning("Role cannot empty.");
            return;
        }

        BaseService.CallAction(SYSTEM_PATH, "SaveUser", BaseService.ConvertParam($scope.formData)).then(function (result) {
            if (result.Result == "Done") {
                $scope.userID = result.ID

                if ($scope.formData.USER_TYPE == 'Dealer') {
                    $scope.formSubData.forEach(function (item, index) {
                        item.USER_ID = $scope.userID;
                        item.USERNAME = $scope.formData.USERNAME;
                        BaseService.CallAction(SYSTEM_PATH, "SaveSubUser", BaseService.ConvertParam(item)).then(function (result) {
                            if (index + 1 == $scope.formSubData.length) {
                                $scope.CloseModal();
                                $scope.GetData();
                                BaseService.Message.info("Successfully saved");
                            }
                        }, function (error) {
                            console.log('Unable to save department: ' + error.message)
                        })
                    })
                } else if ($scope.formData.USER_TYPE == 'Employee' && selectedRole.length > 1) {
                    selectedRole.forEach(function (item, index) {
                        item.USER_ID = $scope.userID;
                        item.USERNAME = $scope.formData.USERNAME;
                        item.SUB_USER_TYPE = 'CIMS';
                        BaseService.CallAction(SYSTEM_PATH, "SaveSubUser", BaseService.ConvertParam(item)).then(function (result) {
                            if (index + 1 == $scope.formSubData.length) {
                                $scope.CloseModal();
                                $scope.GetData();
                                BaseService.Message.info("Successfully saved");
                            }
                        }, function (error) {
                            console.log('Unable to save department: ' + error.message)
                        })
                    })
                } else {
                    $scope.CloseModal();
                    $scope.GetData();
                    BaseService.Message.info("Successfully saved");
                }
            } else {
                BaseService.Message.alert(result.Result);
            }
        }, function (error) {
            console.log('Unable to save department: ' + error.message)
        })
    }

    $scope.CloseModal = function () {
        $scope.formData = {};
        $scope.formSubData = null;
        document.getElementById("UserInfo").style.display = "none";
    }

    $scope.ClearData = function (item) {
        $scope.formData = {};
        $scope.formData.ID = 0;
        $scope.formData.USER_STATUS = '1';
        $scope.formData.HEAD_OFFICE = false;
        $scope.dealerSelected = null;
        $scope.formData.USER_TYPE = item;
    }

    $scope.SetDealerData = function (obj) {
        $scope.formData.FIRST_NAME_TH = obj.DEALER_NAME_TH;
        $scope.formData.FIRST_NAME_EN = obj.DEALER_NAME_EN;
        $scope.formData.REFERENCE_NO = obj.DEALER_ID;
        $scope.formData.USERNAME = obj.DEALER_ID;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.UserFilter = function () {
        return function (input) {

            return input.USER_NAME_TH.indexOf($scope.filters.NAME) >= 0 || ((input.USER_NAME_EN != null) ? input.USER_NAME_EN.indexOf($scope.filters.NAME) >= 0 : false);
        }
    }
    $scope.AddRole = function () {
        $scope.userRoles.push({});
    }

    $scope.init();

}])
