﻿using System.Web;
using System.Web.Optimization;

namespace SMGO
{
    public class BundleConfig
    {
        // For more information on bundling, visit https://go.microsoft.com/fwlink/?LinkId=301862
        public static void RegisterBundles(BundleCollection bundles)
        {
            bundles.Add(new ScriptBundle("~/bundles/jquery").Include(
                        "~/Scripts/jquery-{version}.js"));

            bundles.Add(new ScriptBundle("~/bundles/jqueryval").Include(
                        "~/Scripts/jquery.validate*"));

            // Use the development version of Modernizr to develop with and learn from. Then, when you're
            // ready for production, use the build tool at https://modernizr.com to pick only the tests you need.
            bundles.Add(new ScriptBundle("~/bundles/modernizr").Include(
                        "~/Scripts/modernizr-*"));

            bundles.Add(new ScriptBundle("~/bundles/bootstrap").Include(
                      "~/Scripts/bootstrap.js",
                      "~/Scripts/respond.js"));

            bundles.Add(new StyleBundle("~/Content/css").Include(
                      "~/Content/bootstrap.css",
                      "~/Content/site.css",
                      "~/Content/BaseSite.css",
                      "~/Content/ui-bootstrap-csp.css",
                      "~/Content/W3.css"));

            bundles.Add(new ScriptBundle("~/bundles/nglibs").Include(
                    "~/Scripts/angular.js",
                    "~/Scripts/angular-resource.js",
                    "~/Scripts/angular-idle.js",
                    "~/Scripts/ng-file-upload.js",
                    "~/Scripts/angular-ui/ui-bootstrap-tpls.js"));

            bundles.Add(new ScriptBundle("~/bundles/ngcomponents").Include(
                        "~/AngApp/AppVME.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cCampaign.js",
                        "~/AngApp/cFleet.js",
                        "~/AngApp/cConfiguration.js",
                        "~/AngApp/cLeasing.js",
                        "~/AngApp/cInsurance.js",
                        "~/AngApp/cDealerPortal.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cIncentive.js",
                        "~/AngApp/cCQ.js",
                        "~/AngApp/cAccount.js",
                        "~/AngApp/cSystem.js",
                        "~/AngApp/cInterface.js",
                        "~/AngApp/cMSControl.js",
                        "~/AngApp/cDemoCar.js"
                        ));

            bundles.Add(new ScriptBundle("~/bundles/ngCMP").Include(
                       "~/AngApp/AppVME.js",
                       "~/AngApp/FactoryServices.js",
                       "~/AngApp/cCampaign.js",
                       "~/AngApp/cConfiguration.js",
                       "~/AngApp/cLeasing.js",
                       "~/AngApp/cInsurance.js",
                       "~/AngApp/cDealerPortal.js",
                       "~/AngApp/FactoryServices.js",
                       "~/AngApp/cAccount.js",
                       "~/AngApp/cSystem.js",
                       "~/AngApp/cInterface.js"
                       ));

            bundles.Add(new ScriptBundle("~/bundles/ngFLT").Include(
                        "~/AngApp/AppVME.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cFleet.js",
                        "~/AngApp/cConfiguration.js",
                        "~/AngApp/cDealerPortal.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cAccount.js",
                        "~/AngApp/cSystem.js"
                        ));

            bundles.Add(new ScriptBundle("~/bundles/ngDMC").Include(
                       "~/AngApp/AppVME.js",
                       "~/AngApp/FactoryServices.js",                    
                       "~/AngApp/cConfiguration.js",                    
                       "~/AngApp/FactoryServices.js",                     
                       "~/AngApp/cAccount.js",
                       "~/AngApp/cSystem.js",
                       "~/AngApp/cDemoCar.js"
                       ));

            bundles.Add(new ScriptBundle("~/bundles/ngINC").Include(
                        "~/AngApp/AppVME.js",
                        "~/AngApp/FactoryServices.js",                    
                        "~/AngApp/cConfiguration.js",                  
                        "~/AngApp/cDealerPortal.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cIncentive.js",          
                        "~/AngApp/cAccount.js",
                        "~/AngApp/cSystem.js"
                        ));

            bundles.Add(new ScriptBundle("~/bundles/ngVDM").Include(
                        "~/AngApp/AppVME.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cConfiguration.js",
                        "~/AngApp/cDealerPortal.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cCQ.js",
                        "~/AngApp/cAccount.js",
                        "~/AngApp/cSystem.js"
                        ));


            bundles.Add(new ScriptBundle("~/bundles/ngDealer").Include(
                        "~/AngApp/AppVME.js",
                        "~/AngApp/FactoryServices.js",
                        "~/AngApp/cDealerPortal.js",
                        "~/AngApp/FactoryServices.js",                     
                        "~/AngApp/cSystem.js"                    
                        ));

        }
    }
}
