﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SMGO.Controllers
{
    public class AccountDsController : Controller
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];


        // GET: AccountDs
        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_ACC_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetEstimatePayment()
        {

            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].sp_ACC_EstimatePayment_List {0}";

            gSQL = String.Format(gSQL
                                , (Request.Form["ID"] != null && Request.Form["ID"] != "") ? "'" + Request.Form["ID"] + "'" : "null");
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

        }



        //SaveEstimatePayment


        public ContentResult SaveEstimatePayment()
        {
            if (Request.Form["ID"] != null && Request.Form["ID"] != "")
            {
                gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
                gSQL = "UPDATE [TBL_ACC_Esimate_Payment] " + gSQL;
                gSQL = String.Format(gSQL);
                odb.SqlExecute (gSQL, mDBName);
            }
            else
            {
                gSQL = "EXEC [dbo].[sp_ACC_Esimate_Payment_Add] '{0}','{1}','{2}','{3}','{4}'";
                gSQL = String.Format(gSQL
                                    , Request.Form["PAY_MONTH"]
                                    , DataService.DateValidation(Request.Form["PAY_DATE"])
                                    , DataService.DateValidation(Request.Form["DUE_DATE"])
                                    , DataService.DateValidation(Request.Form["GM_APPROVE_DUE_DATE"])
                                    , Session[Cons.SS_USER_ID].ToString());

                 odb.SqlExecute(gSQL, mDBName);
            }
            return Content("Done");

        }
        

        //[SessionExpire]
        //public JsonResult GetCampaignAccount()
        //{
        //    DataSet ds = new DataSet();

        //    gSQL = "EXEC sp_CMP_AccruePayment_List '{0}'";
        //    gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);

        //    ds = odb.SqlQueryDS(gSQL, mDBName);

        //    return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        //}

        [SessionExpire]
        public JsonResult GetDealerPaymentByMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_ACC_Dealer_Payment_ByMonthly '{0}' , {1}";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["REPORT_ID"]);

            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOverallPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_All_type_Payment_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;            
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOverallCampaignPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_All_Type_Payment_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetPaymentMonthlyByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Payment_Monthly_Model] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarPaymentByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_DMC_Paid_Summary] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOverallIncentivePayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_All_Payment_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }
        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQPaymentMonthlyByModel()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC [sp_Rpt_CQ_Payment_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }
        
        [HttpPost]
        [SessionExpire]
        public JsonResult GetAllOperations()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_All_Monthly_Amount] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetAsOfAllType()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Asof_All_Type_List] '{0}','{1}','{2}'";
            gSQL = string.Format(gSQL
                                ,Request.Form["DATA_MONTH"]
                                ,DataService.DateValidation(Request.Form["ASOF_DATE"])
                                ,Request.Form["VME_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetOverallAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_Overall_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCampaignAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDealerAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Dealer_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetLeasingAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Leasing_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetInsuranceAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Insurance_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetAfterSalesAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_AfterSales_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetFleetAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetIncentiveAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetDemoCarAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_DMC_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetCQAccrueAsof()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CQ_Accrue_Asof]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetOverallAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_Overall_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCampaignAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDealerAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Summary_Dealer]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetLeasingAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Summary_Leasing]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetInsuranceAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Summary_Insurance]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetAfterSalesAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Summary_AfterSales]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }


        [HttpPost]
        public JsonResult GetFleetAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetIncentiveAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetDemoCarAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_DMC_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetCQAccrueAsofSummary()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CQ_Accrue_Asof_Summary]";
            gSQL = string.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }


        [HttpPost]
        public JsonResult GetOverallAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_Overall_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCampaignAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDealerAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Monthly_Dealer] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetLeasingAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Monthly_Leasing] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetInsuranceAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Monthly_Insurance] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetAfterSalesAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_Accrue_Asof_Monthly_AfterSales] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetFleetAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetIncentiveAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetDemoCarAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_DMC_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetCQAccrueAsofMonthly()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CQ_Accrue_Asof_Monthly] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        #region Interface check
        [SessionExpire]
        [HttpGet]
        public JsonResult GetInterfaceStatus()
        {
            DataTable dt = new DataTable();

            dt = odb.SqlQuery("EXEC sp_Interface_SAP_Status", mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetInterfaceDetail(string VME_TYPE, string VME_ID, string IF_FLAG, string IF_SENT)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_Interface_SAP_Detail '{0}','{1}','{2}','{3}'"
                            , VME_TYPE
                            , VME_ID
                            , IF_FLAG
                            , IF_SENT);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        #endregion
    }
}