﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SMGO.Controllers
{
    public class CQDsController : Controller
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();


        [HttpPost]
        [SessionExpire]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_CQ_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpGet]
        public JsonResult GetCQListHeader(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_MT_CQ_Layout '{0}'";

            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQReconHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Reconcile_Status 'CQ'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQAccrueHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Accrue_Status 'CQ'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult GetCQListDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Detail_List '{0}', '{1}'";

            gSQL = String.Format(gSQL, Request.Form["quarter"], Request.Form["quarterYear"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #region CQ Upload (OLD)
        [HttpPost]
        public JsonResult CQFileUploadList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_FileUpload_List '{0}', '{1}', '{2}', {3}";

            gSQL = String.Format(gSQL,
                                Request.Form["quarterYear"],
                                Request.Form["quarter"],
                                Request.Form["type"],
                                (Request.Form["month"] != null && Request.Form["month"] != "") ? "'" + Request.Form["month"] + "'" : "null");
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult UploadBooking(HttpPostedFileBase File, string quarter, string quarterYear, string sourceForm, string month)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + quarterYear + "/" + quarter + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_CQ_Detail_Add] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}', 'Acc'"
                                    , gFileName
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , fileLocation
                                    , quarter
                                    , quarterYear
                                    , month
                                    , sourceForm
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        public JsonResult UploadPayment(HttpPostedFileBase File, string quarter, string quarterYear, string sourceForm, string month)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + quarterYear + "/" + quarter + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_CQ_Detail_Add] '{0}', '{1}', '{2}', '{3}', '{4}', null, '{5}', '{6}', 'Pay'"
                                    , gFileName
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , fileLocation
                                    , quarter
                                    , quarterYear
                                    , sourceForm
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion CQ Upload (OLD)

        [HttpPost]
        public JsonResult GetCQRptSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Rpt1_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult GetCQAccruePayment()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Accrue_Summary_On_Screen '{0}',{1}";
            gSQL = String.Format(gSQL, Request.Form["quarterYear"], Request.Form["quarter"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQAccrueSummary()
        {
            DataSet ds = new DataSet();


            gSQL = "EXEC sp_CQ_Accrue_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);


            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
            //return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQAccrueByChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CQ_Accrue_Detail] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetCQAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CQ_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public ContentResult SubmitCQAccruePayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_AccruePayment_Submit '{0}','{1}',{2},'{3}','{4}'";
            gSQL = String.Format(gSQL
                                , Request.Form["quarterYear"]
                                , Request.Form["quarter"]
                                , (Request.Form["month"] == "") ? "null" : "'" + Request.Form["month"] + "'"
                                , Request.Form["STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }


        [HttpPost]
        public ContentResult SubmitAccrue()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_CQ_Accrue_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            // string emailToSpecific = null;
            string emailStep = null;
            string vmeType = "VDM";
            var sendEmailFlag = false;

            if(gStatus == "Accrue")
            {
                if(ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Accrue":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been calculated, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "AccrueApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "M&S Control";
                    // emailCCDepartment = "Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear M&S Control,\n\nUser request you to approve CQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + "."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";

                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "AccrueReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "MSControlApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by M&S Control , you can check update status to continue process."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Accrue_CQ_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "ACCRUE", "CQ", "");

                    break;

                // case "MSControlReturn": emailToPosition = "Officer,Assistant Manager,Manager,General Manager";
                case "MSControlReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by M&S Control, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Accrue"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetCQSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CQ_Summary_On_Screen] '{0}',{1}";
            gSQL = String.Format(gSQL, Request.Form["quarterYear"], Request.Form["quarter"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetCQConfigList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Config_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["year"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetCQConfig()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Config '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["year"], Request.Form["id"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveCQConfig()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Config_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}','{17}','{18}','{19}','{20}','{21}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["YEAR"]
                                , Request.Form["QUARTER"]
                                , Request.Form["SSI_TARGET1_AMT"]
                                , Request.Form["SSI_TARGET2_AMT"]
                                , Request.Form["CSI_TARGET1_AMT"]
                                , Request.Form["CSI_TARGET2_AMT"]

                                , Request.Form["SSI_STD_PASS1"]
                                , Request.Form["SSI_ADD_PASS1"]
                                , Request.Form["SSI_STD_PASS2"]
                                , Request.Form["SSI_ADD_PASS2"]
                                , Request.Form["CSI_STD_PASS1"]
                                , Request.Form["CSI_ADD_PASS1"]
                                , Request.Form["CSI_STD_PASS2"]
                                , Request.Form["CSI_ADD_PASS2"]

                                , Request.Form["SSI_TARGET_MIN"]
                                , Request.Form["SSI_TARGET_SOP8"]
                                , Request.Form["SSI_TARGET_SOP10"]
                                , Request.Form["CSI_TARGET_MIN"]
                                , Request.Form["CSI_TARGET_SOP13"]
                                , Request.Form["CSI_TARGET_SOP14"]

                                //, Request.Form["MONTH1_PASS_AMT"]
                                //, Request.Form["MONTH2_PASS_AMT"]
                                //, Request.Form["MONTH3_PASS_AMT"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public ContentResult CQApproveSubmit()
        {
            DataTable dt = new DataTable();
            string gStatus = Request.Form["TYPE"];

            gSQL = "EXEC sp_CQ_Config_Approve '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL,
                                gStatus,
                                Request.Form["REMARK"],
                                Request.Form["ID"],
                                Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            var sendEmailFlag = false;

            switch (gStatus)
            {
                case "Approved":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved CQ configuration quarter : " + Request.Form["QUARTER"];
                    emailContent = "Dear Operation,\n\nCQ configuration as quarter " + Request.Form["QUARTER"] + " has been approved by GM, you can check update status to continue process.";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;

                case "Return":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return CQ configuration quarter : " + Request.Form["QUARTER"];
                    emailContent = "Dear Operation,\n\nCQ configuration as quarter " + Request.Form["QUARTER"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;

                case "Send":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send CQ configuration quarter : " + Request.Form["QUARTER"];
                    emailContent = "Dear GM,\n\nCQ configuration as quarter " + Request.Form["QUARTER"] + " has been set, please kindly access to CIMS system to approve.";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("CQ"
                                        , "Configure"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_CQ_Payment_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSubmit()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC [sp_CQ_Payment_Submit_List] '{0}','1'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitPayment()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_CQ_Payment_Submit '{0}', null, {1},'{2}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            // string emailToSpecific = null;
            string emailStep = null;
            string vmeType = "CQ";
            var sendEmailFlag = false;
            string paymentDetailContent = "";

            if (gStatus == "Payment")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            // set total amount
            string totalAmount = ds.Tables["Table"].Select("DATA_MONTHNAME = 'Total'")[0]["TOTAL_AMOUNT"].ToString();

            var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));

            foreach (DataRow row in ds.Tables["Table"].Rows)
            {
                if (row["DATA_MONTHNAME"].ToString() != "Total")
                {
                    paymentDetailContent = paymentDetailContent + "\n" +
                            "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                            "     Payment: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                    (
                        // Check if TOTAL_CB_AMOUNT > 0 then insert chargback line
                        Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                            "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                            "     Net: " + row["NET"].ToString() + " THB\n" : ""
                    );
                }
            }

            paymentDetailContent = paymentDetailContent + "\n" +
                        " Total amount: " + totalAmount + " THB\n";

            switch (gStatus)
            {
                case "Payment":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been sent, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "PaymentApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Finance Dept,\n\nCQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + " has been submited, please kindly check in CIMS system."
                                    + "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "PaymentReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";

                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation & GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been approved by Finance Dept , you can check update status to continue process."
                                    + "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    //Get SAP data
                    gSQL = "EXEC sp_IF_Payment_CQ_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["ID"]);
                    dt = odb.SqlQuery(gSQL, mDBName);

                    DataService.WriteFileToSAP(dt, "PAYMENT", "CQ", "");

                    break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation & GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Payment"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQReconcile()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_CQ_Reconcile_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitReconcile()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_CQ_Reconcile_Submit '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                            , Request.Form["DATA_MONTH"]
                            , gStatus
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "CQ";
            var sendEmailFlag = false;

            if (gStatus == "Reconcile")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Reconcile":
                    emailTitle = "CIMS : Send CQ - Reconcile approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nCQ - Reconcile data as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"] + " has been submited, please kindly approve in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "ReconcileApprove":
                    emailTitle = "CIMS : Send to Account CQ - Reconcile approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"];
                    emailContent = "Dear Account Dept,\n\nCQ - Reconcile data as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"] + " has been submited, please kindly check in CIMS system."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "ReconcileReturn":
                    emailTitle = "CIMS : Return CQ - Reconcile approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nCQ - Reconcile data as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "AccountApprove":
                    emailTitle = "CIMS : Approved by Account CQ - Reconcile approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - Reconcile data as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"] + " has been approved by Account, you can check update status to continue process."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Reconcile_CQ_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "RECONCILE", "CQ", "");

                    break;
                case "AccountReturn":
                    emailTitle = "CIMS : Return by Account CQ - Reconcile approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - Reconcile data as " + ds.Tables["Table"].Rows[0]["DATA_MONTHNAME"] + " has been returned by Account, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Reconcile"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SelectPayment(string[] DEALER_CODE)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Payment_Dealer_Select_Save] '{0}','{1}',null";
            gSQL = String.Format(gSQL
                                , (DEALER_CODE != null && DEALER_CODE.Length > 0) ? string.Join(",", DEALER_CODE) : ""
                                , "CQ");
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SelectAllPayment()
        {

            gSQL = "EXEC [sp_Payment_SelectAll_CQ_Save]";
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult UnSelectAllPayment()
        {

            gSQL = "EXEC [sp_Payment_UnSelectAll_CQ_Save]";
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult RemoveSelectPayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_CQ_Payment_Select_Delete '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DEALER_CODE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_CQ_Payment_ListByMonth '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetAsDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC {0} '{1}',{2}";
            gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["DATA_MONTH"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        #region VDM Configure
        [SessionExpire]
        [HttpGet]
        public JsonResult GetVdmConfigureNameList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_VDM_Config_Name";
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public ContentResult SaveVdmConfigureName()
        {
            gSQL = String.Format("EXEC sp_VDM_Config_Name_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}'"
                                , Request.Form["ID"]
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]
                                , Request.Form["SSI_SOP1_NAME"]
                                , Request.Form["SSI_SOP2_NAME"]
                                , Request.Form["SSI_SOP3_NAME"]
                                , Request.Form["SSI_SOP4_NAME"]
                                , Request.Form["CSI_SOP1_NAME"]
                                , Request.Form["CSI_SOP2_NAME"]
                                , Request.Form["CSI_SOP3_NAME"]
                                , Request.Form["CSI_SOP4_NAME"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetVdmConfigList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_VDM_Config_List";
            //  gSQL = String.Format(gSQL, Request.Form["year"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult AddNewVdmConfig()
        {
            gSQL = "EXEC sp_VDM_Config_Add '{0}'";
            gSQL = String.Format(gSQL, Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveVdmConfig()
        {

            gSQL = String.Format(@"EXEC [sp_VDM_Config_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}',
                                                            '{11}','{12}','{13}','{14}','{15}'"
                                    ,Request.Form["DATA_MONTH"]
                                    ,Request.Form["SSI_MIN_SAMPLE_TARGET"]
                                    ,Request.Form["SSI_NPS_TARGET"]
                                    ,Request.Form["SSI_OS_TARGET"]
                                    ,Request.Form["SSI_SOP1_TARGET"]
                                    ,Request.Form["SSI_SOP2_TARGET"]
                                    ,Request.Form["SSI_SOP3_TARGET"]
                                    ,Request.Form["SSI_SOP4_TARGET"]
                                    ,Request.Form["CSI_QUALITY_TARGET"]
                                    ,Request.Form["CSI_NPS_TARGET"]
                                    ,Request.Form["CSI_OS_TARGET"]
                                    ,Request.Form["CSI_SOP1_TARGET"]
                                    ,Request.Form["CSI_SOP2_TARGET"]
                                    ,Request.Form["CSI_SOP3_TARGET"]
                                    ,Request.Form["CSI_SOP4_TARGET"]
                                    ,Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }

        #endregion VDM Configure

        #region VDM Upload
        [SessionExpire]
        [HttpPost]
        public JsonResult VdmFileUploadList()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_VDM_FileUpload_List '{0}','{1}','{2}'";

            gSQL = String.Format(gSQL,
                                Request.Form["DATA_MONTH"],
                                Request.Form["type"],
                                Request.Form["AccPay"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult VdmFileHeaderList()
        {
            DataTable dt = new DataTable();

            dt = odb.SqlQuery("EXEC sp_VDM_FileUpload_Header_List", mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadCSI(HttpPostedFileBase File, string year, string month)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = File.FileName;
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMCSIUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_CSI_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadSSI(HttpPostedFileBase File, string year, string month)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = File.FileName;
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMSSIUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_SSI_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadManpowerCSI(HttpPostedFileBase File, string year, string month)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = String.Concat("MP_"+File.FileName.Replace("MP_",""));
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMCSIManpowerUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_CSI_Manpower_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadManpowerSSI(HttpPostedFileBase File, string year, string month)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = String.Concat("MP_"+File.FileName.Replace("MP_",""));
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMSSIManpowerUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_SSI_Manpower_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadAssessCSI(HttpPostedFileBase File, string year, string month)
        {
            if (File != null && File.ContentLength > 0)
            {
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMCSIAssessUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_CSI_Assess_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult UploadAssessSSI(HttpPostedFileBase File, string year, string month)
        {
            if (File != null && File.ContentLength > 0)
            {
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMSSIAssessUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_SSI_Assess_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult UploadVOCCSI(HttpPostedFileBase File, string year, string month)
        {
            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = String.Concat("MP_"+File.FileName.Replace("MP_",""));
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMCSIVOCUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_CSI_VOC_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult UploadVOCSSI(HttpPostedFileBase File, string year, string month)
        {
            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                // string gFileName = String.Concat("MP_"+File.FileName.Replace("MP_",""));
                string gFileName = String.Format(
                                        "{0}_{1}.{2}",
                                        "VDMSSIVOCUpload",
                                        DateTime.Now.ToString("yyyyMMdd"),
                                        Path.GetExtension(File.FileName)
                                    );
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                gSQL = String.Format("EXEC [dbo].sp_VDM_FileUpload_SSI_VOC_Temp '{0}','{1}','{2}','{3}','{4}'"
                                    , gFileName
                                    , sourceFile
                                    , fileLocation
                                    , year
                                    , month);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(new
                {
                    fileName = gFileName,
                    filePath = sourceFile,
                    fileLocation = fileLocation,
                    data = DTFM.convertToList(dt)
                }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadCSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_CSI_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadSSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_SSI_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadManpowerCSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_CSI_Manpower_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadManpowerSSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_SSI_Manpower_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );
            return Content("Done");
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadAssessCSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_CSI_Assess_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );
            return Content("Done");
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadAssessSSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_SSI_Assess_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );
            return Content("Done");
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadVOCCSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_CSI_VOC_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );
            return Content("Done");
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmUploadVOCSSI(string pFileName, string pUploadPath, string pFileLocation, string pType, string pYear, string pMonth)
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_FileUpload_SSI_VOC_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}'",
                    pFileName, pUploadPath, pFileLocation, pYear, pMonth, pType, Session[Cons.SS_USER_ID].ToString()
                ),
                mDBName
            );

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetChassisContactable (string pDataMonth, string pAccPay)
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                String.Format("EXEC sp_VDM_Chassis_Contact '{0}','{1}'", pDataMonth,pAccPay)
                ,mDBName
            );

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }
        
        [SessionExpire]
        [HttpPost]
        public ContentResult ChassisContactableSave (HttpPostedFileBase File, string pAccPay, string pYear, string pMonth)
        {
            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + pYear + "/" + pMonth + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                
                odb.SqlExecute(
                    String.Format("EXEC sp_VDM_Chassis_Contact_Save '{0}','{1}','{2}','{3}','{4}'"
                        , sourceFile, pYear, pMonth, pAccPay, Session[Cons.SS_USER_ID].ToString())
                    ,mDBName
                );

                return Content("Done");
            }
            else
            {
                return Content("Unable to process.");
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetServiceUnits (string pDataMonth, string pAccPay)
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                String.Format("EXEC sp_VDM_Service_Units '{0}','{1}'", pDataMonth,pAccPay)
                ,mDBName
            );

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }
        
        [SessionExpire]
        [HttpPost]
        public ContentResult ServiceUnitsSave (HttpPostedFileBase File, string pAccPay, string pYear, string pMonth)
        {
            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/CQ/DataPeriod/" + pYear + "/" + pMonth + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                string sourceFile = aBiz.DataService.MapUploadPath(fileLocation);

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                odb.SqlExecute(
                    String.Format("EXEC sp_VDM_Service_Units_Save '{0}','{1}','{2}','{3}','{4}'"
                        , sourceFile, pYear, pMonth, pAccPay, Session[Cons.SS_USER_ID].ToString())
                    ,mDBName
                );

                return Content("Done");
            }
            else
            {
                return Content("Unable to process.");
            }
        }

        #endregion VDM Upload

        #region VDM Summary

        [SessionExpire]
        [HttpGet]
        public JsonResult GetAccrueSummary(string id) //id = dataMonth
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                    String.Format(
                        "EXEC sp_VDM_Summary '{0}','Accrue'", id
                  ), mDBName
            );

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        [HttpGet]
        public JsonResult GetPaymentSummary(string id) //id = dataMonth
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                    String.Format(
                        "EXEC sp_VDM_Summary '{0}','Payment'", id
                  ), mDBName
            );

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult ConfirmSummaryData ()
        {
            odb.SqlExecute(
                String.Format(
                    "EXEC sp_VDM_Summary_Confirm '{0}','{1}'", Request.Form["DATA_MONTH"], Request.Form["TYPE"]
                ),
                mDBName
            );

            return Content("Done");
        }

        #endregion VDM Summary

        #region VDM Accrue

        [HttpGet]
        [SessionExpire]
        public JsonResult GetVDMAccrueHistory()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Accrue_Status 'VDM'";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        [SessionExpire]
        public JsonResult GetVDMAccrue(string id) //id = dataMonth
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                String.Format(
                    "EXEC sp_VDM_Accrue_List '{0}'", id
                ),
                mDBName
            );

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }
        

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitVDMAccrue()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_VDM_Accrue_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "VDM";
            var sendEmailFlag = false;

            if (gStatus == "Accrue")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Accrue":
                    emailTitle = "CIMS : Send CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been calculated, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "AccrueApprove":
                    emailTitle = "CIMS : Send to M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear M&S Control,\n\nUser request you to approve CQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + "."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";

                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "AccrueReturn":
                    emailTitle = "CIMS : Return CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "MSControlApprove":
                    emailTitle = "CIMS : Approved by M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by M&S Control , you can check update status to continue process."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Accrue_CQ_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "ACCRUE", "CQ", "");

                    break;

                case "MSControlReturn":
                    emailTitle = "CIMS : Return by M&S Control CQ - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nCQ - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by M&S Control, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Accrue"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        #endregion VDM Accrue

        #region VDM Payment

        [HttpGet]
        [SessionExpire]
        public JsonResult VDMStatusList()
        {
            DataTable dt = new DataTable();

            dt = odb.SqlQuery("EXEC sp_VDM_Payment_List", mDBName);

            var JsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            return JsonResult;
        }

        [HttpGet]
        [SessionExpire]
        public JsonResult VDMNotSelectedList()
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS("EXEC sp_VDM_Payment_Non_List", mDBName);

            var JsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            JsonResult.MaxJsonLength = Int32.MaxValue;

            return JsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult VDMSelectedList(string paymentType)
        {
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                    String.Format(
                        "EXEC sp_VDM_Payment_Submit_List null, '{0}'",
                        paymentType
                    )
                , mDBName);

            var JsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            JsonResult.MaxJsonLength = Int32.MaxValue;

            return JsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult VDMSubmitList(string id, string paymentType)
        {
            
            DataSet ds = new DataSet();

            ds = odb.SqlQueryDS(
                    String.Format("EXEC sp_VDM_Payment_Submit_List {0},'{1}'", id, paymentType)
                    , mDBName
                );

            var JsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            JsonResult.MaxJsonLength = Int32.MaxValue;

            return JsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SelectVDMtoPayment(string[] CHASSIS_NO, string PAYMENT_TYPE)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Payment_Select_Save] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , (CHASSIS_NO != null && CHASSIS_NO.Length > 0) ? string.Join(",", CHASSIS_NO) : ""
                                , "CQ"
                                , PAYMENT_TYPE);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult VDMSelectAllPayment(string paymentType)
        {

            gSQL = String.Format("EXEC [sp_Payment_SelectAll_VDM_Save] '{0}'", paymentType);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult VDMUnSelectAllPayment(string paymentType)
        {

            gSQL = String.Format("EXEC [sp_Payment_UnSelectAll_VDM_Save] '{0}'", paymentType);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitVDMPayment()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_VDM_Payment_Submit '{0}',{1},'{2}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "VDM";
            var sendEmailFlag = false;
            string paymentDetailContent = "";

            if (gStatus == "Payment")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));
            foreach (DataRow row in ds.Tables["Table"].Rows)
            {
                paymentDetailContent = paymentDetailContent + "\n" +
                        "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                        "     Payment: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                (
                    Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                        "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                        "     Net: " + row["NET"].ToString() + " THB\n" : ""
                );
            }
            switch (gStatus)
            {
                case "Payment":
                    emailTitle = "CIMS : Send CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been sent, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "PaymentApprove":
                    emailTitle = "CIMS : Send to Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Finance Dept,\n\nCQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + " has been submited, please kindly check in CIMS system."
                                    + "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "PaymentReturn":
                    emailTitle = "CIMS : Return CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";

                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "AccountApprove":
                    emailTitle = "CIMS : Approved by Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation & GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been approved by Finance Dept , you can check update status to continue process."
                                    + "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    //Get SAP data
                    gSQL = "EXEC sp_IF_Payment_CQ_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["ID"]);
                    dt = odb.SqlQuery(gSQL, mDBName);

                    DataService.WriteFileToSAP(dt, "PAYMENT", "CQ", "");

                    break;
                case "AccountReturn":
                    emailTitle = "CIMS : Return by Account CQ - Payment approve as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString();
                    emailContent = "Dear Operation & GM,\n\n" +
                                         "CQ - Payment data as " + ds.Tables["Table"].Rows[0]["DATA_MONTH_NAMES"].ToString() + "\n" +
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                    "\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Payment"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        #endregion VDM Payment
    }
}