﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using SMGO.aBiz;
using SMGO.aControl;
using System.Configuration;
using System.Globalization;

namespace SMGO.Controllers
{
    public class ConfigDsController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();


        #region Dealer work with DB

        public ContentResult EditDealerConf()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Dealer_Update] '{0}', '{1}', '{2}', '{3}', '{4}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["DealerCond"]
                                , Request.Form["AP_VENDOR_CODE"]
                                , Request.Form["DEALER_FLAG"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);
            return Content("Done");
        }
        public ContentResult EditNewDealerConf()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [dbo].[sp_CFG_Dealer_New_Update] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["DealerCond"]
                                , Request.Form["AP_VENDOR_CODE"]
                                , Request.Form["NEW_AP_VENDOR_CODE"]
                                , Request.Form["DEALER_FLAG"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");

        }

        public JsonResult GetDealerList()
        {
            DataTable dt = new DataTable();

            if (Request.Form["DealerCond"] != "" && Request.Form["DealerCond"] != null)
            {
                gSQL = @"EXEC [dbo].[sp_CFG_Dealer_List] {0}, '{1}'";
                gSQL = String.Format(gSQL
                                    , (Request.Form["ID"] != null && Request.Form["ID"] != "" && Request.Form["ID"] != "null") ? "'" + Request.Form["ID"] + "'" : "null"
                                    , Request.Form["DealerCond"]);
                dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { Result = "404" });
            }
        }

 public JsonResult GetNewDealerList()
        {
            DataTable dt = new DataTable();
            if (Request.Form["DealerCond"] != "" && Request.Form["DealerCond"] != null)
            {
                gSQL = @"EXEC [dbo].[sp_CFG_Dealer_List_New] {0}, '{1}'";
                gSQL = String.Format(gSQL
                                    , (Request.Form["ID"] != null && Request.Form["ID"] != "" && Request.Form["ID"] != "null") ? "'" + Request.Form["ID"] + "'" : "null"
                                    , Request.Form["DealerCond"]);
                dt = odb.SqlQuery(gSQL, mDBName);
                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { Result = "404" });
            }
        }
        #endregion


        #region Cost Center work with DB

        public ContentResult EditCostCenterConf()
        {
            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE TBL_MT_Base_Model " + gSQL;
            gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }

        public ContentResult DeleteCostCenterConf()
        {
            DataTable dt = new DataTable();

            gSQL = @"DELETE FROM TBL_MT_CostCenter
                     WHERE [ID] = '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");

        }

        public JsonResult GetCostCenterList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Base_Model_List] {0}";
            gSQL = String.Format(gSQL, (id != "" && id != null) ? id : "null");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetAccountCodeList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Payment_Account_List] {0}";
            gSQL = String.Format(gSQL, (id != "" && id != null) ? id : "null");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public ContentResult EditAccountCodeConf()
        {
            DataTable dt = new DataTable();

            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "PAYMENT_TYPE_CODE");
            gSQL = "UPDATE TBL_MT_Payment_Account " + gSQL;
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");

        }
        #endregion

        [SessionExpire]
        public JsonResult GetModelList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Base_Model_List] {0}";
            gSQL = String.Format(gSQL, (id != "" && id != null) ? id : "null");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #region Model work with DB
        [HttpPost]
        [SessionExpire]
        public ContentResult EditModelConf()
        {
            DataTable dt = new DataTable();

            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE TBL_MT_Base_Model " + gSQL;
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");

        }
        #endregion


        #region MSRP work with DB


        public JsonResult GetMsrpList()
        {

            DataTable dt = new DataTable();

            if (Request.Form["BASE_MODEL"] != "" && Request.Form["BASE_MODEL"] != null)
            {

                gSQL = @"EXEC [dbo].[sp_CFG_Model_MSRP_List] {0}, '{1}'";

                gSQL = String.Format(gSQL
                                    , (Request.Form["ID"] != null && Request.Form["ID"] != "" && Request.Form["ID"] != "null") ? "'" + Request.Form["ID"] + "'" : "null"
                                    , Request.Form["BASE_MODEL"]);
                dt = odb.SqlQuery(gSQL, mDBName);
                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { Result = "404" });
            }
        }

        public JsonResult AddMSRPDup()
        {
            DataTable dt = new DataTable();

            if (Request.Form["_itemType"] != "" && Request.Form["_itemType"] != null)
            {

                gSQL = @"EXEC [dbo].[sp_CFG_Model_MSRP_Add] {0}, '{1}', '{2}'";

                gSQL = String.Format(gSQL
                                    , (Request.Form["_DupFrom"] != null && Request.Form["_DupFrom"] != "" && Request.Form["_DupFrom"] != "null") ? "'" + Request.Form["_DupFrom"] + "'" : "null"
                                    , Request.Form["_itemType"]
                                    , Session[Cons.SS_USER_ID].ToString());
                dt = odb.SqlQuery(gSQL, mDBName);
                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { Result = "404" });
            }
        }

        public ContentResult EditMsrpConf()
        {

            DataTable dt = new DataTable();
            string gCond = "";

            if (Request.Form["_itemType"] == "MSRPList1")
            {
                gCond = "LEFT(BASE_MODEL, 3)";
            }
            else if (Request.Form["_itemType"] == "MSRPList2")
            {
                gCond = "ID";
            }

            if (gCond != "")
            {
                gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), gCond, "_ID");
                gSQL = "UPDATE TBL_MT_Model_MSRP " + gSQL;
                gSQL = String.Format(gSQL);
                dt = odb.SqlQuery(gSQL, mDBName);
            }

            return Content("Done");

        }

        #endregion

        #region Upload MSRP work with DB
        [HttpPost]
        public JsonResult UploadMSRPData(HttpPostedFileBase File)
        {
            if (File != null && File.ContentLength > 0)
            {
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/MSRP/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                gSQL = String.Format("EXEC [dbo].[sp_MSRP_Temp_Add] '{0}', '{1}', '{2}'"
                                    , gFileName
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , fileLocation);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [HttpPost]
        public JsonResult ConfirmMSRPUpload(string fileName)
        {
            if (fileName != null && fileName.Length > 0)
            {
                gSQL = String.Format("EXEC [dbo].[sp_Leasing_Data_Add] '{0}', '{1}'"
                                    , fileName
                                    , Session[Cons.SS_USER_ID].ToString());
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [HttpPost]
        public JsonResult CancelMSRPUpload(string fileName)
        {
            if (fileName != null && fileName.Length > 0)
            {
                gSQL = String.Format("EXEC [dbo].[sp_MSRP_Temp_Remove] '{0}'"
                                    , fileName);
                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                string fileLocationStr = "~/upload/MSRP/" + fileName;
                string fileLocation = Server.MapPath(fileLocationStr);
                DataService.DeleteFileByLocation(fileLocation);
                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion

        #region Payment type work with DB

        [SessionExpire]
        public JsonResult GetPaymentTypeList()
        {

            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_PaymentType_List]";

            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

        }

        [SessionExpire]
        public JsonResult GetPaymentType()
        {

            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_PaymentType_List_ByID] {0}";

            gSQL = String.Format(gSQL, Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

        }

        [SessionExpire]
        public ContentResult SavePaymentType()
        {
            gSQL = "EXEC sp_CFG_PaymentType_Update '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}','{17}','{18}','{19}','{20}','{21}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                Request.Form["CLAIM_TYPE_CODE"],
                                Request.Form["CLAIM_TYPE_NAME"],
                                Request.Form["CC_ACCRUE_DEBIT_ECO"],
                                Request.Form["CC_ACCRUE_DEBIT_NON_ECO"],
                                Request.Form["CC_ACCRUE_CREDIT_ECO"],
                                Request.Form["CC_ACCRUE_CREDIT_NON_ECO"],
                                Request.Form["CC_PAY_DEBIT_ECO"],
                                Request.Form["CC_PAY_DEBIT_NON_ECO"],
                                Request.Form["CC_PAY_CREDIT_ECO"],
                                Request.Form["CC_PAY_CREDIT_NON_ECO"],
                                Request.Form["AC_ACCRUE_DEBIT_ECO"],
                                Request.Form["AC_ACCRUE_DEBIT_NON_ECO"],
                                Request.Form["AC_ACCRUE_CREDIT_ECO"],
                                Request.Form["AC_ACCRUE_CREDIT_NON_ECO"],
                                Request.Form["AC_PAY_DEBIT_ECO"],
                                Request.Form["AC_PAY_DEBIT_NON_ECO"],
                                Request.Form["AC_PAY_CREDIT_ECO"],
                                Request.Form["AC_PAY_CREDIT_NON_ECO"],
                                DataService.DateValidation(Request.Form["START_EFFECTIVE_DATE"].ToString()),
                                DataService.DateValidation(Request.Form["END_EFFECTIVE_DATE"].ToString()),
                                Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }

        #endregion

        #region New Payment type work with DB
        [SessionExpire]
        public JsonResult NewGetPaymentTypeList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [dbo].[sp_CFG_New_PaymentType_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [SessionExpire]
        public JsonResult NewGetPaymentType()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [dbo].[sp_CFG_New_PaymentType_List_ByID] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["CLAIM_TYPE_CODE"]
                                     , Request.Form["TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [SessionExpire]
        public ContentResult NewSavePaymentType()
        {
            gSQL = "EXEC sp_CFG_New_PaymentType_Update '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}','{17}','{18}','{19}','{20}'";
            gSQL = String.Format(gSQL,
                                Request.Form["TYPE"],
                                Request.Form["CLAIM_TYPE_CODE"],
                                Request.Form["ACCRUE_DEBIT_ECO_I"],
                                Request.Form["ACCRUE_CREDIT_ECO_I"],
                                Request.Form["ACCRUE_DEBIT_NON_ECO"],
                                Request.Form["ACCRUE_CREDIT_NON_ECO"],
                                Request.Form["ACCRUE_DEBIT_CBU"],
                                Request.Form["ACCRUE_CREDIT_CBU"],
                                Request.Form["PAY_DEBIT_ECO_I"],
                                Request.Form["PAY_CREDIT_ECO_I"],
                                Request.Form["PAY_DEBIT_NON_ECO"],
                                Request.Form["PAY_CREDIT_NON_ECO"],
                                Request.Form["PAY_DEBIT_CBU"],
                                Request.Form["PAY_CREDIT_CBU"],
                                Request.Form["ACCRUE_DEBIT_ECO_II"],
                                Request.Form["ACCRUE_CREDIT_ECO_II"],
                                Request.Form["PAY_DEBIT_ECO_II"],
                                Request.Form["PAY_CREDIT_ECO_II"],
                                DataService.DateValidation(Request.Form["START_EFFECTIVE_DATE"].ToString()),
                                DataService.DateValidation(Request.Form["END_EFFECTIVE_DATE"].ToString()),
                                Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }
        #endregion
        #region Fleet Program
        public JsonResult GetFleetList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_List] {0}, '{1}'";
            gSQL = String.Format(gSQL
                                , (id != "" && id != null) ? id : "null"
                                , "Active");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public ContentResult EditFleetProgramConf()
        {
            DataTable dt = new DataTable();

            if (Request.Form["ID"] != null && Request.Form["ID"] != "")
            {
                gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
                gSQL = "UPDATE TBL_MT_Fleet_Program " + gSQL;
                gSQL = String.Format(gSQL);
                dt = odb.SqlQuery(gSQL, mDBName);
            }
            else
            {

                gSQL = @"EXEC [dbo].[sp_FLT_Fleet_Program_Add] '{0}'
                                                          ,'{1}'
                                                          ,'{2}'
                                                          ,'{3}'
                                                          ,'{4}'
                                                          ,'{5}'
                                                          ,'{6}'
                                                          ,'{7}'
                                                         ";
                gSQL = String.Format(gSQL
                                    , Request.Form["FLEET_NAME"]
                                    , Request.Form["FLEET_DESCRIPTION"]
                                    , Request.Form["FLEET_LEVEL"]
                                    , Request.Form["STATUS"]
                                    , DataService.DateValidation(Request.Form["START_EFFECTIVE_DATE"])
                                    , DataService.DateValidation(Request.Form["END_EFFECTIVE_DATE"])
                                    , Request.Form["REMARK"]
                                    , Session[Cons.SS_USER_ID].ToString());

                dt = odb.SqlQuery(gSQL, mDBName);
                return Content("Done");
            }


            return Content("Done");

        }
        #endregion

        #region Account Cost Center
        public JsonResult GetAccountCostCenterList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Account_CostCenter_List] {0}";
            gSQL = String.Format(gSQL, (id != "" && id != null) ? id : "null");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public ContentResult SubmitAccountCostCenter()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CFG_Account_CostCenter_Update] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}',{9},{10},'{11}','{12}' ";
            gSQL = string.Format(gSQL
                                , Request.Form["CLAIM_TYPE_CODE"]
                                , Request.Form["ACDE"]
                                , Request.Form["ACDN"]
                                , Request.Form["ACCE"]
                                , Request.Form["ACCN"]
                                , Request.Form["PCDE"]
                                , Request.Form["PCDN"]
                                , Request.Form["PCCE"]
                                , Request.Form["PCCN"]
                                , (Request.Form["STARTDATE"] == "") ? "null" : "'" + DataService.DateValidation(Request.Form["STARTDATE"]) + "'"
                                , (Request.Form["ENDDATE"] == "") ? "null" : "'" + DataService.DateValidation(Request.Form["ENDDATE"]) + "'"
                                , Request.Form["TYPE"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }
        #endregion
        #region Internal order
        [SessionExpire]
        [HttpGet]
        public JsonResult GetInternalOrderList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_CFG_Internal_Order_List";
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult GetInternalOrderByID()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_CFG_Internal_Order_ByID {0},'{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["BASE_MODEL"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult SaveInternalOrder()
        {
            gSQL = "EXEC sp_CFG_Internal_Order_Save {0},'{1}','{2}','{3}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["BASE_MODEL"]
                                , Request.Form["INTERNAL_ORDER_CODE"]
                                , Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }
        #endregion

        [SessionExpire]
        public JsonResult GetSurveyList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_Survey_List]";

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        public JsonResult GetSurveyInfo()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_Survey_Info] {0}";
            gSQL = String.Format(gSQL, Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult AddSurvey()
        {            
            gSQL = "EXEC sp_Survey_New ";
            gSQL = String.Format(gSQL);
            odb.SqlExecute (gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult UpdateSurvey()
        {
           
            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE [TBL_SRV_Survey_Data] " + gSQL;
            gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }
        #region Manual Payment/DOA upload

        [HttpGet]
        [SessionExpire]
        public JsonResult GetDOAImportList(string ID = null)
        {
            DataTable dt = new DataTable();

            if(ID == null)
            {
                gSQL = String.Format("EXEC sp_DOA_Master_List");
            } else
            {
                gSQL = String.Format("EXEC sp_DOA_Master_List_ByType '{0}'", ID);
            }

            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        [SessionExpire]
        public JsonResult GetDOAImportByID(string ID)
        {
            DataSet ds = new DataSet();

            gSQL = String.Format("EXEC sp_DOA_Master_ByID '{0}'", ID);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult SaveDOAImport(string ID
                            , string DOA_NO
                            , string SUBJECT
                            , string APPROVED_BY
                            , string VME_PAYMENT_ID
                            , string ACCRUE_PAYMENT
                            , string UPLOAD_LOCATION
                            , string REMARKS
                            , string STATUS)
        {
            DataTable dt = new DataTable();

            try
            {

                gSQL = String.Format("EXEC sp_DOA_Master_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}'"
                                    , (ID == null) ? "0" : ID
                                    , DOA_NO
                                    , SUBJECT
                                    , APPROVED_BY
                                    , REMARKS
                                    , VME_PAYMENT_ID
                                    , ACCRUE_PAYMENT
                                    , UPLOAD_LOCATION
                                    , aBiz.DataService.MapUploadPath(UPLOAD_LOCATION)
                                    , Session[Cons.SS_USER_ID].ToString()
                                    , STATUS);
                dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            catch (Exception ex)
            {
                return Json(new { result = "Error", message = ex.Message }, JsonRequestBehavior.AllowGet);
            }
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitDOA (string ID, string status)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            try
            {

                gSQL = String.Format("EXEC sp_DOA_Master_Submit '{0}','{1}','{2}'"
                            , ID
                            , status
                            , Session[Cons.SS_USER_ID].ToString());

                ds = odb.SqlQueryDS(gSQL, mDBName);


                //Send email
                string emailTitle = null;
                string emailContent = null;
                string emailStep = null;
                var sendEmailFlag = false;
                string paymentDetailContent = "";
                string toGroupName = "";
                string toDepartment = "";
                string vmeID = "";
                string vmeType = "";
                string vmeTypeShort = "";
                string paymentType = "";
                string subPaymentType = "";
                string accPay = "";
                string DOANo = "";

                if (status == "Submit")
                {
                    if (ds.Tables["Table"].Columns.Contains("RESULT")
                        && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                    {
                        oVME.sendEmailInterfaceError();
                        return Content("Interface layout error.");
                    }
                }

                // set total amount
                string totalAmount = ds.Tables["Table"].Select("DATA_MONTHNAME = 'Total'")[0]["TOTAL_AMOUNT"].ToString();

                var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));

                foreach (DataRow row in ds.Tables["Table"].Rows)
                {
                    paymentDetailContent = paymentDetailContent + "\n" +
                            "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                            "     Amount: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                    (
                        // Check if TOTAL_CB_AMOUNT > 0 then insert chargback line
                        Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                            "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                            "     Net: " + row["NET"].ToString() + " THB\n" : ""
                    );
                }

                paymentDetailContent = paymentDetailContent + "\n" +
                            "Total amount: " + totalAmount + " THB\n";

                vmeID = ds.Tables["Table1"].Rows[0]["VME_ID"].ToString();
                vmeType = ds.Tables["Table1"].Rows[0]["VME_TYPE"].ToString();
                paymentType = ds.Tables["Table1"].Rows[0]["PAYMENT_TYPE"].ToString();
                subPaymentType = ds.Tables["Table1"].Rows[0]["SUB_PAYMENT_TYPE"].ToString();
                accPay = ds.Tables["Table1"].Rows[0]["ACCRUE_PAYMENT"].ToString();
                DOANo = ds.Tables["Table1"].Rows[0]["DOA_NO"].ToString();

                switch (vmeType)
                {
                    case "Campaign":
                        vmeTypeShort = "CMP";
                        break;
                    case "Fleet":
                        vmeTypeShort = "FLT";
                        paymentType = "";
                        break;
                    case "Incentive":
                        vmeTypeShort = "INC";
                        break;
                    case "DemoCar":
                        vmeTypeShort = "DMC";
                        if (accPay == "Accrue") paymentType = "";
                        break;
                    case "CQ":
                        vmeTypeShort = "CQ";
                        break;
                }

                if (accPay == "Accrue")
                {
                    toGroupName = "M&S Control";
                    toDepartment = "M&S Control";

                } else if (accPay == "Payment")
                {
                    toGroupName = "Account";
                    toDepartment = "Financial Dept";
                }

                if (subPaymentType == "Chargeback")
                {
                    switch (status)
                    {
                        case "Submit":
                            emailTitle = "CIMS : Send DOA Chargeback - " + accPay + " approve as " + dataMonthNames;
                            emailContent = "Dear GM," +
                                "\n\nDOA " + accPay + " data as " + dataMonthNames +
                                "\nDOA number: " + DOANo +
                                "\n\nIt has been sent, please kindly access to CIMS system to approve";
                            emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                            emailContent = emailContent + "\nThen go to menu 'Management operation > Additional DOA'";
                            emailContent = emailContent + "\n\nThank you & best regards,";
                            emailContent = emailContent + "\nCIMS system admin";
                            sendEmailFlag = true;
                            emailStep = "Submit";
                            break;
                        case "DOAApprove":
                            emailTitle = "CIMS : Approve DOA Chargeback - " + accPay + " approve as " + dataMonthNames;
                            emailContent = "Dear Operation," +
                                "\n\nDOA " + accPay + " data as " + dataMonthNames +
                                "\nDOA number: " + DOANo +
                                "\n\nIt has been approved by GM, you can check update status to continue process.";
                            emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                            emailContent = emailContent + "\n\nThank you & best regards,";
                            emailContent = emailContent + "\nCIMS system admin";
                            sendEmailFlag = true;
                            emailStep = "GM-Return";
                            break;
                        case "DOAReturn":
                            emailTitle = "CIMS : Return DOA Chargeback - Return" + accPay + " approve as " + dataMonthNames;
                            emailContent = "Dear Operation," +
                                "\n\nDOA " + accPay + " data as " + dataMonthNames +
                                "\nDOA number: " + DOANo +
                                "\n\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";
                            emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                            emailContent = emailContent + "\n\nThank you & best regards,";
                            emailContent = emailContent + "\nCIMS system admin";
                            sendEmailFlag = true;
                            emailStep = "GM-Return";
                            break;
                        default: break;
                    }
                }
                else
                { 
                switch (status)
                {
                    case "Submit":
                        emailTitle = "CIMS : Send DOA - " + accPay + " approve as " + dataMonthNames;
                        emailContent = "Dear GM," +
                            "\n\nDOA " + accPay + " data as " + dataMonthNames +
                            "\nDOA number: " + DOANo +
                            "\n\nIt has been sent, please kindly access to CIMS system to approve";
                        emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                        emailContent = emailContent + "\nThen go to menu 'Management operation > Additional DOA'";
                        emailContent = emailContent + "\n\nThank you & best regards,";
                        emailContent = emailContent + "\nCIMS system admin";
                        sendEmailFlag = true;
                        emailStep = "Submit";
                        break;
                    case "DOAApprove":
                        emailTitle = "CIMS : Send DOA to Account - " + accPay + " approve as " + dataMonthNames;
                        emailContent = "Dear " + toDepartment + "," +
                            "\n\nDOA " + accPay + " data as " + dataMonthNames +
                            "\nDOA number: " + DOANo +
                            "\n\nIt has been submited, please kindly check in CIMS system." +
                            "\n\n" + accPay + " detail" + paymentDetailContent;
                        emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                        emailContent = emailContent + "\nThen go to menu 'Payment operation > Additional DOA'";
                        emailContent = emailContent + "\n\nThank you & best regards,";
                        emailContent = emailContent + "\nCIMS system admin";
                        sendEmailFlag = true;
                        emailStep = "GM";
                        break;
                    case "DOAReturn":
                        emailTitle = "CIMS : Return DOA - Return" + accPay + " approve as " + dataMonthNames;
                        emailContent = "Dear Operation," +
                            "\n\nDOA " + accPay + " data as " + dataMonthNames +
                            "\nDOA number: " + DOANo +
                            "\n\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";
                        emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                        emailContent = emailContent + "\n\nThank you & best regards,";
                        emailContent = emailContent + "\nCIMS system admin";
                        sendEmailFlag = true;
                        emailStep = "GM-Return";
                        break;
                    case "FinalDOAApprove":
                        emailTitle = "CIMS : Approve DOA by " + toGroupName + " - " + accPay + " approve as " + dataMonthNames;
                        emailContent = "Dear Operation & GM," +
                            "\n\nDOA " + accPay + " data as " + dataMonthNames +
                            "\nDOA number: " + DOANo +
                            "\n\nIt has been approved by Finance Dept , you can check update status to continue process." +
                            "\n\n" + accPay + " detail" + paymentDetailContent;
                        emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                        emailContent = emailContent + "\n\nThank you & best regards,";
                        emailContent = emailContent + "\nCIMS system admin";
                        sendEmailFlag = true;
                        emailStep = "Approved";

                        gSQL = String.Format("EXEC sp_PRC_Transaction_Generate_Interface '{0}','{1}'", vmeID, accPay);
                        dt = odb.SqlQuery(gSQL, mDBName);

                        DataService.WriteFileToSAP(dt, accPay.ToUpper(), vmeTypeShort, paymentType);

                        break;
                    case "FinalDOAReturn":
                        emailTitle = "CIMS : Return DOA by " + toGroupName + " - " + accPay + " approve as " + dataMonthNames;
                        emailContent = "Dear Operation & GM," +
                            "\n\nDOA " + accPay + " data as " + dataMonthNames +
                            "\nDOA number: " + DOANo +
                            "\n\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                        emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                        emailContent = emailContent + "\n\nThank you & best regards,";
                        emailContent = emailContent + "\nCIMS system admin";
                        sendEmailFlag = true;
                        emailStep = "Approved";
                        break;
                    default: break;
                    }
                }

                if (sendEmailFlag)
                {
                    string returnStr = oVME.SendEmailToRevision(vmeType
                                            , accPay // Accrue/Payment
                                            , emailStep
                                            , emailTitle
                                            , emailContent);
                }


                return Content("Done");
            } catch (Exception ex)
            {
                return Content(ex.Message);
            }
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult UploadDOAMaster(HttpPostedFileBase File)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = DataService.ConvertFileNameToGUID(File.FileName);
                string uploadLocationStr = "~/upload/DOAImport/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                return Json(new { result = 200, fileLocation = fileLocation.ToString() });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDOASummaryDetail (string ID)
        {
            DataSet ds = new DataSet();

            gSQL = String.Format("EXEC sp_DOA_Master_Summary_Detail '{0}'", ID);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var JsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            JsonResult.MaxJsonLength = Int32.MaxValue;

            return JsonResult;
        }

        [HttpGet]
        [SessionExpire]
        public JsonResult GetVMEPaymentTypeMaster ()
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_MT_VME_Type");
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpGet]
        [SessionExpire]
        public JsonResult GetVMEPaymentTypeLayout()
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_MT_Interface_Layout");
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetVMEPaymentTypeLayoutDetail(string vmePaymentID, string accountType)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_MT_Interface_Layout_Detail {0}, '{1}'", vmePaymentID, accountType);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SaveVMEPaymentTypeLayout(string vmePaymentTypeId, string accountType, string layoutList)
        {
            var layouts = new System.Web.Script.Serialization.JavaScriptSerializer().Deserialize<List<dynamic>>(layoutList);

            odb.SqlExecute(
                String.Format("EXEC sp_MT_Interface_Layout_Delete '{0}'", vmePaymentTypeId)
                , mDBName
            );

            foreach (var layout in layouts)
            {
                gSQL = String.Format("EXEC sp_MT_Interface_Layout_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}' " +
                                            ", '{10}', '{11}', '{12}', '{13}', '{14}', '{15}', '{16}', '{17}', '{18}', '{19}' " +
                                            ", '{20}', '{21}', '{22}', '{23}', '{24}', '{25}', '{26}', '{27}', '{28}', '{29}' " +
                                            ", '{30}', '{31}', '{32}', '{33}', '{34}', '{35}', '{36}', '{37}', '{38}', '{39}' " +
                                            ", '{40}', '{41}', '{42}', '{43}', '{44}', '{45}', '{46}', '{47}', '{48}', '{49}' " +
                                            ", '{50}', '{51}', '{52}', '{53}', '{54}', '{55}', '{56}', '{57}', '{58}', '{59}' " +
                                            ", '{60}', '{61}', '{62}', '{63}', '{64}', '{65}', '{66}', '{67}', '{68}', '{69}' " +
                                            ", '{70}', '{71}', '{72}', '{73}', '{74}', '{75}', '{76}', '{77}', '{78}', '{79}' " +
                                            ", '{80}', '{81}', '{82}', '{83}', '{84}', '{85}', '{86}', '{87}', '{88}', '{89}' " +
                                            ", '{90}', '{91}'"
                                        , vmePaymentTypeId, accountType, layout["REMARKS"], layout["COMPANY_CODE"]
                                        , layout["DOCUMENT_DATE"], layout["DOCUMENT_HEADER_TEXT"], layout["DOCUMENT_TYPE"], layout["POSTING_DATE"], layout["PERIOD"], layout["TRANSLATION_DATE"], layout["DOCUMENT_CURRENCY"], layout["EXCHANGE_RATE"]
                                        , layout["CALCULATE_TAX"], layout["REFERENCE"], layout["REF_KEY_1_HD_INVOICE_TYPE"], layout["BUSINESS_PLACE"], layout["POSTING_KEY"], layout["SPECIAL_G_L_INDICATOR"], layout["G_L_ACCOUNTS"], layout["VENDOR_CODE"]
                                        , layout["CUSTOMER_CODE"], layout["RECONCILLIATION_ACCOUNTS"], layout["AMOUNT_IN_DOCUMENT_CURRENCY"], layout["AMOUNT_IN_LOCAL_CURRENCY"], layout["TAX_CODE"], layout["TAX_AMOUNT"], layout["TAX_BASE_AMOUNT_IN_DOCUMENT_CURRENCY"], layout["COST_CENTER"]
                                        , layout["INTERNAL_ORDER"], layout["PROFIT_CENTER"], layout["LINE_ITEM_TEXT"], layout["WITHOLDING_TAX_TYPE"], layout["WITHOLDING_TAX_CODE"], layout["WITHOLDING_TAX_BASE"], layout["WITHOLDING_TAX_AMOUNT"], layout["ASSIGNMENT_NUMBER"]
                                        , layout["BRANCH_NUMBER_OF_AP_AR"], layout["PAYMENT_TERM"], layout["BASELINE_DATE"], layout["PAYMENT_BLOCK"], layout["PAYMENT_METHOD"], layout["PARTNER_BANK"], layout["HOUSE_BANK"], layout["EXPENSE_CATEGORY_FUNCTIONAL_AREA"]
                                        , layout["MATERIAL_NUMBER"], layout["PLANT"], layout["BUSINESS_PARTNER_REFERENCE_KEY1"], layout["BUSINESS_PARTNER_REFERENCE_KEY2"], layout["BUSINESS_PARTNER_REFERENCE_KEY3"], layout["TITLE_ONE_TIME"], layout["NAME_1_ONE_TIME"], layout["NAME_2_ONE_TIME"]
                                        , layout["NAME_3_ONE_TIME"], layout["NAME_4_ONE_TIME"], layout["POSTAL_CODE_ONE_TIME"], layout["CITY_ONE_TIME"], layout["COUNTRY_KEY_ONE_TIME"], layout["HOUSE_NUMBER_AND_STREET_ONE_TIME"], layout["TYPE_OF_BUSINESS_ONE_TIME"], layout["REGION_ONE_TIME"]
                                        , layout["LANGUAGE_ONE_TIME"], layout["BANK_COUNTRY_KEY_ONE_TIME"], layout["BANK_ACCOUNT_NUMBER_ONE_TIME"], layout["BANK_KEYS_ONE_TIME"], layout["BANK_CONTROL_KEY_ONE_TIME"], layout["REFERENCE_FOR_BANK_DETAILS_ONE_TIME"], layout["INSTRUCTION_KEY_ONE_TIME"], layout["INDICATOR_FOR_DME_ONE_TIME"]
                                        , layout["TAX_NUMBER_1_ONE_TIME"], layout["TAX_NUMBER_2_ONE_TIME"], layout["TAX_NUMBER_3_ONE_TIME"], layout["TAX_NUMBER_4_ONE_TIME"], layout["EQUALIZATION_TAX_ONE_TIME"], layout["LIABLE_FOR_VAT_ONE_TIME"], layout["DUE_DATE_SPECIAL_GL"], layout["VALUE_DATE_BANK_ACCOUNT"]
                                        , layout["TRANSACTION_TYPE"], layout["TRADING_PARTNER"], layout["MARKET_CODE"], layout["LEDGER_GROUP"], layout["CONTROLLING_AREA"], layout["SALES_ORG"], layout["DISTR_CHANNEL"], layout["DIVISION"]
                                        , layout["MODEL_3_4"], layout["BRAND_CODE"], layout["ECO_AND_NON_ECO"], layout["DESTINATION_CODE"], layout["COUNTRY_SHIP_TO"], layout["REGION_CO_PA"], layout["PRODUCT_TYPE"], layout["ORIGINAL_COMPANY"]);
                odb.SqlExecute(gSQL, mDBName);
            }

            return Content("Done");
        }
        #endregion
    }
}
