﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SMGO.Controllers
{
    public class ConfigureController : Controller
    {
                
        [SessionExpire]
        public ActionResult Index()
        {
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Dealer()
        {
            ViewBag.PageTitle = "Dealer code mapping";

            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult CostCenter()
        {
            ViewBag.PageTitle = "Cost center configuration";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult AccountCode()
        {
            ViewBag.PageTitle = "Account code configuration";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult AccountCostCenter()
        {
            ViewBag.PageTitle = "Account Cost Center";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Model()
        {
            ViewBag.PageTitle = "Model type configuration";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult ModelEdit(string id)
        {
            ViewBag.PageTitle = "Model type configuration";
            ViewBag.ID = id;
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult MSRP()
        {
            ViewBag.PageTitle = "MSRP and margin configuration";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult FleetProgram()
        {
            ViewBag.PageTitle = "Fleet program configuration";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult MsrpEdit(string id)
        {
            ViewBag.PageTitle = "MSRP and margin configuration";
            ViewBag.ID = id;
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult DealerEdit(string id)
        {
            ViewBag.PageTitle = "Dealer code mapping";
            ViewBag.dealerID = id;
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult CostCenterEdit(string id)
        {
            ViewBag.PageTitle = "Cost center configuration";
            ViewBag.costID = id;
            return View();
        }



        [SessionExpire, RoleAuthorized]
        public ActionResult ApVendorCode(string id)
        {
            ViewBag.PageTitle = "AP vendor configuration";
            ViewBag.costID = id;
            return View();
        }
        [SessionExpire, RoleAuthorized]
        public ActionResult NewPaymentType()
        {            
            return View();
        }
        [SessionExpire, RoleAuthorized]
        public ActionResult PaymentType()
        {            
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult SubModel()
        {
            ViewBag.PageTitle = "Submodel configuration";
            return View();
        }
        [SessionExpire, RoleAuthorized]
        public ActionResult InternalOrder()
        {
            return View();
        }
        [SessionExpire]
        public ActionResult InterfaceLayout()
        {
            return View();
        }

        [SessionExpire]
        public ActionResult ImportDOA()
        {
            return View();
        }
    }
}
