﻿using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Web;
using System.Web.Mvc;
using System.Xml;

namespace SMGO.Controllers
{
    public class DealerPortalController : Controller
    {

        [SessionExpire]
        public ActionResult Main()
        {
            return View("Main");
        }

        public ActionResult MainSalesArea()
        {
            return View();
        }

        public ActionResult DealerLogin(string token)
        {
            ServicePointManager.ServerCertificateValidationCallback =
                delegate (object s, X509Certificate certificate, X509Chain chain, SslPolicyErrors sslPolicyErrors)
                {
                    return true;
                };

            string Token = token;
            string Password = "12345678";

            Security obj = new Security();
            DecryptServiceModel decrypt = obj.Decryption(Token, Password);

            ViewBag.Status = decrypt.ResultStatus;
            ViewBag.Message = decrypt.ResultMessage;
            ViewBag.Info = decrypt.Info;
            ViewBag.Token = Token;
            ViewBag.Password = Password;

            if (decrypt.ResultStatus.ToString().ToUpper() == "TRUE")
            {
                return RedirectToAction("LoginByToken", "System", new { usrname = "9101801", token = token });
            }
            else
            {
                return View();
            }
        }

        // GET: DealerPortal
        [SessionExpire]
        public ActionResult Index(string noti, bool tokenerr=false)
        {
            if(!tokenerr && Session[Cons.SS_USER_NAME].ToString().Length > 0) 
            {
                ViewBag.Username = Session[Cons.SS_USER_NAME].ToString();
                ViewBag.NameTH = Session[Cons.SS_USER_NAME_TH].ToString();
                ViewBag.NameEN = Session[Cons.SS_USER_NAME_EN].ToString();
                ViewBag.Email = Session[Cons.SS_USER_EMAIL].ToString();
                ViewBag.noti = noti;
            } 
            else 
            {
                ViewBag.noti = noti;
                ViewBag.err = tokenerr;
            }

            return View();
        }

        [SessionExpire]
        public ActionResult ChangePWD(string expired="false", string init="false")
        {
            ViewBag.Username = Session[Cons.SS_USER_NAME].ToString();
            ViewBag.NameTH = Session[Cons.SS_USER_NAME_TH].ToString();
            ViewBag.NameEN = Session[Cons.SS_USER_NAME_EN].ToString();
            ViewBag.DealerType = Session[Cons.SS_DEALER_TYPE].ToString();
            ViewBag.isExpired = expired;
            ViewBag.isInitPwd = init;
            return View();
        }


        // GET: DealerPortal
        [SessionExpire, RoleAuthorized]
        public ActionResult CampaignSelect()
        {
            return View();
        }

        // GET: DealerPortal
        [SessionExpire, RoleAuthorized]
        public ActionResult FleetSelect()
        {
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult UploadPayment()
        {
            return View(); 
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult DealerOperation()
        {
            ViewBag.OutletID = Session[Cons.SS_OUTLET_ID].ToString();
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult DealerOperationView()
        {
            ViewBag.OutletID = Session[Cons.SS_OUTLET_ID].ToString();
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Rpt1DealerTracking()
        {
             ViewBag.OutletID = Session[Cons.SS_OUTLET_ID].ToString();
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Rpt1DealerBenefic()
        {
            ViewBag.OutletID = Session[Cons.SS_OUTLET_ID].ToString();
            return View();
        }
        

        [SessionExpire, RoleAuthorized]
        public ActionResult Rpt2DealerPayment()
        {
            ViewBag.OutletID = Session[Cons.SS_OUTLET_ID].ToString();
            return View();
        }
         [SessionExpire, RoleAuthorized]
        public ActionResult Rpt1Dealer()
        {
            return View();
        }


        [SessionExpire, RoleAuthorized]
        public ActionResult Survey()
        {
            return View();
        }
      
    }
}