﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using SMGO.aBiz;
using SMGO.aControl;
using System.Configuration;
using System.Globalization;

namespace SMGO.Controllers
{
    public class DemoCarDsController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();



        [HttpPost]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarReconHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Reconcile_Status 'DemoCar'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarAccrueAll()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_DMC_Accrue_ByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #region Dealer work with DB


        public JsonResult GetDemoCarDealerList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_DMC_Dealer_List_Select]";
            gSQL = String.Format(gSQL
                                );
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        //public ContentResult EditDealerConf()
        //{
        //    DataTable dt = new DataTable();

        //    gSQL = "EXEC [dbo].[sp_DMC_Dealer_Update] '{0}', '{1}', '{2}', '{3}', '{4}'";
        //    gSQL = String.Format(gSQL
        //                        , Request.Form["ID"]
        //                        , Request.Form["DealerCond"]
        //                        , Request.Form["DEMO_AREA_FLAG"]
        //                        , Request.Form["SIZE"]
        //                        , Session[Cons.SS_USER_ID].ToString());

        //    dt = odb.SqlQuery(gSQL, mDBName);

        //    return Content("Done");

        //}

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOutletList()
        {
            DataTable dt = new DataTable();

                gSQL = "EXEC [dbo].[sp_DMC_Dealer_List] {0}";
                gSQL = String.Format(gSQL, Request.Form["FY"]);
                dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOutletResult()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_DMC_Dealer_Quota] {0}";
            gSQL = String.Format(gSQL, Request.Form["FY"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetOutletInfo()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_DMC_Dealer_Info] {0} , '{1}'";
            gSQL = String.Format(gSQL, Request.Form["FY"], Request.Form["OUTLET_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public ContentResult SaveOutletConfig()
        {
            gSQL = "EXEC sp_DMC_Dealer_Update '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}'";
            gSQL = String.Format(gSQL
                                , Request.Form["FY"]
                                , Request.Form["OUTLET_ID"]
                                , Request.Form["NAVARA"]
                                , Request.Form["MARCH"]
                                , Request.Form["ALMERA"]
                                , Request.Form["NOTE"]
                                , Request.Form["SYLPHY"]
                                , Request.Form["TEANA"]
                                , Request.Form["XTRAIL"]
                                , Request.Form["URVAN"]
                                , Request.Form["TERRA"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }

        #endregion

        #region Period

        [SessionExpire]
        public ContentResult Send_Period()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Send_Period '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                Request.Form["TYPE"],
                                Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);
            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            var sendEmailFlag = false;

            switch (Request.Form["TYPE"])
            {
                case "Send":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send demo car configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear GM,\n\nDemo car configuration as " + Request.Form["PERIOD_NAME"] + " has been set, please kindly access to CIMS system to approve.";
                    sendEmailFlag = true;
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("DemoCar"
                                        , "Configure"
                                        , "Submit"
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [SessionExpire]
        public ContentResult ApproveSubmit()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Approve_Submit '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                Request.Form["TYPE"],
                                Request.Form["REMARK"],
                                Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            var sendEmailFlag = false;

            switch (Request.Form["TYPE"])
            {
                case "Approved":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved demo car configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear Operation,\n\nDemo car configuration as " + Request.Form["PERIOD_NAME"] + " has been approved by GM, you can check update status to continue process.";
                    sendEmailFlag = true;
                    break;

                case "Return":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return demo car configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear Operation,\n\nDemo car configuration as " + Request.Form["PERIOD_NAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    sendEmailFlag = true;
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("DemoCar"
                                        , "Configure"
                                        , "GM"
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoAccrueHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Accrue_Status 'DemoCar'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetPeriodDMCList(string id)
        {
            DataTable dt = new DataTable();

            if (id != "" && id != null)
            {
                gSQL = "EXEC [sp_DMC_Period_ListByID] {0}";
            }
            else
            {
                gSQL = "EXEC [sp_DMC_Period_ListAll]";
            }

            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult CheckPeriodDemoCarExist()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Period_IsExist] '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL
                            , ismoUtil.ConvertAngularDateTo120(Request.Form["START_DATE"].ToString())
                            , ismoUtil.ConvertAngularDateTo120(Request.Form["END_DATE"].ToString())
                            , Request.Form["PERIOD_NAME"].ToString()
                            , Convert.ToInt32(Request.Form["ID"])
                            );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult AddPeriodDemoCar()
        {

            gSQL = "EXEC sp_DMC_Period_Add '{0}','{1}','{2}','{3}','{4}','{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["PERIOD_NAME"]
                                , Request.Form["PERIOD_NAME_EN"]
                                , ismoUtil.ConvertAngularDateTo120(Request.Form["START_DATE"].ToString())
                                , ismoUtil.ConvertAngularDateTo120(Request.Form["END_DATE"].ToString())
                                , Request.Form["REMARKS"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }

        [SessionExpire]
        public ContentResult EditDMCPeriod()
        {
            DataTable dt = new DataTable();

            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE [TBL_DMC_Period] " + gSQL;
            gSQL = String.Format(gSQL);
            Response.Write(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        #endregion

        #region Demo Model work with DB

        [HttpPost]
        public ContentResult DeleteDemocarGroup()
        {
            gSQL = "EXEC sp_DMC_ModelGroup_Delete {0}, '{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["MODELGROUP_ID"]
                                , Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }


        [HttpPost]
        public JsonResult SaveDemoCarModelGroup(string CAMPAIGN_MODEL_NO, string CAMPAIGN_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_ModelGroup_Save '{0}','{1}','{2}','{3}',{4},{5},{6},{7},{8},{9},'{10}','{11}','{12}'";
            gSQL = String.Format(gSQL
                                , Request.Form["CAMPAIGN_MODEL_NO"]
                                , Request.Form["CAMPAIGN_MODEL_NAME"]
                                , Request.Form["REMARKS"]
                                , Request.Form["MODELGROUP_NAME"]
                                , Request.Form["MODELGROUP_NO"]
                                , Request.Form["MODELGROUP_ID"]
                                , (Request.Form["PAYMENT1"] == "" || Request.Form["PAYMENT1"] == null) ? "0" : Request.Form["PAYMENT1"]
                                , (Request.Form["PAYMENT2"] == "" || Request.Form["PAYMENT2"] == null) ? "0" : Request.Form["PAYMENT2"]
                                , Request.Form["MIN_HOLDING"]
                                , Request.Form["MAX_HOLDING"]
                                , Session[Cons.SS_USER_ID].ToString()
                                , (ModelID != null && ModelID.Length > 0) ? string.Join(",", ModelID) : ""
                                , (Request.Form["PERIODID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["periodID"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult SaveDemoCarModel(string CAMPAIGN_MODEL_NO, string CAMPAIGN_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Model_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}'";
            gSQL = String.Format(gSQL
                                , Request.Form["SALES_END_ITEM"]
                                , Request.Form["S_AMOUNT"]
                                , Request.Form["M_AMOUNT"]
                                , Request.Form["L_AMOUNT"]
                                , Session[Cons.SS_USER_ID].ToString()
                                , Request.Form["MIN_HOLDING"]
                                , Request.Form["MAX_HOLDING"]
                                , Request.Form["Payment1"]
                                , Request.Form["Payment2"]
                                , Request.Form["NORMAL_AREA"]
                                , Request.Form["SPECIAL_AREA"]
                                , (Request.Form["CURRENT_PERIOD_ID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["CURRENT_PERIOD_ID"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult SendDemoCarModelToApprove(string CAMPAIGN_MODEL_NO, string CAMPAIGN_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Model_SendToApprove '{0}','{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["SALES_END_ITEM"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        public JsonResult GetDemoCarModelByID(string id)
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_DMC_ModelGroup_ByID '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        public JsonResult GetDemoModelGroupList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_DMC_ModelGroup_List '{0}'";
            gSQL = String.Format(gSQL
                , (Request.Form["CURRENT_PERIOD_ID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["CURRENT_PERIOD_ID"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetDemoModelList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_ModelList '{0}'";
            gSQL = String.Format(gSQL
                , (Request.Form["CURRENT_PERIOD_ID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["CURRENT_PERIOD_ID"]
                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetDemoModelSelectedList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_ModelList_BySelected {0},{1},'{2}'";
            gSQL = String.Format(gSQL
                , Convert.ToInt32((Request.Form["CURRENT_PERIOD_ID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["CURRENT_PERIOD_ID"])
                , Request.Form["MODELGROUP_ID"]
                , Request.Form["TYPE"]
                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetDemoModelNotSelectedList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_ModelList_ByNotSelected {0},{1},'{2}'";
            gSQL = String.Format(gSQL
                        , Convert.ToInt32((Request.Form["CURRENT_PERIOD_ID"] == "0") ? Session[Cons.SS_PERIOD_ID].ToString() : Request.Form["CURRENT_PERIOD_ID"])
                        , Request.Form["MODELGROUP_ID"]
                        , Request.Form["TYPE"]
                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetModelList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CFG_Base_Model_List] {0}";
            gSQL = String.Format(gSQL, (id != "" && id != null) ? id : "null");

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        public JsonResult UpdateDemoCarConfig(HttpPostedFileBase File)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/DemoCar/DemoCarConfig/" + Session[Cons.SS_PERIOD_ID].ToString() + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                //gSQL = String.Format("EXEC [dbo].[sp_DMC_Program_Config_Save] {0}, '{1}', '{2}'"
                //                    , Session[Cons.SS_PERIOD_ID].ToString()
                //                    , aBiz.DataService.MapUploadPath(fileLocation)
                //                    , Session[Cons.SS_USER_ID].ToString());

                //DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion

        #region Demo Car Result



        [HttpPost]
        public JsonResult GetDemoCarSummaryResult()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Summary_Result] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL,
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_FROM"].ToString()),
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_TO"].ToString()),
                                Request.Form["KEY_PLAN"]);

            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetDemoCarResult()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Selected_Bulletin_List '{0}','{1}','{2}','{3}','{4}'";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]
                , ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_FROM"].ToString())
                , ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_TO"].ToString())
                , Request.Form["DEALER_ID"].ToString()
                , Request.Form["BASE_MODEL"].ToString()
                );
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetDemoCarChassisInfo()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Chassis_Info] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]
                );
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetDMCUpload()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Selected_Upload '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]
                , (Request.Form["DATA_MONTH"].ToString())
                );
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        //[HttpPost]
        //public JsonResult GetDMCCheckDocResult()
        //{
        //    DataSet ds = new DataSet();
        //    DataTable dt = new DataTable();

        //    gSQL = "EXEC sp_DMC_CheckDoc_ByChassis '{0}'";
        //    gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]
        //        );
        //    ds = odb.SqlQueryDS(gSQL, mDBName);

        //    return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        //}

        [HttpPost]
        public JsonResult GetDemoCarResultBullatinChange()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Selected_OnChangeBullatin '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]
                , Request.Form["PERIODID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public ContentResult SaveDMCSummaryDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Selected_Update] '{0}','{1}',{2},{3},{4},'{5}','{6}','{7}','{8}',{9}";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["ACCEPTABLEPAYMENT"]
                                , (Request.Form["BULLETIN_ID"] == "") ? "null" : Request.Form["BULLETIN_ID"]
                                , (Request.Form["PAYMENT1"] == "") ? "null" : Request.Form["PAYMENT1"]
                                , (Request.Form["PAYMENT2"] == "") ? "null" : Request.Form["PAYMENT2"]
                                , Request.Form["MIN_HOLDING"]
                                , Request.Form["MAX_HOLDING"]
                                , Session[Cons.SS_USER_ID].ToString()
                                , (Request.Form["DOC_REF"] == null || Request.Form["DOC_REF"] == "" || Request.Form["DOC_REF"] == "null") ? "" : Request.Form["DOC_REF"]
                                , ((Request.Form["DOC_DATE"] == null || Request.Form["DOC_DATE"] == "" || Request.Form["DOC_DATE"] == "null") ? "null" : "'" + DataService.DateValidation(Request.Form["DOC_DATE"].ToString()) + "'"));

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public JsonResult GetDemoCarBulletin()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Bullatin] '{0}','{1}'";
            gSQL = String.Format(gSQL
                , Request.Form["MODEL_CODE"]
                , Request.Form["CHASSIS_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion

        #region Upload Doc
        [HttpPost]
        public JsonResult GetFleetPaymentDoc()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_TRN_VIN_DMC_ByChassis] '{0}'";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult UploadPaymentDoc(HttpPostedFileBase File, string Chassis, string DealerID, string DOC_REF, string DOC_DATE)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/DemoCar/PaymentDoc/" + DealerID + "/" + Chassis + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_TRN_VIN_DMC_Payment_Doc_Add] '{0}','{1}','{2}','{3}',{4}"
                                    , Chassis
                                    , fileLocation
                                , Session[Cons.SS_USER_ID].ToString()
                                , (Request.Form["DOC_REF"] == null || Request.Form["DOC_REF"] == "" || Request.Form["DOC_REF"] == "null") ? "" : Request.Form["DOC_REF"]
                                , (Request.Form["DOC_DATE"] == null || Request.Form["DOC_DATE"] == "" || Request.Form["DOC_DATE"] == "null") ? "null" : "'"
                                + DataService.DateValidation(Request.Form["DOC_DATE"]) + "'");

                //DataService.DateValidation(Request.Form["START_EFFECTIVE_DATE"].ToString()

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = 200 });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion

        #region DMC Select


        [HttpPost]
        public JsonResult GetDemoCarSelectResult()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_DMC_Select_Result] '{0}'";
            gSQL = String.Format(gSQL,
                                (Request.Form["DATA_MONTH"].ToString())
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region payment
        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetNotPaymentListCancelled()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC [sp_DMC_Payment_Non_List_Cancelled] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"], Request.Form["PAYMENT_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult SelectPayment(string[] CHASSIS)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Payment_Select_Save] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , (CHASSIS != null && CHASSIS.Length > 0) ? string.Join(",", CHASSIS) : ""
                                , "DemoCar"
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SelectAllPayment()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_Payment_SelectAll_DemoCar_Save] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_TYPE"]);
            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult UnSelectAllPayment()
        {
            gSQL = "EXEC [sp_Payment_UnSelectAll_DemoCar_Save] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_TYPE"]);
            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult RemoveSelectPayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Payment_Select_Delete '{0}','{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult CancelSelectPayment(string[] CHASSIS)
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_Payment_Cancel] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , (CHASSIS != null && CHASSIS.Length > 0) ? string.Join(",", CHASSIS) : ""
                                , "DemoCar"
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult UndoCancelledChassis()
        {
            gSQL = "EXEC [sp_Payment_Cancel_Reverse] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , Request.Form["CHASSIS"]
                                , "DemoCar"
                                , Request.Form["PAYMENT_TYPE"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetSelectedPayment()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC [sp_DMC_Payment_Selected] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitPayment()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_DMC_Payment_Submit '{0}','{1}',{2},'{3}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , Request.Form["PAYMENT_TYPE"]
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "DemoCar";
            string paymentDetailContent = "";
            var sendEmailFlag = false;
            // string submitdate = ds.Tables[ds.Tables.Count - 1].Rows[0][0].ToString();
            // string round = ds.Tables[ds.Tables.Count-1].Rows[0][1].ToString();

            if (gStatus == "Payment")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            // set total amount
            string totalAmount = ds.Tables["Table"].Select("DATA_MONTHNAME = 'Total'")[0]["TOTAL_AMOUNT"].ToString();

            var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));
            foreach (DataRow row in ds.Tables["Table"].Rows)
            {
                if (row["DATA_MONTHNAME"].ToString() != "Total")
                {
                    paymentDetailContent = paymentDetailContent + "\n" +
                            "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                            "     Payment: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                    (
                        Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                            "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                            "     Net: " + row["NET"].ToString() + " THB\n" : ""
                    );
                }
            }

            paymentDetailContent = paymentDetailContent + "\n" +
                        "Total amount: " + totalAmount + " THB\n";

            switch (gStatus)
            {
                case "Payment":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send demo car - " + Request.Form["PAYMENT_TYPE"] + " Payment approve as " + dataMonthNames;
                    emailContent = "Dear GM,\n\n" +
                                     "Demo car - Payment data as " + dataMonthNames + "\n" +
                                     ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been sent, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\nThank you & best regards,";
                    emailContent = emailContent + "\nCIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;
                case "PaymentApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account Demo car - " + Request.Form["PAYMENT_TYPE"] + " Payment approve as " + dataMonthNames;
                    emailContent = "Dear Finance Dept,\n\n"
                                     + "Demo car - Payment data as " + dataMonthNames + " has been submited, please kindly check in CIMS system."
                                     + "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"]
                                     + "\n\nPayment detail" + paymentDetailContent;
                                    //  + "Payment amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\nThank you & best regards,";
                    emailContent = emailContent + "\nCIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "PaymentReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return demo car - " + Request.Form["PAYMENT_TYPE"] + " Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation,\n\n" +
                                     "Demo car - Payment data as " + dataMonthNames + "\n" +
                                      ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type :" + Request.Form["PAYMENT_TYPE"] + "\n" +
                                     "\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\nThank you & best regards,";
                    emailContent = emailContent + "\nCIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;
                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account Demo car - " + Request.Form["PAYMENT_TYPE"] + " Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation & GM,\n\n" +
                                     "Demo car - Payment data as " + dataMonthNames + "\n" +
                                     ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been approved by Finance Dept , you can check update status to continue process." +
                                     "\n\nPayment detail" +
                                     paymentDetailContent;
                                    //  "Payment amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\nThank you & best regards,";
                    emailContent = emailContent + "\nCIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    gSQL = "EXEC sp_IF_Payment_DMC_To_New_SAP '{0}','{1}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["PAYMENT_TYPE"]
                                     , Request.Form["ID"]);
                    dt = odb.SqlQuery(gSQL, mDBName);

                    DataService.WriteFileToSAP(dt, "PAYMENT", "DMC", Request.Form["PAYMENT_TYPE"]);
                    break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account Demo car - " + Request.Form["PAYMENT_TYPE"] + " Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation & GM,\n\n" +
                                     "Demo car - Payment data as " + dataMonthNames + "\n" +
                                      ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                    emailContent = emailContent + "\n\nYou can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\nThank you & best regards,";
                    emailContent = emailContent + "\nCIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;
                default: break;
            }
            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Payment"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }
            return Content("Done");
        }
        #endregion

        #region payment2

        [HttpPost]
        public ContentResult Save2ndPayment()
        {
            DataTable dt = new DataTable();

            //gSQL = "EXEC [sp_PRC_FleetVin_2ndPayment_Update] '{0}',{1},{2},{3},{4},'{5}','{6}' ";
            gSQL = "EXEC [sp_DMC_2ndPayment_Update] '{0}','{1}','{2}','{3}' ";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                //, Request.Form["MONTHLY_PROGRAM_ID"]
                                , (Request.Form["DOC_FLAG"] != "") ? Request.Form["DOC_FLAG"] : "null"
                                , (Request.Form["REMARKS"] != "") ? Request.Form["REMARKS"] : ""
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment2nd()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment2nd_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region Fleet Check Upload
        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarUploadStatus()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Check_Upload '{0}' ";
            gSQL = String.Format(gSQL, Request.Form["DOC_STATUS"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

       
        #endregion

        #region Accrue

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDMCAccrueSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_DMC_Accrue_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitAccrue()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();

            string gStatus = Request.Form["STATUS"];
            gSQL = "EXEC sp_DMC_Accrue_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "DemoCar";
            var sendEmailFlag = false;

            if (gStatus == "Accrue")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Accrue":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send demo car - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nDemo car - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been calculated, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;
                case "AccrueApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "M&S Control";
                    // emailCCDepartment = "Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to M&S Control Demo car - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear M&S Control,\n\nUser request you to approve demo car - accrue data as " + Request.Form["DATA_MONTHNAME"] + "."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "AccrueReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return demo car - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nDemo car - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;
                case "MSControlApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by M&S Control Demo car - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nDemo car - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by M&S Control , you can check update status to continue process."
                                     + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Accrue_DMC_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "ACCRUE", "DMC", "");
                    break;
                case "MSControlReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by M&S Control Demo car - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nDemo car - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by M&S Control, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;
                default: break;
            }
            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Accrue"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }
            return Content("Done");
        }

        #endregion

        #region Reconcile
        [HttpPost]
        [SessionExpire]
        public JsonResult GetReconcile()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_DMC_Reconcile_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarReconAll()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_DMC_Recon_ByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitRecon()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_DMC_Reconcile_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "DemoCar";
            var sendEmailFlag = false;

            if (gStatus == "Reconcile")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Reconcile":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send demo car - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nDemo car - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been submited, please kindly approve in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;
                case "ReconcileApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account Demo car - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Account Dept,\n\nDemo car - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been submited, please kindly check in CIMS system."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "ReconcileReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return demo car - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nDemo car - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;
                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account Demo car - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nDemo car - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by Account, you can check update status to continue process."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    gSQL = "EXEC sp_IF_Reconcile_DMC_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "RECONCILE", "DMC", "");
                    break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account Demo car - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nDemo car - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by Account, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;
                default: break;
            }
            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Reconcile"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }
            return Content("Done");
        }
        #endregion

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment1ByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment1_ListByMonth] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment2ByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment2_ListByMonth] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment_ListByMonth] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSubmitByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment_Submit_ListByModel] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment2ndSubmitByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_DMC_Payment2nd_Submit_ListByModel] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetPaymentSubmitDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC {0} '{1}',{2}";
            gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["PAYMENT_ID"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetAsDetail()
        {
            DataTable dt = new DataTable();
            if (Request.Form["REPORT_ID"].ToString() == "154" || Request.Form["REPORT_ID"].ToString() == "158")
            {
                gSQL = "EXEC {0} '{1}'";
                gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["DATA_MONTH"]);
            }
            else
            {
                gSQL = "EXEC {0} '{1}',{2}";
                gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["DATA_MONTH"], Request.Form["REPORT_ID"]);
            }

            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult UploadDemoCarConfig(HttpPostedFileBase File, string fy)
        {

            if (File != null && File.ContentLength > 0)
            {
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/DemoCar/DemocarDealerConfig/" + fy + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
												
                gSQL = String.Format("EXEC [dbo].[sp_DMC_Dealer_Config_Import] {0},'{1}','{2}'"
                                    , fy
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });
            }          
            else
            {
                return Json(new { result = 500 });
            }
        }
    }
}
