﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Globalization;

namespace SMGO.Controllers
{
    public class FleetDsController : Controller
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();


        [HttpPost]
        public JsonResult GetFleetDealerList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_STD_Fleet_Dealer_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        #region PeriodFleet work with DB

        public JsonResult GetPeriodFleetList(string id)
        {
            DataTable dt = new DataTable();

            if (id != "" && id != null)
            {
                gSQL = "EXEC [sp_FLT_Period_ListByID] {0}";
            }
            else
            {
                gSQL = "EXEC [sp_FLT_Period_ListAll]";
            }

            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult CheckPeriodFleetExist()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Period_IsExist] '{0}','{1}'";
            gSQL = String.Format(gSQL
                            , ismoUtil.ConvertAngularDateTo120(Request.Form["START_DATE"].ToString())
                            , ismoUtil.ConvertAngularDateTo120(Request.Form["START_DATE"].ToString())
                            );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public ContentResult AddPeriodFleet()
        {

            gSQL = "EXEC sp_FLT_Period_Add '{0}','{1}','{2}','{3}','{4}'";
            gSQL = String.Format(gSQL
                                , Request.Form["PERIOD_NAME"]
                                , ismoUtil.ConvertAngularDateTo120(Request.Form["START_DATE"].ToString())
                                , ismoUtil.ConvertAngularDateTo120(Request.Form["END_DATE"].ToString())
                                , Request.Form["REMARKS"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");

        }

        public ContentResult EditPeriodFleet()
        {

            DataTable dt = new DataTable();

            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE [TBL_FLT_Period] " + gSQL;
            gSQL = String.Format(gSQL);
            Response.Write(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");

        }

        [SessionExpire]
        public ContentResult ApproveSubmit()
        {
            DataTable dt = new DataTable();
            string gStatus = Request.Form["TYPE"];

            gSQL = "EXEC sp_FLT_Approve_Submit '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                gStatus,
                                Request.Form["REMARK"],
                                Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            var sendEmailFlag = false;

            switch (gStatus)
            {
                case "Approved":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS: Approved fleet configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear Operation,\n\nFleet configuration as " + Request.Form["PERIOD_NAME"] + " has been approved by GM, you can check update status to continue process.";
                    sendEmailFlag = true;
                    break;

                case "Return":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return fleet configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear Operation,\n\nFleet configuration as " + Request.Form["PERIOD_NAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    sendEmailFlag = true;
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("Fleet"
                                        , "Configure"
                                        , "GM"
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [SessionExpire]
        public ContentResult FLT_Send_Period()
        {
            DataTable dt = new DataTable();
            string gStatus = Request.Form["TYPE"];

            gSQL = "EXEC sp_FLT_Send_Period '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                gStatus,
                                Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            var sendEmailFlag = false;

            switch (gStatus)
            {
                case "Send":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send fleet configuration - " + Request.Form["PERIOD_NAME"];
                    emailContent = "Dear GM,\n\nFleet configuration as " + Request.Form["PERIOD_NAME"] + " has been set, please kindly access to CIMS system to approve.";
                    sendEmailFlag = true;
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("Fleet"
                                        , "Configure"
                                        , "Submit"
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        #endregion


        #region Fleet Monthly Program

        public JsonResult GetFleetList(string ID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Monthly_Program_List] {0}, '{1}'";
            gSQL = String.Format(gSQL, Session[Cons.SS_PERIOD_ID].ToString(), ID);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetFleetCopyList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_Copy_List] ";
            // gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        public JsonResult GetFleetModel()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_Model] {0}";
            gSQL = String.Format(gSQL, Session[Cons.SS_PERIOD_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);


        }

        public JsonResult GetFleetModelList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_Model_List] {0}, {1},'{2}'";
            gSQL = String.Format(gSQL, Session[Cons.SS_PERIOD_ID].ToString(), Request.Form["PROGRAM_ID"], Request.Form["BASE_MODEL"]);

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetFleetMatching(string ID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_PRC_Fleet_Matching] '{0}'";
            gSQL = String.Format(gSQL, ID);

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

        }

        public ContentResult GenFleetProgram()
        {
            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Monthly_Program_Gen] '{0}','{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }

        public ContentResult CopyFleetProgram()
        {
            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Monthly_Program_Copy] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }

        public ContentResult EditFleetProgram()
        {
            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE TBL_FLT_Fleet_Monthly_Program " + gSQL;
            gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        public ContentResult SaveFleetModel()
        {

            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_FLT_Fleet_Program_Model_Save] '{0}','{1}','{2}','{3}','{4}','{5}',{6},{7},'{8}','{9}','{10}','{11}','{12}','{13}','{14}'";
            gSQL = String.Format(gSQL
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["SALES_END_ITEM"]
                                , Request.Form["COLOR_CODE"]
                                , Request.Form["OPTION_CODE"]
                                , Request.Form["OPTION_NAME"]
                                , Request.Form["DO_CHECK"]
                                , (Request.Form["DO_FROM_DATE"] == "") ? "null" : "'" + DataService.DateValidation(Request.Form["DO_FROM_DATE"]) + "'"
                                , (Request.Form["DO_TO_DATE"] == "") ? "null" : "'" + DataService.DateValidation(Request.Form["DO_TO_DATE"]) + "'"
                                , Request.Form["ONTOP_L"]
                                , Request.Form["ONTOP_M"]
                                , Request.Form["ADD_ONTOP"]
                                , Request.Form["EXCEPT_DO_ONTOP_L"]
                                , Request.Form["EXCEPT_DO_ONTOP_M"]
                                , Request.Form["EXCEPT_DO_ADD_ONTOP"]
                                , Session[Cons.SS_USER_ID].ToString());



            dt = odb.SqlQuery(gSQL, mDBName);
            return Content("Done");
        }

        [HttpPost]
        public JsonResult UpdateFleetConfig(HttpPostedFileBase File, string programID)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Fleet/FleetConfig/" + programID + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_FLT_Program_Config_Upload] {0}, '{1}', '{2}'"
                                    , programID
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult SaveFleetDOA()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_DOA_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}'";
            gSQL = String.Format(gSQL
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["ID"]
                                , Request.Form["DOA_NUMBER"]
                                , Request.Form["DOA_DETAIL"]
                                , Request.Form["DOA_CHASSIS_COUNT"]
                                , DataService.DateValidation(Request.Form["DOA_DATE"])
                                , Request.Form["BULLETIN_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult DeleteFleetDOA()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_DOA_Delete] '{0}','{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["ID"]);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetDOAListByMonthlyID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_DOA_List] '{0}'";
            gSQL = String.Format(gSQL
                                , id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetDOAAvailable(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_DOA_Available_List] '{0}'";
            gSQL = String.Format(gSQL
                                , id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetBulletinActiveList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC [dbo].[sp_FLT_Bulletin_ActiveList] '{0}'"
                                , id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion


        #region Fleet Result


        public JsonResult GetFleetListByDate()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_ListByMonth] '{0}','{1}'";
            gSQL = String.Format(gSQL,
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_FROM"].ToString()),
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_TO"].ToString()));

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        public JsonResult GetFleetListByMonth(string id)
        {
            DataTable dt = new DataTable();

            var dataMonth = id;
            var dataMonthToDate = DateTime.ParseExact(dataMonth, "yyyyMM", CultureInfo.CurrentCulture);
            var dateFrom = dataMonthToDate;
            var dateTo = dataMonthToDate.AddMonths(1).AddDays(-1);

            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Program_ListByMonth] '{0}','{1}'";
            gSQL = String.Format(gSQL,
                                dateFrom.ToString("yyyy-MM-dd"),
                                dateTo.ToString("yyyy-MM-dd"));

            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetResultList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Fleet_Adjust_List] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DEALER_CODE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetBullatin()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Fleet_Bullatin] '{0}','All'";
            gSQL = String.Format(gSQL, Request.Form["FLEET_NAME"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetBullatinDealer()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Fleet_Bullatin] '{0}','Restrict'";
            gSQL = String.Format(gSQL, Request.Form["FLEET_NAME"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetResultListByFleetName()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Fleet_Info_ByFleetName] '{0}','{1}'";
            gSQL = String.Format(gSQL,
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_FROM"].ToString()),
                                ismoUtil.ConvertAngularDateTo120(Request.Form["DATE_TO"].ToString()));
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetResult()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Fleet_Info_ByChassis '{0}'";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetResultGroup()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Fleet_Info_ByModelGroup '{0}','{1}','{2}','{3}','{4}'";
            gSQL = String.Format(gSQL
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , DataService.DateValidation(Request.Form["DATE_FROM"].ToString())
                                , DataService.DateValidation(Request.Form["DATE_TO"].ToString())
                                , Request.Form["FLEET_NAME"]
                                , Request.Form["MODEL_CODE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetChargeBackType()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_FLT_Charge_Back_Type_List";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetChargeBackAmount()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_FLT_Get_ChargeBack_Amount '{0}' ";
            gSQL = String.Format(gSQL, Request.Form["CHASSIS_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        
        [HttpPost]
        public ContentResult SaveFleetResult()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Bulletin_Selected_Update] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}' ";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["FLEET_CAMPAIGN_AMOUNT"]
                                , Request.Form["ONTOP_FLAG"]
                                , Request.Form["ONTOP_M"]
                                , Request.Form["ONTOP_L"]
                                , Request.Form["ADD_ONTOP"]
                                , Request.Form["DOC_REF"]
                                , Request.Form["DOA_ID"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public ContentResult SaveBullatin()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Bulletin_Update] '{0}','{1}','{2}','{3}'";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["ONTOP_FLAG"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public ContentResult SaveFleetAmountGroup()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Bulletin_Update_Group] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}' ";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["MONTHLY_PROGRAM_ID"]
                                , Request.Form["FLEET_CAMPAIGN_AMOUNT"]
                                , Request.Form["ONTOP_FLAG"]
                                , Request.Form["ONTOP_M"]
                                , Request.Form["ONTOP_L"]
                                , Request.Form["ADD_ONTOP"]
                                , Request.Form["DOA_ID"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetFleetGroupList(string DOC_ID, string FLEET_NAME){
            DataTable dt = new DataTable();

            gSQL = string.Format("EXEC sp_FLT_DocGroup_List '{0}','{1}'"
                                , DOC_ID, FLEET_NAME);
            
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public ContentResult UpdateDocGroupStatus(string[] Chassis, string DOC_FLAG, string REMARKS)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_DocumentGroup_Status_Update] '{0}','{1}','{2}','{3}' ";
            gSQL = string.Format(gSQL
                                , "''"+string.Join("'',''", Chassis)+"''"
                                , (DOC_FLAG != "") ? DOC_FLAG : "null"
                                , (REMARKS != "") ? REMARKS : ""
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public ContentResult UpdateDocStatus()
        {
            DataTable dt = new DataTable();

            //gSQL = "EXEC [sp_PRC_FleetVin_2ndPayment_Update] '{0}',{1},{2},{3},{4},'{5}','{6}' ";
            gSQL = "EXEC [sp_FLT_Document_Status_Update] '{0}','{1}',{2},'{3}','{4}',{5},'{6}' ";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["FLEET_PAYMENT1"]
                                , (Request.Form["DOC_FLAG"] != "") ? "'" + Request.Form["DOC_FLAG"] + "'" : "null"
                                , (Request.Form["REMARKS"] != "") ? Request.Form["REMARKS"] : ""
                                , (Request.Form["CHARGE_BACK_TYPE"] !="") ? Request.Form["CHARGE_BACK_TYPE"] : ""
                                , (Request.Form["CHARGE_BACK"] !="") ? Request.Form["CHARGE_BACK"] : "null"
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        #endregion


        #region Dealer Upload payment Doc

        [HttpPost]
        public JsonResult GetFleetPaymentDoc()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_TRN_VIN_Fleet_ByChassis] '{0}'";
            gSQL = string.Format(gSQL
                                , Request.Form["CHASSIS_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult UploadPaymentDoc(HttpPostedFileBase File, string Chassis, string DealerID, string DocRef)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Fleet/PaymentDoc/" + DealerID + "/" + Chassis + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_TRN_VIN_Fleet_Payment_Doc_Add] '{0}', '{1}', '{2}', '{3}'"
                                    , Chassis
                                    , fileLocation
                                    , DocRef
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = 200 });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult UploadPaymentDocGroup(HttpPostedFileBase File, string[] Chassis, string DealerID, string DocRef, string FileID)
        {
            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Fleet/PaymentDoc/" + DealerID + "/{0}/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                // // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_TRN_VIN_Fleet_Payment_DocGroup_Add] {0}, '{1}', '{2}', '{3}'"
                                    , FileID
                                    , fileLocation
                                    , DocRef
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);
                string fileID = dt.Rows[0]["ID"].ToString();

                // Add ID to path
                uploadLocation = String.Format(uploadLocation, fileID);
                fileLocation = String.Format(fileLocation, fileID);

                // Upload file to location
                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));
                return Json(new { result = 200 , FileID = fileID});
            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        [SessionExpire]
        [HttpPost]
        public JsonResult SaveGroupWOUpload (string[] Chassis, string DealerID, string DocRef, string FileID)
        {
            if (Chassis.Length == 1)
            {
                gSQL = String.Format("EXEC [dbo].[sp_FLT_DocGroup_Update] {0}, '{1}', '{2}', '{3}', 1"
                                , FileID
                                , "''"+string.Join("'',''", Chassis)+"''"
                                , DocRef
                                , Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);
            } else
            {
                gSQL = String.Format("EXEC [dbo].[sp_FLT_DocGroup_Update] {0}, '{1}', '{2}', '{3}', 0"
                                    , FileID
                                    , "''" + string.Join("'',''", Chassis) + "''"
                                    , DocRef
                                    , Session[Cons.SS_USER_ID].ToString());
                odb.SqlExecute(gSQL, mDBName);
            }
            return Json(new { result = 200 });
        }

        #endregion


        #region Fleet Summary & Accrue

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Accrue_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueFromTo()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Accrue_FromTo_List] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH_FROM"], Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueFromToByChassis()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_FLT_Accrue_FromTo_ByChassis] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH_FROM"], Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueAll()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_Model_With_Charge_Back_ByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueCurrent()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_List_ByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueChargeBack()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_Accrue_Charge_Back_ByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAccrueHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Accrue_Status 'Fleet'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetReconHistory()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_ACC_Reconcile_Status 'Fleet'";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetReconAll()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_Recon_ByChassis] '{0}','N'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetReconChargeBackByChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_Recon_ByChassis] '{0}','Y'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetReconFromTo()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Recon_FromTo_ByChassis] '{0}','{1}' ,'N'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH_FROM"], Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetReconChargeBackFromTo()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Recon_FromTo_ByChassis] '{0}','{1}','Y'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH_FROM"], Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetNotPaymentList()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_Non_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetNotPaymentListCancelled()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC [sp_FLT_Payment_Non_List_Cancelled] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }
        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSelectedWithChargeBack()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_CB_Selected]";
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSelectedWithChargeBackByChassis()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_CB_ByChassis]";
            //gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSelectedWithChargeBackByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_CB_ByModel]";
            //gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSelectedWithChargeBackByDealer()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_CB_ByDealer]";
            //gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSelectedWithChargeBackByOutlet()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_CB_ByOutlet]";
            //gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        //[HttpPost]
        //[SessionExpire]
        //public JsonResult GetPayment1ByMonth()
        //{
        //    DataSet ds = new DataSet();

        //    gSQL = "EXEC [sp_FLT_Payment1_ListByMonth] '{0}'";
        //    gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
        //    ds = odb.SqlQueryDS(gSQL, mDBName);

        //    return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        //}


        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_ListByMonth] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentMonthlyByChassis()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Payment_Monthly_Chassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentMonthlyByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Payment_Monthly_Model] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentMonthlyByDealer()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Payment_Monthly_Dealer] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentMonthlyByOutlet()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_Payment_Monthly_Outlet] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetChargeBack()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["OPERATION_OF"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetAsDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC {0} '{1}',{2}";
            gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["DATA_MONTH"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetRptSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Rpt1_Summary '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["FLEET_NAME"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitFleetAccruePayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_AccruePayment_Submit '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["STATUS"], Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitAccrue()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();

            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_FLT_Accrue_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Fleet";
            var sendEmailFlag = false;

            if (gStatus == "Accrue")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Accrue":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send fleet - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nFleet - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been calculated, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "AccrueApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "M&S Control";
                    // emailCCDepartment = "Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to M&S Control Fleet - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear M&S Control,\n\nUser request you to approve fleet - accrue data as " + Request.Form["DATA_MONTHNAME"] + "."
                                     + "\n\nCurrent month Accrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB"
                                      + "\n\n Charge back Accrue amount: " + ds.Tables["Table"].Rows[0]["CB_AMOUNT"].ToString() + " THB"
                                        + "\n\n Total Accrue amount: " + ds.Tables["Table"].Rows[0]["NET_AMOUNT"].ToString() + " THB";

                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "AccrueReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return fleet - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nFleet - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "MSControlApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by M&S Control Fleet - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nFleet - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by M&S Control , you can check update status to continue process."
                                       + "\n\nCurrent month Accrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB"
                                        + "\n\n Charge back Accrue amount: " + ds.Tables["Table"].Rows[0]["CB_AMOUNT"].ToString() + " THB"
                                        + "\n\n Total Accrue amount: " + ds.Tables["Table"].Rows[0]["NET_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Accrue_FLT_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "ACCRUE", "FLT", "");

                    break;

                // case "MSControlReturn": emailToPosition = "Officer,Assistant Manager,Manager,General Manager";
                case "MSControlReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by M&S Control Fleet - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nFleet - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by M&S Control, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Accrue"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult SelectPayment(string[] CHASSIS)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Payment_Select_Save] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , (CHASSIS != null && CHASSIS.Length > 0) ? string.Join(",", CHASSIS) : ""
                                , "Fleet"
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult CancelSelectPayment(string[] CHASSIS)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Payment_Cancel] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , (CHASSIS != null && CHASSIS.Length > 0) ? string.Join(",", CHASSIS) : ""
                                , "Fleet"
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult UndoCancelledChassis()
        {
            gSQL = "EXEC [sp_Payment_Cancel_Reverse] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , Request.Form["CHASSIS"]
                                , "Fleet"
                                , Request.Form["PAYMENT_TYPE"]);
            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");
        }
        [HttpPost]
        [SessionExpire]
        public ContentResult SelectAllPayment()
        {

            gSQL = "EXEC [sp_Payment_SelectAll_Fleet_Save]";
            // gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult UnSelectAllPayment()
        {

            gSQL = "EXEC [sp_Payment_UnSelectAll_Fleet_Save]";
            // gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult RemoveSelectPayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Payment_Select_Delete '{0}','{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["PAYMENT_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitPayment()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_FLT_Payment_Submit '{0}','{1}',{2},'{3}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , Request.Form["PAYMENT_TYPE"]
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Fleet";
            var sendEmailFlag = false;
            string paymentDetailContent = "";

            if (gStatus == "Payment")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            // set total amount
            string totalAmount = ds.Tables["Table"].Select("DATA_MONTHNAME = 'Total'")[0]["TOTAL_AMOUNT"].ToString();

            var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));
            // string round = ds.Tables[ds.Tables.Count - 1].Rows[0][1].ToString();
            foreach (DataRow row in ds.Tables["Table"].Rows)
            {
                if (row["DATA_MONTHNAME"].ToString() != "Total")
                {
                    paymentDetailContent = paymentDetailContent + "\n" +
                            "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                            "     Payment: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                    (
                        Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                            "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                            "     Net: " + row["NET"].ToString() + " THB\n" : ""
                    );
                }
            }

            paymentDetailContent = paymentDetailContent + "\n" +
                        "Total amount: " + totalAmount + " THB\n";

            switch (gStatus)
            {
                case "Payment":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send fleet - Payment approve as " + dataMonthNames;
                    emailContent = "Dear GM,\n\n" +
                                     "Fleet - Payment data as " + dataMonthNames + "\n" +
                                     ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been sent, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "PaymentApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account Fleet - Payment approve as " + dataMonthNames;
                    emailContent = "Dear Finance Dept,\n\n" +
                                    "Fleet - Payment data as " + dataMonthNames + " has been submited, please kindly check in CIMS system." +
                                     "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "PaymentReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return fleet - Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation,\n\n" +
                                     "Fleet - Payment data as " + dataMonthNames + "\n" +
                                      ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type :" + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account Fleet - Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation & GM,\n\n" +
                                     "Fleet - Payment data as " + dataMonthNames + "\n" +
                                     ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"] + " : " + ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been approved by Finance Dept , you can check update status to continue process."+
                                     "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    //Get SAP data
                    gSQL = "EXEC sp_IF_Payment_FLT_To_New_SAP '{0}','{1}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["PAYMENT_TYPE"]
                                     , Request.Form["ID"]);
                    dt = odb.SqlQuery(gSQL, mDBName);

                    DataService.WriteFileToSAP(dt, "PAYMENT", "FLT", "");

                    break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account Fleet - Payment approve as " + dataMonthNames;
                    emailContent = "Dear Operation & GM,\n\n" +
                                     "Fleet - Payment data as " + dataMonthNames + "\n" +
                                      ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"] +
                                     "\n\nOperation Type : " + Request.Form["PAYMENT_TYPE"] +
                                     "\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Payment"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitChargeBack()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_FLT_Charge_Back_Submit '{0}','{1}',{2},'{3}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , Request.Form["CHARGE_BACK_TYPE"]
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            var sendEmailFlag = false;

            string submitdate = ds.Tables[ds.Tables.Count - 1].Rows[0][0].ToString();
            string round = ds.Tables[ds.Tables.Count - 1].Rows[0][1].ToString();
            switch (gStatus)
            {
                case "ChargeBack":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send fleet - Charge back approve";
                    emailContent = "Dear GM,\n\n" +
                                     "Fleet - Charge back data\n" +
                                     submitdate + " : " + round + "\n" +
                                     "Operation Type : " + gStatus + "\n" +
                                     "It has been sent, please kindly access to CIMS system to approve.";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "ChargeBackApprove":
                    // emailToPosition = "Officer";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to fleet operation - Charge back approve";
                    emailContent = "Dear Operation Dept,\n\nFleet - Charge back data has been approved.";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "ChargeBackReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return fleet - Charge back approve ";
                    emailContent = "Dear Operation,\n\n" +
                                     "Fleet - Charge back data \n" +
                                      submitdate + " : " + round + "\n" +
                                     "It has been returned by GM, please check, revise and re-submit in CIMS system.";
                    // emailToSpecific = ds.Tables["Table"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision("Fleet"
                                        , "Chargeback"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetReconcile()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_FLT_Reconcile_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitRecon()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_FLT_Reconcile_Submit '{0}', '{1}', '{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], gStatus, Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Fleet";
            var sendEmailFlag = false;

            if (gStatus == "Reconcile")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Reconcile":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send fleet - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nFleet - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been submited, please kindly approve in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                    break;

                case "ReconcileApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account Fleet - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Account Dept,\n\nFleet - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been submited, please kindly check in CIMS system."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                    break;
                case "ReconcileReturn":
                    // emailToPosition = null;
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return fleet - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nFleet - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "GM-Return";
                    break;

                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account Fleet - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nFleet - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by Account, you can check update status to continue process."
                                     + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";

                    gSQL = "EXEC sp_IF_Reconcile_FLT_To_New_SAP '{0}'";
                    gSQL = String.Format(gSQL
                                     , Request.Form["DATA_MONTH"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                    DataService.WriteFileToSAP(dt, "RECONCILE", "FLT", "");

                    break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account Fleet - Reconcile approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nFleet - Reconcile data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by Account, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                    sendEmailFlag = true;
                    emailStep = "Approved";
                    break;

                default: break;
            }

            if (sendEmailFlag)
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Reconcile"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        #endregion

        [SessionExpire]
        [HttpPost]
        public JsonResult GetAccruePaymentStatus()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_D5_STATUS] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }



        [SessionExpire]
        [HttpPost]
        public JsonResult GetAccruePaymentRemain()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_D6_Remain] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        [HttpPost]
        public JsonResult GetDealerPaidStatus()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_S7_Dealer_Status] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetDealerDocStatus()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_FLT_S8_Dealer_Doc_Status] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSubmitByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_Submit_ListByModel] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentWithChargeBack()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Payment_With_ChargeBack_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetPaymentSubmitDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Payment_Submit_List '{0}',{1}";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_ID"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            // return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        #region Fleet Check Upload
        [HttpPost]
        public JsonResult GetFleetWaitingForUpload()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Check_Waiting_Upload '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        public JsonResult GetFleetExpiredForUpload()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Check_Expired_Upload '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        public JsonResult GetFleetIncompleteForUpload()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Check_Incompleted_Upload '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        //[HttpPost]
        //public JsonResult GetFleetChargeBack()
        //{
        //    DataTable dt = new DataTable();

        //    gSQL = "EXEC [sp_FLT_Charge_Back_List]";
        //    dt = odb.SqlQuery(gSQL, mDBName);

        //    return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        //}

        [HttpPost]
        public JsonResult GetFleetUploaded()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Check_Uploaded '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetFleetCompleteForUpload()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC sp_FLT_Check_Completed_Upload '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        public JsonResult GetChargeBackSubmitDetail()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_Submit_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetChargeBackSelectedPaymentByChassis()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_Selected_Payment_ByChassis]";
            // gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetChargeBackSelectedPaymentByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_Selected_Payment_ByModel]";
            // gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetChargeBackSelectedPaymentByDealer()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_Selected_Payment_ByDealer]";
            // gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetChargeBackSelectedPaymentByOutlet()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Charge_Back_Selected_Payment_ByOutlet]";
            // gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        #endregion

        #region Fleet Bulletin master

        [SessionExpire]
        [HttpGet]
        public JsonResult GetBulletinList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_FLT_Bulletin_List";
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetBulletinByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_FLT_Bulletin_ByID '{0}'", id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveBulletin()
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC sp_FLT_Bulletin_Save '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}'"
                                , Request.Form["ID"]
                                , Request.Form["BULLETIN_TYPE"]
                                , Request.Form["BULLETIN_NAME"]
                                , DataService.DateValidation(Request.Form["BULLETIN_DATE"])
                                , Request.Form["BULLETIN_DETAIL"]
                                , DataService.DateValidation(Request.Form["EFFECTIVE_DATE"])
                                , DataService.DateValidation(Request.Form["EXPIRE_DATE"])
                                , Request.Form["BULLETIN_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        #endregion

        #region Fleet Condition

        [HttpPost]
        public JsonResult UploadFleetCondition(HttpPostedFileBase File, string year, string month, string dataType, string condition, int conditionTypeID)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Fleet/Condition/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_Condition_Import] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}'"
                                    , year
                                    , month
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , dataType
                                    , conditionTypeID
                                    , condition
                                    , ""
                                    , 0
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        public JsonResult GetConditionList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_INC_Condition_Upload_List] '{0}','{1}','FLT'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DATA_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        #endregion


        #region Fleet Main

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_FLT_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        #endregion


        [SessionExpire]
        [HttpPost]
        public ContentResult UpdateCampaignGenRateAmount()
        {

            gSQL = String.Format("EXEC [sp_PRC_FLT_Get_Gen_Rate] '{0}'"
                                , Request.Form["PERIOD_ID"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }
    }
}
