﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace SMGO.Controllers
{
    public class IncentiveDsController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRSVolumeListDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_Volume] '{0}','{1}','{2}','RS','{3}'";
            gSQL = String.Format(gSQL
                    , Request.Form["DATA_YEAR"]
                    , Request.Form["DATA_MONTH"]
                    , Request.Form["DEALER_CODE"]
                    , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSPVolumeListDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_Volume] '{0}','{1}','{2}','{3}','{4}'";
            gSQL = String.Format(gSQL
                    , Request.Form["DATA_YEAR"]
                    , Request.Form["DATA_MONTH"]
                    , Request.Form["DEALER_CODE"]
                    , Request.Form["INCENTIVE_TYPE"]
                    , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveRSVolumeConfig()
        {
            gSQL = "EXEC [sp_INC_Volume_Update] '{0}','{1}','{2}',{3},{4},{5},{6},{7},{8},{9},{10},{11},{12}";
            gSQL = string.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["PERCENT_50"]
                                , Request.Form["PERCENT_60"]
                                , Request.Form["PERCENT_70"]
                                , Request.Form["PERCENT_80"]
                                , Request.Form["PERCENT_90"]
                                , Request.Form["PERCENT_100"]
                                , Request.Form["PERCENT_110"]
                                , Request.Form["PERCENT_120"]
                                , Request.Form["PERCENT_130"]
                                , Request.Form["PERCENT_140"]
                                , Request.Form["PERCENT_150"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            odb.SqlExecute (gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveSPVolumeConfig()
        {           
            gSQL = "EXEC [sp_INC_Volume_Update] '{0}','{1}','{2}',{3},{4},{5},{6},{7},{8},{9},{10},{11},{12}";
            gSQL = string.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["PERCENT_50"]
                                , Request.Form["PERCENT_60"]
                                , Request.Form["PERCENT_70"]
                                , Request.Form["PERCENT_80"]
                                , Request.Form["PERCENT_90"]
                                , Request.Form["PERCENT_100"]
                                , Request.Form["PERCENT_110"]
                                , Request.Form["PERCENT_120"]
                                , Request.Form["PERCENT_130"]
                                , Request.Form["PERCENT_140"]
                                , Request.Form["PERCENT_150"]
                                , Session[Cons.SS_USER_ID].ToString()
                                );

            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        #region Incentive Period

        [SessionExpire]
        public JsonResult GetRsPercentList(string fy)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_PercentMonthly_List] '{0}', 'RS'";

            gSQL = String.Format(gSQL, fy);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetRsPercentMonthly(string year,string month)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_PercentMonthly] '{0}','{1}','RS'";

            gSQL = String.Format(gSQL, year, month);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetSpPercentMonthly(string year, string month)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_PercentMonthly] '{0}','{1}','SP'";

            gSQL = String.Format(gSQL, year, month);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetSpPercentMonthlyByID(string year, string month,string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_PercentMonthly_ByID] '{0}','{1}','{2}'";

            gSQL = String.Format(gSQL, year, month, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveChangeIncentivePercent()
        {
            gSQL = "EXEC [sp_INC_CFG_PercentMonthly_Save] '{0}','{1}','{2}','RS','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]
                                , Request.Form["FY"]
                                , Request.Form["PERCENT_50"]
                                , Request.Form["PERCENT_60"]
                                , Request.Form["PERCENT_70"]
                                , Request.Form["PERCENT_80"]
                                , Request.Form["PERCENT_90"]
                                , Request.Form["PERCENT_100"]
                                , Request.Form["PERCENT_110"]
                                , Request.Form["PERCENT_120"]
                                , Request.Form["PERCENT_130"]
                                , Request.Form["PERCENT_140"]
                                , Request.Form["PERCENT_150"]
                                , Request.Form["ID"]
                                );
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult SaveChangeIncentiveDetail()
        {
            gSQL = "EXEC [sp_INC_Model_Percent_Save] '{0}','SP','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["PERCENT_50"]
                                , Request.Form["PERCENT_60"]
                                , Request.Form["PERCENT_70"]
                                , Request.Form["PERCENT_80"]
                                , Request.Form["PERCENT_90"]
                                , Request.Form["PERCENT_100"]
                                , Request.Form["PERCENT_110"]
                                , Request.Form["PERCENT_120"]
                                , Request.Form["PERCENT_130"]
                                , Request.Form["PERCENT_140"]
                                , Request.Form["PERCENT_150"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        #endregion

        #region SP Incentive Period

        public JsonResult GetSPPercentList(string fy, string y, string m)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_SP_PercentMonthly_List] '{0}', '{1}', '{2}'";

            gSQL = String.Format(gSQL, fy, y, m);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public ContentResult SaveChangeSPIncentivePercent()
        {
            gSQL = "EXEC [sp_INC_CFG_PercentMonthly_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]
                                , Request.Form["FY"]
                                , Request.Form["INCENTIVE_TYPE"]
                                , Request.Form["PERCENT_50"]
                                , Request.Form["PERCENT_60"]
                                , Request.Form["PERCENT_70"]
                                , Request.Form["PERCENT_80"]
                                , Request.Form["PERCENT_90"]
                                , Request.Form["PERCENT_100"]
                                , Request.Form["PERCENT_110"]
                                , Request.Form["PERCENT_120"]
                                , Request.Form["PERCENT_130"]
                                , Request.Form["PERCENT_140"]
                                , Request.Form["PERCENT_150"]
                                , Request.Form["ID"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }
        #endregion

        #region Incentive Model Group

        [SessionExpire]
        public JsonResult GetIncentiveModelSelectedList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_ModelList_ByID '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetIncentiveModelNotSelectedList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_ModelList_ByNotSelected '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult CheckIncentiveModel(string ID, string INC_MODEL_NO, string INC_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_Model_Check '{0}','RS','{1}','{2}','{3}','{4}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["FY"]
                                , Request.Form["YEAR"]
                                , Request.Form["MONTH"]
                                , Request.Form["INC_MODEL_NO"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult SaveIncentiveModel(string ID, string INC_MODEL_NO, string INC_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_Model_Save '{0}','RS','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}','{17}','{18}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["FY"]
                                , Request.Form["YEAR"]
                                , Request.Form["MONTH"]
                                , Request.Form["INC_MODEL_NO"]
                                , Request.Form["INC_MODEL_NAME"]
                                  , Request.Form["PERCENT_50"]
                                    , Request.Form["PERCENT_60"]
                                    , Request.Form["PERCENT_70"]
                                    , Request.Form["PERCENT_80"]
                                    , Request.Form["PERCENT_90"]
                                    , Request.Form["PERCENT_100"]
                                    , Request.Form["PERCENT_110"]
                                    , Request.Form["PERCENT_120"]
                                    , Request.Form["PERCENT_130"]
                                    , Request.Form["PERCENT_140"]
                                    , Request.Form["PERCENT_150"]
                                , Session[Cons.SS_USER_ID].ToString()
                                , (ModelID != null && ModelID.Length > 0) ? string.Join(",", ModelID) : ""
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult SaveSPIncentiveModel(string ID, string INC_MODEL_NO, string INC_MODEL_NAME, string REMARKS, string[] ModelID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_Model_Save '{0}','SP','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}','{17}','{18}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["FY"]
                                , Request.Form["YEAR"]
                                , Request.Form["MONTH"]
                                , Request.Form["INC_MODEL_NO"]
                                , Request.Form["INC_MODEL_NAME"]
                                , Request.Form["PERCENT_50"]
                                    , Request.Form["PERCENT_60"]
                                    , Request.Form["PERCENT_70"]
                                    , Request.Form["PERCENT_80"]
                                    , Request.Form["PERCENT_90"]
                                    , Request.Form["PERCENT_100"]
                                    , Request.Form["PERCENT_110"]
                                    , Request.Form["PERCENT_120"]
                                    , Request.Form["PERCENT_130"]
                                    , Request.Form["PERCENT_140"]
                                    , Request.Form["PERCENT_150"]
                                , Session[Cons.SS_USER_ID].ToString()
                                , (ModelID != null && ModelID.Length > 0) ? string.Join(",", ModelID) : ""
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        [HttpPost]
        public ContentResult DeleteIncentiveGroup()
        {

            if(Request.Form["ID"] != "0")
            {
                gSQL = "EXEC sp_INC_Model_Delete {0}, '{1}'";
                gSQL = String.Format(gSQL
                                    , Request.Form["ID"]
                                    , Session[Cons.SS_USER_ID].ToString());
                odb.SqlExecute(gSQL, mDBName);
            }

            return Content("Done");

        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult GetModelGroupList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_ModelGroup_List] '{0}', '{1}','RS'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpModelGroupList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_ModelGroup_List] '{0}', '{1}','SP'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        
        [SessionExpire]
        [HttpPost]
        public ContentResult SaveModelGroup()
        {
            if(Request.Form["ID"] != null)
            {
                gSQL = "EXEC [sp_INC_ModelGroup_Save] {0}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, {8}, {9}, {10}, {11}, '{12}'";
                gSQL = String.Format(gSQL
                                    , Request.Form["ID"]
                                    , Request.Form["PERCENT_50"]
                                    , Request.Form["PERCENT_60"]
                                    , Request.Form["PERCENT_70"]
                                    , Request.Form["PERCENT_80"]
                                    , Request.Form["PERCENT_90"]
                                    , Request.Form["PERCENT_100"]
                                    , Request.Form["PERCENT_110"]
                                    , Request.Form["PERCENT_120"]
                                    , Request.Form["PERCENT_130"]
                                    , Request.Form["PERCENT_140"]
                                    , Request.Form["PERCENT_150"]
                                    , Session[Cons.SS_USER_ID].ToString());
                odb.SqlExecute(gSQL, mDBName);
            }

            return Content("Done");
        }


        [SessionExpire]     
        
        public JsonResult GetIncentiveModelByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_Model_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion

        #region Incentive Summary

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRSVolumeSummary()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_RS_Volume_SummaryByDealer '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsModelPay()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_RS_Volume_ByModel] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DEALER_ID"], Request.Form["PERCENT_GET"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpVolumeSummary()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_SP_Volume_SummaryByDealer '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpModelPay()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_INC_SP_Volume_ByDealer] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DEALER_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsModelChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_RS_Chassis_ByModel] '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL
                                ,Request.Form["DATA_MONTH"]
                                ,Request.Form["DEALER_ID"]
                                ,Request.Form["INC_MODEL_ID"]
                                ,Request.Form["GET_AMOUNT"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetSPModelChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SP_Chassis_ByModel] '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL
                                ,Request.Form["DATA_MONTH"]
                                ,Request.Form["DEALER_ID"]
                                ,Request.Form["INC_MODEL_ID"]
                                ,Request.Form["GET_AMOUNT"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult GetScChassisByDealerIncName()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SC_Chassis_ByDealerIncName] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]
                                , Request.Form["DEALER_ID"]
                                , Request.Form["INC_NAME"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetScChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SC_Chassis_ByScID] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]
                                , Request.Form["DEALER_ID"]
                                , Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public ContentResult SaveRsModelChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_RS_Chassis_Save] '{0}','{1}','{2}','{3}','{4}','{5}'";
            gSQL = String.Format(gSQL
                                ,Request.Form["DATA_MONTH"]
                                ,Request.Form["CHASSIS_NO"]
                                ,Request.Form["INC_COUNT"]
                                ,Request.Form["INC_PAY"]
                                ,Request.Form["RS_AMOUNT"]
                                ,Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public ContentResult SaveSPModelChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SP_Chassis_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}'";
            gSQL = String.Format(gSQL
                                ,Request.Form["DATA_MONTH"]
                                ,Request.Form["CHASSIS_NO"]
                                ,Request.Form["SP_COUNT"]
                                ,Request.Form["SP_PAY"]
                                ,Request.Form["SP_AMOUNT"]
                                ,Request.Form["SP_ID"]
                                ,Request.Form["SP_NO"]
                                ,Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        #endregion

        #region SP Model Config 

        [HttpPost]
        public JsonResult GetSpModelConfig()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_ModelGroup_List] '{0}', '{1}','SP'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public JsonResult GetSpecificModelList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_SP_SpecificModel_List '{0}', '{1}'";
            gSQL = String.Format(gSQL, Request.Form["CFG_YEAR"]
                                , Request.Form["CFG_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion

        #region Special Configuration

        [HttpPost]
        public JsonResult GetSpecialMonthly()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_SC_Monthly_List '{0}', '{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetSpecial()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_SC_Monthly_ListByID '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public ContentResult SaveSpecialConfig()
        {
            gSQL = "EXEC [dbo].[sp_INC_SC_Monthly_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}','{6}','{7}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["CFG_YEAR"]
                                , Request.Form["CFG_MONTH"]
                                , Request.Form["SNO"]
                                , Request.Form["INC_NAME"]
                                , Request.Form["INC_AMOUNT"]
                                , Request.Form["REMARKS"]
                                , Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");

        }

        [HttpPost]
        public ContentResult SaveSpecialGroup(string[] Chassis)
        {
            gSQL = "EXEC [dbo].[sp_TRN_Incentive_Upd_Chassis] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}'";
            gSQL = String.Format(gSQL
                                , Request.Form["SC1_ID"]
                                , Request.Form["SC2_ID"]
                                , Request.Form["SC3_ID"]
                                , Request.Form["SC4_ID"]
                                , Request.Form["SC5_ID"]
                                , Request.Form["SC6_ID"]
                                , Request.Form["SC7_ID"]
                                , Request.Form["SC8_ID"]
                                , Request.Form["SC9_ID"]
                                , Request.Form["SC10_ID"]
                                , Request.Form["SC11_ID"]
                                , Request.Form["SC12_ID"]
                                , (Chassis != null && Chassis.Length > 0) ? "''"+string.Join("'',''", Chassis)+"''" : ""
                                , Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");

        }

        [HttpPost]
        public JsonResult GetSpecialList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_RS_Volume_SummaryByChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetUploadedSpecialList()
        {
            DataTable dt= new DataTable();

            gSQL = "EXEC [sp_INC_SC_UploadedChassis] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["SCID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        public JsonResult GetModelListBySubModel(string BASE_MODEL, string SUB_MODEL)
        {
            DataTable dt= new DataTable();

            gSQL = "EXEC [sp_STD_GetModel_BySubModel] '{0}', '{1}'";
            gSQL = String.Format(gSQL, Request.Form["BASE_MODEL"], Request.Form["SUB_MODEL"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        #endregion

        #region Specific type Configuration

        [HttpPost]
        public JsonResult GetSpecificType()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SP_Type_List] '{0}', '{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetSpecific()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SP_Type_ListByID] '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                );
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public ContentResult SaveSpecificType()
        {
            gSQL = "EXEC [dbo].[sp_INC_SP_Type_Save] '{0}','{1}', '{2}', '{3}', '{4}','{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["CFG_YEAR"]
                                , Request.Form["CFG_MONTH"]
                                , Request.Form["INC_MODEL_NAME"]
                                , Request.Form["SP_TYPE"]
                                , Session[Cons.SS_USER_ID].ToString());

            odb.SqlExecute(gSQL, mDBName);
            return Content("Done");

        }
		
		  [HttpPost]
        public JsonResult GetIncentiveRptSummary()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_Rpt1_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        #endregion

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadRSVolumeConfig(HttpPostedFileBase File, string fy)
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Incentive/RSVolumeConfig/" + fy + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_RS_Volume_Import] {0},'{1}','{2}'"
                                    , fy
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }


        [SessionExpire]
        [HttpPost]
        public JsonResult Upload2MVolumeConfig(HttpPostedFileBase File, string year, string month, string incType)
        {

            if (File != null && File.ContentLength > 0)
            {

                month = "0" + month;
                month = month.Substring(month.Length - 2);

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Incentive/2MVolumeConfig/" + year + month + "/" + incType + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_2M_Volume_Import] {0},'{1}','{2}','{3}','{4}'"
                                    , year
                                    , month
                                    , incType
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadSPVolumeConfig(HttpPostedFileBase File, string year, string month, string incType)
        {

            if (File != null && File.ContentLength > 0)
            {

                month = "0" + month;
                month = month.Substring(month.Length-2);

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Incentive/SPVolumeConfig/" + year + month + "/" + incType + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_SP_Volume_Import] {0},'{1}','{2}','{3}','{4}'"
                                    , year
                                    , month
                                    , incType
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = "Done" });

            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        #region Incentive Accrue Payment
         

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_INC_Accrue_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetAccrueByMonth()
        {
            DataSet ds = new DataSet();
            gSQL = "EXEC sp_INC_Accrue_ListByMonth '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);
            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveAccrueStatus()
        {
            DataSet ds = new DataSet();

            gSQL = " EXEC [sp_ACC_Accrue_Status] 'Incentive' ";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        

        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentByMonth()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_INC_Payment_ListByMonth '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveSelectedPayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_INCR_Selected_Payment '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentivePayment()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_INCR_Payment_List '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["ID"], Request.Form["PAYMENT_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentivePaymentStatus()
        {
            DataSet ds = new DataSet();

            gSQL = " EXEC [sp_ACC_Payment_Status] 'Incentive' ,null "; 
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult UpdateTransaction()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INCR_Convert_Transaction] '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetNotPaymentList()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_INCR_Payment_Non_List] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["PAYMENT_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [Serializable]
        public class ChassisSelectedList
        {
            public string CHASSIS_NO { get; set; }
            public string PAYMENT_TYPE { get; set; }
            public string ID { get; set; }
        }
        
        [HttpPost]
        [SessionExpire]
        public ContentResult SelectPayment (ChassisSelectedList[] oChassis)
        {
            DataTable dt = new DataTable();

            foreach (var item in oChassis)
            {
                gSQL = "EXEC [sp_INC_Payment_Select_Save] '{0}','{1}','{2}'";
                gSQL = String.Format(gSQL
                                    , item.CHASSIS_NO
                                    , item.PAYMENT_TYPE
                                    , item.ID);
                dt = odb.SqlQuery(gSQL, mDBName);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult RemoveSelectPayment (ChassisSelectedList[] oChassis)
        {
            DataTable dt = new DataTable();

            foreach(var item in oChassis) 
            {
                gSQL = "EXEC [sp_INC_Payment_Select_Delete] '{0}','{1}','{2}'";
                gSQL = String.Format(gSQL
                                    , item.CHASSIS_NO
                                    , item.PAYMENT_TYPE
                                    , item.ID);
                dt = odb.SqlQuery(gSQL, mDBName);
            }

            return Content("Done");
        }
        
        [HttpPost]
        [SessionExpire]
        public ContentResult SelectAllPayment()
        {
            gSQL = "EXEC [sp_Payment_SelectAll_Incentive_Save] '{0}','{1}',{2}";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]
                                , Request.Form["PAYMENT_TYPE"]
                                , (Request.Form["ID"] == "") ? "null" : Request.Form["ID"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }
        
        [HttpPost]
        [SessionExpire]
        public ContentResult RemoveAllPayment()
        {
            gSQL = "EXEC [sp_Payment_UnSelectAll_Incentive_Save] '{0}',{1}";
            gSQL = String.Format(gSQL
                                , Request.Form["PAYMENT_TYPE"]
                                , (Request.Form["ID"] == "") ? "null" : Request.Form["ID"]);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveReconcile()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_INC_Reconcile_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveReconStatus()
        {
            DataSet ds = new DataSet();

            gSQL = " EXEC [sp_ACC_Reconcile_Status] 'Incentive' ";
            gSQL = String.Format(gSQL);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetAsDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC {0} '{1}',{2}";
            gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["DATA_MONTH"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }


        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitAccrue()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_INC_Accrue_Submit '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                            , Request.Form["DATA_MONTH"]
                            , gStatus
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);
            
            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Incentive";
            var sendEmailFlag = false;

            if (gStatus == "Accrue")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Accrue":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send incentive - Accrue approve as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear GM,\n\nIncentive - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been calculated, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                               break;

                case "AccrueApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "M&S Control";
                    // emailCCDepartment = "Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to M&S Control Incentive - Accrueapprove as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear M&S Control,\n\nUser request you to approve incentive - accrue data as " + Request.Form["DATA_MONTHNAME"] + "."
                                                + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                               break;
                case "AccrueReturn":
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return incentive - Accrueapprove as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation,\n\nIncentive - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "GM-Return";
                               break;

                case "MSControlApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by M&S Control Incentive - Accrueapprove as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nIncentive - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been approved by M&S Control , you can check update status to continue process."
                                                + "\n\nAccrue amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "Approved";
                    gSQL = "EXEC sp_IF_Accrue_INC_To_New_SAP '{0}'";
                               gSQL = String.Format(gSQL
                                                , Request.Form["DATA_MONTH"]);
                               dt = odb.SqlQuery(gSQL, mDBName);
                                DataService.WriteFileToSAP(dt, "ACCRUE", "INC", "");

                               break;

                case "MSControlReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by M&S Control Incentive - Accrueapprove as " + Request.Form["DATA_MONTHNAME"];
                    emailContent = "Dear Operation & GM,\n\nIncentive - accrue data as " + Request.Form["DATA_MONTHNAME"] + " has been returned by M&S Control, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "Approved";
                               break;

                default: break;
            }
            
            if(sendEmailFlag) 
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Accrue"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitPayment ()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC [sp_INCR_Payment_Submit] '{0}', {1},'{2}'";
            gSQL = String.Format(gSQL
                            , gStatus
                            , (Request.Form["ID"] != "") ? Request.Form["ID"] : "null"
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);
            
            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Incentive";
            var sendEmailFlag = false;
            string paymentDetailContent = "";

            if (gStatus == "Payment")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            // set total amount
            string totalAmount = ds.Tables["Table"].Select("DATA_MONTHNAME = 'Total'")[0]["TOTAL_AMOUNT"].ToString();

            // string submitdate = ds.Tables[ds.Tables.Count - 1].Rows[0][0].ToString();
            var dataMonthNames = string.Join(", ", ds.Tables["Table"].Rows.OfType<DataRow>().Select(r => r["DATA_MONTHNAME"].ToString()));
            
            foreach (DataRow row in ds.Tables["Table"].Rows)
            {
                if (row["DATA_MONTHNAME"].ToString() != "Total")
                {
                    paymentDetailContent = paymentDetailContent + "\n" +
                            "  - " + row["DATA_MONTHNAME"].ToString() + "\n" +
                            "     Payment: " + row["TOTAL_AMOUNT"].ToString() + " THB\n" +
                    (
                        Int32.Parse(row["TOTAL_CB_AMOUNT"].ToString(), NumberStyles.AllowThousands | NumberStyles.AllowDecimalPoint) > 0 ?
                            "     Charge back: " + row["TOTAL_CB_AMOUNT"].ToString() + " THB\n" +
                            "     Net: " + row["NET"].ToString() + " THB\n" : ""
                    );
                }
            }

            paymentDetailContent = paymentDetailContent + "\n" +
                        "Total amount: " + totalAmount + " THB\n";
            switch (gStatus)
            {
                case "Payment":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send incentive - Payment approve as " + dataMonthNames;
                               emailContent = "Dear GM,\n\n"+
                                "Incentive - Payment data as " + dataMonthNames +"\n"+
                                ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"]+
                                "\nIt has been sent, please kindly access to CIMS system to approve.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                               break;

                case "PaymentApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Send to Account Incentive - Payment approve as " + dataMonthNames;
                    emailContent = "Dear Finance Dept,\n\nIncentive - Payment data as " + dataMonthNames +" has been submited, please kindly check in CIMS system."
                                    + "\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                               break;
                case "PaymentReturn":
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return incentive - Payment approve as " + dataMonthNames;
                               emailContent = "Dear Operation,\n\n"+
                                    "Incentive - Payment data as " + dataMonthNames +"\n"+
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"]+
                                    "\nIt has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "GM-Return";
                               break;

                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Approved by Account Incentive - Payment approve as " + dataMonthNames;
                               emailContent = "Dear Operation & GM,\n\n"+
                                    "Incentive - Payment data as " + dataMonthNames +"\n"+
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"]+
                                    "\nIt has been approved by Finance Dept , you can check update status to continue process."
                                    +"\n\nPayment detail" + paymentDetailContent;
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "Approved";
                               //Get SAP data
                    gSQL = "EXEC sp_IF_Payment_INC_To_New_SAP '{0}'";
                               gSQL = String.Format(gSQL
                                                , Request.Form["ID"]);
                               dt = odb.SqlQuery(gSQL, mDBName);

                                DataService.WriteFileToSAP(dt, "PAYMENT", "INC", "");

                               break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                    emailTitle = "CIMS : Return by Account Incentive - Payment approve as " + dataMonthNames;
                               emailContent = "Dear Operation & GM,\n\n"+
                                    "Incentive - Paymentvdata as " + dataMonthNames +"\n"+
                                    ds.Tables["Table2"].Rows[0]["SUBMIT_PAYMENT_DATE"]+" : "+ds.Tables["Table2"].Rows[0]["ROUND_NO"]+
                                    "\nIt has been returned by Finance Dept, please check, revise and re-submit data in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                               sendEmailFlag = true;
                    emailStep = "Approved";
                               break;

                default: break;
            }
            
            if(sendEmailFlag) 
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Payment"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }


        [HttpPost]
        [SessionExpire]
        public JsonResult GetPaymentSubmitByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_Payment_Submit_ListByModel] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["PAYMENT_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetPaymentSubmitDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC {0} '{1}',{2}";
            gSQL = String.Format(gSQL, Request.Form["SP_NAME"], Request.Form["PAYMENT_ID"], Request.Form["REPORT_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

           // return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public ContentResult SubmitReconcile()
        {
            DataTable dt = new DataTable();
            DataSet ds = new DataSet();
            string gStatus = Request.Form["STATUS"];

            gSQL = "EXEC sp_INC_Reconcile_Submit '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL
                            , Request.Form["DATA_MONTH"]
                            , gStatus
                            , Session[Cons.SS_USER_ID].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);
            
            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            string vmeType = "Incentive";
            var sendEmailFlag = false;

            if (gStatus == "Reconcile")
            {
                if (ds.Tables["Table"].Columns.Contains("RESULT")
                    && ds.Tables["Table"].Rows[0]["RESULT"].ToString() == "FAILED")
                {
                    oVME.sendEmailInterfaceError();
                    return Content("Interface layout error.");
                }
            }

            switch (gStatus)
            {
                case "Reconcile":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                                emailTitle = "CIMS : Send incentive - Reconcile approve as "+Request.Form["DATA_MONTHNAME"];
                                emailContent = "Dear GM,\n\nIncentive - Reconcile data as "+Request.Form["DATA_MONTHNAME"]+" has been submited, please kindly approve in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                                break;

                case "ReconcileApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = "Accounting & Financial";
                    // emailCCDepartment = "M&S Control";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                                emailTitle = "CIMS : Send to Account Incentive - Reconcile approve as "+Request.Form["DATA_MONTHNAME"];
                                emailContent = "Dear Account Dept,\n\nIncentive - Reconcile data as "+Request.Form["DATA_MONTHNAME"]+" has been submited, please kindly check in CIMS system."
                                                + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    sendEmailFlag = true;
                    emailStep = "GM";
                                break;
                case "ReconcileReturn":
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                                emailTitle = "CIMS : Return Incentive - Reconcile approve as "+Request.Form["DATA_MONTHNAME"];
                                emailContent = "Dear Operation,\n\nIncentive - Reconcile data as "+Request.Form["DATA_MONTHNAME"]+" has been returned by GM, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                                sendEmailFlag = true;
                    emailStep = "GM-Return";
                                break;

                case "AccountApprove":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                                emailTitle = "CIMS : Approved by Account Incentive - Reconcile approve as "+ Request.Form["DATA_MONTHNAME"];
                                emailContent = "Dear Operation & GM,\n\nIncentive - Reconcile data as "+ Request.Form["DATA_MONTHNAME"] +" has been approved by Account, you can check update status to continue process."
                                                + "\n\nReconcile amount: " + ds.Tables["Table"].Rows[0]["TOTAL_AMOUNT"].ToString() + " THB";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                                sendEmailFlag = true;
                    emailStep = "Approved";
                    gSQL = "EXEC sp_IF_Reconcile_INC_To_New_SAP '{0}'";
                                gSQL = String.Format(gSQL
                                                    , Request.Form["DATA_MONTH"]);
                                dt = odb.SqlQuery(gSQL, mDBName);
                                DataService.WriteFileToSAP(dt, "RECONCILE", "INC", "");

                                break;
                case "AccountReturn":
                    // emailToPosition = "Officer,Manager,Assistant Manager,General Manager";
                    // emailToMyManagerRole = null;
                    // emailToDepartment = null;
                    // emailCCDepartment = "M&S Control,Accounting & Financial";
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                                emailTitle = "CIMS : Return by Account Incentive - Reconcile approve as "+Request.Form["DATA_MONTHNAME"];
                                emailContent = "Dear Operation & GM,\n\nIncentive - Reconcile data as "+Request.Form["DATA_MONTHNAME"]+" has been returned by Account, please check, revise and re-submit in CIMS system.";
                    emailContent = emailContent + "\n\n You can access CIMS from : " + Cons.SERVER_IP;
                    emailContent = emailContent + "\n\n \n\n Thank you & best regards,";
                    emailContent = emailContent + "\n\n CIMS system admin";
                    // emailToSpecific = ds.Tables["Table1"].Rows[0]["REPLY_CONTACTS"].ToString();
                                sendEmailFlag = true;
                    emailStep = "Approved";
                                break;

                default: break;
            }
            
            if(sendEmailFlag) 
            {
                string returnStr = oVME.SendEmailToRevision(vmeType
                                        , "Reconcile"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        
        // [HttpPost]
        // [SessionExpire]
        // public ContentResult SelectPayment (string[] DEALER_CODE)
        // {
        //     DataTable dt = new DataTable();

        //     gSQL = "EXEC [sp_Payment_Dealer_Select_Save] '{0}','{1}',null";
        //     gSQL = String.Format(gSQL
        //                         , (DEALER_CODE != null && DEALER_CODE.Length > 0) ? string.Join(",", DEALER_CODE) : ""
        //                         ,"Incentive");
        //     dt = odb.SqlQuery(gSQL, mDBName);

        //     return Content("Done");
        // }

        // [HttpPost]
        // [SessionExpire]
        // public ContentResult RemoveSelectPayment ()
        // {
        //     DataTable dt = new DataTable();

        //     gSQL = "EXEC sp_INC_Payment_Select_Delete '{0}'";
        //     gSQL = String.Format(gSQL
        //                         , Request.Form["DEALER_CODE"]);
        //     dt = odb.SqlQuery(gSQL, mDBName);

        //     return Content("Done");
        // }

        #endregion

        #region special summary

        [HttpPost]
        public JsonResult GetSCVolumeSummary()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_SC_Volume_SummaryByDealer '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        
        [HttpPost]
        public JsonResult GetSCModelPay()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_SC_Volume_SummaryByModel] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DEALER_ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        #endregion


        #region Approve submit



        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncConfigApprove()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_ConfigApprove_List '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            // ds.Tables.Add(dt);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SubmitIncConfigApprove()
        {
            string gStatus = Request.Form["TYPE"];

            gSQL = "EXEC sp_INC_Config_Submit '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL,
                                Request.Form["ID"],
                                gStatus,
                                Session[Cons.SS_USER_ID].ToString());
            odb.SqlExecute(gSQL, mDBName);
            
            //Send email
            // string emailToPosition = null;
            // string emailToMyManagerRole = null;
            // string emailToDepartment = null;
            // string emailCC = null;
            // string emailCCDepartment = null;
            string emailTitle = null;
            string emailContent = null;
            string emailStep = null;
            var sendEmailFlag = false;

            switch (gStatus)
            {
                case "Approved":
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                               emailTitle = "CIMS : Approved incentive configuration - " + Request.Form["INCENTIVE_TYPE_NAME"];
                               emailContent = "Dear Operation,\n\nIncentive configuration as " + Request.Form["INCENTIVE_TYPE_NAME"] + " has been approved by GM, you can check update status to continue process.";
                    sendEmailFlag = true;
                    emailStep = "GM";
                               break;

                case "Return":
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                               emailTitle = "CIMS : Return incentive configuration - " + Request.Form["INCENTIVE_TYPE_NAME"];
                               emailContent = "Dear Operation,\n\nIncentive configuration as " + Request.Form["INCENTIVE_TYPE_NAME"] + " has been returned by GM, please check, revise and re-submit in CIMS system.";
                    sendEmailFlag = true;
                    emailStep = "GM";
                               break;

                case "Sent":
                    // emailToPosition = "Assistant Manager,Manager,General Manager";
                    // emailToMyManagerRole = Session[Cons.SS_USER_ROLE_PARENT].ToString();
                    // emailToDepartment = null;
                    // emailCC = Session[Cons.SS_USER_EMAIL].ToString();
                               emailTitle = "CIMS : Send incentive configuration - " + Request.Form["INCENTIVE_TYPE_NAME"];
                               emailContent = "Dear GM,\n\nIncentive configuration as " + Request.Form["INCENTIVE_TYPE_NAME"] + " has been set, please kindly access to CIMS system to approve.";
                    sendEmailFlag = true;
                    emailStep = "Submit";
                               break;

                default: break;
            }
            
            if(sendEmailFlag) 
            {
                string returnStr = oVME.SendEmailToRevision("Incentive"
                                        , "Configure"
                                        , emailStep
                                        , emailTitle
                                        , emailContent);
            }

            return Content("Done");
        }

        #endregion

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadSCChassis(HttpPostedFileBase File, string scid)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Incentive/SCChassis/" + scid + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_SC_Chassis_Import] {0},'{1}','{2}'"
                                    , scid
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }


        //------------- INC RS Rpt2
        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheive()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_RS_Volume_SummaryByDealer] '{0}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheiveAccrue()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_RS_Volume_SummaryByDealer_Accrue] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheivePayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_RS_Volume_SummaryByDealer_Payment] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheiveByVolume()
        {
            DataSet  ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_RS_AcheiveByVolumeAll] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS (gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheiveByDealer()
        {      
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_RS_Count_AcheiveByDealerAll] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsDealerAcheivePaymentFY()
        {         
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_RS_Count_AcheiveByDealer_FY] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult GetRsAchievementByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_INC_RS_Volume_AchievementByModel_All '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        //------------- INC SP Rpt3
        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpDealerAcheive()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_SP_Volume_SummaryByDealer] '{0}','{1}'";
            gSQL = String.Format(gSQL , Request.Form["DATA_MONTH"], Request.Form["INCENTIVE_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpDealerAcheiveAccrue()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_SP_Volume_SummaryByDealer_Accrue] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["INCENTIVE_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpDealerAcheivePayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_SP_Volume_SummaryByDealer_Payment] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["INCENTIVE_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpDealerAcheiveByVolume()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_SP_AcheiveByVolumeAll] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["INCENTIVE_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpDealerAcheiveByDealer()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_SP_Count_AcheiveByDealerAll] '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["INCENTIVE_TYPE"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpAchievementByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_INC_SP_Volume_AchievementByModel_All '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["INC_ID"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }


        //------------- INC 2M Rpt4
        // [SessionExpire]
        // [HttpPost]
        // public JsonResult Get2MDealerAcheive()
        // {
        //     DataTable dt = new DataTable();

        //     gSQL = "EXEC [sp_Rpt_INC_2M_Volume_SummaryByDealer] '{0}'";
        //     gSQL = String.Format(gSQL
        //                         , Request.Form["DATA_MONTH"]);
        //     dt = odb.SqlQuery(gSQL, mDBName);

        //     return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        // }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheiveAccrue()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_2M_Volume_SummaryByDealer_Accrue] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheiveAmount()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_2M_Pecent_Amount] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheivePayment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Rpt_INC_2M_Volume_SummaryByDealer_Payment] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheiveByVolume()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_2M_AcheiveByVolume] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheiveByDealer()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_2M_Count_AcheiveByDealer] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MDealerAcheivePaymentFY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_2M_Count_AcheiveByDealer_FY] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MAchievementByModel()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_INC_2M_Volume_AchievementByModel_All '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["PERIOD"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MonthByChassis()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_INC_2M_Chassis '{0}','{1}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["PERIOD"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        // End of Rpt4


        [SessionExpire]
        [HttpPost]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_INC_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult UploadIncentiveNonQualifier(HttpPostedFileBase File
            , string year, string month, string dataType
            , string condition, int conditionTypeID, string ApplyType , int SP_ID)
        {

            if (File != null && File.ContentLength > 0)
            {
                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Incentive/NonQualifier/" + year + "/" + month + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_INC_Condition_Import] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}'"
                                    , year
                                    , month
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , dataType
                                    , conditionTypeID
                                    , condition
                                    , ApplyType
                                    , SP_ID
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [SessionExpire]
        public JsonResult GetConditionList()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_INC_Condition_Upload_List] '{0}','{1}','INC'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DATA_TYPE"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public ContentResult IncBatch (string DATA_MONTH, string DEALER_ID)
        {
            gSQL = String.Format("EXEC sp_PRC_INC_Batch '{0}','{1}'"
                                , DATA_MONTH, DEALER_ID);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }


        [SessionExpire]
        [HttpPost]
        public ContentResult RSRecal()
        {
            gSQL = String.Format("EXEC [sp_PRC_INC_RS_Recal] '{0}','{1}'"
                                , Request.Form["DATA_MONTH"], Request.Form["OUTLET_ID"]);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }


        [SessionExpire]
        [HttpPost]
        public ContentResult SPRecal()
        {
            gSQL = String.Format("EXEC [sp_PRC_INC_SP_Recal] '{0}','{1}'"
                                 , Request.Form["DATA_MONTH"], Request.Form["OUTLET_ID"]);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult M2Recal1st()
        {
            gSQL = String.Format("EXEC [sp_PRC_INC_M2_1st_Recal] '{0}','{1}'"
                                 , Request.Form["DATA_MONTH"], Request.Form["OUTLET_ID"]);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult M2Recal2nd()
        {
            gSQL = String.Format("EXEC [sp_PRC_INC_M2_2nd_Recal] '{0}','{1}'"
                                 , Request.Form["DATA_MONTH"], Request.Form["OUTLET_ID"]);
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetNonQualifyChassis(string id)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC [sp_INC_Non_Qualify_List] '{0}'", id);
            dt = odb.SqlQuery(gSQL, mDBName);

            var JsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            return JsonResult;

        }

        [SessionExpire]
        [HttpGet]
        public JsonResult GetNonQualifyAppliedChassis(string id)
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC [sp_INC_Non_Qualify_Applied_List] '{0}'", id);
            dt = odb.SqlQuery(gSQL, mDBName);

            var JsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            return JsonResult;

        }

        [SessionExpire]
        private class NonQualifyList
        {
            public string CHASSIS_NO { get; set; }
            public int INC_COUNT { get; set; }
            public int INC_PAY { get; set; }
        }
        [SessionExpire]
        public ContentResult ApplyNonQualifyList(string pNonQualify)
        {
            var list = new JavaScriptSerializer().Deserialize<List<NonQualifyList>>(pNonQualify);
            foreach (var item in list)
            {
                gSQL = String.Format("EXEC sp_INC_Configure_Non_Qualify_Apply '{0}','{1}','{2}'"
                                , item.CHASSIS_NO
                                , item.INC_COUNT
                                , item.INC_PAY);
                odb.SqlExecute(gSQL, mDBName);
            }
            return Content("Done");
        }
        [SessionExpire]
        [HttpPost]
        public ContentResult ApplyNonQualify()
        {
            gSQL = String.Format("EXEC sp_INC_Configure_Non_Qualify_Apply '{0}','{1}','{2}'"
                                , Request.Form["CHASSIS_NO"]
                                , Request.Form["INC_COUNT"]
                                , Request.Form["INC_PAY"]);

            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        [HttpPost]
        public ContentResult RemoveNonQualify()
        {
            gSQL = String.Format("EXEC sp_INC_Configure_Non_Qualify_Remove '{0}'"
                                , Request.Form["CHASSIS_NO"]);

            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult GetSpecificMonthly()
        {
            DataTable dt = new DataTable();

            gSQL = String.Format("EXEC [sp_INC_SP_Monthly_List] '{0}'", Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var JsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);

            return JsonResult;
        }

        [SessionExpire]
        public JsonResult Get2MPercentList(string fy, string y, string m)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_2M_PercentMonthly_List] '{0}', '{1}'";

            gSQL = String.Format(gSQL,  y, m);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        //[SessionExpire]
        //[HttpPost]
        //public ContentResult SaveChangeRS2IncentivePercent()
        //{
        //    gSQL = "EXEC [sp_INC_CFG_PercentMonthly_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}'";
        //    gSQL = String.Format(gSQL
        //                        , Request.Form["M"]
        //                        , Request.Form["Y"]
        //                        , Request.Form["FY"]
        //                        , Request.Form["INCENTIVE_TYPE"]
        //                        , Request.Form["PERCENT_50"]
        //                        , Request.Form["PERCENT_60"]
        //                        , Request.Form["PERCENT_70"]
        //                        , Request.Form["PERCENT_80"]
        //                        , Request.Form["PERCENT_90"]
        //                        , Request.Form["PERCENT_100"]
        //                        , Request.Form["PERCENT_110"]
        //                        , Request.Form["PERCENT_120"]
        //                        , Request.Form["PERCENT_130"]
        //                        , Request.Form["PERCENT_140"]
        //                        , Request.Form["PERCENT_150"]
        //                        , Request.Form["ID"]);
        //    odb.SqlExecute(gSQL, mDBName);

        //    return Content("Done");
        //}
                

        [SessionExpire]
        public JsonResult Get2MPercentMonthly(string year, string month)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_PercentMonthly] '{0}','{1}','2M'";

            gSQL = String.Format(gSQL, year, month);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult Get2MModelGroupList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_ModelGroup_List] '{0}', '{1}','2M'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult FeedModelGroupList()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_CFG_2M_FeedModelGroup] '{0}', '{1}'";
            gSQL = String.Format(gSQL
                                , Request.Form["M"]
                                , Request.Form["Y"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        [HttpPost]
        public JsonResult GetRS2VolumeSummary()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_INC_2M_Volume_SummaryByDealer '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        
        [SessionExpire]
        [HttpPost]
        public JsonResult GetRS2ModelPay()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_2M_Volume_ByModel] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"], Request.Form["DEALER_ID"], Request.Form["PERCENT_GET"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        [HttpPost]
        public JsonResult GetRS2ModelChassis()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_2M_Chassis_ByModel] '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL
                                , Request.Form["DATA_MONTH"]
                                , Request.Form["DEALER_ID"]
                                , Request.Form["INC_MODEL_ID"]
                                , Request.Form["GET_AMOUNT"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        [HttpPost]
        public JsonResult GetBatchApprove()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_Batch_Approve] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
    }
}