﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SMGO.Controllers
{
    public class InsuranceDSController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];


        #region Upload Insurance work with DB

        [HttpPost]
        public JsonResult GetFileList(string periodMonth, string periodYear)
        {

            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_IF_Insurance_File_List] '{0}', '{1}'";

            gSQL = String.Format(gSQL, Request.Form["periodMonth"], Request.Form["periodYear"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetInsuranceData()
        {
            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_IF_Insurance_Data_List] '{0}', '{1}'";

            gSQL = String.Format(gSQL, Request.Form["periodMonth"], Request.Form["periodYear"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;

        }

        [HttpPost]
        public JsonResult ConfirmInsuranceUpload(string fileName, string periodMonth = "00", string periodYear = "00")
        {
            if (fileName != null && fileName.Length > 0)
            {
                gSQL = String.Format("EXEC [dbo].[sp_Insurance_Data_Add] '{0}', '{1}'"
                                    , fileName
                                    , Session[Cons.SS_USER_ID].ToString());

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        public JsonResult CancelInsuranceUpload(string fileName, string periodMonth = "00", string periodYear = "00")
        {
            if (fileName != null && fileName.Length > 0)
            {

                //Remove uploaded data.
                gSQL = String.Format("EXEC [dbo].[sp_Insurance_Temp_Remove] '{0}'"
                                    , fileName);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                //Delete uploaded file.
                string fileLocationStr = "~/upload/Insurance/DataPeriod/" + periodYear + "/" + periodMonth + "/" + fileName;
                string fileLocation = Server.MapPath(fileLocationStr);

                DataService.DeleteFileByLocation(fileLocation);


                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        public JsonResult UploadInsuranceData(HttpPostedFileBase File, string periodMonth = "00", string periodYear = "00")
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Insurance/DataPeriod/" + periodYear + "/" + periodMonth + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                gSQL = String.Format("EXEC [sp_Insurance_Temp_Check] '{0}'"
                                    ,aBiz.DataService.MapUploadPath(fileLocation));
                DataTable dt0 = odb.SqlQuery(gSQL, mDBName);
                
                var invalidFieldList = "";
                var invalidString = "";

                foreach(DataRow dr in dt0.Rows)
                {
                    invalidFieldList = "";

                    if (dr.Field<int>("CHASSIS_NO_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Chassis No#(NMT)] is invalid, ";
                    }
                    if (dr.Field<int>("TAX_DATE_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Tax Invoice Date] is invalid, ";
                    }
                    if (dr.Field<int>("GROSS_PERMIUM_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Gross Premium ] is invalid, ";
                    }
                    if (dr.Field<int>("STAMP_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Stamp] is invalid, ";
                    }
                    if (dr.Field<int>("VAT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[VAT] is invalid, ";
                    }
                    if (dr.Field<int>("TOTAL_PREMIUM_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Total Premium] is invalid, ";
                    }
                    if (dr.Field<int>("DISCOUNT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[discount] is invalid, ";
                    }
                    if (dr.Field<int>("TOTAL_PREMIUM_EX_DISCOUNT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[ Total Premium after discount ] is invalid, ";
                    }
                    if (dr.Field<int>("WH_TAX_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[WH Tax] is invalid, ";
                    }
                    if (dr.Field<int>("PAY_TO_LWT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Total Premium pay to LWT] is invalid, ";
                    }
                    if (dr.Field<int>("SOLD_DATE_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Sold Date] is invalid, ";
                    }
                    if (dr.Field<int>("EFFECTIVE_DATE_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Effective Date] is invalid, ";
                    }
                    if (dr.Field<int>("RS_SUM_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[RS SumIns] is invalid, ";
                    }
                    if (dr.Field<int>("M2_SUM_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[M2_SumInsured] is invalid, ";
                    }
                    if (dr.Field<int>("M2_AMT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[M2_Amt] is invalid, ";
                    }
                    if (dr.Field<int>("ROUND_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Round] is invalid, ";
                    }

                    if (invalidFieldList != "") {
                        invalidString = invalidString + dr.Field<string>("CHASSIS_NO") + ": " + invalidFieldList + "\n";
                    }
                }

                if (invalidString != "") {
                    return Json(new {result = 200, data = invalidString});
                }


                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_Insurance_Temp_Add] '{0}', '{1}', '{2}', '{3}', '{4}'"
                                    , gFileName
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , fileLocation
                                    , periodMonth
                                    , periodYear);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);

                var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
                jsonResult.MaxJsonLength = Int32.MaxValue;

                return jsonResult;

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion

        #region Insurance summary report

        [HttpPost]
        public JsonResult GetInsuranceSumList()
        {
            DataTable dt = new DataTable();

            gSQL = "SELECT * FROM [vw_Rpt_CMP_InsureSumAmount] WHERE DATA_MONTH = '{0}' AND INSURANCE_AMOUNT <> 0 ";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        public JsonResult InsuranceMatchChassis(string DATA_MONTH)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_Insurance_Matched_Chassis '{0}'";
            gSQL = String.Format(gSQL, DATA_MONTH);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;
            return jsonResult;

            //return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion
    }
}