﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SMGO.Controllers
{
    public class LeasingDSController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];


        #region Upload Leasing work with DB

        [HttpPost]
        public JsonResult GetFileList(string periodMonth, string periodYear)
        {

            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_IF_Leasing_File_List] '{0}', '{1}'";

            gSQL = String.Format(gSQL, Request.Form["periodMonth"], Request.Form["periodYear"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        public JsonResult GetLeasingData()
        {
            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_IF_Leasing_Data_List] '{0}', '{1}'";

            gSQL = String.Format(gSQL, Request.Form["periodMonth"], Request.Form["periodYear"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        public JsonResult GetLeasingDataList()
        {
            DataTable dt = new DataTable();

            gSQL = @"EXEC [dbo].[sp_IF_Leasing_Data_ListByID] '{0}'";

            gSQL = String.Format(gSQL, Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        public ContentResult EditLeasingData()
        {
                gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
                gSQL = "UPDATE [TBL_IF_Leasing_Data] " + gSQL;
                gSQL = String.Format(gSQL);
                odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [HttpPost]
        public JsonResult ConfirmLeasingUpload(string fileName, string periodMonth = "00", string periodYear = "00")
        {
            if (fileName != null && fileName.Length > 0)
            {
                gSQL = String.Format("EXEC [dbo].[sp_Leasing_Data_Add] '{0}', '{1}'"
                                    , fileName
                                    , Session[Cons.SS_USER_ID].ToString());

                odb.SqlExecute(gSQL, mDBName);


                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        public JsonResult CancelLeasingUpload(string fileName, string periodMonth = "00", string periodYear = "00")
        {
            if (fileName != null && fileName.Length > 0)
            {

                //Remove uploaded data.
                gSQL = String.Format("EXEC [dbo].[sp_Leasing_Temp_Remove] '{0}'"
                                    , fileName);

                odb.SqlExecute(gSQL, mDBName);


                //Delete uploaded file.
                string fileLocationStr = "~/upload/Leasing/DataPeriod/" + periodYear + "/" + periodMonth + "/" + fileName;
                string fileLocation = Server.MapPath(fileLocationStr);

                DataService.DeleteFileByLocation(fileLocation);


                return Json(new { result = 200 });
            }
            else
            {
                return Json(new { result = 500 });
            }
        }

        [HttpPost]
        public JsonResult UploadLeasingData(HttpPostedFileBase File, string periodMonth = "00", string periodYear = "00")
        {

            if (File != null && File.ContentLength > 0)
            {

                // Write file to Server
                string gFileName = File.FileName;
                string uploadLocationStr = "~/upload/Leasing/DataPeriod/" + periodYear + "/" + periodMonth + "/";
                string uploadLocation = Server.MapPath(uploadLocationStr);
                string fileLocation = uploadLocationStr + gFileName;

                DataService.UploadFileByLocation(File
                                                , uploadLocation
                                                , Server.MapPath(fileLocation));

                
                gSQL = String.Format("EXEC [sp_Leasing_Temp_Check] '{0}'"
                                    ,aBiz.DataService.MapUploadPath(fileLocation));
                DataTable dt0 = odb.SqlQuery(gSQL, mDBName);


                var invalidFieldList = "";
                var invalidString = "";

                foreach(DataRow dr in dt0.Rows)
                {
                    invalidFieldList = "";

                    if (dr.Field<int>("CHASSIS_NO_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Serial Number] is invalid, ";
                    }
                    if (dr.Field<int>("APPLICATION_DATE_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Application Date] is invalid, ";
                    }
                    if (dr.Field<int>("BOOKING_DATE_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Booking Date] is invalid, ";
                    }
                    if (dr.Field<int>("CONTRACT_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Contract] is invalid, ";
                    }
                    if (dr.Field<int>("BUDGET_PASS") == 0) {
                        invalidFieldList = invalidFieldList + "[Budget] is invalid, ";
                    }

                    if (invalidFieldList != "") {
                        invalidString = invalidString + dr.Field<string>("CHASSIS_NO") + ": " + invalidFieldList + "\n";
                    }
                }

                if (invalidString != "") {
                    return Json(new {result = 200, data = invalidString});
                }

                // Add data to Temp
                gSQL = String.Format("EXEC [dbo].[sp_Leasing_Temp_Add] '{0}', '{1}', '{2}', '{3}', '{4}'"
                                    , gFileName
                                    , aBiz.DataService.MapUploadPath(fileLocation)
                                    , fileLocation
                                    , periodMonth
                                    , periodYear);

                DataTable dt = odb.SqlQuery(gSQL, mDBName);


                var jsonResult = Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
                jsonResult.MaxJsonLength = Int32.MaxValue;

                return jsonResult;

            }
            else
            {
                return Json(new { result = 500 });
            }
        }
        #endregion
        

        #region Leasing summary report

        [HttpPost]
        public JsonResult GetLeasingSumList()
        {
            DataTable dt = new DataTable();

            gSQL = "SELECT * FROM [vw_Rpt_CMP_NLTHSumAmount] WHERE DATA_MONTH = '{0}' AND LEASING_AMOUNT <> 0";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        #endregion

        #region Leasing report
            [SessionExpire]
            public JsonResult LeasingMatchChassis(string DATA_MONTH)
            {
                DataTable dt = new DataTable();

                gSQL = "EXEC sp_Leasing_Matched_Chassis '{0}'";
                gSQL = String.Format(gSQL, DATA_MONTH);
                dt = odb.SqlQuery(gSQL, mDBName);

                return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
            }
        #endregion
    }
}