﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Globalization;

namespace SMGO.Controllers
{
    public class MSControlDSController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private VMEService oVME = new VMEService();


        [HttpPost]
        [SessionExpire]
        public JsonResult GetDash()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_ACC_Dashboard_List] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #region MSControl summary
        [HttpPost]
        public JsonResult GetMSControlSummaryAfterBooking()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Summary_After_Booking '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
            

        [HttpPost]
        [SessionExpire]
        public JsonResult GetOverallAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_All_Type_Accrue] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCampaignAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CMP_All_Type_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetFleetAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_FLT_All_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetIncentiveAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_INC_All_Type_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetDemoCarAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_DMC_All_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetCQAllAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_Rpt_CQ_All_Accrue_Summary] '{0}'";
            gSQL = string.Format(gSQL, Request.Form["DATA_MONTH"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            var jsonResult = Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = Int32.MaxValue;

            return jsonResult;
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlTrackingReport()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Tracking_Report '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region Campaign Summary
        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlCampaignTotal()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Campaign_Total '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlCampaignAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Campaign_Accrue '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlCampaignAdjustPY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Campaign_Adjust_PY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlCampaignAdjustCY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Campaign_Adjust_CY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region Fleet Summary
        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlFleetTotal()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Fleet_Total '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlFleetAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Fleet_Accrue '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlFleetAdjustPY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Fleet_Adjust_PY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlFleetAdjustCY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Fleet_Adjust_CY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region Incentive Summary
        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlIncentiveTotal()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Incentive_Total '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlIncentiveAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Incentive_Accrue '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlIncentiveAdjustPY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Incentive_Adjust_PY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [HttpPost]
        [SessionExpire]
        public JsonResult GetMSControlIncentiveAdjustCY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_Incentive_Adjust_CY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion

        #region Incentive Summary
        [HttpPost]
        public JsonResult GetMSControlCQTotal()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_CQ_Total '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        
        [HttpPost]
        public JsonResult GetMSControlCQAccrue()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_CQ_Accrue '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        
        [HttpPost]
        public JsonResult GetMSControlCQAdjustPY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_CQ_Adjust_PY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        
        [HttpPost]
        public JsonResult GetMSControlCQAdjustCY()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC sp_Rpt_MSC_CQ_Adjust_CY '{0}','{1}'";
            gSQL = string.Format(gSQL
                                , Request.Form["DATA_MONTH_FROM"]
                                , Request.Form["DATA_MONTH_TO"]);
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }
        #endregion
    }
}