﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IdentityModel.Tokens.Jwt;
using System.Security.Claims;
using Microsoft.IdentityModel.Tokens;
using System.Text;

namespace SMGO.Controllers
{
    public class SystemController : Controller
    {


        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["SYSDBName"];


        [SessionExpire]
        public ActionResult Index()
        {
            return View();
        }

        //------------------------------------------------------------------------------------
        [HttpPost]
        public ActionResult Login(string usrname, string password)
        {

            String lblMsg;

            muliLang msgLang = new muliLang();

            DataTable dt = new DataTable();

            if (!ismoUtil.CheckSpecialCharacter(usrname))
            {
                lblMsg = "Incorrect username.";
                return RedirectToAction("Index", "Home", new { noti = lblMsg });
            }

            gSQL = "EXEC sp_User_Login '{0}','{1}'";
            gSQL = String.Format(gSQL, usrname, password);
            dt = odb.SqlQuery(gSQL, mDBName);

            var Result = dt.Rows[0];

            if (Result["RESULT"].ToString() == "DONE")
            {
                Session.Add(Cons.SS_USER_ID, Result["ID"].ToString());
                Session.Add(Cons.SS_USER_NAME, Result["USER_NAME"].ToString());
                Session.Add(Cons.SS_USER_NAME_TH, Result["NAME_TH"].ToString());
                Session.Add(Cons.SS_USER_NAME_EN, Result["NAME_EN"].ToString());
                Session.Add(Cons.SS_USER_LANG, Result["USER_LANGUAGE"].ToString());
                Session.Add(Cons.SS_USER_DEPT, Result["DEPARTMENT_ID"].ToString());
                Session.Add(Cons.SS_USER_EMAIL, Result["EMAIL"].ToString());
                Session.Add(Cons.SS_USER_TYPE, Result["USER_TYPE"].ToString());
                Session.Add(Cons.SS_USER_ROLE_PARENT, Result["ROLE_PARENT_ID"].ToString());
                Session.Add(Cons.SS_SALE_ZONE, Result["SALE_ZONE"].ToString());

                if (Result["USER_TYPE"].ToString() == "Dealer")
                {
                    Session.Add(Cons.SS_OUTLET_ID, Result["USERNAME"].ToString());
                    return RedirectToAction("Index", "DealerPortal");
                } 
                //else if (Result["IS_MULTI_ROLES"].ToString() == "Y")
                //{
                //    Session.Add(Cons.SS_OUTLET_ID, "0");
                //    Session.Add(Cons.SS_EMP_NO, Result["REFERENCE_NO"].ToString());
                //    Session.Add(Cons.SS_PWD_EXPIRE_IN, Result["EXPIRE_IN"].ToString());

                //    gSQL = "EXEC [sp_User_Emp_Sub_Check] '{0}','CIMS'";
                //    gSQL = String.Format(gSQL, usrname);
                //    dt = odb.SqlQuery(gSQL, mDBName);

                //    var CheckResult = dt.Rows[0];

                //    if (CheckResult["RESULT"].ToString() == "GO_AUTH_TO")
                //    {
                //        return RedirectToAction("AuthTo");
                //    }
                //    else if (CheckResult["RESULT"].ToString() == "GO_LOGIN")
                //    {
                //        Session.Add(Cons.SS_USER_ROLE, CheckResult["ROLE_ID"].ToString());
                //    }
                //}
                else
                {
                    Session.Add(Cons.SS_USER_ROLE, Result["ROLE_ID"].ToString());
                    Session.Add(Cons.SS_OUTLET_ID, "0");
                    Session.Add(Cons.SS_EMP_NO, Result["REFERENCE_NO"].ToString());
                    Session.Add(Cons.SS_PWD_EXPIRE_IN, Result["EXPIRE_IN"].ToString());
                }

               

                return RedirectToAction("Main", "System");

            }
            else if (Result["RESULT"].ToString() == "NOT_EXISTS")
            {
                lblMsg = "Incorrect username or password.";
                return RedirectToAction("Index", "Home", new { noti = lblMsg });
            }
            else if (Result["RESULT"].ToString() == "EXPIRED")
            {
                Session.Add(Cons.SS_PWD_EXPIRE_IN, Result["EXPIRE_IN"].ToString());
                Session.Add(Cons.SS_USER_ID, Result["REFERENCE_NO"].ToString());
                Session.Add(Cons.SS_USER_NAME, Result["USER_NAME"].ToString());
                return RedirectToAction("ChangePWD", "System", new { expired = "true" });
            }
            return RedirectToAction("Index", "Home");
        }
        public ActionResult LoginByToken(string usrname, string token)
        {

            String lblMsg;

            muliLang msgLang = new muliLang();

            DataTable dt = new DataTable();

            if (!ismoUtil.CheckSpecialCharacter(usrname))
            {
                lblMsg = "Incorrect username.";
                return RedirectToAction("Index", "DealerPortal", new { noti = lblMsg, tokenerr = true, token = token });
            }

            gSQL = "EXEC sp_User_Portal_Login '{0}'";
            gSQL = String.Format(gSQL, usrname);
            dt = odb.SqlQuery(gSQL, mDBName);

            var Result = dt.Rows[0];

            if (Result["RESULT"].ToString() == "DONE")
            {
                Session.Add(Cons.SS_USER_ID, Result["ID"].ToString());
                Session.Add(Cons.SS_OUTLET_ID, usrname);
                Session.Add(Cons.SS_USER_NAME, usrname);
                Session.Add(Cons.SS_USER_NAME_TH, Result["NAME_TH"].ToString());
                Session.Add(Cons.SS_USER_NAME_EN, Result["NAME_EN"].ToString());
                Session.Add(Cons.SS_USER_EMAIL, Result["EMAIL"].ToString());

                return RedirectToAction("Index", "DealerPortal", new { token = token });

            }
            else if (Result["RESULT"].ToString() == "NOT_EXISTS")
            {
                lblMsg = "Dealer " + usrname + " is not exists. please contact administrator.";
                return RedirectToAction("Index", "DealerPortal", new { noti = lblMsg, tokenerr = true, token = token });
            }
            return RedirectToAction("Index", "DealerPortal", new { noti = "Unknown error.", tokenerr = true, token = token });
        }
        
        [HttpPost]
        public ActionResult DealerTypeLogin(string usrname, string dealertype, string password)
        {
            String lblMsg;

            muliLang msgLang = new muliLang();

            DataTable dt = new DataTable();

            gSQL = "EXEC sp_User_Portal_Sub_Login '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, usrname, password, dealertype);
            dt = odb.SqlQuery(gSQL, mDBName);

            var Result = dt.Rows[0];

            Session.Add(Cons.SS_DEALER_TYPE, dealertype);

            if (Result["RESULT"].ToString() == "DONE")
            {
                Session.Add(Cons.SS_USER_ROLE, Result["ROLE_ID"].ToString());
                Session.Add(Cons.SS_USER_EMAIL, Result["EMAIL"].ToString());
                Session.Add(Cons.SS_PWD_EXPIRE_IN, Result["EXPIRE_IN"].ToString());

                if(dealertype == "Evt" || dealertype == "Tar")
                {
                    var claims = new List<Claim>
                    {
                        new Claim("SS_USER_ID", Session[Cons.SS_USER_ID].ToString()),
                        new Claim("SS_USER_NAME", Session[Cons.SS_USER_NAME].ToString()),
                        new Claim("SS_USER_NAME_TH", Session[Cons.SS_USER_NAME_TH].ToString()),
                        new Claim("SS_USER_NAME_EN", Session[Cons.SS_USER_NAME_EN].ToString()),
                        new Claim("SS_USER_LANG", Session[Cons.SS_USER_LANG].ToString()),
                        new Claim("SS_USER_DEPT", Session[Cons.SS_USER_DEPT].ToString()),
                        new Claim("SS_USER_EMAIL", Session[Cons.SS_USER_EMAIL].ToString()),
                        new Claim("SS_USER_TYPE", Session[Cons.SS_USER_TYPE].ToString()),
                        new Claim("SS_USER_ROLE_PARENT", Session[Cons.SS_USER_ROLE_PARENT].ToString()),
                        new Claim("SS_SALE_ZONE", Session[Cons.SS_SALE_ZONE].ToString()),
                        new Claim("SS_OUTLET_ID", Session[Cons.SS_OUTLET_ID].ToString()),
                        new Claim("SS_USER_ROLE", Session[Cons.SS_USER_ROLE].ToString()),
                        new Claim("SS_USER_EMAIL", Session[Cons.SS_USER_EMAIL].ToString()),
                        new Claim("SS_PWD_EXPIRE_IN", Session[Cons.SS_PWD_EXPIRE_IN].ToString()),
                        new Claim("SS_DEALER_TYPE", Session[Cons.SS_DEALER_TYPE].ToString())
                    };

                    var jwtKey = Cons.JWT_KEY;
                    var secretKey = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(jwtKey));
                    var signinCredentials = new SigningCredentials(secretKey, SecurityAlgorithms.HmacSha256);

                    var tokeOptions = new JwtSecurityToken(
                        issuer: "NMT",
                        audience: "NMT",
                        claims: claims,
                        expires: DateTime.UtcNow.AddSeconds(30),
                        signingCredentials: signinCredentials
                    );

                    var tokenString = new JwtSecurityTokenHandler().WriteToken(tokeOptions);

                    var AuthToURL = ConfigurationManager.AppSettings["TokenToUrl"];
                    var url = $"{AuthToURL}/System/PortalLogin?t={tokenString}";

                    return Redirect(url);
                }
                else
                {
                    return RedirectToAction("Main", "System");
                }

            }
            else if (Result["RESULT"].ToString() == "NOT_EXISTS")
            {
                lblMsg = "Incorrect password.";
                return RedirectToAction("Index", "DealerPortal", new { noti = lblMsg });
            }
            else if (Result["RESULT"].ToString() == "EXPIRED")
            {
                Session.Add(Cons.SS_PWD_EXPIRE_IN, Result["EXPIRE_IN"].ToString());
                return RedirectToAction("ChangePWD", "DealerPortal", new { expired = "true" });
            }
            else if (Result["RESULT"].ToString() == "INIT_PWD")
            {
                return RedirectToAction("ChangePWD", "DealerPortal", new { init = "true" });
            }

            return RedirectToAction("Index", "DealerPortal");
        }

        [SessionExpire]
        public ActionResult RolesLogin(string usrname, string subusertype, string roleid)
        {
            String lblMsg;

            muliLang msgLang = new muliLang();

            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_User_Emp_Sub_Login] '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, usrname, subusertype, roleid);
            dt = odb.SqlQuery(gSQL, mDBName);

            var Result = dt.Rows[0];

            if (Result["RESULT"].ToString() == "DONE")
            {
                Session.Add(Cons.SS_USER_ROLE, Result["ROLE_ID"].ToString());

                if(subusertype == "Evt" || subusertype == "Tar")
                {
                    var claims = new List<Claim>
                    {
                        new Claim("SS_USER_ID", Session[Cons.SS_USER_ID].ToString()),
                        new Claim("SS_USER_NAME", Session[Cons.SS_USER_NAME].ToString()),
                        new Claim("SS_USER_NAME_TH", Session[Cons.SS_USER_NAME_TH].ToString()),
                        new Claim("SS_USER_NAME_EN", Session[Cons.SS_USER_NAME_EN].ToString()),
                        new Claim("SS_USER_LANG", Session[Cons.SS_USER_LANG].ToString()),
                        new Claim("SS_USER_DEPT", Session[Cons.SS_USER_DEPT].ToString()),
                        new Claim("SS_USER_EMAIL", Session[Cons.SS_USER_EMAIL].ToString()),
                        new Claim("SS_USER_TYPE", Session[Cons.SS_USER_TYPE].ToString()),
                        new Claim("SS_USER_ROLE_PARENT", Session[Cons.SS_USER_ROLE_PARENT].ToString()),
                        new Claim("SS_SALE_ZONE", Session[Cons.SS_SALE_ZONE].ToString()),
                        new Claim("SS_OUTLET_ID", Session[Cons.SS_OUTLET_ID].ToString()),
                        new Claim("SS_USER_ROLE", Session[Cons.SS_USER_ROLE].ToString()),
                        new Claim("SS_USER_EMAIL", Session[Cons.SS_USER_EMAIL].ToString()),
                        new Claim("SS_PWD_EXPIRE_IN", Session[Cons.SS_PWD_EXPIRE_IN].ToString()),
                        new Claim("SS_EMP_NO", Session[Cons.SS_EMP_NO].ToString()),
                        new Claim("SS_SUB_USER_TYPE", subusertype)
                    };

                    var jwtKey = Cons.JWT_KEY;
                    var secretKey = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(jwtKey));
                    var signinCredentials = new SigningCredentials(secretKey, SecurityAlgorithms.HmacSha256);

                    var tokeOptions = new JwtSecurityToken(
                        issuer: "NMT",
                        audience: "NMT",
                        claims: claims,
                        expires: DateTime.UtcNow.AddSeconds(30),
                        signingCredentials: signinCredentials
                    );

                    var tokenString = new JwtSecurityTokenHandler().WriteToken(tokeOptions);

                    var AuthToURL = ConfigurationManager.AppSettings["TokenToUrl"];
                    var url = $"{AuthToURL}/System/PortalLogin?t={tokenString}";

                    return Redirect(url);
                }
                else
                {
                    return RedirectToAction("Main", "System");
                }
            } else {
                lblMsg = "Unable to login, please try again.";
            }

            return RedirectToAction("AuthTo", "System", new { noti = lblMsg});
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult UserList()
        {
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Department()
        {
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Position()
        {
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult Roles()
        {
            return View();
        }

        [SessionExpire]
        public ActionResult Main()
        {
            return View("Index");

            //if (Session[Cons.SS_USER_ROLE].ToString() == "2" || Session[Cons.SS_USER_ROLE].ToString() == "8")
            //{

            //    return RedirectToAction("Main", "Campaign");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "4" || Session[Cons.SS_USER_ROLE].ToString() == "9")
            //{

            //    return RedirectToAction("Main", "Fleet");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "31" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "5" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "10" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "17"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "46"
            //    )
            //{
            //    return RedirectToAction("Main", "Incentive");
            //}
            //else if(Session[Cons.SS_USER_ROLE].ToString() == "15"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "35")
            //{
            //     return RedirectToAction("Main", "MSControl");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "13" || Session[Cons.SS_USER_ROLE].ToString() == "14"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "32"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "33"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "34"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "36"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "47"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "48")
            //{
            //    return RedirectToAction("Main", "CQ");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "7" || Session[Cons.SS_USER_ROLE].ToString() == "25"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "26"
            //    || Session[Cons.SS_USER_ROLE].ToString() == "27")
            //{
            //    return RedirectToAction("Main", "DealerPortal");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "24")
            //{
            //    return RedirectToAction("MainSalesArea", "DealerPortal");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "28")
            //{
            //    return RedirectToAction("Rpt1Dealer", "DealerPortal");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "16" || Session[Cons.SS_USER_ROLE].ToString() == "18")
            //{
            //    return RedirectToAction("Main", "DemoCar");
            //}
            //else if (Session[Cons.SS_USER_ROLE].ToString() == "6" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "19" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "20" 
            //    || Session[Cons.SS_USER_ROLE].ToString() == "21")
            //{
            //    return RedirectToAction("Main", "Account");
            //}
            //else
            //{
            //    return View("Index");
            //}

        }

        [SessionExpire, RoleAuthorized]
        public ActionResult SystemMenu()
        {
            return View();
        }

        public ActionResult Logout()
        {
            Session.Contents.RemoveAll();
            return RedirectToAction("Index", "Home");
        }

        [SessionExpire]
        public ActionResult Personal()
        {
            return View();
        }

        [SessionExpire]
        public ActionResult ChangePWD(string expired="false")
        {
            ViewBag.username = Session[Cons.SS_USER_NAME].ToString();
            ViewBag.isExpired = expired;
            return View();
        }

        public ActionResult Language()
        {
            ViewBag.PageTitle = "Language";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult GridView()
        {
            ViewBag.PageTitle = "GridView Configutation";
            return View();
        }

        [SessionExpire, RoleAuthorized]
        public ActionResult ReportConfigure()
        {
            ViewBag.PageTitle = "Report Configutation";
            return View();
        }

        [SessionExpire]
        public ContentResult Heartbeat()
        {
            return Content("");
        }

        [SessionExpire]
        public ActionResult AuthTo(string noti, bool tokenerr=false)
        {
            if(!tokenerr && Session[Cons.SS_USER_NAME].ToString().Length > 0) 
            {
                ViewBag.Username = Session[Cons.SS_USER_NAME].ToString();
                ViewBag.NameTH = Session[Cons.SS_USER_NAME_TH].ToString();
                ViewBag.NameEN = Session[Cons.SS_USER_NAME_EN].ToString();
                ViewBag.Email = Session[Cons.SS_USER_EMAIL].ToString();
                ViewBag.noti = noti;
            } 
            else 
            {
                ViewBag.noti = noti;
                ViewBag.err = tokenerr;
            }
            return View();
        }
        [SessionExpire]
        public ActionResult pageNotFound()
        {
            return View();
        }


        [SessionExpire]
        public ActionResult UserChangePassword()
        {
            return View();
        }
    }
}
