using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace SMGO.Controllers
{
    public class SystemDsController : Controller
    {
        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["SYSDBName"];

        #region Language
        [SessionExpire]
        public JsonResult GetLanguage()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [dbo].[sp_CONF_Language] {0}";
            gSQL = String.Format(gSQL
                                    , (Request.Form["ID"] != null && Request.Form["ID"] != "") ? "'" + Request.Form["ID"] + "'" : "null");
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult UpdateLanguage()
        {
            gSQL = DataService.GenerateUpdateSQL(Request, Session[Cons.SS_USER_ID].ToString(), "ID");
            gSQL = "UPDATE [TBL_CONF_Language] " + gSQL;
            gSQL = String.Format(gSQL);
            odb.SqlExecute(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetLanguageTH()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_CONF_LanguageTH]";
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetLanguageEN()
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_CONF_LanguageEN]";
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult UpdateLanguageJSON()
        {
            try
            {
                var dataFile = Server.MapPath("~/Language/" + Request.Form["Language"] + ".JSON");
                System.IO.File.WriteAllText(@dataFile, Request.Form["SaveTXT"]);
            }
            catch (Exception ex)
            {
                return Content(ex.Message);
            }

            return Content("Done");
        }
        #endregion


        

        [SessionExpire]
        public JsonResult GetAuthen()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CONF_Get] 'DACT','{0}'";
            gSQL = String.Format(gSQL ,  Session[Cons.SS_OUTLET_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);
            
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetHeaderGridView(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CONF_Grid_List] '{0}','{1}' ";
            gSQL = String.Format(gSQL, id, HttpContext.Session[Cons.SS_USER_LANG].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetHeaderGridViewList(string id)
        {
            DataSet ds = new DataSet();

            gSQL = "EXEC [sp_CONF_Grid_Group_List] '{0}','{1}','{2}','{3}','{4}','{5}' ";
            gSQL = String.Format(gSQL, Request.Form["TableName1"] //5
                                , Request.Form["TableName2"]
                                , Request.Form["TableName3"]
                                , Request.Form["TableName4"]
                                , Request.Form["TableName5"]
                                , HttpContext.Session[Cons.SS_USER_LANG].ToString());
            ds = odb.SqlQueryDS(gSQL, mDBName);

            return Json(DTFM.convertToList(ds), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetReportList(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_CONF_Report_List] '{0}','{1}' ";
            gSQL = String.Format(gSQL, id, HttpContext.Session[Cons.SS_USER_LANG].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }


        [SessionExpire]
        public JsonResult GetDepartment()
        {

            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Department_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetDepartmentByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Department_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SaveDepartment()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Department_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["DEPT_NAME_TH"]
                                , Request.Form["DEPT_NAME_EN"]
                                , Request.Form["DEPT_DETAIL"]
                                , Request.Form["DEPT_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetReportConfigure()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Report_Configure]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetReportConfigureByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Report_Configure_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SaveReportConfigure()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Report_Configure_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}', '{8}', '{9}', '{10}', '{11}', '{12}', '{13}', '{14}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["ReportCode"] //1
                                , Request.Form["ReportName"]
                                , Request.Form["ReportGroup"] //3
                                , Request.Form["ParameterCount"]
                                , Request.Form["ParameterName1"] //5
                                , Request.Form["ParameterName2"]
                                , Request.Form["ParameterName3"] //7
                                , Request.Form["ParameterName4"]
                                , Request.Form["ParameterName5"] //9
                                , Request.Form["ParameterName6"]
                                , Request.Form["ParameterName7"] //11
                                , Request.Form["ParameterName9"]
                                , Request.Form["ParameterName10"] //13
                                , Request.Form["[Remarks]"]

                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public ContentResult SaveReport()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Department_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["DEPT_NAME_TH"]
                                , Request.Form["DEPT_NAME_EN"]
                                , Request.Form["DEPT_DETAIL"]
                                , Request.Form["DEPT_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetPosition()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Position_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetPositionByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Position_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SavePosition()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Position_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["POSITION_NAME_TH"]
                                , Request.Form["POSITION_NAME_EN"]
                                , Request.Form["POSITION_DETAIL"]
                                , Request.Form["POSITION_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetUsers()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_User_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetUsersForDealer()
        {
            DataTable dt = new DataTable();
            gSQL = "EXEC [sp_User_List_For_Dealer]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);
            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
        [SessionExpire]
        public JsonResult GetUserByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_User_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetUserSubByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_User_Sub_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult SaveUser()
        {
            DataTable dt = new DataTable();

            // if (!ismoUtil.CheckSpecialCharacter(Request.Form["USERNAME"])) {
            //     return Json(new {Result="Username can only contains 0-9, A-Z and a-z."});
            // } else 
            if (Request.Form["PASSWORD"] != Request.Form["PASSWORD2"])
            {
                return Json(new { Result = "Password not matched" });
            }
            else if (Request.Form["PASSWORD"] != null && Request.Form["USER_TYPE"] != "Dealer" && !ismoUtil.CheckStrength(Request.Form["PASSWORD"]))
            {
                return Json(new { Result = "Password must contain at least 8 characters including a-z, A-Z, 0-9 and special character !,@,#,$,%,^,&,*,?,_,~,-,£,(,)" });
            }
            else if (Request.Form["ID"] == "0" && Request.Form["PASSWORD"] == "" && Request.Form["USER_TYPE"] != "Dealer")
            {
                return Json(new { Result = "Please fill password" });
            }
            else
            {
                gSQL = "EXEC [sp_User_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}','{13}','{14}','{15}','{16}'";
                gSQL = String.Format(gSQL
                                    , Request.Form["ID"]
                                    , Request.Form["USER_TYPE"]
                                    , Request.Form["TITLE_TH"]
                                    , Request.Form["FIRST_NAME_TH"]
                                    , Request.Form["LAST_NAME_TH"]
                                    , Request.Form["TITLE_EN"]
                                    , Request.Form["FIRST_NAME_EN"]
                                    , Request.Form["LAST_NAME_EN"]
                                    , Request.Form["REFERENCE_NO"]
                                    , Request.Form["DEPARTMENT_ID"]
                                    , Request.Form["POSITION_ID"]
                                    , Request.Form["USERNAME"]
                                    , Request.Form["PASSWORD"]
                                    , Request.Form["ROLE_ID"]
                                    , Request.Form["USER_STATUS"]
                                    , Request.Form["EMAIL"]
                                    , Session[Cons.SS_USER_ID].ToString());
                dt = odb.SqlQuery(gSQL, mDBName);

                string id = dt.Rows[0]["ID"].ToString();

                return Json(new { Result = "Done", ID = id });
            }
        }

        [SessionExpire]
        public ContentResult SaveSubUser(string SUB_USER_TYPE, string ROLE_ID, string PASSWORD, string USER_ID, string USERNAME)
        {
            gSQL = "EXEC [sp_User_Sub_Save] '{0}','{1}','{2}','{3}','{4}','{5}'";
            gSQL = String.Format(gSQL
                                , USER_ID
                                , USERNAME
                                , SUB_USER_TYPE
                                , PASSWORD
                                , ROLE_ID
                                , Session[Cons.SS_USER_ID].ToString());
            odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetMenuHeader()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Header_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetMenuHeaderByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Header_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SaveMenuHeader()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Header_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["TITLE_NO"]
                                , Request.Form["TITLE_NAME_TH"]
                                , Request.Form["TITLE_NAME_EN"]
                                , Request.Form["TITLE_DESC"]
                                , Request.Form["TITLE_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetMenuDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Detail_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetMenuDetailByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Detail_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SaveMenuDetail()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Menu_Detail_Save] '{0}','{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["HEADER_ID"]
                                , Request.Form["MENU_NO"]
                                , Request.Form["MENU_NAME_TH"]
                                , Request.Form["MENU_NAME_EN"]
                                , Request.Form["MENU_DESC"]
                                , Request.Form["ROUTE_TYPE"]
                                , Request.Form["ROUTE_CONTROLLER_NAME"]
                                , Request.Form["ROUTE_VIEW_NAME"]
                                , Request.Form["ROUTE_ADDITIONAL_ID"]
                                , Request.Form["MENU_STATUS"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetSystemMenu()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_System_Menu] '{0}'";
            gSQL = String.Format(gSQL, Session[Cons.SS_USER_ROLE].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetRoleHeader()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Role_List]";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetRoleHeaderByID(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Role_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetRoleDetail(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Role_Detail] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult SaveRole(string[] VIEWABLE_ID, string[] EDITABLE_ID)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_Role_Save] '{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}', '{8}'";
            gSQL = String.Format(gSQL
                                , Request.Form["ID"]
                                , Request.Form["ROLE_NAME_TH"]
                                , Request.Form["ROLE_NAME_EN"]
                                , Request.Form["ROLE_DESC"]
                                , Request.Form["ROLE_STATUS"]
                                , (VIEWABLE_ID != null && VIEWABLE_ID.Length > 0) ? string.Join(",", VIEWABLE_ID) : ""
                                , (EDITABLE_ID != null && EDITABLE_ID.Length > 0) ? string.Join(",", EDITABLE_ID) : ""
                                , Request.Form["ROLE_PARENT_ID"]
                                , Session[Cons.SS_USER_ID].ToString());

            dt = odb.SqlQuery(gSQL, mDBName);
            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetPersonalData()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_User_List_ByID] '{0}'";
            gSQL = String.Format(gSQL, Session[Cons.SS_USER_ID].ToString());
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult CheckPersonalChange()
        {
            DataTable dt = new DataTable();

            if (Request.Form["PASSWORD"] != Request.Form["PASSWORD2"])
            {
                return Content("Password not matched");
            }
            else if (Request.Form["PASSWORD_OLD"] == "" || Request.Form["PASSWORD"] == "" || Request.Form["PASSWORD2"] == "")
            {
                return Content("Please fill password");
            }
            else if (!ismoUtil.CheckStrength(Request.Form["PASSWORD"]))
            {
                return Content("Password must contain at least 8 characters including a-z, A-Z, 0-9 and special character !,@,#,$,%,^,&,*,?,_,~,-,£,(,)");
            }
            else if (Request.Form["PASSWORD_OLD"] != "" && Request.Form["PASSWORD_OLD"] != null)
            {
                if (Session[Cons.SS_USER_NAME].ToString().Substring(0,1) == "9")
                {
                    gSQL = "EXEC [sp_User_Sub_Check] '{0}', '{1}', '{2}'";
                    gSQL = String.Format(gSQL
                                        , Session[Cons.SS_USER_NAME].ToString()
                                    , Session[Cons.SS_DEALER_TYPE].ToString()
                                        , Request.Form["PASSWORD_OLD"]);
                    dt = odb.SqlQuery(gSQL, mDBName);
                }
                else
                {
                gSQL = "EXEC [sp_User_Check] '{0}', '{1}'";
                gSQL = String.Format(gSQL
                                    , Session[Cons.SS_USER_NAME].ToString()
                                    , Request.Form["PASSWORD_OLD"]);
                dt = odb.SqlQuery(gSQL, mDBName);

                }
                if (dt.Rows[0]["RESULT"].ToString() == "NOT_MATCHED")
                {
                    return Content("Incorrect password.");
                }
                else if (Request.Form["PASSWORD_OLD"] != "" && Request.Form["PASSWORD_OLD"] != null && Request.Form["PASSWORD"] == Request.Form["PASSWORD_OLD"])
                {
                    return Content("Please do not use old password");
                }
            }

            return Content("Done");

        }

        [SessionExpire]
        public ContentResult UpdateNewPWD()
        {
            DataTable dt = new DataTable();

            if (Session[Cons.SS_USER_NAME].ToString().Substring(0, 1) == "9")
            {
                gSQL = "EXEC [sp_User_Sub_Update_PWD] '{0}', '{1}', '{2}'";
                gSQL = String.Format(gSQL
                                    , Session[Cons.SS_USER_NAME].ToString()
                                    , Session[Cons.SS_DEALER_TYPE].ToString()
                                    , Request.Form["PASSWORD"]);
                dt = odb.SqlQuery(gSQL, mDBName);
            } else {
            gSQL = "EXEC [sp_User_Update_PWD] '{0}', '{1}'";
            gSQL = String.Format(gSQL
                                , Session[Cons.SS_USER_NAME].ToString()
                                , Request.Form["PASSWORD"]);
            dt = odb.SqlQuery(gSQL, mDBName);
            }


            return Content("Done");

        }

        [SessionExpire]
        public JsonResult GetGridViewHeader(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_GridView_Header] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public JsonResult GetGridViewDetail(string id)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_GridView_Detail] '{0}'";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }

        [SessionExpire]
        public ContentResult CheckGridView()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_GridView_Check] '{0}'";
            gSQL = String.Format(gSQL, Request.Form["ID"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            if (dt.Rows.Count > 0)
                return Content("Duplicated ID");
            else
                return Content("Done");
        }

        [SessionExpire]
        public ContentResult SaveGridView()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_GridView_Update] {0},'{1}','{2}','{3}','{4}','{5}','{6}','{7}','{8}','{9}','{10}','{11}','{12}'";
            gSQL = String.Format(gSQL
                                , (Request.Form["ID"] == null || Request.Form["ID"] == "") ? null : Request.Form["ID"]
                                , Request.Form["TABLE_NAME"]
                                , Request.Form["FIELD_NAME"]
                                , Request.Form["RNO"]
                                , Request.Form["TITLE_TH"]
                                , Request.Form["TITLE_EN"]
                                , Request.Form["WIDTH"]
                                , Request.Form["ALIGN"]
                                , Request.Form["V_ALIGN"]
                                , Request.Form["DATA_TYPE"]
                                , Request.Form["PAGE_URL"]
                                , Request.Form["LINK_FN"]
                                , Request.Form["VISIBILITY"]);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Content("Done");
        }

        [SessionExpire]
        public JsonResult GetUserRoles()
        {
            DataTable dt = new DataTable();

            gSQL = $"EXEC sp_User_Roles '{Session[Cons.SS_USER_ID].ToString()}'";
            gSQL = String.Format(gSQL);
            dt = odb.SqlQuery(gSQL, mDBName);

            return Json(DTFM.convertToList(dt), JsonRequestBehavior.AllowGet);
        }
    }
}
