﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="SMGO.WSYS.WebForm1" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">


body h1 {
  padding-bottom: 0.3em;
  font-size: 2em;
  border-bottom: 1px solid #eee;
}

body h1,
body h2,
body h3,
body h4,
body h5,
body h6 {
  margin-top: 24px;
  margin-bottom: 16px;
  font-weight: 600;
  line-height: 1.25;
}

body h1 {
  font-size: 32px;
  font-weight: 600;
}

body h1,
body h2,
body h3,
body h4,
body h5,
body h6 {
  margin-top: 0;
  margin-bottom: 0;
}

body h1 {
  font-size: 2em;
  margin: 0.67em 0;
}

body * {
  box-sizing: border-box;
}

body ul,
body ol {
  padding-left: 2em;
}

body p,
body blockquote,
body ul,
body ol,
body dl,
body table,
body pre {
  margin-top: 0;
  margin-bottom: 16px;
}

body ul,
body ol {
  padding-left: 0;
  margin-top: 0;
  margin-bottom: 0;
}

body h2 {
  padding-bottom: 0.3em;
  font-size: 1.5em;
  border-bottom: 1px solid #eee;
}

body h2 {
  font-size: 24px;
  font-weight: 600;
}

body li>p {
  margin-top: 16px;
}

body p {
  margin-top: 0;
  margin-bottom: 10px;
}

body li+li {
  margin-top: 0.25em;
}

body .highlight pre,
body pre {
  padding: 16px;
  overflow: auto;
  font-size: 85%;
  line-height: 1.45;
  background-color: #f7f7f7;
  border-radius: 3px;
}

body pre {
  word-wrap: normal;
}

body pre {
  margin-top: 0;
  margin-bottom: 0;
  font: 12px Consolas, "Liberation Mono", Menlo, Courier, monospace;
}

body code,
body kbd,
body pre {
  font-family: monospace, monospace;
  font-size: 1em;
}

body pre code {
  display: inline;
  max-width: auto;
  padding: 0;
  margin: 0;
  overflow: visible;
  line-height: inherit;
  word-wrap: normal;
  background-color: transparent;
  border: 0;
}

body pre>code {
  padding: 0;
  margin: 0;
  font-size: 100%;
  word-break: normal;
  white-space: pre;
  background: transparent;
  border: 0;
}

body code {
  padding: 0;
  padding-top: 0.2em;
  padding-bottom: 0.2em;
  margin: 0;
  font-size: 85%;
  background-color: rgba(0,0,0,0.04);
  border-radius: 3px;
}

body code {
  font-family: Consolas, "Liberation Mono", Menlo, Courier, monospace;
  font-size: 12px;
}

body strong {
  font-weight: 600;
}

body strong {
  font-weight: bolder;
}

body strong {
  font-weight: inherit;
}

body h3 {
  font-size: 1.25em;
}

body h3 {
  font-size: 20px;
  font-weight: 600;
}

body a {
  color: #4078c0;
  text-decoration: none;
}

body a {
  background-color: transparent;
  -webkit-text-decoration-skip: objects;
}

    </style>
</head>
<body>
    <h1 id="next-steps-read-">Next steps - READ!</h1>
    <ul>
        <li>If deploying the control on an intranet site make sure that the page is targeting HTML5.</li>
    </ul>
    <h2 id="adding-the-report-viewer-control-to-a-new-project">Adding the Report Viewer Control to a new project</h2>
    <ol>
        <li>
            <p>
                Create a new ASP.Net empty web site, or open an existing ASP.Net project<br />
                <img alt="New web project" src="https://raw.githubusercontent.com/Microsoft/Reporting-Services/master/Docs_14_0/Get-Started-With-RVC/NewAspWebSite.png" /></p>
        </li>
        <li>
            <p>
                Install the Report Viewer Control Nuget package via the Nuget package manager console</p>
            <pre><code>Install-Package Microsoft.ReportingServices.ReportViewerControl.WebForms
</code></pre>
        </li>
        <li>Add a new .aspx page to the project and register the Report Viewer Control assembly for use within the page<pre><code>&lt;%@ Register assembly=&quot;Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91&quot; namespace=&quot;Microsoft.Reporting.WebForms&quot; tagprefix=&quot;rsweb&quot; %&gt;
</code></pre>
        </li>
        <li>Add a ScriptManagerControl to the page</li>
        <li>Add the Report Viewer control to the page. The below snippet can be updated to reference a report hosted on a remote Report Server<pre><code>&lt;rsweb:ReportViewer ID=&quot;ReportViewer1&quot; runat=&quot;server&quot; ProcessingMode=&quot;Remote&quot;&gt;
&lt;ServerReport ReportPath=&quot;&quot; ReportServerUrl=&quot;&quot; /&gt;
&lt;/rsweb:ReportViewer&gt;
</code></pre>
        </li>
    </ol>
    <p>
        The final page should look like</p>
    <pre><code>&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeBehind=&quot;WebForm1.aspx.cs&quot; Inherits=&quot;Sample&quot; %&gt;

&lt;%@ Register assembly=&quot;Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91&quot; namespace=&quot;Microsoft.Reporting.WebForms&quot; tagprefix=&quot;rsweb&quot; %&gt;

&lt;!DOCTYPE html&gt;

&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;
&lt;head runat=&quot;server&quot;&gt;
    &lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot; /&gt; 
    &lt;title&gt;&lt;/title&gt;
&lt;/head&gt;
&lt;body&gt;
    &lt;form id=&quot;form1&quot; runat=&quot;server&quot;&gt;
    &lt;asp:ScriptManager runat=&quot;server&quot;&gt;&lt;/asp:ScriptManager&gt;        
        &lt;rsweb:ReportViewer ID=&quot;ReportViewer1&quot; runat=&quot;server&quot; ProcessingMode=&quot;Remote&quot;&gt;
            &lt;ServerReport ReportServerUrl=&quot;http://AContosoDepartment/ReportServer&quot; ReportPath=&quot;/LatestSales&quot; /&gt;
        &lt;/rsweb:ReportViewer&gt;
    &lt;/form&gt;
&lt;/body&gt;
&lt;/html&gt;
</code></pre>
    <h2 id="updating-an-existing-project-to-use-the-report-viewer-control">Updating an existing project to use the Report Viewer Control</h2>
    <p>
        To make use of the Report Viewer Control in an existing project add the control via Nuget, and update assembly references to version 14.0.0.0. This will include updating the project’s web.config and all .aspx pages that reference the Report Viewer Control.</p>
    <p>
        <strong>Sample web.config changes</strong></p>
    <pre><code>&lt;?xml version=&quot;1.0&quot;?&gt;
&lt;!--
  For more information on how to configure your ASP.NET application, please visit
  http://go.microsoft.com/fwlink/?LinkId=169433
  --&gt;
&lt;configuration&gt;
  &lt;system.web&gt;
    &lt;compilation debug=&quot;true&quot; targetFramework=&quot;4.5.2&quot;&gt;
      &lt;assemblies&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.Common, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.DataVisualization, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.Design, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.ProcessingObjectModel, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.WebDesign, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
        &lt;add assembly=&quot;Microsoft.ReportViewer.WinForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
      &lt;/assemblies&gt;
      &lt;buildProviders&gt;
        &lt;add extension=&quot;.rdlc&quot;
          type=&quot;Microsoft.Reporting.RdlBuildProvider, Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
      &lt;/buildProviders&gt;
    &lt;/compilation&gt;
    &lt;httpRuntime targetFramework=&quot;4.5.2&quot;/&gt;
    &lt;httpHandlers&gt;
      &lt;add path=&quot;Reserved.ReportViewerWebControl.axd&quot; verb=&quot;*&quot;
        type=&quot;Microsoft.Reporting.WebForms.HttpHandler, Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;
        validate=&quot;false&quot;/&gt;
    &lt;/httpHandlers&gt;
  &lt;/system.web&gt;
  &lt;system.webServer&gt;
    &lt;validation validateIntegratedModeConfiguration=&quot;false&quot;/&gt;
    &lt;modules runAllManagedModulesForAllRequests=&quot;true&quot;/&gt;
    &lt;handlers&gt;
      &lt;add name=&quot;ReportViewerWebControlHandler&quot; verb=&quot;*&quot; path=&quot;Reserved.ReportViewerWebControl.axd&quot; preCondition=&quot;integratedMode&quot;
        type=&quot;Microsoft.Reporting.WebForms.HttpHandler, Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845DCD8080CC91&quot;/&gt;
    &lt;/handlers&gt;
  &lt;/system.webServer&gt;
&lt;/configuration&gt;
</code></pre>
    <p>
        <strong>Sample .aspx</strong></p>
    <pre><code>&lt;%@ Page Language=&quot;C#&quot; AutoEventWireup=&quot;true&quot; CodeBehind=&quot;WebForm1.aspx.cs&quot; Inherits=&quot;SampleAspx&quot; %&gt;

&lt;%@ Register assembly=&quot;Microsoft.ReportViewer.WebForms, Version=14.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91&quot; namespace=&quot;Microsoft.Reporting.WebForms&quot; tagprefix=&quot;rsweb&quot; %&gt;

&lt;!DOCTYPE html&gt;
</code></pre>
    <h2 id="common-issues">Common issues</h2>
    <h3 id="page-is-rendering-in-intranet-compatability-mode">Page is rendering in intranet compatability mode</h3>
    <p>
        The Report Viewer Control is designed to be used with modern browsers, the control may not function if browsers render the web page in an IE compatibility mode. Intranet sites may require a &#39;&lt;meta http-equiv=&quot;X-UA-Compatible&quot; content=&quot;IE=edge&quot; /&gt;&#39; tag to override setting which encourage rendering intranet pages in compatibility mode.</p>
    <h3 id="how-to-set-100-height-on-the-new-report-viewer-control">How to set 100% height on the new Report Viewer control</h3>
    <p>
        For detailed instructions <a href="http://htmlpreview.github.io/?https://github.com/Microsoft/Reporting-Services/blob/master/Docs_14_0/Set-100Percent-Height-With-RVC.html">click here</a></p>
    <h3 id="unable-to-load-dll-sqlserverspatial140-dll-the-specified-module-could-not-be-found-exception-from-hresult-0x8007007e-">Unable to load DLL &#39;SqlServerSpatial140.dll&#39;: The specified module could not be found. (Exception from HRESULT: 0x8007007E)</h3>
    <p>
        For detailed instructions, <a href="http://htmlpreview.github.io/?https://github.com/Microsoft/Reporting-Services/blob/master/Docs_14_0/Set-Reference-To-Sql-Server-Spatial.html">click here</a>.</p>
<SCRIPT src="https://htmlpreview.github.io/htmlpreview.min.js"></SCRIPT>

<SCRIPT>HTMLPreview.replaceAssets();</SCRIPT>
 </body>
</html>
