﻿
using SMGO.aControl;
using Microsoft.Reporting.WebForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace SMGO.WSYS
{
    public partial class wucWREP : System.Web.UI.UserControl
    {
    

        public void setReportWidth(int width)
        {
            Unit uWidth = new Unit(width);
            this.ReportViewer1.Width = uWidth;
            if (width == 0)
                this.ReportViewer1.Visible = false;
        }

        public void setReportHeight(int height)
        {
            Unit uHeight = new Unit(height);
            this.ReportViewer1.Height = uHeight;
            if (height == 0)
                this.ReportViewer1.Visible = false;
        }

        public void showReportToolbar(bool show)
        {
            this.ReportViewer1.ShowToolBar = show;
            this.ReportViewer1.ShowParameterPrompts = show;
            this.ReportViewer1.ShowPromptAreaButton = show;
        }

        public void openReport(string repPath, ReportParameter param = null)
        {
           ReportServerCredentials cred = new ReportServerCredentials();
           this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            if (param != null)
                this.ReportViewer1.ServerReport.SetParameters(param);
            this.ReportViewer1.ServerReport.Refresh();
        }

        public void openReport2Param(string repPath, ReportParameter param1, ReportParameter param2)
        {
            ReportServerCredentials cred = new ReportServerCredentials();
           ReportParameter[] p = new ReportParameter[] { param1, param2 };
            this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            this.ReportViewer1.ServerReport.SetParameters(p);
            this.ReportViewer1.ServerReport.Refresh();
        }

        public void openReport3Param(string repPath, ReportParameter param1, ReportParameter param2, ReportParameter param3)
        {
            ReportServerCredentials cred = new ReportServerCredentials();
            ReportParameter[] p = new ReportParameter[] { param1, param2, param3 };
            this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            this.ReportViewer1.ServerReport.SetParameters(p);
            this.ReportViewer1.ServerReport.Refresh();
        }
        public void openReport4Param(string repPath, ReportParameter param1, ReportParameter param2, ReportParameter param3,ReportParameter param4)
        {
            ReportServerCredentials cred = new ReportServerCredentials();
            ReportParameter[] p = new ReportParameter[] { param1, param2, param3,param4};
            this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            this.ReportViewer1.ServerReport.SetParameters(p);
            this.ReportViewer1.ServerReport.Refresh();
        }
        public void openReport5Param(string repPath, ReportParameter param1, ReportParameter param2, ReportParameter param3,ReportParameter param4,ReportParameter param5)
        {
            ReportServerCredentials cred = new ReportServerCredentials();
            ReportParameter[] p = new ReportParameter[] { param1, param2, param3,param4,param5};
            this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            this.ReportViewer1.ServerReport.SetParameters(p);
            this.ReportViewer1.ServerReport.Refresh();
        }

        public void openReportAndExport(string repPath, ReportParameter[] param, string format, string repFileName)
        {
            ReportServerCredentials cred = new ReportServerCredentials();
           this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            if (param != null)
                this.ReportViewer1.ServerReport.SetParameters(param);
            this.ReportViewer1.ServerReport.Refresh();

            // ---------- Output ---------- //
            byte[] returnValue;
            string mimeType = "";
            string extension = "";
            string deviceInfo = "";
            string encoding = "";
            string[] streams = null;
            Warning[] warnings = null;

            switch(format.ToLower())
            {
                case "pdf":
                    extension = "pdf";
                    mimeType = "application/pdf";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".pdf"));
                    break;

                case "excel":
                    extension = "xls";
                    mimeType = "application/excel";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".xls"));
                    break;

                case "excelopenxml":
                    extension = "xlsx";
                    mimeType = "application/excel";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".xlsx"));
                    break;

                    //
                    // The format is Office Open XML. 
                    // The content type of files generated by this renderer is 
                    // --  application/vnd.openxmlformats-officedocument.spreadsheetml.sheet 
                    // and the file extension of files is .xlsx.

                default:
                    extension = "pdf";
                    mimeType = "application/pdf";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".pdf"));
                    break;
            }

            returnValue = ReportViewer1.ServerReport.Render(format, deviceInfo, out mimeType, out encoding, out extension, out streams, out warnings);
            Response.Buffer = true;
            Response.Clear();

            Response.BinaryWrite(returnValue);
            Response.Flush();
            Response.End();
        }

        public void openReportAndView(string repPath, ReportParameter[] param, string format, string repFileName)
        {
            //ReportServerCredentials cred = new ReportServerCredentials();
            //this.ReportViewer1.ServerReport.ReportServerCredentials = cred;
            this.ReportViewer1.ProcessingMode = ProcessingMode.Remote;
            this.ReportViewer1.ServerReport.ReportPath = repPath;
            if (param != null)
                this.ReportViewer1.ServerReport.SetParameters(param);
            this.ReportViewer1.ServerReport.Refresh();

            // ---------- Output ---------- //
            byte[] returnValue;
            string mimeType = "";
            string extension = "";
            string deviceInfo = "";
            string encoding = "";
            string[] streams = null;
            Warning[] warnings = null;

            switch (format.ToLower())
            {
                case "pdf":
                    extension = "pdf";
                    mimeType = "application/pdf";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".pdf"));
                    break;

                case "excel":
                    extension = "xlsx";
                    mimeType = "application/excel";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".xlsx"));
                    break;

                default:
                    extension = "pdf";
                    mimeType = "application/pdf";
                    Response.ContentType = mimeType;
                    Response.AddHeader("content-disposition", "attachment; filename=" + Server.UrlEncode(repFileName + ".pdf"));
                    break;
            }

            returnValue = ReportViewer1.ServerReport.Render(format, deviceInfo, out mimeType, out encoding, out extension, out streams, out warnings);
            Response.Buffer = true;
            Response.Clear();

            Response.BinaryWrite(returnValue);
            Response.Flush();
            Response.End();
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }
    }
}