﻿using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Globalization;
using System.Data;
using System.Linq;
using System.Web;
using System.IO;
using System.Text;

namespace SMGO.aBiz
{
    public class DataService
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];




        public static string GenerateUpdateSQL(HttpRequestBase rs, string modifyBy, string pKeyFieldName, string pKeyValue = null)
        {
            string gFieldName = "", gSQL = "";

            for (int i = 0; i <= rs.Form.Count - 1; i++)
            {
                gFieldName = rs.Form.Keys[i];
                if (gFieldName != pKeyFieldName)
                {
                    if (gFieldName != gFieldName.ToUpper())
                    {
                        //Do nothing'
                        //-- Protect the field is not in our database , all our field is upper
                    }
                    else if (gFieldName.Substring(0, 1) == "_")
                    {
                        //Do nothing'
                    }
                    else if (gFieldName == "CREATE_DATE_TIME" || gFieldName == "CREATE_BY") // filter date
                    {
                        //Do nothing'
                    }
                    else if (gFieldName.Length >= 5 && gFieldName.Substring(gFieldName.Length - 5) == "_DATE") // filter date
                    {
                        string gDateStr = rs.Form[i].ToString();

                        gDateStr = DateValidation(gDateStr);

                        if (gDateStr.Length == 0)
                        {
                            gSQL = gSQL + "," + gFieldName + "=NULL";
                        }
                        else if (gDateStr.Length >= 8 && gDateStr.IndexOf('-') > 0)
                        {
                            gSQL = gSQL + "," + gFieldName + "=CONVERT(date,'" + gDateStr + "',120)";
                        }
                        else if (gDateStr.Length >= 8 && gDateStr.IndexOf('/') > 0 )
                        {
                            gSQL = gSQL + "," + gFieldName + "=CONVERT(date,'" + gDateStr + "',103)";
                        }

                    }
                    else if (gFieldName == "MODIFY_DATE_TIME" || (gFieldName.Length > 16 && gFieldName.Substring(gFieldName.Length - 16) == "UPDATE_DATE_TIME"))
                    {
                        gSQL = gSQL + "," + gFieldName + " = GETDATE() ";
                    }
                    else if (gFieldName == "MODIFY_BY" || (gFieldName.Length > 9 && gFieldName.Substring(gFieldName.Length - 9) == "UPDATE_BY"))
                    {
                        gSQL = gSQL + "," + gFieldName + "='" + modifyBy + "'";
                    }
                    else
                    {
                        string gValue = rs.Form[i].ToString();
                        if (gValue == "")
                        {
                            gSQL = gSQL + "," + gFieldName + "=NULL";
                        }
                        else
                        {
                            gSQL = gSQL + "," + gFieldName + "='" + gValue + "'";
                        }
                    }
                }
            }
            gSQL = "SET " + gSQL.Substring(1);

            if (pKeyFieldName.Length > 0 && pKeyValue == null)
            {
                gSQL = gSQL + " WHERE " + pKeyFieldName + " = '" + rs.Form[pKeyFieldName].ToString() + "'";
            }
            else if (pKeyFieldName.Length > 0 && pKeyValue.Length > 0)
            {
                gSQL = gSQL + " WHERE " + pKeyFieldName + " = '" + rs.Form[pKeyValue].ToString() + "'";
            }

            return gSQL;
        }

        //public static string DateValidation(string dateString)
        //{
        //    DateTime dDateValue;
        //    //if (DateTime.TryParse(dateString.ToString(), out dDateValue)) {
        //    //    return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
        //    //}
        //    //else 
        //    if (dateString.Length == 0)
        //    {
        //        return "";
        //    }
        //    else if (dateString.Length >= 8 && dateString.Length <= 10)
        //    {
        //        return dateString;
        //    }
        //    else if (dateString.Length >= 24)
        //    {
        //        dDateValue = DateTime.ParseExact(dateString.Substring(0, 24),
        //                     "ddd MMM d yyyy HH:mm:ss", CultureInfo.InvariantCulture);

        //        return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
        //    }
        //    else
        //    {
        //      return "";
        //    }
        //}

        public static string DateValidation(string dateString)
        {
            DateTime dDateValue;
            if (dateString.Length >= 24 && DateTime.TryParse(dateString.ToString(), out dDateValue))
            {
                return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
            }
            else
            {
                if (dateString.Length == 0)
                {
                    return "";
                }
                else if (dateString.Length >= 8 && dateString.Length <= 10)
                {
                    return dateString;
                }
                else if (dateString.Length >= 24)
                {
                    dDateValue = DateTime.ParseExact(dateString.Substring(0, 24),
                                "ddd MMM d yyyy HH:mm:ss", CultureInfo.InvariantCulture);

                    return dDateValue.Year + "-" + dDateValue.Month + "-" + dDateValue.Day;
                }
                else
                {
                    return "";
                }
            }
        }

        public static void UploadFileByLocation(HttpPostedFileBase File, String uploadLocation, String fileLocation)
        {
            //Create Directory If not exists
            FileInfo filePath = new FileInfo(uploadLocation);
            filePath.Directory.Create();

            //Save file to Directory
            File.SaveAs(fileLocation);

        }

        public static void DeleteFileByLocation(String fileLocation)
        {
            //Check fileLocation exists
            if (System.IO.File.Exists(fileLocation))
            {
                //Delete file from location
                System.IO.File.Delete(fileLocation);
            }
        }

        public static string MapUploadPath(string fileLocation)
        {
            //NMT QA Server mappath
            string newLocation;
            if (ConfigurationManager.AppSettings["ServerLocation"] == "NMT")
            {
                newLocation = aControl.Cons.SERVER_NAME_PRODUCTION + (fileLocation).Replace("~", "").Replace("/", "\\").Replace("'", "''");
            }
            else if (ConfigurationManager.AppSettings["ServerLocation"] == "QA")
            {
                newLocation = aControl.Cons.SERVER_NAME_QA + (fileLocation).Replace("~", "").Replace("/", "\\").Replace("'", "''");
            }
            else
            {
               newLocation = HttpContext.Current.Server.MapPath(fileLocation);
            }

            return newLocation;
        }
        
        public static void WriteFileToSAP(DataTable dt, string type, string vmetype, string paymenttype)
        {
            DataService dataservice = new DataService();
            string writeLocation = System.Web.HttpContext.Current.Server.MapPath("~/ftp/O/SAP/");
            // string fileName = fileNamePrefix + "_" + DateTime.Now.ToString("yyyyMMddHHmmssfff") + ".DAT";
            string fileName = dataservice.GetFileName(type, vmetype, paymenttype);
            string fileLocation = writeLocation + fileName;

            int lineAmount = 0;
            //string textToFile;
            //byte[] bytes;
            string textFromDB;

            if(dt.Rows.Count > 0)
            {
                //Create Directory If not exists
                FileInfo filePath = new FileInfo(writeLocation);
                filePath.Directory.Create();

                using (System.IO.StreamWriter file = new System.IO.StreamWriter(fileLocation, true))
                {
                    foreach (DataRowView dr in dt.DefaultView)
                    {
                        lineAmount = lineAmount + (int)dr["DETAIL_COUNT"];

                        if (lineAmount <= 990)
                        {
                            textFromDB = dr["TEXT"].ToString();
                            //bytes = ascii.GetBytes(textFromDB);
                            //textToFile = ascii.GetString(bytes);
                            file.WriteLine(textFromDB);
                            dr.Row.Delete();
                        }
                        else
                        {
                            dt.AcceptChanges();
                            WriteFileToSAP(dt, type, vmetype, paymenttype);
                            break;
                        }
                    }

                    //foreach (DataRow row in dt.Rows)
                    //{
                    //    file.WriteLine(row["TEXT"].ToString());
                    //    row.Delete();
                    //}
                }
                
                    
                //Send FTP
                FTPService ftp = new FTPService();
                ftp.AsyncFtpUpLoader(fileName, fileLocation);

            }

        }
        private string GetFileName(string type, string vmetype, string paymenttype)
        {
            DataTable dt = new DataTable();
            gSQL = @"EXEC sp_IF_GetFilename '{0}','{1}','{2}'";
            gSQL = String.Format(gSQL, type, vmetype, paymenttype);
            dt = odb.SqlQuery(gSQL, mDBName);
            string gPrefix = dt.Rows[0]["FILE_PREFIX"].ToString();
            string gPostfix = dt.Rows[0]["FILE_POSTFIX"].ToString();
            string gFileName = gPrefix + DateTime.Now.ToString("yyyyMMddHHmmssfff") + gPostfix;
            return gFileName;
        }

        public static string ConvertFileNameToGUID(string curFileName)
        {
            var getGUID = Guid.NewGuid().ToString().Replace("-", "").ToUpper();
            var typeFile = curFileName.Substring(curFileName.LastIndexOf('.'), curFileName.Length - curFileName.LastIndexOf('.'));
            return getGUID + typeFile;
        }
    }
}