﻿using SMGO.aBiz;
using SMGO.aControl;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.OleDb;
using System.Linq;
using System.Web;

namespace SMGO.aBiz
{
    public class VMEService
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["BizDBName"];
        private String sysDBName = ConfigurationManager.AppSettings["SysDBName"];

        //----------------------------------------------------------------

        public string GetCampaignPeriodInfo(string id)
        {
            string gInfo;
            DataTable dt = new DataTable();

            gSQL = "SELECT [PERIOD_NAME] FROM [dbo].[TBL_CMP_Period] WHERE ID = {0}";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);
            gInfo = dt.Rows[0]["PERIOD_NAME"].ToString();
            return gInfo;
        }
        public string GetDemoCarPeriodInfo(string id)
        {
            string gInfo;
            DataTable dt = new DataTable();
            gSQL = "SELECT [PERIOD_NAME] FROM [dbo].[TBL_DMC_Period] WHERE ID = {0}";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            gInfo = dt.Rows[0]["PERIOD_NAME"].ToString();
            return gInfo;
        }

        public DataTable GetIncentivePeriodInfo(string m, string y)
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC [sp_INC_Period_ListByID] '{0}', '{1}'";
            gSQL = String.Format(gSQL, m, y);
            dt = odb.SqlQuery(gSQL, mDBName);

            return dt;
        }

        public string GetFleetPeriodInfo(string id)
        {
            string gInfo;
            DataTable dt = new DataTable();

            gSQL = "SELECT [PERIOD_NAME] FROM [dbo].[TBL_FLT_Period] WHERE ID = {0}";
            gSQL = String.Format(gSQL, id);
            dt = odb.SqlQuery(gSQL, mDBName);

            gInfo = dt.Rows[0]["PERIOD_NAME"].ToString();
            return gInfo;
        }


        public void GenFleetProgram(string id)
        {
            gSQL = "EXEC [dbo].[sp_FLT_Fleet_Monthly_Program_Gen] '{0}','{1}'";
            gSQL = String.Format(gSQL, id, "SYS");
            odb.SqlExecute(gSQL, mDBName);
        }

        public void ImportToGrid(string pFilePath, string pExtension, string isHDR, string pUserID, string pJobName)
        {
            // Insert to database
            gSQL = "EXEC [sp_ImportXLSX_BatchScan] '{0}','{1}','{2}','{3}'";
            gSQL = String.Format(gSQL, pFilePath, "SCAN", pUserID, pJobName);
            odb.SqlExecute(gSQL, mDBName);

        }

        //----------------------------------------------------------------
        public DataTable GetSourceType()
        {
            DataTable dt = new DataTable();

            gSQL = "EXEC sp_SourceType_Get";
            dt = odb.SqlQuery(gSQL, mDBName);

            return dt;
        }

        public string SendEmailToRevision(string vmeType, string emailType, string step, string emailTitle, string emailContent)
        {
            DataTable dt = new DataTable();
            string returnString = "Failed";
            string emailTo = "";
            string emailCC = "";
            string emailBCC = "";

            gSQL = String.Format("EXEC [sp_SYS_Email_Configure] '{0}','{1}','{2}'"
                                , vmeType
                                , emailType
                                , step);
            dt = odb.SqlQuery(gSQL, sysDBName);

            if (dt.Rows.Count > 0)
            {
                DataRow row = dt.Rows[0];
                emailTo = String.Concat(emailTo, ';', row["LIST_OF_EMAIL_TO"]).Trim(';');
                emailCC = String.Concat(emailCC, ';', row["LIST_OF_EMAIL_CC"]).Trim(';');
                emailBCC = String.Concat(emailBCC, ';', row["LIST_OF_EMAIL_BCC"]).Trim(';');
                odb.WriteLog("Email", "To:" + emailTo + " | " + "CC:" + emailCC + " | " + "Title: " + emailTitle + " | " + emailContent, gSQL);
                returnString = EmailSender.Email(emailTo, emailCC, emailBCC, emailTitle, emailContent);
            }
            else
            {
                odb.WriteLog("Email", "Unable to send email, because no configure is defined", gSQL);
            }

            return returnString;
        }


        public string SendEmailTo(string positionName
                                , string managerRoleID
                                , string DepartmentName
                                , string emailCC
                                , string DepartmentCCName
                                , string emailTitle
                                , string emailContent
                                , string emailToSpecific = null)
        {
            DataTable dt = new DataTable();
            string returnString = "Failed";
            string emailTo;
			string emailBCC = "samart.dan@nissan.co.th;chanatcha.uam@nissan.co.th";
            string[] positons = (positionName == null) ? null : positionName.Split(',');
            string[] Departments = (DepartmentName == null) ? null : DepartmentName.Split(',');
            string[] DepartmentsCC = (DepartmentCCName == null) ? null : DepartmentCCName.Split(',');

            gSQL = "EXEC sp_User_Send_Email {0},{1},{2},{3},{4},{5}";
            gSQL = String.Format(gSQL
                                , (positionName == null) ? "null" : "'''" + string.Join("'',''", positons) + "'''"
                                , (managerRoleID == null || managerRoleID == "") ? "null" : managerRoleID
                                , (DepartmentName == null) ? "null" : "'''" + string.Join("'',''", Departments) + "'''"
                                , (DepartmentCCName == null) ? "null" : "'''" + string.Join("'',''", DepartmentsCC) + "'''"
                                , (emailToSpecific == null) ? "null" : "'" + emailToSpecific + "'"
                                , (HttpContext.Current.Session[Cons.SS_USER_DEPT].ToString() == "") ? "null" : HttpContext.Current.Session[Cons.SS_USER_DEPT].ToString()
                                );
            dt = odb.SqlQuery(gSQL, sysDBName);

            if (dt.Rows.Count > 0)
            {
                emailTo = dt.Rows[0]["Emails"].ToString();
                emailCC = dt.Rows[0]["Emails_CC"].ToString() + ";" + emailCC;
                odb.WriteLog("Email", "To:" + emailTo + " | " + "CC:" + emailCC + " | " + "Title: " + emailTitle + " | " + emailContent, gSQL);
                returnString = EmailSender.Email(emailTo, emailCC, emailBCC, emailTitle, emailContent);
            }
            else
            {
                odb.WriteLog("Email", "Cannot send email to 0 persons.", gSQL);
            }

            return returnString;
        }

        public void sendEmailInterfaceError()
        {
            string emailTo = "samart.dan@nissan.co.th;chanatcha.uam@nissan.co.th;koolapong@smartgosd.com";
            string emailCC = "samart@smartgosd.com;chanatcha@smartgosd.com;koolapong@smartgosd.com";
            string emailTitle = "Interface layout error found!";
            string emailContent = "System found another error in interface layout, please check.";

            odb.WriteLog("Email Interface error", "To:" + emailTo + " | " + "CC:" + emailCC + " | " + "Title: " + emailTitle + " | " + emailContent, gSQL);

            EmailSender.Email(emailTo, emailCC, "", emailTitle, emailContent);

        }

    }
}