﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;

namespace SMGO.aControl
{
	public class DBManager
	{

		public DataTable SqlQuery(String pSQL,String DBName)
		{
			DataTable dt = new DataTable();
			string mDBConnection;

			mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
							+ ";database=" + DBName
							+ ";UID=" +  ConfigurationManager.AppSettings["DBUser"]
							+ ";password=" + ConfigurationManager.AppSettings["DBPassword"];

			using (SqlConnection conn = new SqlConnection(mDBConnection))
			{
				try
				{
					SqlCommand cmd = new SqlCommand(pSQL, conn);
					conn.Open();
                    cmd.CommandTimeout = 0;
                    SqlDataReader rdr = cmd.ExecuteReader(CommandBehavior.CloseConnection);
					dt.Load(rdr);
				}
				catch (SqlException ex)
				{
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);

				}

				catch (Exception ex)
				{
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
				}

				finally
				{
					conn.Close();
				}
				return dt;
			}
		}


        public DataSet SqlQueryDS(String pSQL, String DBName)
        {
            DataSet ds = new DataSet();
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + DBName
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];

            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    SqlCommand cmd = new SqlCommand(pSQL, conn);
                    conn.Open();
                    cmd.CommandTimeout = 0;
                   // var command = new SqlCommand(InitializeQuery(), conn);
                    var adapter = new SqlDataAdapter(cmd);

                    adapter.Fill(ds);
                }
                catch (SqlException ex)
                {
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return ds;
            }
        }

        public int SqlExecute(String pSQL, String DBName)
		{
			int rowEffect = 0;
			string mDBConnection;

			mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
							+ ";database=" + DBName // ConfigurationManager.AppSettings["DBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
							+ ";password=" + ConfigurationManager.AppSettings["DBPassword"];
			using (SqlConnection conn = new SqlConnection(mDBConnection))
			{
				try
				{
					SqlCommand command = new SqlCommand(pSQL, conn);
					command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
				}
				catch (SqlException ex)
				{
                    // handle error
                    WriteLog("SqlException", ex.Message, pSQL);
                    throw (ex);
				}

				catch (Exception ex)
				{
                    // handle error
                    WriteLog("Exception", ex.Message, pSQL);
                    throw (ex);
				}

				finally
				{
					conn.Close();
				}
				return rowEffect;
			}
        }


        public int WriteLog( String pType , String pMsg, String pEvd)
        {
            int rowEffect = 0;
            string mDBConnection;

            mDBConnection = "server=" + ConfigurationManager.AppSettings["DBServer"]
                            + ";database=" + ConfigurationManager.AppSettings["SysDBName"]
                            + ";UID=" + ConfigurationManager.AppSettings["DBUser"]
                            + ";password=" + ConfigurationManager.AppSettings["DBPassword"];
            using (SqlConnection conn = new SqlConnection(mDBConnection))
            {
                try
                {
                    string gSQL;
                    HttpContext ctx = HttpContext.Current;
                    string gUserID = (ctx.Session[Cons.SS_USER_ID] != null) ? ctx.Session[Cons.SS_USER_ID].ToString() : "null";

                    pType = pType.Replace("'", "''");
                    pMsg = pMsg.Replace("'", "''");
                    pEvd = pEvd.Replace("'", "''");

                    gSQL = "EXEC sp_SYS_Write_Log '{0}','{1}','{2}',{3}";
                    gSQL = String.Format(gSQL, pType, pMsg, pEvd, gUserID);

                    SqlCommand command = new SqlCommand(gSQL, conn);
                    command.Connection.Open();
                    command.CommandTimeout = 0;
                    command.ExecuteNonQuery();
                }
                catch (SqlException ex)
                {
                    // handle error
                    throw (ex);
                }

                catch (Exception ex)
                {
                    // handle error
                    throw (ex);
                }

                finally
                {
                    conn.Close();
                }
                return rowEffect;
            }
        }
    }
}
