﻿
app.controller("CampaignMainController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        // GetHeader();
        GetData();
    }

    $scope.Prevoius_Month = function () {
        $scope.periodMonth--;
        if ($scope.periodMonth == 0) {
            $scope.periodMonth = 12;
            $scope.periodYear--;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.Next_Month = function () {
        $scope.periodMonth++;
        if ($scope.periodMonth == 13) {
            $scope.periodMonth = 1;
            $scope.periodYear++;
        }
        $scope.gMonthName = BizDataService.GetMonthName($scope.periodMonth);
        GetData();
    }

    $scope.LinkToPayment_Click = function (row) {


    }

    $scope.LinkToRecon_Click = function (row) {


    }

    // function GetHeader() {

    //     BaseService.GetHeaderGridView('InceitveConfigApproval')
    //         .then(function (result) {
    //             $scope.ListHeader2 = result;
    //         }, function (error) {
    //             console.log('Unable to load header data: ' + error.message)
    //         })
    // }

    function GetData() {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth.toString()).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, 'GetDash', data)
            .then(function (result) {
                $scope.ListVolume = result.Table;
                $scope.ListLeasingVolume = result.Table1;
                $scope.ListInsuranceVolume = result.Table2;
                $scope.ListDetail = result.Table3;
                $scope.ListAccrue = result.Table4;
                $scope.ListPayment = result.Table5;
                $scope.ListReconcile = result.Table6;

            }, function (error) {
                console.log('Unable to load campaign dashboard data: ' + error.message)
            })

    }

    function GetSummary(listData) {
        var sumUnit = 0;
        for (var idx in listData) {
            sumUnit = sumUnit + listData[idx]['VOLUME'];
        }
        $scope.sumUnit = sumUnit;
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

}])

app.controller("PeriodCampaignController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, $filter) {

    Opening();

    //BaseService.Message.alert('Are you sure you want to delete this customer?')

    function Opening() {
        $scope.formData = {};
        $scope.periodDisable = false;
        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("PeriodCampaignList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function GetData() {
        $scope.copyDataFrom = null;
        BaseService.GetDataTable(CAMPAIGN_PATH, "GetPeriodCampaignList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.copyDataFrom = null;
        $scope.formData = {};
        $scope.formData.ID = 0;
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.Add_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning('Announce cannot empty.'); /*Tidtee edit 12/09/2017*/
            return;
        }

        if ($scope.formData.START_DATE == null || $scope.formData.START_DATE == '' ||
            $scope.formData.END_DATE == null || $scope.formData.END_DATE == '') {
            BaseService.Message.warning('The Start date and End date cannot empty.');
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date"); /*Tidtee edit 12/09/2017*/
            return;
        }

        let addPeriod = function (data) {
            BaseService.CallAction(CAMPAIGN_PATH, "CheckPeriodCampaignExist", data)
                .then(function (result) {
                    if (result[0]["TOTAL"] == 0) {
                        BaseService.CallAction(CAMPAIGN_PATH, "AddPeriodCampaign", data)
                            .then(function (result) {
                                document.getElementById('DetailModal').style.display = 'none';
                                GetData();
                                BaseService.Message.info('Successfully saved.');
                            })
                    } else {
                        BaseService.Message.info('The Start date and End date have already exist.');
                    }
                }, function (error) {
                    console.log('Unable to check data: ' + error.message)
                })
        }

        if ($scope.copyDataFrom && $scope.copyDataFrom != null) {
            let copyFromTitle = $scope.copyDataFrom.PERIOD_NAME;
            BaseService.Message.confirm("Would you like to copy data from " + copyFromTitle).then(function (ret) {
                $scope.formData._CopyDataFrom = $scope.copyDataFrom.ID;
                var data = BaseService.ConvertParam($scope.formData);
                addPeriod(data)
            })
        } else {
            var data = BaseService.ConvertParam($scope.formData);
            addPeriod(data)
        }

    }
    $scope.Edit_Submit = function () {

        if ($scope.formData.PERIOD_NAME == null || $scope.formData.PERIOD_NAME == '') {
            BaseService.Message.warning('Announce cannot empty.'); /*Tidtee edit 12/09/2017*/
            return;
        }

        if (Date.parse($scope.formData.END_DATE) < Date.parse($scope.formData.START_DATE)) {
            BaseService.Message.warning("End date is less than Start date");
            return;
        }

        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(CAMPAIGN_PATH, "EditPeriodCampaign", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved.');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit data: ' + error.message)
            })
    }

    $scope.Delete_Submit = function () {

        let data = BaseService.ConvertParam({
            "ID": $scope.formData.ID
        })

        BaseService.CallAction(CAMPAIGN_PATH, "DeletePeriodCampaign", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved.');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        $scope.copyDataFrom = null;
        $scope.formData.ID = ID;
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetPeriodCampaignList", ID, { id: ID })
            .then(function (result) {
                $scope.formData = result[0]
                $scope.periodDisable = (result[0].REVIEW_STATUS == 'Approved') ? true : false;
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }


    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }

    $scope.Approve_Submit = function (obj, type, PERIOD_NAME) {

        BaseService.Message.confirm("Would you like to \"" + type + "\" this?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj.ID, "TYPE": type, "period_name": PERIOD_NAME });

            BaseService.CallAction(CAMPAIGN_PATH, "ApproveSubmit", data)
                .then(function (result) {
                    GetData();
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }
    //NEW
    $scope.SendPeriod = function (obj, type, PERIOD_NAME) {
        BaseService.Message.confirm("Would you like to \"" + type + "\" this for approve?").then(function () {
            const data = BaseService.ConvertParam({ "ID": obj, "TYPE": type, "period_name": PERIOD_NAME });

            BaseService.CallAction(CAMPAIGN_PATH, "Send_Period_Check", data)
                .then(function (result) {
                    var SendPeriod = function (data) {
                        BaseService.CallAction(CAMPAIGN_PATH, "Send_Period", data)
                            .then(function (result) {
                                GetData();
                            }, function (error) {
                                console.log('Unable to submit send period: ' + error.message);
                            })
                    }
                    if (result == "Done") {
                        SendPeriod(data);
                    } else if (result == "Fail to Send") {
                        BaseService.Message.confirm("This configure is not finished. Are you sure to send for approve?").then(function () {
                            SendPeriod(data);
                        })
                    }
                }, function (error) {
                    console.log('Unable to check for send period: ' + error.message);
                })
        })
    }
    //NEW

    $scope.Report_Click = function (row) {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");
        $scope.reportCode = 'VME_Rpt_CMP_CFG_Detail';
        $scope.reportName = 'Campaign configuration';
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + row.ID + '&p2=' + $scope.reportName, '_blank');
    }

    $scope.CreateCopyAnnouce = function (copyFrom) {
        $scope.copyDataFrom = copyFrom;
        $scope.formData = {};
        $scope.formData.ID = 0;
        document.getElementById('DetailModal').style.display = 'block';
    }
}])

app.controller("CampaignListController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'CONFIG_PATH', '$filter', 'REPORT_PATH', 'Upload', '$timeout', function ($scope, BaseService, CAMPAIGN_PATH, CONFIG_PATH, $filter, REPORT_PATH, Upload, $timeout) {

    Opening();

    function Opening() {
        $scope.formData = {};

        $scope.selector = [];
        $scope.remover = [];
        $scope.filter = {
            BASE_MODEL: null
        };
        $scope.periodID = null;
        $scope.BaseFilter = '';
        $scope.Mode = 1; // 1 = show ; 2 = add
        $scope.ModeAddCampaign = false;
        $scope.AddDetail = false;
        $scope.periodDisable = false;
        //GetGroup();
        GetData();
        GetModelList();
        GetModelHeaderList();

    }

    function GetData() {
        var sendData = [{ "CURRENT_PERIOD_ID": ($scope.periodID) ? $scope.periodID : 0 }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignDetail", data)
            .then(function (result) {
                $scope.ListGroup = result.Table
                $scope.ListDetail = result.Table1;
                if (typeof (result.Table1[0]) != 'undefined') {
                    $scope.periodID = result.Table1[0].PERIOD_ID;
                    $scope.periodDisable = (result.Table1[0].REVIEW_STATUS == 'Approved' || result.Table1[0].REVIEW_STATUS == 'Send') ? true : false;
                }
                $scope.BaseModelList = result.Table2;
                $scope.ErrorList = result.Table3
                $scope.HighlightUploadNPP = $scope.ErrorList.length > 0;

            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialActive", data)
            .then(function (result) {
                $scope.ListSpecial = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.AddMode_Click = function () {
        $scope.Mode = 2;
    }

    $scope.ShowMode_Click = function () {
        $scope.Mode = 1;
    }

    $scope.FilterModel_Click = function (BaseModel) {
        $scope.BaseFilter = BaseModel;
    }

    // ----------------- Group --------------------
    $scope.AddNewGroup_Click = function () {
        document.getElementById('GroupModal').style.display = 'block';
        document.getElementsByName('CAMPAIGN_MODEL_NO')[0].focus();
        $scope.filter = {};
        $scope.filter2 = {};
        $scope.Group = {};
        $scope.Group.ID = 0;
        $scope.selector = [];
        $scope.remover = [];
        $scope.Group.CAMPAIGN_MODEL_NO = $scope.ListGroup.length + 1;

        GetSelectedList(0);
        GetNotSelectedList(0);
        $scope.Mode = 1;
        $scope.ModeAddCampaign = true;
    }

    $scope.ShowGroup_Click = function (ID) {
        document.getElementById('GroupModal').style.display = 'block';
        document.getElementsByName('CAMPAIGN_MODEL_NO')[0].focus();
        $scope.filter = {};
        $scope.filter2 = {};
        $scope.selector = [];
        $scope.remover = [];
        GetSelectedList(ID);
        GetNotSelectedList(ID);
        $scope.Mode = 1;
        $scope.ModeAddCampaign = false;
        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetCampaignModelByID", ID, { id: ID })
            .then(function (result) {
                $scope.Group = result[0]
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.SaveGroup_Click = function () {

        if ($scope.Group.CAMPAIGN_MODEL_NO == null || $scope.Group.CAMPAIGN_MODEL_NO == '') {
            BaseService.Message.info('The campaign number cannot empty.');
            return;
        }

        if ($scope.Group.CAMPAIGN_MODEL_NAME == null || $scope.Group.CAMPAIGN_MODEL_NAME == '') {
            BaseService.Message.info('The campaign name cannot empty.');
            return;
        }

        $scope.Group.ModelID = [];

        $scope.SelectedList.forEach(function (itemList) {
            const itemListID = '\'\''
                + ((itemList.SALES_END_ITEM != null) ? itemList.SALES_END_ITEM : '')
                + ((itemList.OPTION_CODE != null) ? itemList.OPTION_CODE : '')
                + '\'\'';
            $scope.Group.ModelID.push(itemListID);
        })

        var data = BaseService.ConvertParam($scope.Group, "ModelID");

        BaseService.CallAction(CAMPAIGN_PATH, "SaveCampaignModel", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            })
    }

    $scope.DeleteGroup_Click = function () {
        BaseService.Message.confirm("Would you like to remove this group?").then(function () {
            var data = BaseService.ConvertParam({ "ID": $scope.Group.ID })
            BaseService.CallAction(CAMPAIGN_PATH, "DeleteCampaignGroup", data)
                .then(function (result) {
                    // GetGroup();
                    GetData();
                    document.getElementById('GroupModal').style.display = 'none';
                })
        })
    }

    $scope.CloseSaveGroup_Click = function (ID) {
        document.getElementById('GroupModal').style.display = 'none';
    }

    $scope.ToggleToSelector = function (thisItem) {

        const thisItemID = ((thisItem.SALES_END_ITEM != null) ? thisItem.SALES_END_ITEM : '')
            + ((thisItem.OPTION_CODE != null) ? thisItem.OPTION_CODE : '');

        let thisElement = document.getElementById(thisItemID);


        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.ToggleToRemover = function (thisItem) {

        const thisItemID = ((thisItem.SALES_END_ITEM != null) ? thisItem.SALES_END_ITEM : '')
            + ((thisItem.OPTION_CODE != null) ? thisItem.OPTION_CODE : '');

        let thisElement = document.getElementById(thisItemID);

        if (!thisElement.classList.contains("selected")) {
            $scope.remover.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.remover.splice($scope.remover.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.AddModel_Click = function () {
        $scope.selector.forEach(function (item) {
            let thisItem = $filter('filter')($scope.NotSelectedList, $scope.ModelIDFilter(item))[0];
            let thisIndex = $scope.NotSelectedList.indexOf(thisItem);

            $scope.SelectedList.push(thisItem);
            $scope.NotSelectedList.splice(thisIndex, 1);
        })
        $scope.selector = [];

        $scope.Mode = 1;
    }

    $scope.RemoveModel_Click = function () {
        $scope.remover.forEach(function (item) {
            let thisItem = $filter('filter')($scope.SelectedList, $scope.ModelIDFilter(item))[0];
            let thisIndex = $scope.SelectedList.indexOf(thisItem);

            $scope.NotSelectedList.push(thisItem);
            $scope.SelectedList.splice(thisIndex, 1);
        })
        $scope.remover = [];
    }

    $scope.AddAllLeft_Click = function () {
        const AllItem = $filter('filter')($scope.NotSelectedList, $scope.filter2);

        AllItem.forEach(function (thisItem) {
            let thisIndex = $scope.NotSelectedList.indexOf(thisItem);

            $scope.SelectedList.push(thisItem);
            $scope.NotSelectedList.splice(thisIndex, 1);
        })
        $scope.Mode = 1;
    }

    $scope.AddAllRight_Click = function () {
        const AllItem = $filter('filter')($scope.SelectedList, $scope.filter);

        AllItem.forEach(function (thisItem) {
            let thisIndex = $scope.SelectedList.indexOf(thisItem);

            $scope.NotSelectedList.push(thisItem);
            $scope.SelectedList.splice(thisIndex, 1);
        })
    }

    $scope.ModelIDFilter = function (item) {
        return function (input) {
            return (((input.SALES_END_ITEM != null) ? input.SALES_END_ITEM : '') + ((input.OPTION_CODE != null) ? input.OPTION_CODE : '')) === item
        }
    }

    $scope.NotSelectedRowClass = function (row) {

        const thisItemID = ((row.SALES_END_ITEM != null) ? row.SALES_END_ITEM : '')
            + ((row.OPTION_CODE != null) ? row.OPTION_CODE : '');

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = ((row.SALES_END_ITEM != null) ? row.SALES_END_ITEM : '')
            + ((row.OPTION_CODE != null) ? row.OPTION_CODE : '');

        if ($scope.remover.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }
    //----------------------------------------------------------------------------
    //------------------------ Detail -------------------------------------------
    $scope.AddNewDetail_Click = function (GroupID) {
        $scope.AddDetail = true;
        $scope.Detail = {
            "DEALER_CLAIM_AMOUNT": 0,
            "LEASING_AMOUNT": 0,
            "AFTER_SALES_CLAIM_AMOUNT": 0,
        };

        $scope.Detail.ID = 0;
        $scope.Detail.CAMPAIGN_MODEL_ID = GroupID;
        document.getElementById('DetailModal').style.display = 'block';
        document.getElementsByName('CAMPAIGN_NO')[0].focus();
        $scope.GetCampaignDetailByID($scope.Detail.ID, $scope.Detail.CAMPAIGN_MODEL_ID);
    }

    $scope.ShowDetail_Click = function (ID, CAMPAIGN_MODEL_ID) {
        $scope.AddDetail = false;
        document.getElementById('DetailModal').style.display = 'block';
        document.getElementsByName('CAMPAIGN_NO')[0].focus();
        $scope.GetCampaignDetailByID(ID, CAMPAIGN_MODEL_ID);
    }
    $scope.GetCampaignDetailByID = function (ID, ModelID) {
        var data = BaseService.ConvertParam({
            id: ID,
            modelID: ModelID
        })
        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignDetailByID", data)
            .then(function (result) {
                (result.Table[0]) ? $scope.Detail = result.Table[0] : null;
                $scope.ModelNPPList = result.Table1;
                $scope.DetailTitle = $filter('filter')($scope.ListGroup, { ID: ModelID }, true)[0].CAMPAIGN_MODEL_NAME;
                $scope.CSC1_CHECK = ($scope.Detail.CSC1_ID != null && $scope.Detail.CSC1_ID != '');
                $scope.CSC2_CHECK = ($scope.Detail.CSC2_ID != null && $scope.Detail.CSC2_ID != '');
                $scope.CSC3_CHECK = ($scope.Detail.CSC3_ID != null && $scope.Detail.CSC3_ID != '');
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.SaveDetail_Click = function () {

        if ($scope.Detail.CAMPAIGN_NO == null || $scope.Detail.CAMPAIGN_NO == '') {
            console.log($scope.Detail.CAMPAIGN_NO);
            BaseService.Message.info('The campaign number cannot empty.');
            return;
        }

        if ($scope.Detail.CAMPAIGN_CODE == null || $scope.Detail.CAMPAIGN_CODE == '') {
            console.log($scope.Detail.CAMPAIGN_CODE);
            BaseService.Message.info('The campaign code cannot empty.');
            return;
        }

        if ($scope.Detail.CAMPAIGN_NAME == null || $scope.Detail.CAMPAIGN_NAME == '') {
            console.log($scope.Detail.CAMPAIGN_NAME);
            BaseService.Message.info('The campaign name cannot empty.');
            return;
        }

        if (!$scope.Detail.DO_CHECK) {
            $scope.Detail.DO_FROM_DATE = '';
            $scope.Detail.DO_TO_DATE = '';
        }

        if (!$scope.Detail.APP_CHECK) {
            $scope.Detail.APP_FROM_DATE = '';
            $scope.Detail.APP_TO_DATE = '';
        }

        if (!$scope.Detail.BOOKING_CHECK) {
            $scope.Detail.BOOKING_FROM_DATE = '';
            $scope.Detail.BOOKING_TO_DATE = '';
        }

        if (!$scope.Detail.CLOSING_CHECK) {
            $scope.Detail.CLOSING_FROM_DATE = '';
            $scope.Detail.CLOSING_TO_DATE = '';
        }

        var data = BaseService.ConvertParam($scope.Detail);
        BaseService.CallAction(CAMPAIGN_PATH, "SaveCampaignDetail", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            })
    }

    $scope.DeleteDetail_Click = function () {
        BaseService.Message.confirm("Would you like to remove this promotion?").then(function () {
            var data = BaseService.ConvertParam({ "ID": $scope.Detail.ID })
            BaseService.CallAction(CAMPAIGN_PATH, "DeleteCampaignDetail", data)
                .then(function (result) {
                    GetData();
                    document.getElementById('DetailModal').style.display = 'none';
                })
        })
    }

    $scope.CloseDetail_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }
    $scope.UseSpecail_Change = function () {
    }
    $scope.GetListCheck1 = function (value, isChecked) {
        $scope.CSC1_CHECK = isChecked;
        if ($scope.CSC1_CHECK) {
            $scope.Detail.CSC1_ID = value;
        } else {
            $scope.Detail.CSC1_ID = 0;
        }
    }
    $scope.GetListCheck2 = function (value, isChecked) {
        $scope.CSC2_CHECK = isChecked;
        if ($scope.CSC2_CHECK) {
            $scope.Detail.CSC2_ID = value;
        } else {
            $scope.Detail.CSC2_ID = 0;
        }
    }
    $scope.GetListCheck3 = function (value, isChecked) {
        $scope.CSC3_CHECK = isChecked;
        if ($scope.CSC3_CHECK) {
            $scope.Detail.CSC3_ID = value;
        } else {
            $scope.Detail.CSC3_ID = 0;
        }
    }
    //-------------------------------------------------------------

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.OrderColumnSelected = function (pColName) {
        $scope.sortTypeSelected = pColName;
        $scope.sortReverseSelected = !$scope.sortReverseSelected;
    };

    $scope.OrderColumnNotSelected = function (pColName) {
        $scope.sortTypeNotSelected = pColName;
        $scope.sortReverseNotSelected = !$scope.sortReverseNotSelected;
    };

    $scope.openBooking1Date = function () {
        $scope.popupBooking1Date.opened = true;
    }

    $scope.popupBooking1Date = {
        opened: false
    }

    $scope.openBooking2Date = function () {
        $scope.popupBooking2Date.opened = true;
    }

    $scope.popupBooking2Date = {
        opened: false
    }

    $scope.openApp1Date = function () {
        $scope.popupApp1Date.opened = true;
    }

    $scope.popupApp1Date = {
        opened: false
    }

    $scope.openApp2Date = function () {
        $scope.popupApp2Date.opened = true;
    }

    $scope.popupApp2Date = {
        opened: false
    }

    $scope.openDo1Date = function () {
        $scope.popupDo1Date.opened = true;
    }

    $scope.popupDo1Date = {
        opened: false
    }

    $scope.openDo2Date = function () {
        $scope.popupDo2Date.opened = true;
    }

    $scope.popupDo2Date = {
        opened: false
    }


    $scope.openClosing1Date = function () {
        $scope.popupClosing1Date.opened = true;
    }

    $scope.popupClosing1Date = {
        opened: false
    }

    $scope.openClosing2Date = function () {
        $scope.popupClosing2Date.opened = true;
    }

    $scope.popupClosing2Date = {
        opened: false
    }

    //------------------- Group popup ------------------------------
    function GetModelHeaderList() {
        BaseService.GetHeaderGridView("ModelHeaderList")
            .then(function (result) {
                $scope.ModelHeaderList = result
            }, function (error) {
                console.log('Unable to load ModelListHeader data: ' + error.message)
            })

        BaseService.GetHeaderGridView("ModelHeaderListWithNPP")
            .then(function (result) {
                $scope.ModelHeaderListWithNPP = result
            }, function (error) {
                console.log('Unable to load ModelListHeader data: ' + error.message)
            })
    }
    function GetSelectedList(ID) {
        $scope.SelectedList = [];
        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetCampaignModelSelectedList", ID)
            .then(function (result) {
                $scope.SelectedList = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetNotSelectedList(ID) {
        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetCampaignModelNotSelectedList", ID)
            .then(function (result) {
                $scope.NotSelectedList = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.ModelList = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    $scope.Approve_Submit = function (type) {
        BaseService.Message.confirm("Would you like to \"" + type + "\" this period?").then(function () {
            const data = BaseService.ConvertParam({ "ID": $scope.periodID, "TYPE": type });

            BaseService.CallAction(CAMPAIGN_PATH, "ApproveSubmit", data)
                .then(function (result) {
                    console.log(result);
                }, function (error) {
                    console.log('Unable to submit approval: ' + error.message);
                })
        })
    }

    $scope.showGenerateBtn = function (id) {
        let matchedListDetail = $filter('filter')($scope.ListDetail, { CAMPAIGN_MODEL_ID: id }, true);
        return (matchedListDetail.length == 0 || typeof (matchedListDetail) == 'undefined');
    }

    $scope.generateCampaignDetail = function (obj) {
        let id = obj.ID;
        BaseService.Message.confirm("Would you like to generate campaign detail of " + obj.CAMPAIGN_MODEL_NAME + "?").then(function () {
            BaseService.CallAction(CAMPAIGN_PATH, 'GenerateCampaignDetail', BaseService.ConvertParam({ "CAMPAIGN_MODEL_ID": id }))
                .then(function (result) {
                    BaseService.Message.info("Generate Successfully").then(function () {
                        GetData();
                    })
                }, function (error) {
                    console.log('Unable to generate campaign detail: ' + error.message);
                })
        })
    }

    $scope.DownloadCampaign = function (id) {
        let reportCode = "VME_Rpt_CMP_CFG_Model_Detail_List"
        let periodID = id
        let reportID = "VME_Rpt_CMP_CFG_Model_Detail_List"
        let reportName = ""
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + periodID + '&p2=' + reportID + '&p3=' + reportName, '_blank');

    }

    $scope.UploadFile = function (id) {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + CAMPAIGN_PATH + '/UpdateCampaignConfig',
                    data: { File: file, PERIOD_ID: id },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        BaseService.Message.info("Successfully saved");
                        GetData();
                        $scope.fileUpload = null;
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.DownloadNPP = function (PERIOD_ID) {
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=VME_Rpt_CMP_Model_NPP&p1=' + PERIOD_ID, '_blank');
    }

    $scope.UploadNPPFile = function (id) {
        if ($scope.fileUpload2) {
            BaseService.Message.confirm("Would you like to upload NPP/NLTH using this file?").then(function () {
                var file = $scope.fileUpload2;

                $scope.fileName2 = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + CAMPAIGN_PATH + '/UploadCampaignNPP',
                    data: { File: file, PERIOD_ID: id },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        GetData();
                        BaseService.Message.info("Successfully saved");
                        $scope.fileName2 = null;
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.ChangeCampaignName = function (value) {
        $scope.Detail.CAMPAIGN_NAME = value;
        $scope.Detail = BaseService.ObjectAssign($scope.Detail, {
            ADD_70_PERCENT: false,
            USE_DEALER: false,
            USE_NLTH: false,
            USE_SPECIAL: false,
            JOIN_LEASING: false,
            FREE_INSURANCE: false,
            DEALER_CLAIM_AMOUNT: 0,
            LEASING_AMOUNT: 0,
        });
        $scope.Detail.USE_DEALER = ($scope.Detail.CAMPAIGN_NAME == 'Non-NLTH');
        $scope.Detail.JOIN_LEASING = ($scope.Detail.CAMPAIGN_NAME == 'NLTH Exclusive campaign' || $scope.Detail.CAMPAIGN_NAME == 'NLTH General rate');
        $scope.Detail.USE_NLTH = ($scope.Detail.CAMPAIGN_NAME == 'NLTH Exclusive campaign' || $scope.Detail.CAMPAIGN_NAME == 'NLTH General rate');
    }

    $scope.findModelError = function (obj) {
        return $filter('filter')($scope.ErrorList, { CAMPAIGN_MODEL_ID: obj.ID }, true).length > 0;
    }
    $scope.findListError = function (obj) {
        if ($filter('filter')($scope.ErrorList, { CAMPAIGN_ID: obj.ID }, true).length > 0) {
            obj.ERROR_INFO = $filter('filter')($scope.ErrorList, { CAMPAIGN_ID: obj.ID }, true)[0].INFO;
            return true;
        } else {
            return false;
        }
    }
}])

app.controller("CampaignDetailController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', function ($scope, BaseService, CAMPAIGN_PATH) {

    Opening();

    function Opening() {
        $scope.formData = {};


        GetHeader();
        GetData();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("CampaignList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    function GetData() {
        BaseService.GetDataTable(CAMPAIGN_PATH, "GetCampaignList")
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Add_New = function () {
        $scope.formData = {};
        $scope.formData.ID = 0;
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.Add_Submit = function () {

        var data = BaseService.ConvertParam($scope.formData);
        BaseService.CallAction(CAMPAIGN_PATH, "CheckCampaignExist", data)
            .then(function (result) {
                if (result[0]["TOTAL"] == 0) {
                    BaseService.CallAction(CAMPAIGN_PATH, "AddPeriodCampaign", data)
                        .then(function (result) {
                            GetData();
                            document.getElementById('DetailModal').style.display = 'none';
                        })
                } else {
                    BaseService.Message.info('The Start date and End date have already exist.');
                }
            }, function (error) {
                console.log('Unable to check data: ' + error.message)
            })

    }
    $scope.Edit_Submit = function () {
        // alert('EditPeriodCampaign');
        let data = BaseService.ConvertParam($scope.formData)

        BaseService.CallAction(CAMPAIGN_PATH, "EditCampaign", data)
            .then(function (result) {
                //window.location.href = "/Configure/Dealer";
                document.getElementById('DetailModal').style.display = 'none';
                GetData();

            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (ID) {
        $scope.formData.ID = ID;
        document.getElementById('DetailModal').style.display = 'block';
        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetCampaignByID", ID, { id: ID })
            .then(function (result) {
                $scope.formData = result[0]
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.openStartDate = function () {
        $scope.popupStartDate.opened = true;
    }

    $scope.popupStartDate = {
        opened: false
    }

    $scope.openEndDate = function () {
        $scope.popupEndDate.opened = true;
    }

    $scope.popupEndDate = {
        opened: false
    }
}])

app.controller("CampaignUploadController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'Upload', '$timeout', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, Upload, $timeout, $filter) {
    //Campaign Controller here

    let date = new Date()
    $scope.periodMonth = (date.getMonth() + 1).toString();
    $scope.periodYear = date.getFullYear().toString();

    $scope.ListHeader = null;
    $scope.ListDetail = null;
    $scope.confirmBtn = null;
    $scope.fileUpload = null;


    $scope.uploadCampaignData = function () {

        var file = this.fileUpload;

        $scope.fileName = file.name;
        $scope.ListDetail = null;

        file.upload = Upload.upload({
            url: window.location.origin + CAMPAIGN_PATH + '/UploadCampaignData',
            data: { File: file, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                $scope.ListDetail = res.data;
                $scope.confirmBtn = true;
            })
        }, function (res) {
            if (res.status > 0)
                $scope.errorMsg = res.status + ': ' + res.data;
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    };

    $scope.confirmUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "ConfirmCampaignUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetCampaignData();
                }
            }, function (error) {
                console.log('Unable to confirm uploaded data: ' + error.message)
            })
    }

    $scope.cancelUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "CancelCampaignUpload", data)
            .then(function (result) {

                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetCampaignData();
                }
            }, function (error) {
                console.log('Unable to cancel uploaded data: ' + error.message)
            })
    }

    $scope.GetFileList = function () {

        var sendData = [{ periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        BaseService.GetHeaderGridView("FileHistory")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load File header data: ' + error.message)
            })

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignFileList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to list files: ' + error.message)
            })
        $scope.isFileList = true;
    }

    $scope.GetCampaignData = function () {

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        var sendData = [{ periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.GetHeaderGridView("CampaignList")
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load Campaign header data: ' + error.message)
            })

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignData", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to get campaign data: ' + error.message)
            })

        $scope.isFileList = false;
    }
    $scope.GetCampaignData();
}])

app.controller("CampaignResultController", ['$scope', 'BaseService', 'CONFIG_PATH', 'CAMPAIGN_PATH', 'DEALER_PATH', 'BizDataService', '$filter', 'REPORT_PATH', function ($scope, BaseService, CONFIG_PATH, CAMPAIGN_PATH, DEALER_PATH, BizDataService, $filter, REPORT_PATH) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        $scope.FILTER = {}
        $scope.InsuranceLeasingList = [
            { val: '0', text: 'All' },
            { val: '1', text: 'All NLTH' },
            { val: '2', text: 'NLTH with NPP' },
            { val: '3', text: 'NLTH without NPP' },
            { val: '4', text: 'All Non-NLTH' },
            { val: '5', text: 'Non-NLTH with NPP' },
            { val: '6', text: 'Non-NLTH without NPP' }
        ];
        $scope.CampaignOption = [
            { val: '', text: 'All' },
            { val: 'NLTH Exclusive campaign', text: 'NLTH Exclusive campaign' },
            { val: 'NLTH General rate', text: 'NLTH General rate' },
            { val: 'Non-NLTH', text: 'Non-NLTH' }
        ];
        $scope.selector = [];
        GetModelList();
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    $scope.ViewData_Click = function () {

        $scope.selector = [];
        $scope.selectedCampaign = '';

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        GetData();
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.baseModels = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignResultList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "BASE_MODEL": $scope.BASE_MODEL }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignResultList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetCampaignResultList data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        $scope.formData = {};
        $scope.Detail = {};
        $scope.CampaignList = {};
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignMatchList", data)
            .then(function (result) {
                $scope.CampaignList = result;

                BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignResult", data)
                    .then(function (result) {
                        $scope.formData = result[0]
                    }, function (error) {
                        console.log('Unable to load GetCampaignResult data: ' + error.message)
                    })

            }, function (error) {
                console.log('Unable to load GetCampaignMatchList data: ' + error.message)
            })
    }


    $scope.FilterMatchedChassis = function (campaignID) {
        $scope.selector = [];
        $scope.MatchChassisList = null;
        if (campaignID != '') {
            let data = BaseService.ConvertParam({ "DATA_MONTH": $scope.DATA_MONTH, "BASE_MODEL": $scope.BASE_MODEL, "CAMPAIGN_ID": campaignID })

            BaseService.CallAction(CAMPAIGN_PATH, "GetMatchGroupChassis", data)
                .then(function (result) {
                    $scope.MatchChassisList = [];
                    result.forEach(function (item) {
                        $scope.MatchChassisList.push(item.CHASSIS_NO);
                    })
                }, function (error) {
                    console.log('Unable to load GetCampaignMatchGroupList data: ' + error.message)
                })
        }
    }

    $scope.ToggleSelector = function (thisItem) {

        const thisItemID = thisItem.CHASSIS_NO;

        let thisElement = document.getElementById(thisItemID);

        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.selectDeselectAll = function (isSelect) {
        if ($scope.MatchChassisList) {
            $scope.MatchChassisList.forEach(function (CHASSIS_NO) {
                let thisElement = document.getElementById(CHASSIS_NO);

                if (isSelect && thisElement && !thisElement.classList.contains("selected")) {
                    $scope.selector.push(CHASSIS_NO);
                    thisElement.classList.add("selected");
                } else if (!isSelect && thisElement && thisElement.classList.contains("selected")) {
                    $scope.selector.splice($scope.selector.indexOf(CHASSIS_NO), 1);
                    thisElement.classList.remove("selected");
                }
            })
        }
    }

    $scope.Select = function () {
        return function (input) {
            return ((input.CAMPAIGN_ID != null) ? input.CAMPAIGN_ID.toString() : '') == (($scope.formData.DLR_CAMPAIGN_ID != null) ? $scope.formData.DLR_CAMPAIGN_ID.toString() : '');
        }
    }

    $scope.Save_Submit = function () {

        let scopeData = $scope.formData;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CAMPAIGN_PATH, "SaveCampaignResult", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.SaveGroup_Submit = function () {

        let scopeData = $scope.formData;
        scopeData.CHASSIS_NO = "''" + $scope.selector.join("'', ''") + "''";

        let data = BaseService.ConvertParam(scopeData, "CHASSIS_NO")

        BaseService.CallAction(CAMPAIGN_PATH, "SaveCampaignGroupResult", data)
            .then(function (result) {
                document.getElementById('GroupModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }



    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
        // document.getElementById('GroupModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.CalListRecs = function () {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.FILTER);

        return (filteredItems) ? filteredItems.length : 0;
    }

    $scope.FilterInsuranceLeasing = function (obj) {
        switch (obj) {

            case '0':
                //All                
                $scope.FILTER.IS_INSURANCE = null;
                $scope.FILTER.IS_LEASING = null;
                break;
            case '1':
                //All NLTH
                $scope.FILTER.IS_INSURANCE = null;
                $scope.FILTER.IS_LEASING = 'Y';
                break;
            case '2':
                //NLTH with NPP
                $scope.FILTER.IS_INSURANCE = 'Y';
                $scope.FILTER.IS_LEASING = 'Y';
                break;
            case '3':
                //NLTH without NPP
                $scope.FILTER.IS_INSURANCE = 'N';
                $scope.FILTER.IS_LEASING = 'Y';
                break;
            case '4':
                //All Non-NLTH'
                $scope.FILTER.IS_INSURANCE = null;
                $scope.FILTER.IS_LEASING = 'N';
                break;
            case '5':
                //Non-NLTH with NPP
                $scope.FILTER.IS_INSURANCE = 'Y';
                $scope.FILTER.IS_LEASING = 'N';
                break;
            case '6':
                //Non-NLTH without NPP
                $scope.FILTER.IS_INSURANCE = 'N';
                $scope.FILTER.IS_LEASING = 'N';
                break;
            default:
                //All    
                $scope.FILTER.IS_INSURANCE = null;
                $scope.FILTER.IS_LEASING = null;
                break;
        }
    }

    $scope.filterItem = function () {
        let n = 1;
        // $scope.MatchChassisList = [];

        return function (input) {
            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }

            return filterResult;
        }
    }
    $scope.Report_Click = function () {
        $scope.reportCode = 'VME_Rpt_CMP_Selection';
        $scope.reportName = 'Campaign selection';
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + 'null' + '&p3=' + $scope.reportName, '_blank');
    }
}])

app.controller("CampaignSummaryController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', '$window', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService, $window) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListReport = null
        GetReport();
    }

    function GetReport() {
        BaseService.GetReportList('Campaign')
            .then(function (result) {
                $scope.ListReport = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.redirectTo = function (url) {
        $window.open(url, '_blank');
    };
}])

app.controller("CampaignSummaryReportController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService) {

    $scope.GroupBy = 'CAMPAIGN_CODE';
    $scope.GroupByName = 'CAMPAIGN_NAME';

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetDealerList();
        GetRetailSalesMonth();
        GetHeader();
        // GetData();
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            BaseService.Message.warning('Please select month');
            return;
        }
        if (typeof ($scope.DEALER_ID) == 'undefined') {
            BaseService.Message.warning('Please select dealer');
            return;
        }
        GetData();
    }

    function GetDealerList() {
        BizDataService.GetOutletList()
            .then(function (result) {
                $scope.DealerList = result
            }, function (error) {
                console.log('Unable to load DealerList data: ' + error.message)
            })
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignResultList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "DEALER_ID": $scope.DEALER_ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignResultList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetCampaignResultList data: ' + error.message)
            })
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "CHASSIS_NO": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignResult", data)
            .then(function (result) {
                $scope.formData = result[0]
            }, function (error) {
                console.log('Unable to load GetCampaignResult data: ' + error.message)
            })
    }

    $scope.Save_Submit = function () {

        let scopeData = $scope.formData;

        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CAMPAIGN_PATH, "SaveCampaignResult", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();

            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("CampaignUnSelectedController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'DEALER_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, DEALER_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        // GetDealerList();
        GetRetailSalesMonth();
        GetHeader();
        // GetData();

        $scope.$watch('periodYear', function (value) {
            $scope.$watch('periodMonth', function (value) {
                $scope.ViewData_Click();
            });
        });
    }

    $scope.ViewData_Click = function () {

        $scope.ListDetail = null;

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            //BaseService.Message.warning('Please select month');
            return;
        }
        GetData();
    }

    function GetDealerList() {
        BizDataService.GetOutletList()
            .then(function (result) {
                $scope.DealerList = result
            }, function (error) {
                console.log('Unable to load DealerList data: ' + error.message)
            })
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignNotSelectedList')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load CampaignNotSelectedList header data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "CampaignNotSelectedList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetCampaignNotSelected data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.setInitRec = function (obj) {
        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }
}])

app.controller("CampaignDealerAmountController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetRetailSalesMonth();
        GetHeader();
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            BaseService.Message.warning('Please select month');
            return;
        }
        GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignDealerSumRep')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load Dealer summary data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignDealerSumList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetCampaignDealerSumList data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.setInitRec = function (obj) {
        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }
}])

app.controller("CampaignChassisAmountController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null
        $scope.ListDetail = null
        GetDealerList();
        GetRetailSalesMonth();
        GetHeader();
    }

    $scope.ViewData_Click = function () {

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            BaseService.Message.warning('Please select month');
            return;
        }
        GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignChassisAmountRep')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load Chassis amount data: ' + error.message)
            })
    }

    function GetDealerList() {
        BizDataService.GetOutletList()
            .then(function (result) {
                console.log(result);
                $scope.DealerList = result
            }, function (error) {
                console.log('Unable to load DealerList data: ' + error.message)
            })
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "DEALER_ID": $scope.DEALER_ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignChassisSumList", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load GetCampaignChassisSumList data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.setInitRec = function (obj) {
        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }
}])

app.controller("Rpt1CampaignSummaryController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetail = null;
        $scope.filter.checkAll = false;
        //GetBullatinList();
        GetRetailSalesMonth();
        GetHeader();

        $scope.$watch('periodYear', function (value) {
            $scope.$watch('periodMonth', function (value) {
                $scope.ViewData_Click();
            });
        });

    }

    $scope.ViewData_Click = function () {
        console.log($scope.CAMPAIGN_MODEL_NO);

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        else if (typeof ($scope.CAMPAIGN_MODEL_NO) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignChassisAmountRep')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load Chassis amount data: ' + error.message)
            })
    }

    $scope.Month_Change = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        ($scope.DATA_MONTH) ? GetBullatinList() : null;

        $scope.CAMPAIGN_MODEL_NO = null;
    };

    function GetBullatinList() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetBullatinList", data)
            .then(function (result) {
                $scope.BullatinList = result
            }, function (error) {
                console.log('Unable to load GetBullatinList data: ' + error.message)
            })

    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "CAMPAIGN_MODEL_NO": $scope.CAMPAIGN_MODEL_NO }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetRpt1Summary", data)
            .then(function (result) {
                $scope.OverlAll = result.Table;
                $scope.Detail1List = result.Table1;
                $scope.Detail2List = result.Table2;
                console.log(result);
            }, function (error) {
                console.log('Unable to load GetCampaignChassisSumList data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.setInitRec = function (obj) {
        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] != null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true)

    }
}])

app.controller("CampaignAccrueController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    CampaignAccrueAdjust($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter);


    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.MenuSection = 1;
        $scope.DetailSection = false;
        $scope.submitAble = false;
        $scope.ADJUST = 'false';
        $scope.$watch('PAYMENT_TYPE', function (value) {
            GetHeader();
            $scope.GetStatus();
        })
    }

    function GetHeader() {
        let AccrueHeader = ($scope.PAYMENT_TYPE == 'Insurance') ? 'CampaignLWTPaymentSelectedWithOutCB' : 'CampaignAccrueList';
        BaseService.GetHeaderGridView('ModelCampaignSummary')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView(AccrueHeader)
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }
    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
    $scope.Report_Click = function () {
        var reportCode = '';
        var reportID = '';
        var reportName = '';

        //alert(pReportType);
        switch ($scope.PAYMENT_TYPE) {
            case 'Dealer':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_Summary';
                        reportID = 7;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_Summary';
                        reportID = 17;
                    }
                    reportName = 'Campaign accrue summary by dealer';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_Detail';
                        reportID = 7;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_Detail';
                        reportID = 17;
                    }
                    reportName = 'Campaign accrue detail by dealer';
                }

                break;
            case 'Leasing':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_Summary';
                        reportID = 8;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_Summary';
                        reportID = 18;
                    }
                    reportName = 'Campaign accrue summary by leasing';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_Detail';
                        reportID = 8;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_Detail';
                        reportID = 18;
                    }
                    reportName = 'Campaign accrue detail by leasing';
                }
                break;
            case 'Insurance':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_Summary';
                        reportID = 9;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_Summary';
                        reportID = 19;
                    }
                    reportName = 'Campaign accrue summary by insurance';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_Detail';
                        reportID = 9;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_Detail';
                        reportID = 19;
                    }
                    reportName = 'Campaign accrue detail by insurance';
                }
                break;
            case 'After sales':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_Summary';
                        reportID = 10;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_Summary';
                        reportID = 20;
                    }
                    reportName = 'Campaign accrue summary by after sales';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_Detail';
                        reportID = 10;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_Detail';
                        reportID = 20;
                    }
                    reportName = 'Campaign accrue detail by after sales';
                }
                break;
            default:
                break;
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + $scope.ACCRUE_ID + '&p4=' + $scope.PAYMENT_TYPE + '&p5=' + reportName, '_blank');
    }
}])

app.controller("CampaignAdjustController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();
    CampaignAccrueAdjust($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter);

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.MenuSection = 1;
        $scope.DetailSection = false;
        $scope.submitAble = false;
        $scope.ADJUST = 'true';

        $scope.$watch('PAYMENT_TYPE', function (value) {
            GetHeader();
            $scope.GetStatus();
        })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ModelCampaignAdjustSummary')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('AccrueStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('CampaignAccrueList')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }
    $scope.Report_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");
        var reportCode = '';
        var reportID = '';
        var reportName = '';

        //alert(pReportType);
        switch ($scope.PAYMENT_TYPE) {
            case 'Dealer':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Adjust_Summary';
                        reportID = 7;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Adjust_Summary';
                        reportID = 17;
                    }
                    reportName = 'Campaign adjust summary by dealer';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Adjust_Detail';
                        reportID = 7;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Adjust_Detail';
                        reportID = 17;
                    }
                    reportName = 'Campaign adjust detail by dealer';
                }

                break;
            case 'Leasing':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Adjust_Summary';
                        reportID = 8;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Leasing_Adjust_Summary';
                        reportID = 18;
                    }
                    reportName = 'Campaign adjust summary by leasing';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Adjust_Detail';
                        reportID = 8;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Leasing_Adjust_Detail';
                        reportID = 18;
                    }
                    reportName = 'Campaign adjust detail by leasing';
                }
                break;
            case 'Insurance':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Adjust_Summary';
                        reportID = 9;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Insurance_Adjust_Summary';
                        reportID = 19;
                    }
                    reportName = 'Campaign adjust summary by insurance';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Adjust_Detail';
                        reportID = 9;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Insurance_Adjust_Detail';
                        reportID = 19;
                    }
                    reportName = 'Campaign adjust detail by insurance';
                }
                break;
            case 'After sales':
                if (!$scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Adjust_Summary';
                        reportID = 10;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Accessary_Adjust_Summary';
                        reportID = 20;
                    }
                    reportName = 'Campaign adjust summary by after sales';
                }
                else if ($scope.DetailSection) {
                    if ($scope.SubmitStatus.SUBMIT_FLAG != 'Y') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Adjust_Detail';
                        reportID = 10;
                    } else {
                        reportCode = 'VME_Rpt_CMP_Accessary_Adjust_Detail';
                        reportID = 20;
                    }
                    reportName = 'Campaign adjust detail by after sales';
                }
                break;
            default:
                break;
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + $scope.ACCRUE_ID + '&p4=' + $scope.PAYMENT_TYPE + '&p5=' + reportName, '_blank');
    }

}])

function CampaignAccrueAdjust($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        var matchedObj = $filter('filter')($scope.ListStatus, { DATA_MONTH: $scope.DATA_MONTH }, true);
        $scope.ACCRUE_ID = (matchedObj[0]) ? matchedObj[0].ID : 0;

        $scope.GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    $scope.GetStatus = function () {
        $scope.SelectedDealer = [];
        $scope.DeSelectedDealer = [];
        $scope.SelectAllDealer = [];

        var sendData = {
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE,
            "ADJUST": $scope.ADJUST,
        };
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, "GetAccrueStatus", data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetAccrueStatus: ' + error.message)
            })
    }

    $scope.ViewDetail_Click = function (row) {

        $scope.MenuSection = 2;
        $scope.DATA_MONTH = row.DATA_MONTH;
        $scope.ACCRUE_ID = row.ID;
        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));
        $scope.GetData();
    }

    $scope.ViewModelDetail_Click = function () {
        $scope.DetailSection = !$scope.DetailSection;
        if (!$scope.DetailSection) {

        } else if ($scope.DetailSection) {
            $scope.GetDetailData();
        }
    }

    $scope.GetData = function () {
        $scope.Section = 0;
        $scope.DetailSection = false;

        var sendData = {
            "DATA_MONTH": $scope.DATA_MONTH,
            "ACCRUE_ID": $scope.ACCRUE_ID || 0,
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE
        };
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, "GetAccrue", data)
            .then(function (result) {
                $scope.submitAble = false;
                $scope.ListDetail = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.AccPayList = result.Table2[0];
                $scope.ACCRUE_ID = ($scope.AccPayList) ? ($scope.AccPayList.ID || 0) : 0;

            }, function (error) {
                console.log('Unable to load GetAccruePayment: ' + error.message)
            })
    }

    $scope.GetDetailData = function () {
        var sendData = {
            "DATA_MONTH": $scope.DATA_MONTH,
            "ACCRUE_ID": $scope.ACCRUE_ID || 0,
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE
        }
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, "GetAccrueDetail", data)
            .then(function (result) {
                $scope.ListDetail2 = result.Table;
            }, function (error) {
                console.log('Unable to load GetAccrueDetail: ' + error.message)
            })
    }

    $scope.MenuSection_Change = function (iChange) {

        $scope.MenuSection = iChange;
        $scope.ViewDetail = false;

        if (iChange == 1) {

        } else if (iChange == 2) {
            $scope.ROUND = 1;
            $scope.ViewData_Click()
        }
    }

    $scope.UpdateAdjustModel = function () {
        $scope.ListDetail.forEach(function (item, index) {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
                "BASE_MODEL": item.BASE_MODEL,
                "SUB_MODEL": item.SUB_MODEL,
                "ADJUST_AMOUNT": item.ADJUST_AMOUNT || 0,
                "PAYMENT_TYPE": $scope.PAYMENT_TYPE
            });

            BaseService.CallAction(CAMPAIGN_PATH, 'UpdateAdjustAmount', data)
                .then(function (result) {
                    //Get summary amount after update adjust
                    if ($scope.ListDetail.length == index + 1) {
                        $scope.GetData();
                    }
                }, function (error) {
                    console.log('Cannot update adjust amount for ' + item.BASE_MODEL + ' ' + item.SUB_MODEL + ': ' + error.message);
                })
        })
    }

    $scope.Accrue_Submit = function (status) {
        var confirmType, submitType;

        let type = ($scope.ADJUST == 'true') ? 'adjust' : 'accrue';

        switch (status) {
            case 'Accrue':
                $scope.UpdateAdjustModel();
                confirmType = 'submit ' + type;
                submitType = 'submitted';
                break;

            case 'AccrueApprove':
                confirmType = 'approve ' + type;
                submitType = 'approved';
                break;

            case 'AccrueReturn':
                confirmType = 'return ' + type;
                submitType = 'returned';
                break;

            case 'MSControlApprove':
                confirmType = 'approve ' + type;
                submitType = 'approved';
                break;

            case 'MSControlReturn':
                confirmType = 'return ' + type;
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = [{
                "DATA_MONTH": $scope.DATA_MONTH,
                "STATUS": status,
                "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH),
                "ACCRUE_ID": $scope.ACCRUE_ID || 0,
                "PAYMENT_TYPE": $scope.PAYMENT_TYPE,
                "ADJUST": $scope.ADJUST
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CAMPAIGN_PATH, "SubmitAccrue", data)
                .then(function (result) {
                    $scope.GetData();
                    $scope.GetStatus();
                    $scope.MenuSection_Change(1)

                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log('Unable to load GetAccruePayment: ' + error.message)
                })
        })
    }
    $scope.setSubmitAbleFlag = function (obj) {
        $scope.submitAble = (obj.AMOUNT != 0) ? true : $scope.submitAble;
    }
}

app.controller("CampaignPaymentController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', '$filter', 'SYSTEM_PATH', 'REPORT_PATH', 'CONFIG_PATH', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService, $filter, SYSTEM_PATH, REPORT_PATH, CONFIG_PATH) {
    Opening();

    function Opening() {
        $scope.SubSection = 1;
        $scope.ViewModel = 2;
        $scope.SubMenu = 1;
        $scope.SelectedChassis = [];
        $scope.SelectAllChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.FILTER = {};
        $scope.FILTER1 = {};
        $scope.formData = {};
        $scope.ViewDetail = false;
        $scope.CBS_ViewAs = 'By Chassis';
        $scope.A_ViewAs = 'By Chassis';
        $scope.ViewAs = [
            { "value": 1, "name": 'By Chassis' },
            { "value": 2, "name": 'By Base model' },
            { "value": 3, "name": 'By Dealer' },
            { "value": 4, "name": 'By Outlet' },
        ]

        $scope.sortType = 'MODEL_NAME';
        $scope.sortReverse = false;

        $scope.$watch('PaymentType', function (val) {
            GetHeader();
            GetData();
            InitailDataModel();
            GetModelList();
        })
    }
    //----------------------------------------------
    function GetHeader() {
        let NonPaymentHeader = ($scope.PaymentType == 'Insurance') ? 'CampaignPaymentLWTList' :
            ($scope.PaymentType == 'Leasing') ? 'CampaignPaymentNLTHList' : 'CampaignPaymentList';
        BaseService.GetHeaderGridView(NonPaymentHeader)
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            });

        BaseService.GetHeaderGridView('ModelCampaignPaymentSummary')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('PaymentStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        //-----------------------------------------------------------------------------

        BaseService.GetHeaderGridView('RptCampaignPaymentDetail2')
            .then(function (result) {
                $scope.ListHeader4 = result;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })

    }

    function GetData() {
        $scope.SelectedChassis = [];
        $scope.DeSelectedChassis = [];
        $scope.SelectAllChassis = [];

        var sendData = {
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, 'GetPaymentStatus', data)
            .then(function (result) {
                $scope.ListStatus = result.Table;
            }, function (error) {
                console.log('Unable to load GetNonPayment: ' + error.message)
            })
    }

    function InitailDataModel() {
        //---- Data model
        $scope.ViewModel = 2;

        $scope.DVM = {};
        $scope.DVM_TableName1 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentSelectedWithCB' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentSelectedWithOutCB' :
                ($scope.PaymentType == 'Leasing') ? 'CampaignNLTHPaymentSelectedWithOutCB' : 'CampaignPaymentSelectedWithOutCB';
        $scope.DVM_TableName2 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentWithCBbyModel' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentWithOutCBbyModel' : 'CampaignPaymentWithOutCBbyModel';
        $scope.DVM_TableName3 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentChargeBackDealerList' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentDealerList' : 'CampaignPaymentDealerList';
        $scope.DVM_TableName4 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentChargeBackOutletList' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentOutletList' : 'CampaignPaymentOutletList';
        $scope.DVM_TableName5 = 'x';
        $scope.DVM_fnGetDataModel = 'GetPaymentSubmitByModel';
        GetDataModelHeader();
    }

    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function GetSelectedPayment() {
        $scope.ListDetail = [];
        var sendData = {
            "OPERATION_OF": $scope.OperationOf,
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetNotPaymentList', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
            }, function (error) {
                console.log('Unable to load  GetNotPaymentList : ' + error.message)
            });
    }
    function GetCancelledChassis() {
        $scope.ListDetail = [];
        var sendData = {
            "OPERATION_OF": $scope.OperationOf,
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetNotPaymentListCancelled', data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
            }, function (error) {
                console.log('Unable to load cancelled chassis: ' + error.message);
            })
    }

    function InitailDataModel_CBS() {
        //---- Data model
        $scope.CBS_ViewModel = 1;
        $scope.CBS_TableName1 = 'CampaignChargeBackList';
        $scope.CBS_TableName2 = 'CampaignModelChargeBack';
        $scope.CBS_TableName3 = 'CampaignChargeBackDealerList';
        $scope.CBS_TableName4 = 'CampaignChargeBackOutletList';
        $scope.CBS_TableName5 = 'x';
        $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByChassis';
        $scope.MatchMode = 1;
        GetDataModelHeader_CBS();
        GetData_CBS();
    }

    function GetDataModelHeader_CBS() {
        var sendData = [{
            'TableName1': $scope.CBS_TableName1
            , 'TableName2': $scope.CBS_TableName2
            , 'TableName3': $scope.CBS_TableName3
            , 'TableName4': $scope.CBS_TableName4
            , 'TableName5': $scope.CBS_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.CBS_ModelHeader1 = result.Table;
                $scope.CBS_ModelHeader2 = result.Table1;
                $scope.CBS_ModelHeader3 = result.Table2;
                $scope.CBS_ModelHeader4 = result.Table3;
                $scope.CBS_ModelHeader = $scope.CBS_ModelHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function GetData_CBS() {
        var sendData = { "PAYMENT_TYPE": $scope.PaymentType };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(CAMPAIGN_PATH, $scope.CBS_fnGetDataModel, data)
            .then(function (result) {
                $scope.CBS_ModelData1 = result.Table;
                $scope.CBS_ModelData2 = result.Table1;
                // $scope.CBS_ModelData = $scope.CBS_ModelData1;
                $scope.ChangeMatch_Click_CBS($scope.MatchMode);
            }, function (error) {
                console.log('Unable to load ' + $scope.CBS_fnGetDataModel + ': ' + error.message)
            })
    }

    function InitailDataModel_A() {
        //---- Data model
        $scope.A_ViewModel = 1;

        $scope.A_TableName1 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentSelectedWithCB' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentSelectedWithOutCB' : 'CampaignPaymentSelectedWithOutCB';
        $scope.A_TableName2 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentWithCBbyModel' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentWithOutCBbyModel' : 'CampaignPaymentWithOutCBbyModel';
        $scope.A_TableName3 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentChargeBackDealerList' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentDealerList' : 'CampaignPaymentDealerList';
        $scope.A_TableName4 = ($scope.PaymentType == 'Dealer') ? 'CampaignPaymentChargeBackOutletList' :
            ($scope.PaymentType == 'Insurance') ? 'CampaignLWTPaymentOutletList' : 'CampaignPaymentOutletList';
        $scope.A_TableName5 = 'x';
        $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBackByChassis';
        $scope.submitButton = ($scope.OperationOf == 'User') ? 1 : null;

        GetDataModelHeader_A();
        GetData_A();
    }

    function GetDataModelHeader_A() {
        var sendData = [{
            'TableName1': $scope.A_TableName1
            , 'TableName2': $scope.A_TableName2
            , 'TableName3': $scope.A_TableName3
            , 'TableName4': $scope.A_TableName4
            , 'TableName5': $scope.A_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.A_ModelHeader1 = result.Table;
                $scope.A_ModelHeader2 = result.Table1;
                $scope.A_ModelHeader3 = result.Table2;
                $scope.A_ModelHeader4 = result.Table3;
                $scope.A_ModelHeader = $scope.A_ModelHeader1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function GetData_A() {
        var sendData = {
            "PAYMENT_TYPE": $scope.PaymentType
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(CAMPAIGN_PATH, $scope.A_fnGetDataModel, data)
            .then(function (result) {
                $scope.A_ModelData1 = result.Table;

            }, function (error) {
                console.log('Unable to load ' + $scope.A_fnGetDataModel + ': ' + error.message)
            })
    }


    //----------------------------------------------
    /* General functions */
    //----------------------------------------------

    $scope.SubMenu_Change = function (iChange) {
        $scope.SubMenu = iChange;
        if (iChange == 1) {
            GetSelectedPayment();
        } else if (iChange == 2) {
            InitailDataModel_CBS();
        } else if (iChange == 3) {
            InitailDataModel_A();
        } else if (iChange == 4) {
            GetCancelledChassis();
        }
    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail_Change(2);
        $scope.ViewDetail = true;
        $scope.ViewSection == 1;
        $scope.PAYMENT_ID = row.ID;
        $scope.REMARKS = row.REMARKS;
        $scope.formData.REMARKS = row.REMARKS;

        $scope.SubmitStatus = row;
        //---- Get summary      
        var sendData = {
            "PAYMENT_ID": $scope.PAYMENT_ID
        };
        var data = BaseService.ConvertParam(sendData);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetPaymentSubmitByModel', data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;
            }, function (error) {
                console.log('Unable to load GetNonPayment: ' + error.message)
            })
    }
    $scope.SaveRemark_Click = function () {
        ///console.log($scope.formData.REMARKS);
        var data = BaseService.ConvertParam({
            "PAYMENT_ID": $scope.PAYMENT_ID,
            "REMARKS": $scope.formData.REMARKS
        });
        BaseService.CallAction(CAMPAIGN_PATH, "SaveRemark", data)
            .then(function (result) {
                document.getElementById("closeModal").click();
                GetData();
                $scope.REMARKS = $scope.formData.REMARKS;
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log("Unable to save remark :" + error.message);
            })
    }

    $scope.ChangeMatch_Click_CBS = function (iChange) {
        $scope.MatchMode = iChange;
        if (iChange == 1) {
            $scope.CBS_ModelData = $scope.CBS_ModelData1;

        } else {
            $scope.CBS_ModelData = $scope.CBS_ModelData2;

        }
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
        $scope.SubMenu_Change(1);
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
    }

    $scope.ViewDetail_Click_CBS = function (ViewModel) {

        if (ViewModel == $scope.CBS_ViewModel) {
            return;
        }
        $scope.CBS_ViewModel = ViewModel
        if (ViewModel == 1) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByChassis';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader1;
            $scope.CBS_ViewAs = 'By Chassis';
        } else if (ViewModel == 2) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByModel';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader2;
            $scope.CBS_ViewAs = 'By Base model';
        } else if (ViewModel == 3) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByDealer';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader3;
            $scope.CBS_ViewAs = 'By Dealer';
        } else if (ViewModel == 4) {
            $scope.CBS_fnGetDataModel = 'GetChargeBackSelectedPaymentByOutlet';
            $scope.CBS_ModelHeader = $scope.CBS_ModelHeader4;
            $scope.CBS_ViewAs = 'By Outlet';
        } else {
            return;
        }
        GetData_CBS();
    }

    $scope.ViewDetail_Click_A = function (ViewModel) {
        $scope.FILTER1 = {};

        if (ViewModel == $scope.A_ViewModel) {
            return;
        }
        $scope.A_ViewModel = ViewModel;

        if (ViewModel == 1) {
            $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBackByChassis';
            $scope.A_ModelHeader = $scope.A_ModelHeader1;
            $scope.A_ViewAs = 'By Chassis';
        } else if (ViewModel == 2) {
            $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBackByModel';
            $scope.A_ModelHeader = $scope.A_ModelHeader2;
            $scope.A_ViewAs = 'By Base model';
        } else if (ViewModel == 3) {
            $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBackByDealer';
            $scope.A_ModelHeader = $scope.A_ModelHeader3;
            $scope.A_ViewAs = 'By Dealer';
        } else if (ViewModel == 4) {
            $scope.A_fnGetDataModel = 'GetPaymentSelectedWithChargeBackByOutlet';
            $scope.A_ModelHeader = $scope.A_ModelHeader4;
            $scope.A_ViewAs = 'By Outlet';
        }

        GetData_A();
    }

    $scope.SelectAllPayment_Submit = function () {
        var data = BaseService.ConvertParam({
            "PAYMENT_TYPE": $scope.PaymentType
        });
        BaseService.CallAction(CAMPAIGN_PATH, "SelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    $scope.SubMenu_Change(1);
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.UnSelectAll_Submit = function () {
        var data = BaseService.ConvertParam({
            "PAYMENT_TYPE": $scope.PaymentType
        });
        BaseService.CallAction(CAMPAIGN_PATH, "UnSelectAllPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData_A();
                }
            }, function (error) {
                console.log("Unable to select all payment:" + error.message);
            })
    }

    $scope.CancelPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        BaseService.Message.confirm("Would you like to cancel the payment for selected chassis? The chassis will be removed for payment").then(function () {

            var chassis = [];
            $scope.SelectedChassis.forEach(function (item) {
                chassis.push("''" + item + "''");
            })
            var data = BaseService.ConvertParam({
                "CHASSIS": chassis,
                "PAYMENT_TYPE": $scope.PaymentType
            }, "CHASSIS");
            BaseService.CallAction(CAMPAIGN_PATH, "CancelSelectPayment", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                        $scope.SubMenu_Change(1);
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })

        })

    }

    $scope.UndoCancel_Submit = function (chassis) {
        var data = BaseService.ConvertParam({
            "PAYMENT_TYPE": $scope.PaymentType,
            "CHASSIS": chassis
        })
        BaseService.Message.confirm("Would you like to reverse the cancelled chassis to payment?")
            .then(function () {
                BaseService.CallAction(CAMPAIGN_PATH, "UndoCancelledChassis", data)
                    .then(function (result) {
                        if (result == "Done") {
                            BaseService.Message.info("Successfully saved.");
                            GetCancelledChassis();
                        }
                    }, function (error) {
                        console.log("Unable to reverse chassis: " + chassis + ": " + error.message);
                    })
            })
    }
    $scope.SelectPayment_Submit = function () {
        if ($scope.SelectedChassis.length <= 0) {
            BaseService.Message.warning("Please select chassis.");
            return;
        }

        var chassis = [];
        $scope.SelectedChassis.forEach(function (item) {
            chassis.push("''" + item + "''");
        })
        var data = BaseService.ConvertParam({
            "CHASSIS": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        }, "CHASSIS");

        BaseService.CallAction(CAMPAIGN_PATH, "SelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData();
                    $scope.SubMenu_Change(1);
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.RemoveSelect = function (chassis) {
        var data = BaseService.ConvertParam({
            "CHASSIS_NO": chassis,
            "PAYMENT_TYPE": $scope.PaymentType
        });

        BaseService.CallAction(CAMPAIGN_PATH, "RemoveSelectPayment", data)
            .then(function (result) {
                if (result == "Done") {
                    GetData_A();
                    //BaseService.Message.info("Successfully saved.");tid
                }
            }, function (error) {
                console.log("Unable to save selected payment:" + error.message);
            })
    }

    $scope.Payment_Submit = function (status) {

        var confirmType;
        var submitType;

        switch (status) {
            case 'Payment':
                confirmType = 'submit payment';
                submitType = 'submitted';
                break;

            case 'PaymentApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'PaymentReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = '"Approve" payment';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = '"Return" payment';
                submitType = 'returned';
                break;

            default:
                break;
        }


        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "PAYMENT_TYPE": $scope.PaymentType,
                "ID": ($scope.PAYMENT_ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(CAMPAIGN_PATH, "SubmitPayment", data)
                .then(function (result) {
                    GetData();
                    $scope.SubSection_Change(1);

                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".");
                    } else {
                        BaseService.Message.alert(result);
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.ToggleSelectedChassis = function (chassis) {
        if ($scope.SelectedChassis.indexOf(chassis) < 0) {
            $scope.SelectedChassis.push(chassis);
            $scope.DeSelectedChassis.splice($scope.DeSelectedChassis.indexOf(chassis), 1);
        } else {
            $scope.SelectedChassis.splice($scope.SelectedChassis.indexOf(chassis), 1);
            $scope.DeSelectedChassis.push(chassis);
        }
    }

    $scope.selectDeselectAll = function (bool) {
        if (bool) {
            $scope.DeSelectedChassis = [];
            $scope.SelectedChassis = $scope.SelectAllChassis;
        } else {
            $scope.SelectedChassis = [];
            $scope.DeSelectedChassis = $scope.SelectAllChassis;
        }
    }
    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode;
        var reportName;
        var p1 = null;
        var p2 = null;
        switch ($scope.PaymentType) {
            case 'Dealer':
                if ($scope.SubSection == 1) {
                    p1 = $scope.PAYMENT_ID;
                    p2 = $scope.PaymentType;
                    if (ReportNo == 'report1') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_ByChassis';
                        reportName = 'Campaign dealer payment detail by chassis';
                    }
                    else if (ReportNo == 'report2') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_ByModel';
                        reportName = 'Campaign dealer payment detail by base model';
                    }
                    else if (ReportNo == 'report3') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_ByDealer';
                        reportName = 'Campaign dealer payment detail by dealer';
                    }
                    else if (ReportNo == 'report4') {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_ByOutlet';
                        reportName = 'Campaign dealer payment detail by outlet';
                    }
                }
                else {
                    if ($scope.SubMenu == 2) {
                        p1 = $scope.PaymentType;
                        p2 = $scope.MatchMode;
                        if (ReportNo == 'report1') {
                            reportCode = 'VME_Rpt_CMP_CB_Selected_Payment_ByChassis';
                            reportName = 'Campaign dealer charge back selected payment by chassis';
                        }
                        if (ReportNo == 'report2') {
                            reportCode = 'VME_Rpt_CMP_CB_Selected_Payment_ByModel';
                            reportName = 'Campaign dealer charge back selected payment by base model';
                        }
                        if (ReportNo == 'report3') {
                            reportCode = 'VME_Rpt_CMP_CB_Selected_Payment_ByDealer';
                            reportName = 'Campaign dealer charge back selected payment by dealer';
                        }
                        if (ReportNo == 'report4') {
                            reportCode = 'VME_Rpt_CMP_CB_Selected_Payment_ByOutlet';
                            reportName = 'Campaign dealer charge back selected payment by outlet';
                        }
                    }
                    else if ($scope.SubMenu == 3) {
                        p1 = $scope.PaymentType;
                        if (ReportNo == 'report1') {
                            reportCode = 'VME_Rpt_CMP_Dealer_Payment_With_CB_ByChassis';
                            reportName = 'Campaign dealer payment with charge back by chassis';
                        }
                        else if (ReportNo == 'report2') {
                            reportCode = 'VME_Rpt_CMP_Dealer_Payment_With_CB_ByModel';
                            reportName = 'Campaign dealer payment with charge back by base model';
                        }
                        else if (ReportNo == 'report3') {
                            reportCode = 'VME_Rpt_CMP_Dealer_Payment_With_CB_ByDealer';
                            reportName = 'Campaign dealer payment with charge back by dealer';
                        }
                        else if (ReportNo == 'report4') {
                            reportCode = 'VME_Rpt_CMP_Dealer_Payment_With_CB_ByOutlet';
                            reportName = 'Campaign dealer payment with charge back by outlet';
                        }
                    }

                }
                break;
            case 'Leasing':
                if ($scope.SubSection == 1) {
                    p1 = $scope.PAYMENT_ID;
                    p2 = $scope.PaymentType;
                    if (ReportNo == 'report1') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_ByChassis';
                        reportName = 'Campaign leasing payment detail by chassis';
                    }
                    else if (ReportNo == 'report2') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_ByModel';
                        reportName = 'Campaign leasing payment detail by base model';
                    }
                    else if (ReportNo == 'report3') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_ByDealer';
                        reportName = 'Campaign leasing payment detail by dealer';
                    }
                    else if (ReportNo == 'report4') {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_ByOutlet';
                        reportName = 'Campaign leasing payment detail by outlet';
                    }
                }
                else {
                    if ($scope.SubMenu == 3) {
                        p1 = $scope.PaymentType;
                        if (ReportNo == 'report1') {
                            reportCode = 'VME_Rpt_CMP_Leasing_Submit_Payment_ByChassis';
                            reportName = 'Campaign leasing submit payment by chassis';
                        }
                        else if (ReportNo == 'report2') {
                            reportCode = 'VME_Rpt_CMP_Leasing_Submit_Payment_ByModel';
                            reportName = 'Campaign leasing submit payment by base model';
                        }
                        else if (ReportNo == 'report3') {
                            reportCode = 'VME_Rpt_CMP_Leasing_Submit_Payment_ByDealer';
                            reportName = 'Campaign leasing submit payment by dealer';
                        }
                        else if (ReportNo == 'report4') {
                            reportCode = 'VME_Rpt_CMP_Leasing_Submit_Payment_ByOutlet';
                            reportName = 'Campaign leasing submit payment by outlet';
                        }
                    }
                }
                break;
            case 'Insurance':
                if ($scope.SubSection == 1) {
                    p1 = $scope.PAYMENT_ID;
                    p2 = $scope.PaymentType;
                    if (ReportNo == 'report1') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_ByChassis';
                        reportName = 'Campaign insurance payment detail by chassis';
                    }
                    else if (ReportNo == 'report2') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_ByModel';
                        reportName = 'Campaign insurance payment detail by base model';
                    }
                    else if (ReportNo == 'report3') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_ByDealer';
                        reportName = 'Campaign insurance payment detail by dealer';
                    }
                    else if (ReportNo == 'report4') {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_ByOutlet';
                        reportName = 'Campaign insurance payment detail by outlet';
                    }
                }
                else {
                    if ($scope.SubMenu == 3) {
                        p1 = $scope.PaymentType;
                        if (ReportNo == 'report1') {
                            reportCode = 'VME_Rpt_CMP_Insurance_Submit_Payment_ByChassis';
                            reportName = 'Campaign insurance submit payment by chassis';
                        }
                        else if (ReportNo == 'report2') {
                            reportCode = 'VME_Rpt_CMP_Insurance_Submit_Payment_ByModel';
                            reportName = 'Campaign insurance submit payment by base model';
                        }
                        else if (ReportNo == 'report3') {
                            reportCode = 'VME_Rpt_CMP_Insurance_Submit_Payment_ByDealer';
                            reportName = 'Campaign insurance submit payment by dealer';
                        }
                        else if (ReportNo == 'report4') {
                            reportCode = 'VME_Rpt_CMP_Insurance_Submit_Payment_ByOutlet';
                            reportName = 'Campaign insurance submit payment by outlet';
                        }
                    }
                }
                break;
            case 'After sales':
                if ($scope.SubSection == 1) {
                    p1 = $scope.PAYMENT_ID;
                    p2 = $scope.PaymentType;
                    if (ReportNo == 'report1') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_ByChassis';
                        reportName = 'Campaign after sales payment detail by chassis';
                    }
                    else if (ReportNo == 'report2') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_ByModel';
                        reportName = 'Campaign after sales payment detail by base model';
                    }
                    else if (ReportNo == 'report3') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_ByDealer';
                        reportName = 'Campaign after sales payment detail by dealer';
                    }
                    else if (ReportNo == 'report4') {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_ByOutlet';
                        reportName = 'Campaign after sales payment detail by outlet';
                    }
                }
                else {
                    if ($scope.SubMenu == 3) {
                        p1 = $scope.PaymentType;
                        if (ReportNo == 'report1') {
                            reportCode = 'VME_Rpt_CMP_Accessary_Submit_Payment_ByChassis';
                            reportName = 'Campaign after sales submit payment by chassis';
                        }
                        else if (ReportNo == 'report2') {
                            reportCode = 'VME_Rpt_CMP_Accessary_Submit_Payment_ByModel';
                            reportName = 'Campaign after sales submit payment by base model';
                        }
                        else if (ReportNo == 'report3') {
                            reportCode = 'VME_Rpt_CMP_Accessary_Submit_Payment_ByDealer';
                            reportName = 'Campaign after sales submit payment by dealer';
                        }
                        else if (ReportNo == 'report4') {
                            reportCode = 'VME_Rpt_CMP_Accessary_Submit_Payment_ByOutlet';
                            reportName = 'Campaign after sales submit payment by outlet';
                        }
                    }
                }
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + p1 + '&p2=' + p2 + '&p3=' + reportName, '_blank');
    }
    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];
        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }
        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });
            if (filterResult && $scope.selectedBaseModel.length > 0) {
                for (let i = 0; i < $scope.selectedBaseModel.length; i++) {
                    let item = $scope.selectedBaseModel[i];
                    if (item.BASE_MODEL == input.BASE_MODEL && item.SUB_MODEL == input.SUB_MODEL) {
                        filterResult = true;
                        break;
                    } else {
                        filterResult = false;
                    }
                }
            }
            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }
            (filterResult) ? n++ : null;
            return filterResult;
        }
    }
    function GetModelList() {
        BizDataService.GetBaseModel().then(function (result) {
            $scope.baseModels = result;
            $scope.selectedBaseModel = [];
        })
    }
    $scope.selectAllBaseModel = function () {
        $scope.FILTER.MODEL_CODE = '';
        $scope.selectedBaseModel = [];
    }
    $scope.AddRemoveBaseModel = function (baseModel) {
        $scope.FILTER.MODEL_CODE = '';
        if ($scope.selectedBaseModel.indexOf(baseModel) >= 0) {
            $scope.selectedBaseModel.splice($scope.selectedBaseModel.indexOf(baseModel), 1);
        } else {
            $scope.selectedBaseModel.push(baseModel);
        }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("CampaignReconcileController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.filter = {};
        $scope.MenuSection = 1;
        $scope.DetailSection = false;
        GetHeader();
        GetStatus();
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ModelCampaignReconSummary')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('ReconcileStatus')
            .then(function (result) {
                $scope.ListHeader3 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('CampaignReconList')
            .then(function (result) {
                $scope.ListHeader2 = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
            $scope.DATA_MONTHNAME = $filter('filter')($scope.FYMonths, { Month: $scope.periodMonth }, true)[0].MONTH_NAME
                + '-' + String($scope.periodYear);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetRetailSalesMonth() {
        BizDataService.GetRetailSalesMonth()
            .then(function (result) {
                $scope.RetailSalesMonth = result
            }, function (error) {
                console.log('Unable to load RetailSalesMonth data: ' + error.message)
            })
    }

    function GetStatus() {
        $scope.SelectedDealer = [];
        $scope.DeSelectedDealer = [];
        $scope.SelectAllDealer = [];
        $scope.$watch('OperationOf', function (value) {

            var sendData = {
                "PAYMENT_TYPE": $scope.PAYMENT_TYPE
            };
            var data = BaseService.ConvertParam(sendData);

            BaseService.CallAction(CAMPAIGN_PATH, "GetReconcileStatus", data)
                .then(function (result) {
                    $scope.ListStatus = result.Table;
                }, function (error) {
                    console.log('Unable to load GetReconcileStatus: ' + error.message)
                })
        })
    }

    $scope.ViewDetail_Click = function (row) {

        $scope.MenuSection = 2;
        $scope.DATA_MONTH = row.DATA_MONTH;
        $scope.ROUND = row.ROUND_NO;
        $scope.periodYear = parseInt(row.DATA_MONTH.substr(0, 4));
        $scope.periodMonth = parseInt((row.DATA_MONTH).substr(-2));

        GetData();
    }

    $scope.ViewModelDetail_Click = function () {
        $scope.DetailSection = !$scope.DetailSection;
        if (!$scope.DetailSection) {
            //GetData();
        } else if ($scope.DetailSection) {
            GetDetailData();
        }
    }

    function GetData() {
        $scope.Section = 0;
        $scope.DetailSection = false;
        var sendData = {
            "DATA_MONTH": $scope.DATA_MONTH,
            "ROUND": $scope.ROUND,
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE
        };
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, "GetReconcile", data)
            .then(function (result) {
                $scope.ListDetail = result.Table;
                $scope.SubmitStatus = result.Table1[0];
                $scope.ReconcileList = result.Table2[0];
                $scope.RECONCILE_ID = ($scope.ReconcileList) ? $scope.ReconcileList.ID : 0;

            }, function (error) {
                console.log('Unable to load GetReconcile: ' + error.message)
            })
    }

    function GetDetailData() {
        var sendData = {
            "DATA_MONTH": $scope.DATA_MONTH,
            "ROUND": $scope.ROUND,
            "PAYMENT_TYPE": $scope.PAYMENT_TYPE
        }
        var data = BaseService.ConvertParam(sendData);

        BaseService.CallAction(CAMPAIGN_PATH, "GetReconcileDetail", data)
            .then(function (result) {
                $scope.ListDetail2 = result.Table;
            }, function (error) {
                console.log('Unable to load GetReconcileDetail: ' + error.message)
            })
    }

    $scope.MenuSection_Change = function (iChange) {

        $scope.MenuSection = iChange;
        $scope.ViewDetail = false;

        if (iChange == 1) {

        } else if (iChange == 2) {
            $scope.ROUND = 1;
            if ($scope.DATA) {
                GetData()
            } else {
                $scope.ViewData_Click();
            }
        }
    }

    $scope.Reconcile_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'Reconcile':
                confirmType = 'submit reconcile';
                submitType = 'submitted';
                break;

            case 'ReconcileApprove':
                confirmType = 'approve reconcile';
                submitType = 'approved';
                break;

            case 'ReconcileReturn':
                confirmType = 'return reconcile';
                submitType = 'returned';
                break;

            case 'AccountApprove':
                confirmType = 'approve reconcile';
                submitType = 'approved';
                break;

            case 'AccountReturn':
                confirmType = 'return reconcile';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {
            var sendData = [{
                "DATA_MONTH": $scope.DATA_MONTH,
                "STATUS": status,
                "DATA_MONTHNAME": BaseService.GetDataMonthName($scope.DATA_MONTH),
                "RECONCILE_ID": $scope.RECONCILE_ID,
                "PAYMENT_TYPE": $scope.PAYMENT_TYPE
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CAMPAIGN_PATH, "SubmitRecon", data)
                .then(function (result) {
                    GetData();
                    GetStatus();
                    if (result == "Done") {
                        BaseService.Message.info("Successfully " + submitType + ".")
                    } else {
                        BaseService.Message.alert(result);
                    }

                }, function (error) {
                    console.log('Unable to load Submit reconcile: ' + error.message)
                })
        })

    }

    $scope.Report_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");
        var reportCode = '';
        var reportID = '';
        var reportName = '';

        //alert(pReportType);
        switch ($scope.PAYMENT_TYPE) {
            case 'Dealer':
                if (!$scope.DetailSection) {
                    reportCode = 'VME_Rpt_CMP_Dealer_Recon_Summary';
                    reportName = 'Campaign dealer reconcile summary';
                }
                else {
                    reportCode = 'VME_Rpt_CMP_Dealer_Recon_Detail';
                    reportName = 'Campaign dealer reconcile detail';
                }
                reportID = 37;
                break;
            case 'Leasing':
                if (!$scope.DetailSection) {
                    reportCode = 'VME_Rpt_CMP_Leasing_Recon_Summary';
                    reportName = 'Campaign leasing reconcile summary';
                }
                else {
                    reportCode = 'VME_Rpt_CMP_Leasing_Recon_Detail';
                    reportName = 'Campaign leasing reconcile detail';
                }
                reportID = 38;
                break;
            case 'Insurance':
                if (!$scope.DetailSection) {
                    reportCode = 'VME_Rpt_CMP_Insurance_Recon_Summary';
                    reportName = 'Campaign insurance reconcile summary';
                }
                else {
                    reportCode = 'VME_Rpt_CMP_Insurance_Recon_Detail';
                    reportName = 'Campaign insurance reconcile detail';
                }
                reportID = 39;
                break;

            case 'After sales':
                if (!$scope.DetailSection) {
                    reportCode = 'VME_Rpt_CMP_Accessary_Recon_Summary';
                    reportName = 'Campaign after sales reconcile summary';
                }
                else {
                    reportCode = 'VME_Rpt_CMP_Accessary_Recon_Detail';
                    reportName = 'Campaign after sales reconcile detail';
                }
                reportID = 40;
                break;
            default:
                break;
        }

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + reportID + '&p3=' + $scope.PAYMENT_TYPE + '&p4=' + reportName, '_blank');
    }
}])

app.controller("Rpt1CampaignDetailController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {

    Openning();

    function Openning() {
        $scope.Period = 'Accrue';
        $scope.PayTo = 'Overall';
        $scope.Section = 1;
        $scope.FILTER = {};
    }

    $scope.$watch('MonthFrom', function (value) {
        if (value) {
            $scope.DATA_MONTH_FROM = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.$watch('MonthTo', function (value) {
        if (value) {
            $scope.DATA_MONTH_TO = (value) ? value.getFullYear().toString() + ('00' + (value.getMonth() + 1).toString()).substr(-2) : null;
        }
    })

    $scope.ViewDetail_Click = function () {
        $scope.payToChange($scope.PayTo)
    }

    $scope.Section_Change = function (section) {
        $scope.Section = section;


    }

    $scope.payToChange = function (payto) {
        $scope.PayTo = payto;
        $scope.periodChange($scope.Period);
    }

    $scope.periodChange = function (period) {
        $scope.Period = period;
        if (period == 'Accrue') {
            if ($scope.PayTo == 'Overall') {
                headerData = {
                    'TableName1': 'ModelCampaignOverallSummary',
                    'TableName2': 'CampaignOverallAccrueList',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetAccrueFromTo';
            }
            else {
                headerData = {
                    'TableName1': 'ModelCampaignSummary',
                    'TableName2': 'CampaignAccrueListWithOutCB',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetAccrueFromTo';
            }

        } else if (period == 'Payment') {
            if ($scope.PayTo == 'Overall') {
                headerData = {
                    'TableName1': 'ModelCampaignOverallPaymentWithCB',
                    'TableName2': 'CampaignOverallPaymentWithOutCB',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetPaymentFromTo';
            }
            else {
                headerData = {
                    'TableName1': 'CampaignPaymentWithCBbyModel',
                    'TableName2': 'CampaignPaymentSelectedWithOutCB',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetPaymentFromTo';
            }

        } else if (period == 'Reconcile') {
            if ($scope.PayTo == 'Overall') {
                headerData = {
                    'TableName1': 'ModelCampaignOverallReconSummary',
                    'TableName2': 'CampaignOverallReconListWithOutCB',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetReconcileFromTo';
            }
            else {
                headerData = {
                    'TableName1': 'ModelCampaignReconSummary',
                    'TableName2': 'CampaignReconListWithOutCB',
                    'TableName3': 'CampaignCBList'
                }
                detailData = {
                    "DATA_MONTH_FROM": $scope.DATA_MONTH_FROM,
                    "DATA_MONTH_TO": $scope.DATA_MONTH_TO,
                    "PAYMENT_TYPE": $scope.PayTo
                }
                detailFn = 'GetReconcileFromTo';
            }
        }
        getHeader(headerData);
        getDetail(detailData, detailFn);
    }

    function getHeader(obj) {

        var data = BaseService.ConvertParam(obj);

        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
                // $scope.ListHeader3 = result.Table2;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function getDetail(obj, fn) {
        var data = BaseService.ConvertParam(obj);

        BaseService.CallAction(CAMPAIGN_PATH, fn, data)
            .then(function (result) {
                $scope.ListDetail1 = result.Table;
                $scope.ListDetail2 = result.Table1;
                $scope.ListDetail3 = {};
            }, function (error) {
                console.log('Unable to load detail data: ' + error.message)
            });
    }


    $scope.openMonthFrom = function () {
        $scope.popupMonthFrom.opened = true;
    };
    $scope.popupMonthFrom = {
        opened: false,
    };
    $scope.openMonthTo = function () {
        $scope.popupMonthTo.opened = true;
    };
    $scope.popupMonthTo = {
        opened: false
    };

    $scope.Report_Click = function () {
        var reportCode;
        var reportName;
        switch ($scope.PayTo) {
            case 'Overall':
                if ($scope.Period == 'Accrue') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Overall_Accrue_FromTo_Model';
                        reportName = 'Campaign overall accrue summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Overall_Accrue_FromTo_Detail';
                        reportName = 'Campaign overall accrue detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Overall_Accrue_CB_FromTo_Detail';
                        reportName = 'Campaign overall accrue with charge back detail';
                    }
                }
                else if ($scope.Period == 'Payment') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Overall_Payment_FromTo_Model';
                        reportName = 'Campaign overall payment summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Overall_Payment_FromTo_Detail';
                        reportName = 'Campaign overall payment detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Overall_Payment_CB_FromTo_Detail';
                        reportName = 'Campaign overall payment with charge back detail';
                    }
                }
                else if ($scope.Period == 'Reconcile') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Overall_Recon_FromTo_Model';
                        reportName = 'Campaign overall reconcile summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Overall_Recon_FromTo_Detail';
                        reportName = 'Campaign overall reconcile detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Overall_Recon_CB_FromTo_Detail';
                        reportName = 'Campaign overall reconcile with charge back detail';
                    }
                }
                break;
            case 'Dealer':
                if ($scope.Period == 'Accrue') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_FromTo_Model';
                        reportName = 'Campaign dealer accrue summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_FromTo_Detail';
                        reportName = 'Campaign dealer accrue detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Accrue_CB_FromTo_Detail';
                        reportName = 'Campaign dealer accrue with charge back detail';
                    }
                }
                else if ($scope.Period == 'Payment') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_FromTo_Model';
                        reportName = 'Campaign dealer payment summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_FromTo_Detail';
                        reportName = 'Campaign dealer payment detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Payment_CB_FromTo_Detail';
                        reportName = 'Campaign dealer payment with charge back detail';
                    }
                }
                else if ($scope.Period == 'Reconcile') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Recon_FromTo_Model';
                        reportName = 'Campaign dealer reconcile summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Dealer_Recon_FromTo_Detail';
                        reportName = 'Campaign dealer reconcile detail';
                    }
                    else {
                        reportCode = 'VME_Rpt_CMP_Dealer_Recon_CB_FromTo_Detail';
                        reportName = 'Campaign dealer reconcile with charge back detail';
                    }
                }
                break;
            case 'Leasing':
                if ($scope.Period == 'Accrue') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_FromTo_Model';
                        reportName = 'Campaign leasing accrue summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Accrue_FromTo_Detail';
                        reportName = 'Campaign leasing accrue detail';
                    }
                }
                else if ($scope.Period == 'Payment') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_FromTo_Model';
                        reportName = 'Campaign leasing payment summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Payment_FromTo_Detail';
                        reportName = 'Campaign leasing payment detail';
                    }

                }
                else if ($scope.Period == 'Reconcile') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Recon_FromTo_Model';
                        reportName = 'Campaign leasing reconcile summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Leasing_Recon_FromTo_Detail';
                        reportName = 'Campaign leasing reconcile detail';
                    }

                }
                break;
            case 'Insurance':
                if ($scope.Period == 'Accrue') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_FromTo_Model';
                        reportName = 'Campaign insurance accrue summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Accrue_FromTo_Detail';
                        reportName = 'Campaign insurance accrue detail';
                    }
                }
                else if ($scope.Period == 'Payment') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_FromTo_Model';
                        reportName = 'Campaign insurance payment summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Payment_FromTo_Detail';
                        reportName = 'Campaign insurance payment detail';
                    }
                }
                else if ($scope.Period == 'Reconcile') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Recon_FromTo_Model';
                        reportName = 'Campaign insurance reconcile summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Insurance_Recon_FromTo_Detail';
                        reportName = 'Campaign insurance reconcile detail';
                    }
                }
                break;
            case 'After sales':
                if ($scope.Period == 'Accrue') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_FromTo_Model';
                        reportName = 'Campaign after sales accrue summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Accrue_FromTo_Detail';
                        reportName = 'Campaign after sales accrue detail';
                    }
                }
                else if ($scope.Period == 'Payment') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_FromTo_Model';
                        reportName = 'Campaign after sales payment summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Payment_FromTo_Detail';
                        reportName = 'Campaign after sales payment detail';
                    }
                }
                else if ($scope.Period == 'Reconcile') {
                    if ($scope.Section == 1) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Recon_FromTo_Model';
                        reportName = 'Campaign after sales reconcile summary';
                    }
                    else if ($scope.Section == 2) {
                        reportCode = 'VME_Rpt_CMP_Accessary_Recon_FromTo_Detail';
                        reportName = 'Campaign after sales reconcile detail';
                    }
                }
                break;
            default:
                break;
        }
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.DATA_MONTH_FROM + '&p2=' + $scope.DATA_MONTH_TO + '&p3=' + $scope.PayTo + '&p4=' + reportName, '_blank');

    }

}])

app.controller("Rpt1CampaignTrackingController", ['$scope', 'BaseService', 'CONFIG_PATH', 'CAMPAIGN_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, CAMPAIGN_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        $scope.select = {};
        $scope.ListHeader = {};
        $scope.ListDetail = [];
        //--- Default value
        $scope.Section = 1;
        $scope.reportCode = 'VME_Rpt_CPN_S1';
        $scope.select.PayTo = 'UnSelect';
        $scope.FnGetSummary = 'GetAsofList';
        $scope.reportName = 'Campaign';
        $scope.REPORT_ID = 0;
        GetHeader();
        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true)
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('ModelCampaignPaymentSummary')
            .then(function (result) {
                $scope.ModelSummary1 = result;
                $scope.ListHeader = $scope.ModelSummary1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptCampaignAccrueDetail')
            .then(function (result) {
                $scope.RptCampaignAccrueDetail = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptCampaignTrackingDetail')
            .then(function (result) {
                $scope.RptCampaignTrackingDetail = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
        BaseService.GetHeaderGridView('RptCampaignTrackingUn')
            .then(function (result) {
                $scope.RptCampaignTrackingUn = result
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }
    $scope.ViewData_Click = function () {

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        $scope.ListDetail = [];
        if ($scope.Section == 1) {
            GetDataSummary();
        } else {
            GetDataDetail()
        }
        return;
    }

    $scope.Select_Change = function (gChange) {

        // ChangeHeader();
        if ($scope.select.PayTo == 'UnSelect') {
            $scope.REPORT_ID = 0;
        } else if ($scope.select.PayTo == 'Overall') {
            $scope.REPORT_ID = 6;
        } else if ($scope.select.PayTo == 'Dealer') {
            $scope.REPORT_ID = 27;
        } else if ($scope.select.PayTo == 'NLTH') {
            $scope.REPORT_ID = 28;
        } else if ($scope.select.PayTo == 'Lockton') {
            $scope.REPORT_ID = 29;
        } else if ($scope.select.PayTo == 'After sales') {
            $scope.REPORT_ID = 30;
        }

        $scope.reportName = 'Campaign';
        $scope.ListDetail = [];
        if ($scope.Section == 1) {
            $scope.ListHeader = $scope.ModelSummary1;
            $scope.reportCode = 'VME_Rpt_CPN_S1';
            $scope.reportName = $scope.reportName + ' summary (' + $scope.select.PayTo + ')';

            if (gChange == 'PayTo') {
                if ($scope.select.PayTo == 'Overall') {
                    $scope.ListDetail = $scope.Overall;
                } else if ($scope.select.PayTo == 'Dealer') {
                    $scope.ListDetail = $scope.Dealer;
                } else if ($scope.select.PayTo == 'NLTH') {
                    $scope.ListDetail = $scope.Leasing;
                } else if ($scope.select.PayTo == 'Lockton') {
                    $scope.ListDetail = $scope.Insurance;
                } else if ($scope.select.PayTo == 'After sales') {
                    $scope.ListDetail = $scope.AfterSales;
                } else if ($scope.select.PayTo == 'UnSelect') {
                    $scope.ListDetail = $scope.UnSelect;
                }
            } else {
                GetDataSummary();
            }

        } else {
            if ($scope.select.PayTo == 'Overall' || $scope.select.PayTo == 'UnSelect') {
                $scope.FnGetDetail = 'sp_Rpt_D1';
                $scope.reportCode = 'VME_Rpt_CPN_D1';
                $scope.ListHeader = $scope.RptCampaignAccrueDetail;
                if ($scope.select.PayTo == 'UnSelect') {
                    $scope.ListHeader = $scope.RptCampaignTrackingUn;
                }
            } else {
                $scope.FnGetDetail = 'sp_Rpt_D1_No_CMP';
                $scope.reportCode = 'VME_Rpt_CPN_D2';
                $scope.ListHeader = $scope.RptCampaignTrackingDetail;
            }
            $scope.reportName = $scope.reportName + ' detail (' + $scope.select.PayTo + ')';
            GetDataDetail()
        }
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.baseModels = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    function GetDataSummary() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.Overall = result.Table;
                $scope.Dealer = result.Table1;
                $scope.Leasing = result.Table2;
                $scope.Insurance = result.Table3;
                $scope.AfterSales = result.Table4;
                $scope.UnSelect = result.Table5;

                if ($scope.select.PayTo == 'Overall') {
                    $scope.ListDetail = $scope.Overall;
                } else if ($scope.select.PayTo == 'Dealer') {
                    $scope.ListDetail = $scope.Dealer;
                } else if ($scope.select.PayTo == 'NLTH') {
                    $scope.ListDetail = $scope.Leasing;
                } else if ($scope.select.PayTo == 'Lockton') {
                    $scope.ListDetail = $scope.Insurance;
                } else if ($scope.select.PayTo == 'After sales') {
                    $scope.ListDetail = $scope.AfterSales;
                } else if ($scope.select.PayTo == 'UnSelect') {
                    $scope.ListDetail = $scope.UnSelect;
                }

            }, function (error) {
                console.log('Unable to load GetDataSummary data: ' + error.message)
            })
    }

    function GetDataDetail() {
        var sendData = [{ "SP_NAME": $scope.FnGetDetail, "DATA_MONTH": $scope.DATA_MONTH, "REPORT_ID": $scope.REPORT_ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetCampaignAsDetail', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetCampaignAsDetail data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.filterItem = function () {
        return function (input) {
            let filterResult = true;
            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }
            return filterResult;
        }
    }

    $scope.Report_Click = function () {
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.REPORT_ID + '&p3=' + $scope.reportName, '_blank');
    }

}])

app.controller("Rpt3ManagementController", ['$scope', 'BaseService', 'CONFIG_PATH', 'CAMPAIGN_PATH', 'DEALER_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CONFIG_PATH, CAMPAIGN_PATH, DEALER_PATH, REPORT_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.select = {};
        $scope.ListHeader = {};
        $scope.ListDetail = [];
        //--- Default value
        $scope.Section = 1;
        $scope.select.Period = 'Accrue';
        $scope.FnGetSummary = 'GetMonthlySummary';
        $scope.reportName = 'Campaign';
        $scope.reportCode = 'VME_Rpt_CMP_ACC_Summary';
        $scope.REPORT_ID = 0;
        GetHeader();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        $scope.ListDetail = [];
        GetDataSummary();
        return;
    }
    $scope.ViewData_Click();

    $scope.Select_Change = function (gChange) {

        if (gChange == "1") {
            $scope.Section = 1;
        } else if (gChange == "2") {
            $scope.Section = 2;
        }

        ChangeHeader();

        $scope.ListDetail = [];
        if ($scope.Section == 1) {
            $scope.FnGetSummary = 'GetMonthlySummary';
            $scope.REPORT_ID = $scope.REPORT_ID + 5;
            if ($scope.select.Period == 'Accrue') {
                $scope.ListDetail = $scope.AccrueList;
                $scope.reportCode = 'VME_Rpt_CMP_ACC_Summary';
            } else if ($scope.select.Period == 'Payment') {
                $scope.ListDetail = $scope.PaymentList;
                $scope.reportCode = 'VME_Rpt_CMP_PAY_Summary';
            }
            if (gChange == 'Period') {
                GetSummary($scope.ListDetail);
            } else {
                GetDataSummary();
            }
        } else if ($scope.Section == 2) {
            $scope.FnGetSummary = 'GetMonthlySummaryByModel';
            if ($scope.select.Period == 'Accrue') {
                $scope.ListDetail = $scope.AccrueList;
                $scope.reportCode = 'VME_Rpt_CMP_ACC_Breakdown_by_Model';
            } else if ($scope.select.Period == 'Payment') {
                $scope.ListDetail = $scope.PaymentList;
                $scope.reportCode = 'VME_Rpt_CMP_ACC_Breakdown_by_Model';
            }
            if (gChange == 'Period') {
                GetSummary($scope.ListDetail);
            } else {
                GetDataSummary();
            }
        }
    }

    function GetModelList() {
        BaseService.GetDataTable(CONFIG_PATH, "GetModelList")
            .then(function (result) {
                $scope.baseModels = result
            }, function (error) {
                console.log('Unable to load model data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CampaignMonthlySum')
            .then(function (result) {
                $scope.ModelSummary1 = result;
                $scope.ListHeader = $scope.ModelSummary1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })

        BaseService.GetHeaderGridView('CampaignMonthlyByModel')
            .then(function (result) {
                $scope.ModelSummary2 = result;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            })
    }

    function ChangeHeader() {
        if ($scope.Section == 1) {
            $scope.ListHeader = $scope.ModelSummary1;
        } else {
            $scope.ListHeader = $scope.ModelSummary2;
        }
    }

    function GetDataSummary() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, $scope.FnGetSummary, data)
            .then(function (result) {
                $scope.AccrueList = result.Table;
                $scope.PaymentList = result.Table1;

                if ($scope.select.Period == 'Accrue') {
                    $scope.ListDetail = $scope.AccrueList;
                } else if ($scope.select.Period == 'Payment') {
                    $scope.ListDetail = $scope.PaymentList;
                }
                GetSummary($scope.ListDetail);
            }, function (error) {
                console.log('Unable to load ' + $scope.FnGetSummary + ' data: ' + error.message)
            })
    }

    function GetSummary(listData) {
        var sum1 = 0;
        var sum2 = 0;
        var sum3 = 0;
        var sum4 = 0;
        var sum5 = 0;
        var sum6 = 0;
        var sum7 = 0;
        var sum8 = 0;
        var sum9 = 0;
        var sum10 = 0;


        for (var idx in listData) {
            sum1 = sum1 + listData[idx]['DEALER_CLAIM_AMOUNT'];
            sum2 = sum2 + listData[idx]['LEASING_AMOUNT'];
            sum3 = sum3 + listData[idx]['INSURANCE_AMOUNT'];
            sum4 = sum4 + listData[idx]['AFTER_SALES_AMOUNT'];
            sum5 = sum5 + listData[idx]['TOTAL'];

            sum6 = sum6 + listData[idx]['DLR_UNIT'];
            sum7 = sum7 + listData[idx]['NLTH_UNIT'];
            sum8 = sum8 + listData[idx]['LWT_UNIT'];
            sum9 = sum9 + listData[idx]['AFTS_UNIT'];
            sum10 = sum10 + listData[idx]['UNIT'];
        }
        $scope.sum1 = sum1;
        $scope.sum2 = sum2;
        $scope.sum3 = sum3;
        $scope.sum4 = sum4;
        $scope.sum5 = sum5;
        $scope.sum6 = sum6;
        $scope.sum7 = sum7;
        $scope.sum8 = sum8;
        $scope.sum9 = sum9;
        $scope.sum10 = sum10;
        $scope.sum11 = sum5 / sum10;
    }


    function GetDataDetail() {
        var sendData = [{ "SP_NAME": $scope.FnGetDetail, "DATA_MONTH": $scope.DATA_MONTH, "REPORT_ID": $scope.REPORT_ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetCampaignAsDetail', data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetCampaignAsDetail data: ' + error.message)
            })
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };

    $scope.filterItem = function () {

        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if ((input[item]).toLowerCase().indexOf(($scope.FILTER[item]).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult == true && $scope.MatchChassisList != null) {
                filterResult = ($scope.MatchChassisList.indexOf(input.CHASSIS_NO) >= 0);
            }

            return filterResult;
        }
    }


    $scope.Report_Click = function () {
        //window.open("/upload/Fleet_Program_Template.xlsx", "_blank");

        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + $scope.reportCode + '&p1=' + $scope.DATA_MONTH, '_blank');
    }

}])

app.controller("CampaignConditionController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', '$filter', 'Upload', '$timeout', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, $filter, Upload, $timeout) {
    opening();

    function opening() {
        const date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.dataTypes = ["Dealer", "Outlet", "Chassis"];
        $scope.dataType = "Chassis";
        GetConditionType();
        GetCondition();
        GetHeader();

    }

    function GetHeader() {

        BaseService.GetHeaderGridView('CampaignConditionChassis')
            .then(function (result) {
                $scope.ListHeader3 = result;
                $scope.ListHeader = $scope.ListHeader3;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.DataType_Change = function () {
        if ($scope.dataType == 'Dealer') {
            $scope.ListHeader = $scope.ListHeader1;
        } else if ($scope.dataType == 'Outlet') {
            $scope.ListHeader = $scope.ListHeader2;
        } else if ($scope.dataType == 'Chassis') {
            $scope.ListHeader = $scope.ListHeader3;
        }
        GetData();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "DATA_TYPE": $scope.dataType }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CAMPAIGN_PATH, "GetConditionList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetConditionList: ' + error.message)
            })
    }
    function GetConditionType() {
        BaseService.GetDataTableByParam('/Home', 'GetConditionType', 'CMP').then(function (result) {
            $scope.ConditionNameList = result;
            if (result.length > 0) {
                $scope.conditionTypeID = result[0].ID;
            }

        }, function (error) {
            console.log('Unable to load Condition name data: ' + error.message);
        })
    }

    function GetCondition() {
        BaseService.GetDataTableByParam('/Home', 'GetCondition', 'CMP').then(function (result) {
            $scope.ConditionList = result;
        }, function (error) {
            console.log('Unable to load Condition name data: ' + error.message);
        })
    }

    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.uploadCondition = "UploadCampaignCondition";

                file.upload = Upload.upload({
                    url: window.location.origin + CAMPAIGN_PATH + '/' + $scope.uploadCondition,
                    data: {
                        File: file,
                        year: $scope.periodYear,
                        month: $scope.periodMonth,
                        dataType: $scope.dataType,
                        conditionID: $scope.conditionID,
                        conditionTypeID: $scope.conditionTypeID,
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        if (res.data[0].RESULT == "DONE") {
                            BaseService.Message.info("Successfully saved").then(function () {
                                $scope.fileUpload = null;
                                $scope.ViewData_Click();
                            })
                        }
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.Download_Click = function () {
        gText = 'rt=1&export=excelopenxml&ExportName=CampaignChassis' + $scope.DATA_MONTH + '_' + $scope.condition;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=CHASSIS&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.conditionTypeID + '&p3=' + $scope.conditionID, '_blank');
    }

}])

app.controller("SpecialPaymentController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'REPORT_PATH', '$filter', 'Upload', '$timeout', function ($scope, BaseService, CAMPAIGN_PATH, REPORT_PATH, $filter, Upload, $timeout) {
    opening();

    function opening() {
        const date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.dataType = "FinalPay";
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        }, true)
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('SpecialChassisCMP')
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        GetData();
    }

    function GetData() {
        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH, "DATA_TYPE": $scope.dataType }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialPaymentList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetConditionList: ' + error.message)
            })
    }

    $scope.UploadFile = function () {

        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;
                $scope.uploadCondition = "UploadSpecialPayment";

                file.upload = Upload.upload({
                    url: window.location.origin + CAMPAIGN_PATH + '/' + $scope.uploadCondition,
                    data: {
                        File: file,
                        year: $scope.periodYear,
                        month: $scope.periodMonth,
                        dataType: $scope.dataType,
                    },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        if (res.data[0].RESULT == "DONE") {
                            BaseService.Message.info("Successfully saved").then(function () {
                                $scope.fileUpload = null;
                                $scope.ViewData_Click();
                            })
                        }
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.Download_Click = function () {
        gText = 'rt=1&export=excelopenxml&ExportName=CampaignChassis' + $scope.DATA_MONTH + '_' + $scope.condition;
        window.open(window.location.origin + REPORT_PATH + gText + '&rc=CHASSIS&p1=' + $scope.DATA_MONTH + '&p2=' + $scope.conditionTypeID + '&p3=' + $scope.conditionID, '_blank');
    }

}])


app.controller("CampaignBatchController", ['$scope', 'BaseService', 'BizDataService', 'CAMPAIGN_PATH', function ($scope, BaseService, BizDataService, CAMPAIGN_PATH) {
    openning();

    function openning() {
        const date = new Date();
        $scope.periodMonth = date.getMonth() + 1;
        $scope.periodYear = date.getFullYear();
        $scope.BtnCampaignAccrue = false;
        $scope.BtnNLTHCutOff = false;
        $scope.BtnNPPCutOff = false;
        $scope.BtnDealerSelect = false;
        $scope.BtnPayment = false;

        $scope.CampaignBatch = function () {
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignBatch', BaseService.ConvertParam({ DATA_MONTH: $scope.DATA_MONTH }))
                .then(function (result) {
                    $scope.BtnCampaignAccrue = true;
                    $scope.BtnDealerSelect = true;
                    $scope.BtnPayment = true;
                    $scope.BtnNLTHCutOff = (result[0]) ? !result[0].RUN_4 : true;
                    $scope.BtnNPPCutOff = (result[0]) ? !result[0].RUN_5 : true;

                }, function (error) {
                    console.log('Unable to run Generate accrue batch: ' + error.message);
                })
        }

        $scope.$watchGroup(['periodYear', 'periodMonth'], function (value) {
            if (value[0] && value[1]) {
                $scope.DATA_MONTH = String(value[0]) + String('00' + value[1]).slice(-2);

                $scope.MONTH_NAME = BizDataService.GetMonthName(value[1]) + ' ' + value[0];

                $scope.CampaignBatch();
            }
        });

    }

    $scope.CampaignAccrue_Batch = function () {

        BaseService.Message.confirm("Would you like to run batch : Accrue for ***" + $scope.MONTH_NAME + "*** ?").then(function () {

            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignAccrueBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Generate accrue has run successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run Generate accrue batch: ' + error.message);
                })

        })
    }
    $scope.CampaignAccrue_Batch_Dealer = function () {
        BaseService.Message.confirm("Would you like to run batch : Accrue dealer for ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignAccrueDealerBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Generate accrue has run successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run Generate accrue batch: ' + error.message);
                })
        })
    }
    $scope.CampaignAccrue_Batch_Insurance = function () {
        BaseService.Message.confirm("Would you like to run batch : Accrue insurance for ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignAccrueInsuranceBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Generate accrue has run successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run Generate accrue batch: ' + error.message);
                })
        })
    }

    $scope.Payment_Batch = function () {
        BaseService.Message.confirm("Would you like to run payment batch ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignPaymentBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Payment batch successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run payment batch: ' + error.message);
                })
        })
    }

    $scope.Payment_Batch_Dealer = function () {
        BaseService.Message.confirm("Would you like to run payment dealer batch ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignPaymentDealerBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Payment batch successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run payment batch: ' + error.message);
                })
        })
    }

    $scope.Payment_Batch_Leasing = function () {
        BaseService.Message.confirm("Would you like to run payment Leasing batch ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignPaymentLeasingBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Payment batch successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run payment batch: ' + error.message);
                })
        })
    }

    $scope.Payment_Batch_Insurnace = function () {
        BaseService.Message.confirm("Would you like to run payment insurance batch ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignPaymentInsuranceBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Payment batch successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run payment batch: ' + error.message);
                })
        })
    }

    $scope.Payment_Batch_AfterSales = function () {
        BaseService.Message.confirm("Would you like to run payment After Sales batch ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'CampaignPaymentAfterSalesBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Payment batch successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run payment batch: ' + error.message);
                })
        })
    }

    $scope.DealerSelect_Batch = function () {

        BaseService.Message.confirm("Would you like to run batch to stop dealer selection ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'DealerSelectBatch', data)
                .then(function (result) {
                    BaseService.Message.info("Stop dealer selection successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run Generate accrue batch: ' + error.message);
                })
        })

    }

    $scope.NLTHCutoff_Batch = function () {

        BaseService.Message.confirm("Would you like to cutoff NLTH for ***" + $scope.MONTH_NAME + "*** ?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'NLTHCutOffBatch', data)
                .then(function (result) {
                    BaseService.Message.info("NLTH Cutoff has run successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run NLTH Cutoff batch: ' + error.message);
                })

        })
    }

    $scope.NPPCutoff_Batch = function () {

        BaseService.Message.confirm("Would you like to cutoff NPP for " + $scope.MONTH_NAME + "?").then(function () {
            const data = BaseService.ConvertParam({
                "DATA_MONTH": $scope.DATA_MONTH,
            })
            BaseService.CallAction(CAMPAIGN_PATH, 'NPPCutOffBatch', data)
                .then(function (result) {
                    BaseService.Message.info("NPP Cutoff has run successfully.");
                    $scope.CampaignBatch();
                }, function (error) {
                    console.log('Unable to run NPP Cutoff batch: ' + error.message);
                })

        })
    }

}])

app.controller("CampaignChargeBackController", ['$scope', 'BaseService', 'SYSTEM_PATH', 'CAMPAIGN_PATH', 'REPORT_PATH', 'BizDataService', '$filter', function ($scope, BaseService, SYSTEM_PATH, CAMPAIGN_PATH, REPORT_PATH, BizDataService, $filter) {
    Opening();

    function Opening() {
        // InitailDataModel();
        $scope.FILTER = {};
        $scope.FILTER1 = {};
        $scope.FILTER2 = {};
        $scope.FILTER3 = {};
        $scope.FILTER4 = {};
        $scope.sortType = 'DEALER_CODE';
        $scope.sortReverse = false;
        $scope.ViewDetail = false;
        GetHeader();
        GetData();
        InitailDataModel();
    }

    //------------------- Data model section --------------------------
    function InitailDataModel() {
        //---- Data model
        $scope.ViewModel = 1;

        $scope.DVM = {};
        $scope.DVM_TableName1 = 'CampaignChargeBackList';
        $scope.DVM_TableName2 = 'CampaignModelChargeBack';
        $scope.DVM_TableName3 = 'CampaignChargeBackDealerList';
        $scope.DVM_TableName4 = 'CampaignChargeBackOutletList';
        $scope.DVM_TableName5 = 'x';
        $scope.DVM_fnGetDataModel = 'GetChargeBackSubmitDetail';

        GetDataModelHeader();
    }

    $scope.SubSection_Change = function (iChange) {
        $scope.SubSection = iChange;
        $scope.ViewDetail = false;
    }

    function GetHeader() {
        var sendData = [{
            'TableName1': 'ChangeBackStatus',
            'TableName2': 'CampaignChargeBackList',
            'TableName3': 'x',
            'TableName4': 'x',
            'TableName5': 'x'
        }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.ListHeader1 = result.Table;
                $scope.ListHeader2 = result.Table1;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });
    }

    function GetData() {
        let data_months = '';
        $scope.$watch('OperationOf', function (value) {
            var sendData = [{
                "OPERATION_OF": $scope.OperationOf,
                "CHARGE_BACK_TYPE": 'Insurance'
            }];
            var data = BaseService.ConvertParam(sendData[0]);

            BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignChargeBack", data)
                .then(function (result) {
                    $scope.ListStatus = result.Table;
                    $scope.ListDetail = result.Table1;
                    $scope.ListBaseModel = result.Table2;
                }, function (error) {
                    console.log('Unable to load GetCampaignChargeBack: ' + error.message)
                })
        }, true)
    }

    $scope.ChargeBack_Submit = function (status) {
        var confirmType;
        var submitType;

        switch (status) {
            case 'ChargeBack':
                confirmType = 'submit charge back';
                submitType = 'submitted';
                break;

            case 'ChargeBackApprove':
                confirmType = '"Approve" charge back';
                submitType = 'approved';
                break;

            case 'ChargeBackReturn':
                confirmType = '"Return" charge back';
                submitType = 'returned';
                break;

            default:
                break;
        }

        BaseService.Message.confirm("Would you like to " + confirmType + "?").then(function () {

            var data = BaseService.ConvertParam({
                "STATUS": status,
                "CHARGE_BACK_TYPE": 'Insurance',
                "ID": ($scope.CHARGE_BACK_ID || null),
                "DATA_MONTHS": $scope.data_months
            });

            BaseService.CallAction(CAMPAIGN_PATH, "SubmitChargeBack", data)
                .then(function (result) {
                    if (result == "Done") {
                        GetData();
                        $scope.SubmitStatus.APPROVE = 'GM_Approved';
                        BaseService.Message.info("Successfully " + submitType + ".");
                    }
                }, function (error) {
                    console.log("Unable to save selected payment:" + error.message);
                })
        })
    }

    $scope.RecFrom = ($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0;

    $scope.PaymentFilter = function () {
        let n = 1;
        $scope.SelectAllChassis = [];
        $scope.SelectedChassis = [];

        if ($scope.RecFrom != (($scope.$$childTail && $scope.$$childTail.PageRecFrom != null) ? $scope.$$childTail.PageRecFrom : 0)) {
            $scope.DeSelectedChassis = [];
            $scope.RecFrom = $scope.$$childTail.PageRecFrom;
        }

        return function (input, index) {
            let filterResult = true;
            Object.keys($scope.FILTER).forEach(function (item) {
                if ($scope.FILTER[item] == null) {
                    filterResult = true;
                } else if (input[item] && (input[item].toString()).toLowerCase().indexOf(($scope.FILTER[item].toString()).toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && n >= $scope.$$childTail.PageRecFrom && n <= $scope.$$childTail.PageRecTo) {
                $scope.SelectAllChassis.push(input.CHASSIS_NO);
                if ($scope.DeSelectedChassis.indexOf(input.CHASSIS_NO) < 0) {
                    $scope.SelectedChassis.push(input.CHASSIS_NO)
                }
            }

            (filterResult) ? n++ : null;

            return filterResult;
        }
    }


    function GetDataModelHeader() {
        var sendData = [{
            'TableName1': $scope.DVM_TableName1
            , 'TableName2': $scope.DVM_TableName2
            , 'TableName3': $scope.DVM_TableName3
            , 'TableName4': $scope.DVM_TableName4
            , 'TableName5': $scope.DVM_TableName5
        }];

        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(SYSTEM_PATH, 'GetHeaderGridViewList', data)
            .then(function (result) {
                $scope.DVM_ModelHeader1 = result.Table;
                $scope.DVM_ModelHeader2 = result.Table1;
                $scope.DVM_ModelHeader3 = result.Table2;
                $scope.DVM_ModelHeader4 = result.Table3;
            }, function (error) {
                console.log('Unable to load header data: ' + error.message)
            });

    }

    $scope.ViewDetail_Click = function (row) {
        $scope.ViewDetail = true;
        $scope.ViewModel = 1;
        $scope.CHARGE_BACK_ID = row.ID;
        $scope.SubmitStatus = row;

        var sendData = [{ "ID": row.ID }];
        var data = BaseService.ConvertParam(sendData[0]);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetChargeBackSubmitDetail', data)
            .then(function (result) {
                $scope.DVM_ModelData1 = result.Table;
                $scope.DVM_ModelData2 = result.Table1;
                $scope.DVM_ModelData3 = result.Table2;
                $scope.DVM_ModelData4 = result.Table3;
            }, function (error) {
                console.log('Unable to load GetChargeBackSubmitDetail: ' + error.message)
            })
    }

    $scope.ViewDetail_Change = function (iNumber) {
        $scope.ViewModel = iNumber;
    }
    $scope.ModelReport_Click = function (ReportNo) {
        var reportCode;
        var reportName;
        if (ReportNo == 'report1') {
            reportCode = 'VME_Rpt_CMP_ChargeBack_ByChassis';
            reportName = 'Campaign charge back by chassis';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + reportName, '_blank');
        }
        else if (ReportNo == 'report2') {
            reportCode = 'VME_Rpt_CMP_ChargeBack_ByModel';
            reportName = 'Campaign charge back by base model';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + reportName, '_blank');
        }
        else if (ReportNo == 'report3') {
            reportCode = 'VME_Rpt_CMP_ChargeBack_ByDealer';
            reportName = 'Campaign charge back by dealer';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + reportName, '_blank');
        }
        else if (ReportNo == 'report4') {
            reportCode = 'VME_Rpt_CMP_ChargeBack_ByOutlet';
            reportName = 'Campaign charge back by outlet';
            window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=' + reportCode + '&p1=' + $scope.CHARGE_BACK_ID + '&p2=' + reportName, '_blank');
        }

    }

}])
app.controller("CmpScConfigController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'CONFIG_PATH', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, CONFIG_PATH, $filter) {
    Opening();
    function Opening() {
        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.formData = {};
        $scope.Mode = 1; // 1 = show ; 2 = add
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });
    }

    function GetHeader() {
        BaseService.GetHeaderGridView("CmpSpecialMonthlyList")
            .then(function (result) {
                $scope.GroupHeader = result
            }, function (error) {
                console.log('Unable to load Header data: ' + error.message)
            })
    }

    $scope.ViewData_Click = function () {

        $scope.selectedCampaign = '';

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }

        GetData();
    }

    function GetData() {

        var sendData = [{ "DATA_MONTH": $scope.DATA_MONTH }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialMonthly", data)
            .then(function (result) {
                $scope.ListDetail = result
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.Edit_Submit = function () {

        if ($scope.formData.SC.CSC_NAME == null || $scope.formData.SC.CSC_NAME == '') {
            BaseService.Message.warning("Special name cannot empty.");
            return;
        }
        if ($scope.formData.SC.CSC_AMOUNT == null || $scope.formData.SC.CSC_AMOUNT == '') {
            BaseService.Message.warning("Amount (THB) cannot empty.");
            return;
        }

        let scopeData = $scope.formData.SC;
        let data = BaseService.ConvertParam(scopeData)

        BaseService.CallAction(CAMPAIGN_PATH, "SaveSpecialConfig", data)
            .then(function (result) {
                document.getElementById('DetailModal').style.display = 'none';
                GetData();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                BaseService.Message.alert('Cannot save your change, please contact administrator.');
                console.log('Unable to edit dealer data: ' + error.message)
            })

    }

    $scope.AddNewGroup_Click = function () {
        $scope.formData.SC = {}
        $scope.formData.SC.DATA_MONTH = $scope.DATA_MONTH;

        $scope.formData.SC.CNO = $scope.ListDetail.length + 1
        document.getElementById('DetailModal').style.display = 'block';
    }

    $scope.ShowItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'block';
        var sendData = [{ "ID": ID }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecial", data)
            .then(function (result) {
                $scope.formData.SC = result[0]
            }, function (error) {
                console.log('Unable to load GetSpecial data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("CmpScSelectController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', '$filter', 'Upload', '$timeout', 'REPORT_PATH', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService, $filter, Upload, $timeout, REPORT_PATH) {
    Opening();

    function Opening() {

        let date = new Date()
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();

        $scope.section = 0;
        $scope.formData = {};
        $scope.selector = [];
        $scope.FILTER = {};
        $scope.uploadSpecialList = [];
        $scope.ListDetail = [];
        GetModelList();
        GetHeader();

        $scope.$watch('ViewData_Click', function (value) {
            if (value) {
                $scope.ViewData_Click();
            }
        });

        $scope.$watch('section', function (value) {
            if (value == 0) {
                $scope.Refresh_Data = $scope.GetUploadSpecialChassisList;
                var refresh = ($scope.uploadSpecialList.length == 0);
            } else if (value == 1) {
                $scope.Refresh_Data = $scope.GetSpecialForSelectList;
                var refresh = ($scope.ListDetail.length == 0);
            }
            if (refresh) {
                $scope.Refresh_Data();
            }
        });


        $scope.selectedBaseModel = [];
    }


    $scope.ViewData_Click = function () {

        $scope.selectedCampaign = '';

        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }

        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        var refresh = false;
        if ($scope.section == 0) {
            $scope.Refresh_Data = $scope.GetUploadSpecialChassisList;
            refresh = ($scope.uploadSpecialList.length == 0);
        } else if (scope.section == 1) {
            $scope.Refresh_Data = $scope.GetSpecialForSelectList;
            refresh = ($scope.ListDetail.length == 0);
        }
        if (refresh) {
            $scope.Refresh_Data();
        }
    }

    $scope.GetUploadSpecialChassisList = function () {

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH
        });

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialMonthly", data)
            .then(function (result) {
                $scope.uploadSpecialList = result;
                console.log($scope.uploadSpecialList);
            }, function (error) {
                console.log('Unable to load data: ' + error.message)
            })
    }

    $scope.GetSpecialChassisList = function (special) {
        $scope.specialType = special;
        var data = BaseService.ConvertParam({
            "SCID": special
        })
        BaseService.CallAction(CAMPAIGN_PATH, "GetUploadedSpecialList", data)
            .then(function (result) {
                $scope.ListUploadDetail = result;
            }, function (error) {
                console.log('Unable to load Uploaded list: ' + error.message);
            })
    }

    $scope.GetSpecialForSelectList = function () {


        let data = BaseService.ConvertParam({ "DATA_MONTH": $scope.DATA_MONTH });
        $scope.selector = [];

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to load GetSpecialList data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('CmpSpecialConfigure')
            .then(function (result) {
                $scope.ListHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetModelList() {
        BizDataService.GetBaseModel().then(function (result) {
            $scope.baseModels = result;
        })

        $scope.$watchCollection('selectedBaseModel', function (value) {
            if (value.length == 1) {
                var data = BaseService.ConvertParam({
                    "BASE_MODEL": value[0].BASE_MODEL,
                    "SUB_MODEL": value[0].SUB_MODEL
                })
                BaseService.CallAction(CAMPAIGN_PATH, "GetModelListBySubModel", data)
                    .then(function (result) {
                        $scope.ModelItems = result;
                    }, function (error) {
                        console.log('Unable to load ModelList by sub model: ' + error.message);
                    })
            } else {
                $scope.ModelItems = null;
            }
        })
    }

    $scope.ShowItem_Click = function (obj) {
        $scope.formData = obj;
        document.getElementById('EditModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH
        })

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialMonthly", data)
            .then(function (result) {
                $scope.specialList = result
            }, function (error) {
                console.log('Unable to load GetSpecial data: ' + error.message)
            })
    }

    $scope.SaveItem_Submit = function () {

        var data = BaseService.ConvertParam({
            "CSC1_ID": $scope.formData.CSC1_ID
            , "CSC2_ID": $scope.formData.CSC2_ID
            , "CSC3_ID": $scope.formData.CSC3_ID
            , "Chassis": $scope.formData.CHASSIS_NO
        })

        BaseService.CallAction(CAMPAIGN_PATH, "SaveSpecialGroup", data)
            .then(function (result) {
                $scope.CloseItem_Click();
                BaseService.Message.info('Successfully saved');
            }, function (error) {
                console.log('Unable to Save Special data: ' + error.message)
            })

    }

    $scope.ShowEdit_Group = function () {
        $scope.formData = {
            "CSC1_ID": null
            , "CSC2_ID": null
            , "CSC3_ID": null
        };
        document.getElementById('GroupModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.DATA_MONTH
        })

        BaseService.CallAction(CAMPAIGN_PATH, "GetSpecialMonthly", data)
            .then(function (result) {
                $scope.specialList = result
                console.log($scope.specialList);
            }, function (error) {
                console.log('Unable to load GetSpecial data: ' + error.message)
            })
    }

    $scope.SaveGroup_Submit = function () {

        var data = BaseService.ConvertParam({
            "CSC1_ID": $scope.formData.CSC1_ID
            , "CSC2_ID": $scope.formData.CSC2_ID
            , "CSC3_ID": $scope.formData.CSC3_ID
            , "Chassis": $scope.selector
        })

        BaseService.CallAction(CAMPAIGN_PATH, "SaveSpecialGroup", data)
            .then(function (result) {
                $scope.Refresh_Data();
                BaseService.Message.info('Successfully saved');
                $scope.CloseItem_Click();
            }, function (error) {
                console.log('Unable to Save Special data: ' + error.message)
            })

    }

    $scope.ToggleSelector = function (thisItem) {

        const thisItemID = thisItem.CHASSIS_NO;

        let thisElement = document.getElementById(thisItemID);


        if (!thisElement.classList.contains("selected")) {
            $scope.selector.push(thisItemID);
            thisElement.classList.add("selected");
        } else {
            $scope.selector.splice($scope.selector.indexOf(thisItemID), 1);
            thisElement.classList.remove("selected");
        }

    }

    $scope.selectDeselectAll = function (isSelect) {
        const filteredItems = $filter('filter')($scope.ListDetail, $scope.filterPercent());

        filteredItems.forEach(function (item) {
            let thisElement = document.getElementById(item.CHASSIS_NO);
            if (isSelect && !thisElement.classList.contains("selected")) {
                $scope.selector.push(item.CHASSIS_NO);
                thisElement.classList.add("selected");
            } else if (!isSelect && thisElement.classList.contains("selected")) {
                $scope.selector.splice($scope.selector.indexOf(item.CHASSIS_NO), 1);
                thisElement.classList.remove("selected");
            }
        })
    }

    $scope.filterPercent = function () {

        return function (input) {

            let filterResult = true;

            //filter with $scope.FILTER (like case)
            Object.keys($scope.FILTER).forEach(function (item) {
                if ((input[item]).toLowerCase().indexOf($scope.FILTER[item].toLowerCase()) < 0) {
                    filterResult = false;
                }
            });

            if (filterResult && $scope.selectedBaseModel.length > 0) {
                for (let i = 0; i < $scope.selectedBaseModel.length; i++) {
                    let item = $scope.selectedBaseModel[i];
                    if (item.BASE_MODEL == input.BASE_MODEL && item.SUB_MODEL == input.SUB_MODEL) {
                        filterResult = true;
                        break;
                    } else {
                        filterResult = false;
                    }
                }
            }



            return filterResult;
        }
    }

    $scope.SelectedRowClass = function (row) {

        const thisItemID = row.CHASSIS_NO;

        if ($scope.selector.indexOf(thisItemID) >= 0) {
            return { 'sm-table-row': true, 'selected': true }
        } else {
            return { 'sm-table-row': true, 'selected': false }
        }
    }

    $scope.CloseItem_Click = function () {
        $scope.formData = null
        document.getElementById('EditModal').style.display = 'none';
        document.getElementById('GroupModal').style.display = 'none';
    }


    $scope.Download_Click = function () {
        window.open(window.location.origin + REPORT_PATH + 'rt=1&rc=VME_Rpt_CMP_SC_Select&p1=' + $scope.specialType, '_blank');

    }

    $scope.UploadFile = function () {
        if ($scope.fileUpload) {
            BaseService.Message.confirm("Would you like to update using this file?").then(function () {
                var file = $scope.fileUpload;

                $scope.fileName = file.name;

                file.upload = Upload.upload({
                    url: window.location.origin + CAMPAIGN_PATH + '/UploadSCChassis',
                    data: { File: file, scid: $scope.specialType },
                });

                file.upload.then(function (res) {
                    $timeout(function () {
                        console.log(res, "Upload");
                        if (res.data[0].RESULT == "DONE") {
                            BaseService.Message.info("Successfully saved").then(function () {
                                $scope.fileUpload = null;
                                $scope.GetSpecialChassisList($scope.specialType);
                            })
                        }
                    })
                }, function (res) {
                    if (res.status > 0) {
                        $scope.errorMsg = res.status + ': ' + res.data;
                        BaseService.Message.alert("Cannot upload file")
                    }
                }, function (evt) {
                    file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
                });

            })
        }
    }

    $scope.selectAllBaseModel = function () {
        $scope.FILTER.MODEL_CODE = '';
        $scope.selectedBaseModel = [];
    }

    $scope.AddRemoveBaseModel = function (baseModel) {
        $scope.FILTER.MODEL_CODE = '';
        if ($scope.selectedBaseModel.indexOf(baseModel) >= 0) {
            $scope.selectedBaseModel.splice($scope.selectedBaseModel.indexOf(baseModel), 1);
        } else {
            $scope.selectedBaseModel.push(baseModel);
        }
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };
}])

app.controller("CmpScSummaryController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService, $filter) {

    Opening();

    function Opening() {
        $scope.formData = {};
        $scope.ListHeader = null;
        $scope.ListDetailHeader = null;
        $scope.ListMaskHeader = {};
        $scope.ListDetail = null;
        $scope.CurrentMonth = 4;

        GetYearList();
        GetHeader();
        GetDetailHeader();
        $scope.$watch('year', function (value) {
            $scope.$watch('month', function (value) {
                $scope.ViewData_Click;
            });
        });
    }

    function GetYearList() {
        BizDataService.GetRetailSalesYear()
            .then(function (result) {
                $scope.RetailSalesYear = result
            }, function (error) {
                console.log('Unable to load RetailSalesYear data: ' + error.message)
            })
    }

    function GetHeader() {
        BaseService.GetHeaderGridView('SCSummary')
            .then(function (result) {
                $scope.ListHeader = result

            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function GetDetailHeader() {
        BaseService.GetHeaderGridView('ScModelPay')
            .then(function (result) {
                $scope.ListDetailHeader = result
            }, function (error) {
                console.log('Unable to load dealer header data: ' + error.message)
            })
    }

    function calculateTotal() {
        for (var i in $scope.ListDetailHeader) {
            if ($scope.ListDetailHeader[i]['FIELD_NAME'] != 'INC_MODEL_NAME'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'PERCENT_GET'
                && $scope.ListDetailHeader[i]['FIELD_NAME'] != 'GET_AMOUNT') {
                var key = $scope.ListDetailHeader[i]['FIELD_NAME'];
                $scope.Total[key] = 0;

                for (var j in $scope.formDetail) {
                    $scope.Total[key] += parseInt($scope.formDetail[j][key]);
                }
            }
        }
    }

    $scope.ViewData_Click = function () {

        $scope.outletList = null;
        if (typeof ($scope.year) == 'undefined') {
            return;
        }
        if (typeof ($scope.month) == 'undefined') {
            return;
        }

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.year.fullYear + '' + $scope.month.MONTH
        });
        BaseService.CallAction(CAMPAIGN_PATH, "GetSCVolumeSummary", data)
            .then(function (result) {
                $scope.outletList = result;

            }, function (error) {
                console.log('Unable to load GetSCVolumeListDetail data: ' + error.message)
            })

    }

    function GetDetailData(row) {
        document.getElementById('DetailModal').style.display = 'block';
        $scope.formDetail = {};
        $scope.formData = row;
        var sendData = [{
            "DATA_MONTH": $scope.year.fullYear + $scope.month.MONTH,
            "DEALER_ID": row.DEALER_ID,
        }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "GetSCModelPay", data)
            .then(function (result) {
                $scope.formDetail = result;
                calculateTotal();
            }, function (error) {
                console.log('Unable to load GetSCModelPay data: ' + error.message)
            })

    }

    $scope.ShowItem_Click = function (row) {

        $scope.Total = [];
        GetDetailData(row);

        //GetDetailHeaderMask(row);
    }

    $scope.ShowChassisDetail = function (row) {

        $scope.formChassisDetail = null;
        $scope.ModelName = row.INC_MODEL_NAME;


        document.getElementById('ChassisModal').style.display = 'block';

        var data = BaseService.ConvertParam({
            "DATA_MONTH": $scope.year.fullYear + $scope.month.MONTH,
            "DEALER_ID": row.DEALER_ID,
            "ID": row.ID
        });

        BaseService.CallAction(CAMPAIGN_PATH, "GetScChassis", data)
            .then(function (result) {
                $scope.formChassisDetail = result;
            }, function (error) {
                console.log('Unable to load GetScChassis data: ' + error.message)
            })
    }

    $scope.CloseItem_Click = function (ID) {
        document.getElementById('DetailModal').style.display = 'none';
    }

    $scope.Close_ChassisModal = function (ID) {
        document.getElementById('ChassisModal').style.display = 'none';
    }

    $scope.OrderColumn = function (pColName) {
        $scope.sortType = pColName;
        $scope.sortReverse = !$scope.sortReverse;
    };


}])

app.controller("CMPTrackingController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'BizDataService', '$filter', 'SYSTEM_PATH', 'REPORT_PATH', function ($scope, BaseService, CAMPAIGN_PATH, BizDataService, $filter, SYSTEM_PATH, REPORT_PATH) {

    $scope.Opening = function () {
        const date = new Date();
        $scope.periodMonth = (date.getMonth() + 1);
        $scope.periodYear = date.getFullYear();
        $scope.txtChassisNo = '';
        $scope.ListHeader = [];
        $scope.ListDetail = [];
        $scope.filter = {};
        $scope.Section = 1;

        $scope.ViewData_Click();
    }

    $scope.ViewData_Click = function () {
        if (typeof ($scope.periodYear) != 'undefined' && typeof ($scope.periodMonth) != 'undefined') {
            $scope.DATA_MONTH = String($scope.periodYear) + String('00' + $scope.periodMonth).slice(-2);
        }
        if (typeof ($scope.DATA_MONTH) == 'undefined') {
            return;
        }
        $scope.Section_Change($scope.Section);
    }

    $scope.Section_Change = function (iSection) {
        $scope.Section = iSection;

        if (iSection == 1) {
            $scope.GetLeasingDiffData();
        } else if (iSection == 2) {
            $scope.GetServiceRO();
        } else if (iSection == 3) {
            //
        }

    }

    $scope.GetLeasingDiffData = function () {
        BaseService.GetHeaderGridView("NLTHDiffList")
            .then(function (result) {
                $scope.ListHeader = result;
            });

        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetNLTHDiffData", $scope.DATA_MONTH)
            .then(function (result) {
                $scope.ListDetail = result;
            })
    }

    $scope.GetServiceRO = function () {
        BaseService.GetHeaderGridView("ServiceROList") 
            .then(function (result) {
                $scope.ListHeader = result;
            });

        BaseService.GetDataTableByParam(CAMPAIGN_PATH, "GetServiceROMapping", $scope.DATA_MONTH)
            .then(function (result) {
                $scope.ListDetail = result;
            })
    }


    $scope.GetChassisInfo = function () {

        var sendData = [{ "CHASSIS_NO": $scope.txtChassisNo }];
        var data = BaseService.ConvertParam(sendData[0]);
        console.log($scope.txtChassisNo);
        BaseService.CallAction(CAMPAIGN_PATH, 'GetChassisInfo', data)
            .then(function (result) {
                $scope.ChassisInfo = result.Table[0];
                $scope.InsuranceInfo = result.Table1[0];
                $scope.LeasingInfo = result.Table2[0];
                $scope.CampaignInfo = result.Table3;
                $scope.ChassisAccrue = result.Table4[0];
            }, function (error) {
                console.log('Unable to load GetChassisInfo: ' + error.message)
            })

    }

    $scope.Opening();

}])
app.controller("CampaignROUploadController", ['$scope', 'BaseService', 'CAMPAIGN_PATH', 'Upload', '$timeout', '$filter', function ($scope, BaseService, CAMPAIGN_PATH, Upload, $timeout, $filter) {

    let date = new Date();
    $scope.periodMonth = (date.getMonth() + 1);
    $scope.periodYear = date.getFullYear();

    $scope.ListHeader = null;
    $scope.ListDetail = null;
    $scope.confirmBtn = null;
    $scope.fileUpload = null;

    $scope.uploadCampaignROData = function () {

        var file = this.fileUpload;

        $scope.fileName = file.name;
        $scope.ListDetail = null;

        file.upload = Upload.upload({
            url: window.location.origin + CAMPAIGN_PATH + '/UploadCampaignROData',
            data: { File: file, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear },
        });

        file.upload.then(function (res) {
            $timeout(function () {
                if (res.data.result == 500) {
                    BaseService.Message.alert("Please insert file.");
                } else if (res.data.result == 200) {
                    BaseService.Message.alert((res.data.data));
                } else {
                    $scope.ListDetail = res.data;
                    $scope.confirmBtn = true;
                }
            })
        }, function (res) {
            if (res.status > 0) {
                $scope.errorMsg = res.status + ': ' + res.data;
                BaseService.Message.alert("Cannot upload file");
            }
        }, function (evt) {
            file.progress = Math.min(100, parseInt(100.0 * evt.loaded / evt.total));
        });
    };

    $scope.confirmUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "ConfirmCampaignROUpload", data)
            .then(function (result) {
                if (result.result == 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetCampaignROData();
                    BaseService.Message.info("Successfully saved");
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.");
                console.log('Unable to confirm uploaded data: ' + error.message);
            });
    };

    $scope.cancelUpload = function (fileName) {

        var sendData = [{ "fileName": fileName, periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        BaseService.CallAction(CAMPAIGN_PATH, "CancelCampaignROUpload", data)
            .then(function (result) {

                if (result.result === 200) {
                    $scope.ListDetail = null;
                    $scope.ListHeader = null;
                    $scope.confirmBtn = null;
                    $scope.fileUpload = null;
                    $scope.GetCampaignROData();
                }
            }, function (error) {
                BaseService.Message.alert("Cannot save your change, please contact administrator.");
                console.log('Unable to cancel uploaded data: ' + error.message);
            });
    };

    $scope.GetFileList = function () {

        var sendData = [{ periodMonth: $scope.periodMonth, periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        BaseService.GetHeaderGridView("FileHistory")
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load File header data: ' + error.message);
            });

        BaseService.CallAction(CAMPAIGN_PATH, "GetFileList", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to list files: ' + error.message);
            });
        $scope.isFileList = true;
    };

    $scope.GetCampaignROData = function () {

        $scope.ListHeader = null;
        $scope.ListDetail = null;

        var sendData = [{ periodMonth: String('00' + $scope.periodMonth).slice(-2), periodYear: $scope.periodYear }];
        var data = BaseService.ConvertParam(sendData[0]);


        BaseService.GetHeaderGridView("CampaignROData")
            .then(function (result) {
                $scope.ListHeader = result;
            }, function (error) {
                console.log('Unable to load Campaign RO Data header data: ' + error.message);
            });

        BaseService.CallAction(CAMPAIGN_PATH, "GetCampaignROData", data)
            .then(function (result) {
                $scope.ListDetail = result;
            }, function (error) {
                console.log('Unable to get Campaign RO data: ' + error.message);
            });

        $scope.isFileList = false;
    };

    $scope.GetCampaignROData();

    $scope.setInitRec = function (obj) {

        $scope.$watch(obj, function (newVal, oldVal, scope) {
            $scope.recordFilter = (($scope[obj] !== null) ? (($scope[obj].length >= 100) ? 100 : $scope[obj].length) : 0);
        }, true);
    };

    //$scope.GetTemplateFile = function () {
    //    location.href = "/Doc/template/RO template.xlsx";
    //};
}]);